diff -pruN 0.2.0-3/Documentation/Doxyfile.in 0.3.0-1/Documentation/Doxyfile.in
--- 0.2.0-3/Documentation/Doxyfile.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/Doxyfile.in	2024-05-19 15:54:11.000000000 +0000
@@ -20,6 +20,7 @@ TOC_INCLUDE_HEADINGS   = 0
 CASE_SENSE_NAMES       = YES
 
 QUIET                  = YES
+WARN_AS_ERROR          = @WARN_AS_ERROR@
 
 INPUT                  = "@TOP_SRCDIR@/include/libcamera" \
                          "@TOP_SRCDIR@/src/ipa/ipu3" \
@@ -44,6 +45,7 @@ EXCLUDE                = @TOP_SRCDIR@/in
                          @TOP_SRCDIR@/src/libcamera/pipeline/ \
                          @TOP_SRCDIR@/src/libcamera/tracepoints.cpp \
                          @TOP_BUILDDIR@/include/libcamera/internal/tracepoints.h \
+                         @TOP_BUILDDIR@/include/libcamera/ipa/soft_ipa_interface.h \
                          @TOP_BUILDDIR@/src/libcamera/proxy/
 
 EXCLUDE_PATTERNS       = @TOP_BUILDDIR@/include/libcamera/ipa/*_serializer.h \
diff -pruN 0.2.0-3/Documentation/coding-style.rst 0.3.0-1/Documentation/coding-style.rst
--- 0.2.0-3/Documentation/coding-style.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/coding-style.rst	2024-05-19 15:54:11.000000000 +0000
@@ -59,7 +59,7 @@ document:
   underscores in between
 * All formatting rules specified in the selected sections of the Linux kernel
   Code Style for indentation, braces, spacing, etc
-* Header guards are formatted as '__LIBCAMERA_FILE_NAME_H__'
+* Headers are guarded by the use of '#pragma once'
 
 Order of Includes
 ~~~~~~~~~~~~~~~~~
diff -pruN 0.2.0-3/Documentation/environment_variables.rst 0.3.0-1/Documentation/environment_variables.rst
--- 0.2.0-3/Documentation/environment_variables.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/environment_variables.rst	2024-05-19 15:54:11.000000000 +0000
@@ -37,6 +37,14 @@ LIBCAMERA_IPA_MODULE_PATH
 
    Example value: ``${HOME}/.libcamera/lib:/opt/libcamera/vendor/lib``
 
+LIBCAMERA_PIPELINES_MATCH_LIST
+   Define an ordered list of pipeline names to be used to match the media
+   devices in the system. The pipeline handler names used to populate the
+   variable are the ones passed to the REGISTER_PIPELINE_HANDLER() macro in the
+   source code.
+
+   Example value: ``rkisp1,simple``
+
 LIBCAMERA_RPI_CONFIG_FILE
    Define a custom configuration file to use in the Raspberry Pi pipeline handler.
 
diff -pruN 0.2.0-3/Documentation/guides/application-developer.rst 0.3.0-1/Documentation/guides/application-developer.rst
--- 0.2.0-3/Documentation/guides/application-developer.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/guides/application-developer.rst	2024-05-19 15:54:11.000000000 +0000
@@ -348,7 +348,7 @@ The libcamera library uses the concept o
 Signals and Slots`_) to connect events with callbacks to handle them.
 
 .. _signals and slots: https://libcamera.org/api-html/classlibcamera_1_1Signal.html#details
-.. _Qt Signals and Slots: https://doc.qt.io/qt-5/signalsandslots.html
+.. _Qt Signals and Slots: https://doc.qt.io/qt-6/signalsandslots.html
 
 The ``Camera`` device emits two signals that applications can connect to in
 order to execute callbacks on frame completion events.
diff -pruN 0.2.0-3/Documentation/guides/pipeline-handler.rst 0.3.0-1/Documentation/guides/pipeline-handler.rst
--- 0.2.0-3/Documentation/guides/pipeline-handler.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/guides/pipeline-handler.rst	2024-05-19 15:54:11.000000000 +0000
@@ -258,7 +258,7 @@ implementations for the overridden class
           return false;
    }
 
-   REGISTER_PIPELINE_HANDLER(PipelineHandlerVivid)
+   REGISTER_PIPELINE_HANDLER(PipelineHandlerVivid, "vivid")
 
    } /* namespace libcamera */
 
@@ -266,6 +266,8 @@ Note that you must register the ``Pipeli
 handler factory using the `REGISTER_PIPELINE_HANDLER`_ macro which
 registers it and creates a global symbol to reference the class and make it
 available to try and match devices.
+String "vivid" is the name assigned to the pipeline, matching the pipeline
+subdirectory name in the source tree.
 
 .. _REGISTER_PIPELINE_HANDLER: https://libcamera.org/api-html/pipeline__handler_8h.html
 
@@ -651,7 +653,7 @@ inline in our VividCameraData init:
            ctrls.emplace(id, info);
    }
 
-   controlInfo_ = std::move(ctrls);
+   controlInfo_ = ControlInfoMap(std::move(ctrls), controls::controls);
 
 The ``properties_`` field is  a list of ``ControlId`` instances
 associated with immutable values, which represent static characteristics that can
@@ -1422,7 +1424,7 @@ emitted triggers the execution of the co
 of the libcamera implementation is available in the `libcamera Signal and Slot`_
 classes documentation.
 
-.. _Qt Signals and Slots: https://doc.qt.io/qt-5/signalsandslots.html
+.. _Qt Signals and Slots: https://doc.qt.io/qt-6/signalsandslots.html
 .. _libcamera Signal and Slot: https://libcamera.org/api-html/classlibcamera_1_1Signal.html#details
 
 In order to notify applications about the availability of new frames and data,
diff -pruN 0.2.0-3/Documentation/index.rst 0.3.0-1/Documentation/index.rst
--- 0.2.0-3/Documentation/index.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/index.rst	2024-05-19 15:54:11.000000000 +0000
@@ -24,3 +24,4 @@
    Lens driver requirements <lens_driver_requirements>
    Python Bindings <python-bindings>
    Camera Sensor Model <camera-sensor-model>
+   SoftwareISP Benchmarking <software-isp-benchmarking>
diff -pruN 0.2.0-3/Documentation/meson.build 0.3.0-1/Documentation/meson.build
--- 0.2.0-3/Documentation/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/Documentation/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -15,6 +15,7 @@ if doxygen.found() and dot.found()
     cdata.set('TOP_SRCDIR', meson.project_source_root())
     cdata.set('TOP_BUILDDIR', meson.project_build_root())
     cdata.set('OUTPUT_DIR', meson.current_build_dir())
+    cdata.set('WARN_AS_ERROR', get_option('doc_werror') ? 'YES' : 'NO')
 
     doxygen_predefined = []
     foreach key : config_h.keys()
@@ -80,6 +81,7 @@ if sphinx.found()
         'lens_driver_requirements.rst',
         'python-bindings.rst',
         'sensor_driver_requirements.rst',
+        'software-isp-benchmarking.rst',
        '../README.rst',
     ]
 
diff -pruN 0.2.0-3/Documentation/software-isp-benchmarking.rst 0.3.0-1/Documentation/software-isp-benchmarking.rst
--- 0.2.0-3/Documentation/software-isp-benchmarking.rst	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/Documentation/software-isp-benchmarking.rst	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,77 @@
+.. SPDX-License-Identifier: CC-BY-SA-4.0
+
+.. _software-isp-benchmarking:
+
+Software ISP benchmarking
+=========================
+
+The Software ISP is particularly sensitive to performance regressions therefore
+it is a good idea to always benchmark the Software ISP before and after making
+changes to it and ensure that there are no performance regressions.
+
+DebayerCpu class builtin benchmark
+----------------------------------
+
+The DebayerCpu class has a builtin benchmark. This benchmark measures the time
+spent on processing (collecting statistics and debayering) only, it does not
+measure the time spent on capturing or outputting the frames.
+
+The builtin benchmark always runs. So this can be used by simply running "cam"
+or "qcam" with a pipeline using the Software ISP.
+
+When it runs it will skip measuring the first 30 frames to allow the caches and
+the CPU temperature (turbo-ing) to warm-up and then it measures 30 fps and shows
+the total and per frame processing time using an info level log message:
+
+.. code-block:: text
+
+   INFO Debayer debayer_cpu.cpp:907 Processed 30 frames in 244317us, 8143 us/frame
+
+To get stable measurements it is advised to disable any other processes which
+may cause significant CPU usage (e.g. disable wifi, bluetooth and browsers).
+When possible it is also advisable to disable CPU turbo-ing and
+frequency-scaling.
+
+For example when benchmarking on a Lenovo ThinkPad X1 Yoga Gen 8, with the
+charger plugged in, the CPU can be fixed to run at 2 GHz using:
+
+.. code-block:: shell
+
+   sudo x86_energy_perf_policy --turbo-enable 0
+   sudo cpupower frequency-set -d 2GHz -u 2GHz
+
+with these settings the builtin bench reports a processing time of ~7.8ms/frame
+on this laptop for FHD SGRBG10 (unpacked) bayer data.
+
+Measuring power consumption
+---------------------------
+
+Since the Software ISP is often used on mobile devices it is also important to
+measure power consumption and ensure that that does not regress.
+
+For example to measure power consumption on a Lenovo ThinkPad X1 Yoga Gen 8 it
+needs to be running on battery and it should be configured with its
+platform-profile (/sys/firmware/acpi/platform_profile) set to balanced and with
+its default turbo and frequency-scaling behavior to match real world usage.
+
+Then start qcam to capture a FHD picture at 30 fps and position the qcam window
+so that it is fully visible. After this run the following command to monitor the
+power consumption:
+
+.. code-block:: shell
+
+   watch -n 10 cat /sys/class/power_supply/BAT0/power_now /sys/class/hwmon/hwmon6/fan?_input
+
+Note this not only measures the power consumption in µW it also monitors the
+speed of this laptop's 2 fans. This is important because depending on the
+ambient temperature the 2 fans may spin up while testing and this will cause an
+additional power consumption of approx. 0.5 W messing up the measurement.
+
+After starting qcam + the watch command let the laptop sit without using it for
+2 minutes for the readings to stabilize. Then check that the fans have not
+turned on and manually take a couple of consecutive power readings and average
+these.
+
+On the example Lenovo ThinkPad X1 Yoga Gen 8 laptop this results in a measured
+power consumption of approx. 13 W while running qcam versus approx. 4-5 W while
+setting idle with its OLED panel on.
diff -pruN 0.2.0-3/README.rst 0.3.0-1/README.rst
--- 0.2.0-3/README.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/README.rst	2024-05-19 15:54:11.000000000 +0000
@@ -96,6 +96,9 @@ for tracing with lttng: [optional]
 for android: [optional]
         libexif-dev libjpeg-dev
 
+for Python bindings: [optional]
+        pybind11-dev
+
 for lc-compliance: [optional]
         libevent-dev libgtest-dev
 
@@ -120,12 +123,13 @@ setting the ``LIBCAMERA_LOG_LEVELS`` env
 Using GStreamer plugin
 ~~~~~~~~~~~~~~~~~~~~~~
 
-To use GStreamer plugin from source tree, set the following environment so that
-GStreamer can find it. This isn't necessary when libcamera is installed.
+To use the GStreamer plugin from the source tree, use the meson ``devenv``
+command.  This will create a new shell instance with the ``GST_PLUGIN_PATH``
+environment set accordingly.
 
 .. code::
 
-  export GST_PLUGIN_PATH=$(pwd)/build/src/gstreamer
+  meson devenv -C build
 
 The debugging tool ``gst-launch-1.0`` can be used to construct a pipeline and
 test it. The following pipeline will stream from the camera named "Camera 1"
@@ -133,7 +137,7 @@ onto the OpenGL accelerated display elem
 
 .. code::
 
-  gst-launch-1.0 libcamerasrc camera-name="Camera 1" ! glimagesink
+  gst-launch-1.0 libcamerasrc camera-name="Camera 1" ! queue ! glimagesink
 
 To show the first camera found you can omit the camera-name property, or you
 can list the cameras and their capabilities using:
@@ -148,7 +152,7 @@ if desired with a pipeline such as:
 .. code::
 
   gst-launch-1.0 libcamerasrc ! 'video/x-raw,width=1280,height=720' ! \
-        glimagesink
+       queue ! glimagesink
 
 The libcamerasrc element has two log categories, named libcamera-provider (for
 the video device provider) and libcamerasrc (for the operation of the camera).
@@ -164,7 +168,7 @@ the following example could be used as a
 
    gst-launch-1.0 libcamerasrc ! \
         video/x-raw,colorimetry=bt709,format=NV12,width=1280,height=720,framerate=30/1 ! \
-        jpegenc ! multipartmux ! \
+        queue ! jpegenc ! multipartmux ! \
         tcpserversink host=0.0.0.0 port=5000
 
 Which can be received on another device over the network with:
diff -pruN 0.2.0-3/debian/changelog 0.3.0-1/debian/changelog
--- 0.2.0-3/debian/changelog	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/changelog	2024-05-20 08:53:34.000000000 +0000
@@ -1,3 +1,17 @@
+libcamera (0.3.0-1) experimental; urgency=medium
+
+  * New upstream version 0.3.0
+  * Bump SONAME to libcamera0.3
+  * Set architecture to linux-any
+  * Promote libcamera-ipa in Recommends of libcamera0.3 and ensure the
+      binary version matches
+  * Update debian/watch to use upstream recommended tarball
+  * Standards-Version: 4.7.0 (no changes needed)
+  * Drop obsolete pkg-config from Build-Deps
+  * Refresh patches
+
+ -- Dylan Aïssi <daissi@debian.org>  Mon, 20 May 2024 10:53:34 +0200
+
 libcamera (0.2.0-3) unstable; urgency=medium
 
   [ Jeremy Bícha ]
diff -pruN 0.2.0-3/debian/control 0.3.0-1/debian/control
--- 0.2.0-3/debian/control	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/control	2024-05-20 08:53:34.000000000 +0000
@@ -1,10 +1,11 @@
 Source: libcamera
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Emmanuel Arias <emmanuelarias30@gmail.com>,
            IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
            Andrej Shadura <andrewsh@debian.org>,
            Dylan Aïssi <daissi@debian.org>
+Section: libs
+Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
                doxygen <!nodoc>,
@@ -29,24 +30,23 @@ Build-Depends: debhelper-compat (= 13),
                libyaml-dev,
                meson (>= 0.60),
                openssl,
-               pkgconf | pkg-config,
+               pkgconf,
                python3-jinja2,
                python3-ply,
                python3-pybind11 <!pkg.libcamera.nopython>,
                python3-sphinx <!nodoc>,
                python3-yaml,
                qtbase5-dev <!pkg.libcamera.noqt>
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
-Section: libs
-Homepage: https://libcamera.org/
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libcamera
 Vcs-Git: https://salsa.debian.org/multimedia-team/libcamera.git
+Homepage: https://libcamera.org/
+Rules-Requires-Root: no
 
 Package: libcamera-dev
+Architecture: linux-any
 Section: libdevel
-Architecture: any
-Depends: libcamera0.2 (= ${binary:Version}),
+Depends: libcamera0.3 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: complex camera support library (development files)
@@ -57,44 +57,44 @@ Description: complex camera support libr
  This package provides the necessary files needed for development
 
 Package: libcamera-doc
-Section: doc
 Architecture: all
-Build-Profiles: <!nodoc>
+Multi-Arch: foreign
+Section: doc
 Depends: libjs-jquery,
          libjs-sphinxdoc,
          libjs-underscore,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: libcamera-dev
-Multi-Arch: foreign
 Description: complex camera support library (documentation)
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
  programming interface to the applications.
  .
  This package contains the documentation developing with libcamera.
+Build-Profiles: <!nodoc>
 
-Package: libcamera0.2
-Architecture: any
+Package: libcamera0.3
+Architecture: linux-any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Recommends: libcamera-ipa (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
-Suggests: libcamera-ipa
 Breaks: libcamera0 (<< 0.0.3-1~)
 Replaces: libcamera0 (<< 0.0.3-1~)
-Multi-Arch: same
 Description: complex camera support library
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
  programming interface to the applications.
 
 Package: libcamera-ipa
-Architecture: any
+Architecture: linux-any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Breaks: libcamera0 (<< 0.0.3-1~)
 Replaces: libcamera0 (<< 0.0.3-1~)
-Multi-Arch: same
 Description: complex camera support library (IPA modules)
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
@@ -103,12 +103,12 @@ Description: complex camera support libr
  This package contains the libcamera IPA (Image Processing Algorithms) modules.
 
 Package: libcamera-tools
+Architecture: linux-any
+Multi-Arch: foreign
 Section: video
-Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Multi-Arch: foreign
 Description: complex camera support library (tools)
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
@@ -118,11 +118,11 @@ Description: complex camera support libr
 
 Package: libcamera-v4l2
 Architecture: linux-any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Breaks: libcamera0 (<< 0.0.3-1~)
 Replaces: libcamera0 (<< 0.0.3-1~)
-Multi-Arch: same
 Description: complex camera support library (V4L2 module)
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
@@ -131,12 +131,12 @@ Description: complex camera support libr
  This package contains the libcamera V4L2 module.
 
 Package: gstreamer1.0-libcamera
-Architecture: any
+Architecture: linux-any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Breaks: libcamera0 (<< 0.0.3-1~)
 Replaces: libcamera0 (<< 0.0.3-1~)
-Multi-Arch: same
 Description: complex camera support library (GStreamer plugin)
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
@@ -145,12 +145,12 @@ Description: complex camera support libr
  This package contains the libcamera GStreamer plugin.
 
 Package: python3-libcamera
+Architecture: linux-any
+Multi-Arch: same
 Section: python
-Architecture: any
 Depends: ${misc:Depends},
          ${python3:Depends},
-         ${shlibs:Depends},
-Multi-Arch: same
+         ${shlibs:Depends}
 Description: complex camera support library (Python bindings)
  libcamera is a complex camera support library which handles low-level
  control of the camera devices, providing a unified higher-level
diff -pruN 0.2.0-3/debian/libcamera0.2.install 0.3.0-1/debian/libcamera0.2.install
--- 0.2.0-3/debian/libcamera0.2.install	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/libcamera0.2.install	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/lib/*/libcamera*.so.*
diff -pruN 0.2.0-3/debian/libcamera0.3.install 0.3.0-1/debian/libcamera0.3.install
--- 0.2.0-3/debian/libcamera0.3.install	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/debian/libcamera0.3.install	2024-05-20 08:53:34.000000000 +0000
@@ -0,0 +1 @@
+usr/lib/*/libcamera*.so.*
diff -pruN 0.2.0-3/debian/patches/64-bit-time-t-compat.patch 0.3.0-1/debian/patches/64-bit-time-t-compat.patch
--- 0.2.0-3/debian/patches/64-bit-time-t-compat.patch	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/patches/64-bit-time-t-compat.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-Description: 64-bit time_t compatibility for v4l2 module
- The v4l2 build unsets _FILE_OFFSET_BITS, which is not allowed when setting
- _TIME_BITS=64.  Having verified that nothing in this module is sensitive to
- 64-bit time_t (none of the functions it intercepts handle time), we also
- unset _TIME_BITS to allow this to build as before.
-Author: Steve Langasek <steve.langasek@canonical.com>
-Forwarded: no
-Last-Update: 2024-03-13
-Bug-Debian: https://bugs.debian.org/1066836
-
---- a/src/v4l2/meson.build
-+++ b/src/v4l2/meson.build
-@@ -23,6 +23,7 @@
-     # file operations, disable transparent large file support.
-     '-U_FILE_OFFSET_BITS',
-     '-D_FILE_OFFSET_BITS=32',
-+    '-U_TIME_BITS',
-     '-D_LARGEFILE64_SOURCE',
-     '-fvisibility=hidden',
- ]
diff -pruN 0.2.0-3/debian/patches/ppc64el-fix-ftbfs-gcc.patch 0.3.0-1/debian/patches/ppc64el-fix-ftbfs-gcc.patch
--- 0.2.0-3/debian/patches/ppc64el-fix-ftbfs-gcc.patch	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/patches/ppc64el-fix-ftbfs-gcc.patch	2024-05-20 08:53:34.000000000 +0000
@@ -18,7 +18,7 @@ Last-Update: 2022-10-18
 
 --- a/src/ipa/rpi/common/ipa_base.cpp
 +++ b/src/ipa/rpi/common/ipa_base.cpp
-@@ -43,7 +43,7 @@
+@@ -42,7 +42,7 @@
  /* Configure the sensor with these values initially. */
  constexpr double defaultAnalogueGain = 1.0;
  constexpr Duration defaultExposureTime = 20.0ms;
@@ -27,7 +27,7 @@ Last-Update: 2022-10-18
  constexpr Duration defaultMaxFrameDuration = 250.0s;
  
  /*
-@@ -52,7 +52,7 @@
+@@ -51,7 +51,7 @@
   * we rate-limit the controller Prepare() and Process() calls to lower than or
   * equal to this rate.
   */
diff -pruN 0.2.0-3/debian/patches/series 0.3.0-1/debian/patches/series
--- 0.2.0-3/debian/patches/series	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/patches/series	2024-05-20 08:53:34.000000000 +0000
@@ -1,3 +1,2 @@
 ppc64el-fix-ftbfs-gcc.patch
 skip_failing_tests.patch
-64-bit-time-t-compat.patch
diff -pruN 0.2.0-3/debian/patches/skip_failing_tests.patch 0.3.0-1/debian/patches/skip_failing_tests.patch
--- 0.2.0-3/debian/patches/skip_failing_tests.patch	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/patches/skip_failing_tests.patch	2024-05-20 08:53:34.000000000 +0000
@@ -51,7 +51,7 @@ Forwarded: not-needed
      {'name': 'flags', 'sources': ['flags.cpp']},
      {'name': 'hotplug-cameras', 'sources': ['hotplug-cameras.cpp']},
      {'name': 'message', 'sources': ['message.cpp']},
-@@ -65,12 +65,12 @@
+@@ -65,13 +65,13 @@
      {'name': 'object-delete', 'sources': ['object-delete.cpp']},
      {'name': 'object-invoke', 'sources': ['object-invoke.cpp']},
      {'name': 'pixel-format', 'sources': ['pixel-format.cpp']},
@@ -60,6 +60,7 @@ Forwarded: not-needed
      {'name': 'signal-threads', 'sources': ['signal-threads.cpp']},
      {'name': 'threads', 'sources': 'threads.cpp', 'dependencies': [libthreads]},
      {'name': 'timer', 'sources': ['timer.cpp']},
+     {'name': 'timer-fail', 'sources': ['timer-fail.cpp'], 'should_fail': true},
      {'name': 'timer-thread', 'sources': ['timer-thread.cpp']},
 -    {'name': 'unique-fd', 'sources': ['unique-fd.cpp']},
 +#    {'name': 'unique-fd', 'sources': ['unique-fd.cpp']},
diff -pruN 0.2.0-3/debian/watch 0.3.0-1/debian/watch
--- 0.2.0-3/debian/watch	2024-03-14 10:58:17.000000000 +0000
+++ 0.3.0-1/debian/watch	2024-05-20 08:53:34.000000000 +0000
@@ -1,9 +1,4 @@
 version=4
-
-opts="mode=git, pgpmode=none, repack, compression=xz" \
-    https://git.libcamera.org/libcamera/libcamera.git/ \
-    refs/tags/v@ANY_VERSION@
-
-#opts="mode=git, pgpmode=none, pretty=0.0.5+git%cd+%h, repack, compression=xz" \
-#    https://git.libcamera.org/libcamera/libcamera.git/ \
-#    HEAD
+opts="searchmode=plain" \
+ https://gitlab.freedesktop.org/camera/@PACKAGE@/tags?sort=updated_desc \
+ -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
diff -pruN 0.2.0-3/include/libcamera/base/backtrace.h 0.3.0-1/include/libcamera/base/backtrace.h
--- 0.2.0-3/include/libcamera/base/backtrace.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/backtrace.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * backtrace.h - Call stack backtraces
+ * Call stack backtraces
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/bound_method.h 0.3.0-1/include/libcamera/base/bound_method.h
--- 0.2.0-3/include/libcamera/base/bound_method.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/bound_method.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * bound_method.h - Method bind and invocation
+ * Method bind and invocation
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/class.h 0.3.0-1/include/libcamera/base/class.h
--- 0.2.0-3/include/libcamera/base/class.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/class.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * class.h - Utilities and helpers for classes
+ * Utilities and helpers for classes
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/compiler.h 0.3.0-1/include/libcamera/base/compiler.h
--- 0.2.0-3/include/libcamera/base/compiler.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/compiler.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * compiler.h - Compiler support
+ * Compiler support
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/event_dispatcher.h 0.3.0-1/include/libcamera/base/event_dispatcher.h
--- 0.2.0-3/include/libcamera/base/event_dispatcher.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/event_dispatcher.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_dispatcher.h - Event dispatcher
+ * Event dispatcher
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/event_dispatcher_poll.h 0.3.0-1/include/libcamera/base/event_dispatcher_poll.h
--- 0.2.0-3/include/libcamera/base/event_dispatcher_poll.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/event_dispatcher_poll.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_dispatcher_poll.h - Poll-based event dispatcher
+ * Poll-based event dispatcher
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/event_notifier.h 0.3.0-1/include/libcamera/base/event_notifier.h
--- 0.2.0-3/include/libcamera/base/event_notifier.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/event_notifier.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_notifier.h - File descriptor event notifier
+ * File descriptor event notifier
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/file.h 0.3.0-1/include/libcamera/base/file.h
--- 0.2.0-3/include/libcamera/base/file.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/file.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * file.h - File I/O operations
+ * File I/O operations
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/flags.h 0.3.0-1/include/libcamera/base/flags.h
--- 0.2.0-3/include/libcamera/base/flags.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/flags.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * flags.h - Type-safe enum-based bitfields
+ * Type-safe enum-based bitfields
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/log.h 0.3.0-1/include/libcamera/base/log.h
--- 0.2.0-3/include/libcamera/base/log.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/log.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * log.h - Logging infrastructure
+ * Logging infrastructure
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/message.h 0.3.0-1/include/libcamera/base/message.h
--- 0.2.0-3/include/libcamera/base/message.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/message.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * message.h - Message queue support
+ * Message queue support
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/mutex.h 0.3.0-1/include/libcamera/base/mutex.h
--- 0.2.0-3/include/libcamera/base/mutex.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/mutex.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * mutex.h - Mutex classes with clang thread safety annotation
+ * Mutex classes with clang thread safety annotation
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/object.h 0.3.0-1/include/libcamera/base/object.h
--- 0.2.0-3/include/libcamera/base/object.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/object.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * object.h - Base object
+ * Base object
  */
 
 #pragma once
@@ -49,6 +49,8 @@ public:
 protected:
 	virtual void message(Message *msg);
 
+	bool assertThreadBound(const char *message);
+
 private:
 	friend class SignalBase;
 	friend class Thread;
diff -pruN 0.2.0-3/include/libcamera/base/private.h 0.3.0-1/include/libcamera/base/private.h
--- 0.2.0-3/include/libcamera/base/private.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/private.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * private.h - Private Header Validation
+ * Private Header Validation
  *
  * A selection of internal libcamera headers are installed as part
  * of the libcamera package to allow sharing of a select subset of
diff -pruN 0.2.0-3/include/libcamera/base/semaphore.h 0.3.0-1/include/libcamera/base/semaphore.h
--- 0.2.0-3/include/libcamera/base/semaphore.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/semaphore.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * semaphore.h - General-purpose counting semaphore
+ * General-purpose counting semaphore
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/shared_fd.h 0.3.0-1/include/libcamera/base/shared_fd.h
--- 0.2.0-3/include/libcamera/base/shared_fd.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/shared_fd.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * shared_fd.h - File descriptor wrapper with shared ownership
+ * File descriptor wrapper with shared ownership
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/signal.h 0.3.0-1/include/libcamera/base/signal.h
--- 0.2.0-3/include/libcamera/base/signal.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/signal.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * signal.h - Signal & slot implementation
+ * Signal & slot implementation
  */
 
 #pragma once
@@ -13,10 +13,11 @@
 #include <vector>
 
 #include <libcamera/base/bound_method.h>
-#include <libcamera/base/object.h>
 
 namespace libcamera {
 
+class Object;
+
 class SignalBase
 {
 public:
diff -pruN 0.2.0-3/include/libcamera/base/span.h 0.3.0-1/include/libcamera/base/span.h
--- 0.2.0-3/include/libcamera/base/span.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/span.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * span.h - C++20 std::span<> implementation for C++11
+ * C++20 std::span<> implementation for C++11
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/thread.h 0.3.0-1/include/libcamera/base/thread.h
--- 0.2.0-3/include/libcamera/base/thread.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/thread.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * thread.h - Thread support
+ * Thread support
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/thread_annotations.h 0.3.0-1/include/libcamera/base/thread_annotations.h
--- 0.2.0-3/include/libcamera/base/thread_annotations.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/thread_annotations.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * thread_annotation.h - Macro of Clang thread safety analysis
+ * Macro of Clang thread safety analysis
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/timer.h 0.3.0-1/include/libcamera/base/timer.h
--- 0.2.0-3/include/libcamera/base/timer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/timer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * timer.h - Generic timer
+ * Generic timer
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/unique_fd.h 0.3.0-1/include/libcamera/base/unique_fd.h
--- 0.2.0-3/include/libcamera/base/unique_fd.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/unique_fd.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * unique_fd.h - File descriptor wrapper that owns a file descriptor.
+ * File descriptor wrapper that owns a file descriptor.
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/base/utils.h 0.3.0-1/include/libcamera/base/utils.h
--- 0.2.0-3/include/libcamera/base/utils.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/base/utils.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * utils.h - Miscellaneous utility functions
+ * Miscellaneous utility functions
  */
 
 #pragma once
@@ -369,6 +369,12 @@ decltype(auto) abs_diff(const T &a, cons
 
 double strtod(const char *__restrict nptr, char **__restrict endptr);
 
+template<class Enum>
+constexpr std::underlying_type_t<Enum> to_underlying(Enum e) noexcept
+{
+	return static_cast<std::underlying_type_t<Enum>>(e);
+}
+
 } /* namespace utils */
 
 #ifndef __DOXYGEN__
diff -pruN 0.2.0-3/include/libcamera/camera.h 0.3.0-1/include/libcamera/camera.h
--- 0.2.0-3/include/libcamera/camera.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/camera.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * camera.h - Camera object interface
+ * Camera object interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/camera_manager.h 0.3.0-1/include/libcamera/camera_manager.h
--- 0.2.0-3/include/libcamera/camera_manager.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/camera_manager.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * camera_manager.h - Camera management
+ * Camera management
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/color_space.h 0.3.0-1/include/libcamera/color_space.h
--- 0.2.0-3/include/libcamera/color_space.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/color_space.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Raspberry Pi Ltd
  *
- * color_space.h - color space definitions
+ * color space definitions
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/control_ids.h.in 0.3.0-1/include/libcamera/control_ids.h.in
--- 0.2.0-3/include/libcamera/control_ids.h.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/control_ids.h.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_ids.h - Control ID list
+ * Control ID list
  *
  * This file is auto-generated. Do not edit.
  */
@@ -10,7 +10,9 @@
 #pragma once
 
 #include <array>
+#include <map>
 #include <stdint.h>
+#include <string>
 
 #include <libcamera/controls.h>
 
diff -pruN 0.2.0-3/include/libcamera/controls.h 0.3.0-1/include/libcamera/controls.h
--- 0.2.0-3/include/libcamera/controls.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/controls.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * controls.h - Control handling
+ * Control handling
  */
 
 #pragma once
@@ -352,6 +352,11 @@ private:
 	using ControlListMap = std::unordered_map<unsigned int, ControlValue>;
 
 public:
+	enum class MergePolicy {
+		KeepExisting = 0,
+		OverwriteExisting,
+	};
+
 	ControlList();
 	ControlList(const ControlIdMap &idmap, const ControlValidator *validator = nullptr);
 	ControlList(const ControlInfoMap &infoMap, const ControlValidator *validator = nullptr);
@@ -368,7 +373,7 @@ public:
 	std::size_t size() const { return controls_.size(); }
 
 	void clear() { controls_.clear(); }
-	void merge(const ControlList &source);
+	void merge(const ControlList &source, MergePolicy policy = MergePolicy::KeepExisting);
 
 	bool contains(unsigned int id) const;
 
diff -pruN 0.2.0-3/include/libcamera/fence.h 0.3.0-1/include/libcamera/fence.h
--- 0.2.0-3/include/libcamera/fence.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/fence.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * internal/fence.h - Synchronization fence
+ * Synchronization fence
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/formats.h.in 0.3.0-1/include/libcamera/formats.h.in
--- 0.2.0-3/include/libcamera/formats.h.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/formats.h.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * formats.h - Formats
+ * Formats
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/include/libcamera/framebuffer.h 0.3.0-1/include/libcamera/framebuffer.h
--- 0.2.0-3/include/libcamera/framebuffer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/framebuffer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * framebuffer.h - Frame buffer handling
+ * Frame buffer handling
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/framebuffer_allocator.h 0.3.0-1/include/libcamera/framebuffer_allocator.h
--- 0.2.0-3/include/libcamera/framebuffer_allocator.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/framebuffer_allocator.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * framebuffer_allocator.h - FrameBuffer allocator
+ * FrameBuffer allocator
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/geometry.h 0.3.0-1/include/libcamera/geometry.h
--- 0.2.0-3/include/libcamera/geometry.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/geometry.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * geometry.h - Geometry-related classes
+ * Geometry-related classes
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/bayer_format.h 0.3.0-1/include/libcamera/internal/bayer_format.h
--- 0.2.0-3/include/libcamera/internal/bayer_format.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/bayer_format.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * bayer_format.h - Bayer Pixel Format
+ * Bayer Pixel Format
  */
 
 #pragma once
@@ -34,6 +34,8 @@ public:
 		None = 0,
 		CSI2 = 1,
 		IPU3 = 2,
+		PISP1 = 3,
+		PISP2 = 4,
 	};
 
 	constexpr BayerFormat()
diff -pruN 0.2.0-3/include/libcamera/internal/byte_stream_buffer.h 0.3.0-1/include/libcamera/internal/byte_stream_buffer.h
--- 0.2.0-3/include/libcamera/internal/byte_stream_buffer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/byte_stream_buffer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * byte_stream_buffer.h - Byte stream buffer
+ * Byte stream buffer
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/camera.h 0.3.0-1/include/libcamera/internal/camera.h
--- 0.2.0-3/include/libcamera/internal/camera.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/camera.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera.h - Camera private data
+ * Camera private data
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/camera_controls.h 0.3.0-1/include/libcamera/internal/camera_controls.h
--- 0.2.0-3/include/libcamera/internal/camera_controls.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/camera_controls.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_controls.h - Camera controls
+ * Camera controls
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/camera_lens.h 0.3.0-1/include/libcamera/internal/camera_lens.h
--- 0.2.0-3/include/libcamera/internal/camera_lens.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/camera_lens.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_lens.h - A camera lens controller
+ * A camera lens controller
  */
 #pragma once
 
diff -pruN 0.2.0-3/include/libcamera/internal/camera_manager.h 0.3.0-1/include/libcamera/internal/camera_manager.h
--- 0.2.0-3/include/libcamera/internal/camera_manager.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/camera_manager.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Ideas on Board Oy.
  *
- * camera_manager.h - Camera manager private data
+ * Camera manager private data
  */
 
 #pragma once
@@ -44,6 +44,7 @@ protected:
 private:
 	int init();
 	void createPipelineHandlers();
+	void pipelineFactoryMatch(const PipelineHandlerFactoryBase *factory);
 	void cleanup() LIBCAMERA_TSA_EXCLUDES(mutex_);
 
 	/*
diff -pruN 0.2.0-3/include/libcamera/internal/camera_sensor.h 0.3.0-1/include/libcamera/internal/camera_sensor.h
--- 0.2.0-3/include/libcamera/internal/camera_sensor.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/camera_sensor.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_sensor.h - A camera sensor
+ * A camera sensor
  */
 
 #pragma once
@@ -22,12 +22,12 @@
 
 #include <libcamera/ipa/core_ipa_interface.h>
 
+#include "libcamera/internal/bayer_format.h"
 #include "libcamera/internal/formats.h"
 #include "libcamera/internal/v4l2_subdevice.h"
 
 namespace libcamera {
 
-class BayerFormat;
 class CameraLens;
 class MediaEntity;
 class SensorConfiguration;
@@ -46,15 +46,15 @@ public:
 
 	const std::string &model() const { return model_; }
 	const std::string &id() const { return id_; }
+
 	const MediaEntity *entity() const { return entity_; }
+	V4L2Subdevice *device() { return subdev_.get(); }
+
+	CameraLens *focusLens() { return focusLens_.get(); }
+
 	const std::vector<unsigned int> &mbusCodes() const { return mbusCodes_; }
 	std::vector<Size> sizes(unsigned int mbusCode) const;
 	Size resolution() const;
-	const std::vector<controls::draft::TestPatternModeEnum> &testPatternModes() const
-	{
-		return testPatternModes_;
-	}
-	int setTestPatternMode(controls::draft::TestPatternModeEnum mode);
 
 	V4L2SubdeviceFormat getFormat(const std::vector<unsigned int> &mbusCodes,
 				      const Size &size) const;
@@ -66,20 +66,20 @@ public:
 			       Transform transform = Transform::Identity,
 			       V4L2SubdeviceFormat *sensorFormat = nullptr);
 
-	const ControlInfoMap &controls() const;
-	ControlList getControls(const std::vector<uint32_t> &ids);
-	int setControls(ControlList *ctrls);
-
-	V4L2Subdevice *device() { return subdev_.get(); }
-
 	const ControlList &properties() const { return properties_; }
 	int sensorInfo(IPACameraSensorInfo *info) const;
+	Transform computeTransform(Orientation *orientation) const;
+	BayerFormat::Order bayerOrder(Transform t) const;
 
-	void updateControlInfo();
-
-	CameraLens *focusLens() { return focusLens_.get(); }
+	const ControlInfoMap &controls() const;
+	ControlList getControls(const std::vector<uint32_t> &ids);
+	int setControls(ControlList *ctrls);
 
-	Transform computeTransform(Orientation *orientation) const;
+	const std::vector<controls::draft::TestPatternModeEnum> &testPatternModes() const
+	{
+		return testPatternModes_;
+	}
+	int setTestPatternMode(controls::draft::TestPatternModeEnum mode);
 
 protected:
 	std::string logPrefix() const override;
@@ -93,8 +93,8 @@ private:
 	void initStaticProperties();
 	void initTestPatternModes();
 	int initProperties();
-	int applyTestPatternMode(controls::draft::TestPatternModeEnum mode);
 	int discoverAncillaryDevices();
+	int applyTestPatternMode(controls::draft::TestPatternModeEnum mode);
 
 	const MediaEntity *entity_;
 	std::unique_ptr<V4L2Subdevice> subdev_;
@@ -115,6 +115,7 @@ private:
 	Rectangle activeArea_;
 	const BayerFormat *bayerFormat_;
 	bool supportFlips_;
+	bool flipsAlterBayerOrder_;
 	Orientation mountingOrientation_;
 
 	ControlList properties_;
diff -pruN 0.2.0-3/include/libcamera/internal/camera_sensor_properties.h 0.3.0-1/include/libcamera/internal/camera_sensor_properties.h
--- 0.2.0-3/include/libcamera/internal/camera_sensor_properties.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/camera_sensor_properties.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_sensor_properties.h - Database of camera sensor properties
+ * Database of camera sensor properties
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/control_serializer.h 0.3.0-1/include/libcamera/internal/control_serializer.h
--- 0.2.0-3/include/libcamera/internal/control_serializer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/control_serializer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_serializer.h - Control (de)serializer
+ * Control (de)serializer
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/control_validator.h 0.3.0-1/include/libcamera/internal/control_validator.h
--- 0.2.0-3/include/libcamera/internal/control_validator.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/control_validator.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_validator.h - Control validator
+ * Control validator
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/converter/converter_v4l2_m2m.h 0.3.0-1/include/libcamera/internal/converter/converter_v4l2_m2m.h
--- 0.2.0-3/include/libcamera/internal/converter/converter_v4l2_m2m.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/converter/converter_v4l2_m2m.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Laurent Pinchart
  * Copyright 2022 NXP
  *
- * converter_v4l2_m2m.h - V4l2 M2M Format converter interface
+ * V4l2 M2M Format converter interface
  */
 
 #pragma once
@@ -47,7 +47,7 @@ public:
 
 	int configure(const StreamConfiguration &inputCfg,
 		      const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfg);
-	int exportBuffers(unsigned int ouput, unsigned int count,
+	int exportBuffers(unsigned int output, unsigned int count,
 			  std::vector<std::unique_ptr<FrameBuffer>> *buffers);
 
 	int start();
diff -pruN 0.2.0-3/include/libcamera/internal/converter.h 0.3.0-1/include/libcamera/internal/converter.h
--- 0.2.0-3/include/libcamera/internal/converter.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/converter.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Laurent Pinchart
  * Copyright 2022 NXP
  *
- * converter.h - Generic format converter interface
+ * Generic format converter interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/delayed_controls.h 0.3.0-1/include/libcamera/internal/delayed_controls.h
--- 0.2.0-3/include/libcamera/internal/delayed_controls.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/delayed_controls.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * delayed_controls.h - Helper to deal with controls that take effect with a delay
+ * Helper to deal with controls that take effect with a delay
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/device_enumerator.h 0.3.0-1/include/libcamera/internal/device_enumerator.h
--- 0.2.0-3/include/libcamera/internal/device_enumerator.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/device_enumerator.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * device_enumerator.h - API to enumerate and find media devices
+ * API to enumerate and find media devices
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/device_enumerator_sysfs.h 0.3.0-1/include/libcamera/internal/device_enumerator_sysfs.h
--- 0.2.0-3/include/libcamera/internal/device_enumerator_sysfs.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/device_enumerator_sysfs.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * device_enumerator_sysfs.h - sysfs-based device enumerator
+ * sysfs-based device enumerator
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/device_enumerator_udev.h 0.3.0-1/include/libcamera/internal/device_enumerator_udev.h
--- 0.2.0-3/include/libcamera/internal/device_enumerator_udev.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/device_enumerator_udev.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018-2019, Google Inc.
  *
- * device_enumerator_udev.h - udev-based device enumerator
+ * udev-based device enumerator
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/dma_heaps.h 0.3.0-1/include/libcamera/internal/dma_heaps.h
--- 0.2.0-3/include/libcamera/internal/dma_heaps.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/dma_heaps.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,38 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2020, Raspberry Pi Ltd
+ *
+ * Helper class for dma-heap allocations.
+ */
+
+#pragma once
+
+#include <stddef.h>
+
+#include <libcamera/base/flags.h>
+#include <libcamera/base/unique_fd.h>
+
+namespace libcamera {
+
+class DmaHeap
+{
+public:
+	enum class DmaHeapFlag {
+		Cma = 1 << 0,
+		System = 1 << 1,
+	};
+
+	using DmaHeapFlags = Flags<DmaHeapFlag>;
+
+	DmaHeap(DmaHeapFlags flags = DmaHeapFlag::Cma);
+	~DmaHeap();
+	bool isValid() const { return dmaHeapHandle_.isValid(); }
+	UniqueFD alloc(const char *name, std::size_t size);
+
+private:
+	UniqueFD dmaHeapHandle_;
+};
+
+LIBCAMERA_FLAGS_ENABLE_OPERATORS(DmaHeap::DmaHeapFlag)
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/formats.h 0.3.0-1/include/libcamera/internal/formats.h
--- 0.2.0-3/include/libcamera/internal/formats.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/formats.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * formats.h - libcamera image formats
+ * libcamera image formats
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/framebuffer.h 0.3.0-1/include/libcamera/internal/framebuffer.h
--- 0.2.0-3/include/libcamera/internal/framebuffer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/framebuffer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * framebuffer.h - Internal frame buffer handling
+ * Internal frame buffer handling
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipa_data_serializer.h 0.3.0-1/include/libcamera/internal/ipa_data_serializer.h
--- 0.2.0-3/include/libcamera/internal/ipa_data_serializer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipa_data_serializer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipa_data_serializer.h - Image Processing Algorithm data serializer
+ * Image Processing Algorithm data serializer
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipa_manager.h 0.3.0-1/include/libcamera/internal/ipa_manager.h
--- 0.2.0-3/include/libcamera/internal/ipa_manager.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipa_manager.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_manager.h - Image Processing Algorithm module manager
+ * Image Processing Algorithm module manager
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipa_module.h 0.3.0-1/include/libcamera/internal/ipa_module.h
--- 0.2.0-3/include/libcamera/internal/ipa_module.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipa_module.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_module.h - Image Processing Algorithm module
+ * Image Processing Algorithm module
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipa_proxy.h 0.3.0-1/include/libcamera/internal/ipa_proxy.h
--- 0.2.0-3/include/libcamera/internal/ipa_proxy.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipa_proxy.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_proxy.h - Image Processing Algorithm proxy
+ * Image Processing Algorithm proxy
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipc_pipe.h 0.3.0-1/include/libcamera/internal/ipc_pipe.h
--- 0.2.0-3/include/libcamera/internal/ipc_pipe.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipc_pipe.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipc_pipe.h - Image Processing Algorithm IPC module for IPA proxies
+ * Image Processing Algorithm IPC module for IPA proxies
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipc_pipe_unixsocket.h 0.3.0-1/include/libcamera/internal/ipc_pipe_unixsocket.h
--- 0.2.0-3/include/libcamera/internal/ipc_pipe_unixsocket.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipc_pipe_unixsocket.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipc_pipe_unixsocket.h - Image Processing Algorithm IPC module using unix socket
+ * Image Processing Algorithm IPC module using unix socket
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/ipc_unixsocket.h 0.3.0-1/include/libcamera/internal/ipc_unixsocket.h
--- 0.2.0-3/include/libcamera/internal/ipc_unixsocket.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/ipc_unixsocket.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipc_unixsocket.h - IPC mechanism based on Unix sockets
+ * IPC mechanism based on Unix sockets
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/mapped_framebuffer.h 0.3.0-1/include/libcamera/internal/mapped_framebuffer.h
--- 0.2.0-3/include/libcamera/internal/mapped_framebuffer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/mapped_framebuffer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * mapped_framebuffer.h - Frame buffer memory mapping support
+ * Frame buffer memory mapping support
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/media_device.h 0.3.0-1/include/libcamera/internal/media_device.h
--- 0.2.0-3/include/libcamera/internal/media_device.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/media_device.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * media_device.h - Media device handler
+ * Media device handler
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/media_object.h 0.3.0-1/include/libcamera/internal/media_object.h
--- 0.2.0-3/include/libcamera/internal/media_object.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/media_object.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * media_object.h - Media Device objects: entities, pads and links.
+ * Media Device objects: entities, pads and links.
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/meson.build 0.3.0-1/include/libcamera/internal/meson.build
--- 0.2.0-3/include/libcamera/internal/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -25,6 +25,7 @@ libcamera_internal_headers = files([
     'device_enumerator.h',
     'device_enumerator_sysfs.h',
     'device_enumerator_udev.h',
+    'dma_heaps.h',
     'formats.h',
     'framebuffer.h',
     'ipa_manager.h',
@@ -38,6 +39,7 @@ libcamera_internal_headers = files([
     'process.h',
     'pub_key.h',
     'request.h',
+    'shared_mem_object.h',
     'source_paths.h',
     'sysfs.h',
     'v4l2_device.h',
@@ -48,3 +50,4 @@ libcamera_internal_headers = files([
 ])
 
 subdir('converter')
+subdir('software_isp')
diff -pruN 0.2.0-3/include/libcamera/internal/pipeline_handler.h 0.3.0-1/include/libcamera/internal/pipeline_handler.h
--- 0.2.0-3/include/libcamera/internal/pipeline_handler.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/pipeline_handler.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * pipeline_handler.h - Pipeline handler infrastructure
+ * Pipeline handler infrastructure
  */
 
 #pragma once
@@ -114,6 +114,7 @@ public:
 	const std::string &name() const { return name_; }
 
 	static std::vector<PipelineHandlerFactoryBase *> &factories();
+	static const PipelineHandlerFactoryBase *getFactoryByName(const std::string &name);
 
 private:
 	static void registerType(PipelineHandlerFactoryBase *factory);
@@ -140,7 +141,7 @@ public:
 	}
 };
 
-#define REGISTER_PIPELINE_HANDLER(handler) \
-static PipelineHandlerFactory<handler> global_##handler##Factory(#handler);
+#define REGISTER_PIPELINE_HANDLER(handler, name) \
+	static PipelineHandlerFactory<handler> global_##handler##Factory(name);
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/process.h 0.3.0-1/include/libcamera/internal/process.h
--- 0.2.0-3/include/libcamera/internal/process.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/process.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * process.h - Process object
+ * Process object
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/pub_key.h 0.3.0-1/include/libcamera/internal/pub_key.h
--- 0.2.0-3/include/libcamera/internal/pub_key.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/pub_key.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * pub_key.h - Public key signature verification
+ * Public key signature verification
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/request.h 0.3.0-1/include/libcamera/internal/request.h
--- 0.2.0-3/include/libcamera/internal/request.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/request.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * request.h - Request class private data
+ * Request class private data
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/shared_mem_object.h 0.3.0-1/include/libcamera/internal/shared_mem_object.h
--- 0.2.0-3/include/libcamera/internal/shared_mem_object.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/shared_mem_object.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,127 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023 Raspberry Pi Ltd
+ * Copyright (C) 2024 Andrei Konovalov
+ * Copyright (C) 2024 Dennis Bonke
+ *
+ * Helpers for shared memory allocations
+ */
+#pragma once
+
+#include <stddef.h>
+#include <stdint.h>
+#include <string>
+#include <sys/mman.h>
+#include <type_traits>
+#include <utility>
+
+#include <libcamera/base/class.h>
+#include <libcamera/base/shared_fd.h>
+#include <libcamera/base/span.h>
+
+namespace libcamera {
+
+class SharedMem
+{
+public:
+	SharedMem();
+
+	SharedMem(const std::string &name, std::size_t size);
+	SharedMem(SharedMem &&rhs);
+
+	virtual ~SharedMem();
+
+	SharedMem &operator=(SharedMem &&rhs);
+
+	const SharedFD &fd() const
+	{
+		return fd_;
+	}
+
+	Span<uint8_t> mem() const
+	{
+		return mem_;
+	}
+
+	explicit operator bool() const
+	{
+		return !mem_.empty();
+	}
+
+private:
+	LIBCAMERA_DISABLE_COPY(SharedMem)
+
+	SharedFD fd_;
+
+	Span<uint8_t> mem_;
+};
+
+template<class T, typename = std::enable_if_t<std::is_standard_layout<T>::value>>
+class SharedMemObject : public SharedMem
+{
+public:
+	static constexpr std::size_t kSize = sizeof(T);
+
+	SharedMemObject()
+		: SharedMem(), obj_(nullptr)
+	{
+	}
+
+	template<class... Args>
+	SharedMemObject(const std::string &name, Args &&...args)
+		: SharedMem(name, kSize), obj_(nullptr)
+	{
+		if (mem().empty())
+			return;
+
+		obj_ = new (mem().data()) T(std::forward<Args>(args)...);
+	}
+
+	SharedMemObject(SharedMemObject<T> &&rhs)
+		: SharedMem(std::move(rhs))
+	{
+		this->obj_ = rhs.obj_;
+		rhs.obj_ = nullptr;
+	}
+
+	~SharedMemObject()
+	{
+		if (obj_)
+			obj_->~T();
+	}
+
+	SharedMemObject<T> &operator=(SharedMemObject<T> &&rhs)
+	{
+		SharedMem::operator=(std::move(rhs));
+		this->obj_ = rhs.obj_;
+		rhs.obj_ = nullptr;
+		return *this;
+	}
+
+	T *operator->()
+	{
+		return obj_;
+	}
+
+	const T *operator->() const
+	{
+		return obj_;
+	}
+
+	T &operator*()
+	{
+		return *obj_;
+	}
+
+	const T &operator*() const
+	{
+		return *obj_;
+	}
+
+private:
+	LIBCAMERA_DISABLE_COPY(SharedMemObject)
+
+	T *obj_;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/software_isp/debayer_params.h 0.3.0-1/include/libcamera/internal/software_isp/debayer_params.h
--- 0.2.0-3/include/libcamera/internal/software_isp/debayer_params.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/software_isp/debayer_params.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,29 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * DebayerParams header
+ */
+
+#pragma once
+
+namespace libcamera {
+
+struct DebayerParams {
+	static constexpr unsigned int kGain10 = 256;
+
+	unsigned int gainR;
+	unsigned int gainG;
+	unsigned int gainB;
+
+	float gamma;
+	/**
+	 * \brief Level of the black point, 0..255, 0 is no correction.
+	 */
+	unsigned int blackLevel;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/software_isp/meson.build 0.3.0-1/include/libcamera/internal/software_isp/meson.build
--- 0.2.0-3/include/libcamera/internal/software_isp/meson.build	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/software_isp/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,7 @@
+# SPDX-License-Identifier: CC0-1.0
+
+libcamera_internal_headers += files([
+    'debayer_params.h',
+    'software_isp.h',
+    'swisp_stats.h',
+])
diff -pruN 0.2.0-3/include/libcamera/internal/software_isp/software_isp.h 0.3.0-1/include/libcamera/internal/software_isp/software_isp.h
--- 0.2.0-3/include/libcamera/internal/software_isp/software_isp.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/software_isp/software_isp.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,99 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ *
+ * Simple software ISP implementation
+ */
+
+#pragma once
+
+#include <functional>
+#include <initializer_list>
+#include <map>
+#include <memory>
+#include <string>
+#include <tuple>
+#include <vector>
+
+#include <libcamera/base/class.h>
+#include <libcamera/base/log.h>
+#include <libcamera/base/signal.h>
+#include <libcamera/base/thread.h>
+
+#include <libcamera/geometry.h>
+#include <libcamera/pixel_format.h>
+
+#include <libcamera/ipa/soft_ipa_interface.h>
+#include <libcamera/ipa/soft_ipa_proxy.h>
+
+#include "libcamera/internal/camera_sensor.h"
+#include "libcamera/internal/dma_heaps.h"
+#include "libcamera/internal/pipeline_handler.h"
+#include "libcamera/internal/shared_mem_object.h"
+#include "libcamera/internal/software_isp/debayer_params.h"
+
+namespace libcamera {
+
+class DebayerCpu;
+class FrameBuffer;
+class PixelFormat;
+struct StreamConfiguration;
+
+LOG_DECLARE_CATEGORY(SoftwareIsp)
+
+class SoftwareIsp
+{
+public:
+	SoftwareIsp(PipelineHandler *pipe, const CameraSensor *sensor);
+	~SoftwareIsp();
+
+	int loadConfiguration([[maybe_unused]] const std::string &filename) { return 0; }
+
+	bool isValid() const;
+
+	std::vector<PixelFormat> formats(PixelFormat input);
+
+	SizeRange sizes(PixelFormat inputFormat, const Size &inputSize);
+
+	std::tuple<unsigned int, unsigned int>
+	strideAndFrameSize(const PixelFormat &outputFormat, const Size &size);
+
+	int configure(const StreamConfiguration &inputCfg,
+		      const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfgs,
+		      const ControlInfoMap &sensorControls);
+
+	int exportBuffers(unsigned int output, unsigned int count,
+			  std::vector<std::unique_ptr<FrameBuffer>> *buffers);
+
+	void processStats(const ControlList &sensorControls);
+
+	int start();
+	void stop();
+
+	int queueBuffers(FrameBuffer *input,
+			 const std::map<unsigned int, FrameBuffer *> &outputs);
+
+	void process(FrameBuffer *input, FrameBuffer *output);
+
+	Signal<FrameBuffer *> inputBufferReady;
+	Signal<FrameBuffer *> outputBufferReady;
+	Signal<> ispStatsReady;
+	Signal<const ControlList &> setSensorControls;
+
+private:
+	void saveIspParams();
+	void setSensorCtrls(const ControlList &sensorControls);
+	void statsReady();
+	void inputReady(FrameBuffer *input);
+	void outputReady(FrameBuffer *output);
+
+	std::unique_ptr<DebayerCpu> debayer_;
+	Thread ispWorkerThread_;
+	SharedMemObject<DebayerParams> sharedParams_;
+	DebayerParams debayerParams_;
+	DmaHeap dmaHeap_;
+
+	std::unique_ptr<ipa::soft::IPAProxySoft> ipa_;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/software_isp/swisp_stats.h 0.3.0-1/include/libcamera/internal/software_isp/swisp_stats.h
--- 0.2.0-3/include/libcamera/internal/software_isp/swisp_stats.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/software_isp/swisp_stats.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,49 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ *
+ * Statistics data format used by the software ISP and software IPA
+ */
+
+#pragma once
+
+#include <array>
+#include <stdint.h>
+
+namespace libcamera {
+
+/**
+ * \brief Struct that holds the statistics for the Software ISP
+ *
+ * The struct value types are large enough to not overflow.
+ * Should they still overflow for some reason, no check is performed and they
+ * wrap around.
+ */
+struct SwIspStats {
+	/**
+	 * \brief Holds the sum of all sampled red pixels
+	 */
+	uint64_t sumR_;
+	/**
+	 * \brief Holds the sum of all sampled green pixels
+	 */
+	uint64_t sumG_;
+	/**
+	 * \brief Holds the sum of all sampled blue pixels
+	 */
+	uint64_t sumB_;
+	/**
+	 * \brief Number of bins in the yHistogram
+	 */
+	static constexpr unsigned int kYHistogramSize = 64;
+	/**
+	 * \brief Type of the histogram.
+	 */
+	using Histogram = std::array<uint32_t, kYHistogramSize>;
+	/**
+	 * \brief A histogram of luminance values
+	 */
+	Histogram yHistogram;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/source_paths.h 0.3.0-1/include/libcamera/internal/source_paths.h
--- 0.2.0-3/include/libcamera/internal/source_paths.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/source_paths.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * source_paths.h - Identify libcamera source and build paths
+ * Identify libcamera source and build paths
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/sysfs.h 0.3.0-1/include/libcamera/internal/sysfs.h
--- 0.2.0-3/include/libcamera/internal/sysfs.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/sysfs.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * sysfs.h - Miscellaneous utility functions to access sysfs
+ * Miscellaneous utility functions to access sysfs
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/tracepoints.h.in 0.3.0-1/include/libcamera/internal/tracepoints.h.in
--- 0.2.0-3/include/libcamera/internal/tracepoints.h.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/tracepoints.h.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) {{year}}, Google Inc.
  *
- * tracepoints.h - Tracepoints with lttng
+ * Tracepoints with lttng
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/include/libcamera/internal/v4l2_device.h 0.3.0-1/include/libcamera/internal/v4l2_device.h
--- 0.2.0-3/include/libcamera/internal/v4l2_device.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/v4l2_device.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_device.h - Common base for V4L2 video devices and subdevices
+ * Common base for V4L2 video devices and subdevices
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/v4l2_pixelformat.h 0.3.0-1/include/libcamera/internal/v4l2_pixelformat.h
--- 0.2.0-3/include/libcamera/internal/v4l2_pixelformat.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/v4l2_pixelformat.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Google Inc.
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * v4l2_pixelformat.h - V4L2 Pixel Format
+ * V4L2 Pixel Format
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/v4l2_subdevice.h 0.3.0-1/include/libcamera/internal/v4l2_subdevice.h
--- 0.2.0-3/include/libcamera/internal/v4l2_subdevice.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/v4l2_subdevice.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_subdevice.h - V4L2 Subdevice
+ * V4L2 Subdevice
  */
 
 #pragma once
@@ -29,6 +29,26 @@ namespace libcamera {
 
 class MediaDevice;
 
+class MediaBusFormatInfo
+{
+public:
+	enum class Type {
+		Image,
+		Metadata,
+		EmbeddedData,
+	};
+
+	bool isValid() const { return code != 0; }
+
+	static const MediaBusFormatInfo &info(uint32_t code);
+
+	const char *name;
+	uint32_t code;
+	Type type;
+	unsigned int bitsPerPixel;
+	PixelFormatInfo::ColourEncoding colourEncoding;
+};
+
 struct V4L2SubdeviceCapability final : v4l2_subdev_capability {
 	bool isReadOnly() const
 	{
@@ -36,17 +56,16 @@ struct V4L2SubdeviceCapability final : v
 	}
 	bool hasStreams() const
 	{
-		return capabilities & V4L2_SUBDEV_CAP_MPLEXED;
+		return capabilities & V4L2_SUBDEV_CAP_STREAMS;
 	}
 };
 
 struct V4L2SubdeviceFormat {
-	uint32_t mbus_code;
+	uint32_t code;
 	Size size;
 	std::optional<ColorSpace> colorSpace;
 
 	const std::string toString() const;
-	uint8_t bitsPerPixel() const;
 };
 
 std::ostream &operator<<(std::ostream &out, const V4L2SubdeviceFormat &f);
@@ -61,12 +80,39 @@ public:
 		ActiveFormat = V4L2_SUBDEV_FORMAT_ACTIVE,
 	};
 
-	class Routing : public std::vector<struct v4l2_subdev_route>
-	{
-	public:
-		std::string toString() const;
+	struct Stream {
+		Stream()
+			: pad(0), stream(0)
+		{
+		}
+
+		Stream(unsigned int p, unsigned int s)
+			: pad(p), stream(s)
+		{
+		}
+
+		unsigned int pad;
+		unsigned int stream;
 	};
 
+	struct Route {
+		Route()
+			: flags(0)
+		{
+		}
+
+		Route(const Stream &snk, const Stream &src, uint32_t f)
+			: sink(snk), source(src), flags(f)
+		{
+		}
+
+		Stream sink;
+		Stream source;
+		uint32_t flags;
+	};
+
+	using Routing = std::vector<Route>;
+
 	explicit V4L2Subdevice(const MediaEntity *entity);
 	~V4L2Subdevice();
 
@@ -74,17 +120,39 @@ public:
 
 	const MediaEntity *entity() const { return entity_; }
 
-	int getSelection(unsigned int pad, unsigned int target,
+	int getSelection(const Stream &stream, unsigned int target,
 			 Rectangle *rect);
-	int setSelection(unsigned int pad, unsigned int target,
+	int getSelection(unsigned int pad, unsigned int target, Rectangle *rect)
+	{
+		return getSelection({ pad, 0 }, target, rect);
+	}
+	int setSelection(const Stream &stream, unsigned int target,
 			 Rectangle *rect);
+	int setSelection(unsigned int pad, unsigned int target, Rectangle *rect)
+	{
+		return setSelection({ pad, 0 }, target, rect);
+	}
 
-	Formats formats(unsigned int pad);
+	Formats formats(const Stream &stream);
+	Formats formats(unsigned int pad)
+	{
+		return formats({ pad, 0 });
+	}
 
+	int getFormat(const Stream &stream, V4L2SubdeviceFormat *format,
+		      Whence whence = ActiveFormat);
 	int getFormat(unsigned int pad, V4L2SubdeviceFormat *format,
+		      Whence whence = ActiveFormat)
+	{
+		return getFormat({ pad, 0 }, format, whence);
+	}
+	int setFormat(const Stream &stream, V4L2SubdeviceFormat *format,
 		      Whence whence = ActiveFormat);
 	int setFormat(unsigned int pad, V4L2SubdeviceFormat *format,
-		      Whence whence = ActiveFormat);
+		      Whence whence = ActiveFormat)
+	{
+		return setFormat({ pad, 0 }, format, whence);
+	}
 
 	int getRouting(Routing *routing, Whence whence = ActiveFormat);
 	int setRouting(Routing *routing, Whence whence = ActiveFormat);
@@ -104,8 +172,8 @@ private:
 	std::optional<ColorSpace>
 	toColorSpace(const v4l2_mbus_framefmt &format) const;
 
-	std::vector<unsigned int> enumPadCodes(unsigned int pad);
-	std::vector<SizeRange> enumPadSizes(unsigned int pad,
+	std::vector<unsigned int> enumPadCodes(const Stream &stream);
+	std::vector<SizeRange> enumPadSizes(const Stream &stream,
 					    unsigned int code);
 
 	const MediaEntity *entity_;
@@ -114,4 +182,15 @@ private:
 	struct V4L2SubdeviceCapability caps_;
 };
 
+bool operator==(const V4L2Subdevice::Stream &lhs, const V4L2Subdevice::Stream &rhs);
+static inline bool operator!=(const V4L2Subdevice::Stream &lhs,
+			      const V4L2Subdevice::Stream &rhs)
+{
+	return !(lhs == rhs);
+}
+
+std::ostream &operator<<(std::ostream &out, const V4L2Subdevice::Stream &stream);
+std::ostream &operator<<(std::ostream &out, const V4L2Subdevice::Route &route);
+std::ostream &operator<<(std::ostream &out, const V4L2Subdevice::Routing &routing);
+
 } /* namespace libcamera */
diff -pruN 0.2.0-3/include/libcamera/internal/v4l2_videodevice.h 0.3.0-1/include/libcamera/internal/v4l2_videodevice.h
--- 0.2.0-3/include/libcamera/internal/v4l2_videodevice.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/v4l2_videodevice.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_videodevice.h - V4L2 Video Device
+ * V4L2 Video Device
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/internal/yaml_parser.h 0.3.0-1/include/libcamera/internal/yaml_parser.h
--- 0.2.0-3/include/libcamera/internal/yaml_parser.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/internal/yaml_parser.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * yaml_parser.h - libcamera YAML parsing helper
+ * libcamera YAML parsing helper
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/ipa/ipa_controls.h 0.3.0-1/include/libcamera/ipa/ipa_controls.h
--- 0.2.0-3/include/libcamera/ipa/ipa_controls.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/ipa/ipa_controls.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_controls.h - IPA Control handling
+ * IPA Control handling
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/ipa/ipa_interface.h 0.3.0-1/include/libcamera/ipa/ipa_interface.h
--- 0.2.0-3/include/libcamera/ipa/ipa_interface.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/ipa/ipa_interface.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_interface.h - Image Processing Algorithm interface
+ * Image Processing Algorithm interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/ipa/ipa_module_info.h 0.3.0-1/include/libcamera/ipa/ipa_module_info.h
--- 0.2.0-3/include/libcamera/ipa/ipa_module_info.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/ipa/ipa_module_info.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_module_info.h - Image Processing Algorithm module information
+ * Image Processing Algorithm module information
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/ipa/meson.build 0.3.0-1/include/libcamera/ipa/meson.build
--- 0.2.0-3/include/libcamera/ipa/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/ipa/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -65,6 +65,7 @@ pipeline_ipa_mojom_mapping = {
     'ipu3': 'ipu3.mojom',
     'rkisp1': 'rkisp1.mojom',
     'rpi/vc4': 'raspberrypi.mojom',
+    'simple': 'soft.mojom',
     'vimc': 'vimc.mojom',
 }
 
diff -pruN 0.2.0-3/include/libcamera/ipa/soft.mojom 0.3.0-1/include/libcamera/ipa/soft.mojom
--- 0.2.0-3/include/libcamera/ipa/soft.mojom	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/include/libcamera/ipa/soft.mojom	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,28 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+
+/*
+ * \todo Document the interface and remove the related EXCLUDE_PATTERNS entry.
+ */
+
+module ipa.soft;
+
+import "include/libcamera/ipa/core.mojom";
+
+interface IPASoftInterface {
+	init(libcamera.IPASettings settings,
+	     libcamera.SharedFD fdStats,
+	     libcamera.SharedFD fdParams,
+	     libcamera.ControlInfoMap sensorCtrlInfoMap)
+		=> (int32 ret);
+	start() => (int32 ret);
+	stop();
+	configure(libcamera.ControlInfoMap sensorCtrlInfoMap)
+		=> (int32 ret);
+
+	[async] processStats(libcamera.ControlList sensorControls);
+};
+
+interface IPASoftEventInterface {
+	setSensorControls(libcamera.ControlList sensorControls);
+	setIspParams();
+};
diff -pruN 0.2.0-3/include/libcamera/logging.h 0.3.0-1/include/libcamera/logging.h
--- 0.2.0-3/include/libcamera/logging.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/logging.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * logging.h - Logging infrastructure
+ * Logging infrastructure
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/orientation.h 0.3.0-1/include/libcamera/orientation.h
--- 0.2.0-3/include/libcamera/orientation.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/orientation.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Ideas On Board Oy
  *
- * orientation.h - Image orientation
+ * Image orientation
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/pixel_format.h 0.3.0-1/include/libcamera/pixel_format.h
--- 0.2.0-3/include/libcamera/pixel_format.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/pixel_format.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * pixel_format.h - libcamera Pixel Format
+ * libcamera Pixel Format
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/property_ids.h.in 0.3.0-1/include/libcamera/property_ids.h.in
--- 0.2.0-3/include/libcamera/property_ids.h.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/property_ids.h.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,14 +2,16 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * property_ids.h - Property ID list
+ * Property ID list
  *
  * This file is auto-generated. Do not edit.
  */
 
 #pragma once
 
+#include <map>
 #include <stdint.h>
+#include <string>
 
 #include <libcamera/controls.h>
 
diff -pruN 0.2.0-3/include/libcamera/request.h 0.3.0-1/include/libcamera/request.h
--- 0.2.0-3/include/libcamera/request.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/request.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * request.h - Capture request handling
+ * Capture request handling
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/stream.h 0.3.0-1/include/libcamera/stream.h
--- 0.2.0-3/include/libcamera/stream.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/stream.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * stream.h - Video stream for a Camera
+ * Video stream for a Camera
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/transform.h 0.3.0-1/include/libcamera/transform.h
--- 0.2.0-3/include/libcamera/transform.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/transform.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * transform.h - 2D plane transforms
+ * 2D plane transforms
  */
 
 #pragma once
diff -pruN 0.2.0-3/include/libcamera/version.h.in 0.3.0-1/include/libcamera/version.h.in
--- 0.2.0-3/include/libcamera/version.h.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/libcamera/version.h.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * version.h - Library version information
+ * Library version information
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/include/linux/README 0.3.0-1/include/linux/README
--- 0.2.0-3/include/linux/README	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/README	2024-05-19 15:54:11.000000000 +0000
@@ -1,4 +1,4 @@
 # SPDX-License-Identifier: CC0-1.0
 
-Files in this directory are imported from v5.19 of the Linux kernel. Do not
+Files in this directory are imported from v6.7 of the Linux kernel. Do not
 modify them manually.
diff -pruN 0.2.0-3/include/linux/dma-buf.h 0.3.0-1/include/linux/dma-buf.h
--- 0.2.0-3/include/linux/dma-buf.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/dma-buf.h	2024-05-19 15:54:11.000000000 +0000
@@ -85,6 +85,88 @@ struct dma_buf_sync {
 
 #define DMA_BUF_NAME_LEN	32
 
+/**
+ * struct dma_buf_export_sync_file - Get a sync_file from a dma-buf
+ *
+ * Userspace can perform a DMA_BUF_IOCTL_EXPORT_SYNC_FILE to retrieve the
+ * current set of fences on a dma-buf file descriptor as a sync_file.  CPU
+ * waits via poll() or other driver-specific mechanisms typically wait on
+ * whatever fences are on the dma-buf at the time the wait begins.  This
+ * is similar except that it takes a snapshot of the current fences on the
+ * dma-buf for waiting later instead of waiting immediately.  This is
+ * useful for modern graphics APIs such as Vulkan which assume an explicit
+ * synchronization model but still need to inter-operate with dma-buf.
+ *
+ * The intended usage pattern is the following:
+ *
+ *  1. Export a sync_file with flags corresponding to the expected GPU usage
+ *     via DMA_BUF_IOCTL_EXPORT_SYNC_FILE.
+ *
+ *  2. Submit rendering work which uses the dma-buf.  The work should wait on
+ *     the exported sync file before rendering and produce another sync_file
+ *     when complete.
+ *
+ *  3. Import the rendering-complete sync_file into the dma-buf with flags
+ *     corresponding to the GPU usage via DMA_BUF_IOCTL_IMPORT_SYNC_FILE.
+ *
+ * Unlike doing implicit synchronization via a GPU kernel driver's exec ioctl,
+ * the above is not a single atomic operation.  If userspace wants to ensure
+ * ordering via these fences, it is the respnosibility of userspace to use
+ * locks or other mechanisms to ensure that no other context adds fences or
+ * submits work between steps 1 and 3 above.
+ */
+struct dma_buf_export_sync_file {
+	/**
+	 * @flags: Read/write flags
+	 *
+	 * Must be DMA_BUF_SYNC_READ, DMA_BUF_SYNC_WRITE, or both.
+	 *
+	 * If DMA_BUF_SYNC_READ is set and DMA_BUF_SYNC_WRITE is not set,
+	 * the returned sync file waits on any writers of the dma-buf to
+	 * complete.  Waiting on the returned sync file is equivalent to
+	 * poll() with POLLIN.
+	 *
+	 * If DMA_BUF_SYNC_WRITE is set, the returned sync file waits on
+	 * any users of the dma-buf (read or write) to complete.  Waiting
+	 * on the returned sync file is equivalent to poll() with POLLOUT.
+	 * If both DMA_BUF_SYNC_WRITE and DMA_BUF_SYNC_READ are set, this
+	 * is equivalent to just DMA_BUF_SYNC_WRITE.
+	 */
+	__u32 flags;
+	/** @fd: Returned sync file descriptor */
+	__s32 fd;
+};
+
+/**
+ * struct dma_buf_import_sync_file - Insert a sync_file into a dma-buf
+ *
+ * Userspace can perform a DMA_BUF_IOCTL_IMPORT_SYNC_FILE to insert a
+ * sync_file into a dma-buf for the purposes of implicit synchronization
+ * with other dma-buf consumers.  This allows clients using explicitly
+ * synchronized APIs such as Vulkan to inter-op with dma-buf consumers
+ * which expect implicit synchronization such as OpenGL or most media
+ * drivers/video.
+ */
+struct dma_buf_import_sync_file {
+	/**
+	 * @flags: Read/write flags
+	 *
+	 * Must be DMA_BUF_SYNC_READ, DMA_BUF_SYNC_WRITE, or both.
+	 *
+	 * If DMA_BUF_SYNC_READ is set and DMA_BUF_SYNC_WRITE is not set,
+	 * this inserts the sync_file as a read-only fence.  Any subsequent
+	 * implicitly synchronized writes to this dma-buf will wait on this
+	 * fence but reads will not.
+	 *
+	 * If DMA_BUF_SYNC_WRITE is set, this inserts the sync_file as a
+	 * write fence.  All subsequent implicitly synchronized access to
+	 * this dma-buf will wait on this fence.
+	 */
+	__u32 flags;
+	/** @fd: Sync file descriptor */
+	__s32 fd;
+};
+
 #define DMA_BUF_BASE		'b'
 #define DMA_BUF_IOCTL_SYNC	_IOW(DMA_BUF_BASE, 0, struct dma_buf_sync)
 
@@ -94,5 +176,7 @@ struct dma_buf_sync {
 #define DMA_BUF_SET_NAME	_IOW(DMA_BUF_BASE, 1, const char *)
 #define DMA_BUF_SET_NAME_A	_IOW(DMA_BUF_BASE, 1, __u32)
 #define DMA_BUF_SET_NAME_B	_IOW(DMA_BUF_BASE, 1, __u64)
+#define DMA_BUF_IOCTL_EXPORT_SYNC_FILE	_IOWR(DMA_BUF_BASE, 2, struct dma_buf_export_sync_file)
+#define DMA_BUF_IOCTL_IMPORT_SYNC_FILE	_IOW(DMA_BUF_BASE, 3, struct dma_buf_import_sync_file)
 
 #endif
diff -pruN 0.2.0-3/include/linux/drm_fourcc.h 0.3.0-1/include/linux/drm_fourcc.h
--- 0.2.0-3/include/linux/drm_fourcc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/drm_fourcc.h	2024-05-19 15:54:11.000000000 +0000
@@ -88,6 +88,18 @@ extern "C" {
  *
  * The authoritative list of format modifier codes is found in
  * `include/uapi/drm/drm_fourcc.h`
+ *
+ * Open Source User Waiver
+ * -----------------------
+ *
+ * Because this is the authoritative source for pixel formats and modifiers
+ * referenced by GL, Vulkan extensions and other standards and hence used both
+ * by open source and closed source driver stacks, the usual requirement for an
+ * upstream in-kernel or open source userspace user does not apply.
+ *
+ * To ensure, as much as feasible, compatibility across stacks and avoid
+ * confusion with incompatible enumerations stakeholders for all relevant driver
+ * stacks should approve additions.
  */
 
 #define fourcc_code(a, b, c, d) ((__u32)(a) | ((__u32)(b) << 8) | \
@@ -99,18 +111,42 @@ extern "C" {
 #define DRM_FORMAT_INVALID	0
 
 /* color index */
+#define DRM_FORMAT_C1		fourcc_code('C', '1', ' ', ' ') /* [7:0] C0:C1:C2:C3:C4:C5:C6:C7 1:1:1:1:1:1:1:1 eight pixels/byte */
+#define DRM_FORMAT_C2		fourcc_code('C', '2', ' ', ' ') /* [7:0] C0:C1:C2:C3 2:2:2:2 four pixels/byte */
+#define DRM_FORMAT_C4		fourcc_code('C', '4', ' ', ' ') /* [7:0] C0:C1 4:4 two pixels/byte */
 #define DRM_FORMAT_C8		fourcc_code('C', '8', ' ', ' ') /* [7:0] C */
 
-/* 8 bpp Red */
+/* 1 bpp Darkness (inverse relationship between channel value and brightness) */
+#define DRM_FORMAT_D1		fourcc_code('D', '1', ' ', ' ') /* [7:0] D0:D1:D2:D3:D4:D5:D6:D7 1:1:1:1:1:1:1:1 eight pixels/byte */
+
+/* 2 bpp Darkness (inverse relationship between channel value and brightness) */
+#define DRM_FORMAT_D2		fourcc_code('D', '2', ' ', ' ') /* [7:0] D0:D1:D2:D3 2:2:2:2 four pixels/byte */
+
+/* 4 bpp Darkness (inverse relationship between channel value and brightness) */
+#define DRM_FORMAT_D4		fourcc_code('D', '4', ' ', ' ') /* [7:0] D0:D1 4:4 two pixels/byte */
+
+/* 8 bpp Darkness (inverse relationship between channel value and brightness) */
+#define DRM_FORMAT_D8		fourcc_code('D', '8', ' ', ' ') /* [7:0] D */
+
+/* 1 bpp Red (direct relationship between channel value and brightness) */
+#define DRM_FORMAT_R1		fourcc_code('R', '1', ' ', ' ') /* [7:0] R0:R1:R2:R3:R4:R5:R6:R7 1:1:1:1:1:1:1:1 eight pixels/byte */
+
+/* 2 bpp Red (direct relationship between channel value and brightness) */
+#define DRM_FORMAT_R2		fourcc_code('R', '2', ' ', ' ') /* [7:0] R0:R1:R2:R3 2:2:2:2 four pixels/byte */
+
+/* 4 bpp Red (direct relationship between channel value and brightness) */
+#define DRM_FORMAT_R4		fourcc_code('R', '4', ' ', ' ') /* [7:0] R0:R1 4:4 two pixels/byte */
+
+/* 8 bpp Red (direct relationship between channel value and brightness) */
 #define DRM_FORMAT_R8		fourcc_code('R', '8', ' ', ' ') /* [7:0] R */
 
-/* 10 bpp Red */
+/* 10 bpp Red (direct relationship between channel value and brightness) */
 #define DRM_FORMAT_R10		fourcc_code('R', '1', '0', ' ') /* [15:0] x:R 6:10 little endian */
 
-/* 12 bpp Red */
+/* 12 bpp Red (direct relationship between channel value and brightness) */
 #define DRM_FORMAT_R12		fourcc_code('R', '1', '2', ' ') /* [15:0] x:R 4:12 little endian */
 
-/* 16 bpp Red */
+/* 16 bpp Red (direct relationship between channel value and brightness) */
 #define DRM_FORMAT_R16		fourcc_code('R', '1', '6', ' ') /* [15:0] R little endian */
 
 /* 16 bpp RG */
@@ -174,6 +210,10 @@ extern "C" {
 #define DRM_FORMAT_RGBA1010102	fourcc_code('R', 'A', '3', '0') /* [31:0] R:G:B:A 10:10:10:2 little endian */
 #define DRM_FORMAT_BGRA1010102	fourcc_code('B', 'A', '3', '0') /* [31:0] B:G:R:A 10:10:10:2 little endian */
 
+/* 48 bpp RGB */
+#define DRM_FORMAT_RGB161616 fourcc_code('R', 'G', '4', '8') /* [47:0] R:G:B 16:16:16 little endian */
+#define DRM_FORMAT_BGR161616 fourcc_code('B', 'G', '4', '8') /* [47:0] B:G:R 16:16:16 little endian */
+
 /* 64 bpp RGB */
 #define DRM_FORMAT_XRGB16161616	fourcc_code('X', 'R', '4', '8') /* [63:0] x:R:G:B 16:16:16:16 little endian */
 #define DRM_FORMAT_XBGR16161616	fourcc_code('X', 'B', '4', '8') /* [63:0] x:B:G:R 16:16:16:16 little endian */
@@ -287,6 +327,8 @@ extern "C" {
  * index 1 = Cr:Cb plane, [39:0] Cr1:Cb1:Cr0:Cb0 little endian
  */
 #define DRM_FORMAT_NV15		fourcc_code('N', 'V', '1', '5') /* 2x2 subsampled Cr:Cb plane */
+#define DRM_FORMAT_NV20		fourcc_code('N', 'V', '2', '0') /* 2x1 subsampled Cr:Cb plane */
+#define DRM_FORMAT_NV30		fourcc_code('N', 'V', '3', '0') /* non-subsampled Cr:Cb plane */
 
 /*
  * 2 plane YCbCr MSB aligned
@@ -448,6 +490,7 @@ extern "C" {
 #define DRM_FORMAT_MOD_VENDOR_ALLWINNER 0x09
 #define DRM_FORMAT_MOD_VENDOR_AMLOGIC 0x0a
 #define DRM_FORMAT_MOD_VENDOR_MIPI 0x0b
+#define DRM_FORMAT_MOD_VENDOR_RPI 0x0c
 
 /* add more to the end as needed */
 
@@ -626,7 +669,7 @@ extern "C" {
  *
  * The main surface is Y-tiled and is at plane index 0 whereas CCS is linear
  * and at index 1. The clear color is stored at index 2, and the pitch should
- * be ignored. The clear color structure is 256 bits. The first 128 bits
+ * be 64 bytes aligned. The clear color structure is 256 bits. The first 128 bits
  * represents Raw Clear Color Red, Green, Blue and Alpha color each represented
  * by 32 bits. The raw clear color is consumed by the 3d engine and generates
  * the converted clear color of size 64 bits. The first 32 bits store the Lower
@@ -679,14 +722,57 @@ extern "C" {
  * outside of the GEM object in a reserved memory area dedicated for the
  * storage of the CCS data for all RC/RC_CC/MC compressible GEM objects. The
  * main surface pitch is required to be a multiple of four Tile 4 widths. The
- * clear color is stored at plane index 1 and the pitch should be ignored. The
- * format of the 256 bits of clear color data matches the one used for the
- * I915_FORMAT_MOD_Y_TILED_GEN12_RC_CCS_CC modifier, see its description
+ * clear color is stored at plane index 1 and the pitch should be 64 bytes
+ * aligned. The format of the 256 bits of clear color data matches the one used
+ * for the I915_FORMAT_MOD_Y_TILED_GEN12_RC_CCS_CC modifier, see its description
  * for details.
  */
 #define I915_FORMAT_MOD_4_TILED_DG2_RC_CCS_CC fourcc_mod_code(INTEL, 12)
 
 /*
+ * Intel Color Control Surfaces (CCS) for display ver. 14 render compression.
+ *
+ * The main surface is tile4 and at plane index 0, the CCS is linear and
+ * at index 1. A 64B CCS cache line corresponds to an area of 4x1 tiles in
+ * main surface. In other words, 4 bits in CCS map to a main surface cache
+ * line pair. The main surface pitch is required to be a multiple of four
+ * tile4 widths.
+ */
+#define I915_FORMAT_MOD_4_TILED_MTL_RC_CCS fourcc_mod_code(INTEL, 13)
+
+/*
+ * Intel Color Control Surfaces (CCS) for display ver. 14 media compression
+ *
+ * The main surface is tile4 and at plane index 0, the CCS is linear and
+ * at index 1. A 64B CCS cache line corresponds to an area of 4x1 tiles in
+ * main surface. In other words, 4 bits in CCS map to a main surface cache
+ * line pair. The main surface pitch is required to be a multiple of four
+ * tile4 widths. For semi-planar formats like NV12, CCS planes follow the
+ * Y and UV planes i.e., planes 0 and 1 are used for Y and UV surfaces,
+ * planes 2 and 3 for the respective CCS.
+ */
+#define I915_FORMAT_MOD_4_TILED_MTL_MC_CCS fourcc_mod_code(INTEL, 14)
+
+/*
+ * Intel Color Control Surface with Clear Color (CCS) for display ver. 14 render
+ * compression.
+ *
+ * The main surface is tile4 and is at plane index 0 whereas CCS is linear
+ * and at index 1. The clear color is stored at index 2, and the pitch should
+ * be ignored. The clear color structure is 256 bits. The first 128 bits
+ * represents Raw Clear Color Red, Green, Blue and Alpha color each represented
+ * by 32 bits. The raw clear color is consumed by the 3d engine and generates
+ * the converted clear color of size 64 bits. The first 32 bits store the Lower
+ * Converted Clear Color value and the next 32 bits store the Higher Converted
+ * Clear Color value when applicable. The Converted Clear Color values are
+ * consumed by the DE. The last 64 bits are used to store Color Discard Enable
+ * and Depth Clear Value Valid which are ignored by the DE. A CCS cache line
+ * corresponds to an area of 4x1 tiles in the main surface. The main surface
+ * pitch is required to be a multiple of 4 tile widths.
+ */
+#define I915_FORMAT_MOD_4_TILED_MTL_RC_CCS_CC fourcc_mod_code(INTEL, 15)
+
+/*
  * IPU3 Bayer packing layout
  *
  * The IPU3 raw Bayer formats use a custom packing layout where there are no
@@ -795,6 +881,35 @@ extern "C" {
  */
 #define DRM_FORMAT_MOD_VIVANTE_SPLIT_SUPER_TILED fourcc_mod_code(VIVANTE, 4)
 
+/*
+ * Vivante TS (tile-status) buffer modifiers. They can be combined with all of
+ * the color buffer tiling modifiers defined above. When TS is present it's a
+ * separate buffer containing the clear/compression status of each tile. The
+ * modifiers are defined as VIVANTE_MOD_TS_c_s, where c is the color buffer
+ * tile size in bytes covered by one entry in the status buffer and s is the
+ * number of status bits per entry.
+ * We reserve the top 8 bits of the Vivante modifier space for tile status
+ * clear/compression modifiers, as future cores might add some more TS layout
+ * variations.
+ */
+#define VIVANTE_MOD_TS_64_4               (1ULL << 48)
+#define VIVANTE_MOD_TS_64_2               (2ULL << 48)
+#define VIVANTE_MOD_TS_128_4              (3ULL << 48)
+#define VIVANTE_MOD_TS_256_4              (4ULL << 48)
+#define VIVANTE_MOD_TS_MASK               (0xfULL << 48)
+
+/*
+ * Vivante compression modifiers. Those depend on a TS modifier being present
+ * as the TS bits get reinterpreted as compression tags instead of simple
+ * clear markers when compression is enabled.
+ */
+#define VIVANTE_MOD_COMP_DEC400           (1ULL << 52)
+#define VIVANTE_MOD_COMP_MASK             (0xfULL << 52)
+
+/* Masking out the extension bits will yield the base modifier. */
+#define VIVANTE_MOD_EXT_MASK              (VIVANTE_MOD_TS_MASK | \
+                                           VIVANTE_MOD_COMP_MASK)
+
 /* NVIDIA frame buffer modifiers */
 
 /*
@@ -1440,6 +1555,7 @@ drm_fourcc_canonicalize_nvidia_format_mo
 #define AMD_FMT_MOD_TILE_VER_GFX9 1
 #define AMD_FMT_MOD_TILE_VER_GFX10 2
 #define AMD_FMT_MOD_TILE_VER_GFX10_RBPLUS 3
+#define AMD_FMT_MOD_TILE_VER_GFX11 4
 
 /*
  * 64K_S is the same for GFX9/GFX10/GFX10_RBPLUS and hence has GFX9 as canonical
@@ -1455,6 +1571,7 @@ drm_fourcc_canonicalize_nvidia_format_mo
 #define AMD_FMT_MOD_TILE_GFX9_64K_S_X 25
 #define AMD_FMT_MOD_TILE_GFX9_64K_D_X 26
 #define AMD_FMT_MOD_TILE_GFX9_64K_R_X 27
+#define AMD_FMT_MOD_TILE_GFX11_256K_R_X 31
 
 #define AMD_FMT_MOD_DCC_BLOCK_64B 0
 #define AMD_FMT_MOD_DCC_BLOCK_128B 1
@@ -1554,6 +1671,9 @@ drm_fourcc_canonicalize_nvidia_format_mo
  */
 #define MIPI_FORMAT_MOD_CSI2_PACKED fourcc_mod_code(MIPI, 1)
 
+#define PISP_FORMAT_MOD_COMPRESS_MODE1 fourcc_mod_code(RPI, 1)
+#define PISP_FORMAT_MOD_COMPRESS_MODE2 fourcc_mod_code(RPI, 2)
+
 #if defined(__cplusplus)
 }
 #endif
diff -pruN 0.2.0-3/include/linux/intel-ipu3.h 0.3.0-1/include/linux/intel-ipu3.h
--- 0.2.0-3/include/linux/intel-ipu3.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/intel-ipu3.h	2024-05-19 15:54:11.000000000 +0000
@@ -626,8 +626,11 @@ struct ipu3_uapi_stats_3a {
  * @b:	white balance gain for B channel.
  * @gb:	white balance gain for Gb channel.
  *
- * Precision u3.13, range [0, 8). White balance correction is done by applying
- * a multiplicative gain to each color channels prior to BNR.
+ * For BNR parameters WB gain factor for the three channels [Ggr, Ggb, Gb, Gr].
+ * Their precision is U3.13 and the range is (0, 8) and the actual gain is
+ * Gx + 1, it is typically Gx = 1.
+ *
+ * Pout = {Pin * (1 + Gx)}.
  */
 struct ipu3_uapi_bnr_static_config_wb_gains_config {
 	__u16 gr;
diff -pruN 0.2.0-3/include/linux/media-bus-format.h 0.3.0-1/include/linux/media-bus-format.h
--- 0.2.0-3/include/linux/media-bus-format.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/media-bus-format.h	2024-05-19 15:54:11.000000000 +0000
@@ -34,7 +34,7 @@
 
 #define MEDIA_BUS_FMT_FIXED			0x0001
 
-/* RGB - next is	0x101e */
+/* RGB - next is	0x1026 */
 #define MEDIA_BUS_FMT_RGB444_1X12		0x1016
 #define MEDIA_BUS_FMT_RGB444_2X8_PADHI_BE	0x1001
 #define MEDIA_BUS_FMT_RGB444_2X8_PADHI_LE	0x1002
@@ -46,8 +46,12 @@
 #define MEDIA_BUS_FMT_RGB565_2X8_BE		0x1007
 #define MEDIA_BUS_FMT_RGB565_2X8_LE		0x1008
 #define MEDIA_BUS_FMT_RGB666_1X18		0x1009
+#define MEDIA_BUS_FMT_RGB666_2X9_BE		0x1025
+#define MEDIA_BUS_FMT_BGR666_1X18		0x1023
 #define MEDIA_BUS_FMT_RBG888_1X24		0x100e
 #define MEDIA_BUS_FMT_RGB666_1X24_CPADHI	0x1015
+#define MEDIA_BUS_FMT_BGR666_1X24_CPADHI	0x1024
+#define MEDIA_BUS_FMT_RGB565_1X24_CPADHI	0x1022
 #define MEDIA_BUS_FMT_RGB666_1X7X3_SPWG		0x1010
 #define MEDIA_BUS_FMT_BGR888_1X24		0x1013
 #define MEDIA_BUS_FMT_BGR888_3X8		0x101b
@@ -59,13 +63,17 @@
 #define MEDIA_BUS_FMT_RGB888_3X8_DELTA		0x101d
 #define MEDIA_BUS_FMT_RGB888_1X7X4_SPWG		0x1011
 #define MEDIA_BUS_FMT_RGB888_1X7X4_JEIDA	0x1012
+#define MEDIA_BUS_FMT_RGB666_1X30_CPADLO	0x101e
+#define MEDIA_BUS_FMT_RGB888_1X30_CPADLO	0x101f
 #define MEDIA_BUS_FMT_ARGB8888_1X32		0x100d
 #define MEDIA_BUS_FMT_RGB888_1X32_PADHI		0x100f
 #define MEDIA_BUS_FMT_RGB101010_1X30		0x1018
+#define MEDIA_BUS_FMT_RGB666_1X36_CPADLO	0x1020
+#define MEDIA_BUS_FMT_RGB888_1X36_CPADLO	0x1021
 #define MEDIA_BUS_FMT_RGB121212_1X36		0x1019
 #define MEDIA_BUS_FMT_RGB161616_1X48		0x101a
 
-/* YUV (including grey) - next is	0x202e */
+/* YUV (including grey) - next is	0x202f */
 #define MEDIA_BUS_FMT_Y8_1X8			0x2001
 #define MEDIA_BUS_FMT_UV8_1X8			0x2015
 #define MEDIA_BUS_FMT_UYVY8_1_5X8		0x2002
@@ -88,6 +96,7 @@
 #define MEDIA_BUS_FMT_YUYV12_2X12		0x201e
 #define MEDIA_BUS_FMT_YVYU12_2X12		0x201f
 #define MEDIA_BUS_FMT_Y14_1X14			0x202d
+#define MEDIA_BUS_FMT_Y16_1X16			0x202e
 #define MEDIA_BUS_FMT_UYVY8_1X16		0x200f
 #define MEDIA_BUS_FMT_VYUY8_1X16		0x2010
 #define MEDIA_BUS_FMT_YUYV8_1X16		0x2011
diff -pruN 0.2.0-3/include/linux/media.h 0.3.0-1/include/linux/media.h
--- 0.2.0-3/include/linux/media.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/media.h	2024-05-19 15:54:11.000000000 +0000
@@ -20,7 +20,6 @@
 #ifndef __LINUX_MEDIA_H
 #define __LINUX_MEDIA_H
 
-#include <stdint.h>
 #include <linux/ioctl.h>
 #include <linux/types.h>
 
@@ -141,8 +140,8 @@ struct media_device_info {
 #define MEDIA_ENT_F_DV_ENCODER			(MEDIA_ENT_F_BASE + 0x6002)
 
 /* Entity flags */
-#define MEDIA_ENT_FL_DEFAULT			(1 << 0)
-#define MEDIA_ENT_FL_CONNECTOR			(1 << 1)
+#define MEDIA_ENT_FL_DEFAULT			(1U << 0)
+#define MEDIA_ENT_FL_CONNECTOR			(1U << 1)
 
 /* OR with the entity id value to find the next entity */
 #define MEDIA_ENT_ID_FLAG_NEXT			(1U << 31)
@@ -204,9 +203,9 @@ struct media_entity_desc {
 	};
 };
 
-#define MEDIA_PAD_FL_SINK			(1 << 0)
-#define MEDIA_PAD_FL_SOURCE			(1 << 1)
-#define MEDIA_PAD_FL_MUST_CONNECT		(1 << 2)
+#define MEDIA_PAD_FL_SINK			(1U << 0)
+#define MEDIA_PAD_FL_SOURCE			(1U << 1)
+#define MEDIA_PAD_FL_MUST_CONNECT		(1U << 2)
 
 struct media_pad_desc {
 	__u32 entity;		/* entity ID */
@@ -215,14 +214,14 @@ struct media_pad_desc {
 	__u32 reserved[2];
 };
 
-#define MEDIA_LNK_FL_ENABLED			(1 << 0)
-#define MEDIA_LNK_FL_IMMUTABLE			(1 << 1)
-#define MEDIA_LNK_FL_DYNAMIC			(1 << 2)
+#define MEDIA_LNK_FL_ENABLED			(1U << 0)
+#define MEDIA_LNK_FL_IMMUTABLE			(1U << 1)
+#define MEDIA_LNK_FL_DYNAMIC			(1U << 2)
 
 #define MEDIA_LNK_FL_LINK_TYPE			(0xf << 28)
-#  define MEDIA_LNK_FL_DATA_LINK		(0 << 28)
-#  define MEDIA_LNK_FL_INTERFACE_LINK		(1 << 28)
-#  define MEDIA_LNK_FL_ANCILLARY_LINK		(2 << 28)
+#  define MEDIA_LNK_FL_DATA_LINK		(0U << 28)
+#  define MEDIA_LNK_FL_INTERFACE_LINK		(1U << 28)
+#  define MEDIA_LNK_FL_ANCILLARY_LINK		(2U << 28)
 
 struct media_link_desc {
 	struct media_pad_desc source;
@@ -277,7 +276,7 @@ struct media_links_enum {
  * struct media_device_info.
  */
 #define MEDIA_V2_ENTITY_HAS_FLAGS(media_version) \
-	((media_version) >= ((4 << 16) | (19 << 8) | 0))
+	((media_version) >= ((4U << 16) | (19U << 8) | 0U))
 
 struct media_v2_entity {
 	__u32 id;
@@ -312,7 +311,7 @@ struct media_v2_interface {
  * struct media_device_info.
  */
 #define MEDIA_V2_PAD_HAS_INDEX(media_version) \
-	((media_version) >= ((4 << 16) | (19 << 8) | 0))
+	((media_version) >= ((4U << 16) | (19U << 8) | 0U))
 
 struct media_v2_pad {
 	__u32 id;
@@ -415,7 +414,7 @@ struct media_v2_topology {
 #define MEDIA_INTF_T_ALSA_TIMER                (MEDIA_INTF_T_ALSA_BASE + 7)
 
 /* Obsolete symbol for media_version, no longer used in the kernel */
-#define MEDIA_API_VERSION			((0 << 16) | (1 << 8) | 0)
+#define MEDIA_API_VERSION			((0U << 16) | (1U << 8) | 0U)
 
 
 #endif /* __LINUX_MEDIA_H */
diff -pruN 0.2.0-3/include/linux/rkisp1-config.h 0.3.0-1/include/linux/rkisp1-config.h
--- 0.2.0-3/include/linux/rkisp1-config.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/rkisp1-config.h	2024-05-19 15:54:11.000000000 +0000
@@ -4,8 +4,8 @@
  * Copyright (C) 2017 Rockchip Electronics Co., Ltd.
  */
 
-#ifndef _RKISP1_CONFIG_H
-#define _RKISP1_CONFIG_H
+#ifndef _UAPI_RKISP1_CONFIG_H
+#define _UAPI_RKISP1_CONFIG_H
 
 #include <linux/types.h>
 
@@ -179,12 +179,14 @@
  * @RKISP1_V11: declared in the original vendor code, but not used
  * @RKISP1_V12: used at least in rk3326 and px30
  * @RKISP1_V13: used at least in rk1808
+ * @RKISP1_V_IMX8MP: used in at least imx8mp
  */
 enum rkisp1_cif_isp_version {
 	RKISP1_V10 = 10,
 	RKISP1_V11,
 	RKISP1_V12,
 	RKISP1_V13,
+	RKISP1_V_IMX8MP,
 };
 
 enum rkisp1_cif_isp_histogram_mode {
@@ -992,4 +994,4 @@ struct rkisp1_stat_buffer {
 	struct rkisp1_cif_isp_stat params;
 };
 
-#endif /* _RKISP1_CONFIG_H */
+#endif /* _UAPI_RKISP1_CONFIG_H */
diff -pruN 0.2.0-3/include/linux/v4l2-common.h 0.3.0-1/include/linux/v4l2-common.h
--- 0.2.0-3/include/linux/v4l2-common.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/v4l2-common.h	2024-05-19 15:54:11.000000000 +0000
@@ -10,45 +10,6 @@
  *
  * Copyright (C) 2012 Nokia Corporation
  * Contact: Sakari Ailus <sakari.ailus@iki.fi>
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  Alternatively you can redistribute this file under the terms of the
- *  BSD license as stated below:
- *
- *  Redistribution and use in source and binary forms, with or without
- *  modification, are permitted provided that the following conditions
- *  are met:
- *  1. Redistributions of source code must retain the above copyright
- *     notice, this list of conditions and the following disclaimer.
- *  2. Redistributions in binary form must reproduce the above copyright
- *     notice, this list of conditions and the following disclaimer in
- *     the documentation and/or other materials provided with the
- *     distribution.
- *  3. The names of its contributors may not be used to endorse or promote
- *     products derived from this software without specific prior written
- *     permission.
- *
- *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
- *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
- *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
- *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
- *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
- *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
- *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
  */
 
 #ifndef __V4L2_COMMON__
diff -pruN 0.2.0-3/include/linux/v4l2-controls.h 0.3.0-1/include/linux/v4l2-controls.h
--- 0.2.0-3/include/linux/v4l2-controls.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/v4l2-controls.h	2024-05-19 15:54:11.000000000 +0000
@@ -4,44 +4,6 @@
  *
  *  Copyright (C) 1999-2012 the contributors
  *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  Alternatively you can redistribute this file under the terms of the
- *  BSD license as stated below:
- *
- *  Redistribution and use in source and binary forms, with or without
- *  modification, are permitted provided that the following conditions
- *  are met:
- *  1. Redistributions of source code must retain the above copyright
- *     notice, this list of conditions and the following disclaimer.
- *  2. Redistributions in binary form must reproduce the above copyright
- *     notice, this list of conditions and the following disclaimer in
- *     the documentation and/or other materials provided with the
- *     distribution.
- *  3. The names of its contributors may not be used to endorse or promote
- *     products derived from this software without specific prior written
- *     permission.
- *
- *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
- *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
- *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
- *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
- *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
- *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
- *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
  *  The contents of this header was split off from videodev2.h. All control
  *  definitions should be added to this header, which is included by
  *  videodev2.h.
@@ -153,8 +115,10 @@ enum v4l2_colorfx {
 
 /* USER-class private control IDs */
 
-/* The base for the meye driver controls. See linux/meye.h for the list
- * of controls. We reserve 16 controls for this driver. */
+/*
+ * The base for the meye driver controls. This driver was removed, but
+ * we keep this define in case any software still uses it.
+ */
 #define V4L2_CID_USER_MEYE_BASE			(V4L2_CID_USER_BASE + 0x1000)
 
 /* The base for the bttv driver controls.
@@ -229,6 +193,24 @@ enum v4l2_colorfx {
  */
 #define V4L2_CID_USER_ISL7998X_BASE		(V4L2_CID_USER_BASE + 0x1180)
 
+/*
+ * The base for DW100 driver controls.
+ * We reserve 16 controls for this driver.
+ */
+#define V4L2_CID_USER_DW100_BASE		(V4L2_CID_USER_BASE + 0x1190)
+
+/*
+ * The base for Aspeed driver controls.
+ * We reserve 16 controls for this driver.
+ */
+#define V4L2_CID_USER_ASPEED_BASE		(V4L2_CID_USER_BASE + 0x11a0)
+
+/*
+ * The base for Nuvoton NPCM driver controls.
+ * We reserve 16 controls for this driver.
+ */
+#define V4L2_CID_USER_NPCM_BASE			(V4L2_CID_USER_BASE + 0x11b0)
+
 /* MPEG-class control IDs */
 /* The MPEG controls are applicable to all codec controls
  * and the 'MPEG' part of the define is historical */
@@ -828,6 +810,88 @@ enum v4l2_mpeg_video_frame_skip_mode {
 #define V4L2_CID_MPEG_VIDEO_DEC_DISPLAY_DELAY		(V4L2_CID_CODEC_BASE + 653)
 #define V4L2_CID_MPEG_VIDEO_DEC_DISPLAY_DELAY_ENABLE	(V4L2_CID_CODEC_BASE + 654)
 
+#define V4L2_CID_MPEG_VIDEO_AV1_PROFILE (V4L2_CID_CODEC_BASE + 655)
+/**
+ * enum v4l2_mpeg_video_av1_profile - AV1 profiles
+ *
+ * @V4L2_MPEG_VIDEO_AV1_PROFILE_MAIN: compliant decoders must be able to decode
+ * streams with seq_profile equal to 0.
+ * @V4L2_MPEG_VIDEO_AV1_PROFILE_HIGH: compliant decoders must be able to decode
+ * streams with seq_profile equal less than or equal to 1.
+ * @V4L2_MPEG_VIDEO_AV1_PROFILE_PROFESSIONAL: compliant decoders must be able to
+ * decode streams with seq_profile less than or equal to 2.
+ *
+ * Conveys the highest profile a decoder can work with.
+ */
+enum v4l2_mpeg_video_av1_profile {
+	V4L2_MPEG_VIDEO_AV1_PROFILE_MAIN = 0,
+	V4L2_MPEG_VIDEO_AV1_PROFILE_HIGH = 1,
+	V4L2_MPEG_VIDEO_AV1_PROFILE_PROFESSIONAL = 2,
+};
+
+#define V4L2_CID_MPEG_VIDEO_AV1_LEVEL (V4L2_CID_CODEC_BASE + 656)
+/**
+ * enum v4l2_mpeg_video_av1_level - AV1 levels
+ *
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_2_0: Level 2.0.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_2_1: Level 2.1.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_2_2: Level 2.2.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_2_3: Level 2.3.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_3_0: Level 3.0.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_3_1: Level 3.1.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_3_2: Level 3.2.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_3_3: Level 3.3.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_4_0: Level 4.0.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_4_1: Level 4.1.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_4_2: Level 4.2.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_4_3: Level 4.3.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_5_0: Level 5.0.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_5_1: Level 5.1.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_5_2: Level 5.2.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_5_3: Level 5.3.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_6_0: Level 6.0.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_6_1: Level 6.1.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_6_2: Level 6.2.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_6_3: Level 6.3.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_7_0: Level 7.0.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_7_1: Level 7.1.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_7_2: Level 7.2.
+ * @V4L2_MPEG_VIDEO_AV1_LEVEL_7_3: Level 7.3.
+ *
+ * Conveys the highest level a decoder can work with.
+ */
+enum v4l2_mpeg_video_av1_level {
+	V4L2_MPEG_VIDEO_AV1_LEVEL_2_0 = 0,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_2_1 = 1,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_2_2 = 2,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_2_3 = 3,
+
+	V4L2_MPEG_VIDEO_AV1_LEVEL_3_0 = 4,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_3_1 = 5,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_3_2 = 6,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_3_3 = 7,
+
+	V4L2_MPEG_VIDEO_AV1_LEVEL_4_0 = 8,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_4_1 = 9,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_4_2 = 10,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_4_3 = 11,
+
+	V4L2_MPEG_VIDEO_AV1_LEVEL_5_0 = 12,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_5_1 = 13,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_5_2 = 14,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_5_3 = 15,
+
+	V4L2_MPEG_VIDEO_AV1_LEVEL_6_0 = 16,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_6_1 = 17,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_6_2 = 18,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_6_3 = 19,
+
+	V4L2_MPEG_VIDEO_AV1_LEVEL_7_0 = 20,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_7_1 = 21,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_7_2 = 22,
+	V4L2_MPEG_VIDEO_AV1_LEVEL_7_3 = 23
+};
+
 /*  MPEG-class control IDs specific to the CX2341x driver as defined by V4L2 */
 #define V4L2_CID_CODEC_CX2341X_BASE				(V4L2_CTRL_CLASS_CODEC | 0x1000)
 #define V4L2_CID_MPEG_CX2341X_VIDEO_SPATIAL_FILTER_MODE		(V4L2_CID_CODEC_CX2341X_BASE+0)
@@ -1015,6 +1079,8 @@ enum v4l2_auto_focus_range {
 
 #define V4L2_CID_CAMERA_SENSOR_ROTATION		(V4L2_CID_CAMERA_CLASS_BASE+35)
 
+#define V4L2_CID_HDR_SENSOR_MODE		(V4L2_CID_CAMERA_CLASS_BASE+36)
+
 /* FM Modulator class control IDs */
 
 #define V4L2_CID_FM_TX_CLASS_BASE		(V4L2_CTRL_CLASS_FM_TX | 0x900)
@@ -1732,7 +1798,7 @@ struct v4l2_vp8_segment {
  * @sharpness_level: matches sharpness_level syntax element.
  * @level: matches loop_filter_level syntax element.
  * @padding: padding field. Should be zeroed by applications.
- * @flags: see V4L2_VP8_LF_FLAG_{}.
+ * @flags: see V4L2_VP8_LF_{}.
  *
  * This structure contains loop filter related parameters.
  * See the 'mb_lf_adjustments()' part of the frame header syntax,
@@ -1999,6 +2065,469 @@ struct v4l2_ctrl_mpeg2_quantisation {
 	__u8	chroma_non_intra_quantiser_matrix[64];
 };
 
+#define V4L2_CID_STATELESS_HEVC_SPS		(V4L2_CID_CODEC_STATELESS_BASE + 400)
+#define V4L2_CID_STATELESS_HEVC_PPS		(V4L2_CID_CODEC_STATELESS_BASE + 401)
+#define V4L2_CID_STATELESS_HEVC_SLICE_PARAMS	(V4L2_CID_CODEC_STATELESS_BASE + 402)
+#define V4L2_CID_STATELESS_HEVC_SCALING_MATRIX	(V4L2_CID_CODEC_STATELESS_BASE + 403)
+#define V4L2_CID_STATELESS_HEVC_DECODE_PARAMS	(V4L2_CID_CODEC_STATELESS_BASE + 404)
+#define V4L2_CID_STATELESS_HEVC_DECODE_MODE	(V4L2_CID_CODEC_STATELESS_BASE + 405)
+#define V4L2_CID_STATELESS_HEVC_START_CODE	(V4L2_CID_CODEC_STATELESS_BASE + 406)
+#define V4L2_CID_STATELESS_HEVC_ENTRY_POINT_OFFSETS (V4L2_CID_CODEC_STATELESS_BASE + 407)
+
+enum v4l2_stateless_hevc_decode_mode {
+	V4L2_STATELESS_HEVC_DECODE_MODE_SLICE_BASED,
+	V4L2_STATELESS_HEVC_DECODE_MODE_FRAME_BASED,
+};
+
+enum v4l2_stateless_hevc_start_code {
+	V4L2_STATELESS_HEVC_START_CODE_NONE,
+	V4L2_STATELESS_HEVC_START_CODE_ANNEX_B,
+};
+
+#define V4L2_HEVC_SLICE_TYPE_B	0
+#define V4L2_HEVC_SLICE_TYPE_P	1
+#define V4L2_HEVC_SLICE_TYPE_I	2
+
+#define V4L2_HEVC_SPS_FLAG_SEPARATE_COLOUR_PLANE		(1ULL << 0)
+#define V4L2_HEVC_SPS_FLAG_SCALING_LIST_ENABLED			(1ULL << 1)
+#define V4L2_HEVC_SPS_FLAG_AMP_ENABLED				(1ULL << 2)
+#define V4L2_HEVC_SPS_FLAG_SAMPLE_ADAPTIVE_OFFSET		(1ULL << 3)
+#define V4L2_HEVC_SPS_FLAG_PCM_ENABLED				(1ULL << 4)
+#define V4L2_HEVC_SPS_FLAG_PCM_LOOP_FILTER_DISABLED		(1ULL << 5)
+#define V4L2_HEVC_SPS_FLAG_LONG_TERM_REF_PICS_PRESENT		(1ULL << 6)
+#define V4L2_HEVC_SPS_FLAG_SPS_TEMPORAL_MVP_ENABLED		(1ULL << 7)
+#define V4L2_HEVC_SPS_FLAG_STRONG_INTRA_SMOOTHING_ENABLED	(1ULL << 8)
+
+/**
+ * struct v4l2_ctrl_hevc_sps - ITU-T Rec. H.265: Sequence parameter set
+ *
+ * @video_parameter_set_id: specifies the value of the
+ *			vps_video_parameter_set_id of the active VPS
+ * @seq_parameter_set_id: provides an identifier for the SPS for
+ *			  reference by other syntax elements
+ * @pic_width_in_luma_samples:	specifies the width of each decoded picture
+ *				in units of luma samples
+ * @pic_height_in_luma_samples: specifies the height of each decoded picture
+ *				in units of luma samples
+ * @bit_depth_luma_minus8: this value plus 8specifies the bit depth of the
+ *                         samples of the luma array
+ * @bit_depth_chroma_minus8: this value plus 8 specifies the bit depth of the
+ *                           samples of the chroma arrays
+ * @log2_max_pic_order_cnt_lsb_minus4: this value plus 4 specifies the value of
+ *                                     the variable MaxPicOrderCntLsb
+ * @sps_max_dec_pic_buffering_minus1: this value plus 1 specifies the maximum
+ *                                    required size of the decoded picture
+ *                                    buffer for the codec video sequence
+ * @sps_max_num_reorder_pics: indicates the maximum allowed number of pictures
+ * @sps_max_latency_increase_plus1: not equal to 0 is used to compute the
+ *				    value of SpsMaxLatencyPictures array
+ * @log2_min_luma_coding_block_size_minus3: plus 3 specifies the minimum
+ *					    luma coding block size
+ * @log2_diff_max_min_luma_coding_block_size: specifies the difference between
+ *					      the maximum and minimum luma
+ *					      coding block size
+ * @log2_min_luma_transform_block_size_minus2: plus 2 specifies the minimum luma
+ *					       transform block size
+ * @log2_diff_max_min_luma_transform_block_size: specifies the difference between
+ *						 the maximum and minimum luma
+ *						 transform block size
+ * @max_transform_hierarchy_depth_inter: specifies the maximum hierarchy
+ *					 depth for transform units of
+ *					 coding units coded in inter
+ *					 prediction mode
+ * @max_transform_hierarchy_depth_intra: specifies the maximum hierarchy
+ *					 depth for transform units of
+ *					 coding units coded in intra
+ *					 prediction mode
+ * @pcm_sample_bit_depth_luma_minus1: this value plus 1 specifies the number of
+ *                                    bits used to represent each of PCM sample
+ *                                    values of the luma component
+ * @pcm_sample_bit_depth_chroma_minus1: this value plus 1 specifies the number
+ *                                      of bits used to represent each of PCM
+ *                                      sample values of the chroma components
+ * @log2_min_pcm_luma_coding_block_size_minus3: this value plus 3 specifies the
+ *                                              minimum size of coding blocks
+ * @log2_diff_max_min_pcm_luma_coding_block_size: specifies the difference between
+ *						  the maximum and minimum size of
+ *						  coding blocks
+ * @num_short_term_ref_pic_sets: specifies the number of st_ref_pic_set()
+ *				 syntax structures included in the SPS
+ * @num_long_term_ref_pics_sps: specifies the number of candidate long-term
+ *				reference pictures that are specified in the SPS
+ * @chroma_format_idc: specifies the chroma sampling
+ * @sps_max_sub_layers_minus1: this value plus 1 specifies the maximum number
+ *                             of temporal sub-layers
+ * @reserved: padding field. Should be zeroed by applications.
+ * @flags: see V4L2_HEVC_SPS_FLAG_{}
+ */
+struct v4l2_ctrl_hevc_sps {
+	__u8	video_parameter_set_id;
+	__u8	seq_parameter_set_id;
+	__u16	pic_width_in_luma_samples;
+	__u16	pic_height_in_luma_samples;
+	__u8	bit_depth_luma_minus8;
+	__u8	bit_depth_chroma_minus8;
+	__u8	log2_max_pic_order_cnt_lsb_minus4;
+	__u8	sps_max_dec_pic_buffering_minus1;
+	__u8	sps_max_num_reorder_pics;
+	__u8	sps_max_latency_increase_plus1;
+	__u8	log2_min_luma_coding_block_size_minus3;
+	__u8	log2_diff_max_min_luma_coding_block_size;
+	__u8	log2_min_luma_transform_block_size_minus2;
+	__u8	log2_diff_max_min_luma_transform_block_size;
+	__u8	max_transform_hierarchy_depth_inter;
+	__u8	max_transform_hierarchy_depth_intra;
+	__u8	pcm_sample_bit_depth_luma_minus1;
+	__u8	pcm_sample_bit_depth_chroma_minus1;
+	__u8	log2_min_pcm_luma_coding_block_size_minus3;
+	__u8	log2_diff_max_min_pcm_luma_coding_block_size;
+	__u8	num_short_term_ref_pic_sets;
+	__u8	num_long_term_ref_pics_sps;
+	__u8	chroma_format_idc;
+	__u8	sps_max_sub_layers_minus1;
+
+	__u8	reserved[6];
+	__u64	flags;
+};
+
+#define V4L2_HEVC_PPS_FLAG_DEPENDENT_SLICE_SEGMENT_ENABLED	(1ULL << 0)
+#define V4L2_HEVC_PPS_FLAG_OUTPUT_FLAG_PRESENT			(1ULL << 1)
+#define V4L2_HEVC_PPS_FLAG_SIGN_DATA_HIDING_ENABLED		(1ULL << 2)
+#define V4L2_HEVC_PPS_FLAG_CABAC_INIT_PRESENT			(1ULL << 3)
+#define V4L2_HEVC_PPS_FLAG_CONSTRAINED_INTRA_PRED		(1ULL << 4)
+#define V4L2_HEVC_PPS_FLAG_TRANSFORM_SKIP_ENABLED		(1ULL << 5)
+#define V4L2_HEVC_PPS_FLAG_CU_QP_DELTA_ENABLED			(1ULL << 6)
+#define V4L2_HEVC_PPS_FLAG_PPS_SLICE_CHROMA_QP_OFFSETS_PRESENT	(1ULL << 7)
+#define V4L2_HEVC_PPS_FLAG_WEIGHTED_PRED			(1ULL << 8)
+#define V4L2_HEVC_PPS_FLAG_WEIGHTED_BIPRED			(1ULL << 9)
+#define V4L2_HEVC_PPS_FLAG_TRANSQUANT_BYPASS_ENABLED		(1ULL << 10)
+#define V4L2_HEVC_PPS_FLAG_TILES_ENABLED			(1ULL << 11)
+#define V4L2_HEVC_PPS_FLAG_ENTROPY_CODING_SYNC_ENABLED		(1ULL << 12)
+#define V4L2_HEVC_PPS_FLAG_LOOP_FILTER_ACROSS_TILES_ENABLED	(1ULL << 13)
+#define V4L2_HEVC_PPS_FLAG_PPS_LOOP_FILTER_ACROSS_SLICES_ENABLED (1ULL << 14)
+#define V4L2_HEVC_PPS_FLAG_DEBLOCKING_FILTER_OVERRIDE_ENABLED	(1ULL << 15)
+#define V4L2_HEVC_PPS_FLAG_PPS_DISABLE_DEBLOCKING_FILTER	(1ULL << 16)
+#define V4L2_HEVC_PPS_FLAG_LISTS_MODIFICATION_PRESENT		(1ULL << 17)
+#define V4L2_HEVC_PPS_FLAG_SLICE_SEGMENT_HEADER_EXTENSION_PRESENT (1ULL << 18)
+#define V4L2_HEVC_PPS_FLAG_DEBLOCKING_FILTER_CONTROL_PRESENT	(1ULL << 19)
+#define V4L2_HEVC_PPS_FLAG_UNIFORM_SPACING			(1ULL << 20)
+
+/**
+ * struct v4l2_ctrl_hevc_pps - ITU-T Rec. H.265: Picture parameter set
+ *
+ * @pic_parameter_set_id: identifies the PPS for reference by other
+ *			  syntax elements
+ * @num_extra_slice_header_bits: specifies the number of extra slice header
+ *				 bits that are present in the slice header RBSP
+ *				 for coded pictures referring to the PPS.
+ * @num_ref_idx_l0_default_active_minus1: this value plus 1 specifies the
+ *                                        inferred value of num_ref_idx_l0_active_minus1
+ * @num_ref_idx_l1_default_active_minus1: this value plus 1 specifies the
+ *                                        inferred value of num_ref_idx_l1_active_minus1
+ * @init_qp_minus26: this value plus 26 specifies the initial value of SliceQp Y for
+ *		     each slice referring to the PPS
+ * @diff_cu_qp_delta_depth: specifies the difference between the luma coding
+ *			    tree block size and the minimum luma coding block
+ *			    size of coding units that convey cu_qp_delta_abs
+ *			    and cu_qp_delta_sign_flag
+ * @pps_cb_qp_offset: specify the offsets to the luma quantization parameter Cb
+ * @pps_cr_qp_offset: specify the offsets to the luma quantization parameter Cr
+ * @num_tile_columns_minus1: this value plus 1 specifies the number of tile columns
+ *			     partitioning the picture
+ * @num_tile_rows_minus1: this value plus 1 specifies the number of tile rows partitioning
+ *			  the picture
+ * @column_width_minus1: this value plus 1 specifies the width of the each tile column in
+ *			 units of coding tree blocks
+ * @row_height_minus1: this value plus 1 specifies the height of the each tile row in
+ *		       units of coding tree blocks
+ * @pps_beta_offset_div2: specify the default deblocking parameter offsets for
+ *			  beta divided by 2
+ * @pps_tc_offset_div2: specify the default deblocking parameter offsets for tC
+ *			divided by 2
+ * @log2_parallel_merge_level_minus2: this value plus 2 specifies the value of
+ *                                    the variable Log2ParMrgLevel
+ * @reserved: padding field. Should be zeroed by applications.
+ * @flags: see V4L2_HEVC_PPS_FLAG_{}
+ */
+struct v4l2_ctrl_hevc_pps {
+	__u8	pic_parameter_set_id;
+	__u8	num_extra_slice_header_bits;
+	__u8	num_ref_idx_l0_default_active_minus1;
+	__u8	num_ref_idx_l1_default_active_minus1;
+	__s8	init_qp_minus26;
+	__u8	diff_cu_qp_delta_depth;
+	__s8	pps_cb_qp_offset;
+	__s8	pps_cr_qp_offset;
+	__u8	num_tile_columns_minus1;
+	__u8	num_tile_rows_minus1;
+	__u8	column_width_minus1[20];
+	__u8	row_height_minus1[22];
+	__s8	pps_beta_offset_div2;
+	__s8	pps_tc_offset_div2;
+	__u8	log2_parallel_merge_level_minus2;
+	__u8	reserved;
+	__u64	flags;
+};
+
+#define V4L2_HEVC_DPB_ENTRY_LONG_TERM_REFERENCE	0x01
+
+#define V4L2_HEVC_SEI_PIC_STRUCT_FRAME				0
+#define V4L2_HEVC_SEI_PIC_STRUCT_TOP_FIELD			1
+#define V4L2_HEVC_SEI_PIC_STRUCT_BOTTOM_FIELD			2
+#define V4L2_HEVC_SEI_PIC_STRUCT_TOP_BOTTOM			3
+#define V4L2_HEVC_SEI_PIC_STRUCT_BOTTOM_TOP			4
+#define V4L2_HEVC_SEI_PIC_STRUCT_TOP_BOTTOM_TOP			5
+#define V4L2_HEVC_SEI_PIC_STRUCT_BOTTOM_TOP_BOTTOM		6
+#define V4L2_HEVC_SEI_PIC_STRUCT_FRAME_DOUBLING			7
+#define V4L2_HEVC_SEI_PIC_STRUCT_FRAME_TRIPLING			8
+#define V4L2_HEVC_SEI_PIC_STRUCT_TOP_PAIRED_PREVIOUS_BOTTOM	9
+#define V4L2_HEVC_SEI_PIC_STRUCT_BOTTOM_PAIRED_PREVIOUS_TOP	10
+#define V4L2_HEVC_SEI_PIC_STRUCT_TOP_PAIRED_NEXT_BOTTOM		11
+#define V4L2_HEVC_SEI_PIC_STRUCT_BOTTOM_PAIRED_NEXT_TOP		12
+
+#define V4L2_HEVC_DPB_ENTRIES_NUM_MAX		16
+
+/**
+ * struct v4l2_hevc_dpb_entry - HEVC decoded picture buffer entry
+ *
+ * @timestamp: timestamp of the V4L2 capture buffer to use as reference.
+ * @flags: long term flag for the reference frame
+ * @field_pic: whether the reference is a field picture or a frame.
+ * @reserved: padding field. Should be zeroed by applications.
+ * @pic_order_cnt_val: the picture order count of the current picture.
+ */
+struct v4l2_hevc_dpb_entry {
+	__u64	timestamp;
+	__u8	flags;
+	__u8	field_pic;
+	__u16	reserved;
+	__s32	pic_order_cnt_val;
+};
+
+/**
+ * struct v4l2_hevc_pred_weight_table - HEVC weighted prediction parameters
+ *
+ * @delta_luma_weight_l0: the difference of the weighting factor applied
+ *			  to the luma prediction value for list 0
+ * @luma_offset_l0: the additive offset applied to the luma prediction value
+ *		    for list 0
+ * @delta_chroma_weight_l0: the difference of the weighting factor applied
+ *			    to the chroma prediction values for list 0
+ * @chroma_offset_l0: the difference of the additive offset applied to
+ *		      the chroma prediction values for list 0
+ * @delta_luma_weight_l1: the difference of the weighting factor applied
+ *			  to the luma prediction value for list 1
+ * @luma_offset_l1: the additive offset applied to the luma prediction value
+ *		    for list 1
+ * @delta_chroma_weight_l1: the difference of the weighting factor applied
+ *			    to the chroma prediction values for list 1
+ * @chroma_offset_l1: the difference of the additive offset applied to
+ *		      the chroma prediction values for list 1
+ * @luma_log2_weight_denom: the base 2 logarithm of the denominator for
+ *			    all luma weighting factors
+ * @delta_chroma_log2_weight_denom: the difference of the base 2 logarithm
+ *				    of the denominator for all chroma
+ *				    weighting factors
+ */
+struct v4l2_hevc_pred_weight_table {
+	__s8	delta_luma_weight_l0[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__s8	luma_offset_l0[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__s8	delta_chroma_weight_l0[V4L2_HEVC_DPB_ENTRIES_NUM_MAX][2];
+	__s8	chroma_offset_l0[V4L2_HEVC_DPB_ENTRIES_NUM_MAX][2];
+
+	__s8	delta_luma_weight_l1[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__s8	luma_offset_l1[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__s8	delta_chroma_weight_l1[V4L2_HEVC_DPB_ENTRIES_NUM_MAX][2];
+	__s8	chroma_offset_l1[V4L2_HEVC_DPB_ENTRIES_NUM_MAX][2];
+
+	__u8	luma_log2_weight_denom;
+	__s8	delta_chroma_log2_weight_denom;
+};
+
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_SLICE_SAO_LUMA		(1ULL << 0)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_SLICE_SAO_CHROMA		(1ULL << 1)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_SLICE_TEMPORAL_MVP_ENABLED	(1ULL << 2)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_MVD_L1_ZERO			(1ULL << 3)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_CABAC_INIT			(1ULL << 4)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_COLLOCATED_FROM_L0		(1ULL << 5)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_USE_INTEGER_MV		(1ULL << 6)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_SLICE_DEBLOCKING_FILTER_DISABLED (1ULL << 7)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_SLICE_LOOP_FILTER_ACROSS_SLICES_ENABLED (1ULL << 8)
+#define V4L2_HEVC_SLICE_PARAMS_FLAG_DEPENDENT_SLICE_SEGMENT	(1ULL << 9)
+
+/**
+ * struct v4l2_ctrl_hevc_slice_params - HEVC slice parameters
+ *
+ * This control is a dynamically sized 1-dimensional array,
+ * V4L2_CTRL_FLAG_DYNAMIC_ARRAY flag must be set when using it.
+ *
+ * @bit_size: size (in bits) of the current slice data
+ * @data_byte_offset: offset (in bytes) to the video data in the current slice data
+ * @num_entry_point_offsets: specifies the number of entry point offset syntax
+ *			     elements in the slice header.
+ * @nal_unit_type: specifies the coding type of the slice (B, P or I)
+ * @nuh_temporal_id_plus1: minus 1 specifies a temporal identifier for the NAL unit
+ * @slice_type: see V4L2_HEVC_SLICE_TYPE_{}
+ * @colour_plane_id: specifies the colour plane associated with the current slice
+ * @slice_pic_order_cnt: specifies the picture order count
+ * @num_ref_idx_l0_active_minus1: this value plus 1 specifies the maximum
+ *                                reference index for reference picture list 0
+ *                                that may be used to decode the slice
+ * @num_ref_idx_l1_active_minus1: this value plus 1 specifies the maximum
+ *                                reference index for reference picture list 1
+ *                                that may be used to decode the slice
+ * @collocated_ref_idx: specifies the reference index of the collocated picture used
+ *			for temporal motion vector prediction
+ * @five_minus_max_num_merge_cand: specifies the maximum number of merging
+ *				   motion vector prediction candidates supported in
+ *				   the slice subtracted from 5
+ * @slice_qp_delta: specifies the initial value of QpY to be used for the coding
+ *		    blocks in the slice
+ * @slice_cb_qp_offset: specifies a difference to be added to the value of pps_cb_qp_offset
+ * @slice_cr_qp_offset: specifies a difference to be added to the value of pps_cr_qp_offset
+ * @slice_act_y_qp_offset: screen content extension parameters
+ * @slice_act_cb_qp_offset: screen content extension parameters
+ * @slice_act_cr_qp_offset: screen content extension parameters
+ * @slice_beta_offset_div2: specify the deblocking parameter offsets for beta divided by 2
+ * @slice_tc_offset_div2: specify the deblocking parameter offsets for tC divided by 2
+ * @pic_struct: indicates whether a picture should be displayed as a frame or as one or
+ *		more fields
+ * @reserved0: padding field. Should be zeroed by applications.
+ * @slice_segment_addr: specifies the address of the first coding tree block in
+ *			the slice segment
+ * @ref_idx_l0: the list of L0 reference elements as indices in the DPB
+ * @ref_idx_l1: the list of L1 reference elements as indices in the DPB
+ * @short_term_ref_pic_set_size: specifies the size of short-term reference
+ *				 pictures set included in the SPS
+ * @long_term_ref_pic_set_size: specifies the size of long-term reference
+ *				pictures set include in the SPS
+ * @pred_weight_table: the prediction weight coefficients for inter-picture
+ *		       prediction
+ * @reserved1: padding field. Should be zeroed by applications.
+ * @flags: see V4L2_HEVC_SLICE_PARAMS_FLAG_{}
+ */
+struct v4l2_ctrl_hevc_slice_params {
+	__u32	bit_size;
+	__u32	data_byte_offset;
+	__u32	num_entry_point_offsets;
+
+	/* ISO/IEC 23008-2, ITU-T Rec. H.265: NAL unit header */
+	__u8	nal_unit_type;
+	__u8	nuh_temporal_id_plus1;
+
+	/* ISO/IEC 23008-2, ITU-T Rec. H.265: General slice segment header */
+	__u8	slice_type;
+	__u8	colour_plane_id;
+	__s32	slice_pic_order_cnt;
+	__u8	num_ref_idx_l0_active_minus1;
+	__u8	num_ref_idx_l1_active_minus1;
+	__u8	collocated_ref_idx;
+	__u8	five_minus_max_num_merge_cand;
+	__s8	slice_qp_delta;
+	__s8	slice_cb_qp_offset;
+	__s8	slice_cr_qp_offset;
+	__s8	slice_act_y_qp_offset;
+	__s8	slice_act_cb_qp_offset;
+	__s8	slice_act_cr_qp_offset;
+	__s8	slice_beta_offset_div2;
+	__s8	slice_tc_offset_div2;
+
+	/* ISO/IEC 23008-2, ITU-T Rec. H.265: Picture timing SEI message */
+	__u8	pic_struct;
+
+	__u8	reserved0[3];
+	/* ISO/IEC 23008-2, ITU-T Rec. H.265: General slice segment header */
+	__u32	slice_segment_addr;
+	__u8	ref_idx_l0[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__u8	ref_idx_l1[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__u16	short_term_ref_pic_set_size;
+	__u16	long_term_ref_pic_set_size;
+
+	/* ISO/IEC 23008-2, ITU-T Rec. H.265: Weighted prediction parameter */
+	struct v4l2_hevc_pred_weight_table pred_weight_table;
+
+	__u8	reserved1[2];
+	__u64	flags;
+};
+
+#define V4L2_HEVC_DECODE_PARAM_FLAG_IRAP_PIC		0x1
+#define V4L2_HEVC_DECODE_PARAM_FLAG_IDR_PIC		0x2
+#define V4L2_HEVC_DECODE_PARAM_FLAG_NO_OUTPUT_OF_PRIOR  0x4
+
+/**
+ * struct v4l2_ctrl_hevc_decode_params - HEVC decode parameters
+ *
+ * @pic_order_cnt_val: picture order count
+ * @short_term_ref_pic_set_size: specifies the size of short-term reference
+ *				 pictures set included in the SPS of the first slice
+ * @long_term_ref_pic_set_size: specifies the size of long-term reference
+ *				pictures set include in the SPS of the first slice
+ * @num_active_dpb_entries: the number of entries in dpb
+ * @num_poc_st_curr_before: the number of reference pictures in the short-term
+ *			    set that come before the current frame
+ * @num_poc_st_curr_after: the number of reference pictures in the short-term
+ *			   set that come after the current frame
+ * @num_poc_lt_curr: the number of reference pictures in the long-term set
+ * @poc_st_curr_before: provides the index of the short term before references
+ *			in DPB array
+ * @poc_st_curr_after: provides the index of the short term after references
+ *		       in DPB array
+ * @poc_lt_curr: provides the index of the long term references in DPB array
+ * @num_delta_pocs_of_ref_rps_idx: same as the derived value NumDeltaPocs[RefRpsIdx],
+ *				   can be used to parse the RPS data in slice headers
+ *				   instead of skipping it with @short_term_ref_pic_set_size.
+ * @reserved: padding field. Should be zeroed by applications.
+ * @dpb: the decoded picture buffer, for meta-data about reference frames
+ * @flags: see V4L2_HEVC_DECODE_PARAM_FLAG_{}
+ */
+struct v4l2_ctrl_hevc_decode_params {
+	__s32	pic_order_cnt_val;
+	__u16	short_term_ref_pic_set_size;
+	__u16	long_term_ref_pic_set_size;
+	__u8	num_active_dpb_entries;
+	__u8	num_poc_st_curr_before;
+	__u8	num_poc_st_curr_after;
+	__u8	num_poc_lt_curr;
+	__u8	poc_st_curr_before[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__u8	poc_st_curr_after[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__u8	poc_lt_curr[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__u8	num_delta_pocs_of_ref_rps_idx;
+	__u8	reserved[3];
+	struct	v4l2_hevc_dpb_entry dpb[V4L2_HEVC_DPB_ENTRIES_NUM_MAX];
+	__u64	flags;
+};
+
+/**
+ * struct v4l2_ctrl_hevc_scaling_matrix - HEVC scaling lists parameters
+ *
+ * @scaling_list_4x4: scaling list is used for the scaling process for
+ *		      transform coefficients. The values on each scaling
+ *		      list are expected in raster scan order
+ * @scaling_list_8x8: scaling list is used for the scaling process for
+ *		      transform coefficients. The values on each scaling
+ *		      list are expected in raster scan order
+ * @scaling_list_16x16:	scaling list is used for the scaling process for
+ *			transform coefficients. The values on each scaling
+ *			list are expected in raster scan order
+ * @scaling_list_32x32:	scaling list is used for the scaling process for
+ *			transform coefficients. The values on each scaling
+ *			list are expected in raster scan order
+ * @scaling_list_dc_coef_16x16:	scaling list is used for the scaling process
+ *				for transform coefficients. The values on each
+ *				scaling list are expected in raster scan order.
+ * @scaling_list_dc_coef_32x32:	scaling list is used for the scaling process
+ *				for transform coefficients. The values on each
+ *				scaling list are expected in raster scan order.
+ */
+struct v4l2_ctrl_hevc_scaling_matrix {
+	__u8	scaling_list_4x4[6][16];
+	__u8	scaling_list_8x8[6][64];
+	__u8	scaling_list_16x16[6][64];
+	__u8	scaling_list_32x32[2][64];
+	__u8	scaling_list_dc_coef_16x16[6];
+	__u8	scaling_list_dc_coef_32x32[2];
+};
+
 #define V4L2_CID_COLORIMETRY_CLASS_BASE	(V4L2_CTRL_CLASS_COLORIMETRY | 0x900)
 #define V4L2_CID_COLORIMETRY_CLASS	(V4L2_CTRL_CLASS_COLORIMETRY | 1)
 
@@ -2317,6 +2846,645 @@ struct v4l2_ctrl_vp9_compressed_hdr {
 	struct v4l2_vp9_mv_probs mv;
 };
 
+/* Stateless AV1 controls */
+
+#define V4L2_AV1_TOTAL_REFS_PER_FRAME	8
+#define V4L2_AV1_CDEF_MAX		8
+#define V4L2_AV1_NUM_PLANES_MAX		3 /* 1 if monochrome, 3 otherwise */
+#define V4L2_AV1_MAX_SEGMENTS		8
+#define V4L2_AV1_MAX_OPERATING_POINTS	(1 << 5) /* 5 bits to encode */
+#define V4L2_AV1_REFS_PER_FRAME		7
+#define V4L2_AV1_MAX_NUM_Y_POINTS	(1 << 4) /* 4 bits to encode */
+#define V4L2_AV1_MAX_NUM_CB_POINTS	(1 << 4) /* 4 bits to encode */
+#define V4L2_AV1_MAX_NUM_CR_POINTS	(1 << 4) /* 4 bits to encode */
+#define V4L2_AV1_AR_COEFFS_SIZE		25 /* (2 * 3 * (3 + 1)) + 1 */
+#define V4L2_AV1_MAX_NUM_PLANES		3
+#define V4L2_AV1_MAX_TILE_COLS		64
+#define V4L2_AV1_MAX_TILE_ROWS		64
+#define V4L2_AV1_MAX_TILE_COUNT		512
+
+#define V4L2_AV1_SEQUENCE_FLAG_STILL_PICTURE		  0x00000001
+#define V4L2_AV1_SEQUENCE_FLAG_USE_128X128_SUPERBLOCK	  0x00000002
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_FILTER_INTRA	  0x00000004
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_INTRA_EDGE_FILTER   0x00000008
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_INTERINTRA_COMPOUND 0x00000010
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_MASKED_COMPOUND	  0x00000020
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_WARPED_MOTION	  0x00000040
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_DUAL_FILTER	  0x00000080
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_ORDER_HINT	  0x00000100
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_JNT_COMP		  0x00000200
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_REF_FRAME_MVS	  0x00000400
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_SUPERRES		  0x00000800
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_CDEF		  0x00001000
+#define V4L2_AV1_SEQUENCE_FLAG_ENABLE_RESTORATION	  0x00002000
+#define V4L2_AV1_SEQUENCE_FLAG_MONO_CHROME		  0x00004000
+#define V4L2_AV1_SEQUENCE_FLAG_COLOR_RANGE		  0x00008000
+#define V4L2_AV1_SEQUENCE_FLAG_SUBSAMPLING_X		  0x00010000
+#define V4L2_AV1_SEQUENCE_FLAG_SUBSAMPLING_Y		  0x00020000
+#define V4L2_AV1_SEQUENCE_FLAG_FILM_GRAIN_PARAMS_PRESENT  0x00040000
+#define V4L2_AV1_SEQUENCE_FLAG_SEPARATE_UV_DELTA_Q	  0x00080000
+
+#define V4L2_CID_STATELESS_AV1_SEQUENCE (V4L2_CID_CODEC_STATELESS_BASE + 500)
+/**
+ * struct v4l2_ctrl_av1_sequence - AV1 Sequence
+ *
+ * Represents an AV1 Sequence OBU. See section 5.5 "Sequence header OBU syntax"
+ * for more details.
+ *
+ * @flags: See V4L2_AV1_SEQUENCE_FLAG_{}.
+ * @seq_profile: specifies the features that can be used in the coded video
+ * sequence.
+ * @order_hint_bits: specifies the number of bits used for the order_hint field
+ * at each frame.
+ * @bit_depth: the bitdepth to use for the sequence as described in section
+ * 5.5.2 "Color config syntax".
+ * @reserved: padding field. Should be zeroed by applications.
+ * @max_frame_width_minus_1: specifies the maximum frame width minus 1 for the
+ * frames represented by this sequence header.
+ * @max_frame_height_minus_1: specifies the maximum frame height minus 1 for the
+ * frames represented by this sequence header.
+ */
+struct v4l2_ctrl_av1_sequence {
+	__u32 flags;
+	__u8 seq_profile;
+	__u8 order_hint_bits;
+	__u8 bit_depth;
+	__u8 reserved;
+	__u16 max_frame_width_minus_1;
+	__u16 max_frame_height_minus_1;
+};
+
+#define V4L2_CID_STATELESS_AV1_TILE_GROUP_ENTRY (V4L2_CID_CODEC_STATELESS_BASE + 501)
+/**
+ * struct v4l2_ctrl_av1_tile_group_entry - AV1 Tile Group entry
+ *
+ * Represents a single AV1 tile inside an AV1 Tile Group. Note that MiRowStart,
+ * MiRowEnd, MiColStart and MiColEnd can be retrieved from struct
+ * v4l2_av1_tile_info in struct v4l2_ctrl_av1_frame using tile_row and
+ * tile_col. See section 6.10.1 "General tile group OBU semantics" for more
+ * details.
+ *
+ * @tile_offset: offset from the OBU data, i.e. where the coded tile data
+ * actually starts.
+ * @tile_size: specifies the size in bytes of the coded tile. Equivalent to
+ * "TileSize" in the AV1 Specification.
+ * @tile_row: specifies the row of the current tile. Equivalent to "TileRow" in
+ * the AV1 Specification.
+ * @tile_col: specifies the col of the current tile. Equivalent to "TileCol" in
+ * the AV1 Specification.
+ */
+struct v4l2_ctrl_av1_tile_group_entry {
+	__u32 tile_offset;
+	__u32 tile_size;
+	__u32 tile_row;
+	__u32 tile_col;
+};
+
+/**
+ * enum v4l2_av1_warp_model - AV1 Warp Model as described in section 3
+ * "Symbols and abbreviated terms" of the AV1 Specification.
+ *
+ * @V4L2_AV1_WARP_MODEL_IDENTITY: Warp model is just an identity transform.
+ * @V4L2_AV1_WARP_MODEL_TRANSLATION: Warp model is a pure translation.
+ * @V4L2_AV1_WARP_MODEL_ROTZOOM: Warp model is a rotation + symmetric zoom +
+ * translation.
+ * @V4L2_AV1_WARP_MODEL_AFFINE: Warp model is a general affine transform.
+ */
+enum v4l2_av1_warp_model {
+	V4L2_AV1_WARP_MODEL_IDENTITY = 0,
+	V4L2_AV1_WARP_MODEL_TRANSLATION = 1,
+	V4L2_AV1_WARP_MODEL_ROTZOOM = 2,
+	V4L2_AV1_WARP_MODEL_AFFINE = 3,
+};
+
+/**
+ * enum v4l2_av1_reference_frame - AV1 reference frames
+ *
+ * @V4L2_AV1_REF_INTRA_FRAME: Intra Frame Reference
+ * @V4L2_AV1_REF_LAST_FRAME: Last Reference Frame
+ * @V4L2_AV1_REF_LAST2_FRAME: Last2 Reference Frame
+ * @V4L2_AV1_REF_LAST3_FRAME: Last3 Reference Frame
+ * @V4L2_AV1_REF_GOLDEN_FRAME: Golden Reference Frame
+ * @V4L2_AV1_REF_BWDREF_FRAME: BWD Reference Frame
+ * @V4L2_AV1_REF_ALTREF2_FRAME: Alternative2 Reference Frame
+ * @V4L2_AV1_REF_ALTREF_FRAME: Alternative Reference Frame
+ */
+enum v4l2_av1_reference_frame {
+	V4L2_AV1_REF_INTRA_FRAME = 0,
+	V4L2_AV1_REF_LAST_FRAME = 1,
+	V4L2_AV1_REF_LAST2_FRAME = 2,
+	V4L2_AV1_REF_LAST3_FRAME = 3,
+	V4L2_AV1_REF_GOLDEN_FRAME = 4,
+	V4L2_AV1_REF_BWDREF_FRAME = 5,
+	V4L2_AV1_REF_ALTREF2_FRAME = 6,
+	V4L2_AV1_REF_ALTREF_FRAME = 7,
+};
+
+#define V4L2_AV1_GLOBAL_MOTION_IS_INVALID(ref) (1 << (ref))
+
+#define V4L2_AV1_GLOBAL_MOTION_FLAG_IS_GLOBAL	   0x1
+#define V4L2_AV1_GLOBAL_MOTION_FLAG_IS_ROT_ZOOM	   0x2
+#define V4L2_AV1_GLOBAL_MOTION_FLAG_IS_TRANSLATION 0x4
+/**
+ * struct v4l2_av1_global_motion - AV1 Global Motion parameters as described in
+ * section 6.8.17 "Global motion params semantics" of the AV1 specification.
+ *
+ * @flags: A bitfield containing the flags per reference frame. See
+ * V4L2_AV1_GLOBAL_MOTION_FLAG_{}
+ * @type: The type of global motion transform used.
+ * @params: this field has the same meaning as "gm_params" in the AV1
+ * specification.
+ * @invalid: bitfield indicating whether the global motion params are invalid
+ * for a given reference frame. See section 7.11.3.6 Setup shear process and
+ * the variable "warpValid". Use V4L2_AV1_GLOBAL_MOTION_IS_INVALID(ref) to
+ * create a suitable mask.
+ * @reserved: padding field. Should be zeroed by applications.
+ */
+
+struct v4l2_av1_global_motion {
+	__u8 flags[V4L2_AV1_TOTAL_REFS_PER_FRAME];
+	enum v4l2_av1_warp_model type[V4L2_AV1_TOTAL_REFS_PER_FRAME];
+	__s32 params[V4L2_AV1_TOTAL_REFS_PER_FRAME][6];
+	__u8 invalid;
+	__u8 reserved[3];
+};
+
+/**
+ * enum v4l2_av1_frame_restoration_type - AV1 Frame Restoration Type
+ * @V4L2_AV1_FRAME_RESTORE_NONE: no filtering is applied.
+ * @V4L2_AV1_FRAME_RESTORE_WIENER: Wiener filter process is invoked.
+ * @V4L2_AV1_FRAME_RESTORE_SGRPROJ: self guided filter process is invoked.
+ * @V4L2_AV1_FRAME_RESTORE_SWITCHABLE: restoration filter is swichtable.
+ */
+enum v4l2_av1_frame_restoration_type {
+	V4L2_AV1_FRAME_RESTORE_NONE = 0,
+	V4L2_AV1_FRAME_RESTORE_WIENER = 1,
+	V4L2_AV1_FRAME_RESTORE_SGRPROJ = 2,
+	V4L2_AV1_FRAME_RESTORE_SWITCHABLE = 3,
+};
+
+#define V4L2_AV1_LOOP_RESTORATION_FLAG_USES_LR		0x1
+#define V4L2_AV1_LOOP_RESTORATION_FLAG_USES_CHROMA_LR	0x2
+
+/**
+ * struct v4l2_av1_loop_restoration - AV1 Loop Restauration as described in
+ * section 6.10.15 "Loop restoration params semantics" of the AV1 specification.
+ *
+ * @flags: See V4L2_AV1_LOOP_RESTORATION_FLAG_{}.
+ * @lr_unit_shift: specifies if the luma restoration size should be halved.
+ * @lr_uv_shift: specifies if the chroma size should be half the luma size.
+ * @reserved: padding field. Should be zeroed by applications.
+ * @frame_restoration_type: specifies the type of restoration used for each
+ * plane. See enum v4l2_av1_frame_restoration_type.
+ * @loop_restoration_size: specifies the size of loop restoration units in units
+ * of samples in the current plane.
+ */
+struct v4l2_av1_loop_restoration {
+	__u8 flags;
+	__u8 lr_unit_shift;
+	__u8 lr_uv_shift;
+	__u8 reserved;
+	enum v4l2_av1_frame_restoration_type frame_restoration_type[V4L2_AV1_NUM_PLANES_MAX];
+	__u32 loop_restoration_size[V4L2_AV1_MAX_NUM_PLANES];
+};
+
+/**
+ * struct v4l2_av1_cdef - AV1 CDEF params semantics as described in section
+ * 6.10.14 "CDEF params semantics" of the AV1 specification
+ *
+ * @damping_minus_3: controls the amount of damping in the deringing filter.
+ * @bits: specifies the number of bits needed to specify which CDEF filter to
+ * apply.
+ * @y_pri_strength: specifies the strength of the primary filter.
+ * @y_sec_strength: specifies the strength of the secondary filter.
+ * @uv_pri_strength: specifies the strength of the primary filter.
+ * @uv_sec_strength: specifies the strength of the secondary filter.
+ */
+struct v4l2_av1_cdef {
+	__u8 damping_minus_3;
+	__u8 bits;
+	__u8 y_pri_strength[V4L2_AV1_CDEF_MAX];
+	__u8 y_sec_strength[V4L2_AV1_CDEF_MAX];
+	__u8 uv_pri_strength[V4L2_AV1_CDEF_MAX];
+	__u8 uv_sec_strength[V4L2_AV1_CDEF_MAX];
+};
+
+#define V4L2_AV1_SEGMENTATION_FLAG_ENABLED	   0x1
+#define V4L2_AV1_SEGMENTATION_FLAG_UPDATE_MAP	   0x2
+#define V4L2_AV1_SEGMENTATION_FLAG_TEMPORAL_UPDATE 0x4
+#define V4L2_AV1_SEGMENTATION_FLAG_UPDATE_DATA	   0x8
+#define V4L2_AV1_SEGMENTATION_FLAG_SEG_ID_PRE_SKIP 0x10
+
+/**
+ * enum v4l2_av1_segment_feature - AV1 segment features as described in section
+ * 3 "Symbols and abbreviated terms" of the AV1 specification.
+ *
+ * @V4L2_AV1_SEG_LVL_ALT_Q: Index for quantizer segment feature.
+ * @V4L2_AV1_SEG_LVL_ALT_LF_Y_V: Index for vertical luma loop filter segment
+ * feature.
+ * @V4L2_AV1_SEG_LVL_REF_FRAME: Index for reference frame segment feature.
+ * @V4L2_AV1_SEG_LVL_REF_SKIP: Index for skip segment feature.
+ * @V4L2_AV1_SEG_LVL_REF_GLOBALMV: Index for global mv feature.
+ * @V4L2_AV1_SEG_LVL_MAX: Number of segment features.
+ */
+enum v4l2_av1_segment_feature {
+	V4L2_AV1_SEG_LVL_ALT_Q = 0,
+	V4L2_AV1_SEG_LVL_ALT_LF_Y_V = 1,
+	V4L2_AV1_SEG_LVL_REF_FRAME = 5,
+	V4L2_AV1_SEG_LVL_REF_SKIP = 6,
+	V4L2_AV1_SEG_LVL_REF_GLOBALMV = 7,
+	V4L2_AV1_SEG_LVL_MAX = 8
+};
+
+#define V4L2_AV1_SEGMENT_FEATURE_ENABLED(id)	(1 << (id))
+
+/**
+ * struct v4l2_av1_segmentation - AV1 Segmentation params as defined in section
+ * 6.8.13 "Segmentation params semantics" of the AV1 specification.
+ *
+ * @flags: see V4L2_AV1_SEGMENTATION_FLAG_{}.
+ * @last_active_seg_id: indicates the highest numbered segment id that has some
+ * enabled feature. This is used when decoding the segment id to only decode
+ * choices corresponding to used segments.
+ * @feature_enabled: bitmask defining which features are enabled in each
+ * segment. Use V4L2_AV1_SEGMENT_FEATURE_ENABLED to build a suitable mask.
+ * @feature_data: data attached to each feature. Data entry is only valid if the
+ * feature is enabled
+ */
+struct v4l2_av1_segmentation {
+	__u8 flags;
+	__u8 last_active_seg_id;
+	__u8 feature_enabled[V4L2_AV1_MAX_SEGMENTS];
+	__s16 feature_data[V4L2_AV1_MAX_SEGMENTS][V4L2_AV1_SEG_LVL_MAX];
+};
+
+#define V4L2_AV1_LOOP_FILTER_FLAG_DELTA_ENABLED    0x1
+#define V4L2_AV1_LOOP_FILTER_FLAG_DELTA_UPDATE     0x2
+#define V4L2_AV1_LOOP_FILTER_FLAG_DELTA_LF_PRESENT 0x4
+#define V4L2_AV1_LOOP_FILTER_FLAG_DELTA_LF_MULTI   0x8
+
+/**
+ * struct v4l2_av1_loop_filter - AV1 Loop filter params as defined in section
+ * 6.8.10 "Loop filter semantics" and 6.8.16 "Loop filter delta parameters
+ * semantics" of the AV1 specification.
+ *
+ * @flags: see V4L2_AV1_LOOP_FILTER_FLAG_{}
+ * @level: an array containing loop filter strength values. Different loop
+ * filter strength values from the array are used depending on the image plane
+ * being filtered, and the edge direction (vertical or horizontal) being
+ * filtered.
+ * @sharpness: indicates the sharpness level. The loop_filter_level and
+ * loop_filter_sharpness together determine when a block edge is filtered, and
+ * by how much the filtering can change the sample values. The loop filter
+ * process is described in section 7.14 of the AV1 specification.
+ * @ref_deltas: contains the adjustment needed for the filter level based on the
+ * chosen reference frame. If this syntax element is not present, it maintains
+ * its previous value.
+ * @mode_deltas: contains the adjustment needed for the filter level based on
+ * the chosen mode. If this syntax element is not present, it maintains its
+ * previous value.
+ * @delta_lf_res: specifies the left shift which should be applied to decoded
+ * loop filter delta values.
+ */
+struct v4l2_av1_loop_filter {
+	__u8 flags;
+	__u8 level[4];
+	__u8 sharpness;
+	__s8 ref_deltas[V4L2_AV1_TOTAL_REFS_PER_FRAME];
+	__s8 mode_deltas[2];
+	__u8 delta_lf_res;
+};
+
+#define V4L2_AV1_QUANTIZATION_FLAG_DIFF_UV_DELTA   0x1
+#define V4L2_AV1_QUANTIZATION_FLAG_USING_QMATRIX   0x2
+#define V4L2_AV1_QUANTIZATION_FLAG_DELTA_Q_PRESENT 0x4
+
+/**
+ * struct v4l2_av1_quantization - AV1 Quantization params as defined in section
+ * 6.8.11 "Quantization params semantics" of the AV1 specification.
+ *
+ * @flags: see V4L2_AV1_QUANTIZATION_FLAG_{}
+ * @base_q_idx: indicates the base frame qindex. This is used for Y AC
+ * coefficients and as the base value for the other quantizers.
+ * @delta_q_y_dc: indicates the Y DC quantizer relative to base_q_idx.
+ * @delta_q_u_dc: indicates the U DC quantizer relative to base_q_idx.
+ * @delta_q_u_ac: indicates the U AC quantizer relative to base_q_idx.
+ * @delta_q_v_dc: indicates the V DC quantizer relative to base_q_idx.
+ * @delta_q_v_ac: indicates the V AC quantizer relative to base_q_idx.
+ * @qm_y: specifies the level in the quantizer matrix that should be used for
+ * luma plane decoding.
+ * @qm_u: specifies the level in the quantizer matrix that should be used for
+ * chroma U plane decoding.
+ * @qm_v: specifies the level in the quantizer matrix that should be used for
+ * chroma V plane decoding.
+ * @delta_q_res: specifies the left shift which should be applied to decoded
+ * quantizer index delta values.
+ */
+struct v4l2_av1_quantization {
+	__u8 flags;
+	__u8 base_q_idx;
+	__s8 delta_q_y_dc;
+	__s8 delta_q_u_dc;
+	__s8 delta_q_u_ac;
+	__s8 delta_q_v_dc;
+	__s8 delta_q_v_ac;
+	__u8 qm_y;
+	__u8 qm_u;
+	__u8 qm_v;
+	__u8 delta_q_res;
+};
+
+#define V4L2_AV1_TILE_INFO_FLAG_UNIFORM_TILE_SPACING	0x1
+
+/**
+ * struct v4l2_av1_tile_info - AV1 Tile info as defined in section 6.8.14 "Tile
+ * info semantics" of the AV1 specification.
+ *
+ * @flags: see V4L2_AV1_TILE_INFO_FLAG_{}
+ * @context_update_tile_id: specifies which tile to use for the CDF update.
+ * @tile_rows: specifies the number of tiles down the frame.
+ * @tile_cols: specifies the number of tiles across the frame.
+ * @mi_col_starts: an array specifying the start column (in units of 4x4 luma
+ * samples) for each tile across the image.
+ * @mi_row_starts: an array specifying the start row (in units of 4x4 luma
+ * samples) for each tile down the image.
+ * @width_in_sbs_minus_1: specifies the width of a tile minus 1 in units of
+ * superblocks.
+ * @height_in_sbs_minus_1:  specifies the height of a tile minus 1 in units of
+ * superblocks.
+ * @tile_size_bytes: specifies the number of bytes needed to code each tile
+ * size.
+ * @reserved: padding field. Should be zeroed by applications.
+ */
+struct v4l2_av1_tile_info {
+	__u8 flags;
+	__u8 context_update_tile_id;
+	__u8 tile_cols;
+	__u8 tile_rows;
+	__u32 mi_col_starts[V4L2_AV1_MAX_TILE_COLS + 1];
+	__u32 mi_row_starts[V4L2_AV1_MAX_TILE_ROWS + 1];
+	__u32 width_in_sbs_minus_1[V4L2_AV1_MAX_TILE_COLS];
+	__u32 height_in_sbs_minus_1[V4L2_AV1_MAX_TILE_ROWS];
+	__u8 tile_size_bytes;
+	__u8 reserved[3];
+};
+
+/**
+ * enum v4l2_av1_frame_type - AV1 Frame Type
+ *
+ * @V4L2_AV1_KEY_FRAME: Key frame
+ * @V4L2_AV1_INTER_FRAME: Inter frame
+ * @V4L2_AV1_INTRA_ONLY_FRAME: Intra-only frame
+ * @V4L2_AV1_SWITCH_FRAME: Switch frame
+ */
+enum v4l2_av1_frame_type {
+	V4L2_AV1_KEY_FRAME = 0,
+	V4L2_AV1_INTER_FRAME = 1,
+	V4L2_AV1_INTRA_ONLY_FRAME = 2,
+	V4L2_AV1_SWITCH_FRAME = 3
+};
+
+/**
+ * enum v4l2_av1_interpolation_filter - AV1 interpolation filter types
+ *
+ * @V4L2_AV1_INTERPOLATION_FILTER_EIGHTTAP: eight tap filter
+ * @V4L2_AV1_INTERPOLATION_FILTER_EIGHTTAP_SMOOTH: eight tap smooth filter
+ * @V4L2_AV1_INTERPOLATION_FILTER_EIGHTTAP_SHARP: eight tap sharp filter
+ * @V4L2_AV1_INTERPOLATION_FILTER_BILINEAR: bilinear filter
+ * @V4L2_AV1_INTERPOLATION_FILTER_SWITCHABLE: filter selection is signaled at
+ * the block level
+ *
+ * See section 6.8.9 "Interpolation filter semantics" of the AV1 specification
+ * for more details.
+ */
+enum v4l2_av1_interpolation_filter {
+	V4L2_AV1_INTERPOLATION_FILTER_EIGHTTAP = 0,
+	V4L2_AV1_INTERPOLATION_FILTER_EIGHTTAP_SMOOTH = 1,
+	V4L2_AV1_INTERPOLATION_FILTER_EIGHTTAP_SHARP = 2,
+	V4L2_AV1_INTERPOLATION_FILTER_BILINEAR = 3,
+	V4L2_AV1_INTERPOLATION_FILTER_SWITCHABLE = 4,
+};
+
+/**
+ * enum v4l2_av1_tx_mode - AV1 Tx mode as described in section 6.8.21 "TX mode
+ * semantics" of the AV1 specification.
+ * @V4L2_AV1_TX_MODE_ONLY_4X4: the inverse transform will use only 4x4
+ * transforms
+ * @V4L2_AV1_TX_MODE_LARGEST: the inverse transform will use the largest
+ * transform size that fits inside the block
+ * @V4L2_AV1_TX_MODE_SELECT: the choice of transform size is specified
+ * explicitly for each block.
+ */
+enum v4l2_av1_tx_mode {
+	V4L2_AV1_TX_MODE_ONLY_4X4 = 0,
+	V4L2_AV1_TX_MODE_LARGEST = 1,
+	V4L2_AV1_TX_MODE_SELECT = 2
+};
+
+#define V4L2_AV1_FRAME_FLAG_SHOW_FRAME			 0x00000001
+#define V4L2_AV1_FRAME_FLAG_SHOWABLE_FRAME		 0x00000002
+#define V4L2_AV1_FRAME_FLAG_ERROR_RESILIENT_MODE	 0x00000004
+#define V4L2_AV1_FRAME_FLAG_DISABLE_CDF_UPDATE		 0x00000008
+#define V4L2_AV1_FRAME_FLAG_ALLOW_SCREEN_CONTENT_TOOLS	 0x00000010
+#define V4L2_AV1_FRAME_FLAG_FORCE_INTEGER_MV		 0x00000020
+#define V4L2_AV1_FRAME_FLAG_ALLOW_INTRABC		 0x00000040
+#define V4L2_AV1_FRAME_FLAG_USE_SUPERRES		 0x00000080
+#define V4L2_AV1_FRAME_FLAG_ALLOW_HIGH_PRECISION_MV	 0x00000100
+#define V4L2_AV1_FRAME_FLAG_IS_MOTION_MODE_SWITCHABLE	 0x00000200
+#define V4L2_AV1_FRAME_FLAG_USE_REF_FRAME_MVS		 0x00000400
+#define V4L2_AV1_FRAME_FLAG_DISABLE_FRAME_END_UPDATE_CDF 0x00000800
+#define V4L2_AV1_FRAME_FLAG_ALLOW_WARPED_MOTION		 0x00001000
+#define V4L2_AV1_FRAME_FLAG_REFERENCE_SELECT		 0x00002000
+#define V4L2_AV1_FRAME_FLAG_REDUCED_TX_SET		 0x00004000
+#define V4L2_AV1_FRAME_FLAG_SKIP_MODE_ALLOWED		 0x00008000
+#define V4L2_AV1_FRAME_FLAG_SKIP_MODE_PRESENT		 0x00010000
+#define V4L2_AV1_FRAME_FLAG_FRAME_SIZE_OVERRIDE		 0x00020000
+#define V4L2_AV1_FRAME_FLAG_BUFFER_REMOVAL_TIME_PRESENT	 0x00040000
+#define V4L2_AV1_FRAME_FLAG_FRAME_REFS_SHORT_SIGNALING	 0x00080000
+
+#define V4L2_CID_STATELESS_AV1_FRAME (V4L2_CID_CODEC_STATELESS_BASE + 502)
+/**
+ * struct v4l2_ctrl_av1_frame - Represents an AV1 Frame Header OBU.
+ *
+ * @tile_info: tile info
+ * @quantization: quantization params
+ * @segmentation: segmentation params
+ * @superres_denom: the denominator for the upscaling ratio.
+ * @loop_filter: loop filter params
+ * @cdef: cdef params
+ * @skip_mode_frame: specifies the frames to use for compound prediction when
+ * skip_mode is equal to 1.
+ * @primary_ref_frame: specifies which reference frame contains the CDF values
+ * and other state that should be loaded at the start of the frame.
+ * @loop_restoration: loop restoration params
+ * @global_motion: global motion params
+ * @flags: see V4L2_AV1_FRAME_FLAG_{}
+ * @frame_type: specifies the AV1 frame type
+ * @order_hint: specifies OrderHintBits least significant bits of the expected
+ * output order for this frame.
+ * @upscaled_width: the upscaled width.
+ * @interpolation_filter: specifies the filter selection used for performing
+ * inter prediction.
+ * @tx_mode: specifies how the transform size is determined.
+ * @frame_width_minus_1: add 1 to get the frame's width.
+ * @frame_height_minus_1: add 1 to get the frame's height
+ * @render_width_minus_1: add 1 to get the render width of the frame in luma
+ * samples.
+ * @render_height_minus_1: add 1 to get the render height of the frame in luma
+ * samples.
+ * @current_frame_id: specifies the frame id number for the current frame. Frame
+ * id numbers are additional information that do not affect the decoding
+ * process, but provide decoders with a way of detecting missing reference
+ * frames so that appropriate action can be taken.
+ * @buffer_removal_time: specifies the frame removal time in units of DecCT clock
+ * ticks counted from the removal time of the last random access point for
+ * operating point opNum.
+ * @reserved: padding field. Should be zeroed by applications.
+ * @order_hints: specifies the expected output order hint for each reference
+ * frame. This field corresponds to the OrderHints variable from the
+ * specification (section 5.9.2 "Uncompressed header syntax"). As such, this is
+ * only used for non-intra frames and ignored otherwise. order_hints[0] is
+ * always ignored.
+ * @reference_frame_ts: the V4L2 timestamp of the reference frame slots.
+ * @ref_frame_idx: used to index into @reference_frame_ts when decoding
+ * inter-frames. The meaning of this array is the same as in the specification.
+ * The timestamp refers to the timestamp field in struct v4l2_buffer. Use
+ * v4l2_timeval_to_ns() to convert the struct timeval to a __u64.
+ * @refresh_frame_flags: contains a bitmask that specifies which reference frame
+ * slots will be updated with the current frame after it is decoded.
+ */
+struct v4l2_ctrl_av1_frame {
+	struct v4l2_av1_tile_info tile_info;
+	struct v4l2_av1_quantization quantization;
+	__u8 superres_denom;
+	struct v4l2_av1_segmentation segmentation;
+	struct v4l2_av1_loop_filter loop_filter;
+	struct v4l2_av1_cdef cdef;
+	__u8 skip_mode_frame[2];
+	__u8 primary_ref_frame;
+	struct v4l2_av1_loop_restoration loop_restoration;
+	struct v4l2_av1_global_motion global_motion;
+	__u32 flags;
+	enum v4l2_av1_frame_type frame_type;
+	__u32 order_hint;
+	__u32 upscaled_width;
+	enum v4l2_av1_interpolation_filter interpolation_filter;
+	enum v4l2_av1_tx_mode tx_mode;
+	__u32 frame_width_minus_1;
+	__u32 frame_height_minus_1;
+	__u16 render_width_minus_1;
+	__u16 render_height_minus_1;
+
+	__u32 current_frame_id;
+	__u32 buffer_removal_time[V4L2_AV1_MAX_OPERATING_POINTS];
+	__u8 reserved[4];
+	__u32 order_hints[V4L2_AV1_TOTAL_REFS_PER_FRAME];
+	__u64 reference_frame_ts[V4L2_AV1_TOTAL_REFS_PER_FRAME];
+	__s8 ref_frame_idx[V4L2_AV1_REFS_PER_FRAME];
+	__u8 refresh_frame_flags;
+};
+
+#define V4L2_AV1_FILM_GRAIN_FLAG_APPLY_GRAIN 0x1
+#define V4L2_AV1_FILM_GRAIN_FLAG_UPDATE_GRAIN 0x2
+#define V4L2_AV1_FILM_GRAIN_FLAG_CHROMA_SCALING_FROM_LUMA 0x4
+#define V4L2_AV1_FILM_GRAIN_FLAG_OVERLAP 0x8
+#define V4L2_AV1_FILM_GRAIN_FLAG_CLIP_TO_RESTRICTED_RANGE 0x10
+
+#define V4L2_CID_STATELESS_AV1_FILM_GRAIN (V4L2_CID_CODEC_STATELESS_BASE + 505)
+/**
+ * struct v4l2_ctrl_av1_film_grain - AV1 Film Grain parameters.
+ *
+ * Film grain parameters as specified by section 6.8.20 of the AV1 Specification.
+ *
+ * @flags: see V4L2_AV1_FILM_GRAIN_{}.
+ * @cr_mult: represents a multiplier for the cr component used in derivation of
+ * the input index to the cr component scaling function.
+ * @grain_seed: specifies the starting value for the pseudo-random numbers used
+ * during film grain synthesis.
+ * @film_grain_params_ref_idx: indicates which reference frame contains the
+ * film grain parameters to be used for this frame.
+ * @num_y_points: specifies the number of points for the piece-wise linear
+ * scaling function of the luma component.
+ * @point_y_value: represents the x (luma value) coordinate for the i-th point
+ * of the piecewise linear scaling function for luma component. The values are
+ * signaled on the scale of 0..255. In case of 10 bit video, these values
+ * correspond to luma values divided by 4. In case of 12 bit video, these values
+ * correspond to luma values divided by 16.
+ * @point_y_scaling:  represents the scaling (output) value for the i-th point
+ * of the piecewise linear scaling function for luma component.
+ * @num_cb_points: specifies the number of points for the piece-wise linear
+ * scaling function of the cb component.
+ * @point_cb_value: represents the x coordinate for the i-th point of the
+ * piece-wise linear scaling function for cb component. The values are signaled
+ * on the scale of 0..255.
+ * @point_cb_scaling: represents the scaling (output) value for the i-th point
+ * of the piecewise linear scaling function for cb component.
+ * @num_cr_points: specifies represents the number of points for the piece-wise
+ * linear scaling function of the cr component.
+ * @point_cr_value:  represents the x coordinate for the i-th point of the
+ * piece-wise linear scaling function for cr component. The values are signaled
+ * on the scale of 0..255.
+ * @point_cr_scaling:  represents the scaling (output) value for the i-th point
+ * of the piecewise linear scaling function for cr component.
+ * @grain_scaling_minus_8: represents the shift – 8 applied to the values of the
+ * chroma component. The grain_scaling_minus_8 can take values of 0..3 and
+ * determines the range and quantization step of the standard deviation of film
+ * grain.
+ * @ar_coeff_lag: specifies the number of auto-regressive coefficients for luma
+ * and chroma.
+ * @ar_coeffs_y_plus_128: specifies auto-regressive coefficients used for the Y
+ * plane.
+ * @ar_coeffs_cb_plus_128: specifies auto-regressive coefficients used for the U
+ * plane.
+ * @ar_coeffs_cr_plus_128: specifies auto-regressive coefficients used for the V
+ * plane.
+ * @ar_coeff_shift_minus_6: specifies the range of the auto-regressive
+ * coefficients. Values of 0, 1, 2, and 3 correspond to the ranges for
+ * auto-regressive coefficients of [-2, 2), [-1, 1), [-0.5, 0.5) and [-0.25,
+ * 0.25) respectively.
+ * @grain_scale_shift: specifies how much the Gaussian random numbers should be
+ * scaled down during the grain synthesis process.
+ * @cb_mult: represents a multiplier for the cb component used in derivation of
+ * the input index to the cb component scaling function.
+ * @cb_luma_mult: represents a multiplier for the average luma component used in
+ * derivation of the input index to the cb component scaling function.
+ * @cr_luma_mult: represents a multiplier for the average luma component used in
+ * derivation of the input index to the cr component scaling function.
+ * @cb_offset: represents an offset used in derivation of the input index to the
+ * cb component scaling function.
+ * @cr_offset: represents an offset used in derivation of the input index to the
+ * cr component scaling function.
+ * @reserved: padding field. Should be zeroed by applications.
+ */
+struct v4l2_ctrl_av1_film_grain {
+	__u8 flags;
+	__u8 cr_mult;
+	__u16 grain_seed;
+	__u8 film_grain_params_ref_idx;
+	__u8 num_y_points;
+	__u8 point_y_value[V4L2_AV1_MAX_NUM_Y_POINTS];
+	__u8 point_y_scaling[V4L2_AV1_MAX_NUM_Y_POINTS];
+	__u8 num_cb_points;
+	__u8 point_cb_value[V4L2_AV1_MAX_NUM_CB_POINTS];
+	__u8 point_cb_scaling[V4L2_AV1_MAX_NUM_CB_POINTS];
+	__u8 num_cr_points;
+	__u8 point_cr_value[V4L2_AV1_MAX_NUM_CR_POINTS];
+	__u8 point_cr_scaling[V4L2_AV1_MAX_NUM_CR_POINTS];
+	__u8 grain_scaling_minus_8;
+	__u8 ar_coeff_lag;
+	__u8 ar_coeffs_y_plus_128[V4L2_AV1_AR_COEFFS_SIZE];
+	__u8 ar_coeffs_cb_plus_128[V4L2_AV1_AR_COEFFS_SIZE];
+	__u8 ar_coeffs_cr_plus_128[V4L2_AV1_AR_COEFFS_SIZE];
+	__u8 ar_coeff_shift_minus_6;
+	__u8 grain_scale_shift;
+	__u8 cb_mult;
+	__u8 cb_luma_mult;
+	__u8 cr_luma_mult;
+	__u16 cb_offset;
+	__u16 cr_offset;
+	__u8 reserved[4];
+};
+
 /* MPEG-compression definitions kept for backwards compatibility */
 #define V4L2_CTRL_CLASS_MPEG            V4L2_CTRL_CLASS_CODEC
 #define V4L2_CID_MPEG_CLASS             V4L2_CID_CODEC_CLASS
diff -pruN 0.2.0-3/include/linux/v4l2-mediabus.h 0.3.0-1/include/linux/v4l2-mediabus.h
--- 0.2.0-3/include/linux/v4l2-mediabus.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/v4l2-mediabus.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,10 +3,6 @@
  * Media Bus API header
  *
  * Copyright (C) 2009, Guennadi Liakhovetski <g.liakhovetski@gmx.de>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation.
  */
 
 #ifndef __LINUX_V4L2_MEDIABUS_H
diff -pruN 0.2.0-3/include/linux/v4l2-subdev.h 0.3.0-1/include/linux/v4l2-subdev.h
--- 0.2.0-3/include/linux/v4l2-subdev.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/v4l2-subdev.h	2024-05-19 15:54:11.000000000 +0000
@@ -6,24 +6,12 @@
  *
  * Contacts: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
  *	     Sakari Ailus <sakari.ailus@iki.fi>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
 #ifndef __LINUX_V4L2_SUBDEV_H
 #define __LINUX_V4L2_SUBDEV_H
 
+#include <linux/const.h>
 #include <linux/ioctl.h>
 #include <linux/types.h>
 #include <linux/v4l2-common.h>
@@ -202,29 +190,14 @@ struct v4l2_subdev_capability {
 /* The v4l2 sub-device video device node is registered in read-only mode. */
 #define V4L2_SUBDEV_CAP_RO_SUBDEV		0x00000001
 
-/* The v4l2 sub-device supports multiplexed streams. */
-#define V4L2_SUBDEV_CAP_MPLEXED			0x00000002
+/* The v4l2 sub-device supports routing and multiplexed streams. */
+#define V4L2_SUBDEV_CAP_STREAMS			0x00000002
 
 /*
  * Is the route active? An active route will start when streaming is enabled
  * on a video node.
  */
-#define V4L2_SUBDEV_ROUTE_FL_ACTIVE		_BITUL(0)
-
-/*
- * Is the route immutable, i.e. can it be activated and inactivated?
- * Set by the driver.
- */
-#define V4L2_SUBDEV_ROUTE_FL_IMMUTABLE		_BITUL(1)
-
-/*
- * Is the route a source endpoint? A source endpoint route refers to a stream
- * generated internally by the subdevice (usually a sensor), and thus there
- * is no sink-side endpoint for the route. The sink_pad and sink_stream
- * fields are unused.
- * Set by the driver.
- */
-#define V4L2_SUBDEV_ROUTE_FL_SOURCE		_BITUL(2)
+#define V4L2_SUBDEV_ROUTE_FL_ACTIVE		(1U << 0)
 
 /**
  * struct v4l2_subdev_route - A route inside a subdev
@@ -260,6 +233,24 @@ struct v4l2_subdev_routing {
 	__u32 reserved[6];
 };
 
+/*
+ * The client is aware of streams. Setting this flag enables the use of 'stream'
+ * fields (referring to the stream number) with various ioctls. If this is not
+ * set (which is the default), the 'stream' fields will be forced to 0 by the
+ * kernel.
+ */
+ #define V4L2_SUBDEV_CLIENT_CAP_STREAMS		(1ULL << 0)
+
+/**
+ * struct v4l2_subdev_client_capability - Capabilities of the client accessing
+ *					  the subdev
+ *
+ * @capabilities: A bitmask of V4L2_SUBDEV_CLIENT_CAP_* flags.
+ */
+struct v4l2_subdev_client_capability {
+	__u64 capabilities;
+};
+
 /* Backwards compatibility define --- to be removed */
 #define v4l2_subdev_edid v4l2_edid
 
@@ -277,6 +268,9 @@ struct v4l2_subdev_routing {
 #define VIDIOC_SUBDEV_S_SELECTION		_IOWR('V', 62, struct v4l2_subdev_selection)
 #define VIDIOC_SUBDEV_G_ROUTING			_IOWR('V', 38, struct v4l2_subdev_routing)
 #define VIDIOC_SUBDEV_S_ROUTING			_IOWR('V', 39, struct v4l2_subdev_routing)
+#define VIDIOC_SUBDEV_G_CLIENT_CAP		_IOR('V',  101, struct v4l2_subdev_client_capability)
+#define VIDIOC_SUBDEV_S_CLIENT_CAP		_IOWR('V',  102, struct v4l2_subdev_client_capability)
+
 /* The following ioctls are identical to the ioctls in videodev2.h */
 #define VIDIOC_SUBDEV_G_STD			_IOR('V', 23, v4l2_std_id)
 #define VIDIOC_SUBDEV_S_STD			_IOW('V', 24, v4l2_std_id)
diff -pruN 0.2.0-3/include/linux/videodev2.h 0.3.0-1/include/linux/videodev2.h
--- 0.2.0-3/include/linux/videodev2.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/include/linux/videodev2.h	2024-05-19 15:54:11.000000000 +0000
@@ -243,6 +243,7 @@ enum v4l2_colorspace {
 
 	/* DCI-P3 colorspace, used by cinema projectors */
 	V4L2_COLORSPACE_DCI_P3        = 12,
+
 };
 
 /*
@@ -474,7 +475,6 @@ struct v4l2_capability {
 #define V4L2_CAP_META_CAPTURE		0x00800000  /* Is a metadata capture device */
 
 #define V4L2_CAP_READWRITE              0x01000000  /* read/write systemcalls */
-#define V4L2_CAP_ASYNCIO                0x02000000  /* async I/O */
 #define V4L2_CAP_STREAMING              0x04000000  /* streaming I/O ioctls */
 #define V4L2_CAP_META_OUTPUT		0x08000000  /* Is a metadata output device */
 
@@ -549,6 +549,15 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_RGBX32  v4l2_fourcc('X', 'B', '2', '4') /* 32  RGBX-8-8-8-8  */
 #define V4L2_PIX_FMT_ARGB32  v4l2_fourcc('B', 'A', '2', '4') /* 32  ARGB-8-8-8-8  */
 #define V4L2_PIX_FMT_XRGB32  v4l2_fourcc('B', 'X', '2', '4') /* 32  XRGB-8-8-8-8  */
+#define V4L2_PIX_FMT_RGBX1010102 v4l2_fourcc('R', 'X', '3', '0') /* 32  RGBX-10-10-10-2 */
+#define V4L2_PIX_FMT_RGBA1010102 v4l2_fourcc('R', 'A', '3', '0') /* 32  RGBA-10-10-10-2 */
+#define V4L2_PIX_FMT_ARGB2101010 v4l2_fourcc('A', 'R', '3', '0') /* 32  ARGB-2-10-10-10 */
+
+/* RGB formats (6 or 8 bytes per pixel) */
+#define V4L2_PIX_FMT_BGR48_12    v4l2_fourcc('B', '3', '1', '2') /* 48  BGR 12-bit per component */
+#define V4L2_PIX_FMT_BGR48       v4l2_fourcc('B', 'G', 'R', '6') /* 48  BGR 16-bit per component */
+#define V4L2_PIX_FMT_RGB48       v4l2_fourcc('R', 'G', 'B', '6') /* 48  RGB 16-bit per component */
+#define V4L2_PIX_FMT_ABGR64_12   v4l2_fourcc('B', '4', '1', '2') /* 64  BGRA 12-bit per component */
 
 /* Grey formats */
 #define V4L2_PIX_FMT_GREY    v4l2_fourcc('G', 'R', 'E', 'Y') /*  8  Greyscale     */
@@ -556,6 +565,7 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_Y6      v4l2_fourcc('Y', '0', '6', ' ') /*  6  Greyscale     */
 #define V4L2_PIX_FMT_Y10     v4l2_fourcc('Y', '1', '0', ' ') /* 10  Greyscale     */
 #define V4L2_PIX_FMT_Y12     v4l2_fourcc('Y', '1', '2', ' ') /* 12  Greyscale     */
+#define V4L2_PIX_FMT_Y012    v4l2_fourcc('Y', '0', '1', '2') /* 12  Greyscale     */
 #define V4L2_PIX_FMT_Y14     v4l2_fourcc('Y', '1', '4', ' ') /* 14  Greyscale     */
 #define V4L2_PIX_FMT_Y16     v4l2_fourcc('Y', '1', '6', ' ') /* 16  Greyscale     */
 #define V4L2_PIX_FMT_Y16_BE  v4l2_fourcc_be('Y', '1', '6', ' ') /* 16  Greyscale BE  */
@@ -590,6 +600,15 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_YUVA32  v4l2_fourcc('Y', 'U', 'V', 'A') /* 32  YUVA-8-8-8-8  */
 #define V4L2_PIX_FMT_YUVX32  v4l2_fourcc('Y', 'U', 'V', 'X') /* 32  YUVX-8-8-8-8  */
 #define V4L2_PIX_FMT_M420    v4l2_fourcc('M', '4', '2', '0') /* 12  YUV 4:2:0 2 lines y, 1 line uv interleaved */
+#define V4L2_PIX_FMT_YUV48_12    v4l2_fourcc('Y', '3', '1', '2') /* 48  YUV 4:4:4 12-bit per component */
+
+/*
+ * YCbCr packed format. For each Y2xx format, xx bits of valid data occupy the MSBs
+ * of the 16 bit components, and 16-xx bits of zero padding occupy the LSBs.
+ */
+#define V4L2_PIX_FMT_Y210    v4l2_fourcc('Y', '2', '1', '0') /* 32  YUYV 4:2:2 */
+#define V4L2_PIX_FMT_Y212    v4l2_fourcc('Y', '2', '1', '2') /* 32  YUYV 4:2:2 */
+#define V4L2_PIX_FMT_Y216    v4l2_fourcc('Y', '2', '1', '6') /* 32  YUYV 4:2:2 */
 
 /* two planes -- one Y, one Cr + Cb interleaved  */
 #define V4L2_PIX_FMT_NV12    v4l2_fourcc('N', 'V', '1', '2') /* 12  Y/CbCr 4:2:0  */
@@ -598,12 +617,15 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_NV61    v4l2_fourcc('N', 'V', '6', '1') /* 16  Y/CrCb 4:2:2  */
 #define V4L2_PIX_FMT_NV24    v4l2_fourcc('N', 'V', '2', '4') /* 24  Y/CbCr 4:4:4  */
 #define V4L2_PIX_FMT_NV42    v4l2_fourcc('N', 'V', '4', '2') /* 24  Y/CrCb 4:4:4  */
+#define V4L2_PIX_FMT_P010    v4l2_fourcc('P', '0', '1', '0') /* 24  Y/CbCr 4:2:0 10-bit per component */
+#define V4L2_PIX_FMT_P012    v4l2_fourcc('P', '0', '1', '2') /* 24  Y/CbCr 4:2:0 12-bit per component */
 
 /* two non contiguous planes - one Y, one Cr + Cb interleaved  */
 #define V4L2_PIX_FMT_NV12M   v4l2_fourcc('N', 'M', '1', '2') /* 12  Y/CbCr 4:2:0  */
 #define V4L2_PIX_FMT_NV21M   v4l2_fourcc('N', 'M', '2', '1') /* 21  Y/CrCb 4:2:0  */
 #define V4L2_PIX_FMT_NV16M   v4l2_fourcc('N', 'M', '1', '6') /* 16  Y/CbCr 4:2:2  */
 #define V4L2_PIX_FMT_NV61M   v4l2_fourcc('N', 'M', '6', '1') /* 16  Y/CrCb 4:2:2  */
+#define V4L2_PIX_FMT_P012M   v4l2_fourcc('P', 'M', '1', '2') /* 24  Y/CbCr 4:2:0 12-bit per component */
 
 /* three planes - Y Cb, Cr */
 #define V4L2_PIX_FMT_YUV410  v4l2_fourcc('Y', 'U', 'V', '9') /*  9  YUV 4:1:0     */
@@ -625,6 +647,10 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_NV12_4L4 v4l2_fourcc('V', 'T', '1', '2')   /* 12  Y/CbCr 4:2:0  4x4 tiles */
 #define V4L2_PIX_FMT_NV12_16L16 v4l2_fourcc('H', 'M', '1', '2') /* 12  Y/CbCr 4:2:0 16x16 tiles */
 #define V4L2_PIX_FMT_NV12_32L32 v4l2_fourcc('S', 'T', '1', '2') /* 12  Y/CbCr 4:2:0 32x32 tiles */
+#define V4L2_PIX_FMT_NV15_4L4 v4l2_fourcc('V', 'T', '1', '5') /* 15 Y/CbCr 4:2:0 10-bit 4x4 tiles */
+#define V4L2_PIX_FMT_P010_4L4 v4l2_fourcc('T', '0', '1', '0') /* 12  Y/CbCr 4:2:0 10-bit 4x4 macroblocks */
+#define V4L2_PIX_FMT_NV12_8L128       v4l2_fourcc('A', 'T', '1', '2') /* Y/CbCr 4:2:0 8x128 tiles */
+#define V4L2_PIX_FMT_NV12_10BE_8L128  v4l2_fourcc_be('A', 'X', '1', '2') /* Y/CbCr 4:2:0 10-bit 8x128 tiles */
 
 /* Tiled YUV formats, non contiguous planes */
 #define V4L2_PIX_FMT_NV12MT  v4l2_fourcc('T', 'M', '1', '2') /* 12  Y/CbCr 4:2:0 64x32 tiles */
@@ -707,6 +733,11 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_FWHT     v4l2_fourcc('F', 'W', 'H', 'T') /* Fast Walsh Hadamard Transform (vicodec) */
 #define V4L2_PIX_FMT_FWHT_STATELESS     v4l2_fourcc('S', 'F', 'W', 'H') /* Stateless FWHT (vicodec) */
 #define V4L2_PIX_FMT_H264_SLICE v4l2_fourcc('S', '2', '6', '4') /* H264 parsed slices */
+#define V4L2_PIX_FMT_HEVC_SLICE v4l2_fourcc('S', '2', '6', '5') /* HEVC parsed slices */
+#define V4L2_PIX_FMT_AV1_FRAME v4l2_fourcc('A', 'V', '1', 'F') /* AV1 parsed frame */
+#define V4L2_PIX_FMT_SPK      v4l2_fourcc('S', 'P', 'K', '0') /* Sorenson Spark */
+#define V4L2_PIX_FMT_RV30     v4l2_fourcc('R', 'V', '3', '0') /* RealVideo 8 */
+#define V4L2_PIX_FMT_RV40     v4l2_fourcc('R', 'V', '4', '0') /* RealVideo 9 & 10 */
 
 /*  Vendor-specific formats   */
 #define V4L2_PIX_FMT_CPIA1    v4l2_fourcc('C', 'P', 'I', 'A') /* cpia1 YUV */
@@ -740,11 +771,15 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_Z16      v4l2_fourcc('Z', '1', '6', ' ') /* Depth data 16-bit */
 #define V4L2_PIX_FMT_MT21C    v4l2_fourcc('M', 'T', '2', '1') /* Mediatek compressed block mode  */
 #define V4L2_PIX_FMT_MM21     v4l2_fourcc('M', 'M', '2', '1') /* Mediatek 8-bit block mode, two non-contiguous planes */
+#define V4L2_PIX_FMT_MT2110T  v4l2_fourcc('M', 'T', '2', 'T') /* Mediatek 10-bit block tile mode */
+#define V4L2_PIX_FMT_MT2110R  v4l2_fourcc('M', 'T', '2', 'R') /* Mediatek 10-bit block raster mode */
 #define V4L2_PIX_FMT_INZI     v4l2_fourcc('I', 'N', 'Z', 'I') /* Intel Planar Greyscale 10-bit and Depth 16-bit */
 #define V4L2_PIX_FMT_CNF4     v4l2_fourcc('C', 'N', 'F', '4') /* Intel 4-bit packed depth confidence information */
 #define V4L2_PIX_FMT_HI240    v4l2_fourcc('H', 'I', '2', '4') /* BTTV 8-bit dithered RGB */
 #define V4L2_PIX_FMT_QC08C    v4l2_fourcc('Q', '0', '8', 'C') /* Qualcomm 8-bit compressed */
 #define V4L2_PIX_FMT_QC10C    v4l2_fourcc('Q', '1', '0', 'C') /* Qualcomm 10-bit compressed */
+#define V4L2_PIX_FMT_AJPG     v4l2_fourcc('A', 'J', 'P', 'G') /* Aspeed JPEG */
+#define V4L2_PIX_FMT_HEXTILE  v4l2_fourcc('H', 'X', 'T', 'L') /* Hextile compressed */
 
 /* 10bit raw packed, 32 bytes for every 25 pixels, last LSB 6 bits unused */
 #define V4L2_PIX_FMT_IPU3_SBGGR10	v4l2_fourcc('i', 'p', '3', 'b') /* IPU3 packed 10-bit BGGR bayer */
@@ -752,6 +787,18 @@ struct v4l2_pix_format {
 #define V4L2_PIX_FMT_IPU3_SGRBG10	v4l2_fourcc('i', 'p', '3', 'G') /* IPU3 packed 10-bit GRBG bayer */
 #define V4L2_PIX_FMT_IPU3_SRGGB10	v4l2_fourcc('i', 'p', '3', 'r') /* IPU3 packed 10-bit RGGB bayer */
 
+/* Raspberry Pi PiSP compressed formats. */
+#define V4L2_PIX_FMT_PISP_COMP1_RGGB	v4l2_fourcc('P', 'C', '1', 'R') /* PiSP 8-bit mode 1 compressed RGGB bayer */
+#define V4L2_PIX_FMT_PISP_COMP1_GRBG	v4l2_fourcc('P', 'C', '1', 'G') /* PiSP 8-bit mode 1 compressed GRBG bayer */
+#define V4L2_PIX_FMT_PISP_COMP1_GBRG	v4l2_fourcc('P', 'C', '1', 'g') /* PiSP 8-bit mode 1 compressed GBRG bayer */
+#define V4L2_PIX_FMT_PISP_COMP1_BGGR	v4l2_fourcc('P', 'C', '1', 'B') /* PiSP 8-bit mode 1 compressed BGGR bayer */
+#define V4L2_PIX_FMT_PISP_COMP1_MONO	v4l2_fourcc('P', 'C', '1', 'M') /* PiSP 8-bit mode 1 compressed monochrome */
+#define V4L2_PIX_FMT_PISP_COMP2_RGGB	v4l2_fourcc('P', 'C', '2', 'R') /* PiSP 8-bit mode 2 compressed RGGB bayer */
+#define V4L2_PIX_FMT_PISP_COMP2_GRBG	v4l2_fourcc('P', 'C', '2', 'G') /* PiSP 8-bit mode 2 compressed GRBG bayer */
+#define V4L2_PIX_FMT_PISP_COMP2_GBRG	v4l2_fourcc('P', 'C', '2', 'g') /* PiSP 8-bit mode 2 compressed GBRG bayer */
+#define V4L2_PIX_FMT_PISP_COMP2_BGGR	v4l2_fourcc('P', 'C', '2', 'B') /* PiSP 8-bit mode 2 compressed BGGR bayer */
+#define V4L2_PIX_FMT_PISP_COMP2_MONO	v4l2_fourcc('P', 'C', '2', 'M') /* PiSP 8-bit mode 2 compressed monochrome */
+
 /* SDR formats - used only for Software Defined Radio devices */
 #define V4L2_SDR_FMT_CU8          v4l2_fourcc('C', 'U', '0', '8') /* IQ u8 */
 #define V4L2_SDR_FMT_CU16LE       v4l2_fourcc('C', 'U', '1', '6') /* IQ u16le */
@@ -781,6 +828,15 @@ struct v4l2_pix_format {
 #define V4L2_META_FMT_RK_ISP1_PARAMS	v4l2_fourcc('R', 'K', '1', 'P') /* Rockchip ISP1 3A Parameters */
 #define V4L2_META_FMT_RK_ISP1_STAT_3A	v4l2_fourcc('R', 'K', '1', 'S') /* Rockchip ISP1 3A Statistics */
 
+/* The metadata format identifier for BE configuration buffers. */
+#define V4L2_META_FMT_RPI_BE_CFG v4l2_fourcc('R', 'P', 'B', 'C')
+
+/* The metadata format identifier for FE configuration buffers. */
+#define V4L2_META_FMT_RPI_FE_CFG v4l2_fourcc('R', 'P', 'F', 'C')
+
+/* The metadata format identifier for FE stats buffers. */
+#define V4L2_META_FMT_RPI_FE_STATS v4l2_fourcc('R', 'P', 'F', 'S')
+
 /* priv field value to indicates that subsequent fields are valid. */
 #define V4L2_PIX_FMT_PRIV_MAGIC		0xfeedcafe
 
@@ -1550,7 +1606,8 @@ struct v4l2_bt_timings {
 	((bt)->width + V4L2_DV_BT_BLANKING_WIDTH(bt))
 #define V4L2_DV_BT_BLANKING_HEIGHT(bt) \
 	((bt)->vfrontporch + (bt)->vsync + (bt)->vbackporch + \
-	 (bt)->il_vfrontporch + (bt)->il_vsync + (bt)->il_vbackporch)
+	 ((bt)->interlaced ? \
+	  ((bt)->il_vfrontporch + (bt)->il_vsync + (bt)->il_vbackporch) : 0))
 #define V4L2_DV_BT_FRAME_HEIGHT(bt) \
 	((bt)->height + V4L2_DV_BT_BLANKING_HEIGHT(bt))
 
@@ -1641,7 +1698,7 @@ struct v4l2_input {
 	__u8	     name[32];		/*  Label */
 	__u32	     type;		/*  Type of input */
 	__u32	     audioset;		/*  Associated audios (bitfield) */
-	__u32        tuner;             /*  enum v4l2_tuner_type */
+	__u32        tuner;             /*  Tuner index */
 	v4l2_std_id  std;
 	__u32	     status;
 	__u32	     capabilities;
@@ -1728,6 +1785,8 @@ struct v4l2_ext_control {
 		__u8 *p_u8;
 		__u16 *p_u16;
 		__u32 *p_u32;
+		__s32 *p_s32;
+		__s64 *p_s64;
 		struct v4l2_area *p_area;
 		struct v4l2_ctrl_h264_sps *p_h264_sps;
 		struct v4l2_ctrl_h264_pps *p_h264_pps;
@@ -1742,6 +1801,15 @@ struct v4l2_ext_control {
 		struct v4l2_ctrl_mpeg2_quantisation *p_mpeg2_quantisation;
 		struct v4l2_ctrl_vp9_compressed_hdr *p_vp9_compressed_hdr_probs;
 		struct v4l2_ctrl_vp9_frame *p_vp9_frame;
+		struct v4l2_ctrl_hevc_sps *p_hevc_sps;
+		struct v4l2_ctrl_hevc_pps *p_hevc_pps;
+		struct v4l2_ctrl_hevc_slice_params *p_hevc_slice_params;
+		struct v4l2_ctrl_hevc_scaling_matrix *p_hevc_scaling_matrix;
+		struct v4l2_ctrl_hevc_decode_params *p_hevc_decode_params;
+		struct v4l2_ctrl_av1_sequence *p_av1_sequence;
+		struct v4l2_ctrl_av1_tile_group_entry *p_av1_tile_group_entry;
+		struct v4l2_ctrl_av1_frame *p_av1_frame;
+		struct v4l2_ctrl_av1_film_grain *p_av1_film_grain;
 		void *ptr;
 	};
 } __attribute__ ((packed));
@@ -1805,6 +1873,17 @@ enum v4l2_ctrl_type {
 
 	V4L2_CTRL_TYPE_VP9_COMPRESSED_HDR	= 0x0260,
 	V4L2_CTRL_TYPE_VP9_FRAME		= 0x0261,
+
+	V4L2_CTRL_TYPE_HEVC_SPS			= 0x0270,
+	V4L2_CTRL_TYPE_HEVC_PPS			= 0x0271,
+	V4L2_CTRL_TYPE_HEVC_SLICE_PARAMS	= 0x0272,
+	V4L2_CTRL_TYPE_HEVC_SCALING_MATRIX	= 0x0273,
+	V4L2_CTRL_TYPE_HEVC_DECODE_PARAMS	= 0x0274,
+
+	V4L2_CTRL_TYPE_AV1_SEQUENCE	    = 0x280,
+	V4L2_CTRL_TYPE_AV1_TILE_GROUP_ENTRY = 0x281,
+	V4L2_CTRL_TYPE_AV1_FRAME	    = 0x282,
+	V4L2_CTRL_TYPE_AV1_FILM_GRAIN	    = 0x283,
 };
 
 /*  Used in the VIDIOC_QUERYCTRL ioctl for querying controls */
@@ -1860,6 +1939,7 @@ struct v4l2_querymenu {
 #define V4L2_CTRL_FLAG_HAS_PAYLOAD	0x0100
 #define V4L2_CTRL_FLAG_EXECUTE_ON_WRITE	0x0200
 #define V4L2_CTRL_FLAG_MODIFY_LAYOUT	0x0400
+#define V4L2_CTRL_FLAG_DYNAMIC_ARRAY	0x0800
 
 /*  Query flags, to be ORed with the control ID */
 #define V4L2_CTRL_FLAG_NEXT_CTRL	0x80000000
@@ -2367,6 +2447,7 @@ struct v4l2_event_vsync {
 #define V4L2_EVENT_CTRL_CH_VALUE		(1 << 0)
 #define V4L2_EVENT_CTRL_CH_FLAGS		(1 << 1)
 #define V4L2_EVENT_CTRL_CH_RANGE		(1 << 2)
+#define V4L2_EVENT_CTRL_CH_DIMENSIONS		(1 << 3)
 
 struct v4l2_event_ctrl {
 	__u32 changes;
@@ -2609,5 +2690,10 @@ struct v4l2_create_buffers {
 /* Deprecated definitions kept for backwards compatibility */
 #define V4L2_PIX_FMT_HM12 V4L2_PIX_FMT_NV12_16L16
 #define V4L2_PIX_FMT_SUNXI_TILED_NV12 V4L2_PIX_FMT_NV12_32L32
+/*
+ * This capability was never implemented, anyone using this cap should drop it
+ * from their code.
+ */
+#define V4L2_CAP_ASYNCIO 0x02000000
 
 #endif /* __LINUX_VIDEODEV2_H */
diff -pruN 0.2.0-3/meson.build 0.3.0-1/meson.build
--- 0.2.0-3/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 
 project('libcamera', 'c', 'cpp',
     meson_version : '>= 0.60',
-    version : '0.2.0',
+    version : '0.3.0',
     default_options : [
         'werror=true',
         'warning_level=2',
@@ -82,6 +82,10 @@ if cc.has_header_symbol('locale.h', 'loc
     config_h.set('HAVE_LOCALE_T', 1)
 endif
 
+if cc.has_header_symbol('sys/mman.h', 'memfd_create', prefix : '#define _GNU_SOURCE')
+    config_h.set('HAVE_MEMFD_CREATE', 1)
+endif
+
 if cc.has_header_symbol('stdlib.h', 'secure_getenv', prefix : '#define _GNU_SOURCE')
     config_h.set('HAVE_SECURE_GETENV', 1)
 endif
@@ -198,6 +202,7 @@ arch_x86 = ['x86', 'x86_64']
 pipelines_support = {
     'imx8-isi':     arch_arm,
     'ipu3':         arch_x86,
+    'mali-c55':     arch_arm,
     'rkisp1':       arch_arm,
     'rpi/vc4':      arch_arm,
     'simple':       arch_arm,
diff -pruN 0.2.0-3/meson_options.txt 0.3.0-1/meson_options.txt
--- 0.2.0-3/meson_options.txt	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/meson_options.txt	2024-05-19 15:54:11.000000000 +0000
@@ -20,6 +20,11 @@ option('documentation',
         type : 'feature',
         description : 'Generate the project documentation')
 
+option('doc_werror',
+        type : 'boolean',
+        value : false,
+        description : 'Treat documentation warnings as errors')
+
 option('gstreamer',
         type : 'feature',
         value : 'auto',
@@ -27,7 +32,7 @@ option('gstreamer',
 
 option('ipas',
         type : 'array',
-        choices : ['ipu3', 'rkisp1', 'rpi/vc4', 'vimc'],
+        choices : ['ipu3', 'rkisp1', 'rpi/vc4', 'simple', 'vimc'],
         description : 'Select which IPA modules to build')
 
 option('lc-compliance',
@@ -43,6 +48,7 @@ option('pipelines',
             'auto',
             'imx8-isi',
             'ipu3',
+            'mali-c55',
             'rkisp1',
             'rpi/vc4',
             'simple',
@@ -53,7 +59,7 @@ option('pipelines',
 
 option('pycamera',
         type : 'feature',
-        value : 'disabled',
+        value : 'auto',
         description : 'Enable libcamera Python bindings (experimental)')
 
 option('qcam',
diff -pruN 0.2.0-3/src/android/camera3_hal.cpp 0.3.0-1/src/android/camera3_hal.cpp
--- 0.2.0-3/src/android/camera3_hal.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera3_hal.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera3_hal.cpp - Android Camera HALv3 module
+ * Android Camera HALv3 module
  */
 
 #include <hardware/camera_common.h>
diff -pruN 0.2.0-3/src/android/camera_buffer.h 0.3.0-1/src/android/camera_buffer.h
--- 0.2.0-3/src/android/camera_buffer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_buffer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_buffer.h - Frame buffer handling interface definition
+ * Frame buffer handling interface definition
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_capabilities.cpp 0.3.0-1/src/android/camera_capabilities.cpp
--- 0.2.0-3/src/android/camera_capabilities.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_capabilities.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_capabilities.cpp - Camera static properties manager
+ * Camera static properties manager
  */
 
 #include "camera_capabilities.h"
diff -pruN 0.2.0-3/src/android/camera_capabilities.h 0.3.0-1/src/android/camera_capabilities.h
--- 0.2.0-3/src/android/camera_capabilities.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_capabilities.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_capabilities.h - Camera static properties manager
+ * Camera static properties manager
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_device.cpp 0.3.0-1/src/android/camera_device.cpp
--- 0.2.0-3/src/android/camera_device.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_device.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_device.cpp - libcamera Android Camera Device
+ * libcamera Android Camera Device
  */
 
 #include "camera_device.h"
@@ -433,8 +433,6 @@ void CameraDevice::flush()
 void CameraDevice::stop()
 {
 	MutexLocker stateLock(stateMutex_);
-	if (state_ == State::Stopped)
-		return;
 
 	camera_->stop();
 
@@ -952,8 +950,8 @@ int CameraDevice::processCaptureRequest(
 	 */
 	if (camera3Request->settings)
 		lastSettings_ = camera3Request->settings;
-	else
-		descriptor->settings_ = lastSettings_;
+
+	descriptor->settings_ = lastSettings_;
 
 	LOG(HAL, Debug) << "Queueing request " << descriptor->request_->cookie()
 			<< " with " << descriptor->buffers_.size() << " streams";
@@ -1108,6 +1106,8 @@ int CameraDevice::processCaptureRequest(
 	}
 
 	if (state_ == State::Stopped) {
+		lastSettings_ = {};
+
 		ret = camera_->start();
 		if (ret) {
 			LOG(HAL, Error) << "Failed to start camera";
diff -pruN 0.2.0-3/src/android/camera_device.h 0.3.0-1/src/android/camera_device.h
--- 0.2.0-3/src/android/camera_device.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_device.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_device.h - libcamera Android Camera Device
+ * libcamera Android Camera Device
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_hal_config.cpp 0.3.0-1/src/android/camera_hal_config.cpp
--- 0.2.0-3/src/android/camera_hal_config.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_hal_config.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_hal_config.cpp - Camera HAL configuration file manager
+ * Camera HAL configuration file manager
  */
 #include "camera_hal_config.h"
 
diff -pruN 0.2.0-3/src/android/camera_hal_config.h 0.3.0-1/src/android/camera_hal_config.h
--- 0.2.0-3/src/android/camera_hal_config.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_hal_config.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_hal_config.h - Camera HAL configuration file manager
+ * Camera HAL configuration file manager
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_hal_manager.cpp 0.3.0-1/src/android/camera_hal_manager.cpp
--- 0.2.0-3/src/android/camera_hal_manager.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_hal_manager.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_hal_manager.cpp - libcamera Android Camera Manager
+ * libcamera Android Camera Manager
  */
 
 #include "camera_hal_manager.h"
diff -pruN 0.2.0-3/src/android/camera_hal_manager.h 0.3.0-1/src/android/camera_hal_manager.h
--- 0.2.0-3/src/android/camera_hal_manager.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_hal_manager.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_hal_manager.h - libcamera Android Camera Manager
+ * libcamera Android Camera Manager
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_metadata.cpp 0.3.0-1/src/android/camera_metadata.cpp
--- 0.2.0-3/src/android/camera_metadata.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_metadata.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_metadata.cpp - libcamera Android Camera Metadata Helper
+ * libcamera Android Camera Metadata Helper
  */
 
 #include "camera_metadata.h"
diff -pruN 0.2.0-3/src/android/camera_metadata.h 0.3.0-1/src/android/camera_metadata.h
--- 0.2.0-3/src/android/camera_metadata.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_metadata.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_metadata.h - libcamera Android Camera Metadata Helper
+ * libcamera Android Camera Metadata Helper
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_ops.cpp 0.3.0-1/src/android/camera_ops.cpp
--- 0.2.0-3/src/android/camera_ops.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_ops.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_ops.h - Android Camera HAL Operations
+ * Android Camera HAL Operations
  */
 
 #include "camera_ops.h"
diff -pruN 0.2.0-3/src/android/camera_ops.h 0.3.0-1/src/android/camera_ops.h
--- 0.2.0-3/src/android/camera_ops.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_ops.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_ops.h - Android Camera HAL Operations
+ * Android Camera HAL Operations
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_request.cpp 0.3.0-1/src/android/camera_request.cpp
--- 0.2.0-3/src/android/camera_request.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_request.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Google Inc.
  *
- * camera_request.cpp - libcamera Android Camera Request Descriptor
+ * libcamera Android Camera Request Descriptor
  */
 
 #include "camera_request.h"
diff -pruN 0.2.0-3/src/android/camera_request.h 0.3.0-1/src/android/camera_request.h
--- 0.2.0-3/src/android/camera_request.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_request.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Google Inc.
  *
- * camera_request.h - libcamera Android Camera Request Descriptor
+ * libcamera Android Camera Request Descriptor
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/camera_stream.cpp 0.3.0-1/src/android/camera_stream.cpp
--- 0.2.0-3/src/android/camera_stream.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_stream.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * camera_stream.cpp - Camera HAL stream
+ * Camera HAL stream
  */
 
 #include "camera_stream.h"
diff -pruN 0.2.0-3/src/android/camera_stream.h 0.3.0-1/src/android/camera_stream.h
--- 0.2.0-3/src/android/camera_stream.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/camera_stream.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * camera_stream.h - Camera HAL stream
+ * Camera HAL stream
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/cros/camera3_hal.cpp 0.3.0-1/src/android/cros/camera3_hal.cpp
--- 0.2.0-3/src/android/cros/camera3_hal.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/cros/camera3_hal.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera3_hal.cpp - cros-specific components of Android Camera HALv3 module
+ * cros-specific components of Android Camera HALv3 module
  */
 
 #include <cros-camera/cros_camera_hal.h>
diff -pruN 0.2.0-3/src/android/cros_mojo_token.h 0.3.0-1/src/android/cros_mojo_token.h
--- 0.2.0-3/src/android/cros_mojo_token.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/cros_mojo_token.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * cros_mojo_token.h - cros-specific mojo token
+ * cros-specific mojo token
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/frame_buffer_allocator.h 0.3.0-1/src/android/frame_buffer_allocator.h
--- 0.2.0-3/src/android/frame_buffer_allocator.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/frame_buffer_allocator.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * frame_buffer_allocator.h - Interface definition to allocate Frame buffer in
+ * Interface definition to allocate Frame buffer in
  * platform dependent way.
  */
 #ifndef __ANDROID_FRAME_BUFFER_ALLOCATOR_H__
diff -pruN 0.2.0-3/src/android/hal_framebuffer.cpp 0.3.0-1/src/android/hal_framebuffer.cpp
--- 0.2.0-3/src/android/hal_framebuffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/hal_framebuffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * hal_framebuffer.cpp - HAL Frame Buffer Handling
+ * HAL Frame Buffer Handling
  */
 
 #include "hal_framebuffer.h"
diff -pruN 0.2.0-3/src/android/hal_framebuffer.h 0.3.0-1/src/android/hal_framebuffer.h
--- 0.2.0-3/src/android/hal_framebuffer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/hal_framebuffer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * hal_framebuffer.h - HAL Frame Buffer Handling
+ * HAL Frame Buffer Handling
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/jpeg/encoder.h 0.3.0-1/src/android/jpeg/encoder.h
--- 0.2.0-3/src/android/jpeg/encoder.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/encoder.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * encoder.h - Image encoding interface
+ * Image encoding interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/jpeg/encoder_jea.cpp 0.3.0-1/src/android/jpeg/encoder_jea.cpp
--- 0.2.0-3/src/android/jpeg/encoder_jea.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/encoder_jea.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * encoder_jea.cpp - JPEG encoding using CrOS JEA
+ * JPEG encoding using CrOS JEA
  */
 
 #include "encoder_jea.h"
diff -pruN 0.2.0-3/src/android/jpeg/encoder_jea.h 0.3.0-1/src/android/jpeg/encoder_jea.h
--- 0.2.0-3/src/android/jpeg/encoder_jea.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/encoder_jea.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * encoder_jea.h - JPEG encoding using CrOS JEA
+ * JPEG encoding using CrOS JEA
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/jpeg/encoder_libjpeg.cpp 0.3.0-1/src/android/jpeg/encoder_libjpeg.cpp
--- 0.2.0-3/src/android/jpeg/encoder_libjpeg.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/encoder_libjpeg.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * encoder_libjpeg.cpp - JPEG encoding using libjpeg native API
+ * JPEG encoding using libjpeg native API
  */
 
 #include "encoder_libjpeg.h"
diff -pruN 0.2.0-3/src/android/jpeg/encoder_libjpeg.h 0.3.0-1/src/android/jpeg/encoder_libjpeg.h
--- 0.2.0-3/src/android/jpeg/encoder_libjpeg.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/encoder_libjpeg.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * encoder_libjpeg.h - JPEG encoding using libjpeg
+ * JPEG encoding using libjpeg
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/jpeg/exif.cpp 0.3.0-1/src/android/jpeg/exif.cpp
--- 0.2.0-3/src/android/jpeg/exif.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/exif.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * exif.cpp - EXIF tag creation using libexif
+ * EXIF tag creation using libexif
  */
 
 #include "exif.h"
diff -pruN 0.2.0-3/src/android/jpeg/exif.h 0.3.0-1/src/android/jpeg/exif.h
--- 0.2.0-3/src/android/jpeg/exif.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/exif.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * exif.h - EXIF tag creator using libexif
+ * EXIF tag creator using libexif
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/jpeg/post_processor_jpeg.cpp 0.3.0-1/src/android/jpeg/post_processor_jpeg.cpp
--- 0.2.0-3/src/android/jpeg/post_processor_jpeg.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/post_processor_jpeg.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * post_processor_jpeg.cpp - JPEG Post Processor
+ * JPEG Post Processor
  */
 
 #include "post_processor_jpeg.h"
diff -pruN 0.2.0-3/src/android/jpeg/post_processor_jpeg.h 0.3.0-1/src/android/jpeg/post_processor_jpeg.h
--- 0.2.0-3/src/android/jpeg/post_processor_jpeg.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/post_processor_jpeg.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * post_processor_jpeg.h - JPEG Post Processor
+ * JPEG Post Processor
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/jpeg/thumbnailer.cpp 0.3.0-1/src/android/jpeg/thumbnailer.cpp
--- 0.2.0-3/src/android/jpeg/thumbnailer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/thumbnailer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * thumbnailer.cpp - Simple image thumbnailer
+ * Simple image thumbnailer
  */
 
 #include "thumbnailer.h"
diff -pruN 0.2.0-3/src/android/jpeg/thumbnailer.h 0.3.0-1/src/android/jpeg/thumbnailer.h
--- 0.2.0-3/src/android/jpeg/thumbnailer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/jpeg/thumbnailer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * thumbnailer.h - Simple image thumbnailer
+ * Simple image thumbnailer
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/mm/cros_camera_buffer.cpp 0.3.0-1/src/android/mm/cros_camera_buffer.cpp
--- 0.2.0-3/src/android/mm/cros_camera_buffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/mm/cros_camera_buffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * cros_camera_buffer.cpp - Chromium OS buffer backend using CameraBufferManager
+ * Chromium OS buffer backend using CameraBufferManager
  */
 
 #include "../camera_buffer.h"
diff -pruN 0.2.0-3/src/android/mm/cros_frame_buffer_allocator.cpp 0.3.0-1/src/android/mm/cros_frame_buffer_allocator.cpp
--- 0.2.0-3/src/android/mm/cros_frame_buffer_allocator.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/mm/cros_frame_buffer_allocator.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,8 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * cros_frame_buffer.cpp - Allocate FrameBuffer for Chromium OS using
- * CameraBufferManager
+ * Allocate FrameBuffer for Chromium OS using CameraBufferManager
  */
 
 #include <memory>
diff -pruN 0.2.0-3/src/android/mm/generic_camera_buffer.cpp 0.3.0-1/src/android/mm/generic_camera_buffer.cpp
--- 0.2.0-3/src/android/mm/generic_camera_buffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/mm/generic_camera_buffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * generic_camera_buffer.cpp - Generic Android frame buffer backend
+ * Generic Android frame buffer backend
  */
 
 #include "../camera_buffer.h"
diff -pruN 0.2.0-3/src/android/mm/generic_frame_buffer_allocator.cpp 0.3.0-1/src/android/mm/generic_frame_buffer_allocator.cpp
--- 0.2.0-3/src/android/mm/generic_frame_buffer_allocator.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/mm/generic_frame_buffer_allocator.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * generic_camera_buffer.cpp - Allocate FrameBuffer using gralloc API
+ * Allocate FrameBuffer using gralloc API
  */
 
 #include <dlfcn.h>
diff -pruN 0.2.0-3/src/android/mm/libhardware_stub.c 0.3.0-1/src/android/mm/libhardware_stub.c
--- 0.2.0-3/src/android/mm/libhardware_stub.c	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/mm/libhardware_stub.c	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Ideas on Board
  *
- * libhardware_stub.c - Android libhardware stub for test compilation
+ * Android libhardware stub for test compilation
  */
 
 #include <errno.h>
diff -pruN 0.2.0-3/src/android/post_processor.h 0.3.0-1/src/android/post_processor.h
--- 0.2.0-3/src/android/post_processor.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/post_processor.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * post_processor.h - CameraStream Post Processing Interface
+ * CameraStream Post Processing Interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/android/yuv/post_processor_yuv.cpp 0.3.0-1/src/android/yuv/post_processor_yuv.cpp
--- 0.2.0-3/src/android/yuv/post_processor_yuv.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/yuv/post_processor_yuv.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * post_processor_yuv.cpp - Post Processor using libyuv
+ * Post Processor using libyuv
  */
 
 #include "post_processor_yuv.h"
diff -pruN 0.2.0-3/src/android/yuv/post_processor_yuv.h 0.3.0-1/src/android/yuv/post_processor_yuv.h
--- 0.2.0-3/src/android/yuv/post_processor_yuv.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/android/yuv/post_processor_yuv.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * post_processor_yuv.h - Post Processor using libyuv
+ * Post Processor using libyuv
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/camera_session.cpp 0.3.0-1/src/apps/cam/camera_session.cpp
--- 0.2.0-3/src/apps/cam/camera_session.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/camera_session.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_session.cpp - Camera capture session
+ * Camera capture session
  */
 
 #include <iomanip>
@@ -377,7 +377,7 @@ void CameraSession::requestComplete(Requ
 	 * Defer processing of the completed request to the event loop, to avoid
 	 * blocking the camera manager thread.
 	 */
-	EventLoop::instance()->callLater([=]() { processRequest(request); });
+	EventLoop::instance()->callLater([this, request]() { processRequest(request); });
 }
 
 void CameraSession::processRequest(Request *request)
diff -pruN 0.2.0-3/src/apps/cam/camera_session.h 0.3.0-1/src/apps/cam/camera_session.h
--- 0.2.0-3/src/apps/cam/camera_session.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/camera_session.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_session.h - Camera capture session
+ * Camera capture session
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/capture_script.cpp 0.3.0-1/src/apps/cam/capture_script.cpp
--- 0.2.0-3/src/apps/cam/capture_script.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/capture_script.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * capture_script.cpp - Capture session configuration script
+ * Capture session configuration script
  */
 
 #include "capture_script.h"
@@ -351,7 +351,10 @@ ControlValue CaptureScript::parseRectang
 	}
 
 	ControlValue controlValue;
-	controlValue.set(Span<const Rectangle>(rectangles));
+	if (rectangles.size() == 1)
+		controlValue.set(rectangles.at(0));
+	else
+		controlValue.set(Span<const Rectangle>(rectangles));
 
 	return controlValue;
 }
diff -pruN 0.2.0-3/src/apps/cam/capture_script.h 0.3.0-1/src/apps/cam/capture_script.h
--- 0.2.0-3/src/apps/cam/capture_script.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/capture_script.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * capture_script.h - Capture session configuration script
+ * Capture session configuration script
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/drm.cpp 0.3.0-1/src/apps/cam/drm.cpp
--- 0.2.0-3/src/apps/cam/drm.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/drm.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * drm.cpp - DRM/KMS Helpers
+ * DRM/KMS Helpers
  */
 
 #include "drm.h"
diff -pruN 0.2.0-3/src/apps/cam/drm.h 0.3.0-1/src/apps/cam/drm.h
--- 0.2.0-3/src/apps/cam/drm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/drm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * drm.h - DRM/KMS Helpers
+ * DRM/KMS Helpers
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/file_sink.cpp 0.3.0-1/src/apps/cam/file_sink.cpp
--- 0.2.0-3/src/apps/cam/file_sink.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/file_sink.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * file_sink.cpp - File Sink
+ * File Sink
  */
 
 #include <assert.h>
@@ -17,6 +17,7 @@
 
 #include "../common/dng_writer.h"
 #include "../common/image.h"
+#include "../common/ppm_writer.h"
 
 #include "file_sink.h"
 
@@ -76,6 +77,7 @@ void FileSink::writeBuffer(const Stream
 #ifdef HAVE_TIFF
 	bool dng = filename.find(".dng", filename.size() - 4) != std::string::npos;
 #endif /* HAVE_TIFF */
+	bool ppm = filename.find(".ppm", filename.size() - 4) != std::string::npos;
 
 	if (filename.empty() || filename.back() == '/')
 		filename += "frame-#.bin";
@@ -102,6 +104,15 @@ void FileSink::writeBuffer(const Stream
 		return;
 	}
 #endif /* HAVE_TIFF */
+	if (ppm) {
+		ret = PPMWriter::write(filename.c_str(), stream->configuration(),
+				       image->data(0));
+		if (ret < 0)
+			std::cerr << "failed to write PPM file `" << filename
+				  << "'" << std::endl;
+
+		return;
+	}
 
 	fd = open(filename.c_str(), O_CREAT | O_WRONLY |
 		  (pos == std::string::npos ? O_APPEND : O_TRUNC),
diff -pruN 0.2.0-3/src/apps/cam/file_sink.h 0.3.0-1/src/apps/cam/file_sink.h
--- 0.2.0-3/src/apps/cam/file_sink.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/file_sink.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * file_sink.h - File Sink
+ * File Sink
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/frame_sink.cpp 0.3.0-1/src/apps/cam/frame_sink.cpp
--- 0.2.0-3/src/apps/cam/frame_sink.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/frame_sink.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * frame_sink.cpp - Base Frame Sink Class
+ * Base Frame Sink Class
  */
 
 #include "frame_sink.h"
diff -pruN 0.2.0-3/src/apps/cam/frame_sink.h 0.3.0-1/src/apps/cam/frame_sink.h
--- 0.2.0-3/src/apps/cam/frame_sink.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/frame_sink.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * frame_sink.h - Base Frame Sink Class
+ * Base Frame Sink Class
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/kms_sink.cpp 0.3.0-1/src/apps/cam/kms_sink.cpp
--- 0.2.0-3/src/apps/cam/kms_sink.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/kms_sink.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * kms_sink.cpp - KMS Sink
+ * KMS Sink
  */
 
 #include "kms_sink.h"
diff -pruN 0.2.0-3/src/apps/cam/kms_sink.h 0.3.0-1/src/apps/cam/kms_sink.h
--- 0.2.0-3/src/apps/cam/kms_sink.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/kms_sink.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * kms_sink.h - KMS Sink
+ * KMS Sink
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/main.cpp 0.3.0-1/src/apps/cam/main.cpp
--- 0.2.0-3/src/apps/cam/main.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/main.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * main.cpp - cam - The libcamera swiss army knife
+ * cam - The libcamera swiss army knife
  */
 
 #include <atomic>
@@ -154,6 +154,8 @@ int CamApp::parseOptions(int argc, char
 			 "If the file name ends with '.dng', then the frame will be written to\n"
 			 "the output file(s) in DNG format.\n"
 #endif
+			 "If the file name ends with '.ppm', then the frame will be written to\n"
+			 "the output file(s) in PPM format.\n"
 			 "The default file name is 'frame-#.bin'.",
 			 "file", ArgumentOptional, "filename", false,
 			 OptCamera);
diff -pruN 0.2.0-3/src/apps/cam/main.h 0.3.0-1/src/apps/cam/main.h
--- 0.2.0-3/src/apps/cam/main.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/main.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * main.h - Cam application
+ * Cam application
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/sdl_sink.cpp 0.3.0-1/src/apps/cam/sdl_sink.cpp
--- 0.2.0-3/src/apps/cam/sdl_sink.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_sink.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_sink.h - SDL Sink
+ * SDL Sink
  */
 
 #include "sdl_sink.h"
diff -pruN 0.2.0-3/src/apps/cam/sdl_sink.h 0.3.0-1/src/apps/cam/sdl_sink.h
--- 0.2.0-3/src/apps/cam/sdl_sink.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_sink.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_sink.h - SDL Sink
+ * SDL Sink
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/sdl_texture.cpp 0.3.0-1/src/apps/cam/sdl_texture.cpp
--- 0.2.0-3/src/apps/cam/sdl_texture.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_texture.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_texture.cpp - SDL Texture
+ * SDL Texture
  */
 
 #include "sdl_texture.h"
diff -pruN 0.2.0-3/src/apps/cam/sdl_texture.h 0.3.0-1/src/apps/cam/sdl_texture.h
--- 0.2.0-3/src/apps/cam/sdl_texture.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_texture.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_texture.h - SDL Texture
+ * SDL Texture
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/sdl_texture_mjpg.cpp 0.3.0-1/src/apps/cam/sdl_texture_mjpg.cpp
--- 0.2.0-3/src/apps/cam/sdl_texture_mjpg.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_texture_mjpg.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_texture_mjpg.cpp - SDL Texture MJPG
+ * SDL Texture MJPG
  */
 
 #include "sdl_texture_mjpg.h"
diff -pruN 0.2.0-3/src/apps/cam/sdl_texture_mjpg.h 0.3.0-1/src/apps/cam/sdl_texture_mjpg.h
--- 0.2.0-3/src/apps/cam/sdl_texture_mjpg.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_texture_mjpg.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_texture_mjpg.h - SDL Texture MJPG
+ * SDL Texture MJPG
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/cam/sdl_texture_yuv.cpp 0.3.0-1/src/apps/cam/sdl_texture_yuv.cpp
--- 0.2.0-3/src/apps/cam/sdl_texture_yuv.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_texture_yuv.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_texture_yuv.cpp - SDL YUV Textures
+ * SDL YUV Textures
  */
 
 #include "sdl_texture_yuv.h"
diff -pruN 0.2.0-3/src/apps/cam/sdl_texture_yuv.h 0.3.0-1/src/apps/cam/sdl_texture_yuv.h
--- 0.2.0-3/src/apps/cam/sdl_texture_yuv.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/cam/sdl_texture_yuv.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy
  *
- * sdl_texture_yuv.h - SDL YUV Textures
+ * SDL YUV Textures
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/common/dng_writer.cpp 0.3.0-1/src/apps/common/dng_writer.cpp
--- 0.2.0-3/src/apps/common/dng_writer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/dng_writer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * dng_writer.cpp - DNG writer
+ * DNG writer
  */
 
 #include "dng_writer.h"
@@ -248,6 +248,7 @@ void thumbScanlineIPU3([[maybe_unused]]
 
 		uint16_t val1, val2, val3, val4;
 		switch (pixelInBlock % 4) {
+		default:
 		case 0:
 			val1 = (in[1] & 0x03) << 14 | (in[0] & 0xff) << 6;
 			val2 = (in[2] & 0x0f) << 12 | (in[1] & 0xfc) << 4;
diff -pruN 0.2.0-3/src/apps/common/dng_writer.h 0.3.0-1/src/apps/common/dng_writer.h
--- 0.2.0-3/src/apps/common/dng_writer.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/dng_writer.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * dng_writer.h - DNG writer
+ * DNG writer
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/common/event_loop.cpp 0.3.0-1/src/apps/common/event_loop.cpp
--- 0.2.0-3/src/apps/common/event_loop.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/event_loop.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_loop.cpp - cam - Event loop
+ * cam - Event loop
  */
 
 #include "event_loop.h"
diff -pruN 0.2.0-3/src/apps/common/event_loop.h 0.3.0-1/src/apps/common/event_loop.h
--- 0.2.0-3/src/apps/common/event_loop.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/event_loop.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_loop.h - cam - Event loop
+ * cam - Event loop
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/common/image.cpp 0.3.0-1/src/apps/common/image.cpp
--- 0.2.0-3/src/apps/common/image.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/image.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * image.cpp - Multi-planar image with access to pixel data
+ * Multi-planar image with access to pixel data
  */
 
 #include "image.h"
diff -pruN 0.2.0-3/src/apps/common/image.h 0.3.0-1/src/apps/common/image.h
--- 0.2.0-3/src/apps/common/image.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/image.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * image.h - Multi-planar image with access to pixel data
+ * Multi-planar image with access to pixel data
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/common/meson.build 0.3.0-1/src/apps/common/meson.build
--- 0.2.0-3/src/apps/common/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -3,6 +3,7 @@
 apps_sources = files([
     'image.cpp',
     'options.cpp',
+    'ppm_writer.cpp',
     'stream_options.cpp',
 ])
 
diff -pruN 0.2.0-3/src/apps/common/options.cpp 0.3.0-1/src/apps/common/options.cpp
--- 0.2.0-3/src/apps/common/options.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/options.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * options.cpp - cam - Options parsing
+ * cam - Options parsing
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/apps/common/options.h 0.3.0-1/src/apps/common/options.h
--- 0.2.0-3/src/apps/common/options.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/options.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * options.h - cam - Options parsing
+ * cam - Options parsing
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/common/ppm_writer.cpp 0.3.0-1/src/apps/common/ppm_writer.cpp
--- 0.2.0-3/src/apps/common/ppm_writer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/apps/common/ppm_writer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,53 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024 Red Hat, Inc.
+ *
+ * PPM writer
+ */
+
+#include "ppm_writer.h"
+
+#include <fstream>
+#include <iostream>
+
+#include <libcamera/formats.h>
+#include <libcamera/pixel_format.h>
+
+using namespace libcamera;
+
+int PPMWriter::write(const char *filename,
+		     const StreamConfiguration &config,
+		     const Span<uint8_t> &data)
+{
+	if (config.pixelFormat != formats::BGR888) {
+		std::cerr << "Only BGR888 output pixel format is supported ("
+			  << config.pixelFormat << " requested)" << std::endl;
+		return -EINVAL;
+	}
+
+	std::ofstream output(filename, std::ios::binary);
+	if (!output) {
+		std::cerr << "Failed to open ppm file: " << filename << std::endl;
+		return -EINVAL;
+	}
+
+	output << "P6" << std::endl
+	       << config.size.width << " " << config.size.height << std::endl
+	       << "255" << std::endl;
+	if (!output) {
+		std::cerr << "Failed to write the file header" << std::endl;
+		return -EINVAL;
+	}
+
+	const unsigned int rowLength = config.size.width * 3;
+	const char *row = reinterpret_cast<const char *>(data.data());
+	for (unsigned int y = 0; y < config.size.height; y++, row += config.stride) {
+		output.write(row, rowLength);
+		if (!output) {
+			std::cerr << "Failed to write image data at row " << y << std::endl;
+			return -EINVAL;
+		}
+	}
+
+	return 0;
+}
diff -pruN 0.2.0-3/src/apps/common/ppm_writer.h 0.3.0-1/src/apps/common/ppm_writer.h
--- 0.2.0-3/src/apps/common/ppm_writer.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/apps/common/ppm_writer.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,20 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024, Red Hat, Inc.
+ *
+ * PPM writer
+ */
+
+#pragma once
+
+#include <libcamera/base/span.h>
+
+#include <libcamera/stream.h>
+
+class PPMWriter
+{
+public:
+	static int write(const char *filename,
+			 const libcamera::StreamConfiguration &config,
+			 const libcamera::Span<uint8_t> &data);
+};
diff -pruN 0.2.0-3/src/apps/common/stream_options.cpp 0.3.0-1/src/apps/common/stream_options.cpp
--- 0.2.0-3/src/apps/common/stream_options.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/stream_options.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * stream_options.cpp - Helper to parse options for streams
+ * Helper to parse options for streams
  */
 #include "stream_options.h"
 
diff -pruN 0.2.0-3/src/apps/common/stream_options.h 0.3.0-1/src/apps/common/stream_options.h
--- 0.2.0-3/src/apps/common/stream_options.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/common/stream_options.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * stream_options.h - Helper to parse options for streams
+ * Helper to parse options for streams
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/ipa-verify/main.cpp 0.3.0-1/src/apps/ipa-verify/main.cpp
--- 0.2.0-3/src/apps/ipa-verify/main.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/ipa-verify/main.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Ideas on Board Oy
  *
- * ipa_verify.cpp - Verify signature on an IPA module
+ * Verify signature on an IPA module
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/src/apps/lc-compliance/capture_test.cpp 0.3.0-1/src/apps/lc-compliance/capture_test.cpp
--- 0.2.0-3/src/apps/lc-compliance/capture_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/capture_test.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,135 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
-/*
- * Copyright (C) 2020, Google Inc.
- * Copyright (C) 2021, Collabora Ltd.
- *
- * capture_test.cpp - Test camera capture
- */
-
-#include <iostream>
-
-#include <gtest/gtest.h>
-
-#include "environment.h"
-#include "simple_capture.h"
-
-using namespace libcamera;
-
-const std::vector<int> NUMREQUESTS = { 1, 2, 3, 5, 8, 13, 21, 34, 55, 89 };
-const std::vector<StreamRole> ROLES = {
-	StreamRole::Raw,
-	StreamRole::StillCapture,
-	StreamRole::VideoRecording,
-	StreamRole::Viewfinder
-};
-
-class SingleStream : public testing::TestWithParam<std::tuple<StreamRole, int>>
-{
-public:
-	static std::string nameParameters(const testing::TestParamInfo<SingleStream::ParamType> &info);
-
-protected:
-	void SetUp() override;
-	void TearDown() override;
-
-	std::shared_ptr<Camera> camera_;
-};
-
-/*
- * We use gtest's SetUp() and TearDown() instead of constructor and destructor
- * in order to be able to assert on them.
- */
-void SingleStream::SetUp()
-{
-	Environment *env = Environment::get();
-
-	camera_ = env->cm()->get(env->cameraId());
-
-	ASSERT_EQ(camera_->acquire(), 0);
-}
-
-void SingleStream::TearDown()
-{
-	if (!camera_)
-		return;
-
-	camera_->release();
-	camera_.reset();
-}
-
-std::string SingleStream::nameParameters(const testing::TestParamInfo<SingleStream::ParamType> &info)
-{
-	std::map<StreamRole, std::string> rolesMap = {
-		{ StreamRole::Raw, "Raw" },
-		{ StreamRole::StillCapture, "StillCapture" },
-		{ StreamRole::VideoRecording, "VideoRecording" },
-		{ StreamRole::Viewfinder, "Viewfinder" }
-	};
-
-	std::string roleName = rolesMap[std::get<0>(info.param)];
-	std::string numRequestsName = std::to_string(std::get<1>(info.param));
-
-	return roleName + "_" + numRequestsName;
-}
-
-/*
- * Test single capture cycles
- *
- * Makes sure the camera completes the exact number of requests queued. Example
- * failure is a camera that completes less requests than the number of requests
- * queued.
- */
-TEST_P(SingleStream, Capture)
-{
-	auto [role, numRequests] = GetParam();
-
-	SimpleCaptureBalanced capture(camera_);
-
-	capture.configure(role);
-
-	capture.capture(numRequests);
-}
-
-/*
- * Test multiple start/stop cycles
- *
- * Makes sure the camera supports multiple start/stop cycles. Example failure is
- * a camera that does not clean up correctly in its error path but is only
- * tested by single-capture applications.
- */
-TEST_P(SingleStream, CaptureStartStop)
-{
-	auto [role, numRequests] = GetParam();
-	unsigned int numRepeats = 3;
-
-	SimpleCaptureBalanced capture(camera_);
-
-	capture.configure(role);
-
-	for (unsigned int starts = 0; starts < numRepeats; starts++)
-		capture.capture(numRequests);
-}
-
-/*
- * Test unbalanced stop
- *
- * Makes sure the camera supports a stop with requests queued. Example failure
- * is a camera that does not handle cancelation of buffers coming back from the
- * video device while stopping.
- */
-TEST_P(SingleStream, UnbalancedStop)
-{
-	auto [role, numRequests] = GetParam();
-
-	SimpleCaptureUnbalanced capture(camera_);
-
-	capture.configure(role);
-
-	capture.capture(numRequests);
-}
-
-INSTANTIATE_TEST_SUITE_P(CaptureTests,
-			 SingleStream,
-			 testing::Combine(testing::ValuesIn(ROLES),
-					  testing::ValuesIn(NUMREQUESTS)),
-			 SingleStream::nameParameters);
diff -pruN 0.2.0-3/src/apps/lc-compliance/environment.cpp 0.3.0-1/src/apps/lc-compliance/environment.cpp
--- 0.2.0-3/src/apps/lc-compliance/environment.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/environment.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Collabora Ltd.
  *
- * environment.cpp - Common environment for tests
+ * Common environment for tests
  */
 
 #include "environment.h"
diff -pruN 0.2.0-3/src/apps/lc-compliance/environment.h 0.3.0-1/src/apps/lc-compliance/environment.h
--- 0.2.0-3/src/apps/lc-compliance/environment.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/environment.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Collabora Ltd.
  *
- * environment.h - Common environment for tests
+ * Common environment for tests
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/lc-compliance/helpers/capture.cpp 0.3.0-1/src/apps/lc-compliance/helpers/capture.cpp
--- 0.2.0-3/src/apps/lc-compliance/helpers/capture.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/helpers/capture.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,196 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+/*
+ * Copyright (C) 2020-2021, Google Inc.
+ *
+ * Simple capture helper
+ */
+
+#include "capture.h"
+
+#include <gtest/gtest.h>
+
+using namespace libcamera;
+
+Capture::Capture(std::shared_ptr<Camera> camera)
+	: loop_(nullptr), camera_(camera),
+	  allocator_(std::make_unique<FrameBufferAllocator>(camera))
+{
+}
+
+Capture::~Capture()
+{
+	stop();
+}
+
+void Capture::configure(StreamRole role)
+{
+	config_ = camera_->generateConfiguration({ role });
+
+	if (!config_) {
+		std::cout << "Role not supported by camera" << std::endl;
+		GTEST_SKIP();
+	}
+
+	if (config_->validate() != CameraConfiguration::Valid) {
+		config_.reset();
+		FAIL() << "Configuration not valid";
+	}
+
+	if (camera_->configure(config_.get())) {
+		config_.reset();
+		FAIL() << "Failed to configure camera";
+	}
+}
+
+void Capture::start()
+{
+	Stream *stream = config_->at(0).stream();
+	int count = allocator_->allocate(stream);
+
+	ASSERT_GE(count, 0) << "Failed to allocate buffers";
+	EXPECT_EQ(count, config_->at(0).bufferCount) << "Allocated less buffers than expected";
+
+	camera_->requestCompleted.connect(this, &Capture::requestComplete);
+
+	ASSERT_EQ(camera_->start(), 0) << "Failed to start camera";
+}
+
+void Capture::stop()
+{
+	if (!config_ || !allocator_->allocated())
+		return;
+
+	camera_->stop();
+
+	camera_->requestCompleted.disconnect(this);
+
+	Stream *stream = config_->at(0).stream();
+	requests_.clear();
+	allocator_->free(stream);
+}
+
+/* CaptureBalanced */
+
+CaptureBalanced::CaptureBalanced(std::shared_ptr<Camera> camera)
+	: Capture(camera)
+{
+}
+
+void CaptureBalanced::capture(unsigned int numRequests)
+{
+	start();
+
+	Stream *stream = config_->at(0).stream();
+	const std::vector<std::unique_ptr<FrameBuffer>> &buffers = allocator_->buffers(stream);
+
+	/* No point in testing less requests then the camera depth. */
+	if (buffers.size() > numRequests) {
+		std::cout << "Camera needs " + std::to_string(buffers.size())
+			+ " requests, can't test only "
+			+ std::to_string(numRequests) << std::endl;
+		GTEST_SKIP();
+	}
+
+	queueCount_ = 0;
+	captureCount_ = 0;
+	captureLimit_ = numRequests;
+
+	/* Queue the recommended number of requests. */
+	for (const std::unique_ptr<FrameBuffer> &buffer : buffers) {
+		std::unique_ptr<Request> request = camera_->createRequest();
+		ASSERT_TRUE(request) << "Can't create request";
+
+		ASSERT_EQ(request->addBuffer(stream, buffer.get()), 0) << "Can't set buffer for request";
+
+		ASSERT_EQ(queueRequest(request.get()), 0) << "Failed to queue request";
+
+		requests_.push_back(std::move(request));
+	}
+
+	/* Run capture session. */
+	loop_ = new EventLoop();
+	loop_->exec();
+	stop();
+	delete loop_;
+
+	ASSERT_EQ(captureCount_, captureLimit_);
+}
+
+int CaptureBalanced::queueRequest(Request *request)
+{
+	queueCount_++;
+	if (queueCount_ > captureLimit_)
+		return 0;
+
+	return camera_->queueRequest(request);
+}
+
+void CaptureBalanced::requestComplete(Request *request)
+{
+	EXPECT_EQ(request->status(), Request::Status::RequestComplete)
+		<< "Request didn't complete successfully";
+
+	captureCount_++;
+	if (captureCount_ >= captureLimit_) {
+		loop_->exit(0);
+		return;
+	}
+
+	request->reuse(Request::ReuseBuffers);
+	if (queueRequest(request))
+		loop_->exit(-EINVAL);
+}
+
+/* CaptureUnbalanced */
+
+CaptureUnbalanced::CaptureUnbalanced(std::shared_ptr<Camera> camera)
+	: Capture(camera)
+{
+}
+
+void CaptureUnbalanced::capture(unsigned int numRequests)
+{
+	start();
+
+	Stream *stream = config_->at(0).stream();
+	const std::vector<std::unique_ptr<FrameBuffer>> &buffers = allocator_->buffers(stream);
+
+	captureCount_ = 0;
+	captureLimit_ = numRequests;
+
+	/* Queue the recommended number of requests. */
+	for (const std::unique_ptr<FrameBuffer> &buffer : buffers) {
+		std::unique_ptr<Request> request = camera_->createRequest();
+		ASSERT_TRUE(request) << "Can't create request";
+
+		ASSERT_EQ(request->addBuffer(stream, buffer.get()), 0) << "Can't set buffer for request";
+
+		ASSERT_EQ(camera_->queueRequest(request.get()), 0) << "Failed to queue request";
+
+		requests_.push_back(std::move(request));
+	}
+
+	/* Run capture session. */
+	loop_ = new EventLoop();
+	int status = loop_->exec();
+	stop();
+	delete loop_;
+
+	ASSERT_EQ(status, 0);
+}
+
+void CaptureUnbalanced::requestComplete(Request *request)
+{
+	captureCount_++;
+	if (captureCount_ >= captureLimit_) {
+		loop_->exit(0);
+		return;
+	}
+
+	EXPECT_EQ(request->status(), Request::Status::RequestComplete)
+		<< "Request didn't complete successfully";
+
+	request->reuse(Request::ReuseBuffers);
+	if (camera_->queueRequest(request))
+		loop_->exit(-EINVAL);
+}
diff -pruN 0.2.0-3/src/apps/lc-compliance/helpers/capture.h 0.3.0-1/src/apps/lc-compliance/helpers/capture.h
--- 0.2.0-3/src/apps/lc-compliance/helpers/capture.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/helpers/capture.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,66 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+/*
+ * Copyright (C) 2020-2021, Google Inc.
+ *
+ * Simple capture helper
+ */
+
+#pragma once
+
+#include <memory>
+
+#include <libcamera/libcamera.h>
+
+#include "../common/event_loop.h"
+
+class Capture
+{
+public:
+	void configure(libcamera::StreamRole role);
+
+protected:
+	Capture(std::shared_ptr<libcamera::Camera> camera);
+	virtual ~Capture();
+
+	void start();
+	void stop();
+
+	virtual void requestComplete(libcamera::Request *request) = 0;
+
+	EventLoop *loop_;
+
+	std::shared_ptr<libcamera::Camera> camera_;
+	std::unique_ptr<libcamera::FrameBufferAllocator> allocator_;
+	std::unique_ptr<libcamera::CameraConfiguration> config_;
+	std::vector<std::unique_ptr<libcamera::Request>> requests_;
+};
+
+class CaptureBalanced : public Capture
+{
+public:
+	CaptureBalanced(std::shared_ptr<libcamera::Camera> camera);
+
+	void capture(unsigned int numRequests);
+
+private:
+	int queueRequest(libcamera::Request *request);
+	void requestComplete(libcamera::Request *request) override;
+
+	unsigned int queueCount_;
+	unsigned int captureCount_;
+	unsigned int captureLimit_;
+};
+
+class CaptureUnbalanced : public Capture
+{
+public:
+	CaptureUnbalanced(std::shared_ptr<libcamera::Camera> camera);
+
+	void capture(unsigned int numRequests);
+
+private:
+	void requestComplete(libcamera::Request *request) override;
+
+	unsigned int captureCount_;
+	unsigned int captureLimit_;
+};
diff -pruN 0.2.0-3/src/apps/lc-compliance/main.cpp 0.3.0-1/src/apps/lc-compliance/main.cpp
--- 0.2.0-3/src/apps/lc-compliance/main.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/main.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Google Inc.
  * Copyright (C) 2021, Collabora Ltd.
  *
- * main.cpp - lc-compliance - The libcamera compliance tool
+ * lc-compliance - The libcamera compliance tool
  */
 
 #include <iomanip>
diff -pruN 0.2.0-3/src/apps/lc-compliance/meson.build 0.3.0-1/src/apps/lc-compliance/meson.build
--- 0.2.0-3/src/apps/lc-compliance/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -12,10 +12,15 @@ endif
 lc_compliance_enabled = true
 
 lc_compliance_sources = files([
-    'capture_test.cpp',
     'environment.cpp',
+    'helpers/capture.cpp',
     'main.cpp',
-    'simple_capture.cpp',
+    'tests/capture_test.cpp',
+])
+
+lc_compliance_includes = ([
+    include_directories('.'),
+    include_directories('helpers/')
 ])
 
 lc_compliance  = executable('lc-compliance', lc_compliance_sources,
@@ -27,5 +32,6 @@ lc_compliance  = executable('lc-complian
                                 libevent,
                                 libgtest,
                             ],
+                            include_directories : lc_compliance_includes,
                             install : true,
                             install_tag : 'bin-devel')
diff -pruN 0.2.0-3/src/apps/lc-compliance/simple_capture.cpp 0.3.0-1/src/apps/lc-compliance/simple_capture.cpp
--- 0.2.0-3/src/apps/lc-compliance/simple_capture.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/simple_capture.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,190 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
-/*
- * Copyright (C) 2020-2021, Google Inc.
- *
- * simple_capture.cpp - Simple capture helper
- */
-
-#include <gtest/gtest.h>
-
-#include "simple_capture.h"
-
-using namespace libcamera;
-
-SimpleCapture::SimpleCapture(std::shared_ptr<Camera> camera)
-	: loop_(nullptr), camera_(camera),
-	  allocator_(std::make_unique<FrameBufferAllocator>(camera))
-{
-}
-
-SimpleCapture::~SimpleCapture()
-{
-	stop();
-}
-
-void SimpleCapture::configure(StreamRole role)
-{
-	config_ = camera_->generateConfiguration({ role });
-
-	if (!config_) {
-		std::cout << "Role not supported by camera" << std::endl;
-		GTEST_SKIP();
-	}
-
-	if (config_->validate() != CameraConfiguration::Valid) {
-		config_.reset();
-		FAIL() << "Configuration not valid";
-	}
-
-	if (camera_->configure(config_.get())) {
-		config_.reset();
-		FAIL() << "Failed to configure camera";
-	}
-}
-
-void SimpleCapture::start()
-{
-	Stream *stream = config_->at(0).stream();
-	int count = allocator_->allocate(stream);
-
-	ASSERT_GE(count, 0) << "Failed to allocate buffers";
-	EXPECT_EQ(count, config_->at(0).bufferCount) << "Allocated less buffers than expected";
-
-	camera_->requestCompleted.connect(this, &SimpleCapture::requestComplete);
-
-	ASSERT_EQ(camera_->start(), 0) << "Failed to start camera";
-}
-
-void SimpleCapture::stop()
-{
-	if (!config_ || !allocator_->allocated())
-		return;
-
-	camera_->stop();
-
-	camera_->requestCompleted.disconnect(this);
-
-	Stream *stream = config_->at(0).stream();
-	requests_.clear();
-	allocator_->free(stream);
-}
-
-/* SimpleCaptureBalanced */
-
-SimpleCaptureBalanced::SimpleCaptureBalanced(std::shared_ptr<Camera> camera)
-	: SimpleCapture(camera)
-{
-}
-
-void SimpleCaptureBalanced::capture(unsigned int numRequests)
-{
-	start();
-
-	Stream *stream = config_->at(0).stream();
-	const std::vector<std::unique_ptr<FrameBuffer>> &buffers = allocator_->buffers(stream);
-
-	/* No point in testing less requests then the camera depth. */
-	if (buffers.size() > numRequests) {
-		std::cout << "Camera needs " + std::to_string(buffers.size())
-			+ " requests, can't test only "
-			+ std::to_string(numRequests) << std::endl;
-		GTEST_SKIP();
-	}
-
-	queueCount_ = 0;
-	captureCount_ = 0;
-	captureLimit_ = numRequests;
-
-	/* Queue the recommended number of reqeuests. */
-	for (const std::unique_ptr<FrameBuffer> &buffer : buffers) {
-		std::unique_ptr<Request> request = camera_->createRequest();
-		ASSERT_TRUE(request) << "Can't create request";
-
-		ASSERT_EQ(request->addBuffer(stream, buffer.get()), 0) << "Can't set buffer for request";
-
-		ASSERT_EQ(queueRequest(request.get()), 0) << "Failed to queue request";
-
-		requests_.push_back(std::move(request));
-	}
-
-	/* Run capture session. */
-	loop_ = new EventLoop();
-	loop_->exec();
-	stop();
-	delete loop_;
-
-	ASSERT_EQ(captureCount_, captureLimit_);
-}
-
-int SimpleCaptureBalanced::queueRequest(Request *request)
-{
-	queueCount_++;
-	if (queueCount_ > captureLimit_)
-		return 0;
-
-	return camera_->queueRequest(request);
-}
-
-void SimpleCaptureBalanced::requestComplete(Request *request)
-{
-	captureCount_++;
-	if (captureCount_ >= captureLimit_) {
-		loop_->exit(0);
-		return;
-	}
-
-	request->reuse(Request::ReuseBuffers);
-	if (queueRequest(request))
-		loop_->exit(-EINVAL);
-}
-
-/* SimpleCaptureUnbalanced */
-
-SimpleCaptureUnbalanced::SimpleCaptureUnbalanced(std::shared_ptr<Camera> camera)
-	: SimpleCapture(camera)
-{
-}
-
-void SimpleCaptureUnbalanced::capture(unsigned int numRequests)
-{
-	start();
-
-	Stream *stream = config_->at(0).stream();
-	const std::vector<std::unique_ptr<FrameBuffer>> &buffers = allocator_->buffers(stream);
-
-	captureCount_ = 0;
-	captureLimit_ = numRequests;
-
-	/* Queue the recommended number of reqeuests. */
-	for (const std::unique_ptr<FrameBuffer> &buffer : buffers) {
-		std::unique_ptr<Request> request = camera_->createRequest();
-		ASSERT_TRUE(request) << "Can't create request";
-
-		ASSERT_EQ(request->addBuffer(stream, buffer.get()), 0) << "Can't set buffer for request";
-
-		ASSERT_EQ(camera_->queueRequest(request.get()), 0) << "Failed to queue request";
-
-		requests_.push_back(std::move(request));
-	}
-
-	/* Run capture session. */
-	loop_ = new EventLoop();
-	int status = loop_->exec();
-	stop();
-	delete loop_;
-
-	ASSERT_EQ(status, 0);
-}
-
-void SimpleCaptureUnbalanced::requestComplete(Request *request)
-{
-	captureCount_++;
-	if (captureCount_ >= captureLimit_) {
-		loop_->exit(0);
-		return;
-	}
-
-	request->reuse(Request::ReuseBuffers);
-	if (camera_->queueRequest(request))
-		loop_->exit(-EINVAL);
-}
diff -pruN 0.2.0-3/src/apps/lc-compliance/simple_capture.h 0.3.0-1/src/apps/lc-compliance/simple_capture.h
--- 0.2.0-3/src/apps/lc-compliance/simple_capture.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/simple_capture.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
-/*
- * Copyright (C) 2020-2021, Google Inc.
- *
- * simple_capture.h - Simple capture helper
- */
-
-#pragma once
-
-#include <memory>
-
-#include <libcamera/libcamera.h>
-
-#include "../common/event_loop.h"
-
-class SimpleCapture
-{
-public:
-	void configure(libcamera::StreamRole role);
-
-protected:
-	SimpleCapture(std::shared_ptr<libcamera::Camera> camera);
-	virtual ~SimpleCapture();
-
-	void start();
-	void stop();
-
-	virtual void requestComplete(libcamera::Request *request) = 0;
-
-	EventLoop *loop_;
-
-	std::shared_ptr<libcamera::Camera> camera_;
-	std::unique_ptr<libcamera::FrameBufferAllocator> allocator_;
-	std::unique_ptr<libcamera::CameraConfiguration> config_;
-	std::vector<std::unique_ptr<libcamera::Request>> requests_;
-};
-
-class SimpleCaptureBalanced : public SimpleCapture
-{
-public:
-	SimpleCaptureBalanced(std::shared_ptr<libcamera::Camera> camera);
-
-	void capture(unsigned int numRequests);
-
-private:
-	int queueRequest(libcamera::Request *request);
-	void requestComplete(libcamera::Request *request) override;
-
-	unsigned int queueCount_;
-	unsigned int captureCount_;
-	unsigned int captureLimit_;
-};
-
-class SimpleCaptureUnbalanced : public SimpleCapture
-{
-public:
-	SimpleCaptureUnbalanced(std::shared_ptr<libcamera::Camera> camera);
-
-	void capture(unsigned int numRequests);
-
-private:
-	void requestComplete(libcamera::Request *request) override;
-
-	unsigned int captureCount_;
-	unsigned int captureLimit_;
-};
diff -pruN 0.2.0-3/src/apps/lc-compliance/tests/capture_test.cpp 0.3.0-1/src/apps/lc-compliance/tests/capture_test.cpp
--- 0.2.0-3/src/apps/lc-compliance/tests/capture_test.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/apps/lc-compliance/tests/capture_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,136 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+/*
+ * Copyright (C) 2020, Google Inc.
+ * Copyright (C) 2021, Collabora Ltd.
+ *
+ * Test camera capture
+ */
+
+#include "capture.h"
+
+#include <iostream>
+
+#include <gtest/gtest.h>
+
+#include "environment.h"
+
+using namespace libcamera;
+
+const std::vector<int> NUMREQUESTS = { 1, 2, 3, 5, 8, 13, 21, 34, 55, 89 };
+const std::vector<StreamRole> ROLES = {
+	StreamRole::Raw,
+	StreamRole::StillCapture,
+	StreamRole::VideoRecording,
+	StreamRole::Viewfinder
+};
+
+class SingleStream : public testing::TestWithParam<std::tuple<StreamRole, int>>
+{
+public:
+	static std::string nameParameters(const testing::TestParamInfo<SingleStream::ParamType> &info);
+
+protected:
+	void SetUp() override;
+	void TearDown() override;
+
+	std::shared_ptr<Camera> camera_;
+};
+
+/*
+ * We use gtest's SetUp() and TearDown() instead of constructor and destructor
+ * in order to be able to assert on them.
+ */
+void SingleStream::SetUp()
+{
+	Environment *env = Environment::get();
+
+	camera_ = env->cm()->get(env->cameraId());
+
+	ASSERT_EQ(camera_->acquire(), 0);
+}
+
+void SingleStream::TearDown()
+{
+	if (!camera_)
+		return;
+
+	camera_->release();
+	camera_.reset();
+}
+
+std::string SingleStream::nameParameters(const testing::TestParamInfo<SingleStream::ParamType> &info)
+{
+	std::map<StreamRole, std::string> rolesMap = {
+		{ StreamRole::Raw, "Raw" },
+		{ StreamRole::StillCapture, "StillCapture" },
+		{ StreamRole::VideoRecording, "VideoRecording" },
+		{ StreamRole::Viewfinder, "Viewfinder" }
+	};
+
+	std::string roleName = rolesMap[std::get<0>(info.param)];
+	std::string numRequestsName = std::to_string(std::get<1>(info.param));
+
+	return roleName + "_" + numRequestsName;
+}
+
+/*
+ * Test single capture cycles
+ *
+ * Makes sure the camera completes the exact number of requests queued. Example
+ * failure is a camera that completes less requests than the number of requests
+ * queued.
+ */
+TEST_P(SingleStream, Capture)
+{
+	auto [role, numRequests] = GetParam();
+
+	CaptureBalanced capture(camera_);
+
+	capture.configure(role);
+
+	capture.capture(numRequests);
+}
+
+/*
+ * Test multiple start/stop cycles
+ *
+ * Makes sure the camera supports multiple start/stop cycles. Example failure is
+ * a camera that does not clean up correctly in its error path but is only
+ * tested by single-capture applications.
+ */
+TEST_P(SingleStream, CaptureStartStop)
+{
+	auto [role, numRequests] = GetParam();
+	unsigned int numRepeats = 3;
+
+	CaptureBalanced capture(camera_);
+
+	capture.configure(role);
+
+	for (unsigned int starts = 0; starts < numRepeats; starts++)
+		capture.capture(numRequests);
+}
+
+/*
+ * Test unbalanced stop
+ *
+ * Makes sure the camera supports a stop with requests queued. Example failure
+ * is a camera that does not handle cancelation of buffers coming back from the
+ * video device while stopping.
+ */
+TEST_P(SingleStream, UnbalancedStop)
+{
+	auto [role, numRequests] = GetParam();
+
+	CaptureUnbalanced capture(camera_);
+
+	capture.configure(role);
+
+	capture.capture(numRequests);
+}
+
+INSTANTIATE_TEST_SUITE_P(CaptureTests,
+			 SingleStream,
+			 testing::Combine(testing::ValuesIn(ROLES),
+					  testing::ValuesIn(NUMREQUESTS)),
+			 SingleStream::nameParameters);
diff -pruN 0.2.0-3/src/apps/qcam/cam_select_dialog.cpp 0.3.0-1/src/apps/qcam/cam_select_dialog.cpp
--- 0.2.0-3/src/apps/qcam/cam_select_dialog.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/cam_select_dialog.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Utkarsh Tiwari <utkarsh02t@gmail.com>
  *
- * cam_select_dialog.cpp - qcam - Camera Selection dialog
+ * qcam - Camera Selection dialog
  */
 
 #include "cam_select_dialog.h"
diff -pruN 0.2.0-3/src/apps/qcam/cam_select_dialog.h 0.3.0-1/src/apps/qcam/cam_select_dialog.h
--- 0.2.0-3/src/apps/qcam/cam_select_dialog.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/cam_select_dialog.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Utkarsh Tiwari <utkarsh02t@gmail.com>
  *
- * cam_select_dialog.h - qcam - Camera Selection dialog
+ * qcam - Camera Selection dialog
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/qcam/format_converter.cpp 0.3.0-1/src/apps/qcam/format_converter.cpp
--- 0.2.0-3/src/apps/qcam/format_converter.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/format_converter.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * format_convert.cpp - qcam - Convert buffer to RGB
+ * Convert buffer to RGB
  */
 
 #include "format_converter.h"
diff -pruN 0.2.0-3/src/apps/qcam/format_converter.h 0.3.0-1/src/apps/qcam/format_converter.h
--- 0.2.0-3/src/apps/qcam/format_converter.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/format_converter.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * format_convert.h - qcam - Convert buffer to RGB
+ * Convert buffer to RGB
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/qcam/main.cpp 0.3.0-1/src/apps/qcam/main.cpp
--- 0.2.0-3/src/apps/qcam/main.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/main.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * main.cpp - qcam - The libcamera GUI test application
+ * qcam - The libcamera GUI test application
  */
 
 #include <signal.h>
diff -pruN 0.2.0-3/src/apps/qcam/main_window.cpp 0.3.0-1/src/apps/qcam/main_window.cpp
--- 0.2.0-3/src/apps/qcam/main_window.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/main_window.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * main_window.cpp - qcam - Main application window
+ * qcam - Main application window
  */
 
 #include "main_window.h"
@@ -190,7 +190,7 @@ int MainWindow::createToolbars()
 	action = toolbar_->addAction(QIcon::fromTheme("application-exit",
 						      QIcon(":x-circle.svg")),
 				     "Quit");
-	action->setShortcut(Qt::CTRL | Qt::Key_Q);
+	action->setShortcut(QKeySequence::Quit);
 	connect(action, &QAction::triggered, this, &MainWindow::quit);
 
 	/* Camera selector. */
diff -pruN 0.2.0-3/src/apps/qcam/main_window.h 0.3.0-1/src/apps/qcam/main_window.h
--- 0.2.0-3/src/apps/qcam/main_window.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/main_window.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * main_window.h - qcam - Main application window
+ * qcam - Main application window
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/qcam/message_handler.cpp 0.3.0-1/src/apps/qcam/message_handler.cpp
--- 0.2.0-3/src/apps/qcam/message_handler.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/message_handler.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Laurent Pinchart <laurent.pinchart@ideasonboard.com>
  *
- * message_handler.cpp - qcam - Log message handling
+ * qcam - Log message handling
  */
 
 #include "message_handler.h"
diff -pruN 0.2.0-3/src/apps/qcam/message_handler.h 0.3.0-1/src/apps/qcam/message_handler.h
--- 0.2.0-3/src/apps/qcam/message_handler.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/message_handler.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Laurent Pinchart <laurent.pinchart@ideasonboard.com>
  *
- * message_handler.cpp - qcam - Log message handling
+ * Log message handling
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/qcam/viewfinder.h 0.3.0-1/src/apps/qcam/viewfinder.h
--- 0.2.0-3/src/apps/qcam/viewfinder.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/viewfinder.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * viewfinder.h - qcam - Viewfinder base class
+ * qcam - Viewfinder base class
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/qcam/viewfinder_gl.cpp 0.3.0-1/src/apps/qcam/viewfinder_gl.cpp
--- 0.2.0-3/src/apps/qcam/viewfinder_gl.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/viewfinder_gl.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Linaro
  *
- * viewfinderGL.cpp - OpenGL Viewfinder for rendering by OpenGL shader
+ * OpenGL Viewfinder for rendering by OpenGL shader
  */
 
 #include "viewfinder_gl.h"
diff -pruN 0.2.0-3/src/apps/qcam/viewfinder_gl.h 0.3.0-1/src/apps/qcam/viewfinder_gl.h
--- 0.2.0-3/src/apps/qcam/viewfinder_gl.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/viewfinder_gl.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,8 +2,7 @@
 /*
  * Copyright (C) 2020, Linaro
  *
- * viewfinder_GL.h - OpenGL Viewfinder for rendering by OpenGL shader
- *
+ * OpenGL Viewfinder for rendering by OpenGL shader
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/apps/qcam/viewfinder_qt.cpp 0.3.0-1/src/apps/qcam/viewfinder_qt.cpp
--- 0.2.0-3/src/apps/qcam/viewfinder_qt.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/viewfinder_qt.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * viewfinder_qt.cpp - qcam - QPainter-based ViewFinder
+ * qcam - QPainter-based ViewFinder
  */
 
 #include "viewfinder_qt.h"
diff -pruN 0.2.0-3/src/apps/qcam/viewfinder_qt.h 0.3.0-1/src/apps/qcam/viewfinder_qt.h
--- 0.2.0-3/src/apps/qcam/viewfinder_qt.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/apps/qcam/viewfinder_qt.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * viewfinder_qt.h - qcam - QPainter-based ViewFinder
+ * qcam - QPainter-based ViewFinder
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamera-utils.cpp 0.3.0-1/src/gstreamer/gstlibcamera-utils.cpp
--- 0.2.0-3/src/gstreamer/gstlibcamera-utils.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamera-utils.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamera-utils.c - GStreamer libcamera Utility Function
+ * GStreamer libcamera Utility Function
  */
 
 #include "gstlibcamera-utils.h"
@@ -25,6 +25,26 @@ static struct {
 	{ GST_VIDEO_FORMAT_ENCODED, formats::SGBRG8 },
 	{ GST_VIDEO_FORMAT_ENCODED, formats::SGRBG8 },
 	{ GST_VIDEO_FORMAT_ENCODED, formats::SRGGB8 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SBGGR10 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGBRG10 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGRBG10 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SRGGB10 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SBGGR12 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGBRG12 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGRBG12 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SRGGB12 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SBGGR14 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGBRG14 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGRBG14 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SRGGB14 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SBGGR16 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGBRG16 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SGRBG16 },
+	{ GST_VIDEO_FORMAT_ENCODED, formats::SRGGB16 },
+
+	/* Monochrome */
+	{ GST_VIDEO_FORMAT_GRAY8, formats::R8 },
+	{ GST_VIDEO_FORMAT_GRAY16_LE, formats::R16 },
 
 	/* RGB16 */
 	{ GST_VIDEO_FORMAT_RGB16, formats::RGB565 },
@@ -246,6 +266,38 @@ bayer_format_to_string(int format)
 		return "grbg";
 	case formats::SRGGB8:
 		return "rggb";
+	case formats::SBGGR10:
+		return "bggr10le";
+	case formats::SGBRG10:
+		return "gbrg10le";
+	case formats::SGRBG10:
+		return "grbg10le";
+	case formats::SRGGB10:
+		return "rggb10le";
+	case formats::SBGGR12:
+		return "bggr12le";
+	case formats::SGBRG12:
+		return "gbrg12le";
+	case formats::SGRBG12:
+		return "grbg12le";
+	case formats::SRGGB12:
+		return "rggb12le";
+	case formats::SBGGR14:
+		return "bggr14le";
+	case formats::SGBRG14:
+		return "gbrg14le";
+	case formats::SGRBG14:
+		return "grbg14le";
+	case formats::SRGGB14:
+		return "rggb14le";
+	case formats::SBGGR16:
+		return "bggr16le";
+	case formats::SGBRG16:
+		return "gbrg16le";
+	case formats::SGRBG16:
+		return "grbg16le";
+	case formats::SRGGB16:
+		return "rggb16le";
 	}
 	return NULL;
 }
@@ -333,7 +385,7 @@ gst_libcamera_stream_configuration_to_ca
 
 	if (stream_cfg.colorSpace) {
 		GstVideoColorimetry colorimetry = colorimetry_from_colorspace(stream_cfg.colorSpace.value());
-		gchar *colorimetry_str = gst_video_colorimetry_to_string(&colorimetry);
+		g_autofree gchar *colorimetry_str = gst_video_colorimetry_to_string(&colorimetry);
 
 		if (colorimetry_str)
 			gst_structure_set(s, "colorimetry", G_TYPE_STRING, colorimetry_str, nullptr);
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamera-utils.h 0.3.0-1/src/gstreamer/gstlibcamera-utils.h
--- 0.2.0-3/src/gstreamer/gstlibcamera-utils.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamera-utils.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamera-utils.h - GStreamer libcamera Utility Functions
+ * GStreamer libcamera Utility Functions
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamera.cpp 0.3.0-1/src/gstreamer/gstlibcamera.cpp
--- 0.2.0-3/src/gstreamer/gstlibcamera.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamera.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamera.c - GStreamer plugin
+ * GStreamer plugin
  */
 
 #include "gstlibcameraprovider.h"
diff -pruN 0.2.0-3/src/gstreamer/gstlibcameraallocator.cpp 0.3.0-1/src/gstreamer/gstlibcameraallocator.cpp
--- 0.2.0-3/src/gstreamer/gstlibcameraallocator.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcameraallocator.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcameraallocator.cpp - GStreamer Custom Allocator
+ * GStreamer Custom Allocator
  */
 
 #include "gstlibcameraallocator.h"
diff -pruN 0.2.0-3/src/gstreamer/gstlibcameraallocator.h 0.3.0-1/src/gstreamer/gstlibcameraallocator.h
--- 0.2.0-3/src/gstreamer/gstlibcameraallocator.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcameraallocator.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcameraallocator.h - GStreamer Custom Allocator
+ * GStreamer Custom Allocator
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamerapad.cpp 0.3.0-1/src/gstreamer/gstlibcamerapad.cpp
--- 0.2.0-3/src/gstreamer/gstlibcamerapad.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamerapad.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamerapad.cpp - GStreamer Capture Pad
+ * GStreamer Capture Pad
  */
 
 #include "gstlibcamerapad.h"
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamerapad.h 0.3.0-1/src/gstreamer/gstlibcamerapad.h
--- 0.2.0-3/src/gstreamer/gstlibcamerapad.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamerapad.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamerapad.h - GStreamer Capture Element
+ * GStreamer Capture Element
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamerapool.cpp 0.3.0-1/src/gstreamer/gstlibcamerapool.cpp
--- 0.2.0-3/src/gstreamer/gstlibcamerapool.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamerapool.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamerapool.cpp - GStreamer Buffer Pool
+ * GStreamer Buffer Pool
  */
 
 #include "gstlibcamerapool.h"
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamerapool.h 0.3.0-1/src/gstreamer/gstlibcamerapool.h
--- 0.2.0-3/src/gstreamer/gstlibcamerapool.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamerapool.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamerapool.h - GStreamer Buffer Pool
+ * GStreamer Buffer Pool
  *
  * This is a partial implementation of GstBufferPool intended for internal use
  * only. This pool cannot be configured or activated.
diff -pruN 0.2.0-3/src/gstreamer/gstlibcameraprovider.cpp 0.3.0-1/src/gstreamer/gstlibcameraprovider.cpp
--- 0.2.0-3/src/gstreamer/gstlibcameraprovider.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcameraprovider.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcameraprovider.c - GStreamer Device Provider
+ * GStreamer Device Provider
  */
 
 #include <array>
diff -pruN 0.2.0-3/src/gstreamer/gstlibcameraprovider.h 0.3.0-1/src/gstreamer/gstlibcameraprovider.h
--- 0.2.0-3/src/gstreamer/gstlibcameraprovider.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcameraprovider.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcameraprovider.h - GStreamer Device Provider
+ * GStreamer Device Provider
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamerasrc.cpp 0.3.0-1/src/gstreamer/gstlibcamerasrc.cpp
--- 0.2.0-3/src/gstreamer/gstlibcamerasrc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamerasrc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamerasrc.cpp - GStreamer Capture Element
+ * GStreamer Capture Element
  */
 
 /**
@@ -377,10 +377,10 @@ gst_libcamera_src_open(GstLibcameraSrc *
 	}
 
 	if (camera_name) {
-		cam = cm->get(self->camera_name);
+		cam = cm->get(camera_name);
 		if (!cam) {
 			GST_ELEMENT_ERROR(self, RESOURCE, NOT_FOUND,
-					  ("Could not find a camera named '%s'.", self->camera_name),
+					  ("Could not find a camera named '%s'.", camera_name),
 					  ("libcamera::CameraMananger::get() returned nullptr"));
 			return false;
 		}
diff -pruN 0.2.0-3/src/gstreamer/gstlibcamerasrc.h 0.3.0-1/src/gstreamer/gstlibcamerasrc.h
--- 0.2.0-3/src/gstreamer/gstlibcamerasrc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/gstlibcamerasrc.h	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Collabora Ltd.
  *     Author: Nicolas Dufresne <nicolas.dufresne@collabora.com>
  *
- * gstlibcamerasrc.h - GStreamer Capture Element
+ * GStreamer Capture Element
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/gstreamer/meson.build 0.3.0-1/src/gstreamer/meson.build
--- 0.2.0-3/src/gstreamer/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/gstreamer/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -46,3 +46,15 @@ libcamera_gst = shared_library('gstlibca
     install : true,
     install_dir : '@0@/gstreamer-1.0'.format(get_option('libdir')),
 )
+
+# Make the plugin visible to GStreamer inside meson devenv.
+fs = import('fs')
+gst_plugin_path = fs.parent(libcamera_gst.full_path())
+
+gst_env = environment()
+gst_env.prepend('GST_PLUGIN_PATH', gst_plugin_path)
+
+# Avoid polluting the system registry.
+gst_env.set('GST_REGISTRY', gst_plugin_path / 'registry.data')
+
+meson.add_devenv(gst_env)
diff -pruN 0.2.0-3/src/ipa/ipa-sign-install.sh 0.3.0-1/src/ipa/ipa-sign-install.sh
--- 0.2.0-3/src/ipa/ipa-sign-install.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipa-sign-install.sh	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# ipa-sign-install.sh - Regenerate IPA module signatures when installing
+# Regenerate IPA module signatures when installing
 
 key=$1
 shift
diff -pruN 0.2.0-3/src/ipa/ipa-sign.sh 0.3.0-1/src/ipa/ipa-sign.sh
--- 0.2.0-3/src/ipa/ipa-sign.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipa-sign.sh	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# ipa-sign.sh - Generate a signature for an IPA module
+# Generate a signature for an IPA module
 
 key="$1"
 input="$2"
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/af.cpp 0.3.0-1/src/ipa/ipu3/algorithms/af.cpp
--- 0.2.0-3/src/ipa/ipu3/algorithms/af.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/af.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Red Hat
  *
- * af.cpp - IPU3 auto focus algorithm
+ * IPU3 auto focus algorithm
  */
 
 #include "af.h"
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/af.h 0.3.0-1/src/ipa/ipu3/algorithms/af.h
--- 0.2.0-3/src/ipa/ipu3/algorithms/af.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/af.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Red Hat
  *
- * af.h - IPU3 Af algorithm
+ * IPU3 Af algorithm
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/agc.cpp 0.3.0-1/src/ipa/ipu3/algorithms/agc.cpp
--- 0.2.0-3/src/ipa/ipu3/algorithms/agc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/agc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * ipu3_agc.cpp - AGC/AEC mean-based control algorithm
+ * AGC/AEC mean-based control algorithm
  */
 
 #include "agc.h"
@@ -56,24 +56,32 @@ static constexpr utils::Duration kMaxShu
 /* Histogram constants */
 static constexpr uint32_t knumHistogramBins = 256;
 
-/* Target value to reach for the top 2% of the histogram */
-static constexpr double kEvGainTarget = 0.5;
-
-/* Number of frames to wait before calculating stats on minimum exposure */
-static constexpr uint32_t kNumStartupFrames = 10;
+Agc::Agc()
+	: minShutterSpeed_(0s), maxShutterSpeed_(0s)
+{
+}
 
-/*
- * Relative luminance target.
+/**
+ * \brief Initialise the AGC algorithm from tuning files
+ * \param[in] context The shared IPA context
+ * \param[in] tuningData The YamlObject containing Agc tuning data
+ *
+ * This function calls the base class' tuningData parsers to discover which
+ * control values are supported.
  *
- * It's a number that's chosen so that, when the camera points at a grey
- * target, the resulting image brightness is considered right.
+ * \return 0 on success or errors from the base class
  */
-static constexpr double kRelativeLuminanceTarget = 0.16;
-
-Agc::Agc()
-	: frameCount_(0), minShutterSpeed_(0s),
-	  maxShutterSpeed_(0s), filteredExposure_(0s)
+int Agc::init(IPAContext &context, const YamlObject &tuningData)
 {
+	int ret;
+
+	ret = parseTuningData(tuningData);
+	if (ret)
+		return ret;
+
+	context.ctrlMap.merge(controls());
+
+	return 0;
 }
 
 /**
@@ -90,6 +98,7 @@ int Agc::configure(IPAContext &context,
 	IPAActiveState &activeState = context.activeState;
 
 	stride_ = configuration.grid.stride;
+	bdsGrid_ = configuration.grid.bdsGrid;
 
 	minShutterSpeed_ = configuration.agc.minShutterSpeed;
 	maxShutterSpeed_ = std::min(configuration.agc.maxShutterSpeed,
@@ -102,168 +111,53 @@ int Agc::configure(IPAContext &context,
 	activeState.agc.gain = minAnalogueGain_;
 	activeState.agc.exposure = 10ms / configuration.sensor.lineDuration;
 
-	frameCount_ = 0;
+	context.activeState.agc.constraintMode = constraintModes().begin()->first;
+	context.activeState.agc.exposureMode = exposureModeHelpers().begin()->first;
+
+	/* \todo Run this again when FrameDurationLimits is passed in */
+	setLimits(minShutterSpeed_, maxShutterSpeed_, minAnalogueGain_,
+		  maxAnalogueGain_);
+	resetFrameCount();
+
 	return 0;
 }
 
-/**
- * \brief Estimate the mean value of the top 2% of the histogram
- * \param[in] stats The statistics computed by the ImgU
- * \param[in] grid The grid used to store the statistics in the IPU3
- * \return The mean value of the top 2% of the histogram
- */
-double Agc::measureBrightness(const ipu3_uapi_stats_3a *stats,
-			      const ipu3_uapi_grid_config &grid) const
+Histogram Agc::parseStatistics(const ipu3_uapi_stats_3a *stats,
+			       const ipu3_uapi_grid_config &grid)
 {
-	/* Initialise the histogram array */
 	uint32_t hist[knumHistogramBins] = { 0 };
 
+	rgbTriples_.clear();
+
 	for (unsigned int cellY = 0; cellY < grid.height; cellY++) {
 		for (unsigned int cellX = 0; cellX < grid.width; cellX++) {
 			uint32_t cellPosition = cellY * stride_ + cellX;
 
 			const ipu3_uapi_awb_set_item *cell =
 				reinterpret_cast<const ipu3_uapi_awb_set_item *>(
-					&stats->awb_raw_buffer.meta_data[cellPosition]
-				);
+					&stats->awb_raw_buffer.meta_data[cellPosition]);
+
+			rgbTriples_.push_back({
+				cell->R_avg,
+				(cell->Gr_avg + cell->Gb_avg) / 2,
+				cell->B_avg
+			});
 
-			uint8_t gr = cell->Gr_avg;
-			uint8_t gb = cell->Gb_avg;
 			/*
 			 * Store the average green value to estimate the
 			 * brightness. Even the overexposed pixels are
 			 * taken into account.
 			 */
-			hist[(gr + gb) / 2]++;
+			hist[(cell->Gr_avg + cell->Gb_avg) / 2]++;
 		}
 	}
 
-	/* Estimate the quantile mean of the top 2% of the histogram. */
-	return Histogram(Span<uint32_t>(hist)).interQuantileMean(0.98, 1.0);
-}
-
-/**
- * \brief Apply a filter on the exposure value to limit the speed of changes
- * \param[in] exposureValue The target exposure from the AGC algorithm
- *
- * The speed of the filter is adaptive, and will produce the target quicker
- * during startup, or when the target exposure is within 20% of the most recent
- * filter output.
- *
- * \return The filtered exposure
- */
-utils::Duration Agc::filterExposure(utils::Duration exposureValue)
-{
-	double speed = 0.2;
-
-	/* Adapt instantly if we are in startup phase. */
-	if (frameCount_ < kNumStartupFrames)
-		speed = 1.0;
-
-	/*
-	 * If we are close to the desired result, go faster to avoid making
-	 * multiple micro-adjustments.
-	 * \todo Make this customisable?
-	 */
-	if (filteredExposure_ < 1.2 * exposureValue &&
-	    filteredExposure_ > 0.8 * exposureValue)
-		speed = sqrt(speed);
-
-	filteredExposure_ = speed * exposureValue +
-			    filteredExposure_ * (1.0 - speed);
-
-	LOG(IPU3Agc, Debug) << "After filtering, exposure " << filteredExposure_;
-
-	return filteredExposure_;
-}
-
-/**
- * \brief Estimate the new exposure and gain values
- * \param[inout] frameContext The shared IPA frame Context
- * \param[in] yGain The gain calculated based on the relative luminance target
- * \param[in] iqMeanGain The gain calculated based on the relative luminance target
- */
-void Agc::computeExposure(IPAContext &context, IPAFrameContext &frameContext,
-			  double yGain, double iqMeanGain)
-{
-	const IPASessionConfiguration &configuration = context.configuration;
-	/* Get the effective exposure and gain applied on the sensor. */
-	uint32_t exposure = frameContext.sensor.exposure;
-	double analogueGain = frameContext.sensor.gain;
-
-	/* Use the highest of the two gain estimates. */
-	double evGain = std::max(yGain, iqMeanGain);
-
-	/* Consider within 1% of the target as correctly exposed */
-	if (utils::abs_diff(evGain, 1.0) < 0.01)
-		LOG(IPU3Agc, Debug) << "We are well exposed (evGain = "
-				    << evGain << ")";
-
-	/* extracted from Rpi::Agc::computeTargetExposure */
-
-	/* Calculate the shutter time in seconds */
-	utils::Duration currentShutter = exposure * configuration.sensor.lineDuration;
-
-	/*
-	 * Update the exposure value for the next computation using the values
-	 * of exposure and gain really used by the sensor.
-	 */
-	utils::Duration effectiveExposureValue = currentShutter * analogueGain;
-
-	LOG(IPU3Agc, Debug) << "Actual total exposure " << currentShutter * analogueGain
-			    << " Shutter speed " << currentShutter
-			    << " Gain " << analogueGain
-			    << " Needed ev gain " << evGain;
-
-	/*
-	 * Calculate the current exposure value for the scene as the latest
-	 * exposure value applied multiplied by the new estimated gain.
-	 */
-	utils::Duration exposureValue = effectiveExposureValue * evGain;
-
-	/* Clamp the exposure value to the min and max authorized */
-	utils::Duration maxTotalExposure = maxShutterSpeed_ * maxAnalogueGain_;
-	exposureValue = std::min(exposureValue, maxTotalExposure);
-	LOG(IPU3Agc, Debug) << "Target total exposure " << exposureValue
-			    << ", maximum is " << maxTotalExposure;
-
-	/*
-	 * Filter the exposure.
-	 * \todo estimate if we need to desaturate
-	 */
-	exposureValue = filterExposure(exposureValue);
-
-	/*
-	 * Divide the exposure value as new exposure and gain values.
-	 *
-	 * Push the shutter time up to the maximum first, and only then
-	 * increase the gain.
-	 */
-	utils::Duration shutterTime =
-		std::clamp<utils::Duration>(exposureValue / minAnalogueGain_,
-					    minShutterSpeed_, maxShutterSpeed_);
-	double stepGain = std::clamp(exposureValue / shutterTime,
-				     minAnalogueGain_, maxAnalogueGain_);
-	LOG(IPU3Agc, Debug) << "Divided up shutter and gain are "
-			    << shutterTime << " and "
-			    << stepGain;
-
-	IPAActiveState &activeState = context.activeState;
-	/* Update the estimated exposure and gain. */
-	activeState.agc.exposure = shutterTime / configuration.sensor.lineDuration;
-	activeState.agc.gain = stepGain;
+	return Histogram(Span<uint32_t>(hist));
 }
 
 /**
  * \brief Estimate the relative luminance of the frame with a given gain
- * \param[in] frameContext The shared IPA frame context
- * \param[in] grid The grid used to store the statistics in the IPU3
- * \param[in] stats The IPU3 statistics and ISP results
- * \param[in] gain The gain to apply to the frame
- * \return The relative luminance
- *
- * This function estimates the average relative luminance of the frame that
- * would be output by the sensor if an additional \a gain was applied.
+ * \param[in] gain The gain to apply in estimating luminance
  *
  * The estimation is based on the AWB statistics for the current frame. Red,
  * green and blue averages for all cells are first multiplied by the gain, and
@@ -278,40 +172,24 @@ void Agc::computeExposure(IPAContext &co
  *
  * More detailed information can be found in:
  * https://en.wikipedia.org/wiki/Relative_luminance
+ *
+ * \return The relative luminance of the frame
  */
-double Agc::estimateLuminance(IPAActiveState &activeState,
-			      const ipu3_uapi_grid_config &grid,
-			      const ipu3_uapi_stats_3a *stats,
-			      double gain)
+double Agc::estimateLuminance(double gain) const
 {
 	double redSum = 0, greenSum = 0, blueSum = 0;
 
-	/* Sum the per-channel averages, saturated to 255. */
-	for (unsigned int cellY = 0; cellY < grid.height; cellY++) {
-		for (unsigned int cellX = 0; cellX < grid.width; cellX++) {
-			uint32_t cellPosition = cellY * stride_ + cellX;
-
-			const ipu3_uapi_awb_set_item *cell =
-				reinterpret_cast<const ipu3_uapi_awb_set_item *>(
-					&stats->awb_raw_buffer.meta_data[cellPosition]
-				);
-			const uint8_t G_avg = (cell->Gr_avg + cell->Gb_avg) / 2;
-
-			redSum += std::min(cell->R_avg * gain, 255.0);
-			greenSum += std::min(G_avg * gain, 255.0);
-			blueSum += std::min(cell->B_avg * gain, 255.0);
-		}
+	for (unsigned int i = 0; i < rgbTriples_.size(); i++) {
+		redSum += std::min(std::get<0>(rgbTriples_[i]) * gain, 255.0);
+		greenSum += std::min(std::get<1>(rgbTriples_[i]) * gain, 255.0);
+		blueSum += std::min(std::get<2>(rgbTriples_[i]) * gain, 255.0);
 	}
 
-	/*
-	 * Apply the AWB gains to approximate colours correctly, use the Rec.
-	 * 601 formula to calculate the relative luminance, and normalize it.
-	 */
-	double ySum = redSum * activeState.awb.gains.red * 0.299
-		    + greenSum * activeState.awb.gains.green * 0.587
-		    + blueSum * activeState.awb.gains.blue * 0.114;
+	double ySum = redSum * rGain_ * 0.299
+		    + greenSum * gGain_ * 0.587
+		    + blueSum * bGain_ * 0.114;
 
-	return ySum / (grid.height * grid.width) / 255;
+	return ySum / (bdsGrid_.height * bdsGrid_.width) / 255;
 }
 
 /**
@@ -330,44 +208,36 @@ void Agc::process(IPAContext &context, [
 		  const ipu3_uapi_stats_3a *stats,
 		  ControlList &metadata)
 {
-	/*
-	 * Estimate the gain needed to have the proportion of pixels in a given
-	 * desired range. iqMean is the mean value of the top 2% of the
-	 * cumulative histogram, and we want it to be as close as possible to a
-	 * configured target.
-	 */
-	double iqMean = measureBrightness(stats, context.configuration.grid.bdsGrid);
-	double iqMeanGain = kEvGainTarget * knumHistogramBins / iqMean;
+	Histogram hist = parseStatistics(stats, context.configuration.grid.bdsGrid);
+	rGain_ = context.activeState.awb.gains.red;
+	gGain_ = context.activeState.awb.gains.blue;
+	bGain_ = context.activeState.awb.gains.green;
 
 	/*
-	 * Estimate the gain needed to achieve a relative luminance target. To
-	 * account for non-linearity caused by saturation, the value needs to be
-	 * estimated in an iterative process, as multiplying by a gain will not
-	 * increase the relative luminance by the same factor if some image
-	 * regions are saturated.
+	 * The Agc algorithm needs to know the effective exposure value that was
+	 * applied to the sensor when the statistics were collected.
 	 */
-	double yGain = 1.0;
-	double yTarget = kRelativeLuminanceTarget;
+	utils::Duration exposureTime = context.configuration.sensor.lineDuration
+				     * frameContext.sensor.exposure;
+	double analogueGain = frameContext.sensor.gain;
+	utils::Duration effectiveExposureValue = exposureTime * analogueGain;
 
-	for (unsigned int i = 0; i < 8; i++) {
-		double yValue = estimateLuminance(context.activeState,
-						  context.configuration.grid.bdsGrid,
-						  stats, yGain);
-		double extraGain = std::min(10.0, yTarget / (yValue + .001));
-
-		yGain *= extraGain;
-		LOG(IPU3Agc, Debug) << "Y value: " << yValue
-				    << ", Y target: " << yTarget
-				    << ", gives gain " << yGain;
-		if (extraGain < 1.01)
-			break;
-	}
+	utils::Duration shutterTime;
+	double aGain, dGain;
+	std::tie(shutterTime, aGain, dGain) =
+		calculateNewEv(context.activeState.agc.constraintMode,
+			       context.activeState.agc.exposureMode, hist,
+			       effectiveExposureValue);
+
+	LOG(IPU3Agc, Debug)
+		<< "Divided up shutter, analogue gain and digital gain are "
+		<< shutterTime << ", " << aGain << " and " << dGain;
 
-	computeExposure(context, frameContext, yGain, iqMeanGain);
-	frameCount_++;
+	IPAActiveState &activeState = context.activeState;
+	/* Update the estimated exposure and gain. */
+	activeState.agc.exposure = shutterTime / context.configuration.sensor.lineDuration;
+	activeState.agc.gain = aGain;
 
-	utils::Duration exposureTime = context.configuration.sensor.lineDuration
-				     * frameContext.sensor.exposure;
 	metadata.set(controls::AnalogueGain, frameContext.sensor.gain);
 	metadata.set(controls::ExposureTime, exposureTime.get<std::micro>());
 
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/agc.h 0.3.0-1/src/ipa/ipu3/algorithms/agc.h
--- 0.2.0-3/src/ipa/ipu3/algorithms/agc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/agc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * agc.h - IPU3 AGC/AEC mean-based control algorithm
+ * IPU3 AGC/AEC mean-based control algorithm
  */
 
 #pragma once
@@ -13,6 +13,9 @@
 
 #include <libcamera/geometry.h>
 
+#include "libipa/agc_mean_luminance.h"
+#include "libipa/histogram.h"
+
 #include "algorithm.h"
 
 namespace libcamera {
@@ -21,12 +24,13 @@ struct IPACameraSensorInfo;
 
 namespace ipa::ipu3::algorithms {
 
-class Agc : public Algorithm
+class Agc : public Algorithm, public AgcMeanLuminance
 {
 public:
 	Agc();
 	~Agc() = default;
 
+	int init(IPAContext &context, const YamlObject &tuningData) override;
 	int configure(IPAContext &context, const IPAConfigInfo &configInfo) override;
 	void process(IPAContext &context, const uint32_t frame,
 		     IPAFrameContext &frameContext,
@@ -34,17 +38,9 @@ public:
 		     ControlList &metadata) override;
 
 private:
-	double measureBrightness(const ipu3_uapi_stats_3a *stats,
-				 const ipu3_uapi_grid_config &grid) const;
-	utils::Duration filterExposure(utils::Duration currentExposure);
-	void computeExposure(IPAContext &context, IPAFrameContext &frameContext,
-			     double yGain, double iqMeanGain);
-	double estimateLuminance(IPAActiveState &activeState,
-				 const ipu3_uapi_grid_config &grid,
-				 const ipu3_uapi_stats_3a *stats,
-				 double gain);
-
-	uint64_t frameCount_;
+	double estimateLuminance(double gain) const override;
+	Histogram parseStatistics(const ipu3_uapi_stats_3a *stats,
+				  const ipu3_uapi_grid_config &grid);
 
 	utils::Duration minShutterSpeed_;
 	utils::Duration maxShutterSpeed_;
@@ -52,9 +48,12 @@ private:
 	double minAnalogueGain_;
 	double maxAnalogueGain_;
 
-	utils::Duration filteredExposure_;
-
 	uint32_t stride_;
+	double rGain_;
+	double gGain_;
+	double bGain_;
+	ipu3_uapi_grid_config bdsGrid_;
+	std::vector<std::tuple<uint8_t, uint8_t, uint8_t>> rgbTriples_;
 };
 
 } /* namespace ipa::ipu3::algorithms */
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/algorithm.h 0.3.0-1/src/ipa/ipu3/algorithms/algorithm.h
--- 0.2.0-3/src/ipa/ipu3/algorithms/algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * algorithm.h - IPU3 control algorithm interface
+ * IPU3 control algorithm interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/awb.cpp 0.3.0-1/src/ipa/ipu3/algorithms/awb.cpp
--- 0.2.0-3/src/ipa/ipu3/algorithms/awb.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/awb.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * awb.cpp - AWB control algorithm
+ * AWB control algorithm
  */
 #include "awb.h"
 
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/awb.h 0.3.0-1/src/ipa/ipu3/algorithms/awb.h
--- 0.2.0-3/src/ipa/ipu3/algorithms/awb.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/awb.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * awb.h - IPU3 AWB control algorithm
+ * IPU3 AWB control algorithm
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/blc.cpp 0.3.0-1/src/ipa/ipu3/algorithms/blc.cpp
--- 0.2.0-3/src/ipa/ipu3/algorithms/blc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/blc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google inc.
  *
- * blc.cpp - IPU3 Black Level Correction control
+ * IPU3 Black Level Correction control
  */
 
 #include "blc.h"
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/blc.h 0.3.0-1/src/ipa/ipu3/algorithms/blc.h
--- 0.2.0-3/src/ipa/ipu3/algorithms/blc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/blc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google inc.
  *
- * black_correction.h - IPU3 Black Level Correction control
+ * IPU3 Black Level Correction control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/tone_mapping.cpp 0.3.0-1/src/ipa/ipu3/algorithms/tone_mapping.cpp
--- 0.2.0-3/src/ipa/ipu3/algorithms/tone_mapping.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/tone_mapping.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google inc.
  *
- * tone_mapping.cpp - IPU3 ToneMapping and Gamma control
+ * IPU3 ToneMapping and Gamma control
  */
 
 #include "tone_mapping.h"
diff -pruN 0.2.0-3/src/ipa/ipu3/algorithms/tone_mapping.h 0.3.0-1/src/ipa/ipu3/algorithms/tone_mapping.h
--- 0.2.0-3/src/ipa/ipu3/algorithms/tone_mapping.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/algorithms/tone_mapping.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google inc.
  *
- * tone_mapping.h - IPU3 ToneMapping and Gamma control
+ * IPU3 ToneMapping and Gamma control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/ipu3/ipa_context.cpp 0.3.0-1/src/ipa/ipu3/ipa_context.cpp
--- 0.2.0-3/src/ipa/ipu3/ipa_context.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/ipa_context.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * ipa_context.cpp - IPU3 IPA Context
+ * IPU3 IPA Context
  */
 
 #include "ipa_context.h"
@@ -47,6 +47,9 @@ namespace libcamera::ipa::ipu3 {
  *
  * \var IPAContext::activeState
  * \brief The current state of IPA algorithms
+ *
+ * \var IPAContext::ctrlMap
+ * \brief A ControlInfoMap::Map of controls populated by the algorithms
  */
 
 /**
diff -pruN 0.2.0-3/src/ipa/ipu3/ipa_context.h 0.3.0-1/src/ipa/ipu3/ipa_context.h
--- 0.2.0-3/src/ipa/ipu3/ipa_context.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/ipa_context.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * ipa_context.h - IPU3 IPA Context
+ * IPU3 IPA Context
  *
  */
 
@@ -12,6 +12,7 @@
 
 #include <libcamera/base/utils.h>
 
+#include <libcamera/controls.h>
 #include <libcamera/geometry.h>
 
 #include <libipa/fc_queue.h>
@@ -55,6 +56,8 @@ struct IPAActiveState {
 	struct {
 		uint32_t exposure;
 		double gain;
+		uint32_t constraintMode;
+		uint32_t exposureMode;
 	} agc;
 
 	struct {
@@ -85,6 +88,8 @@ struct IPAContext {
 	IPAActiveState activeState;
 
 	FCQueue<IPAFrameContext> frameContexts;
+
+	ControlInfoMap::Map ctrlMap;
 };
 
 } /* namespace ipa::ipu3 */
diff -pruN 0.2.0-3/src/ipa/ipu3/ipu3.cpp 0.3.0-1/src/ipa/ipu3/ipu3.cpp
--- 0.2.0-3/src/ipa/ipu3/ipu3.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/ipu3.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipu3.cpp - IPU3 Image Processing Algorithms
+ * IPU3 Image Processing Algorithms
  */
 
 #include <algorithm>
@@ -189,7 +189,7 @@ private:
 };
 
 IPAIPU3::IPAIPU3()
-	: context_({ {}, {}, { kMaxFrameContexts } })
+	: context_({ {}, {}, { kMaxFrameContexts }, {} })
 {
 }
 
@@ -287,6 +287,7 @@ void IPAIPU3::updateControls(const IPACa
 							       frameDurations[1],
 							       frameDurations[2]);
 
+	controls.merge(context_.ctrlMap);
 	*ipaControls = ControlInfoMap(std::move(controls), controls::controls);
 }
 
@@ -672,7 +673,7 @@ extern "C" {
 const struct IPAModuleInfo ipaModuleInfo = {
 	IPA_MODULE_API_VERSION,
 	1,
-	"PipelineHandlerIPU3",
+	"ipu3",
 	"ipu3",
 };
 
diff -pruN 0.2.0-3/src/ipa/ipu3/module.h 0.3.0-1/src/ipa/ipu3/module.h
--- 0.2.0-3/src/ipa/ipu3/module.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/ipu3/module.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas On Board
  *
- * module.h - IPU3 IPA Module
+ * IPU3 IPA Module
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/libipa/agc_mean_luminance.cpp 0.3.0-1/src/ipa/libipa/agc_mean_luminance.cpp
--- 0.2.0-3/src/ipa/libipa/agc_mean_luminance.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/agc_mean_luminance.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,577 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024 Ideas on Board Oy
+ *
+ * Base class for mean luminance AGC algorithms
+ */
+
+#include "agc_mean_luminance.h"
+
+#include <cmath>
+
+#include <libcamera/base/log.h>
+#include <libcamera/control_ids.h>
+
+#include "exposure_mode_helper.h"
+
+using namespace libcamera::controls;
+
+/**
+ * \file agc_mean_luminance.h
+ * \brief Base class implementing mean luminance AEGC
+ */
+
+namespace libcamera {
+
+using namespace std::literals::chrono_literals;
+
+LOG_DEFINE_CATEGORY(AgcMeanLuminance)
+
+namespace ipa {
+
+/*
+ * Number of frames for which to run the algorithm at full speed, before slowing
+ * down to prevent large and jarring changes in exposure from frame to frame.
+ */
+static constexpr uint32_t kNumStartupFrames = 10;
+
+/*
+ * Default relative luminance target
+ *
+ * This value should be chosen so that when the camera points at a grey target,
+ * the resulting image brightness looks "right". Custom values can be passed
+ * as the relativeLuminanceTarget value in sensor tuning files.
+ */
+static constexpr double kDefaultRelativeLuminanceTarget = 0.16;
+
+/**
+ * \struct AgcMeanLuminance::AgcConstraint
+ * \brief The boundaries and target for an AeConstraintMode constraint
+ *
+ * This structure describes an AeConstraintMode constraint for the purposes of
+ * this algorithm. These constraints are expressed as a pair of quantile
+ * boundaries for a histogram, along with a luminance target and a bounds-type.
+ * The algorithm uses the constraints by ensuring that the defined portion of a
+ * luminance histogram (I.E. lying between the two quantiles) is above or below
+ * the given luminance value.
+ */
+
+/**
+ * \enum AgcMeanLuminance::AgcConstraint::Bound
+ * \brief Specify whether the constraint defines a lower or upper bound
+ * \var AgcMeanLuminance::AgcConstraint::lower
+ * \brief The constraint defines a lower bound
+ * \var AgcMeanLuminance::AgcConstraint::upper
+ * \brief The constraint defines an upper bound
+ */
+
+/**
+ * \var AgcMeanLuminance::AgcConstraint::bound
+ * \brief The type of constraint bound
+ */
+
+/**
+ * \var AgcMeanLuminance::AgcConstraint::qLo
+ * \brief The lower quantile to use for the constraint
+ */
+
+/**
+ * \var AgcMeanLuminance::AgcConstraint::qHi
+ * \brief The upper quantile to use for the constraint
+ */
+
+/**
+ * \var AgcMeanLuminance::AgcConstraint::yTarget
+ * \brief The luminance target for the constraint
+ */
+
+/**
+ * \class AgcMeanLuminance
+ * \brief A mean-based auto-exposure algorithm
+ *
+ * This algorithm calculates a shutter time, analogue and digital gain such that
+ * the normalised mean luminance value of an image is driven towards a target,
+ * which itself is discovered from tuning data. The algorithm is a two-stage
+ * process.
+ *
+ * In the first stage, an initial gain value is derived by iteratively comparing
+ * the gain-adjusted mean luminance across the entire image against a target,
+ * and selecting a value which pushes it as closely as possible towards the
+ * target.
+ *
+ * In the second stage we calculate the gain required to drive the average of a
+ * section of a histogram to a target value, where the target and the boundaries
+ * of the section of the histogram used in the calculation are taken from the
+ * values defined for the currently configured AeConstraintMode within the
+ * tuning data. This class provides a helper function to parse those tuning data
+ * to discover the constraints, and so requires a specific format for those
+ * data which is described in \ref parseTuningData(). The gain from the first
+ * stage is then clamped to the gain from this stage.
+ *
+ * The final gain is used to adjust the effective exposure value of the image,
+ * and that new exposure value is divided into shutter time, analogue gain and
+ * digital gain according to the selected AeExposureMode. This class uses the
+ * \ref ExposureModeHelper class to assist in that division, and expects the
+ * data needed to initialise that class to be present in tuning data in a
+ * format described in \ref parseTuningData().
+ *
+ * In order to be able to use this algorithm an IPA module needs to be able to
+ * do the following:
+ *
+ * 1. Provide a luminance estimation across an entire image.
+ * 2. Provide a luminance Histogram for the image to use in calculating
+ *    constraint compliance. The precision of the Histogram that is available
+ *    will determine the supportable precision of the constraints.
+ *
+ * IPA modules that want to use this class to implement their AEGC algorithm
+ * should derive it and provide an overriding estimateLuminance() function for
+ * this class to use. They must call parseTuningData() in init(), and must also
+ * call setLimits() and resetFrameCounter() in configure(). They may then use
+ * calculateNewEv() in process(). If the limits passed to setLimits() change for
+ * any reason (for example, in response to a FrameDurationLimit control being
+ * passed in queueRequest()) then setLimits() must be called again with the new
+ * values.
+ */
+
+AgcMeanLuminance::AgcMeanLuminance()
+	: frameCount_(0), filteredExposure_(0s), relativeLuminanceTarget_(0)
+{
+}
+
+AgcMeanLuminance::~AgcMeanLuminance() = default;
+
+void AgcMeanLuminance::parseRelativeLuminanceTarget(const YamlObject &tuningData)
+{
+	relativeLuminanceTarget_ =
+		tuningData["relativeLuminanceTarget"].get<double>(kDefaultRelativeLuminanceTarget);
+}
+
+void AgcMeanLuminance::parseConstraint(const YamlObject &modeDict, int32_t id)
+{
+	for (const auto &[boundName, content] : modeDict.asDict()) {
+		if (boundName != "upper" && boundName != "lower") {
+			LOG(AgcMeanLuminance, Warning)
+				<< "Ignoring unknown constraint bound '" << boundName << "'";
+			continue;
+		}
+
+		unsigned int idx = static_cast<unsigned int>(boundName == "upper");
+		AgcConstraint::Bound bound = static_cast<AgcConstraint::Bound>(idx);
+		double qLo = content["qLo"].get<double>().value_or(0.98);
+		double qHi = content["qHi"].get<double>().value_or(1.0);
+		double yTarget =
+			content["yTarget"].getList<double>().value_or(std::vector<double>{ 0.5 }).at(0);
+
+		AgcConstraint constraint = { bound, qLo, qHi, yTarget };
+
+		if (!constraintModes_.count(id))
+			constraintModes_[id] = {};
+
+		if (idx)
+			constraintModes_[id].push_back(constraint);
+		else
+			constraintModes_[id].insert(constraintModes_[id].begin(), constraint);
+	}
+}
+
+int AgcMeanLuminance::parseConstraintModes(const YamlObject &tuningData)
+{
+	std::vector<ControlValue> availableConstraintModes;
+
+	const YamlObject &yamlConstraintModes = tuningData[controls::AeConstraintMode.name()];
+	if (yamlConstraintModes.isDictionary()) {
+		for (const auto &[modeName, modeDict] : yamlConstraintModes.asDict()) {
+			if (AeConstraintModeNameValueMap.find(modeName) ==
+			    AeConstraintModeNameValueMap.end()) {
+				LOG(AgcMeanLuminance, Warning)
+					<< "Skipping unknown constraint mode '" << modeName << "'";
+				continue;
+			}
+
+			if (!modeDict.isDictionary()) {
+				LOG(AgcMeanLuminance, Error)
+					<< "Invalid constraint mode '" << modeName << "'";
+				return -EINVAL;
+			}
+
+			parseConstraint(modeDict,
+					AeConstraintModeNameValueMap.at(modeName));
+			availableConstraintModes.push_back(
+				AeConstraintModeNameValueMap.at(modeName));
+		}
+	}
+
+	/*
+	 * If the tuning data file contains no constraints then we use the
+	 * default constraint that the IPU3/RkISP1 Agc algorithms were adhering
+	 * to anyway before centralisation; this constraint forces the top 2% of
+	 * the histogram to be at least 0.5.
+	 */
+	if (constraintModes_.empty()) {
+		AgcConstraint constraint = {
+			AgcConstraint::Bound::lower,
+			0.98,
+			1.0,
+			0.5
+		};
+
+		constraintModes_[controls::ConstraintNormal].insert(
+			constraintModes_[controls::ConstraintNormal].begin(),
+			constraint);
+		availableConstraintModes.push_back(
+			AeConstraintModeNameValueMap.at("ConstraintNormal"));
+	}
+
+	controls_[&controls::AeConstraintMode] = ControlInfo(availableConstraintModes);
+
+	return 0;
+}
+
+int AgcMeanLuminance::parseExposureModes(const YamlObject &tuningData)
+{
+	std::vector<ControlValue> availableExposureModes;
+
+	const YamlObject &yamlExposureModes = tuningData[controls::AeExposureMode.name()];
+	if (yamlExposureModes.isDictionary()) {
+		for (const auto &[modeName, modeValues] : yamlExposureModes.asDict()) {
+			if (AeExposureModeNameValueMap.find(modeName) ==
+			    AeExposureModeNameValueMap.end()) {
+				LOG(AgcMeanLuminance, Warning)
+					<< "Skipping unknown exposure mode '" << modeName << "'";
+				continue;
+			}
+
+			if (!modeValues.isDictionary()) {
+				LOG(AgcMeanLuminance, Error)
+					<< "Invalid exposure mode '" << modeName << "'";
+				return -EINVAL;
+			}
+
+			std::vector<uint32_t> shutters =
+				modeValues["shutter"].getList<uint32_t>().value_or(std::vector<uint32_t>{});
+			std::vector<double> gains =
+				modeValues["gain"].getList<double>().value_or(std::vector<double>{});
+
+			if (shutters.size() != gains.size()) {
+				LOG(AgcMeanLuminance, Error)
+					<< "Shutter and gain array sizes unequal";
+				return -EINVAL;
+			}
+
+			if (shutters.empty()) {
+				LOG(AgcMeanLuminance, Error)
+					<< "Shutter and gain arrays are empty";
+				return -EINVAL;
+			}
+
+			std::vector<std::pair<utils::Duration, double>> stages;
+			for (unsigned int i = 0; i < shutters.size(); i++) {
+				stages.push_back({
+					std::chrono::microseconds(shutters[i]),
+					gains[i]
+				});
+			}
+
+			std::shared_ptr<ExposureModeHelper> helper =
+				std::make_shared<ExposureModeHelper>(stages);
+
+			exposureModeHelpers_[AeExposureModeNameValueMap.at(modeName)] = helper;
+			availableExposureModes.push_back(AeExposureModeNameValueMap.at(modeName));
+		}
+	}
+
+	/*
+	 * If we don't have any exposure modes in the tuning data we create an
+	 * ExposureModeHelper using an empty vector of stages. This will result
+	 * in the ExposureModeHelper simply driving the shutter as high as
+	 * possible before touching gain.
+	 */
+	if (availableExposureModes.empty()) {
+		int32_t exposureModeId = AeExposureModeNameValueMap.at("ExposureNormal");
+		std::vector<std::pair<utils::Duration, double>> stages = { };
+
+		std::shared_ptr<ExposureModeHelper> helper =
+			std::make_shared<ExposureModeHelper>(stages);
+
+		exposureModeHelpers_[exposureModeId] = helper;
+		availableExposureModes.push_back(exposureModeId);
+	}
+
+	controls_[&controls::AeExposureMode] = ControlInfo(availableExposureModes);
+
+	return 0;
+}
+
+/**
+ * \brief Parse tuning data for AeConstraintMode and AeExposureMode controls
+ * \param[in] tuningData the YamlObject representing the tuning data
+ *
+ * This function parses tuning data to build the list of allowed values for the
+ * AeConstraintMode and AeExposureMode controls. Those tuning data must provide
+ * the data in a specific format; the Agc algorithm's tuning data should contain
+ * a dictionary called AeConstraintMode containing per-mode setting dictionaries
+ * with the key being a value from \ref controls::AeConstraintModeNameValueMap.
+ * Each mode dict may contain either a "lower" or "upper" key or both, for
+ * example:
+ *
+ * \code{.unparsed}
+ * algorithms:
+ *   - Agc:
+ *       AeConstraintMode:
+ *         ConstraintNormal:
+ *           lower:
+ *             qLo: 0.98
+ *             qHi: 1.0
+ *             yTarget: 0.5
+ *         ConstraintHighlight:
+ *           lower:
+ *             qLo: 0.98
+ *             qHi: 1.0
+ *             yTarget: 0.5
+ *           upper:
+ *             qLo: 0.98
+ *             qHi: 1.0
+ *             yTarget: 0.8
+ *
+ * \endcode
+ *
+ * For the AeExposureMode control the data should contain a dictionary called
+ * AeExposureMode containing per-mode setting dictionaries with the key being a
+ * value from \ref controls::AeExposureModeNameValueMap. Each mode dict should
+ * contain an array of shutter times with the key "shutter" and an array of gain
+ * values with the key "gain", in this format:
+ *
+ * \code{.unparsed}
+ * algorithms:
+ *   - Agc:
+ *       AeExposureMode:
+ *         ExposureNormal:
+ *           shutter: [ 100, 10000, 30000, 60000, 120000 ]
+ *           gain: [ 2.0, 4.0, 6.0, 8.0, 10.0 ]
+ *         ExposureShort:
+ *           shutter: [ 100, 10000, 30000, 60000, 120000 ]
+ *           gain: [ 2.0, 4.0, 6.0, 8.0, 10.0 ]
+ *
+ * \endcode
+ *
+ * \return 0 on success or a negative error code
+ */
+int AgcMeanLuminance::parseTuningData(const YamlObject &tuningData)
+{
+	int ret;
+
+	parseRelativeLuminanceTarget(tuningData);
+
+	ret = parseConstraintModes(tuningData);
+	if (ret)
+		return ret;
+
+	return parseExposureModes(tuningData);
+}
+
+/**
+ * \brief Set the ExposureModeHelper limits for this class
+ * \param[in] minShutter Minimum shutter time to allow
+ * \param[in] maxShutter Maximum shutter time to allow
+ * \param[in] minGain Minimum gain to allow
+ * \param[in] maxGain Maximum gain to allow
+ *
+ * This function calls \ref ExposureModeHelper::setLimits() for each
+ * ExposureModeHelper that has been created for this class.
+ */
+void AgcMeanLuminance::setLimits(utils::Duration minShutter,
+				 utils::Duration maxShutter,
+				 double minGain, double maxGain)
+{
+	for (auto &[id, helper] : exposureModeHelpers_)
+		helper->setLimits(minShutter, maxShutter, minGain, maxGain);
+}
+
+/**
+ * \fn AgcMeanLuminance::constraintModes()
+ * \brief Get the constraint modes that have been parsed from tuning data
+ */
+
+/**
+ * \fn AgcMeanLuminance::exposureModeHelpers()
+ * \brief Get the ExposureModeHelpers that have been parsed from tuning data
+ */
+
+/**
+ * \fn AgcMeanLuminance::controls()
+ * \brief Get the controls that have been generated after parsing tuning data
+ */
+
+/**
+ * \fn AgcMeanLuminance::estimateLuminance(const double gain)
+ * \brief Estimate the luminance of an image, adjusted by a given gain
+ * \param[in] gain The gain with which to adjust the luminance estimate
+ *
+ * This function estimates the average relative luminance of the frame that
+ * would be output by the sensor if an additional \a gain was applied. It is a
+ * pure virtual function because estimation of luminance is a hardware-specific
+ * operation, which depends wholly on the format of the stats that are delivered
+ * to libcamera from the ISP. Derived classes must override this function with
+ * one that calculates the normalised mean luminance value across the entire
+ * image.
+ *
+ * \return The normalised relative luminance of the image
+ */
+
+/**
+ * \brief Estimate the initial gain needed to achieve a relative luminance
+ * target
+ * \return The calculated initial gain
+ */
+double AgcMeanLuminance::estimateInitialGain() const
+{
+	double yTarget = relativeLuminanceTarget_;
+	double yGain = 1.0;
+
+	/*
+	* To account for non-linearity caused by saturation, the value needs to
+	* be estimated in an iterative process, as multiplying by a gain will
+	* not increase the relative luminance by the same factor if some image
+	* regions are saturated.
+	*/
+	for (unsigned int i = 0; i < 8; i++) {
+		double yValue = estimateLuminance(yGain);
+		double extra_gain = std::min(10.0, yTarget / (yValue + .001));
+
+		yGain *= extra_gain;
+		LOG(AgcMeanLuminance, Debug) << "Y value: " << yValue
+				<< ", Y target: " << yTarget
+				<< ", gives gain " << yGain;
+
+		if (utils::abs_diff(extra_gain, 1.0) < 0.01)
+			break;
+	}
+
+	return yGain;
+}
+
+/**
+ * \brief Clamp gain within the bounds of a defined constraint
+ * \param[in] constraintModeIndex The index of the constraint to adhere to
+ * \param[in] hist A histogram over which to calculate inter-quantile means
+ * \param[in] gain The gain to clamp
+ *
+ * \return The gain clamped within the constraint bounds
+ */
+double AgcMeanLuminance::constraintClampGain(uint32_t constraintModeIndex,
+					     const Histogram &hist,
+					     double gain)
+{
+	std::vector<AgcConstraint> &constraints = constraintModes_[constraintModeIndex];
+	for (const AgcConstraint &constraint : constraints) {
+		double newGain = constraint.yTarget * hist.bins() /
+				 hist.interQuantileMean(constraint.qLo, constraint.qHi);
+
+		if (constraint.bound == AgcConstraint::Bound::lower &&
+		    newGain > gain)
+			gain = newGain;
+
+		if (constraint.bound == AgcConstraint::Bound::upper &&
+		    newGain < gain)
+			gain = newGain;
+	}
+
+	return gain;
+}
+
+/**
+ * \brief Apply a filter on the exposure value to limit the speed of changes
+ * \param[in] exposureValue The target exposure from the AGC algorithm
+ *
+ * The speed of the filter is adaptive, and will produce the target quicker
+ * during startup, or when the target exposure is within 20% of the most recent
+ * filter output.
+ *
+ * \return The filtered exposure
+ */
+utils::Duration AgcMeanLuminance::filterExposure(utils::Duration exposureValue)
+{
+	double speed = 0.2;
+
+	/* Adapt instantly if we are in startup phase. */
+	if (frameCount_ < kNumStartupFrames)
+		speed = 1.0;
+
+	/*
+	 * If we are close to the desired result, go faster to avoid making
+	 * multiple micro-adjustments.
+	 * \todo Make this customisable?
+	 */
+	if (filteredExposure_ < 1.2 * exposureValue &&
+	    filteredExposure_ > 0.8 * exposureValue)
+		speed = sqrt(speed);
+
+	filteredExposure_ = speed * exposureValue +
+			    filteredExposure_ * (1.0 - speed);
+
+	return filteredExposure_;
+}
+
+/**
+ * \brief Calculate the new exposure value and splut it between shutter time and gain
+ * \param[in] constraintModeIndex The index of the current constraint mode
+ * \param[in] exposureModeIndex The index of the current exposure mode
+ * \param[in] yHist A Histogram from the ISP statistics to use in constraining
+ * the calculated gain
+ * \param[in] effectiveExposureValue The EV applied to the frame from which the
+ * statistics in use derive
+ *
+ * Calculate a new exposure value to try to obtain the target. The calculated
+ * exposure value is filtered to prevent rapid changes from frame to frame, and
+ * divided into shutter time, analogue and digital gain.
+ *
+ * \return Tuple of shutter time, analogue gain, and digital gain
+ */
+std::tuple<utils::Duration, double, double>
+AgcMeanLuminance::calculateNewEv(uint32_t constraintModeIndex,
+				 uint32_t exposureModeIndex,
+				 const Histogram &yHist,
+				 utils::Duration effectiveExposureValue)
+{
+	/*
+	 * The pipeline handler should validate that we have received an allowed
+	 * value for AeExposureMode.
+	 */
+	std::shared_ptr<ExposureModeHelper> exposureModeHelper =
+		exposureModeHelpers_.at(exposureModeIndex);
+
+	double gain = estimateInitialGain();
+	gain = constraintClampGain(constraintModeIndex, yHist, gain);
+
+	/*
+	 * We don't check whether we're already close to the target, because
+	 * even if the effective exposure value is the same as the last frame's
+	 * we could have switched to an exposure mode that would require a new
+	 * pass through the splitExposure() function.
+	 */
+
+	utils::Duration newExposureValue = effectiveExposureValue * gain;
+
+	/*
+	 * We filter the exposure value to make sure changes are not too jarring
+	 * from frame to frame.
+	 */
+	newExposureValue = filterExposure(newExposureValue);
+
+	frameCount_++;
+	return exposureModeHelper->splitExposure(newExposureValue);
+}
+
+/**
+ * \fn AgcMeanLuminance::resetFrameCount()
+ * \brief Reset the frame counter
+ *
+ * This function resets the internal frame counter, which exists to help the
+ * algorithm decide whether it should respond instantly or not. The expectation
+ * is for derived classes to call this function before each camera start call in
+ * their configure() function.
+ */
+
+} /* namespace ipa */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/libipa/agc_mean_luminance.h 0.3.0-1/src/ipa/libipa/agc_mean_luminance.h
--- 0.2.0-3/src/ipa/libipa/agc_mean_luminance.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/agc_mean_luminance.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,96 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024 Ideas on Board Oy
+ *
+ agc_mean_luminance.h - Base class for mean luminance AGC algorithms
+ */
+
+#pragma once
+
+#include <map>
+#include <memory>
+#include <tuple>
+#include <vector>
+
+#include <libcamera/controls.h>
+
+#include "libcamera/internal/yaml_parser.h"
+
+#include "exposure_mode_helper.h"
+#include "histogram.h"
+
+namespace libcamera {
+
+namespace ipa {
+
+class AgcMeanLuminance
+{
+public:
+	AgcMeanLuminance();
+	virtual ~AgcMeanLuminance();
+
+	struct AgcConstraint {
+		enum class Bound {
+			lower = 0,
+			upper = 1
+		};
+		Bound bound;
+		double qLo;
+		double qHi;
+		double yTarget;
+	};
+
+	int parseTuningData(const YamlObject &tuningData);
+
+	void setLimits(utils::Duration minShutter, utils::Duration maxShutter,
+		       double minGain, double maxGain);
+
+	std::map<int32_t, std::vector<AgcConstraint>> constraintModes()
+	{
+		return constraintModes_;
+	}
+
+	std::map<int32_t, std::shared_ptr<ExposureModeHelper>> exposureModeHelpers()
+	{
+		return exposureModeHelpers_;
+	}
+
+	ControlInfoMap::Map controls()
+	{
+		return controls_;
+	}
+
+	std::tuple<utils::Duration, double, double>
+	calculateNewEv(uint32_t constraintModeIndex, uint32_t exposureModeIndex,
+		       const Histogram &yHist, utils::Duration effectiveExposureValue);
+
+	void resetFrameCount()
+	{
+		frameCount_ = 0;
+	}
+
+private:
+	virtual double estimateLuminance(const double gain) const = 0;
+
+	void parseRelativeLuminanceTarget(const YamlObject &tuningData);
+	void parseConstraint(const YamlObject &modeDict, int32_t id);
+	int parseConstraintModes(const YamlObject &tuningData);
+	int parseExposureModes(const YamlObject &tuningData);
+	double estimateInitialGain() const;
+	double constraintClampGain(uint32_t constraintModeIndex,
+				   const Histogram &hist,
+				   double gain);
+	utils::Duration filterExposure(utils::Duration exposureValue);
+
+	uint64_t frameCount_;
+	utils::Duration filteredExposure_;
+	double relativeLuminanceTarget_;
+
+	std::map<int32_t, std::vector<AgcConstraint>> constraintModes_;
+	std::map<int32_t, std::shared_ptr<ExposureModeHelper>> exposureModeHelpers_;
+	ControlInfoMap::Map controls_;
+};
+
+} /* namespace ipa */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/libipa/algorithm.cpp 0.3.0-1/src/ipa/libipa/algorithm.cpp
--- 0.2.0-3/src/ipa/libipa/algorithm.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/algorithm.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * algorithm.cpp - IPA control algorithm interface
+ * IPA control algorithm interface
  */
 
 #include "algorithm.h"
diff -pruN 0.2.0-3/src/ipa/libipa/algorithm.h 0.3.0-1/src/ipa/libipa/algorithm.h
--- 0.2.0-3/src/ipa/libipa/algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * algorithm.h - ISP control algorithm interface
+ * ISP control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/libipa/camera_sensor_helper.cpp 0.3.0-1/src/ipa/libipa/camera_sensor_helper.cpp
--- 0.2.0-3/src/ipa/libipa/camera_sensor_helper.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/camera_sensor_helper.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_sensor_helper.cpp - Helper class that performs sensor-specific
+ * Helper class that performs sensor-specific
  * parameter computations
  */
 #include "camera_sensor_helper.h"
@@ -417,6 +417,17 @@ public:
 };
 REGISTER_CAMERA_SENSOR_HELPER("imx258", CameraSensorHelperImx258)
 
+class CameraSensorHelperImx283 : public CameraSensorHelper
+{
+public:
+	CameraSensorHelperImx283()
+	{
+		gainType_ = AnalogueGainLinear;
+		gainConstants_.linear = { 0, 2048, -1, 2048 };
+	}
+};
+REGISTER_CAMERA_SENSOR_HELPER("imx283", CameraSensorHelperImx283)
+
 class CameraSensorHelperImx290 : public CameraSensorHelper
 {
 public:
@@ -444,6 +455,28 @@ class CameraSensorHelperImx327 : public
 };
 REGISTER_CAMERA_SENSOR_HELPER("imx327", CameraSensorHelperImx327)
 
+class CameraSensorHelperImx335 : public CameraSensorHelper
+{
+public:
+	CameraSensorHelperImx335()
+	{
+		gainType_ = AnalogueGainExponential;
+		gainConstants_.exp = { 1.0, expGainDb(0.3) };
+	}
+};
+REGISTER_CAMERA_SENSOR_HELPER("imx335", CameraSensorHelperImx335)
+
+class CameraSensorHelperImx415 : public CameraSensorHelper
+{
+public:
+	CameraSensorHelperImx415()
+	{
+		gainType_ = AnalogueGainExponential;
+		gainConstants_.exp = { 1.0, expGainDb(0.3) };
+	}
+};
+REGISTER_CAMERA_SENSOR_HELPER("imx415", CameraSensorHelperImx415)
+
 class CameraSensorHelperImx477 : public CameraSensorHelper
 {
 public:
diff -pruN 0.2.0-3/src/ipa/libipa/camera_sensor_helper.h 0.3.0-1/src/ipa/libipa/camera_sensor_helper.h
--- 0.2.0-3/src/ipa/libipa/camera_sensor_helper.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/camera_sensor_helper.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_sensor_helper.h - Helper class that performs sensor-specific parameter computations
+ * Helper class that performs sensor-specific parameter computations
  */
 
 #pragma once
@@ -88,7 +88,7 @@ public:
 	}
 
 private:
-	std::unique_ptr<CameraSensorHelper> createInstance() const
+	std::unique_ptr<CameraSensorHelper> createInstance() const override
 	{
 		return std::make_unique<_Helper>();
 	}
diff -pruN 0.2.0-3/src/ipa/libipa/exposure_mode_helper.cpp 0.3.0-1/src/ipa/libipa/exposure_mode_helper.cpp
--- 0.2.0-3/src/ipa/libipa/exposure_mode_helper.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/exposure_mode_helper.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,246 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024, Paul Elder <paul.elder@ideasonboard.com>
+ *
+ * Helper class that performs computations relating to exposure
+ */
+#include "exposure_mode_helper.h"
+
+#include <algorithm>
+
+#include <libcamera/base/log.h>
+
+/**
+ * \file exposure_mode_helper.h
+ * \brief Helper class that performs computations relating to exposure
+ *
+ * AEGC algorithms have a need to split exposure between shutter time, analogue
+ * and digital gain. Multiple implementations do so based on paired stages of
+ * shutter time and gain limits; provide a helper to avoid duplicating the code.
+ */
+
+namespace libcamera {
+
+using namespace std::literals::chrono_literals;
+
+LOG_DEFINE_CATEGORY(ExposureModeHelper)
+
+namespace ipa {
+
+/**
+ * \class ExposureModeHelper
+ * \brief Class for splitting exposure into shutter time and total gain
+ *
+ * The ExposureModeHelper class provides a standard interface through which an
+ * AEGC algorithm can divide exposure between shutter time and gain. It is
+ * configured with a set of shutter time and gain pairs and works by initially
+ * fixing gain at 1.0 and increasing shutter time up to the shutter time value
+ * from the first pair in the set in an attempt to meet the required exposure
+ * value.
+ *
+ * If the required exposure is not achievable by the first shutter time value
+ * alone it ramps gain up to the value from the first pair in the set. If the
+ * required exposure is still not met it then allows shutter time to ramp up to
+ * the shutter time value from the second pair in the set, and continues in this
+ * vein until either the required exposure time is met, or else the hardware's
+ * shutter time or gain limits are reached.
+ *
+ * This method allows users to strike a balance between a well-exposed image and
+ * an acceptable frame-rate, as opposed to simply maximising shutter time
+ * followed by gain. The same helpers can be used to perform the latter
+ * operation if needed by passing an empty set of pairs to the initialisation
+ * function.
+ *
+ * The gain values may exceed a camera sensor's analogue gain limits if either
+ * it or the IPA is also capable of digital gain. The configure() function must
+ * be called with the hardware's limits to inform the helper of those
+ * constraints. Any gain that is needed will be applied as analogue gain first
+ * until the hardware's limit is reached, following which digital gain will be
+ * used.
+ */
+
+/**
+ * \brief Construct an ExposureModeHelper instance
+ * \param[in] stages The vector of paired shutter time and gain limits
+ *
+ * The input stages are shutter time and _total_ gain pairs; the gain
+ * encompasses both analogue and digital gain.
+ *
+ * The vector of stages may be empty. In that case, the helper will simply use
+ * the runtime limits set through setShutterGainLimits() instead.
+ */
+ExposureModeHelper::ExposureModeHelper(const Span<std::pair<utils::Duration, double>> stages)
+{
+	minShutter_ = 0us;
+	maxShutter_ = 0us;
+	minGain_ = 0;
+	maxGain_ = 0;
+
+	for (const auto &[s, g] : stages) {
+		shutters_.push_back(s);
+		gains_.push_back(g);
+	}
+}
+
+/**
+ * \brief Set the shutter time and gain limits
+ * \param[in] minShutter The minimum shutter time supported
+ * \param[in] maxShutter The maximum shutter time supported
+ * \param[in] minGain The minimum analogue gain supported
+ * \param[in] maxGain The maximum analogue gain supported
+ *
+ * This function configures the shutter time and analogue gain limits that need
+ * to be adhered to as the helper divides up exposure. Note that this function
+ * *must* be called whenever those limits change and before splitExposure() is
+ * used.
+ *
+ * If the algorithm using the helpers needs to indicate that either shutter time
+ * or analogue gain or both should be fixed it can do so by setting both the
+ * minima and maxima to the same value.
+ */
+void ExposureModeHelper::setLimits(utils::Duration minShutter,
+				   utils::Duration maxShutter,
+				   double minGain, double maxGain)
+{
+	minShutter_ = minShutter;
+	maxShutter_ = maxShutter;
+	minGain_ = minGain;
+	maxGain_ = maxGain;
+}
+
+utils::Duration ExposureModeHelper::clampShutter(utils::Duration shutter) const
+{
+	return std::clamp(shutter, minShutter_, maxShutter_);
+}
+
+double ExposureModeHelper::clampGain(double gain) const
+{
+	return std::clamp(gain, minGain_, maxGain_);
+}
+
+/**
+ * \brief Split exposure time into shutter time and gain
+ * \param[in] exposure Exposure time
+ *
+ * This function divides a given exposure time into shutter time, analogue and
+ * digital gain by iterating through stages of shutter time and gain limits. At
+ * each stage the current stage's shutter time limit is multiplied by the
+ * previous stage's gain limit (or 1.0 initially) to see if the combination of
+ * the two can meet the required exposure time. If they cannot then the current
+ * stage's shutter time limit is multiplied by the same stage's gain limit to
+ * see if that combination can meet the required exposure time. If they cannot
+ * then the function moves to consider the next stage.
+ *
+ * When a combination of shutter time and gain _stage_ limits are found that are
+ * sufficient to meet the required exposure time, the function attempts to
+ * reduce shutter time as much as possible whilst fixing gain and still meeting
+ * the exposure time. If a _runtime_ limit prevents shutter time from being
+ * lowered enough to meet the exposure time with gain fixed at the stage limit,
+ * gain is also lowered to compensate.
+ *
+ * Once the shutter time and gain values are ascertained, gain is assigned as
+ * analogue gain as much as possible, with digital gain only in use if the
+ * maximum analogue gain runtime limit is unable to accommodate the exposure
+ * value.
+ *
+ * If no combination of shutter time and gain limits is found that meets the
+ * required exposure time, the helper falls-back to simply maximising the
+ * shutter time first, followed by analogue gain, followed by digital gain.
+ *
+ * \return Tuple of shutter time, analogue gain, and digital gain
+ */
+std::tuple<utils::Duration, double, double>
+ExposureModeHelper::splitExposure(utils::Duration exposure) const
+{
+	ASSERT(maxShutter_);
+	ASSERT(maxGain_);
+
+	bool gainFixed = minGain_ == maxGain_;
+	bool shutterFixed = minShutter_ == maxShutter_;
+
+	/*
+	 * There's no point entering the loop if we cannot change either gain
+	 * nor shutter anyway.
+	 */
+	if (shutterFixed && gainFixed)
+		return { minShutter_, minGain_, exposure / (minShutter_ * minGain_) };
+
+	utils::Duration shutter;
+	double stageGain;
+	double gain;
+
+	for (unsigned int stage = 0; stage < gains_.size(); stage++) {
+		double lastStageGain = stage == 0 ? 1.0 : clampGain(gains_[stage - 1]);
+		utils::Duration stageShutter = clampShutter(shutters_[stage]);
+		stageGain = clampGain(gains_[stage]);
+
+		/*
+		 * We perform the clamping on both shutter and gain in case the
+		 * helper has had limits set that prevent those values being
+		 * lowered beyond a certain minimum...this can happen at runtime
+		 * for various reasons and so would not be known when the stage
+		 * limits are initialised.
+		 */
+
+		if (stageShutter * lastStageGain >= exposure) {
+			shutter = clampShutter(exposure / clampGain(lastStageGain));
+			gain = clampGain(exposure / shutter);
+
+			return { shutter, gain, exposure / (shutter * gain) };
+		}
+
+		if (stageShutter * stageGain >= exposure) {
+			shutter = clampShutter(exposure / clampGain(stageGain));
+			gain = clampGain(exposure / shutter);
+
+			return { shutter, gain, exposure / (shutter * gain) };
+		}
+	}
+
+	/*
+	 * From here on all we can do is max out the shutter time, followed by
+	 * the analogue gain. If we still haven't achieved the target we send
+	 * the rest of the exposure time to digital gain. If we were given no
+	 * stages to use then set stageGain to 1.0 so that shutter time is maxed
+	 * before gain touched at all.
+	 */
+	if (gains_.empty())
+		stageGain = 1.0;
+
+	shutter = clampShutter(exposure / clampGain(stageGain));
+	gain = clampGain(exposure / shutter);
+
+	return { shutter, gain, exposure / (shutter * gain) };
+}
+
+/**
+ * \fn ExposureModeHelper::minShutter()
+ * \brief Retrieve the configured minimum shutter time limit set through
+ * setShutterGainLimits()
+ * \return The minShutter_ value
+ */
+
+/**
+ * \fn ExposureModeHelper::maxShutter()
+ * \brief Retrieve the configured maximum shutter time set through
+ * setShutterGainLimits()
+ * \return The maxShutter_ value
+ */
+
+/**
+ * \fn ExposureModeHelper::minGain()
+ * \brief Retrieve the configured minimum gain set through
+ * setShutterGainLimits()
+ * \return The minGain_ value
+ */
+
+/**
+ * \fn ExposureModeHelper::maxGain()
+ * \brief Retrieve the configured maximum gain set through
+ * setShutterGainLimits()
+ * \return The maxGain_ value
+ */
+
+} /* namespace ipa */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/libipa/exposure_mode_helper.h 0.3.0-1/src/ipa/libipa/exposure_mode_helper.h
--- 0.2.0-3/src/ipa/libipa/exposure_mode_helper.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/exposure_mode_helper.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,53 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024, Paul Elder <paul.elder@ideasonboard.com>
+ *
+ * Helper class that performs computations relating to exposure
+ */
+
+#pragma once
+
+#include <tuple>
+#include <utility>
+#include <vector>
+
+#include <libcamera/base/span.h>
+#include <libcamera/base/utils.h>
+
+namespace libcamera {
+
+namespace ipa {
+
+class ExposureModeHelper
+{
+public:
+	ExposureModeHelper(const Span<std::pair<utils::Duration, double>> stages);
+	~ExposureModeHelper() = default;
+
+	void setLimits(utils::Duration minShutter, utils::Duration maxShutter,
+		       double minGain, double maxGain);
+
+	std::tuple<utils::Duration, double, double>
+	splitExposure(utils::Duration exposure) const;
+
+	utils::Duration minShutter() const { return minShutter_; }
+	utils::Duration maxShutter() const { return maxShutter_; }
+	double minGain() const { return minGain_; }
+	double maxGain() const { return maxGain_; }
+
+private:
+	utils::Duration clampShutter(utils::Duration shutter) const;
+	double clampGain(double gain) const;
+
+	std::vector<utils::Duration> shutters_;
+	std::vector<double> gains_;
+
+	utils::Duration minShutter_;
+	utils::Duration maxShutter_;
+	double minGain_;
+	double maxGain_;
+};
+
+} /* namespace ipa */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/libipa/fc_queue.cpp 0.3.0-1/src/ipa/libipa/fc_queue.cpp
--- 0.2.0-3/src/ipa/libipa/fc_queue.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/fc_queue.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * fc_queue.cpp - IPA Frame context queue
+ * IPA Frame context queue
  */
 
 #include "fc_queue.h"
diff -pruN 0.2.0-3/src/ipa/libipa/fc_queue.h 0.3.0-1/src/ipa/libipa/fc_queue.h
--- 0.2.0-3/src/ipa/libipa/fc_queue.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/fc_queue.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * fc_queue.h - IPA Frame context queue
+ * IPA Frame context queue
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/libipa/histogram.cpp 0.3.0-1/src/ipa/libipa/histogram.cpp
--- 0.2.0-3/src/ipa/libipa/histogram.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/histogram.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * histogram.cpp - histogram calculations
+ * histogram calculations
  */
 #include "histogram.h"
 
@@ -29,18 +29,34 @@ namespace ipa {
  */
 
 /**
+ * \fn Histogram::Histogram()
+ * \brief Construct an empty Histogram
+ *
+ * This empty constructor exists largely to allow Histograms to be embedded in
+ * other classes which may be created before the contents of the Histogram are
+ * known.
+ */
+
+/**
  * \brief Create a cumulative histogram
- * \param[in] data A pre-sorted histogram to be passed
+ * \param[in] data A (non-cumulative) histogram
  */
 Histogram::Histogram(Span<const uint32_t> data)
 {
-	cumulative_.reserve(data.size());
-	cumulative_.push_back(0);
-	for (const uint32_t &value : data)
-		cumulative_.push_back(cumulative_.back() + value);
+	cumulative_.resize(data.size() + 1);
+	cumulative_[0] = 0;
+	for (const auto &[i, value] : utils::enumerate(data))
+		cumulative_[i + 1] = cumulative_[i] + value;
 }
 
 /**
+ * \fn Histogram::Histogram(Span<const uint32_t> data, Transform transform)
+ * \brief Create a cumulative histogram
+ * \param[in] data A (non-cumulative) histogram
+ * \param[in] transform The transformation function to apply to every bin
+ */
+
+/**
  * \fn Histogram::bins()
  * \brief Retrieve the number of bins currently used by the Histogram
  * \return Number of bins
diff -pruN 0.2.0-3/src/ipa/libipa/histogram.h 0.3.0-1/src/ipa/libipa/histogram.h
--- 0.2.0-3/src/ipa/libipa/histogram.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/histogram.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * histogram.h - histogram calculation interface
+ * histogram calculation interface
  */
 
 #pragma once
@@ -10,10 +10,11 @@
 #include <assert.h>
 #include <limits.h>
 #include <stdint.h>
-
+#include <type_traits>
 #include <vector>
 
 #include <libcamera/base/span.h>
+#include <libcamera/base/utils.h>
 
 namespace libcamera {
 
@@ -22,7 +23,19 @@ namespace ipa {
 class Histogram
 {
 public:
+	Histogram() { cumulative_.push_back(0); }
 	Histogram(Span<const uint32_t> data);
+
+	template<typename Transform,
+		 std::enable_if_t<std::is_invocable_v<Transform, uint32_t>> * = nullptr>
+	Histogram(Span<const uint32_t> data, Transform transform)
+	{
+		cumulative_.resize(data.size() + 1);
+		cumulative_[0] = 0;
+		for (const auto &[i, value] : utils::enumerate(data))
+			cumulative_[i + 1] = cumulative_[i] + transform(value);
+	}
+
 	size_t bins() const { return cumulative_.size() - 1; }
 	uint64_t total() const { return cumulative_[cumulative_.size() - 1]; }
 	uint64_t cumulativeFrequency(double bin) const;
diff -pruN 0.2.0-3/src/ipa/libipa/meson.build 0.3.0-1/src/ipa/libipa/meson.build
--- 0.2.0-3/src/ipa/libipa/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -1,16 +1,20 @@
 # SPDX-License-Identifier: CC0-1.0
 
 libipa_headers = files([
+    'agc_mean_luminance.h',
     'algorithm.h',
     'camera_sensor_helper.h',
+    'exposure_mode_helper.h',
     'fc_queue.h',
     'histogram.h',
     'module.h',
 ])
 
 libipa_sources = files([
+    'agc_mean_luminance.cpp',
     'algorithm.cpp',
     'camera_sensor_helper.cpp',
+    'exposure_mode_helper.cpp',
     'fc_queue.cpp',
     'histogram.cpp',
     'module.cpp',
diff -pruN 0.2.0-3/src/ipa/libipa/module.cpp 0.3.0-1/src/ipa/libipa/module.cpp
--- 0.2.0-3/src/ipa/libipa/module.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/module.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas On Board
  *
- * module.cpp - IPA Module
+ * IPA Module
  */
 
 #include "module.h"
diff -pruN 0.2.0-3/src/ipa/libipa/module.h 0.3.0-1/src/ipa/libipa/module.h
--- 0.2.0-3/src/ipa/libipa/module.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/libipa/module.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas On Board
  *
- * module.h - IPA module
+ * IPA module
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/meson.build 0.3.0-1/src/ipa/meson.build
--- 0.2.0-3/src/ipa/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -41,6 +41,9 @@ ipa_names = []
 
 subdirs = []
 foreach pipeline : pipelines
+    # The current implementation expects the IPA module name to match the
+    # pipeline name.
+    # \todo Make the IPA naming scheme more flexible.
     if not ipa_modules.contains(pipeline)
         continue
     endif
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/agc.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/agc.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/agc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/agc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * agc.cpp - AGC/AEC mean-based control algorithm
+ * AGC/AEC mean-based control algorithm
  */
 
 #include "agc.h"
@@ -36,32 +36,32 @@ namespace ipa::rkisp1::algorithms {
 
 LOG_DEFINE_CATEGORY(RkISP1Agc)
 
-/* Minimum limit for analogue gain value */
-static constexpr double kMinAnalogueGain = 1.0;
-
-/* \todo Honour the FrameDurationLimits control instead of hardcoding a limit */
-static constexpr utils::Duration kMaxShutterSpeed = 60ms;
-
-/* Number of frames to wait before calculating stats on minimum exposure */
-static constexpr uint32_t kNumStartupFrames = 10;
-
-/* Target value to reach for the top 2% of the histogram */
-static constexpr double kEvGainTarget = 0.5;
+Agc::Agc()
+{
+	supportsRaw_ = true;
+}
 
-/*
- * Relative luminance target.
+/**
+ * \brief Initialise the AGC algorithm from tuning files
+ * \param[in] context The shared IPA context
+ * \param[in] tuningData The YamlObject containing Agc tuning data
  *
- * It's a number that's chosen so that, when the camera points at a grey
- * target, the resulting image brightness is considered right.
+ * This function calls the base class' tuningData parsers to discover which
+ * control values are supported.
  *
- * \todo Why is the value different between IPU3 and RkISP1 ?
+ * \return 0 on success or errors from the base class
  */
-static constexpr double kRelativeLuminanceTarget = 0.4;
-
-Agc::Agc()
-	: frameCount_(0), numCells_(0), numHistBins_(0), filteredExposure_(0s)
+int Agc::init(IPAContext &context, const YamlObject &tuningData)
 {
-	supportsRaw_ = true;
+	int ret;
+
+	ret = parseTuningData(tuningData);
+	if (ret)
+		return ret;
+
+	context.ctrlMap.merge(controls());
+
+	return 0;
 }
 
 /**
@@ -81,18 +81,8 @@ int Agc::configure(IPAContext &context,
 	context.activeState.agc.manual.exposure = context.activeState.agc.automatic.exposure;
 	context.activeState.agc.autoEnabled = !context.configuration.raw;
 
-	/*
-	 * According to the RkISP1 documentation:
-	 * - versions < V12 have RKISP1_CIF_ISP_AE_MEAN_MAX_V10 entries,
-	 * - versions >= V12 have RKISP1_CIF_ISP_AE_MEAN_MAX_V12 entries.
-	 */
-	if (context.configuration.hw.revision < RKISP1_V12) {
-		numCells_ = RKISP1_CIF_ISP_AE_MEAN_MAX_V10;
-		numHistBins_ = RKISP1_CIF_ISP_HIST_BIN_N_MAX_V10;
-	} else {
-		numCells_ = RKISP1_CIF_ISP_AE_MEAN_MAX_V12;
-		numHistBins_ = RKISP1_CIF_ISP_HIST_BIN_N_MAX_V12;
-	}
+	context.activeState.agc.constraintMode = constraintModes().begin()->first;
+	context.activeState.agc.exposureMode = exposureModeHelpers().begin()->first;
 
 	/*
 	 * Define the measurement window for AGC as a centered rectangle
@@ -103,11 +93,14 @@ int Agc::configure(IPAContext &context,
 	context.configuration.agc.measureWindow.h_size = 3 * configInfo.outputSize.width / 4;
 	context.configuration.agc.measureWindow.v_size = 3 * configInfo.outputSize.height / 4;
 
-	/*
-	 * \todo Use the upcoming per-frame context API that will provide a
-	 * frame index
-	 */
-	frameCount_ = 0;
+	/* \todo Run this again when FrameDurationLimits is passed in */
+	setLimits(context.configuration.sensor.minShutterSpeed,
+		  context.configuration.sensor.maxShutterSpeed,
+		  context.configuration.sensor.minAnalogueGain,
+		  context.configuration.sensor.maxAnalogueGain);
+
+	resetFrameCount();
+
 	return 0;
 }
 
@@ -186,8 +179,11 @@ void Agc::prepare(IPAContext &context, c
 	/* Produce the luminance histogram. */
 	params->meas.hst_config.mode = RKISP1_CIF_ISP_HISTOGRAM_MODE_Y_HISTOGRAM;
 	/* Set an average weighted histogram. */
-	for (unsigned int histBin = 0; histBin < numHistBins_; histBin++)
-		params->meas.hst_config.hist_weight[histBin] = 1;
+	Span<uint8_t> weights{
+		params->meas.hst_config.hist_weight,
+		context.hw->numHistogramWeights
+	};
+	std::fill(weights.begin(), weights.end(), 1);
 	/* Step size can't be less than 3. */
 	params->meas.hst_config.histogram_predivider = 4;
 
@@ -198,127 +194,24 @@ void Agc::prepare(IPAContext &context, c
 	params->module_en_update |= RKISP1_CIF_ISP_MODULE_HST;
 }
 
-/**
- * \brief Apply a filter on the exposure value to limit the speed of changes
- * \param[in] exposureValue The target exposure from the AGC algorithm
- *
- * The speed of the filter is adaptive, and will produce the target quicker
- * during startup, or when the target exposure is within 20% of the most recent
- * filter output.
- *
- * \return The filtered exposure
- */
-utils::Duration Agc::filterExposure(utils::Duration exposureValue)
-{
-	double speed = 0.2;
-
-	/* Adapt instantly if we are in startup phase. */
-	if (frameCount_ < kNumStartupFrames)
-		speed = 1.0;
-
-	/*
-	 * If we are close to the desired result, go faster to avoid making
-	 * multiple micro-adjustments.
-	 * \todo Make this customisable?
-	 */
-	if (filteredExposure_ < 1.2 * exposureValue &&
-	    filteredExposure_ > 0.8 * exposureValue)
-		speed = sqrt(speed);
-
-	filteredExposure_ = speed * exposureValue +
-			    filteredExposure_ * (1.0 - speed);
-
-	LOG(RkISP1Agc, Debug) << "After filtering, exposure " << filteredExposure_;
-
-	return filteredExposure_;
-}
-
-/**
- * \brief Estimate the new exposure and gain values
- * \param[inout] context The shared IPA Context
- * \param[in] frameContext The FrameContext for this frame
- * \param[in] yGain The gain calculated on the current brightness level
- * \param[in] iqMeanGain The gain calculated based on the relative luminance target
- */
-void Agc::computeExposure(IPAContext &context, IPAFrameContext &frameContext,
-			  double yGain, double iqMeanGain)
+void Agc::fillMetadata(IPAContext &context, IPAFrameContext &frameContext,
+		       ControlList &metadata)
 {
-	IPASessionConfiguration &configuration = context.configuration;
-	IPAActiveState &activeState = context.activeState;
-
-	/* Get the effective exposure and gain applied on the sensor. */
-	uint32_t exposure = frameContext.sensor.exposure;
-	double analogueGain = frameContext.sensor.gain;
-
-	/* Use the highest of the two gain estimates. */
-	double evGain = std::max(yGain, iqMeanGain);
-
-	utils::Duration minShutterSpeed = configuration.sensor.minShutterSpeed;
-	utils::Duration maxShutterSpeed = std::min(configuration.sensor.maxShutterSpeed,
-						   kMaxShutterSpeed);
-
-	double minAnalogueGain = std::max(configuration.sensor.minAnalogueGain,
-					  kMinAnalogueGain);
-	double maxAnalogueGain = configuration.sensor.maxAnalogueGain;
-
-	/* Consider within 1% of the target as correctly exposed. */
-	if (utils::abs_diff(evGain, 1.0) < 0.01)
-		return;
-
-	/* extracted from Rpi::Agc::computeTargetExposure. */
-
-	/* Calculate the shutter time in seconds. */
-	utils::Duration currentShutter = exposure * configuration.sensor.lineDuration;
-
-	/*
-	 * Update the exposure value for the next computation using the values
-	 * of exposure and gain really used by the sensor.
-	 */
-	utils::Duration effectiveExposureValue = currentShutter * analogueGain;
-
-	LOG(RkISP1Agc, Debug) << "Actual total exposure " << currentShutter * analogueGain
-			      << " Shutter speed " << currentShutter
-			      << " Gain " << analogueGain
-			      << " Needed ev gain " << evGain;
-
-	/*
-	 * Calculate the current exposure value for the scene as the latest
-	 * exposure value applied multiplied by the new estimated gain.
-	 */
-	utils::Duration exposureValue = effectiveExposureValue * evGain;
-
-	/* Clamp the exposure value to the min and max authorized. */
-	utils::Duration maxTotalExposure = maxShutterSpeed * maxAnalogueGain;
-	exposureValue = std::min(exposureValue, maxTotalExposure);
-	LOG(RkISP1Agc, Debug) << "Target total exposure " << exposureValue
-			      << ", maximum is " << maxTotalExposure;
-
-	/*
-	 * Divide the exposure value as new exposure and gain values.
-	 * \todo estimate if we need to desaturate
-	 */
-	exposureValue = filterExposure(exposureValue);
-
-	/*
-	 * Push the shutter time up to the maximum first, and only then
-	 * increase the gain.
-	 */
-	utils::Duration shutterTime = std::clamp<utils::Duration>(exposureValue / minAnalogueGain,
-								  minShutterSpeed, maxShutterSpeed);
-	double stepGain = std::clamp(exposureValue / shutterTime,
-				     minAnalogueGain, maxAnalogueGain);
-	LOG(RkISP1Agc, Debug) << "Divided up shutter and gain are "
-			      << shutterTime << " and "
-			      << stepGain;
+	utils::Duration exposureTime = context.configuration.sensor.lineDuration
+				     * frameContext.sensor.exposure;
+	metadata.set(controls::AnalogueGain, frameContext.sensor.gain);
+	metadata.set(controls::ExposureTime, exposureTime.get<std::micro>());
 
-	/* Update the estimated exposure and gain. */
-	activeState.agc.automatic.exposure = shutterTime / configuration.sensor.lineDuration;
-	activeState.agc.automatic.gain = stepGain;
+	/* \todo Use VBlank value calculated from each frame exposure. */
+	uint32_t vTotal = context.configuration.sensor.size.height
+			+ context.configuration.sensor.defVBlank;
+	utils::Duration frameDuration = context.configuration.sensor.lineDuration
+				      * vTotal;
+	metadata.set(controls::FrameDuration, frameDuration.get<std::micro>());
 }
 
 /**
  * \brief Estimate the relative luminance of the frame with a given gain
- * \param[in] ae The RkISP1 statistics and ISP results
  * \param[in] gain The gain to apply to the frame
  *
  * This function estimates the average relative luminance of the frame that
@@ -332,8 +225,6 @@ void Agc::computeExposure(IPAContext &co
  * YUV doesn't take into account the fact that the R, G and B components
  * contribute differently to the relative luminance.
  *
- * \todo Have a dedicated YUV algorithm ?
- *
  * The values are normalized to the [0.0, 1.0] range, where 1.0 corresponds to a
  * theoretical perfect reflector of 100% reference white.
  *
@@ -342,46 +233,17 @@ void Agc::computeExposure(IPAContext &co
  *
  * \return The relative luminance
  */
-double Agc::estimateLuminance(const rkisp1_cif_isp_ae_stat *ae,
-			      double gain)
+double Agc::estimateLuminance(double gain) const
 {
 	double ySum = 0.0;
 
 	/* Sum the averages, saturated to 255. */
-	for (unsigned int aeCell = 0; aeCell < numCells_; aeCell++)
-		ySum += std::min(ae->exp_mean[aeCell] * gain, 255.0);
+	for (uint8_t expMean : expMeans_)
+		ySum += std::min(expMean * gain, 255.0);
 
 	/* \todo Weight with the AWB gains */
 
-	return ySum / numCells_ / 255;
-}
-
-/**
- * \brief Estimate the mean value of the top 2% of the histogram
- * \param[in] hist The histogram statistics computed by the ImgU
- * \return The mean value of the top 2% of the histogram
- */
-double Agc::measureBrightness(const rkisp1_cif_isp_hist_stat *hist) const
-{
-	Histogram histogram{ Span<const uint32_t>(hist->hist_bins, numHistBins_) };
-	/* Estimate the quantile mean of the top 2% of the histogram. */
-	return histogram.interQuantileMean(0.98, 1.0);
-}
-
-void Agc::fillMetadata(IPAContext &context, IPAFrameContext &frameContext,
-		       ControlList &metadata)
-{
-	utils::Duration exposureTime = context.configuration.sensor.lineDuration
-				     * frameContext.sensor.exposure;
-	metadata.set(controls::AnalogueGain, frameContext.sensor.gain);
-	metadata.set(controls::ExposureTime, exposureTime.get<std::micro>());
-
-	/* \todo Use VBlank value calculated from each frame exposure. */
-	uint32_t vTotal = context.configuration.sensor.size.height
-			+ context.configuration.sensor.defVBlank;
-	utils::Duration frameDuration = context.configuration.sensor.lineDuration
-				      * vTotal;
-	metadata.set(controls::FrameDuration, frameDuration.get<std::micro>());
+	return ySum / expMeans_.size() / 255;
 }
 
 /**
@@ -415,38 +277,38 @@ void Agc::process(IPAContext &context, [
 	const rkisp1_cif_isp_stat *params = &stats->params;
 	ASSERT(stats->meas_type & RKISP1_CIF_ISP_STAT_AUTOEXP);
 
-	const rkisp1_cif_isp_ae_stat *ae = &params->ae;
-	const rkisp1_cif_isp_hist_stat *hist = &params->hist;
-
-	double iqMean = measureBrightness(hist);
-	double iqMeanGain = kEvGainTarget * numHistBins_ / iqMean;
+	/* The lower 4 bits are fractional and meant to be discarded. */
+	Histogram hist({ params->hist.hist_bins, context.hw->numHistogramBins },
+		       [](uint32_t x) { return x >> 4; });
+	expMeans_ = { params->ae.exp_mean, context.hw->numAeCells };
 
 	/*
-	 * Estimate the gain needed to achieve a relative luminance target. To
-	 * account for non-linearity caused by saturation, the value needs to be
-	 * estimated in an iterative process, as multiplying by a gain will not
-	 * increase the relative luminance by the same factor if some image
-	 * regions are saturated.
+	 * The Agc algorithm needs to know the effective exposure value that was
+	 * applied to the sensor when the statistics were collected.
 	 */
-	double yGain = 1.0;
-	double yTarget = kRelativeLuminanceTarget;
+	utils::Duration exposureTime = context.configuration.sensor.lineDuration
+				       * frameContext.sensor.exposure;
+	double analogueGain = frameContext.sensor.gain;
+	utils::Duration effectiveExposureValue = exposureTime * analogueGain;
 
-	for (unsigned int i = 0; i < 8; i++) {
-		double yValue = estimateLuminance(ae, yGain);
-		double extra_gain = std::min(10.0, yTarget / (yValue + .001));
-
-		yGain *= extra_gain;
-		LOG(RkISP1Agc, Debug) << "Y value: " << yValue
-				      << ", Y target: " << yTarget
-				      << ", gives gain " << yGain;
-		if (extra_gain < 1.01)
-			break;
-	}
+	utils::Duration shutterTime;
+	double aGain, dGain;
+	std::tie(shutterTime, aGain, dGain) =
+		calculateNewEv(context.activeState.agc.constraintMode,
+			       context.activeState.agc.exposureMode,
+			       hist, effectiveExposureValue);
+
+	LOG(RkISP1Agc, Debug)
+		<< "Divided up shutter, analogue gain and digital gain are "
+		<< shutterTime << ", " << aGain << " and " << dGain;
 
-	computeExposure(context, frameContext, yGain, iqMeanGain);
-	frameCount_++;
+	IPAActiveState &activeState = context.activeState;
+	/* Update the estimated exposure and gain. */
+	activeState.agc.automatic.exposure = shutterTime / context.configuration.sensor.lineDuration;
+	activeState.agc.automatic.gain = aGain;
 
 	fillMetadata(context, frameContext, metadata);
+	expMeans_ = {};
 }
 
 REGISTER_IPA_ALGORITHM(Agc, "Agc")
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/agc.h 0.3.0-1/src/ipa/rkisp1/algorithms/agc.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/agc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/agc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,29 +2,34 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * agc.h - RkISP1 AGC/AEC mean-based control algorithm
+ * RkISP1 AGC/AEC mean-based control algorithm
  */
 
 #pragma once
 
 #include <linux/rkisp1-config.h>
 
+#include <libcamera/base/span.h>
 #include <libcamera/base/utils.h>
 
 #include <libcamera/geometry.h>
 
+#include "libipa/agc_mean_luminance.h"
+#include "libipa/histogram.h"
+
 #include "algorithm.h"
 
 namespace libcamera {
 
 namespace ipa::rkisp1::algorithms {
 
-class Agc : public Algorithm
+class Agc : public Algorithm, public AgcMeanLuminance
 {
 public:
 	Agc();
 	~Agc() = default;
 
+	int init(IPAContext &context, const YamlObject &tuningData) override;
 	int configure(IPAContext &context, const IPACameraSensorInfo &configInfo) override;
 	void queueRequest(IPAContext &context,
 			  const uint32_t frame,
@@ -39,20 +44,11 @@ public:
 		     ControlList &metadata) override;
 
 private:
-	void computeExposure(IPAContext &Context, IPAFrameContext &frameContext,
-			     double yGain, double iqMeanGain);
-	utils::Duration filterExposure(utils::Duration exposureValue);
-	double estimateLuminance(const rkisp1_cif_isp_ae_stat *ae, double gain);
-	double measureBrightness(const rkisp1_cif_isp_hist_stat *hist) const;
 	void fillMetadata(IPAContext &context, IPAFrameContext &frameContext,
 			  ControlList &metadata);
+	double estimateLuminance(double gain) const override;
 
-	uint64_t frameCount_;
-
-	uint32_t numCells_;
-	uint32_t numHistBins_;
-
-	utils::Duration filteredExposure_;
+	Span<const uint8_t> expMeans_;
 };
 
 } /* namespace ipa::rkisp1::algorithms */
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/algorithm.h 0.3.0-1/src/ipa/rkisp1/algorithms/algorithm.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas On Board
  *
- * algorithm.h - RkISP1 control algorithm interface
+ * RkISP1 control algorithm interface
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/awb.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/awb.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/awb.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/awb.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * awb.cpp - AWB control algorithm
+ * AWB control algorithm
  */
 
 #include "awb.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/awb.h 0.3.0-1/src/ipa/rkisp1/algorithms/awb.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/awb.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/awb.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * awb.h - AWB control algorithm
+ * AWB control algorithm
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/blc.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/blc.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/blc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/blc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * blc.cpp - RkISP1 Black Level Correction control
+ * RkISP1 Black Level Correction control
  */
 
 #include "blc.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/blc.h 0.3.0-1/src/ipa/rkisp1/algorithms/blc.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/blc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/blc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * blc.h - RkISP1 Black Level Correction control
+ * RkISP1 Black Level Correction control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/cproc.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/cproc.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/cproc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/cproc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * cproc.cpp - RkISP1 Color Processing control
+ * RkISP1 Color Processing control
  */
 
 #include "cproc.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/cproc.h 0.3.0-1/src/ipa/rkisp1/algorithms/cproc.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/cproc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/cproc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * cproc.h - RkISP1 Color Processing control
+ * RkISP1 Color Processing control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/dpcc.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/dpcc.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/dpcc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/dpcc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * dpcc.cpp - RkISP1 Defect Pixel Cluster Correction control
+ * RkISP1 Defect Pixel Cluster Correction control
  */
 
 #include "dpcc.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/dpcc.h 0.3.0-1/src/ipa/rkisp1/algorithms/dpcc.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/dpcc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/dpcc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * dpcc.h - RkISP1 Defect Pixel Cluster Correction control
+ * RkISP1 Defect Pixel Cluster Correction control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/dpf.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/dpf.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/dpf.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/dpf.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * dpf.cpp - RkISP1 Denoise Pre-Filter control
+ * RkISP1 Denoise Pre-Filter control
  */
 
 #include "dpf.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/dpf.h 0.3.0-1/src/ipa/rkisp1/algorithms/dpf.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/dpf.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/dpf.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * dpf.h - RkISP1 Denoise Pre-Filter control
+ * RkISP1 Denoise Pre-Filter control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/filter.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/filter.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/filter.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/filter.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * filter.cpp - RkISP1 Filter control
+ * RkISP1 Filter control
  */
 
 #include "filter.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/filter.h 0.3.0-1/src/ipa/rkisp1/algorithms/filter.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/filter.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/filter.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * filter.h - RkISP1 Filter control
+ * RkISP1 Filter control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/gsl.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/gsl.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/gsl.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/gsl.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * gsl.cpp - RkISP1 Gamma Sensor Linearization control
+ * RkISP1 Gamma Sensor Linearization control
  */
 
 #include "gsl.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/gsl.h 0.3.0-1/src/ipa/rkisp1/algorithms/gsl.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/gsl.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/gsl.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * gsl.h - RkISP1 Gamma Sensor Linearization control
+ * RkISP1 Gamma Sensor Linearization control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/lsc.cpp 0.3.0-1/src/ipa/rkisp1/algorithms/lsc.cpp
--- 0.2.0-3/src/ipa/rkisp1/algorithms/lsc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/lsc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * lsc.cpp - RkISP1 Lens Shading Correction control
+ * RkISP1 Lens Shading Correction control
  */
 
 #include "lsc.h"
diff -pruN 0.2.0-3/src/ipa/rkisp1/algorithms/lsc.h 0.3.0-1/src/ipa/rkisp1/algorithms/lsc.h
--- 0.2.0-3/src/ipa/rkisp1/algorithms/lsc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/algorithms/lsc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * lsc.h - RkISP1 Lens Shading Correction control
+ * RkISP1 Lens Shading Correction control
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/ipa_context.cpp 0.3.0-1/src/ipa/rkisp1/ipa_context.cpp
--- 0.2.0-3/src/ipa/rkisp1/ipa_context.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/ipa_context.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * ipa_context.cpp - RkISP1 IPA Context
+ * RkISP1 IPA Context
  */
 
 #include "ipa_context.h"
@@ -15,6 +15,25 @@
 namespace libcamera::ipa::rkisp1 {
 
 /**
+ * \struct IPAHwSettings
+ * \brief RkISP1 version-specific hardware parameters
+ */
+
+/**
+ * \var IPAHwSettings::numAeCells
+ * \brief Number of cells in the AE exposure means grid
+ *
+ * \var IPAHwSettings::numHistogramBins
+ * \brief Number of bins in the histogram
+ *
+ * \var IPAHwSettings::numHistogramWeights
+ * \brief Number of weights in the histogram grid
+ *
+ * \var IPAHwSettings::numGammaOutSamples
+ * \brief Number of samples in the gamma out table
+ */
+
+/**
  * \struct IPASessionConfiguration
  * \brief Session configuration for the IPA module
  *
@@ -33,14 +52,6 @@ namespace libcamera::ipa::rkisp1 {
  */
 
 /**
- * \var IPASessionConfiguration::hw
- * \brief RkISP1-specific hardware information
- *
- * \var IPASessionConfiguration::hw.revision
- * \brief Hardware revision of the ISP
- */
-
-/**
  * \var IPASessionConfiguration::awb
  * \brief AWB parameters configuration of the IPA
  *
@@ -337,6 +348,9 @@ namespace libcamera::ipa::rkisp1 {
  * \struct IPAContext
  * \brief Global IPA context data shared between all algorithms
  *
+ * \var IPAContext::hw
+ * \brief RkISP1 version-specific hardware parameters
+ *
  * \var IPAContext::configuration
  * \brief The IPA session configuration, immutable during the session
  *
diff -pruN 0.2.0-3/src/ipa/rkisp1/ipa_context.h 0.3.0-1/src/ipa/rkisp1/ipa_context.h
--- 0.2.0-3/src/ipa/rkisp1/ipa_context.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/ipa_context.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021-2022, Ideas On Board
  *
- * ipa_context.h - RkISP1 IPA Context
+ * RkISP1 IPA Context
  *
  */
 
@@ -12,6 +12,7 @@
 
 #include <libcamera/base/utils.h>
 
+#include <libcamera/controls.h>
 #include <libcamera/geometry.h>
 
 #include <libipa/fc_queue.h>
@@ -20,6 +21,13 @@ namespace libcamera {
 
 namespace ipa::rkisp1 {
 
+struct IPAHwSettings {
+	unsigned int numAeCells;
+	unsigned int numHistogramBins;
+	unsigned int numHistogramWeights;
+	unsigned int numGammaOutSamples;
+};
+
 struct IPASessionConfiguration {
 	struct {
 		struct rkisp1_cif_isp_window measureWindow;
@@ -45,10 +53,6 @@ struct IPASessionConfiguration {
 		Size size;
 	} sensor;
 
-	struct {
-		rkisp1_cif_isp_version revision;
-	} hw;
-
 	bool raw;
 };
 
@@ -64,6 +68,8 @@ struct IPAActiveState {
 		} automatic;
 
 		bool autoEnabled;
+		uint32_t constraintMode;
+		uint32_t exposureMode;
 	} agc;
 
 	struct {
@@ -143,10 +149,13 @@ struct IPAFrameContext : public FrameCon
 };
 
 struct IPAContext {
+	const IPAHwSettings *hw;
 	IPASessionConfiguration configuration;
 	IPAActiveState activeState;
 
 	FCQueue<IPAFrameContext> frameContexts;
+
+	ControlInfoMap::Map ctrlMap;
 };
 
 } /* namespace ipa::rkisp1 */
diff -pruN 0.2.0-3/src/ipa/rkisp1/module.h 0.3.0-1/src/ipa/rkisp1/module.h
--- 0.2.0-3/src/ipa/rkisp1/module.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/module.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas On Board
  *
- * module.h - RkISP1 IPA Module
+ * RkISP1 IPA Module
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/ipa/rkisp1/rkisp1.cpp 0.3.0-1/src/ipa/rkisp1/rkisp1.cpp
--- 0.2.0-3/src/ipa/rkisp1/rkisp1.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rkisp1/rkisp1.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * rkisp1.cpp - RkISP1 Image Processing Algorithms
+ * RkISP1 Image Processing Algorithms
  */
 
 #include <algorithm>
@@ -81,12 +81,6 @@ private:
 
 	ControlInfoMap sensorControls_;
 
-	/* revision-specific data */
-	rkisp1_cif_isp_version hwRevision_;
-	unsigned int hwHistBinNMax_;
-	unsigned int hwGammaOutMaxSamples_;
-	unsigned int hwHistogramWeightGridsSize_;
-
 	/* Interface to the Camera Helper */
 	std::unique_ptr<CameraSensorHelper> camHelper_;
 
@@ -96,6 +90,20 @@ private:
 
 namespace {
 
+const IPAHwSettings ipaHwSettingsV10{
+	RKISP1_CIF_ISP_AE_MEAN_MAX_V10,
+	RKISP1_CIF_ISP_HIST_BIN_N_MAX_V10,
+	RKISP1_CIF_ISP_HISTOGRAM_WEIGHT_GRIDS_SIZE_V10,
+	RKISP1_CIF_ISP_GAMMA_OUT_MAX_SAMPLES_V10,
+};
+
+const IPAHwSettings ipaHwSettingsV12{
+	RKISP1_CIF_ISP_AE_MEAN_MAX_V12,
+	RKISP1_CIF_ISP_HIST_BIN_N_MAX_V12,
+	RKISP1_CIF_ISP_HISTOGRAM_WEIGHT_GRIDS_SIZE_V12,
+	RKISP1_CIF_ISP_GAMMA_OUT_MAX_SAMPLES_V12,
+};
+
 /* List of controls handled by the RkISP1 IPA */
 const ControlInfoMap::Map rkisp1Controls{
 	{ &controls::AeEnable, ControlInfo(false, true) },
@@ -111,7 +119,7 @@ const ControlInfoMap::Map rkisp1Controls
 } /* namespace */
 
 IPARkISP1::IPARkISP1()
-	: context_({ {}, {}, { kMaxFrameContexts } })
+	: context_({ {}, {}, {}, { kMaxFrameContexts }, {} })
 {
 }
 
@@ -128,14 +136,11 @@ int IPARkISP1::init(const IPASettings &s
 	/* \todo Add support for other revisions */
 	switch (hwRevision) {
 	case RKISP1_V10:
-		hwHistBinNMax_ = RKISP1_CIF_ISP_HIST_BIN_N_MAX_V10;
-		hwGammaOutMaxSamples_ = RKISP1_CIF_ISP_GAMMA_OUT_MAX_SAMPLES_V10;
-		hwHistogramWeightGridsSize_ = RKISP1_CIF_ISP_HISTOGRAM_WEIGHT_GRIDS_SIZE_V10;
+	case RKISP1_V_IMX8MP:
+		context_.hw = &ipaHwSettingsV10;
 		break;
 	case RKISP1_V12:
-		hwHistBinNMax_ = RKISP1_CIF_ISP_HIST_BIN_N_MAX_V12;
-		hwGammaOutMaxSamples_ = RKISP1_CIF_ISP_GAMMA_OUT_MAX_SAMPLES_V12;
-		hwHistogramWeightGridsSize_ = RKISP1_CIF_ISP_HISTOGRAM_WEIGHT_GRIDS_SIZE_V12;
+		context_.hw = &ipaHwSettingsV12;
 		break;
 	default:
 		LOG(IPARkISP1, Error)
@@ -146,9 +151,6 @@ int IPARkISP1::init(const IPASettings &s
 
 	LOG(IPARkISP1, Debug) << "Hardware revision is " << hwRevision;
 
-	/* Cache the value to set it in configure. */
-	hwRevision_ = static_cast<rkisp1_cif_isp_version>(hwRevision);
-
 	camHelper_ = CameraSensorHelperFactoryBase::create(settings.sensorModel);
 	if (!camHelper_) {
 		LOG(IPARkISP1, Error)
@@ -232,9 +234,6 @@ int IPARkISP1::configure(const IPAConfig
 	context_.activeState = {};
 	context_.frameContexts.clear();
 
-	/* Set the hardware revision for the algorithms. */
-	context_.configuration.hw.revision = hwRevision_;
-
 	const IPACameraSensorInfo &info = ipaConfig.sensorInfo;
 	const ControlInfo vBlank = sensorControls_.find(V4L2_CID_VBLANK)->second;
 	context_.configuration.sensor.defVBlank = vBlank.def().get<int32_t>();
@@ -428,6 +427,7 @@ void IPARkISP1::updateControls(const IPA
 							      frameDurations[1],
 							      frameDurations[2]);
 
+	ctrlMap.merge(context_.ctrlMap);
 	*ipaControls = ControlInfoMap(std::move(ctrlMap), controls::controls);
 }
 
@@ -459,7 +459,7 @@ extern "C" {
 const struct IPAModuleInfo ipaModuleInfo = {
 	IPA_MODULE_API_VERSION,
 	1,
-	"PipelineHandlerRkISP1",
+	"rkisp1",
 	"rkisp1",
 };
 
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * cam_helper.cpp - helper information for different sensors
+ * helper information for different sensors
  */
 
 #include <linux/videodev2.h>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper.h 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper.h
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * cam_helper.h - helper class providing camera information
+ * helper class providing camera information
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx219.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx219.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx219.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx219.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * cam_helper_imx219.cpp - camera helper for imx219 sensor
+ * camera helper for imx219 sensor
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx290.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx290.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx290.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx290.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Raspberry Pi Ltd
  *
- * cam_helper_imx290.cpp - camera helper for imx290 sensor
+ * camera helper for imx290 sensor
  */
 
 #include <math.h>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx296.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx296.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx296.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx296.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * cam_helper_imx296.cpp - Camera helper for IMX296 sensor
+ * Camera helper for IMX296 sensor
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx477.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx477.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx477.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx477.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * cam_helper_imx477.cpp - camera helper for imx477 sensor
+ * camera helper for imx477 sensor
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx519.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx519.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx519.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx519.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Based on cam_helper_imx477.cpp
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * cam_helper_imx519.cpp - camera helper for imx519 sensor
+ * camera helper for imx519 sensor
  * Copyright (C) 2021, Arducam Technology co., Ltd.
  */
 
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx708.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx708.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_imx708.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_imx708.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Raspberry Pi Ltd
  *
- * cam_helper_imx708.cpp - camera helper for imx708 sensor
+ * camera helper for imx708 sensor
  */
 
 #include <cmath>
@@ -269,7 +269,7 @@ bool CamHelperImx708::parsePdafData(cons
 {
 	size_t step = bpp >> 1; /* bytes per PDAF grid entry */
 
-	if (bpp < 10 || bpp > 12 || len < 194 * step || ptr[0] != 0 || ptr[1] >= 0x40) {
+	if (bpp < 10 || bpp > 14 || len < 194 * step || ptr[0] != 0 || ptr[1] >= 0x40) {
 		LOG(IPARPI, Error) << "PDAF data in unsupported format";
 		return false;
 	}
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_ov5647.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_ov5647.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_ov5647.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_ov5647.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * cam_helper_ov5647.cpp - camera information for ov5647 sensor
+ * camera information for ov5647 sensor
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_ov64a40.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_ov64a40.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_ov64a40.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_ov64a40.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2021, Raspberry Pi Ltd
  * Copyright (C) 2023, Ideas on Board Oy.
  *
- * cam_helper_ov64a40.cpp - camera information for ov64a40 sensor
+ * camera information for ov64a40 sensor
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_ov9281.cpp 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_ov9281.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/cam_helper_ov9281.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/cam_helper_ov9281.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Raspberry Pi Ltd
  *
- * cam_helper_ov9281.cpp - camera information for ov9281 sensor
+ * camera information for ov9281 sensor
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/md_parser.h 0.3.0-1/src/ipa/rpi/cam_helper/md_parser.h
--- 0.2.0-3/src/ipa/rpi/cam_helper/md_parser.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/md_parser.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * md_parser.h - image sensor metadata parser interface
+ * image sensor metadata parser interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/cam_helper/md_parser_smia.cpp 0.3.0-1/src/ipa/rpi/cam_helper/md_parser_smia.cpp
--- 0.2.0-3/src/ipa/rpi/cam_helper/md_parser_smia.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/cam_helper/md_parser_smia.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Raspberry Pi Ltd
  *
- * md_parser_smia.cpp - SMIA specification based embedded data parser
+ * SMIA specification based embedded data parser
  */
 
 #include <libcamera/base/log.h>
@@ -86,10 +86,13 @@ MdParserSmia::ParseStatus MdParserSmia::
 	while (1) {
 		int tag = buffer[currentOffset++];
 
-		if ((bitsPerPixel_ == 10 &&
-		     (currentOffset + 1 - currentLineStart) % 5 == 0) ||
-		    (bitsPerPixel_ == 12 &&
-		     (currentOffset + 1 - currentLineStart) % 3 == 0)) {
+		/* Non-dummy bytes come in even-sized blocks: skip can only ever follow tag */
+		while ((bitsPerPixel_ == 10 &&
+			(currentOffset + 1 - currentLineStart) % 5 == 0) ||
+		       (bitsPerPixel_ == 12 &&
+			(currentOffset + 1 - currentLineStart) % 3 == 0) ||
+		       (bitsPerPixel_ == 14 &&
+			(currentOffset - currentLineStart) % 7 >= 4)) {
 			if (buffer[currentOffset++] != RegSkip)
 				return BadDummy;
 		}
diff -pruN 0.2.0-3/src/ipa/rpi/common/ipa_base.cpp 0.3.0-1/src/ipa/rpi/common/ipa_base.cpp
--- 0.2.0-3/src/ipa/rpi/common/ipa_base.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/common/ipa_base.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2023, Raspberry Pi Ltd
  *
- * ipa_base.cpp - Raspberry Pi IPA base class
+ * Raspberry Pi IPA base class
  */
 
 #include "ipa_base.h"
@@ -25,7 +25,6 @@
 #include "controller/contrast_algorithm.h"
 #include "controller/denoise_algorithm.h"
 #include "controller/hdr_algorithm.h"
-#include "controller/hdr_status.h"
 #include "controller/lux_status.h"
 #include "controller/sharpen_algorithm.h"
 #include "controller/statistics.h"
@@ -104,9 +103,8 @@ LOG_DEFINE_CATEGORY(IPARPI)
 namespace ipa::RPi {
 
 IpaBase::IpaBase()
-	: controller_(), frameLengths_(FrameLengthsQueueSize, 0s), statsMetadataOutput_(false),
-	  frameCount_(0), mistrustCount_(0), lastRunTimestamp_(0), firstStart_(true),
-	  flickerState_({ 0, 0s })
+	: controller_(), frameLengths_(FrameLengthsQueueSize, 0s), stitchSwapBuffers_(false), frameCount_(0),
+	  mistrustCount_(0), lastRunTimestamp_(0), firstStart_(true), flickerState_({ 0, 0s })
 {
 }
 
@@ -299,6 +297,8 @@ void IpaBase::start(const ControlList &c
 		result->controls = std::move(ctrls);
 		setCameraTimeoutValue();
 	}
+	/* Make a note of this as it tells us the HDR status of the first few frames. */
+	hdrStatus_ = agcStatus.hdr;
 
 	/*
 	 * Initialise frame counts, and decide how many frames must be hidden or
@@ -402,11 +402,17 @@ void IpaBase::prepareIsp(const PreparePa
 	 * sensor exposure/gain changes. So fetch it from the metadata list
 	 * indexed by the IPA cookie returned, and put it in the current frame
 	 * metadata.
+	 *
+	 * Note if the HDR mode has changed, as things like tonemaps may need updating.
 	 */
 	AgcStatus agcStatus;
+	bool hdrChange = false;
 	RPiController::Metadata &delayedMetadata = rpiMetadata_[params.delayContext];
-	if (!delayedMetadata.get<AgcStatus>("agc.status", agcStatus))
+	if (!delayedMetadata.get<AgcStatus>("agc.status", agcStatus)) {
 		rpiMetadata.set("agc.delayed_status", agcStatus);
+		hdrChange = agcStatus.hdr.mode != hdrStatus_.mode;
+		hdrStatus_ = agcStatus.hdr;
+	}
 
 	/*
 	 * This may overwrite the DeviceStatus using values from the sensor
@@ -417,7 +423,7 @@ void IpaBase::prepareIsp(const PreparePa
 	/* Allow a 10% margin on the comparison below. */
 	Duration delta = (frameTimestamp - lastRunTimestamp_) * 1.0ns;
 	if (lastRunTimestamp_ && frameCount_ > dropFrameCount_ &&
-	    delta < controllerMinFrameDuration * 0.9) {
+	    delta < controllerMinFrameDuration * 0.9 && !hdrChange) {
 		/*
 		 * Ensure we merge the previous frame's metadata with the current
 		 * frame. This will not overwrite exposure/gain values for the
@@ -454,7 +460,7 @@ void IpaBase::prepareIsp(const PreparePa
 		reportMetadata(ipaContext);
 
 	/* Ready to push the input buffer into the ISP. */
-	prepareIspComplete.emit(params.buffers, false);
+	prepareIspComplete.emit(params.buffers, stitchSwapBuffers_);
 }
 
 void IpaBase::processStats(const ProcessParams &params)
@@ -586,6 +592,12 @@ void IpaBase::setMode(const IPACameraSen
 	mode_.minAnalogueGain = helper_->gain(gainCtrl.min().get<int32_t>());
 	mode_.maxAnalogueGain = helper_->gain(gainCtrl.max().get<int32_t>());
 
+	/*
+	 * We need to give the helper the min/max frame durations so it can calculate
+	 * the correct exposure limits below.
+	 */
+	helper_->setCameraMode(mode_);
+
 	/* Shutter speed is calculated based on the limits of the frame durations. */
 	mode_.minShutter = helper_->exposure(shutterCtrl.min().get<int32_t>(), mode_.minLineLength);
 	mode_.maxShutter = Duration::max();
@@ -695,14 +707,18 @@ static const std::map<int32_t, RPiContro
 
 static const std::map<int32_t, std::string> HdrModeTable = {
 	{ controls::HdrModeOff, "Off" },
+	{ controls::HdrModeMultiExposureUnmerged, "MultiExposureUnmerged" },
 	{ controls::HdrModeMultiExposure, "MultiExposure" },
 	{ controls::HdrModeSingleExposure, "SingleExposure" },
+	{ controls::HdrModeNight, "Night" },
 };
 
 void IpaBase::applyControls(const ControlList &controls)
 {
 	using RPiController::AgcAlgorithm;
 	using RPiController::AfAlgorithm;
+	using RPiController::ContrastAlgorithm;
+	using RPiController::DenoiseAlgorithm;
 	using RPiController::HdrAlgorithm;
 
 	/* Clear the return metadata buffer. */
@@ -1194,9 +1210,32 @@ void IpaBase::applyControls(const Contro
 				break;
 			}
 
-			if (hdr->setMode(mode->second) == 0)
+			if (hdr->setMode(mode->second) == 0) {
 				agc->setActiveChannels(hdr->getChannels());
-			else
+
+				/* We also disable adpative contrast enhancement if HDR is running. */
+				ContrastAlgorithm *contrast =
+					dynamic_cast<ContrastAlgorithm *>(controller_.getAlgorithm("contrast"));
+				if (contrast) {
+					if (mode->second == "Off")
+						contrast->restoreCe();
+					else
+						contrast->enableCe(false);
+				}
+
+				DenoiseAlgorithm *denoise =
+					dynamic_cast<DenoiseAlgorithm *>(controller_.getAlgorithm("denoise"));
+				if (denoise) {
+					/* \todo - make the HDR mode say what denoise it wants? */
+					if (mode->second == "Night")
+						denoise->setConfig("night");
+					else if (mode->second == "SingleExposure")
+						denoise->setConfig("hdr");
+					/* MultiExposure doesn't need extra extra denoise. */
+					else
+						denoise->setConfig("normal");
+				}
+			} else
 				LOG(IPARPI, Warning)
 					<< "HDR mode " << mode->second << " not supported";
 
@@ -1354,12 +1393,31 @@ void IpaBase::reportMetadata(unsigned in
 		libcameraMetadata_.set(controls::AfPauseState, p);
 	}
 
-	const HdrStatus *hdrStatus = rpiMetadata.getLocked<HdrStatus>("hdr.status");
-	if (hdrStatus) {
-		if (hdrStatus->channel == "short")
+	/*
+	 * THe HDR algorithm sets the HDR channel into the agc.status at the time that those
+	 * AGC parameters were calculated several frames ago, so it comes back to us now in
+	 * the delayed_status. If this frame is too soon after a mode switch for the
+	 * delayed_status to be available, we use the HDR status that came out of the
+	 * switchMode call.
+	 */
+	const AgcStatus *agcStatus = rpiMetadata.getLocked<AgcStatus>("agc.delayed_status");
+	const HdrStatus &hdrStatus = agcStatus ? agcStatus->hdr : hdrStatus_;
+	if (!hdrStatus.mode.empty() && hdrStatus.mode != "Off") {
+		int32_t hdrMode = controls::HdrModeOff;
+		for (auto const &[mode, name] : HdrModeTable) {
+			if (hdrStatus.mode == name) {
+				hdrMode = mode;
+				break;
+			}
+		}
+		libcameraMetadata_.set(controls::HdrMode, hdrMode);
+
+		if (hdrStatus.channel == "short")
 			libcameraMetadata_.set(controls::HdrChannel, controls::HdrChannelShort);
-		else if (hdrStatus->channel == "long")
+		else if (hdrStatus.channel == "long")
 			libcameraMetadata_.set(controls::HdrChannel, controls::HdrChannelLong);
+		else if (hdrStatus.channel == "medium")
+			libcameraMetadata_.set(controls::HdrChannel, controls::HdrChannelMedium);
 		else
 			libcameraMetadata_.set(controls::HdrChannel, controls::HdrChannelNone);
 	}
diff -pruN 0.2.0-3/src/ipa/rpi/common/ipa_base.h 0.3.0-1/src/ipa/rpi/common/ipa_base.h
--- 0.2.0-3/src/ipa/rpi/common/ipa_base.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/common/ipa_base.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Raspberry Pi Ltd
  *
- * ipa_base.h - Raspberry Pi IPA base class
+ * Raspberry Pi IPA base class
  */
 #pragma once
 
@@ -22,6 +22,7 @@
 #include "controller/agc_status.h"
 #include "controller/camera_mode.h"
 #include "controller/controller.h"
+#include "controller/hdr_status.h"
 #include "controller/metadata.h"
 
 namespace libcamera {
@@ -48,6 +49,11 @@ public:
 	void processStats(const ProcessParams &params) override;
 
 protected:
+	bool monoSensor()
+	{
+		return monoSensor_;
+	}
+
 	/* Raspberry Pi controller specific defines. */
 	std::unique_ptr<RPiController::CamHelper> helper_;
 	RPiController::Controller controller_;
@@ -64,6 +70,12 @@ protected:
 	ControlList libcameraMetadata_;
 	bool statsMetadataOutput_;
 
+	/* Remember the HDR status after a mode switch. */
+	HdrStatus hdrStatus_;
+
+	/* Whether the stitch block (if available) needs to swap buffers. */
+	bool stitchSwapBuffers_;
+
 private:
 	/* Number of metadata objects available in the context list. */
 	static constexpr unsigned int numMetadataContexts = 16;
diff -pruN 0.2.0-3/src/ipa/rpi/controller/af_status.h 0.3.0-1/src/ipa/rpi/controller/af_status.h
--- 0.2.0-3/src/ipa/rpi/controller/af_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/af_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Raspberry Pi Ltd
  *
- * af_status.h - AF control algorithm status
+ * AF control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/agc_algorithm.h 0.3.0-1/src/ipa/rpi/controller/agc_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/agc_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/agc_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * agc_algorithm.h - AGC/AEC control algorithm interface
+ * AGC/AEC control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/agc_status.h 0.3.0-1/src/ipa/rpi/controller/agc_status.h
--- 0.2.0-3/src/ipa/rpi/controller/agc_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/agc_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * agc_status.h - AGC/AEC control algorithm status
+ * AGC/AEC control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/algorithm.cpp 0.3.0-1/src/ipa/rpi/controller/algorithm.cpp
--- 0.2.0-3/src/ipa/rpi/controller/algorithm.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/algorithm.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * algorithm.cpp - ISP control algorithms
+ * ISP control algorithms
  */
 
 #include "algorithm.h"
diff -pruN 0.2.0-3/src/ipa/rpi/controller/algorithm.h 0.3.0-1/src/ipa/rpi/controller/algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * algorithm.h - ISP control algorithm interface
+ * ISP control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/alsc_status.h 0.3.0-1/src/ipa/rpi/controller/alsc_status.h
--- 0.2.0-3/src/ipa/rpi/controller/alsc_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/alsc_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * alsc_status.h - ALSC (auto lens shading correction) control algorithm status
+ * ALSC (auto lens shading correction) control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/awb_algorithm.h 0.3.0-1/src/ipa/rpi/controller/awb_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/awb_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/awb_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * awb_algorithm.h - AWB control algorithm interface
+ * AWB control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/awb_status.h 0.3.0-1/src/ipa/rpi/controller/awb_status.h
--- 0.2.0-3/src/ipa/rpi/controller/awb_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/awb_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * awb_status.h - AWB control algorithm status
+ * AWB control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/black_level_algorithm.h 0.3.0-1/src/ipa/rpi/controller/black_level_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/black_level_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/black_level_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Raspberry Pi Ltd
  *
- * black_level_algorithm.h - black level control algorithm interface
+ * black level control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/black_level_status.h 0.3.0-1/src/ipa/rpi/controller/black_level_status.h
--- 0.2.0-3/src/ipa/rpi/controller/black_level_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/black_level_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * black_level_status.h - black level control algorithm status
+ * black level control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/camera_mode.h 0.3.0-1/src/ipa/rpi/controller/camera_mode.h
--- 0.2.0-3/src/ipa/rpi/controller/camera_mode.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/camera_mode.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2020, Raspberry Pi Ltd
  *
- * camera_mode.h - description of a particular operating mode of a sensor
+ * description of a particular operating mode of a sensor
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/ccm_algorithm.h 0.3.0-1/src/ipa/rpi/controller/ccm_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/ccm_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/ccm_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * ccm_algorithm.h - CCM (colour correction matrix) control algorithm interface
+ * CCM (colour correction matrix) control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/ccm_status.h 0.3.0-1/src/ipa/rpi/controller/ccm_status.h
--- 0.2.0-3/src/ipa/rpi/controller/ccm_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/ccm_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * ccm_status.h - CCM (colour correction matrix) control algorithm status
+ * CCM (colour correction matrix) control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/contrast_algorithm.h 0.3.0-1/src/ipa/rpi/controller/contrast_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/contrast_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/contrast_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * contrast_algorithm.h - contrast (gamma) control algorithm interface
+ * contrast (gamma) control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/contrast_status.h 0.3.0-1/src/ipa/rpi/controller/contrast_status.h
--- 0.2.0-3/src/ipa/rpi/controller/contrast_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/contrast_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * contrast_status.h - contrast (gamma) control algorithm status
+ * contrast (gamma) control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/controller.cpp 0.3.0-1/src/ipa/rpi/controller/controller.cpp
--- 0.2.0-3/src/ipa/rpi/controller/controller.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/controller.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * controller.cpp - ISP controller
+ * ISP controller
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/controller.h 0.3.0-1/src/ipa/rpi/controller/controller.h
--- 0.2.0-3/src/ipa/rpi/controller/controller.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/controller.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * controller.h - ISP controller interface
+ * ISP controller interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/denoise_algorithm.h 0.3.0-1/src/ipa/rpi/controller/denoise_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/denoise_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/denoise_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Raspberry Pi Ltd
  *
- * denoise.h - Denoise control algorithm interface
+ * Denoise control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/denoise_status.h 0.3.0-1/src/ipa/rpi/controller/denoise_status.h
--- 0.2.0-3/src/ipa/rpi/controller/denoise_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/denoise_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Raspberry Pi Ltd
  *
- * denoise_status.h - Denoise control algorithm status
+ * Denoise control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/device_status.cpp 0.3.0-1/src/ipa/rpi/controller/device_status.cpp
--- 0.2.0-3/src/ipa/rpi/controller/device_status.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/device_status.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Raspberry Pi Ltd
  *
- * device_status.cpp - device (image sensor) status
+ * device (image sensor) status
  */
 #include "device_status.h"
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/device_status.h 0.3.0-1/src/ipa/rpi/controller/device_status.h
--- 0.2.0-3/src/ipa/rpi/controller/device_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/device_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Raspberry Pi Ltd
  *
- * device_status.h - device (image sensor) status
+ * device (image sensor) status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/dpc_status.h 0.3.0-1/src/ipa/rpi/controller/dpc_status.h
--- 0.2.0-3/src/ipa/rpi/controller/dpc_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/dpc_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * dpc_status.h - DPC (defective pixel correction) control algorithm status
+ * DPC (defective pixel correction) control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/geq_status.h 0.3.0-1/src/ipa/rpi/controller/geq_status.h
--- 0.2.0-3/src/ipa/rpi/controller/geq_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/geq_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * geq_status.h - GEQ (green equalisation) control algorithm status
+ * GEQ (green equalisation) control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/hdr_algorithm.h 0.3.0-1/src/ipa/rpi/controller/hdr_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/hdr_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/hdr_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Raspberry Pi Ltd
  *
- * hdr_algorithm.h - HDR control algorithm interface
+ * HDR control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/hdr_status.h 0.3.0-1/src/ipa/rpi/controller/hdr_status.h
--- 0.2.0-3/src/ipa/rpi/controller/hdr_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/hdr_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023 Raspberry Pi Ltd
  *
- * hdr_status.h - HDR control algorithm status
+ * HDR control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/histogram.cpp 0.3.0-1/src/ipa/rpi/controller/histogram.cpp
--- 0.2.0-3/src/ipa/rpi/controller/histogram.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/histogram.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * histogram.cpp - histogram calculations
+ * histogram calculations
  */
 #include <math.h>
 #include <stdio.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/histogram.h 0.3.0-1/src/ipa/rpi/controller/histogram.h
--- 0.2.0-3/src/ipa/rpi/controller/histogram.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/histogram.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * histogram.h - histogram calculation interface
+ * histogram calculation interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/lux_status.h 0.3.0-1/src/ipa/rpi/controller/lux_status.h
--- 0.2.0-3/src/ipa/rpi/controller/lux_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/lux_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * lux_status.h - Lux control algorithm status
+ * Lux control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/metadata.h 0.3.0-1/src/ipa/rpi/controller/metadata.h
--- 0.2.0-3/src/ipa/rpi/controller/metadata.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/metadata.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Raspberry Pi Ltd
  *
- * metadata.h - general metadata class
+ * general metadata class
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/noise_status.h 0.3.0-1/src/ipa/rpi/controller/noise_status.h
--- 0.2.0-3/src/ipa/rpi/controller/noise_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/noise_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * noise_status.h - Noise control algorithm status
+ * Noise control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/pdaf_data.h 0.3.0-1/src/ipa/rpi/controller/pdaf_data.h
--- 0.2.0-3/src/ipa/rpi/controller/pdaf_data.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/pdaf_data.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Raspberry Pi Ltd
  *
- * pdaf_data.h - PDAF Metadata
+ * PDAF Metadata
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/pwl.cpp 0.3.0-1/src/ipa/rpi/controller/pwl.cpp
--- 0.2.0-3/src/ipa/rpi/controller/pwl.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/pwl.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * pwl.cpp - piecewise linear functions
+ * piecewise linear functions
  */
 
 #include <cassert>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/pwl.h 0.3.0-1/src/ipa/rpi/controller/pwl.h
--- 0.2.0-3/src/ipa/rpi/controller/pwl.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/pwl.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * pwl.h - piecewise linear functions interface
+ * piecewise linear functions interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/region_stats.h 0.3.0-1/src/ipa/rpi/controller/region_stats.h
--- 0.2.0-3/src/ipa/rpi/controller/region_stats.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/region_stats.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Raspberry Pi Ltd
  *
- * region_stats.h - Raspberry Pi region based statistics container
+ * Raspberry Pi region based statistics container
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/af.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/af.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/af.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/af.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022-2023, Raspberry Pi Ltd
  *
- * af.cpp - Autofocus control algorithm
+ * Autofocus control algorithm
  */
 
 #include "af.h"
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/af.h 0.3.0-1/src/ipa/rpi/controller/rpi/af.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/af.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/af.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022-2023, Raspberry Pi Ltd
  *
- * af.h - Autofocus control algorithm
+ * Autofocus control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/agc.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/agc.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/agc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/agc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * agc.cpp - AGC/AEC control algorithm
+ * AGC/AEC control algorithm
  */
 
 #include "agc.h"
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/agc.h 0.3.0-1/src/ipa/rpi/controller/rpi/agc.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/agc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/agc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * agc.h - AGC/AEC control algorithm
+ * AGC/AEC control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/agc_channel.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/agc_channel.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/agc_channel.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/agc_channel.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Raspberry Pi Ltd
  *
- * agc_channel.cpp - AGC/AEC control algorithm
+ * AGC/AEC control algorithm
  */
 
 #include "agc_channel.h"
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/agc_channel.h 0.3.0-1/src/ipa/rpi/controller/rpi/agc_channel.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/agc_channel.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/agc_channel.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Raspberry Pi Ltd
  *
- * agc_channel.h - AGC/AEC control algorithm
+ * AGC/AEC control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/alsc.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/alsc.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/alsc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/alsc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * alsc.cpp - ALSC (auto lens shading correction) control algorithm
+ * ALSC (auto lens shading correction) control algorithm
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/alsc.h 0.3.0-1/src/ipa/rpi/controller/rpi/alsc.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/alsc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/alsc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * alsc.h - ALSC (auto lens shading correction) control algorithm
+ * ALSC (auto lens shading correction) control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/awb.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/awb.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/awb.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/awb.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * awb.cpp - AWB control algorithm
+ * AWB control algorithm
  */
 
 #include <assert.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/awb.h 0.3.0-1/src/ipa/rpi/controller/rpi/awb.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/awb.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/awb.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * awb.h - AWB control algorithm
+ * AWB control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/black_level.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/black_level.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/black_level.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/black_level.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * black_level.cpp - black level control algorithm
+ * black level control algorithm
  */
 
 #include <math.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/black_level.h 0.3.0-1/src/ipa/rpi/controller/rpi/black_level.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/black_level.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/black_level.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * black_level.h - black level control algorithm
+ * black level control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/cac.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/cac.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/cac.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/cac.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023 Raspberry Pi Ltd
  *
- * cac.cpp - Chromatic Aberration Correction algorithm
+ * Chromatic Aberration Correction algorithm
  */
 #include "cac.h"
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/ccm.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/ccm.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/ccm.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/ccm.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * ccm.cpp - CCM (colour correction matrix) control algorithm
+ * CCM (colour correction matrix) control algorithm
  */
 
 #include <libcamera/base/log.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/ccm.h 0.3.0-1/src/ipa/rpi/controller/rpi/ccm.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/ccm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/ccm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * ccm.h - CCM (colour correction matrix) control algorithm
+ * CCM (colour correction matrix) control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/contrast.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/contrast.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/contrast.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/contrast.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * contrast.cpp - contrast (gamma) control algorithm
+ * contrast (gamma) control algorithm
  */
 #include <stdint.h>
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/contrast.h 0.3.0-1/src/ipa/rpi/controller/rpi/contrast.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/contrast.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/contrast.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * contrast.h - contrast (gamma) control algorithm
+ * contrast (gamma) control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/denoise.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/denoise.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/denoise.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/denoise.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022 Raspberry Pi Ltd
  *
- * Denoise.cpp - Denoise (spatial, colour, temporal) control algorithm
+ * Denoise (spatial, colour, temporal) control algorithm
  */
 #include "denoise.h"
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/dpc.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/dpc.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/dpc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/dpc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * dpc.cpp - DPC (defective pixel correction) control algorithm
+ * DPC (defective pixel correction) control algorithm
  */
 
 #include <libcamera/base/log.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/dpc.h 0.3.0-1/src/ipa/rpi/controller/rpi/dpc.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/dpc.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/dpc.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * dpc.h - DPC (defective pixel correction) control algorithm
+ * DPC (defective pixel correction) control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/focus.h 0.3.0-1/src/ipa/rpi/controller/rpi/focus.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/focus.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/focus.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * focus.h - focus algorithm
+ * focus algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/geq.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/geq.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/geq.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/geq.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * geq.cpp - GEQ (green equalisation) control algorithm
+ * GEQ (green equalisation) control algorithm
  */
 
 #include <libcamera/base/log.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/geq.h 0.3.0-1/src/ipa/rpi/controller/rpi/geq.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/geq.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/geq.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * geq.h - GEQ (green equalisation) control algorithm
+ * GEQ (green equalisation) control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/hdr.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/hdr.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/hdr.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/hdr.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,11 +2,13 @@
 /*
  * Copyright (C) 2023 Raspberry Pi Ltd
  *
- * hdr.cpp - HDR control algorithm
+ * HDR control algorithm
  */
 
 #include "hdr.h"
 
+#include <cmath>
+
 #include <libcamera/base/log.h>
 
 #include "../agc_status.h"
@@ -39,25 +41,52 @@ void HdrConfig::read(const libcamera::Ya
 		channelMap[v.get<unsigned int>().value()] = k;
 
 	/* Lens shading related parameters. */
-	if (params.contains("spatial_gain")) {
-		spatialGain.read(params["spatial_gain"]);
-		diffusion = params["diffusion"].get<unsigned int>(3);
-		/* Clip to an arbitrary limit just to stop typos from killing the system! */
-		const unsigned int MAX_DIFFUSION = 15;
-		if (diffusion > MAX_DIFFUSION) {
-			diffusion = MAX_DIFFUSION;
-			LOG(RPiHdr, Warning) << "Diffusion value clipped to " << MAX_DIFFUSION;
-		}
+	if (params.contains("spatial_gain_curve")) {
+		spatialGainCurve.read(params["spatial_gain_curve"]);
+	} else if (params.contains("spatial_gain")) {
+		double spatialGain = params["spatial_gain"].get<double>(2.0);
+		spatialGainCurve.append(0.0, spatialGain);
+		spatialGainCurve.append(0.01, spatialGain);
+		spatialGainCurve.append(0.06, 1.0); /* maybe make this programmable? */
+		spatialGainCurve.append(1.0, 1.0);
+	}
+
+	diffusion = params["diffusion"].get<unsigned int>(3);
+	/* Clip to an arbitrary limit just to stop typos from killing the system! */
+	const unsigned int MAX_DIFFUSION = 15;
+	if (diffusion > MAX_DIFFUSION) {
+		diffusion = MAX_DIFFUSION;
+		LOG(RPiHdr, Warning) << "Diffusion value clipped to " << MAX_DIFFUSION;
 	}
 
 	/* Read any tonemap parameters. */
 	tonemapEnable = params["tonemap_enable"].get<int>(0);
-	detailConstant = params["detail_constant"].get<uint16_t>(50);
-	detailSlope = params["detail_slope"].get<double>(8.0);
+	detailConstant = params["detail_constant"].get<uint16_t>(0);
+	detailSlope = params["detail_slope"].get<double>(0.0);
 	iirStrength = params["iir_strength"].get<double>(8.0);
 	strength = params["strength"].get<double>(1.5);
 	if (tonemapEnable)
 		tonemap.read(params["tonemap"]);
+	speed = params["speed"].get<double>(1.0);
+	if (params.contains("hi_quantile_targets")) {
+		hiQuantileTargets = params["hi_quantile_targets"].getList<double>().value();
+		if (hiQuantileTargets.empty() || hiQuantileTargets.size() % 2)
+			LOG(RPiHdr, Fatal) << "hi_quantile_targets much be even and non-empty";
+	} else
+		hiQuantileTargets = { 0.95, 0.65, 0.5, 0.28, 0.3, 0.25 };
+	hiQuantileMaxGain = params["hi_quantile_max_gain"].get<double>(1.6);
+	if (params.contains("quantile_targets")) {
+		quantileTargets = params["quantile_targets"].getList<double>().value();
+		if (quantileTargets.empty() || quantileTargets.size() % 2)
+			LOG(RPiHdr, Fatal) << "quantile_targets much be even and non-empty";
+	} else
+		quantileTargets = { 0.2, 0.03, 1.0, 0.15 };
+	powerMin = params["power_min"].get<double>(0.65);
+	powerMax = params["power_max"].get<double>(1.0);
+	if (params.contains("contrast_adjustments")) {
+		contrastAdjustments = params["contrast_adjustments"].getList<double>().value();
+	} else
+		contrastAdjustments = { 0.5, 0.75 };
 
 	/* Read any stitch parameters. */
 	stitchEnable = params["stitch_enable"].get<int>(0);
@@ -159,7 +188,7 @@ void Hdr::prepare(Metadata *imageMetadat
 	}
 
 	HdrConfig &config = it->second;
-	if (config.spatialGain.empty())
+	if (config.spatialGainCurve.empty())
 		return;
 
 	AlscStatus alscStatus{}; /* some compilers seem to require the braces */
@@ -205,10 +234,61 @@ bool Hdr::updateTonemap([[maybe_unused]]
 		return true;
 
 	/*
-	 * If we wanted to build or adjust tonemaps dynamically, this would be the place
-	 * to do it. But for now we seem to be getting by without.
+	 * Create a tonemap dynamically. We have three ingredients.
+	 *
+	 * 1. We have a list of "hi quantiles" and "targets". We use these to judge if
+	 * the image does seem to be reasonably saturated. If it isn't, we calculate
+	 * a gain that we will feed as a linear factor into the tonemap generation.
+	 * This prevents unsaturated images from beoming quite so "flat".
+	 *
+	 * 2. We have a list of quantile/target pairs for the bottom of the histogram.
+	 * We use these to calculate how much gain we must apply to the bottom of the
+	 * tonemap. We apply this gain as a power curve so as not to blow out the top
+	 * end.
+	 *
+	 * 3. Finally, when we generate the tonemap, we have some contrast adjustments
+	 * for the bottom because we know that power curves can start quite steeply and
+	 * cause a washed-out look.
 	 */
 
+	/* Compute the linear gain from the headroom for saturation at the top. */
+	double gain = 10; /* arbitrary, but hiQuantileMaxGain will clamp it later */
+	for (unsigned int i = 0; i < config.hiQuantileTargets.size(); i += 2) {
+		double quantile = config.hiQuantileTargets[i];
+		double target = config.hiQuantileTargets[i + 1];
+		double value = stats->yHist.interQuantileMean(quantile, 1.0) / 1024.0;
+		double newGain = target / (value + 0.01);
+		gain = std::min(gain, newGain);
+	}
+	gain = std::clamp(gain, 1.0, config.hiQuantileMaxGain);
+
+	/* Compute the power curve from the amount of gain needed at the bottom. */
+	double min_power = 2; /* arbitrary, but config.powerMax will clamp it later */
+	for (unsigned int i = 0; i < config.quantileTargets.size(); i += 2) {
+		double quantile = config.quantileTargets[i];
+		double target = config.quantileTargets[i + 1];
+		double value = stats->yHist.interQuantileMean(0, quantile) / 1024.0;
+		value = std::min(value * gain, 1.0);
+		double power = log(target + 1e-6) / log(value + 1e-6);
+		min_power = std::min(min_power, power);
+	}
+	double power = std::clamp(min_power, config.powerMin, config.powerMax);
+
+	/* Generate the tonemap, including the contrast adjustment factors. */
+	Pwl tonemap;
+	tonemap.append(0, 0);
+	for (unsigned int i = 0; i <= 6; i++) {
+		double x = 1 << (i + 9); /* x loops from 512 to 32768 inclusive */
+		double y = pow(std::min(x * gain, 65535.0) / 65536.0, power) * 65536;
+		if (i < config.contrastAdjustments.size())
+			y *= config.contrastAdjustments[i];
+		if (!tonemap_.empty())
+			y = y * config.speed + tonemap_.eval(x) * (1 - config.speed);
+		tonemap.append(x, y);
+	}
+	tonemap.append(65535, 65535);
+	tonemap_ = tonemap;
+
 	return true;
 }
 
@@ -255,7 +335,7 @@ static void averageGains(std::vector<dou
 
 void Hdr::updateGains(StatisticsPtr &stats, HdrConfig &config)
 {
-	if (config.spatialGain.empty())
+	if (config.spatialGainCurve.empty())
 		return;
 
 	/* When alternating exposures, only compute these gains for the short frame. */
@@ -270,7 +350,7 @@ void Hdr::updateGains(StatisticsPtr &sta
 		double g = region.val.gSum / counted;
 		double b = region.val.bSum / counted;
 		double brightness = std::max({ r, g, b }) / 65535;
-		gains_[0][i] = config.spatialGain.eval(brightness);
+		gains_[0][i] = config.spatialGainCurve.eval(brightness);
 	}
 
 	/* Ping-pong between the two gains_ buffers. */
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/hdr.h 0.3.0-1/src/ipa/rpi/controller/rpi/hdr.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/hdr.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/hdr.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Raspberry Pi Ltd
  *
- * hdr.h - HDR control algorithm
+ * HDR control algorithm
  */
 #pragma once
 
@@ -26,7 +26,7 @@ struct HdrConfig {
 	std::map<unsigned int, std::string> channelMap;
 
 	/* Lens shading related parameters. */
-	Pwl spatialGain; /* Brightness to gain curve for different image regions. */
+	Pwl spatialGainCurve; /* Brightness to gain curve for different image regions. */
 	unsigned int diffusion; /* How much to diffuse the gain spatially. */
 
 	/* Tonemap related parameters. */
@@ -36,6 +36,14 @@ struct HdrConfig {
 	double iirStrength;
 	double strength;
 	Pwl tonemap;
+	/* These relate to adaptive tonemap calculation. */
+	double speed;
+	std::vector<double> hiQuantileTargets; /* quantiles to check for unsaturated images */
+	double hiQuantileMaxGain; /* the max gain we'll apply when unsaturated */
+	std::vector<double> quantileTargets; /* target values for histogram quantiles */
+	double powerMin; /* minimum tonemap power */
+	double powerMax; /* maximum tonemap power */
+	std::vector<double> contrastAdjustments; /* any contrast adjustment factors */
 
 	/* Stitch related parameters. */
 	bool stitchEnable;
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/lux.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/lux.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/lux.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/lux.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * lux.cpp - Lux control algorithm
+ * Lux control algorithm
  */
 #include <math.h>
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/lux.h 0.3.0-1/src/ipa/rpi/controller/rpi/lux.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/lux.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/lux.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * lux.h - Lux control algorithm
+ * Lux control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/noise.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/noise.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/noise.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/noise.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * noise.cpp - Noise control algorithm
+ * Noise control algorithm
  */
 
 #include <math.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/noise.h 0.3.0-1/src/ipa/rpi/controller/rpi/noise.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/noise.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/noise.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * noise.h - Noise control algorithm
+ * Noise control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/saturation.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/saturation.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/saturation.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/saturation.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022 Raspberry Pi Ltd
  *
- * saturation.cpp - Saturation control algorithm
+ * Saturation control algorithm
  */
 #include "saturation.h"
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/sdn.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/sdn.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/sdn.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/sdn.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,10 +2,11 @@
 /*
  * Copyright (C) 2019-2021, Raspberry Pi Ltd
  *
- * sdn.cpp - SDN (spatial denoise) control algorithm
+ * SDN (spatial denoise) control algorithm
  */
 
 #include <libcamera/base/log.h>
+#include <libcamera/base/utils.h>
 
 #include "../denoise_status.h"
 #include "../noise_status.h"
@@ -60,7 +61,7 @@ void Sdn::prepare(Metadata *imageMetadat
 	status.noiseConstant = noiseStatus.noiseConstant * deviation_;
 	status.noiseSlope = noiseStatus.noiseSlope * deviation_;
 	status.strength = strength_;
-	status.mode = static_cast<std::underlying_type_t<DenoiseMode>>(mode_);
+	status.mode = utils::to_underlying(mode_);
 	imageMetadata->set("denoise.status", status);
 	LOG(RPiSdn, Debug)
 		<< "programmed constant " << status.noiseConstant
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/sdn.h 0.3.0-1/src/ipa/rpi/controller/rpi/sdn.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/sdn.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/sdn.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * sdn.h - SDN (spatial denoise) control algorithm
+ * SDN (spatial denoise) control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/sharpen.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/sharpen.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/sharpen.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/sharpen.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * sharpen.cpp - sharpening control algorithm
+ * sharpening control algorithm
  */
 
 #include <math.h>
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/sharpen.h 0.3.0-1/src/ipa/rpi/controller/rpi/sharpen.h
--- 0.2.0-3/src/ipa/rpi/controller/rpi/sharpen.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/sharpen.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * sharpen.h - sharpening control algorithm
+ * sharpening control algorithm
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/rpi/tonemap.cpp 0.3.0-1/src/ipa/rpi/controller/rpi/tonemap.cpp
--- 0.2.0-3/src/ipa/rpi/controller/rpi/tonemap.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/rpi/tonemap.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022 Raspberry Pi Ltd
  *
- * tonemap.cpp - Tonemap control algorithm
+ * Tonemap control algorithm
  */
 #include "tonemap.h"
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/saturation_status.h 0.3.0-1/src/ipa/rpi/controller/saturation_status.h
--- 0.2.0-3/src/ipa/rpi/controller/saturation_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/saturation_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022 Raspberry Pi Ltd
  *
- * saturation_status.h - Saturation control algorithm status
+ * Saturation control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/sharpen_algorithm.h 0.3.0-1/src/ipa/rpi/controller/sharpen_algorithm.h
--- 0.2.0-3/src/ipa/rpi/controller/sharpen_algorithm.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/sharpen_algorithm.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * sharpen_algorithm.h - sharpness control algorithm interface
+ * sharpness control algorithm interface
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/sharpen_status.h 0.3.0-1/src/ipa/rpi/controller/sharpen_status.h
--- 0.2.0-3/src/ipa/rpi/controller/sharpen_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/sharpen_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Raspberry Pi Ltd
  *
- * sharpen_status.h - Sharpen control algorithm status
+ * Sharpen control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/statistics.h 0.3.0-1/src/ipa/rpi/controller/statistics.h
--- 0.2.0-3/src/ipa/rpi/controller/statistics.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/statistics.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Raspberry Pi Ltd
  *
- * statistics.h - Raspberry Pi generic statistics structure
+ * Raspberry Pi generic statistics structure
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/stitch_status.h 0.3.0-1/src/ipa/rpi/controller/stitch_status.h
--- 0.2.0-3/src/ipa/rpi/controller/stitch_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/stitch_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023 Raspberry Pi Ltd
  *
- * stitch_status.h - stitch control algorithm status
+ * stitch control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/controller/tonemap_status.h 0.3.0-1/src/ipa/rpi/controller/tonemap_status.h
--- 0.2.0-3/src/ipa/rpi/controller/tonemap_status.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/controller/tonemap_status.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022 Raspberry Pi Ltd
  *
- * hdr.h - Tonemap control algorithm status
+ * Tonemap control algorithm status
  */
 #pragma once
 
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx219.json 0.3.0-1/src/ipa/rpi/vc4/data/imx219.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx219.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx219.json	2024-05-19 15:54:11.000000000 +0000
@@ -131,282 +131,308 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -651,20 +677,19 @@
         {
             "rpi.sharpen": { }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
 }
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx219_noir.json 0.3.0-1/src/ipa/rpi/vc4/data/imx219_noir.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx219_noir.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx219_noir.json	2024-05-19 15:54:11.000000000 +0000
@@ -47,282 +47,308 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -585,20 +611,19 @@
         {
             "rpi.sharpen": { }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
 }
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx290.json 0.3.0-1/src/ipa/rpi/vc4/data/imx290.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx290.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx290.json	2024-05-19 15:54:11.000000000 +0000
@@ -52,15 +52,24 @@
                 {
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     },
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx296.json 0.3.0-1/src/ipa/rpi/vc4/data/imx296.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx296.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx296.json	2024-05-19 15:54:11.000000000 +0000
@@ -135,15 +135,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
@@ -431,4 +440,4 @@
             }
         }
     ]
-}
+}
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx296_mono.json 0.3.0-1/src/ipa/rpi/vc4/data/imx296_mono.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx296_mono.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx296_mono.json	2024-05-19 15:54:11.000000000 +0000
@@ -38,15 +38,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
@@ -228,4 +237,4 @@
             }
         }
     ]
-}
+}
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx378.json 0.3.0-1/src/ipa/rpi/vc4/data/imx378.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx378.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx378.json	2024-05-19 15:54:11.000000000 +0000
@@ -133,15 +133,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx477.json 0.3.0-1/src/ipa/rpi/vc4/data/imx477.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx477.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx477.json	2024-05-19 15:54:11.000000000 +0000
@@ -115,16 +115,16 @@
                 "ct_curve":
                 [
                     2360.0, 0.6009, 0.3093,
-                    2848.0, 0.5071, 0.4000,
+                    2848.0, 0.5071, 0.4,
                     2903.0, 0.4905, 0.4392,
                     3628.0, 0.4261, 0.5564,
                     3643.0, 0.4228, 0.5623,
-                    4660.0, 0.3529, 0.6800,
-                    5579.0, 0.3227, 0.7000,
-                    6125.0, 0.3129, 0.7100,
-                    6671.0, 0.3065, 0.7200,
-                    7217.0, 0.3014, 0.7300,
-                    7763.0, 0.2950, 0.7400,
+                    4660.0, 0.3529, 0.68,
+                    5579.0, 0.3227, 0.7,
+                    6125.0, 0.3129, 0.71,
+                    6671.0, 0.3065, 0.72,
+                    7217.0, 0.3014, 0.73,
+                    7763.0, 0.295, 0.74,
                     9505.0, 0.2524, 0.7856
                 ],
                 "sensitivity_r": 1.05,
@@ -136,282 +136,308 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
+                "channels": [
                     {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-                    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-                    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    }
-		]
-	    }
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -656,20 +682,19 @@
         {
             "rpi.sharpen": { }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
 }
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx477_noir.json 0.3.0-1/src/ipa/rpi/vc4/data/imx477_noir.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx477_noir.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx477_noir.json	2024-05-19 15:54:11.000000000 +0000
@@ -47,282 +47,308 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.3,
-					1000, 0.3
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			]
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.3,
+                                        1000, 0.3
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -612,20 +638,19 @@
         {
             "rpi.sharpen": { }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
 }
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx477_scientific.json 0.3.0-1/src/ipa/rpi/vc4/data/imx477_scientific.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx477_scientific.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx477_scientific.json	2024-05-19 15:54:11.000000000 +0000
@@ -148,15 +148,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx477_v1.json 0.3.0-1/src/ipa/rpi/vc4/data/imx477_v1.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx477_v1.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx477_v1.json	2024-05-19 15:54:11.000000000 +0000
@@ -138,15 +138,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx519.json 0.3.0-1/src/ipa/rpi/vc4/data/imx519.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx519.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx519.json	2024-05-19 15:54:11.000000000 +0000
@@ -133,15 +133,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx708.json 0.3.0-1/src/ipa/rpi/vc4/data/imx708.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx708.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx708.json	2024-05-19 15:54:11.000000000 +0000
@@ -139,255 +139,281 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -627,20 +653,19 @@
                 "map": [ 0.0, 445, 15.0, 925 ]
             }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
-}
+}
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx708_noir.json 0.3.0-1/src/ipa/rpi/vc4/data/imx708_noir.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx708_noir.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx708_noir.json	2024-05-19 15:54:11.000000000 +0000
@@ -139,255 +139,281 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -726,20 +752,19 @@
                 "map": [ 0.0, 445, 15.0, 925 ]
             }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
-}
+}
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx708_wide.json 0.3.0-1/src/ipa/rpi/vc4/data/imx708_wide.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx708_wide.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx708_wide.json	2024-05-19 15:54:11.000000000 +0000
@@ -129,255 +129,281 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -638,20 +664,19 @@
                 "map": [ 0.0, 420, 35.0, 920 ]
             }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
-}
+}
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/imx708_wide_noir.json 0.3.0-1/src/ipa/rpi/vc4/data/imx708_wide_noir.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/imx708_wide_noir.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/imx708_wide_noir.json	2024-05-19 15:54:11.000000000 +0000
@@ -129,255 +129,281 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 15000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 1000, 30000, 60000, 90000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.2,
-					1000, 0.2
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"startup_frames": 5,
-			"convergence_frames": 6,
-			"speed": 0.15
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 0.125,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    },
+                    {
+                        "base_ev": 1.5,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 15000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 1.0, 2.0, 4.0, 6.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 6.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 1000, 30000, 60000, 90000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.2,
+                                        1000, 0.2
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "startup_frames": 5,
+                        "convergence_frames": 6,
+                        "speed": 0.15
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -629,20 +655,19 @@
                 "map": [ 0.0, 420, 35.0, 920 ]
             }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
-}
+}
\ No newline at end of file
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/ov5647.json 0.3.0-1/src/ipa/rpi/vc4/data/ov5647.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/ov5647.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/ov5647.json	2024-05-19 15:54:11.000000000 +0000
@@ -131,285 +131,309 @@
         {
             "rpi.agc":
             {
-		"channels":
-		[
-		    {
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"base_ev": 1.25
-		    },
-		    {
-			"base_ev": 0.125,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"base_ev": 1.25
-		    },
-		    {
-			"base_ev": 1.5,
-			"metering_modes":
-			{
-			    "centre-weighted":
-			    {
-				"weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
-			    },
-			    "spot":
-			    {
-				"weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
-			    },
-			    "matrix":
-			    {
-				"weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
-			    }
-			},
-			"exposure_modes":
-			{
-			    "normal":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 66666 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "short":
-			    {
-				"shutter": [ 100, 5000, 10000, 20000, 33333 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
-			    },
-			    "long":
-			    {
-				"shutter": [ 100, 10000, 30000, 60000, 120000 ],
-				"gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
-			    }
-			},
-			"constraint_modes":
-			{
-			    "normal": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				}
-			    ],
-			    "highlight": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.5,
-					1000, 0.5
-				    ]
-				},
-				{
-				    "bound": "UPPER",
-				    "q_lo": 0.98,
-				    "q_hi": 1.0,
-				    "y_target":
-				    [
-					0, 0.8,
-					1000, 0.8
-				    ]
-				}
-			    ],
-			    "shadows": [
-				{
-				    "bound": "LOWER",
-				    "q_lo": 0.0,
-				    "q_hi": 0.5,
-				    "y_target":
-				    [
-					0, 0.17,
-					1000, 0.17
-				    ]
-				}
-			    ]
-			},
-			"y_target":
-			[
-			    0, 0.16,
-			    1000, 0.165,
-			    10000, 0.17
-			],
-			"base_ev": 1.25
-		    }
-		]
-	    }
+                "channels": [
+                    {
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ],
+                        "base_ev": 1.25
+                    },
+                    {
+                        "base_ev": 1.25,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    },
+                    {
+                        "base_ev": 1.25,
+                        "metering_modes":
+                        {
+                            "centre-weighted":
+                            {
+                                "weights":
+                                [
+                                    3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                                ]
+                            },
+                            "spot":
+                            {
+                                "weights":
+                                [
+                                    2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                                ]
+                            },
+                            "matrix":
+                            {
+                                "weights":
+                                [
+                                    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                                ]
+                            }
+                        },
+                        "exposure_modes":
+                        {
+                            "normal":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 66666 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "short":
+                            {
+                                "shutter": [ 100, 5000, 10000, 20000, 33333 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 8.0 ]
+                            },
+                            "long":
+                            {
+                                "shutter": [ 100, 10000, 30000, 60000, 120000 ],
+                                "gain": [ 1.0, 2.0, 4.0, 6.0, 12.0 ]
+                            }
+                        },
+                        "constraint_modes":
+                        {
+                            "normal": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                }
+                            ],
+                            "highlight": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.5,
+                                        1000, 0.5
+                                    ]
+                                },
+                                {
+                                    "bound": "UPPER",
+                                    "q_lo": 0.98,
+                                    "q_hi": 1.0,
+                                    "y_target":
+                                    [
+                                        0, 0.8,
+                                        1000, 0.8
+                                    ]
+                                }
+                            ],
+                            "shadows": [
+                                {
+                                    "bound": "LOWER",
+                                    "q_lo": 0.0,
+                                    "q_hi": 0.5,
+                                    "y_target":
+                                    [
+                                        0, 0.17,
+                                        1000, 0.17
+                                    ]
+                                }
+                            ]
+                        },
+                        "y_target":
+                        [
+                            0, 0.16,
+                            1000, 0.165,
+                            10000, 0.17
+                        ]
+                    }
+                ]
+            }
         },
         {
             "rpi.alsc":
@@ -654,20 +678,19 @@
         {
             "rpi.sharpen": { }
         },
-	{
-	    "rpi.hdr":
-	    {
-		"MultiExposure":
-		{
-		    "cadence": [ 1, 2 ],
-		    "channel_map": { "short": 1, "long": 2 }
-		},
-		"SingleExposure":
-		{
-		    "cadence": [ 1 ],
-		    "channel_map": { "short": 1 }
-		}
-	    }
-	}
+        {
+            "rpi.hdr":
+            {
+                "MultiExposureUnmerged":
+                {
+                    "cadence": [ 1, 2 ],
+                    "channel_map":
+                    {
+                        "short": 1,
+                        "long": 2
+                    }
+                }
+            }
+        }
     ]
 }
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/ov5647_noir.json 0.3.0-1/src/ipa/rpi/vc4/data/ov5647_noir.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/ov5647_noir.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/ov5647_noir.json	2024-05-19 15:54:11.000000000 +0000
@@ -51,15 +51,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/ov9281_mono.json 0.3.0-1/src/ipa/rpi/vc4/data/ov9281_mono.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/ov9281_mono.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/ov9281_mono.json	2024-05-19 15:54:11.000000000 +0000
@@ -35,7 +35,10 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 4, 4, 4, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            4, 4, 4, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/se327m12.json 0.3.0-1/src/ipa/rpi/vc4/data/se327m12.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/se327m12.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/se327m12.json	2024-05-19 15:54:11.000000000 +0000
@@ -133,15 +133,24 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     },
                     "spot":
                     {
-                        "weights": [ 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+                        ]
                     },
                     "matrix":
                     {
-                        "weights": [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ]
+                        "weights":
+                        [
+                            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/data/uncalibrated.json 0.3.0-1/src/ipa/rpi/vc4/data/uncalibrated.json
--- 0.2.0-3/src/ipa/rpi/vc4/data/uncalibrated.json	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/data/uncalibrated.json	2024-05-19 15:54:11.000000000 +0000
@@ -22,7 +22,10 @@
                 {
                     "centre-weighted":
                     {
-                        "weights": [ 4, 4, 4, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0 ]
+                        "weights":
+                        [
+                            4, 4, 4, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0
+                        ]
                     }
                 },
                 "exposure_modes":
diff -pruN 0.2.0-3/src/ipa/rpi/vc4/vc4.cpp 0.3.0-1/src/ipa/rpi/vc4/vc4.cpp
--- 0.2.0-3/src/ipa/rpi/vc4/vc4.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/rpi/vc4/vc4.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2021, Raspberry Pi Ltd
  *
- * rpi.cpp - Raspberry Pi VC4/BCM2835 ISP IPA.
+ * Raspberry Pi VC4/BCM2835 ISP IPA.
  */
 
 #include <string.h>
@@ -583,7 +583,7 @@ extern "C" {
 const struct IPAModuleInfo ipaModuleInfo = {
 	IPA_MODULE_API_VERSION,
 	1,
-	"PipelineHandlerVc4",
+	"rpi/vc4",
 	"rpi/vc4",
 };
 
diff -pruN 0.2.0-3/src/ipa/simple/black_level.cpp 0.3.0-1/src/ipa/simple/black_level.cpp
--- 0.2.0-3/src/ipa/simple/black_level.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/simple/black_level.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,88 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024, Red Hat Inc.
+ *
+ * black level handling
+ */
+
+#include "black_level.h"
+
+#include <numeric>
+
+#include <libcamera/base/log.h>
+
+namespace libcamera {
+
+LOG_DEFINE_CATEGORY(IPASoftBL)
+
+/**
+ * \class BlackLevel
+ * \brief Object providing black point level for software ISP
+ *
+ * Black level can be provided in hardware tuning files or, if no tuning file is
+ * available for the given hardware, guessed automatically, with less accuracy.
+ * As tuning files are not yet implemented for software ISP, BlackLevel
+ * currently provides only guessed black levels.
+ *
+ * This class serves for tracking black level as a property of the underlying
+ * hardware, not as means of enhancing a particular scene or image.
+ *
+ * The class is supposed to be instantiated for the given camera stream.
+ * The black level can be retrieved using BlackLevel::get() method. It is
+ * initially 0 and may change when updated using BlackLevel::update() method.
+ */
+
+BlackLevel::BlackLevel()
+	: blackLevel_(255), blackLevelSet_(false)
+{
+}
+
+/**
+ * \brief Return the current black level
+ *
+ * \return The black level, in the range from 0 (minimum) to 255 (maximum).
+ * If the black level couldn't be determined yet, return 0.
+ */
+unsigned int BlackLevel::get() const
+{
+	return blackLevelSet_ ? blackLevel_ : 0;
+}
+
+/**
+ * \brief Update black level from the provided histogram
+ * \param[in] yHistogram The histogram to be used for updating black level
+ *
+ * The black level is property of the given hardware, not image. It is updated
+ * only if it has not been yet set or if it is lower than the lowest value seen
+ * so far.
+ */
+void BlackLevel::update(SwIspStats::Histogram &yHistogram)
+{
+	/*
+	 * The constant is selected to be "good enough", not overly conservative or
+	 * aggressive. There is no magic about the given value.
+	 */
+	constexpr float ignoredPercentage_ = 0.02;
+	const unsigned int total =
+		std::accumulate(begin(yHistogram), end(yHistogram), 0);
+	const unsigned int pixelThreshold = ignoredPercentage_ * total;
+	const unsigned int histogramRatio = 256 / SwIspStats::kYHistogramSize;
+	const unsigned int currentBlackIdx = blackLevel_ / histogramRatio;
+
+	for (unsigned int i = 0, seen = 0;
+	     i < currentBlackIdx && i < SwIspStats::kYHistogramSize;
+	     i++) {
+		seen += yHistogram[i];
+		if (seen >= pixelThreshold) {
+			blackLevel_ = i * histogramRatio;
+			blackLevelSet_ = true;
+			LOG(IPASoftBL, Debug)
+				<< "Auto-set black level: "
+				<< i << "/" << SwIspStats::kYHistogramSize
+				<< " (" << 100 * (seen - yHistogram[i]) / total << "% below, "
+				<< 100 * seen / total << "% at or below)";
+			break;
+		}
+	};
+}
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/simple/black_level.h 0.3.0-1/src/ipa/simple/black_level.h
--- 0.2.0-3/src/ipa/simple/black_level.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/simple/black_level.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,28 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024, Red Hat Inc.
+ *
+ * black level handling
+ */
+
+#pragma once
+
+#include <array>
+
+#include "libcamera/internal/software_isp/swisp_stats.h"
+
+namespace libcamera {
+
+class BlackLevel
+{
+public:
+	BlackLevel();
+	unsigned int get() const;
+	void update(SwIspStats::Histogram &yHistogram);
+
+private:
+	unsigned int blackLevel_;
+	bool blackLevelSet_;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/simple/data/meson.build 0.3.0-1/src/ipa/simple/data/meson.build
--- 0.2.0-3/src/ipa/simple/data/meson.build	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/simple/data/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,10 @@
+# SPDX-License-Identifier: CC0-1.0
+
+conf_files = files([
+    'uncalibrated.yaml',
+])
+
+# The install_dir must match the name from the IPAModuleInfo
+install_data(conf_files,
+             install_dir : ipa_data_dir / 'simple',
+             install_tag : 'runtime')
diff -pruN 0.2.0-3/src/ipa/simple/data/uncalibrated.yaml 0.3.0-1/src/ipa/simple/data/uncalibrated.yaml
--- 0.2.0-3/src/ipa/simple/data/uncalibrated.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/simple/data/uncalibrated.yaml	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,5 @@
+# SPDX-License-Identifier: CC0-1.0
+%YAML 1.1
+---
+version: 1
+...
diff -pruN 0.2.0-3/src/ipa/simple/meson.build 0.3.0-1/src/ipa/simple/meson.build
--- 0.2.0-3/src/ipa/simple/meson.build	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/simple/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,30 @@
+# SPDX-License-Identifier: CC0-1.0
+
+ipa_name = 'ipa_soft_simple'
+
+soft_simple_sources = files([
+    'soft_simple.cpp',
+    'black_level.cpp',
+])
+
+mod = shared_module(ipa_name,
+                    [soft_simple_sources, libcamera_generated_ipa_headers],
+                    name_prefix : '',
+                    include_directories : [ipa_includes, libipa_includes],
+                    dependencies : libcamera_private,
+                    link_with : libipa,
+                    install : true,
+                    install_dir : ipa_install_dir)
+
+if ipa_sign_module
+    custom_target(ipa_name + '.so.sign',
+                  input : mod,
+                  output : ipa_name + '.so.sign',
+                  command : [ipa_sign, ipa_priv_key, '@INPUT@', '@OUTPUT@'],
+                  install : false,
+                  build_by_default : true)
+endif
+
+subdir('data')
+
+ipa_names += ipa_name
diff -pruN 0.2.0-3/src/ipa/simple/soft_simple.cpp 0.3.0-1/src/ipa/simple/soft_simple.cpp
--- 0.2.0-3/src/ipa/simple/soft_simple.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/ipa/simple/soft_simple.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,403 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ *
+ * Simple Software Image Processing Algorithm module
+ */
+
+#include <sys/mman.h>
+
+#include <linux/v4l2-controls.h>
+
+#include <libcamera/base/file.h>
+#include <libcamera/base/log.h>
+#include <libcamera/base/shared_fd.h>
+
+#include <libcamera/control_ids.h>
+#include <libcamera/controls.h>
+
+#include <libcamera/ipa/ipa_interface.h>
+#include <libcamera/ipa/ipa_module_info.h>
+#include <libcamera/ipa/soft_ipa_interface.h>
+
+#include "libcamera/internal/software_isp/debayer_params.h"
+#include "libcamera/internal/software_isp/swisp_stats.h"
+#include "libcamera/internal/yaml_parser.h"
+
+#include "libipa/camera_sensor_helper.h"
+
+#include "black_level.h"
+
+namespace libcamera {
+LOG_DEFINE_CATEGORY(IPASoft)
+
+namespace ipa::soft {
+
+/*
+ * The number of bins to use for the optimal exposure calculations.
+ */
+static constexpr unsigned int kExposureBinsCount = 5;
+
+/*
+ * The exposure is optimal when the mean sample value of the histogram is
+ * in the middle of the range.
+ */
+static constexpr float kExposureOptimal = kExposureBinsCount / 2.0;
+
+/*
+ * The below value implements the hysteresis for the exposure adjustment.
+ * It is small enough to have the exposure close to the optimal, and is big
+ * enough to prevent the exposure from wobbling around the optimal value.
+ */
+static constexpr float kExposureSatisfactory = 0.2;
+
+class IPASoftSimple : public ipa::soft::IPASoftInterface
+{
+public:
+	IPASoftSimple()
+		: params_(nullptr), stats_(nullptr), blackLevel_(BlackLevel()),
+		  ignoreUpdates_(0)
+	{
+	}
+
+	~IPASoftSimple();
+
+	int init(const IPASettings &settings,
+		 const SharedFD &fdStats,
+		 const SharedFD &fdParams,
+		 const ControlInfoMap &sensorInfoMap) override;
+	int configure(const ControlInfoMap &sensorInfoMap) override;
+
+	int start() override;
+	void stop() override;
+
+	void processStats(const ControlList &sensorControls) override;
+
+private:
+	void updateExposure(double exposureMSV);
+
+	DebayerParams *params_;
+	SwIspStats *stats_;
+	std::unique_ptr<CameraSensorHelper> camHelper_;
+	ControlInfoMap sensorInfoMap_;
+	BlackLevel blackLevel_;
+
+	int32_t exposureMin_, exposureMax_;
+	int32_t exposure_;
+	double againMin_, againMax_, againMinStep_;
+	double again_;
+	unsigned int ignoreUpdates_;
+};
+
+IPASoftSimple::~IPASoftSimple()
+{
+	if (stats_)
+		munmap(stats_, sizeof(SwIspStats));
+	if (params_)
+		munmap(params_, sizeof(DebayerParams));
+}
+
+int IPASoftSimple::init(const IPASettings &settings,
+			const SharedFD &fdStats,
+			const SharedFD &fdParams,
+			const ControlInfoMap &sensorInfoMap)
+{
+	camHelper_ = CameraSensorHelperFactoryBase::create(settings.sensorModel);
+	if (!camHelper_) {
+		LOG(IPASoft, Warning)
+			<< "Failed to create camera sensor helper for "
+			<< settings.sensorModel;
+	}
+
+	/* Load the tuning data file */
+	File file(settings.configurationFile);
+	if (!file.open(File::OpenModeFlag::ReadOnly)) {
+		int ret = file.error();
+		LOG(IPASoft, Error)
+			<< "Failed to open configuration file "
+			<< settings.configurationFile << ": " << strerror(-ret);
+		return ret;
+	}
+
+	std::unique_ptr<libcamera::YamlObject> data = YamlParser::parse(file);
+	if (!data)
+		return -EINVAL;
+
+	/* \todo Use the IPA configuration file for real. */
+	unsigned int version = (*data)["version"].get<uint32_t>(0);
+	LOG(IPASoft, Debug) << "Tuning file version " << version;
+
+	params_ = nullptr;
+	stats_ = nullptr;
+
+	if (!fdStats.isValid()) {
+		LOG(IPASoft, Error) << "Invalid Statistics handle";
+		return -ENODEV;
+	}
+
+	if (!fdParams.isValid()) {
+		LOG(IPASoft, Error) << "Invalid Parameters handle";
+		return -ENODEV;
+	}
+
+	{
+		void *mem = mmap(nullptr, sizeof(DebayerParams), PROT_WRITE,
+				 MAP_SHARED, fdParams.get(), 0);
+		if (mem == MAP_FAILED) {
+			LOG(IPASoft, Error) << "Unable to map Parameters";
+			return -errno;
+		}
+
+		params_ = static_cast<DebayerParams *>(mem);
+	}
+
+	{
+		void *mem = mmap(nullptr, sizeof(SwIspStats), PROT_READ,
+				 MAP_SHARED, fdStats.get(), 0);
+		if (mem == MAP_FAILED) {
+			LOG(IPASoft, Error) << "Unable to map Statistics";
+			return -errno;
+		}
+
+		stats_ = static_cast<SwIspStats *>(mem);
+	}
+
+	/*
+	 * Check if the sensor driver supports the controls required by the
+	 * Soft IPA.
+	 * Don't save the min and max control values yet, as e.g. the limits
+	 * for V4L2_CID_EXPOSURE depend on the configured sensor resolution.
+	 */
+	if (sensorInfoMap.find(V4L2_CID_EXPOSURE) == sensorInfoMap.end()) {
+		LOG(IPASoft, Error) << "Don't have exposure control";
+		return -EINVAL;
+	}
+
+	if (sensorInfoMap.find(V4L2_CID_ANALOGUE_GAIN) == sensorInfoMap.end()) {
+		LOG(IPASoft, Error) << "Don't have gain control";
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+int IPASoftSimple::configure(const ControlInfoMap &sensorInfoMap)
+{
+	sensorInfoMap_ = sensorInfoMap;
+
+	const ControlInfo &exposureInfo = sensorInfoMap_.find(V4L2_CID_EXPOSURE)->second;
+	const ControlInfo &gainInfo = sensorInfoMap_.find(V4L2_CID_ANALOGUE_GAIN)->second;
+
+	exposureMin_ = exposureInfo.min().get<int32_t>();
+	exposureMax_ = exposureInfo.max().get<int32_t>();
+	if (!exposureMin_) {
+		LOG(IPASoft, Warning) << "Minimum exposure is zero, that can't be linear";
+		exposureMin_ = 1;
+	}
+
+	int32_t againMin = gainInfo.min().get<int32_t>();
+	int32_t againMax = gainInfo.max().get<int32_t>();
+
+	if (camHelper_) {
+		againMin_ = camHelper_->gain(againMin);
+		againMax_ = camHelper_->gain(againMax);
+		againMinStep_ = (againMax_ - againMin_) / 100.0;
+	} else {
+		/*
+		 * The camera sensor gain (g) is usually not equal to the value written
+		 * into the gain register (x). But the way how the AGC algorithm changes
+		 * the gain value to make the total exposure closer to the optimum
+		 * assumes that g(x) is not too far from linear function. If the minimal
+		 * gain is 0, the g(x) is likely to be far from the linear, like
+		 * g(x) = a / (b * x + c). To avoid unexpected changes to the gain by
+		 * the AGC algorithm (abrupt near one edge, and very small near the
+		 * other) we limit the range of the gain values used.
+		 */
+		againMax_ = againMax;
+		if (!againMin) {
+			LOG(IPASoft, Warning)
+				<< "Minimum gain is zero, that can't be linear";
+			againMin_ = std::min(100, againMin / 2 + againMax / 2);
+		}
+		againMinStep_ = 1.0;
+	}
+
+	LOG(IPASoft, Info) << "Exposure " << exposureMin_ << "-" << exposureMax_
+			   << ", gain " << againMin_ << "-" << againMax_
+			   << " (" << againMinStep_ << ")";
+
+	return 0;
+}
+
+int IPASoftSimple::start()
+{
+	return 0;
+}
+
+void IPASoftSimple::stop()
+{
+}
+
+void IPASoftSimple::processStats(const ControlList &sensorControls)
+{
+	/*
+	 * Calculate red and blue gains for AWB.
+	 * Clamp max gain at 4.0, this also avoids 0 division.
+	 */
+	if (stats_->sumR_ <= stats_->sumG_ / 4)
+		params_->gainR = 1024;
+	else
+		params_->gainR = 256 * stats_->sumG_ / stats_->sumR_;
+
+	if (stats_->sumB_ <= stats_->sumG_ / 4)
+		params_->gainB = 1024;
+	else
+		params_->gainB = 256 * stats_->sumG_ / stats_->sumB_;
+
+	/* Green gain and gamma values are fixed */
+	params_->gainG = 256;
+	params_->gamma = 0.5;
+
+	if (ignoreUpdates_ > 0)
+		blackLevel_.update(stats_->yHistogram);
+	params_->blackLevel = blackLevel_.get();
+
+	setIspParams.emit();
+
+	/* \todo Switch to the libipa/algorithm.h API someday. */
+
+	/*
+	 * AE / AGC, use 2 frames delay to make sure that the exposure and
+	 * the gain set have applied to the camera sensor.
+	 * \todo This could be handled better with DelayedControls.
+	 */
+	if (ignoreUpdates_ > 0) {
+		--ignoreUpdates_;
+		return;
+	}
+
+	/*
+	 * Calculate Mean Sample Value (MSV) according to formula from:
+	 * https://www.araa.asn.au/acra/acra2007/papers/paper84final.pdf
+	 */
+	const unsigned int blackLevelHistIdx =
+		params_->blackLevel / (256 / SwIspStats::kYHistogramSize);
+	const unsigned int histogramSize =
+		SwIspStats::kYHistogramSize - blackLevelHistIdx;
+	const unsigned int yHistValsPerBin = histogramSize / kExposureBinsCount;
+	const unsigned int yHistValsPerBinMod =
+		histogramSize / (histogramSize % kExposureBinsCount + 1);
+	int exposureBins[kExposureBinsCount] = {};
+	unsigned int denom = 0;
+	unsigned int num = 0;
+
+	for (unsigned int i = 0; i < histogramSize; i++) {
+		unsigned int idx = (i - (i / yHistValsPerBinMod)) / yHistValsPerBin;
+		exposureBins[idx] += stats_->yHistogram[blackLevelHistIdx + i];
+	}
+
+	for (unsigned int i = 0; i < kExposureBinsCount; i++) {
+		LOG(IPASoft, Debug) << i << ": " << exposureBins[i];
+		denom += exposureBins[i];
+		num += exposureBins[i] * (i + 1);
+	}
+
+	float exposureMSV = static_cast<float>(num) / denom;
+
+	/* Sanity check */
+	if (!sensorControls.contains(V4L2_CID_EXPOSURE) ||
+	    !sensorControls.contains(V4L2_CID_ANALOGUE_GAIN)) {
+		LOG(IPASoft, Error) << "Control(s) missing";
+		return;
+	}
+
+	exposure_ = sensorControls.get(V4L2_CID_EXPOSURE).get<int32_t>();
+	int32_t again = sensorControls.get(V4L2_CID_ANALOGUE_GAIN).get<int32_t>();
+	again_ = camHelper_ ? camHelper_->gain(again) : again;
+
+	updateExposure(exposureMSV);
+
+	ControlList ctrls(sensorInfoMap_);
+
+	ctrls.set(V4L2_CID_EXPOSURE, exposure_);
+	ctrls.set(V4L2_CID_ANALOGUE_GAIN,
+		  static_cast<int32_t>(camHelper_ ? camHelper_->gainCode(again_) : again_));
+
+	ignoreUpdates_ = 2;
+
+	setSensorControls.emit(ctrls);
+
+	LOG(IPASoft, Debug) << "exposureMSV " << exposureMSV
+			    << " exp " << exposure_ << " again " << again_
+			    << " gain R/B " << params_->gainR << "/" << params_->gainB
+			    << " black level " << params_->blackLevel;
+}
+
+void IPASoftSimple::updateExposure(double exposureMSV)
+{
+	/*
+	 * kExpDenominator of 10 gives ~10% increment/decrement;
+	 * kExpDenominator of 5 - about ~20%
+	 */
+	static constexpr uint8_t kExpDenominator = 10;
+	static constexpr uint8_t kExpNumeratorUp = kExpDenominator + 1;
+	static constexpr uint8_t kExpNumeratorDown = kExpDenominator - 1;
+
+	double next;
+
+	if (exposureMSV < kExposureOptimal - kExposureSatisfactory) {
+		next = exposure_ * kExpNumeratorUp / kExpDenominator;
+		if (next - exposure_ < 1)
+			exposure_ += 1;
+		else
+			exposure_ = next;
+		if (exposure_ >= exposureMax_) {
+			next = again_ * kExpNumeratorUp / kExpDenominator;
+			if (next - again_ < againMinStep_)
+				again_ += againMinStep_;
+			else
+				again_ = next;
+		}
+	}
+
+	if (exposureMSV > kExposureOptimal + kExposureSatisfactory) {
+		if (exposure_ == exposureMax_ && again_ > againMin_) {
+			next = again_ * kExpNumeratorDown / kExpDenominator;
+			if (again_ - next < againMinStep_)
+				again_ -= againMinStep_;
+			else
+				again_ = next;
+		} else {
+			next = exposure_ * kExpNumeratorDown / kExpDenominator;
+			if (exposure_ - next < 1)
+				exposure_ -= 1;
+			else
+				exposure_ = next;
+		}
+	}
+
+	exposure_ = std::clamp(exposure_, exposureMin_, exposureMax_);
+	again_ = std::clamp(again_, againMin_, againMax_);
+}
+
+} /* namespace ipa::soft */
+
+/*
+ * External IPA module interface
+ */
+extern "C" {
+const struct IPAModuleInfo ipaModuleInfo = {
+	IPA_MODULE_API_VERSION,
+	0,
+	"simple",
+	"simple",
+};
+
+IPAInterface *ipaCreate()
+{
+	return new ipa::soft::IPASoftSimple();
+}
+
+} /* extern "C" */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/ipa/vimc/vimc.cpp 0.3.0-1/src/ipa/vimc/vimc.cpp
--- 0.2.0-3/src/ipa/vimc/vimc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/ipa/vimc/vimc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * vimc.cpp - Vimc Image Processing Algorithm module
+ * Vimc Image Processing Algorithm module
  */
 #include <libcamera/ipa/vimc_ipa_interface.h>
 
@@ -200,7 +200,7 @@ extern "C" {
 const struct IPAModuleInfo ipaModuleInfo = {
 	IPA_MODULE_API_VERSION,
 	0,
-	"PipelineHandlerVimc",
+	"vimc",
 	"vimc",
 };
 
diff -pruN 0.2.0-3/src/libcamera/base/backtrace.cpp 0.3.0-1/src/libcamera/base/backtrace.cpp
--- 0.2.0-3/src/libcamera/base/backtrace.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/backtrace.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Ideas on Board Oy
  *
- * backtrace.h - Call stack backtraces
+ * Call stack backtraces
  */
 
 #include <libcamera/base/backtrace.h>
diff -pruN 0.2.0-3/src/libcamera/base/bound_method.cpp 0.3.0-1/src/libcamera/base/bound_method.cpp
--- 0.2.0-3/src/libcamera/base/bound_method.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/bound_method.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,11 +2,12 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * bound_method.cpp - Method bind and invocation
+ * Method bind and invocation
  */
 
 #include <libcamera/base/bound_method.h>
 #include <libcamera/base/message.h>
+#include <libcamera/base/object.h>
 #include <libcamera/base/semaphore.h>
 #include <libcamera/base/thread.h>
 
diff -pruN 0.2.0-3/src/libcamera/base/class.cpp 0.3.0-1/src/libcamera/base/class.cpp
--- 0.2.0-3/src/libcamera/base/class.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/class.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * class.cpp - Utilities and helpers for classes
+ * Utilities and helpers for classes
  */
 
 #include <libcamera/base/class.h>
diff -pruN 0.2.0-3/src/libcamera/base/event_dispatcher.cpp 0.3.0-1/src/libcamera/base/event_dispatcher.cpp
--- 0.2.0-3/src/libcamera/base/event_dispatcher.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/event_dispatcher.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_dispatcher.cpp - Event dispatcher
+ * Event dispatcher
  */
 
 #include <libcamera/base/event_dispatcher.h>
diff -pruN 0.2.0-3/src/libcamera/base/event_dispatcher_poll.cpp 0.3.0-1/src/libcamera/base/event_dispatcher_poll.cpp
--- 0.2.0-3/src/libcamera/base/event_dispatcher_poll.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/event_dispatcher_poll.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_dispatcher_poll.cpp - Poll-based event dispatcher
+ * Poll-based event dispatcher
  */
 
 #include <libcamera/base/event_dispatcher_poll.h>
diff -pruN 0.2.0-3/src/libcamera/base/event_notifier.cpp 0.3.0-1/src/libcamera/base/event_notifier.cpp
--- 0.2.0-3/src/libcamera/base/event_notifier.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/event_notifier.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,12 +2,13 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event_notifier.cpp - File descriptor event notifier
+ * File descriptor event notifier
  */
 
 #include <libcamera/base/event_notifier.h>
 
 #include <libcamera/base/event_dispatcher.h>
+#include <libcamera/base/log.h>
 #include <libcamera/base/message.h>
 #include <libcamera/base/thread.h>
 
@@ -20,6 +21,8 @@
 
 namespace libcamera {
 
+LOG_DECLARE_CATEGORY(Event)
+
 /**
  * \class EventNotifier
  * \brief Notify of activity on a file descriptor
@@ -104,6 +107,9 @@ EventNotifier::~EventNotifier()
  */
 void EventNotifier::setEnabled(bool enable)
 {
+	if (!assertThreadBound("EventNotifier can't be enabled from another thread"))
+		return;
+
 	if (enabled_ == enable)
 		return;
 
diff -pruN 0.2.0-3/src/libcamera/base/file.cpp 0.3.0-1/src/libcamera/base/file.cpp
--- 0.2.0-3/src/libcamera/base/file.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/file.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * file.cpp - File I/O operations
+ * File I/O operations
  */
 
 #include <libcamera/base/file.h>
diff -pruN 0.2.0-3/src/libcamera/base/flags.cpp 0.3.0-1/src/libcamera/base/flags.cpp
--- 0.2.0-3/src/libcamera/base/flags.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/flags.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * flags.cpp - Type-safe enum-based bitfields
+ * Type-safe enum-based bitfields
  */
 
 #include <libcamera/base/flags.h>
diff -pruN 0.2.0-3/src/libcamera/base/log.cpp 0.3.0-1/src/libcamera/base/log.cpp
--- 0.2.0-3/src/libcamera/base/log.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/log.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * log.cpp - Logging infrastructure
+ * Logging infrastructure
  */
 
 #include <libcamera/base/log.h>
diff -pruN 0.2.0-3/src/libcamera/base/message.cpp 0.3.0-1/src/libcamera/base/message.cpp
--- 0.2.0-3/src/libcamera/base/message.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/message.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * message.cpp - Message queue support
+ * Message queue support
  */
 
 #include <libcamera/base/message.h>
diff -pruN 0.2.0-3/src/libcamera/base/mutex.cpp 0.3.0-1/src/libcamera/base/mutex.cpp
--- 0.2.0-3/src/libcamera/base/mutex.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/mutex.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * mutex.cpp - Mutex classes with clang thread safety annotation
+ * Mutex classes with clang thread safety annotation
  */
 
 #include <libcamera/base/mutex.h>
diff -pruN 0.2.0-3/src/libcamera/base/object.cpp 0.3.0-1/src/libcamera/base/object.cpp
--- 0.2.0-3/src/libcamera/base/object.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/object.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * object.cpp - Base object
+ * Base object
  */
 
 #include <libcamera/base/object.h>
@@ -40,8 +40,9 @@ LOG_DEFINE_CATEGORY(Object)
  * Object class.
  *
  * Deleting an object from a thread other than the one the object is bound to is
- * unsafe, unless the caller ensures that the object isn't processing any
- * message concurrently.
+ * unsafe, unless the caller ensures that the object's thread is stopped and no
+ * parent or child of the object gets deleted concurrently. See
+ * Object::~Object() for more information.
  *
  * Object slots connected to signals will also run in the context of the
  * object's thread, regardless of whether the signal is emitted in the same or
@@ -84,9 +85,20 @@ Object::Object(Object *parent)
  * Object instances shall be destroyed from the thread they are bound to,
  * otherwise undefined behaviour may occur. If deletion of an Object needs to
  * be scheduled from a different thread, deleteLater() shall be used.
+ *
+ * As an exception to this rule, Object instances may be deleted from a
+ * different thread if the thread the instance is bound to is stopped through
+ * the whole duration of the object's destruction, *and* the parent and children
+ * of the object do not get deleted concurrently. The caller is responsible for
+ * fulfilling those requirements.
+ *
+ * In all cases Object instances shall be deleted before the Thread they are
+ * bound to.
  */
 Object::~Object()
 {
+	ASSERT(Thread::current() == thread_ || !thread_->isRunning());
+
 	/*
 	 * Move signals to a private list to avoid concurrent iteration and
 	 * deletion of items from Signal::disconnect().
@@ -116,8 +128,9 @@ Object::~Object()
  * event loop that the object belongs to. This ensures the object is destroyed
  * from the right context, as required by the libcamera threading model.
  *
- * If this function is called before the thread's event loop is started, the
- * object will be deleted when the event loop starts.
+ * If this function is called before the thread's event loop is started or after
+ * it has stopped, the object will be deleted when the event loop (re)starts. If
+ * this never occurs, the object will be leaked.
  *
  * Deferred deletion can be used to control the destruction context with shared
  * pointers. An object managed with shared pointers is deleted when the last
@@ -213,6 +226,35 @@ void Object::message(Message *msg)
 }
 
 /**
+ * \fn Object::assertThreadBound()
+ * \brief Check if the caller complies with thread-bound constraints
+ * \param[in] message The message to be printed on error
+ *
+ * This function verifies the calling constraints required by the \threadbound
+ * definition. It shall be called at the beginning of member functions of an
+ * Object subclass that are explicitly marked as thread-bound in their
+ * documentation.
+ *
+ * If the thread-bound constraints are not met, the function prints \a message
+ * as an error message. For debug builds, it additionally causes an assertion
+ * error.
+ *
+ * \todo Verify the thread-bound requirements for functions marked as
+ * thread-bound at the class level.
+ *
+ * \return True if the call is thread-bound compliant, false otherwise
+ */
+bool Object::assertThreadBound(const char *message)
+{
+	if (Thread::current() == thread_)
+		return true;
+
+	LOG(Object, Error) << message;
+	ASSERT(false);
+	return false;
+}
+
+/**
  * \fn R Object::invokeMethod()
  * \brief Invoke a method asynchronously on an Object instance
  * \param[in] func The object method to invoke
@@ -259,11 +301,12 @@ void Object::message(Message *msg)
  * Moving an object that has a parent is not allowed, and causes undefined
  * behaviour.
  *
- * \context This function is thread-bound.
+ * \context This function is \threadbound.
  */
 void Object::moveToThread(Thread *thread)
 {
-	ASSERT(Thread::current() == thread_);
+	if (!assertThreadBound("Object can't be moved from another thread"))
+		return;
 
 	if (thread_ == thread)
 		return;
diff -pruN 0.2.0-3/src/libcamera/base/semaphore.cpp 0.3.0-1/src/libcamera/base/semaphore.cpp
--- 0.2.0-3/src/libcamera/base/semaphore.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/semaphore.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * semaphore.cpp - General-purpose counting semaphore
+ * General-purpose counting semaphore
  */
 
 #include <libcamera/base/semaphore.h>
diff -pruN 0.2.0-3/src/libcamera/base/shared_fd.cpp 0.3.0-1/src/libcamera/base/shared_fd.cpp
--- 0.2.0-3/src/libcamera/base/shared_fd.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/shared_fd.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * shared_fd.cpp - File descriptor wrapper with shared ownership
+ * File descriptor wrapper with shared ownership
  */
 
 #include <libcamera/base/shared_fd.h>
diff -pruN 0.2.0-3/src/libcamera/base/signal.cpp 0.3.0-1/src/libcamera/base/signal.cpp
--- 0.2.0-3/src/libcamera/base/signal.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/signal.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,12 +2,13 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * signal.cpp - Signal & slot implementation
+ * Signal & slot implementation
  */
 
 #include <libcamera/base/signal.h>
 
 #include <libcamera/base/mutex.h>
+#include <libcamera/base/object.h>
 
 /**
  * \file base/signal.h
@@ -74,7 +75,7 @@ SignalBase::SlotList SignalBase::slots()
  *
  * Signals and slots are a language construct aimed at communication between
  * objects through the observer pattern without the need for boilerplate code.
- * See http://doc.qt.io/qt-5/signalsandslots.html for more information.
+ * See http://doc.qt.io/qt-6/signalsandslots.html for more information.
  *
  * Signals model events that can be observed from objects unrelated to the event
  * source. Slots are functions that are called in response to a signal. Signals
diff -pruN 0.2.0-3/src/libcamera/base/thread.cpp 0.3.0-1/src/libcamera/base/thread.cpp
--- 0.2.0-3/src/libcamera/base/thread.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/thread.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * thread.cpp - Thread support
+ * Thread support
  */
 
 #include <libcamera/base/thread.h>
@@ -18,6 +18,7 @@
 #include <libcamera/base/log.h>
 #include <libcamera/base/message.h>
 #include <libcamera/base/mutex.h>
+#include <libcamera/base/object.h>
 
 /**
  * \page thread Thread Support
@@ -370,6 +371,12 @@ void Thread::run()
 
 void Thread::finishThread()
 {
+	/*
+	 * Objects may have been scheduled for deletion right before the thread
+	 * exited. Ensure they get deleted now, before the thread stops.
+	 */
+	dispatchMessages(Message::Type::DeferredDelete);
+
 	data_->mutex_.lock();
 	data_->running_ = false;
 	data_->mutex_.unlock();
diff -pruN 0.2.0-3/src/libcamera/base/timer.cpp 0.3.0-1/src/libcamera/base/timer.cpp
--- 0.2.0-3/src/libcamera/base/timer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/timer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * timer.cpp - Generic timer
+ * Generic timer
  */
 
 #include <libcamera/base/timer.h>
@@ -85,10 +85,8 @@ void Timer::start(std::chrono::milliseco
  */
 void Timer::start(std::chrono::steady_clock::time_point deadline)
 {
-	if (Thread::current() != thread()) {
-		LOG(Timer, Error) << "Timer " << this << " << can't be started from another thread";
+	if (!assertThreadBound("Timer can't be started from another thread"))
 		return;
-	}
 
 	deadline_ = deadline;
 
@@ -114,13 +112,11 @@ void Timer::start(std::chrono::steady_cl
  */
 void Timer::stop()
 {
-	if (!isRunning())
+	if (!assertThreadBound("Timer can't be stopped from another thread"))
 		return;
 
-	if (Thread::current() != thread()) {
-		LOG(Timer, Error) << "Timer " << this << " can't be stopped from another thread";
+	if (!isRunning())
 		return;
-	}
 
 	unregisterTimer();
 }
diff -pruN 0.2.0-3/src/libcamera/base/unique_fd.cpp 0.3.0-1/src/libcamera/base/unique_fd.cpp
--- 0.2.0-3/src/libcamera/base/unique_fd.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/unique_fd.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * unique_fd.cpp - File descriptor wrapper that owns a file descriptor
+ * File descriptor wrapper that owns a file descriptor
  */
 
 #include <libcamera/base/unique_fd.h>
diff -pruN 0.2.0-3/src/libcamera/base/utils.cpp 0.3.0-1/src/libcamera/base/utils.cpp
--- 0.2.0-3/src/libcamera/base/utils.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/base/utils.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * utils.cpp - Miscellaneous utility functions
+ * Miscellaneous utility functions
  */
 
 #include <libcamera/base/utils.h>
@@ -517,10 +517,20 @@ double strtod(const char *__restrict npt
 	 * If the libc implementation doesn't provide locale object support,
 	 * assume that strtod() is locale-independent.
 	 */
-	return strtod(nptr, endptr);
+	return ::strtod(nptr, endptr);
 #endif
 }
 
+/**
+ * \fn to_underlying(Enum e)
+ * \brief Convert an enumeration to its underlygin type
+ * \param[in] e Enumeration value to convert
+ *
+ * This function is equivalent to the C++23 std::to_underlying().
+ *
+ * \return The value of e converted to its underlying type
+ */
+
 } /* namespace utils */
 
 #ifndef __DOXYGEN__
diff -pruN 0.2.0-3/src/libcamera/bayer_format.cpp 0.3.0-1/src/libcamera/bayer_format.cpp
--- 0.2.0-3/src/libcamera/bayer_format.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/bayer_format.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * bayer_format.cpp - Class to represent Bayer formats
+ * Class to represent Bayer formats
  */
 
 #include "libcamera/internal/bayer_format.h"
@@ -61,6 +61,10 @@ namespace libcamera {
  * \brief Format uses MIPI CSI-2 style packing
  * \var BayerFormat::Packing::IPU3
  * \brief Format uses IPU3 style packing
+ * \var BayerFormat::Packing::PISP1
+ * \brief Format uses PISP mode 1 compression
+ * \var BayerFormat::Packing::PISP2
+ * \brief Format uses PISP mode 2 compression
  */
 
 namespace {
@@ -164,12 +168,26 @@ const std::map<BayerFormat, Formats, Bay
 		{ formats::SGRBG16, V4L2PixelFormat(V4L2_PIX_FMT_SGRBG16) } },
 	{ { BayerFormat::RGGB, 16, BayerFormat::Packing::None },
 		{ formats::SRGGB16, V4L2PixelFormat(V4L2_PIX_FMT_SRGGB16) } },
+	{ { BayerFormat::BGGR, 16, BayerFormat::Packing::PISP1 },
+		{ formats::BGGR_PISP_COMP1, V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_BGGR) } },
+	{ { BayerFormat::GBRG, 16, BayerFormat::Packing::PISP1 },
+		{ formats::GBRG_PISP_COMP1, V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_GBRG) } },
+	{ { BayerFormat::GRBG, 16, BayerFormat::Packing::PISP1 },
+		{ formats::GRBG_PISP_COMP1, V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_GRBG) } },
+	{ { BayerFormat::RGGB, 16, BayerFormat::Packing::PISP1 },
+		{ formats::RGGB_PISP_COMP1, V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_RGGB) } },
 	{ { BayerFormat::MONO, 8, BayerFormat::Packing::None },
 		{ formats::R8, V4L2PixelFormat(V4L2_PIX_FMT_GREY) } },
 	{ { BayerFormat::MONO, 10, BayerFormat::Packing::None },
 		{ formats::R10, V4L2PixelFormat(V4L2_PIX_FMT_Y10) } },
 	{ { BayerFormat::MONO, 10, BayerFormat::Packing::CSI2 },
 		{ formats::R10_CSI2P, V4L2PixelFormat(V4L2_PIX_FMT_Y10P) } },
+	{ { BayerFormat::MONO, 12, BayerFormat::Packing::None },
+		{ formats::R12, V4L2PixelFormat(V4L2_PIX_FMT_Y12) } },
+	{ { BayerFormat::MONO, 16, BayerFormat::Packing::None },
+		{ formats::R16, V4L2PixelFormat(V4L2_PIX_FMT_Y16) } },
+	{ { BayerFormat::MONO, 16, BayerFormat::Packing::PISP1 },
+		{ formats::MONO_PISP_COMP1, V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_MONO) } },
 };
 
 const std::unordered_map<unsigned int, BayerFormat> mbusCodeToBayer{
@@ -208,6 +226,7 @@ const std::unordered_map<unsigned int, B
 	{ MEDIA_BUS_FMT_Y8_1X8, { BayerFormat::MONO, 8, BayerFormat::Packing::None } },
 	{ MEDIA_BUS_FMT_Y10_1X10, { BayerFormat::MONO, 10, BayerFormat::Packing::None } },
 	{ MEDIA_BUS_FMT_Y12_1X12, { BayerFormat::MONO, 12, BayerFormat::Packing::None } },
+	{ MEDIA_BUS_FMT_Y16_1X16, { BayerFormat::MONO, 16, BayerFormat::Packing::None } },
 };
 
 } /* namespace */
@@ -298,6 +317,10 @@ std::ostream &operator<<(std::ostream &o
 		out << "-CSI2P";
 	else if (f.packing == BayerFormat::Packing::IPU3)
 		out << "-IPU3P";
+	else if (f.packing == BayerFormat::Packing::PISP1)
+		out << "-PISP1";
+	else if (f.packing == BayerFormat::Packing::PISP2)
+		out << "-PISP2";
 
 	return out;
 }
diff -pruN 0.2.0-3/src/libcamera/byte_stream_buffer.cpp 0.3.0-1/src/libcamera/byte_stream_buffer.cpp
--- 0.2.0-3/src/libcamera/byte_stream_buffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/byte_stream_buffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * byte_stream_buffer.cpp - Byte stream buffer
+ * Byte stream buffer
  */
 
 #include "libcamera/internal/byte_stream_buffer.h"
diff -pruN 0.2.0-3/src/libcamera/camera.cpp 0.3.0-1/src/libcamera/camera.cpp
--- 0.2.0-3/src/libcamera/camera.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/camera.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * camera.cpp - Camera device
+ * Camera device
  */
 
 #include <libcamera/camera.h>
diff -pruN 0.2.0-3/src/libcamera/camera_controls.cpp 0.3.0-1/src/libcamera/camera_controls.cpp
--- 0.2.0-3/src/libcamera/camera_controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/camera_controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_controls.cpp - Camera controls
+ * Camera controls
  */
 
 #include "libcamera/internal/camera_controls.h"
diff -pruN 0.2.0-3/src/libcamera/camera_lens.cpp 0.3.0-1/src/libcamera/camera_lens.cpp
--- 0.2.0-3/src/libcamera/camera_lens.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/camera_lens.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * camera_lens.cpp - A camera lens
+ * A camera lens
  */
 
 #include "libcamera/internal/camera_lens.h"
diff -pruN 0.2.0-3/src/libcamera/camera_manager.cpp 0.3.0-1/src/libcamera/camera_manager.cpp
--- 0.2.0-3/src/libcamera/camera_manager.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/camera_manager.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * camera_manager.h - Camera management
+ * Camera management
  */
 
 #include "libcamera/internal/camera_manager.h"
@@ -99,16 +99,37 @@ int CameraManager::Private::init()
 
 void CameraManager::Private::createPipelineHandlers()
 {
-	CameraManager *const o = LIBCAMERA_O_PTR();
-
 	/*
 	 * \todo Try to read handlers and order from configuration
-	 * file and only fallback on all handlers if there is no
-	 * configuration file.
+	 * file and only fallback on environment variable or all handlers, if
+	 * there is no configuration file.
 	 */
+	const char *pipesList =
+		utils::secure_getenv("LIBCAMERA_PIPELINES_MATCH_LIST");
+	if (pipesList) {
+		/*
+		 * When a list of preferred pipelines is defined, iterate
+		 * through the ordered list to match the enumerated devices.
+		 */
+		for (const auto &pipeName : utils::split(pipesList, ",")) {
+			const PipelineHandlerFactoryBase *factory;
+			factory = PipelineHandlerFactoryBase::getFactoryByName(pipeName);
+			if (!factory)
+				continue;
+
+			LOG(Camera, Debug)
+				<< "Found listed pipeline handler '"
+				<< pipeName << "'";
+			pipelineFactoryMatch(factory);
+		}
+
+		return;
+	}
+
 	const std::vector<PipelineHandlerFactoryBase *> &factories =
 		PipelineHandlerFactoryBase::factories();
 
+	/* Match all the registered pipeline handlers. */
 	for (const PipelineHandlerFactoryBase *factory : factories) {
 		LOG(Camera, Debug)
 			<< "Found registered pipeline handler '"
@@ -117,15 +138,23 @@ void CameraManager::Private::createPipel
 		 * Try each pipeline handler until it exhaust
 		 * all pipelines it can provide.
 		 */
-		while (1) {
-			std::shared_ptr<PipelineHandler> pipe = factory->create(o);
-			if (!pipe->match(enumerator_.get()))
-				break;
+		pipelineFactoryMatch(factory);
+	}
+}
 
-			LOG(Camera, Debug)
-				<< "Pipeline handler \"" << factory->name()
-				<< "\" matched";
-		}
+void CameraManager::Private::pipelineFactoryMatch(const PipelineHandlerFactoryBase *factory)
+{
+	CameraManager *const o = LIBCAMERA_O_PTR();
+
+	/* Provide as many matching pipelines as possible. */
+	while (1) {
+		std::shared_ptr<PipelineHandler> pipe = factory->create(o);
+		if (!pipe->match(enumerator_.get()))
+			break;
+
+		LOG(Camera, Debug)
+			<< "Pipeline handler \"" << factory->name()
+			<< "\" matched";
 	}
 }
 
diff -pruN 0.2.0-3/src/libcamera/camera_sensor.cpp 0.3.0-1/src/libcamera/camera_sensor.cpp
--- 0.2.0-3/src/libcamera/camera_sensor.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/camera_sensor.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1202 +0,0 @@
-/* SPDX-License-Identifier: LGPL-2.1-or-later */
-/*
- * Copyright (C) 2019, Google Inc.
- *
- * camera_sensor.cpp - A camera sensor
- */
-
-#include "libcamera/internal/camera_sensor.h"
-#include "libcamera/internal/media_device.h"
-
-#include <algorithm>
-#include <float.h>
-#include <iomanip>
-#include <limits.h>
-#include <math.h>
-#include <string.h>
-
-#include <libcamera/camera.h>
-#include <libcamera/orientation.h>
-#include <libcamera/property_ids.h>
-
-#include <libcamera/base/utils.h>
-
-#include "libcamera/internal/bayer_format.h"
-#include "libcamera/internal/camera_lens.h"
-#include "libcamera/internal/camera_sensor_properties.h"
-#include "libcamera/internal/formats.h"
-#include "libcamera/internal/sysfs.h"
-
-/**
- * \file camera_sensor.h
- * \brief A camera sensor
- */
-
-namespace libcamera {
-
-LOG_DEFINE_CATEGORY(CameraSensor)
-
-/**
- * \class CameraSensor
- * \brief A camera sensor based on V4L2 subdevices
- *
- * The CameraSensor class eases handling of sensors for pipeline handlers by
- * hiding the details of the V4L2 subdevice kernel API and caching sensor
- * information.
- *
- * The implementation is currently limited to sensors that expose a single V4L2
- * subdevice with a single pad. It will be extended to support more complex
- * devices as the needs arise.
- */
-
-/**
- * \brief Construct a CameraSensor
- * \param[in] entity The media entity backing the camera sensor
- *
- * Once constructed the instance must be initialized with init().
- */
-CameraSensor::CameraSensor(const MediaEntity *entity)
-	: entity_(entity), pad_(UINT_MAX), staticProps_(nullptr),
-	  bayerFormat_(nullptr), supportFlips_(false),
-	  properties_(properties::properties)
-{
-}
-
-/**
- * \brief Destroy a CameraSensor
- */
-CameraSensor::~CameraSensor()
-{
-}
-
-/**
- * \brief Initialize the camera sensor instance
- *
- * This function performs the initialisation steps of the CameraSensor that may
- * fail. It shall be called once and only once after constructing the instance.
- *
- * \return 0 on success or a negative error code otherwise
- */
-int CameraSensor::init()
-{
-	for (const MediaPad *pad : entity_->pads()) {
-		if (pad->flags() & MEDIA_PAD_FL_SOURCE) {
-			pad_ = pad->index();
-			break;
-		}
-	}
-
-	if (pad_ == UINT_MAX) {
-		LOG(CameraSensor, Error)
-			<< "Sensors with more than one pad are not supported";
-		return -EINVAL;
-	}
-
-	switch (entity_->function()) {
-	case MEDIA_ENT_F_CAM_SENSOR:
-	case MEDIA_ENT_F_PROC_VIDEO_ISP:
-		break;
-
-	default:
-		LOG(CameraSensor, Error)
-			<< "Invalid sensor function "
-			<< utils::hex(entity_->function());
-		return -EINVAL;
-	}
-
-	/* Create and open the subdev. */
-	subdev_ = std::make_unique<V4L2Subdevice>(entity_);
-	int ret = subdev_->open();
-	if (ret < 0)
-		return ret;
-
-	/*
-	 * Clear any flips to be sure we get the "native" Bayer order. This is
-	 * harmless for sensors where the flips don't affect the Bayer order.
-	 */
-	ControlList ctrls(subdev_->controls());
-	if (subdev_->controls().find(V4L2_CID_HFLIP) != subdev_->controls().end())
-		ctrls.set(V4L2_CID_HFLIP, 0);
-	if (subdev_->controls().find(V4L2_CID_VFLIP) != subdev_->controls().end())
-		ctrls.set(V4L2_CID_VFLIP, 0);
-	subdev_->setControls(&ctrls);
-
-	/* Enumerate, sort and cache media bus codes and sizes. */
-	formats_ = subdev_->formats(pad_);
-	if (formats_.empty()) {
-		LOG(CameraSensor, Error) << "No image format found";
-		return -EINVAL;
-	}
-
-	mbusCodes_ = utils::map_keys(formats_);
-	std::sort(mbusCodes_.begin(), mbusCodes_.end());
-
-	for (const auto &format : formats_) {
-		const std::vector<SizeRange> &ranges = format.second;
-		std::transform(ranges.begin(), ranges.end(), std::back_inserter(sizes_),
-			       [](const SizeRange &range) { return range.max; });
-	}
-
-	std::sort(sizes_.begin(), sizes_.end());
-
-	/* Remove duplicates. */
-	auto last = std::unique(sizes_.begin(), sizes_.end());
-	sizes_.erase(last, sizes_.end());
-
-	/*
-	 * VIMC is a bit special, as it does not yet support all the mandatory
-	 * requirements regular sensors have to respect.
-	 *
-	 * Do not validate the driver if it's VIMC and initialize the sensor
-	 * properties with static information.
-	 *
-	 * \todo Remove the special case once the VIMC driver has been
-	 * updated in all test platforms.
-	 */
-	if (entity_->device()->driver() == "vimc") {
-		initVimcDefaultProperties();
-
-		ret = initProperties();
-		if (ret)
-			return ret;
-
-		return discoverAncillaryDevices();
-	}
-
-	/* Get the color filter array pattern (only for RAW sensors). */
-	for (unsigned int mbusCode : mbusCodes_) {
-		const BayerFormat &bayerFormat = BayerFormat::fromMbusCode(mbusCode);
-		if (bayerFormat.isValid()) {
-			bayerFormat_ = &bayerFormat;
-			break;
-		}
-	}
-
-	ret = validateSensorDriver();
-	if (ret)
-		return ret;
-
-	ret = initProperties();
-	if (ret)
-		return ret;
-
-	ret = discoverAncillaryDevices();
-	if (ret)
-		return ret;
-
-	/*
-	 * Set HBLANK to the minimum to start with a well-defined line length,
-	 * allowing IPA modules that do not modify HBLANK to use the sensor
-	 * minimum line length in their calculations.
-	 *
-	 * At present, there is no way of knowing if a control is read-only.
-	 * As a workaround, assume that if the minimum and maximum values of
-	 * the V4L2_CID_HBLANK control are the same, it implies the control
-	 * is read-only.
-	 *
-	 * \todo The control API ought to have a flag to specify if a control
-	 * is read-only which could be used below.
-	 */
-	if (ctrls.infoMap()->find(V4L2_CID_HBLANK) != ctrls.infoMap()->end()) {
-		const ControlInfo hblank = ctrls.infoMap()->at(V4L2_CID_HBLANK);
-		const int32_t hblankMin = hblank.min().get<int32_t>();
-		const int32_t hblankMax = hblank.max().get<int32_t>();
-
-		if (hblankMin != hblankMax) {
-			ControlList ctrl(subdev_->controls());
-
-			ctrl.set(V4L2_CID_HBLANK, hblankMin);
-			ret = subdev_->setControls(&ctrl);
-			if (ret)
-				return ret;
-		}
-	}
-
-	return applyTestPatternMode(controls::draft::TestPatternModeEnum::TestPatternModeOff);
-}
-
-int CameraSensor::validateSensorDriver()
-{
-	int err = 0;
-
-	/*
-	 * Optional controls are used to register optional sensor properties. If
-	 * not present, some values will be defaulted.
-	 */
-	static constexpr uint32_t optionalControls[] = {
-		V4L2_CID_CAMERA_SENSOR_ROTATION,
-	};
-
-	const ControlIdMap &controls = subdev_->controls().idmap();
-	for (uint32_t ctrl : optionalControls) {
-		if (!controls.count(ctrl))
-			LOG(CameraSensor, Debug)
-				<< "Optional V4L2 control " << utils::hex(ctrl)
-				<< " not supported";
-	}
-
-	/*
-	 * Recommended controls are similar to optional controls, but will
-	 * become mandatory in the near future. Be loud if they're missing.
-	 */
-	static constexpr uint32_t recommendedControls[] = {
-		V4L2_CID_CAMERA_ORIENTATION,
-	};
-
-	for (uint32_t ctrl : recommendedControls) {
-		if (!controls.count(ctrl)) {
-			LOG(CameraSensor, Warning)
-				<< "Recommended V4L2 control " << utils::hex(ctrl)
-				<< " not supported";
-			err = -EINVAL;
-		}
-	}
-
-	/*
-	 * Verify if sensor supports horizontal/vertical flips
-	 *
-	 * \todo Handle horizontal and vertical flips independently.
-	 */
-	const struct v4l2_query_ext_ctrl *hflipInfo = subdev_->controlInfo(V4L2_CID_HFLIP);
-	const struct v4l2_query_ext_ctrl *vflipInfo = subdev_->controlInfo(V4L2_CID_VFLIP);
-	if (hflipInfo && !(hflipInfo->flags & V4L2_CTRL_FLAG_READ_ONLY) &&
-	    vflipInfo && !(vflipInfo->flags & V4L2_CTRL_FLAG_READ_ONLY))
-		supportFlips_ = true;
-
-	if (!supportFlips_)
-		LOG(CameraSensor, Debug)
-			<< "Camera sensor does not support horizontal/vertical flip";
-
-	/*
-	 * Make sure the required selection targets are supported.
-	 *
-	 * Failures in reading any of the targets are not deemed to be fatal,
-	 * but some properties and features, like constructing a
-	 * IPACameraSensorInfo for the IPA module, won't be supported.
-	 *
-	 * \todo Make support for selection targets mandatory as soon as all
-	 * test platforms have been updated.
-	 */
-	Rectangle rect;
-	int ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP_BOUNDS, &rect);
-	if (ret) {
-		/*
-		 * Default the pixel array size to the largest size supported
-		 * by the sensor. The sizes_ vector is sorted in ascending
-		 * order, the largest size is thus the last element.
-		 */
-		pixelArraySize_ = sizes_.back();
-
-		LOG(CameraSensor, Warning)
-			<< "The PixelArraySize property has been defaulted to "
-			<< pixelArraySize_;
-		err = -EINVAL;
-	} else {
-		pixelArraySize_ = rect.size();
-	}
-
-	ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP_DEFAULT, &activeArea_);
-	if (ret) {
-		activeArea_ = Rectangle(pixelArraySize_);
-		LOG(CameraSensor, Warning)
-			<< "The PixelArrayActiveAreas property has been defaulted to "
-			<< activeArea_;
-		err = -EINVAL;
-	}
-
-	ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP, &rect);
-	if (ret) {
-		LOG(CameraSensor, Warning)
-			<< "Failed to retrieve the sensor crop rectangle";
-		err = -EINVAL;
-	}
-
-	if (err) {
-		LOG(CameraSensor, Warning)
-			<< "The sensor kernel driver needs to be fixed";
-		LOG(CameraSensor, Warning)
-			<< "See Documentation/sensor_driver_requirements.rst in the libcamera sources for more information";
-	}
-
-	if (!bayerFormat_)
-		return 0;
-
-	/*
-	 * For raw sensors, make sure the sensor driver supports the controls
-	 * required by the CameraSensor class.
-	 */
-	static constexpr uint32_t mandatoryControls[] = {
-		V4L2_CID_ANALOGUE_GAIN,
-		V4L2_CID_EXPOSURE,
-		V4L2_CID_HBLANK,
-		V4L2_CID_PIXEL_RATE,
-		V4L2_CID_VBLANK,
-	};
-
-	err = 0;
-	for (uint32_t ctrl : mandatoryControls) {
-		if (!controls.count(ctrl)) {
-			LOG(CameraSensor, Error)
-				<< "Mandatory V4L2 control " << utils::hex(ctrl)
-				<< " not available";
-			err = -EINVAL;
-		}
-	}
-
-	if (err) {
-		LOG(CameraSensor, Error)
-			<< "The sensor kernel driver needs to be fixed";
-		LOG(CameraSensor, Error)
-			<< "See Documentation/sensor_driver_requirements.rst in the libcamera sources for more information";
-		return err;
-	}
-
-	return 0;
-}
-
-/*
- * \brief Initialize properties that cannot be intialized by the
- * regular initProperties() function for VIMC
- */
-void CameraSensor::initVimcDefaultProperties()
-{
-	/* Use the largest supported size. */
-	pixelArraySize_ = sizes_.back();
-	activeArea_ = Rectangle(pixelArraySize_);
-}
-
-void CameraSensor::initStaticProperties()
-{
-	staticProps_ = CameraSensorProperties::get(model_);
-	if (!staticProps_)
-		return;
-
-	/* Register the properties retrieved from the sensor database. */
-	properties_.set(properties::UnitCellSize, staticProps_->unitCellSize);
-
-	initTestPatternModes();
-}
-
-void CameraSensor::initTestPatternModes()
-{
-	const auto &v4l2TestPattern = controls().find(V4L2_CID_TEST_PATTERN);
-	if (v4l2TestPattern == controls().end()) {
-		LOG(CameraSensor, Debug) << "V4L2_CID_TEST_PATTERN is not supported";
-		return;
-	}
-
-	const auto &testPatternModes = staticProps_->testPatternModes;
-	if (testPatternModes.empty()) {
-		/*
-		 * The camera sensor supports test patterns but we don't know
-		 * how to map them so this should be fixed.
-		 */
-		LOG(CameraSensor, Debug) << "No static test pattern map for \'"
-					 << model() << "\'";
-		return;
-	}
-
-	/*
-	 * Create a map that associates the V4L2 control index to the test
-	 * pattern mode by reversing the testPatternModes map provided by the
-	 * camera sensor properties. This makes it easier to verify if the
-	 * control index is supported in the below for loop that creates the
-	 * list of supported test patterns.
-	 */
-	std::map<int32_t, controls::draft::TestPatternModeEnum> indexToTestPatternMode;
-	for (const auto &it : testPatternModes)
-		indexToTestPatternMode[it.second] = it.first;
-
-	for (const ControlValue &value : v4l2TestPattern->second.values()) {
-		const int32_t index = value.get<int32_t>();
-
-		const auto it = indexToTestPatternMode.find(index);
-		if (it == indexToTestPatternMode.end()) {
-			LOG(CameraSensor, Debug)
-				<< "Test pattern mode " << index << " ignored";
-			continue;
-		}
-
-		testPatternModes_.push_back(it->second);
-	}
-}
-
-int CameraSensor::initProperties()
-{
-	model_ = subdev_->model();
-	properties_.set(properties::Model, utils::toAscii(model_));
-
-	/* Generate a unique ID for the sensor. */
-	int ret = generateId();
-	if (ret)
-		return ret;
-
-	/* Initialize the static properties from the sensor database. */
-	initStaticProperties();
-
-	/* Retrieve and register properties from the kernel interface. */
-	const ControlInfoMap &controls = subdev_->controls();
-
-	const auto &orientation = controls.find(V4L2_CID_CAMERA_ORIENTATION);
-	if (orientation != controls.end()) {
-		int32_t v4l2Orientation = orientation->second.def().get<int32_t>();
-		int32_t propertyValue;
-
-		switch (v4l2Orientation) {
-		default:
-			LOG(CameraSensor, Warning)
-				<< "Unsupported camera location "
-				<< v4l2Orientation << ", setting to External";
-			[[fallthrough]];
-		case V4L2_CAMERA_ORIENTATION_EXTERNAL:
-			propertyValue = properties::CameraLocationExternal;
-			break;
-		case V4L2_CAMERA_ORIENTATION_FRONT:
-			propertyValue = properties::CameraLocationFront;
-			break;
-		case V4L2_CAMERA_ORIENTATION_BACK:
-			propertyValue = properties::CameraLocationBack;
-			break;
-		}
-		properties_.set(properties::Location, propertyValue);
-	} else {
-		LOG(CameraSensor, Warning) << "Failed to retrieve the camera location";
-	}
-
-	const auto &rotationControl = controls.find(V4L2_CID_CAMERA_SENSOR_ROTATION);
-	if (rotationControl != controls.end()) {
-		int32_t propertyValue = rotationControl->second.def().get<int32_t>();
-
-		/*
-		 * Cache the Transform associated with the camera mounting
-		 * rotation for later use in computeTransform().
-		 */
-		bool success;
-		mountingOrientation_ = orientationFromRotation(propertyValue, &success);
-		if (!success) {
-			LOG(CameraSensor, Warning)
-				<< "Invalid rotation of " << propertyValue
-				<< " degrees - ignoring";
-			mountingOrientation_ = Orientation::Rotate0;
-		}
-
-		properties_.set(properties::Rotation, propertyValue);
-	} else {
-		LOG(CameraSensor, Warning)
-			<< "Rotation control not available, default to 0 degrees";
-		properties_.set(properties::Rotation, 0);
-		mountingOrientation_ = Orientation::Rotate0;
-	}
-
-	properties_.set(properties::PixelArraySize, pixelArraySize_);
-	properties_.set(properties::PixelArrayActiveAreas, { activeArea_ });
-
-	/* Color filter array pattern, register only for RAW sensors. */
-	if (bayerFormat_) {
-		int32_t cfa;
-		switch (bayerFormat_->order) {
-		case BayerFormat::BGGR:
-			cfa = properties::draft::BGGR;
-			break;
-		case BayerFormat::GBRG:
-			cfa = properties::draft::GBRG;
-			break;
-		case BayerFormat::GRBG:
-			cfa = properties::draft::GRBG;
-			break;
-		case BayerFormat::RGGB:
-			cfa = properties::draft::RGGB;
-			break;
-		case BayerFormat::MONO:
-			cfa = properties::draft::MONO;
-			break;
-		}
-
-		properties_.set(properties::draft::ColorFilterArrangement, cfa);
-	}
-
-	return 0;
-}
-
-/**
- * \brief Check for and initialise any ancillary devices
- *
- * Sensors sometimes have ancillary devices such as a Lens or Flash that could
- * be linked to their MediaEntity by the kernel. Search for and handle any
- * such device.
- *
- * \todo Handle MEDIA_ENT_F_FLASH too.
- */
-int CameraSensor::discoverAncillaryDevices()
-{
-	int ret;
-
-	for (MediaEntity *ancillary : entity_->ancillaryEntities()) {
-		switch (ancillary->function()) {
-		case MEDIA_ENT_F_LENS:
-			focusLens_ = std::make_unique<CameraLens>(ancillary);
-			ret = focusLens_->init();
-			if (ret) {
-				LOG(CameraSensor, Error)
-					<< "Lens initialisation failed, lens disabled";
-				focusLens_.reset();
-			}
-			break;
-
-		default:
-			LOG(CameraSensor, Warning)
-				<< "Unsupported ancillary entity function "
-				<< ancillary->function();
-			break;
-		}
-	}
-
-	return 0;
-}
-
-/**
- * \fn CameraSensor::model()
- * \brief Retrieve the sensor model name
- *
- * The sensor model name is a free-formed string that uniquely identifies the
- * sensor model.
- *
- * \return The sensor model name
- */
-
-/**
- * \fn CameraSensor::id()
- * \brief Retrieve the sensor ID
- *
- * The sensor ID is a free-form string that uniquely identifies the sensor in
- * the system. The ID satisfies the requirements to be used as a camera ID.
- *
- * \return The sensor ID
- */
-
-/**
- * \fn CameraSensor::entity()
- * \brief Retrieve the sensor media entity
- * \return The sensor media entity
- */
-
-/**
- * \fn CameraSensor::mbusCodes()
- * \brief Retrieve the media bus codes supported by the camera sensor
- *
- * Any Bayer formats are listed using the sensor's native Bayer order,
- * that is, with the effect of V4L2_CID_HFLIP and V4L2_CID_VFLIP undone
- * (where these controls exist).
- *
- * \return The supported media bus codes sorted in increasing order
- */
-
-/**
- * \brief Retrieve the supported frame sizes for a media bus code
- * \param[in] mbusCode The media bus code for which sizes are requested
- *
- * \return The supported frame sizes for \a mbusCode sorted in increasing order
- */
-std::vector<Size> CameraSensor::sizes(unsigned int mbusCode) const
-{
-	std::vector<Size> sizes;
-
-	const auto &format = formats_.find(mbusCode);
-	if (format == formats_.end())
-		return sizes;
-
-	const std::vector<SizeRange> &ranges = format->second;
-	std::transform(ranges.begin(), ranges.end(), std::back_inserter(sizes),
-		       [](const SizeRange &range) { return range.max; });
-
-	std::sort(sizes.begin(), sizes.end());
-
-	return sizes;
-}
-
-/**
- * \brief Retrieve the camera sensor resolution
- *
- * The camera sensor resolution is the active pixel area size, clamped to the
- * maximum frame size the sensor can produce if it is smaller than the active
- * pixel area.
- *
- * \todo Consider if it desirable to distinguish between the maximum resolution
- * the sensor can produce (also including upscaled ones) and the actual pixel
- * array size by splitting this function in two.
- *
- * \return The camera sensor resolution in pixels
- */
-Size CameraSensor::resolution() const
-{
-	return std::min(sizes_.back(), activeArea_.size());
-}
-
-/**
- * \fn CameraSensor::testPatternModes()
- * \brief Retrieve all the supported test pattern modes of the camera sensor
- * The test pattern mode values correspond to the controls::TestPattern control.
- *
- * \return The list of test pattern modes
- */
-
-/**
- * \brief Set the test pattern mode for the camera sensor
- * \param[in] mode The test pattern mode
- *
- * The new \a mode is applied to the sensor if it differs from the active test
- * pattern mode. Otherwise, this function is a no-op. Setting the same test
- * pattern mode for every frame thus incurs no performance penalty.
- */
-int CameraSensor::setTestPatternMode(controls::draft::TestPatternModeEnum mode)
-{
-	if (testPatternMode_ == mode)
-		return 0;
-
-	if (testPatternModes_.empty()) {
-		LOG(CameraSensor, Error)
-			<< "Camera sensor does not support test pattern modes.";
-		return -EINVAL;
-	}
-
-	return applyTestPatternMode(mode);
-}
-
-int CameraSensor::applyTestPatternMode(controls::draft::TestPatternModeEnum mode)
-{
-	if (testPatternModes_.empty())
-		return 0;
-
-	auto it = std::find(testPatternModes_.begin(), testPatternModes_.end(),
-			    mode);
-	if (it == testPatternModes_.end()) {
-		LOG(CameraSensor, Error) << "Unsupported test pattern mode "
-					 << mode;
-		return -EINVAL;
-	}
-
-	LOG(CameraSensor, Debug) << "Apply test pattern mode " << mode;
-
-	int32_t index = staticProps_->testPatternModes.at(mode);
-	ControlList ctrls{ controls() };
-	ctrls.set(V4L2_CID_TEST_PATTERN, index);
-
-	int ret = setControls(&ctrls);
-	if (ret)
-		return ret;
-
-	testPatternMode_ = mode;
-
-	return 0;
-}
-
-/**
- * \brief Retrieve the best sensor format for a desired output
- * \param[in] mbusCodes The list of acceptable media bus codes
- * \param[in] size The desired size
- *
- * Media bus codes are selected from \a mbusCodes, which lists all acceptable
- * codes in decreasing order of preference. Media bus codes supported by the
- * sensor but not listed in \a mbusCodes are ignored. If none of the desired
- * codes is supported, it returns an error.
- *
- * \a size indicates the desired size at the output of the sensor. This function
- * selects the best media bus code and size supported by the sensor according
- * to the following criteria.
- *
- * - The desired \a size shall fit in the sensor output size to avoid the need
- *   to up-scale.
- * - The sensor output size shall match the desired aspect ratio to avoid the
- *   need to crop the field of view.
- * - The sensor output size shall be as small as possible to lower the required
- *   bandwidth.
- * - The desired \a size shall be supported by one of the media bus code listed
- *   in \a mbusCodes.
- *
- * When multiple media bus codes can produce the same size, the code at the
- * lowest position in \a mbusCodes is selected.
- *
- * The use of this function is optional, as the above criteria may not match the
- * needs of all pipeline handlers. Pipeline handlers may implement custom
- * sensor format selection when needed.
- *
- * The returned sensor output format is guaranteed to be acceptable by the
- * setFormat() function without any modification.
- *
- * \return The best sensor output format matching the desired media bus codes
- * and size on success, or an empty format otherwise.
- */
-V4L2SubdeviceFormat CameraSensor::getFormat(const std::vector<unsigned int> &mbusCodes,
-					    const Size &size) const
-{
-	unsigned int desiredArea = size.width * size.height;
-	unsigned int bestArea = UINT_MAX;
-	float desiredRatio = static_cast<float>(size.width) / size.height;
-	float bestRatio = FLT_MAX;
-	const Size *bestSize = nullptr;
-	uint32_t bestCode = 0;
-
-	for (unsigned int code : mbusCodes) {
-		const auto formats = formats_.find(code);
-		if (formats == formats_.end())
-			continue;
-
-		for (const SizeRange &range : formats->second) {
-			const Size &sz = range.max;
-
-			if (sz.width < size.width || sz.height < size.height)
-				continue;
-
-			float ratio = static_cast<float>(sz.width) / sz.height;
-			float ratioDiff = fabsf(ratio - desiredRatio);
-			unsigned int area = sz.width * sz.height;
-			unsigned int areaDiff = area - desiredArea;
-
-			if (ratioDiff > bestRatio)
-				continue;
-
-			if (ratioDiff < bestRatio || areaDiff < bestArea) {
-				bestRatio = ratioDiff;
-				bestArea = areaDiff;
-				bestSize = &sz;
-				bestCode = code;
-			}
-		}
-	}
-
-	if (!bestSize) {
-		LOG(CameraSensor, Debug) << "No supported format or size found";
-		return {};
-	}
-
-	V4L2SubdeviceFormat format{
-		.mbus_code = bestCode,
-		.size = *bestSize,
-		.colorSpace = ColorSpace::Raw,
-	};
-
-	return format;
-}
-
-/**
- * \brief Set the sensor output format
- * \param[in] format The desired sensor output format
- * \param[in] transform The transform to be applied on the sensor.
- * Defaults to Identity.
- *
- * If flips are writable they are configured according to the desired Transform.
- * Transform::Identity always corresponds to H/V flip being disabled if the
- * controls are writable. Flips are set before the new format is applied as
- * they can effectively change the Bayer pattern ordering.
- *
- * The ranges of any controls associated with the sensor are also updated.
- *
- * \return 0 on success or a negative error code otherwise
- */
-int CameraSensor::setFormat(V4L2SubdeviceFormat *format, Transform transform)
-{
-	/* Configure flips if the sensor supports that. */
-	if (supportFlips_) {
-		ControlList flipCtrls(subdev_->controls());
-
-		flipCtrls.set(V4L2_CID_HFLIP,
-			      static_cast<int32_t>(!!(transform & Transform::HFlip)));
-		flipCtrls.set(V4L2_CID_VFLIP,
-			      static_cast<int32_t>(!!(transform & Transform::VFlip)));
-
-		int ret = subdev_->setControls(&flipCtrls);
-		if (ret)
-			return ret;
-	}
-
-	/* Apply format on the subdev. */
-	int ret = subdev_->setFormat(pad_, format);
-	if (ret)
-		return ret;
-
-	updateControlInfo();
-	return 0;
-}
-
-/**
- * \brief Try the sensor output format
- * \param[in] format The desired sensor output format
- *
- * The ranges of any controls associated with the sensor are not updated.
- *
- * \todo Add support for Transform by changing the format's Bayer ordering
- * before calling subdev_->setFormat().
- *
- * \return 0 on success or a negative error code otherwise
- */
-int CameraSensor::tryFormat(V4L2SubdeviceFormat *format) const
-{
-	return subdev_->setFormat(pad_, format,
-				  V4L2Subdevice::Whence::TryFormat);
-}
-
-/**
- * \brief Apply a sensor configuration to the camera sensor
- * \param[in] config The sensor configuration
- * \param[in] transform The transform to be applied on the sensor.
- * Defaults to Identity
- * \param[out] sensorFormat Format applied to the sensor (optional)
- *
- * Apply to the camera sensor the configuration \a config.
- *
- * \todo The configuration shall be fully populated and if any of the fields
- * specified cannot be applied exactly, an error code is returned.
- *
- * \return 0 if \a config is applied correctly to the camera sensor, a negative
- * error code otherwise
- */
-int CameraSensor::applyConfiguration(const SensorConfiguration &config,
-				     Transform transform,
-				     V4L2SubdeviceFormat *sensorFormat)
-{
-	if (!config.isValid()) {
-		LOG(CameraSensor, Error) << "Invalid sensor configuration";
-		return -EINVAL;
-	}
-
-	std::vector<unsigned int> filteredCodes;
-	std::copy_if(mbusCodes_.begin(), mbusCodes_.end(),
-		     std::back_inserter(filteredCodes),
-		     [&config](unsigned int mbusCode) {
-			     BayerFormat bayer = BayerFormat::fromMbusCode(mbusCode);
-			     if (bayer.bitDepth == config.bitDepth)
-				     return true;
-			     return false;
-		     });
-	if (filteredCodes.empty()) {
-		LOG(CameraSensor, Error)
-			<< "Cannot find any format with bit depth "
-			<< config.bitDepth;
-		return -EINVAL;
-	}
-
-	/*
-	 * Compute the sensor's data frame size by applying the cropping
-	 * rectangle, subsampling and output crop to the sensor's pixel array
-	 * size.
-	 *
-	 * \todo The actual size computation is for now ignored and only the
-	 * output size is considered. This implies that resolutions obtained
-	 * with two different cropping/subsampling will look identical and
-	 * only the first found one will be considered.
-	 */
-	V4L2SubdeviceFormat subdevFormat = {};
-	for (unsigned int code : filteredCodes) {
-		for (const Size &size : sizes(code)) {
-			if (size.width != config.outputSize.width ||
-			    size.height != config.outputSize.height)
-				continue;
-
-			subdevFormat.mbus_code = code;
-			subdevFormat.size = size;
-			break;
-		}
-	}
-	if (!subdevFormat.mbus_code) {
-		LOG(CameraSensor, Error) << "Invalid output size in sensor configuration";
-		return -EINVAL;
-	}
-
-	int ret = setFormat(&subdevFormat, transform);
-	if (ret)
-		return ret;
-
-	/*
-	 * Return to the caller the format actually applied to the sensor.
-	 * This is relevant if transform has changed the bayer pattern order.
-	 */
-	if (sensorFormat)
-		*sensorFormat = subdevFormat;
-
-	/* \todo Handle AnalogCrop. Most sensors do not support set_selection */
-	/* \todo Handle scaling in the digital domain. */
-
-	return 0;
-}
-
-/**
- * \brief Retrieve the supported V4L2 controls and their information
- *
- * Control information is updated automatically to reflect the current sensor
- * configuration when the setFormat() function is called, without invalidating
- * any iterator on the ControlInfoMap. A manual update can also be forced by
- * calling the updateControlInfo() function for pipeline handlers that change
- * the sensor configuration wihtout using setFormat().
- *
- * \return A map of the V4L2 controls supported by the sensor
- */
-const ControlInfoMap &CameraSensor::controls() const
-{
-	return subdev_->controls();
-}
-
-/**
- * \brief Read V4L2 controls from the sensor
- * \param[in] ids The list of controls to read, specified by their ID
- *
- * This function reads the value of all controls contained in \a ids, and
- * returns their values as a ControlList. The control identifiers are defined by
- * the V4L2 specification (V4L2_CID_*).
- *
- * If any control in \a ids is not supported by the device, is disabled (i.e.
- * has the V4L2_CTRL_FLAG_DISABLED flag set), or if any other error occurs
- * during validation of the requested controls, no control is read and this
- * function returns an empty control list.
- *
- * \sa V4L2Device::getControls()
- *
- * \return The control values in a ControlList on success, or an empty list on
- * error
- */
-ControlList CameraSensor::getControls(const std::vector<uint32_t> &ids)
-{
-	return subdev_->getControls(ids);
-}
-
-/**
- * \brief Write V4L2 controls to the sensor
- * \param[in] ctrls The list of controls to write
- *
- * This function writes the value of all controls contained in \a ctrls, and
- * stores the values actually applied to the device in the corresponding \a
- * ctrls entry. The control identifiers are defined by the V4L2 specification
- * (V4L2_CID_*).
- *
- * If any control in \a ctrls is not supported by the device, is disabled (i.e.
- * has the V4L2_CTRL_FLAG_DISABLED flag set), is read-only, or if any other
- * error occurs during validation of the requested controls, no control is
- * written and this function returns -EINVAL.
- *
- * If an error occurs while writing the controls, the index of the first
- * control that couldn't be written is returned. All controls below that index
- * are written and their values are updated in \a ctrls, while all other
- * controls are not written and their values are not changed.
- *
- * \sa V4L2Device::setControls()
- *
- * \return 0 on success or an error code otherwise
- * \retval -EINVAL One of the control is not supported or not accessible
- * \retval i The index of the control that failed
- */
-int CameraSensor::setControls(ControlList *ctrls)
-{
-	return subdev_->setControls(ctrls);
-}
-
-/**
- * \fn CameraSensor::device()
- * \brief Retrieve the camera sensor device
- * \todo Remove this function by integrating DelayedControl with CameraSensor
- * \return The camera sensor device
- */
-
-/**
- * \fn CameraSensor::properties()
- * \brief Retrieve the camera sensor properties
- * \return The list of camera sensor properties
- */
-
-/**
- * \brief Assemble and return the camera sensor info
- * \param[out] info The camera sensor info
- *
- * This function fills \a info with information that describes the camera sensor
- * and its current configuration. The information combines static data (such as
- * the the sensor model or active pixel array size) and data specific to the
- * current sensor configuration (such as the line length and pixel rate).
- *
- * Sensor information is only available for raw sensors. When called for a YUV
- * sensor, this function returns -EINVAL.
- *
- * Pipeline handlers that do not change the sensor format using the setFormat()
- * function may need to call updateControlInfo() beforehand, to ensure all the
- * control ranges are up to date.
- *
- * \return 0 on success, a negative error code otherwise
- */
-int CameraSensor::sensorInfo(IPACameraSensorInfo *info) const
-{
-	if (!bayerFormat_)
-		return -EINVAL;
-
-	info->model = model();
-
-	/*
-	 * The active area size is a static property, while the crop
-	 * rectangle needs to be re-read as it depends on the sensor
-	 * configuration.
-	 */
-	info->activeAreaSize = { activeArea_.width, activeArea_.height };
-
-	/*
-	 * \todo Support for retreiving the crop rectangle is scheduled to
-	 * become mandatory. For the time being use the default value if it has
-	 * been initialized at sensor driver validation time.
-	 */
-	int ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP, &info->analogCrop);
-	if (ret) {
-		info->analogCrop = activeArea_;
-		LOG(CameraSensor, Warning)
-			<< "The analogue crop rectangle has been defaulted to the active area size";
-	}
-
-	/*
-	 * IPACameraSensorInfo::analogCrop::x and IPACameraSensorInfo::analogCrop::y
-	 * are defined relatively to the active pixel area, while V4L2's
-	 * TGT_CROP target is defined in respect to the full pixel array.
-	 *
-	 * Compensate it by subtracting the active area offset.
-	 */
-	info->analogCrop.x -= activeArea_.x;
-	info->analogCrop.y -= activeArea_.y;
-
-	/* The bit depth and image size depend on the currently applied format. */
-	V4L2SubdeviceFormat format{};
-	ret = subdev_->getFormat(pad_, &format);
-	if (ret)
-		return ret;
-	info->bitsPerPixel = format.bitsPerPixel();
-	info->outputSize = format.size;
-
-	std::optional<int32_t> cfa = properties_.get(properties::draft::ColorFilterArrangement);
-	info->cfaPattern = cfa ? *cfa : properties::draft::RGB;
-
-	/*
-	 * Retrieve the pixel rate, line length and minimum/maximum frame
-	 * duration through V4L2 controls. Support for the V4L2_CID_PIXEL_RATE,
-	 * V4L2_CID_HBLANK and V4L2_CID_VBLANK controls is mandatory.
-	 */
-	ControlList ctrls = subdev_->getControls({ V4L2_CID_PIXEL_RATE,
-						   V4L2_CID_HBLANK,
-						   V4L2_CID_VBLANK });
-	if (ctrls.empty()) {
-		LOG(CameraSensor, Error)
-			<< "Failed to retrieve camera info controls";
-		return -EINVAL;
-	}
-
-	info->pixelRate = ctrls.get(V4L2_CID_PIXEL_RATE).get<int64_t>();
-
-	const ControlInfo hblank = ctrls.infoMap()->at(V4L2_CID_HBLANK);
-	info->minLineLength = info->outputSize.width + hblank.min().get<int32_t>();
-	info->maxLineLength = info->outputSize.width + hblank.max().get<int32_t>();
-
-	const ControlInfo vblank = ctrls.infoMap()->at(V4L2_CID_VBLANK);
-	info->minFrameLength = info->outputSize.height + vblank.min().get<int32_t>();
-	info->maxFrameLength = info->outputSize.height + vblank.max().get<int32_t>();
-
-	return 0;
-}
-
-/**
- * \fn void CameraSensor::updateControlInfo()
- * \brief Update the sensor's ControlInfoMap in case they have changed
- * \sa V4L2Device::updateControlInfo()
- */
-void CameraSensor::updateControlInfo()
-{
-	subdev_->updateControlInfo();
-}
-
-/**
- * \fn CameraSensor::focusLens()
- * \brief Retrieve the focus lens controller
- *
- * \return The focus lens controller. nullptr if no focus lens controller is
- * connected to the sensor
- */
-
-/**
- * \brief Compute the Transform that gives the requested \a orientation
- * \param[inout] orientation The desired image orientation
- *
- * This function computes the Transform that the pipeline handler should apply
- * to the CameraSensor to obtain the requested \a orientation.
- *
- * The intended caller of this function is the validate() implementation of
- * pipeline handlers, that pass in the application requested
- * CameraConfiguration::orientation and obtain a Transform to apply to the
- * camera sensor, likely at configure() time.
- *
- * If the requested \a orientation cannot be obtained, the \a orientation
- * parameter is adjusted to report the current image orientation and
- * Transform::Identity is returned.
- *
- * If the requested \a orientation can be obtained, the function computes a
- * Transform and does not adjust \a orientation.
- *
- * Pipeline handlers are expected to verify if \a orientation has been
- * adjusted by this function and set the CameraConfiguration::status to
- * Adjusted accordingly.
- *
- * \return A Transform instance that applied to the CameraSensor produces images
- * with \a orientation
- */
-Transform CameraSensor::computeTransform(Orientation *orientation) const
-{
-	/*
-	 * If we cannot do any flips we cannot change the native camera mounting
-	 * orientation.
-	 */
-	if (!supportFlips_) {
-		*orientation = mountingOrientation_;
-		return Transform::Identity;
-	}
-
-	/*
-	 * Now compute the required transform to obtain 'orientation' starting
-	 * from the mounting rotation.
-	 *
-	 * As a note:
-	 * 	orientation / mountingOrientation_ = transform
-	 * 	mountingOrientation_ * transform = orientation
-	 */
-	Transform transform = *orientation / mountingOrientation_;
-
-	/*
-	 * If transform contains any Transpose we cannot do it, so adjust
-	 * 'orientation' to report the image native orientation and return Identity.
-	 */
-	if (!!(transform & Transform::Transpose)) {
-		*orientation = mountingOrientation_;
-		return Transform::Identity;
-	}
-
-	return transform;
-}
-
-std::string CameraSensor::logPrefix() const
-{
-	return "'" + entity_->name() + "'";
-}
-
-int CameraSensor::generateId()
-{
-	const std::string devPath = subdev_->devicePath();
-
-	/* Try to get ID from firmware description. */
-	id_ = sysfs::firmwareNodePath(devPath);
-	if (!id_.empty())
-		return 0;
-
-	/*
-	 * Virtual sensors not described in firmware
-	 *
-	 * Verify it's a platform device and construct ID from the device path
-	 * and model of sensor.
-	 */
-	if (devPath.find("/sys/devices/platform/", 0) == 0) {
-		id_ = devPath.substr(strlen("/sys/devices/")) + " " + model();
-		return 0;
-	}
-
-	LOG(CameraSensor, Error) << "Can't generate sensor ID";
-	return -EINVAL;
-}
-
-} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/camera_sensor_properties.cpp 0.3.0-1/src/libcamera/camera_sensor_properties.cpp
--- 0.2.0-3/src/libcamera/camera_sensor_properties.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/camera_sensor_properties.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,272 +0,0 @@
-/* SPDX-License-Identifier: LGPL-2.1-or-later */
-/*
- * Copyright (C) 2021, Google Inc.
- *
- * camera_sensor_properties.cpp - Database of camera sensor properties
- */
-
-#include "libcamera/internal/camera_sensor_properties.h"
-
-#include <map>
-
-#include <libcamera/base/log.h>
-
-#include <libcamera/control_ids.h>
-
-/**
- * \file camera_sensor_properties.h
- * \brief Database of camera sensor properties
- *
- * The database of camera sensor properties collects static information about
- * camera sensors that is not possible or desirable to retrieve from the device
- * at run time.
- *
- * The database is indexed using the camera sensor model, as reported by the
- * properties::Model property, and for each supported sensor it contains a
- * list of properties.
- */
-
-namespace libcamera {
-
-LOG_DEFINE_CATEGORY(CameraSensorProperties)
-
-/**
- * \struct CameraSensorProperties
- * \brief Database of camera sensor properties
- *
- * \var CameraSensorProperties::unitCellSize
- * \brief The physical size of a pixel, including pixel edges, in nanometers.
- *
- * \var CameraSensorProperties::testPatternModes
- * \brief Map that associates the TestPattern control value with the indexes of
- * the corresponding sensor test pattern modes as returned by
- * V4L2_CID_TEST_PATTERN.
- */
-
-/**
- * \brief Retrieve the properties associated with a sensor
- * \param sensor The sensor model name as reported by properties::Model
- * \return A pointer to the CameraSensorProperties instance associated with a sensor
- * or nullptr if the sensor is not supported
- */
-const CameraSensorProperties *CameraSensorProperties::get(const std::string &sensor)
-{
-	static const std::map<std::string, const CameraSensorProperties> sensorProps = {
-		{ "ar0521", {
-			.unitCellSize = { 2200, 2200 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeSolidColor, 1 },
-				{ controls::draft::TestPatternModeColorBars, 2 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
-			},
-		} },
-		{ "hi846", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeSolidColor, 1 },
-				{ controls::draft::TestPatternModeColorBars, 2 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
-				{ controls::draft::TestPatternModePn9, 4 },
-				/*
-				 * No corresponding test pattern mode for:
-				 * 5: "Gradient Horizontal"
-				 * 6: "Gradient Vertical"
-				 * 7: "Check Board"
-				 * 8: "Slant Pattern"
-				 * 9: "Resolution Pattern"
-				 */
-			},
-		} },
-		{ "imx219", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-				{ controls::draft::TestPatternModeSolidColor, 2 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
-				{ controls::draft::TestPatternModePn9, 4 },
-			},
-		} },
-		{ "imx258", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeSolidColor, 1 },
-				{ controls::draft::TestPatternModeColorBars, 2 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
-				{ controls::draft::TestPatternModePn9, 4 },
-			},
-		} },
-		{ "imx290", {
-			.unitCellSize = { 2900, 2900 },
-			.testPatternModes = {},
-		} },
-		{ "imx296", {
-			.unitCellSize = { 3450, 3450 },
-			.testPatternModes = {},
-		} },
-		{ "imx327", {
-			.unitCellSize = { 2900, 2900 },
-			.testPatternModes = {},
-		} },
-		{ "imx477", {
-			.unitCellSize = { 1550, 1550 },
-			.testPatternModes = {},
-		} },
-		{ "imx519", {
-			.unitCellSize = { 1220, 1220 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeSolidColor, 2 },
-				{ controls::draft::TestPatternModePn9, 4 },
-				/*
-				 * The driver reports ColorBars and ColorBarsFadeToGray as well but
-				 * these two patterns do not comply with MIPI CCS v1.1 (Section 10.1).
-				 */
-			},
-		} },
-		{ "imx708", {
-			.unitCellSize = { 1400, 1400 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-				{ controls::draft::TestPatternModeSolidColor, 2 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
-				{ controls::draft::TestPatternModePn9, 4 },
-			},
-		} },
-		{ "ov2685", {
-			.unitCellSize = { 1750, 1750 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1},
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2 },
-				/*
-				 * No corresponding test pattern mode for:
-				 * 3: "Random Data"
-				 * 4: "Black White Square"
-				 * 5: "Color Square"
-				 */
-			},
-		} },
-		{ "ov2740", {
-			.unitCellSize = { 1400, 1400 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1},
-			},
-		} },
-		{ "ov4689", {
-			.unitCellSize = { 2000, 2000 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1},
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2},
-				/*
-				 * No corresponding test patterns in
-				 * MIPI CCS specification for sensor's
-				 * colorBarType2 and colorBarType3.
-				 */
-			},
-		} },
-		{ "ov5640", {
-			.unitCellSize = { 1400, 1400 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-			},
-		} },
-		{ "ov5647", {
-			.unitCellSize = { 1400, 1400 },
-			.testPatternModes = {},
-		} },
-		{ "ov5670", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-			},
-		} },
-		{ "ov5675", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-			},
-		} },
-		{ "ov5693", {
-			.unitCellSize = { 1400, 1400 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 2 },
-				/*
-				 * No corresponding test pattern mode for
-				 * 1: "Random data" and 3: "Colour Bars with
-				 * Rolling Bar".
-				 */
-			},
-		} },
-		{ "ov64a40", {
-			.unitCellSize = { 1008, 1008 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2 },
-				/*
-				 * No corresponding test patter mode
-				 * 3: "Vertical Color Bar Type 3",
-				 * 4: "Vertical Color Bar Type 4"
-				 */
-			},
-		} },
-		{ "ov8858", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2 },
-				/*
-				 * No corresponding test patter mode
-				 * 3: "Vertical Color Bar Type 3",
-				 * 4: "Vertical Color Bar Type 4"
-				 */
-			},
-		} },
-		{ "ov8865", {
-			.unitCellSize = { 1400, 1400 },
-			.testPatternModes = {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 2 },
-				/*
-				 * No corresponding test pattern mode for:
-				 * 1: "Random data"
-				 * 3: "Color bars with rolling bar"
-				 * 4: "Color squares"
-				 * 5: "Color squares with rolling bar"
-				 */
-			},
-		} },
-		{ "ov13858", {
-			.unitCellSize = { 1120, 1120 },
-			.testPatternModes =  {
-				{ controls::draft::TestPatternModeOff, 0 },
-				{ controls::draft::TestPatternModeColorBars, 1 },
-			},
-		} },
-	};
-
-	const auto it = sensorProps.find(sensor);
-	if (it == sensorProps.end()) {
-		LOG(CameraSensorProperties, Warning)
-			<< "No static properties available for '" << sensor << "'";
-		LOG(CameraSensorProperties, Warning)
-			<< "Please consider updating the camera sensor properties database";
-		return nullptr;
-	}
-
-	return &it->second;
-}
-
-} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/color_space.cpp 0.3.0-1/src/libcamera/color_space.cpp
--- 0.2.0-3/src/libcamera/color_space.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/color_space.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Raspberry Pi Ltd
  *
- * color_space.cpp - color spaces.
+ * color spaces.
  */
 
 #include <libcamera/color_space.h>
diff -pruN 0.2.0-3/src/libcamera/control_ids_core.yaml 0.3.0-1/src/libcamera/control_ids_core.yaml
--- 0.2.0-3/src/libcamera/control_ids_core.yaml	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/control_ids_core.yaml	2024-05-19 15:54:11.000000000 +0000
@@ -449,7 +449,7 @@ controls:
         range of reported temperatures is device dependent.
 
         The SensorTemperature control will only be returned in metadata if a
-        themal sensor is present.
+        thermal sensor is present.
 
   - SensorTimestamp:
       type: int64_t
diff -pruN 0.2.0-3/src/libcamera/control_serializer.cpp 0.3.0-1/src/libcamera/control_serializer.cpp
--- 0.2.0-3/src/libcamera/control_serializer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/control_serializer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_serializer.cpp - Control (de)serializer
+ * Control (de)serializer
  */
 
 #include "libcamera/internal/control_serializer.h"
diff -pruN 0.2.0-3/src/libcamera/control_validator.cpp 0.3.0-1/src/libcamera/control_validator.cpp
--- 0.2.0-3/src/libcamera/control_validator.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/control_validator.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_validator.cpp - Control validator
+ * Control validator
  */
 
 #include "libcamera/internal/control_validator.h"
diff -pruN 0.2.0-3/src/libcamera/controls.cpp 0.3.0-1/src/libcamera/controls.cpp
--- 0.2.0-3/src/libcamera/controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * controls.cpp - Control handling
+ * Control handling
  */
 
 #include <libcamera/controls.h>
@@ -908,12 +908,26 @@ ControlList::ControlList(const ControlIn
  */
 
 /**
+ * \enum ControlList::MergePolicy
+ * \brief The policy used by the merge function
+ *
+ * \var ControlList::MergePolicy::KeepExisting
+ * \brief Existing controls in the target list are kept
+ *
+ * \var ControlList::MergePolicy::OverwriteExisting
+ * \brief Existing controls in the target list are updated
+ */
+
+/**
  * \brief Merge the \a source into the ControlList
  * \param[in] source The ControlList to merge into this object
+ * \param[in] policy Controls if existing elements in *this shall be
+ * overwritten
  *
  * Merging two control lists copies elements from the \a source and inserts
  * them in *this. If the \a source contains elements whose key is already
- * present in *this, then those elements are not overwritten.
+ * present in *this, then those elements are only overwritten if
+ * \a policy is MergePolicy::OverwriteExisting.
  *
  * Only control lists created from the same ControlIdMap or ControlInfoMap may
  * be merged. Attempting to do otherwise results in undefined behaviour.
@@ -921,7 +935,7 @@ ControlList::ControlList(const ControlIn
  * \todo Reimplement or implement an overloaded version which internally uses
  * std::unordered_map::merge() and accepts a non-const argument.
  */
-void ControlList::merge(const ControlList &source)
+void ControlList::merge(const ControlList &source, MergePolicy policy)
 {
 	/**
 	 * \todo ASSERT that the current and source ControlList are derived
@@ -936,7 +950,7 @@ void ControlList::merge(const ControlLis
 	 */
 
 	for (const auto &ctrl : source) {
-		if (contains(ctrl.first)) {
+		if (policy == MergePolicy::KeepExisting && contains(ctrl.first)) {
 			const ControlId *id = idmap_->at(ctrl.first);
 			LOG(Controls, Warning)
 				<< "Control " << id->name() << " not overwritten";
diff -pruN 0.2.0-3/src/libcamera/converter/converter_v4l2_m2m.cpp 0.3.0-1/src/libcamera/converter/converter_v4l2_m2m.cpp
--- 0.2.0-3/src/libcamera/converter/converter_v4l2_m2m.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/converter/converter_v4l2_m2m.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Laurent Pinchart
  * Copyright 2022 NXP
  *
- * converter_v4l2_m2m.cpp - V4L2 M2M Format converter
+ * V4L2 M2M Format converter
  */
 
 #include "libcamera/internal/converter/converter_v4l2_m2m.h"
@@ -445,6 +445,7 @@ int V4L2M2MConverter::queueBuffers(Frame
 }
 
 static std::initializer_list<std::string> compatibles = {
+	"mtk-mdp",
 	"pxp",
 };
 
diff -pruN 0.2.0-3/src/libcamera/converter.cpp 0.3.0-1/src/libcamera/converter.cpp
--- 0.2.0-3/src/libcamera/converter.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/converter.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright 2022 NXP
  *
- * converter.cpp - Generic format converter interface
+ * Generic format converter interface
  */
 
 #include "libcamera/internal/converter.h"
diff -pruN 0.2.0-3/src/libcamera/delayed_controls.cpp 0.3.0-1/src/libcamera/delayed_controls.cpp
--- 0.2.0-3/src/libcamera/delayed_controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/delayed_controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * delayed_controls.h - Helper to deal with controls that take effect with a delay
+ * Helper to deal with controls that take effect with a delay
  */
 
 #include "libcamera/internal/delayed_controls.h"
diff -pruN 0.2.0-3/src/libcamera/device_enumerator.cpp 0.3.0-1/src/libcamera/device_enumerator.cpp
--- 0.2.0-3/src/libcamera/device_enumerator.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/device_enumerator.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * device_enumerator.cpp - Enumeration and matching
+ * Enumeration and matching
  */
 
 #include "libcamera/internal/device_enumerator.h"
@@ -56,7 +56,7 @@ LOG_DEFINE_CATEGORY(DeviceEnumerator)
  * names can be added as match criteria.
  *
  * Pipeline handlers are recommended to add entities to DeviceMatch as
- * appropriare to ensure that the media device they need can be uniquely
+ * appropriate to ensure that the media device they need can be uniquely
  * identified. This is useful when the corresponding kernel driver can produce
  * different graphs, for instance as a result of different driver versions or
  * hardware configurations, and not all those graphs are suitable for a pipeline
diff -pruN 0.2.0-3/src/libcamera/device_enumerator_sysfs.cpp 0.3.0-1/src/libcamera/device_enumerator_sysfs.cpp
--- 0.2.0-3/src/libcamera/device_enumerator_sysfs.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/device_enumerator_sysfs.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * device_enumerator_sysfs.cpp - sysfs-based device enumerator
+ * sysfs-based device enumerator
  */
 
 #include "libcamera/internal/device_enumerator_sysfs.h"
diff -pruN 0.2.0-3/src/libcamera/device_enumerator_udev.cpp 0.3.0-1/src/libcamera/device_enumerator_udev.cpp
--- 0.2.0-3/src/libcamera/device_enumerator_udev.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/device_enumerator_udev.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018-2019, Google Inc.
  *
- * device_enumerator_udev.cpp - udev-based device enumerator
+ * udev-based device enumerator
  */
 
 #include "libcamera/internal/device_enumerator_udev.h"
diff -pruN 0.2.0-3/src/libcamera/dma_heaps.cpp 0.3.0-1/src/libcamera/dma_heaps.cpp
--- 0.2.0-3/src/libcamera/dma_heaps.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/dma_heaps.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,165 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2020, Raspberry Pi Ltd
+ *
+ * Helper class for dma-heap allocations.
+ */
+
+#include "libcamera/internal/dma_heaps.h"
+
+#include <array>
+#include <fcntl.h>
+#include <sys/ioctl.h>
+#include <unistd.h>
+
+#include <linux/dma-buf.h>
+#include <linux/dma-heap.h>
+
+#include <libcamera/base/log.h>
+
+/**
+ * \file dma_heaps.cpp
+ * \brief dma-heap allocator
+ */
+
+namespace libcamera {
+
+/*
+ * /dev/dma_heap/linux,cma is the dma-heap allocator, which allows dmaheap-cma
+ * to only have to worry about importing.
+ *
+ * Annoyingly, should the cma heap size be specified on the kernel command line
+ * instead of DT, the heap gets named "reserved" instead.
+ */
+
+#ifndef __DOXYGEN__
+struct DmaHeapInfo {
+	DmaHeap::DmaHeapFlag type;
+	const char *deviceNodeName;
+};
+#endif
+
+static constexpr std::array<DmaHeapInfo, 3> heapInfos = { {
+	{ DmaHeap::DmaHeapFlag::Cma, "/dev/dma_heap/linux,cma" },
+	{ DmaHeap::DmaHeapFlag::Cma, "/dev/dma_heap/reserved" },
+	{ DmaHeap::DmaHeapFlag::System, "/dev/dma_heap/system" },
+} };
+
+LOG_DEFINE_CATEGORY(DmaHeap)
+
+/**
+ * \class DmaHeap
+ * \brief Helper class for dma-heap allocations
+ *
+ * DMA heaps are kernel devices that provide an API to allocate memory from
+ * different pools called "heaps", wrap each allocated piece of memory in a
+ * dmabuf object, and return the dmabuf file descriptor to userspace. Multiple
+ * heaps can be provided by the system, with different properties for the
+ * underlying memory.
+ *
+ * This class wraps a DMA heap selected at construction time, and exposes
+ * functions to manage memory allocation.
+ */
+
+/**
+ * \enum DmaHeap::DmaHeapFlag
+ * \brief Type of the dma-heap
+ * \var DmaHeap::Cma
+ * \brief Allocate from a CMA dma-heap, providing physically-contiguous memory
+ * \var DmaHeap::System
+ * \brief Allocate from the system dma-heap, using the page allocator
+ */
+
+/**
+ * \typedef DmaHeap::DmaHeapFlags
+ * \brief A bitwise combination of DmaHeap::DmaHeapFlag values
+ */
+
+/**
+ * \brief Construct a DmaHeap of a given type
+ * \param[in] type The type(s) of the dma-heap(s) to allocate from
+ *
+ * The DMA heap type is selected with the \a type parameter, which defaults to
+ * the CMA heap. If no heap of the given type can be accessed, the constructed
+ * DmaHeap instance is invalid as indicated by the isValid() function.
+ *
+ * Multiple types can be selected by combining type flags, in which case the
+ * constructed DmaHeap will match one of the types. If the system provides
+ * multiple heaps that match the requested types, which heap is used is
+ * undefined.
+ */
+DmaHeap::DmaHeap(DmaHeapFlags type)
+{
+	for (const auto &info : heapInfos) {
+		if (!(type & info.type))
+			continue;
+
+		int ret = ::open(info.deviceNodeName, O_RDWR | O_CLOEXEC, 0);
+		if (ret < 0) {
+			ret = errno;
+			LOG(DmaHeap, Debug)
+				<< "Failed to open " << info.deviceNodeName << ": "
+				<< strerror(ret);
+			continue;
+		}
+
+		LOG(DmaHeap, Debug) << "Using " << info.deviceNodeName;
+		dmaHeapHandle_ = UniqueFD(ret);
+		break;
+	}
+
+	if (!dmaHeapHandle_.isValid())
+		LOG(DmaHeap, Error) << "Could not open any dmaHeap device";
+}
+
+/**
+ * \brief Destroy the DmaHeap instance
+ */
+DmaHeap::~DmaHeap() = default;
+
+/**
+ * \fn DmaHeap::isValid()
+ * \brief Check if the DmaHeap instance is valid
+ * \return True if the DmaHeap is valid, false otherwise
+ */
+
+/**
+ * \brief Allocate a dma-buf from the DmaHeap
+ * \param [in] name The name to set for the allocated buffer
+ * \param [in] size The size of the buffer to allocate
+ *
+ * Allocates a dma-buf with read/write access.
+ *
+ * If the allocation fails, return an invalid UniqueFD.
+ *
+ * \return The UniqueFD of the allocated buffer
+ */
+UniqueFD DmaHeap::alloc(const char *name, std::size_t size)
+{
+	int ret;
+
+	if (!name)
+		return {};
+
+	struct dma_heap_allocation_data alloc = {};
+
+	alloc.len = size;
+	alloc.fd_flags = O_CLOEXEC | O_RDWR;
+
+	ret = ::ioctl(dmaHeapHandle_.get(), DMA_HEAP_IOCTL_ALLOC, &alloc);
+	if (ret < 0) {
+		LOG(DmaHeap, Error) << "dmaHeap allocation failure for " << name;
+		return {};
+	}
+
+	UniqueFD allocFd(alloc.fd);
+	ret = ::ioctl(allocFd.get(), DMA_BUF_SET_NAME, name);
+	if (ret < 0) {
+		LOG(DmaHeap, Error) << "dmaHeap naming failure for " << name;
+		return {};
+	}
+
+	return allocFd;
+}
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/fence.cpp 0.3.0-1/src/libcamera/fence.cpp
--- 0.2.0-3/src/libcamera/fence.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/fence.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * fence.cpp - Synchronization fence
+ * Synchronization fence
  */
 
 #include "libcamera/fence.h"
diff -pruN 0.2.0-3/src/libcamera/formats.cpp 0.3.0-1/src/libcamera/formats.cpp
--- 0.2.0-3/src/libcamera/formats.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/formats.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * formats.cpp - libcamera image formats
+ * libcamera image formats
  */
 
 #include "libcamera/internal/formats.h"
@@ -33,7 +33,7 @@ LOG_DEFINE_CATEGORY(Formats)
  * used in pipeline handlers.
  *
  * \var PixelFormatInfo::name
- * \brief The format name as a human-readable string, used as the test
+ * \brief The format name as a human-readable string, used as the text
  * representation of the PixelFormat
  *
  * \var PixelFormatInfo::format
@@ -49,9 +49,9 @@ LOG_DEFINE_CATEGORY(Formats)
  * \var PixelFormatInfo::bitsPerPixel
  * \brief The average number of bits per pixel
  *
- * The number per pixel averages the total number of bits for all colour
- * components over the whole image, excluding any padding bits or padding
- * pixels.
+ * The number of bits per pixel averages the total number of bits for all
+ * colour components over the whole image, excluding any padding bits or
+ * padding pixels.
  *
  * For formats that store pixels with bit padding within words, only the
  * effective bits are taken into account. For instance, 12-bit Bayer data
@@ -270,6 +270,26 @@ const std::map<PixelFormat, PixelFormatI
 		.pixelsPerGroup = 1,
 		.planes = {{ { 4, 1 }, { 0, 0 }, { 0, 0 } }},
 	} },
+	{ formats::BGR161616, {
+		.name = "BGR161616",
+		.format = formats::BGR161616,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_RGB48), },
+		.bitsPerPixel = 48,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+		.packed = false,
+		.pixelsPerGroup = 1,
+		.planes = {{ { 3, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
+	{ formats::RGB161616, {
+		.name = "RGB161616",
+		.format = formats::RGB161616,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_BGR48), },
+		.bitsPerPixel = 48,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+		.packed = false,
+		.pixelsPerGroup = 1,
+		.planes = {{ { 3, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
 
 	/* YUV packed formats. */
 	{ formats::YUYV, {
@@ -497,6 +517,16 @@ const std::map<PixelFormat, PixelFormatI
 		.pixelsPerGroup = 1,
 		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
 	} },
+	{ formats::R10_CSI2P, {
+		.name = "R10_CSI2P",
+		.format = formats::R10_CSI2P,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_Y10P), },
+		.bitsPerPixel = 10,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+		.packed = true,
+		.pixelsPerGroup = 4,
+		.planes = {{ { 5, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
 	{ formats::R12, {
 		.name = "R12",
 		.format = formats::R12,
@@ -507,15 +537,25 @@ const std::map<PixelFormat, PixelFormatI
 		.pixelsPerGroup = 1,
 		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
 	} },
-	{ formats::R10_CSI2P, {
-		.name = "R10_CSI2P",
-		.format = formats::R10_CSI2P,
-		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_Y10P), },
-		.bitsPerPixel = 10,
+	{ formats::R16, {
+		.name = "R16",
+		.format = formats::R16,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_Y16), },
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+		.packed = false,
+		.pixelsPerGroup = 1,
+		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
+	{ formats::MONO_PISP_COMP1, {
+		.name = "MONO_PISP_COMP1",
+		.format = formats::MONO_PISP_COMP1,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_MONO), },
+		.bitsPerPixel = 8,
 		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
 		.packed = true,
-		.pixelsPerGroup = 4,
-		.planes = {{ { 5, 1 }, { 0, 0 }, { 0, 0 } }},
+		.pixelsPerGroup = 1,
+		.planes = {{ { 1, 1 }, { 0, 0 }, { 0, 0 } }},
 	} },
 
 	/* Bayer formats. */
@@ -880,7 +920,46 @@ const std::map<PixelFormat, PixelFormatI
 		.pixelsPerGroup = 25,
 		.planes = {{ { 32, 1 }, { 0, 0 }, { 0, 0 } }},
 	} },
-
+	{ formats::BGGR_PISP_COMP1, {
+		.name = "BGGR_PISP_COMP1",
+		.format = formats::BGGR_PISP_COMP1,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_BGGR), },
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+		.packed = true,
+		.pixelsPerGroup = 2,
+		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
+	{ formats::GBRG_PISP_COMP1, {
+		.name = "GBRG_PISP_COMP1",
+		.format = formats::GBRG_PISP_COMP1,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_GBRG), },
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+		.packed = true,
+		.pixelsPerGroup = 2,
+		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
+	{ formats::GRBG_PISP_COMP1, {
+		.name = "GRBG_PISP_COMP1",
+		.format = formats::GRBG_PISP_COMP1,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_GRBG), },
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+		.packed = true,
+		.pixelsPerGroup = 2,
+		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
+	{ formats::RGGB_PISP_COMP1, {
+		.name = "RGGB_PISP_COMP1",
+		.format = formats::RGGB_PISP_COMP1,
+		.v4l2Formats = { V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_RGGB), },
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+		.packed = true,
+		.pixelsPerGroup = 2,
+		.planes = {{ { 2, 1 }, { 0, 0 }, { 0, 0 } }},
+	} },
 	/* Compressed formats. */
 	{ formats::MJPEG, {
 		.name = "MJPEG",
@@ -987,7 +1066,7 @@ unsigned int PixelFormatInfo::stride(uns
 		return 0;
 	}
 
-	if (plane > planes.size() || !planes[plane].bytesPerGroup) {
+	if (plane >= planes.size() || !planes[plane].bytesPerGroup) {
 		LOG(Formats, Warning) << "Invalid plane index, stride is zero";
 		return 0;
 	}
diff -pruN 0.2.0-3/src/libcamera/formats.yaml 0.3.0-1/src/libcamera/formats.yaml
--- 0.2.0-3/src/libcamera/formats.yaml	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/formats.yaml	2024-05-19 15:54:11.000000000 +0000
@@ -11,6 +11,8 @@ formats:
       fourcc: DRM_FORMAT_R10
   - R12:
       fourcc: DRM_FORMAT_R12
+  - R16:
+      fourcc: DRM_FORMAT_R16
 
   - RGB565:
       fourcc: DRM_FORMAT_RGB565
@@ -41,6 +43,11 @@ formats:
   - BGRA8888:
       fourcc: DRM_FORMAT_BGRA8888
 
+  - RGB161616:
+      fourcc: DRM_FORMAT_RGB161616
+  - BGR161616:
+      fourcc: DRM_FORMAT_BGR161616
+
   - YUYV:
       fourcc: DRM_FORMAT_YUYV
   - YVYU:
@@ -183,4 +190,20 @@ formats:
   - SBGGR10_IPU3:
       fourcc: DRM_FORMAT_SBGGR10
       mod: IPU3_FORMAT_MOD_PACKED
+
+  - RGGB_PISP_COMP1:
+      fourcc: DRM_FORMAT_SRGGB16
+      mod: PISP_FORMAT_MOD_COMPRESS_MODE1
+  - GRBG_PISP_COMP1:
+      fourcc: DRM_FORMAT_SGRBG16
+      mod: PISP_FORMAT_MOD_COMPRESS_MODE1
+  - GBRG_PISP_COMP1:
+      fourcc: DRM_FORMAT_SGBRG16
+      mod: PISP_FORMAT_MOD_COMPRESS_MODE1
+  - BGGR_PISP_COMP1:
+      fourcc: DRM_FORMAT_SBGGR16
+      mod: PISP_FORMAT_MOD_COMPRESS_MODE1
+  - MONO_PISP_COMP1:
+      fourcc: DRM_FORMAT_R16
+      mod: PISP_FORMAT_MOD_COMPRESS_MODE1
 ...
diff -pruN 0.2.0-3/src/libcamera/framebuffer.cpp 0.3.0-1/src/libcamera/framebuffer.cpp
--- 0.2.0-3/src/libcamera/framebuffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/framebuffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * framebuffer.cpp - Frame buffer handling
+ * Frame buffer handling
  */
 
 #include <libcamera/framebuffer.h>
diff -pruN 0.2.0-3/src/libcamera/framebuffer_allocator.cpp 0.3.0-1/src/libcamera/framebuffer_allocator.cpp
--- 0.2.0-3/src/libcamera/framebuffer_allocator.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/framebuffer_allocator.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * framebuffer_allocator.cpp - FrameBuffer allocator
+ * FrameBuffer allocator
  */
 
 #include <libcamera/framebuffer_allocator.h>
@@ -59,14 +59,11 @@ LOG_DEFINE_CATEGORY(Allocator)
  * \param[in] camera The camera
  */
 FrameBufferAllocator::FrameBufferAllocator(std::shared_ptr<Camera> camera)
-	: camera_(camera)
+	: camera_(std::move(camera))
 {
 }
 
-FrameBufferAllocator::~FrameBufferAllocator()
-{
-	buffers_.clear();
-}
+FrameBufferAllocator::~FrameBufferAllocator() = default;
 
 /**
  * \brief Allocate buffers for a configured stream
@@ -100,6 +97,10 @@ int FrameBufferAllocator::allocate(Strea
 		LOG(Allocator, Error)
 			<< "Stream is not part of " << camera_->id()
 			<< " active configuration";
+
+	if (ret < 0)
+		buffers_.erase(it);
+
 	return ret;
 }
 
diff -pruN 0.2.0-3/src/libcamera/geometry.cpp 0.3.0-1/src/libcamera/geometry.cpp
--- 0.2.0-3/src/libcamera/geometry.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/geometry.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * geometry.cpp - Geometry-related structures
+ * Geometry-related structures
  */
 
 #include <libcamera/geometry.h>
diff -pruN 0.2.0-3/src/libcamera/ipa_controls.cpp 0.3.0-1/src/libcamera/ipa_controls.cpp
--- 0.2.0-3/src/libcamera/ipa_controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_controls.cpp - IPA control handling
+ * IPA control handling
  */
 
 #include <libcamera/ipa/ipa_controls.h>
diff -pruN 0.2.0-3/src/libcamera/ipa_data_serializer.cpp 0.3.0-1/src/libcamera/ipa_data_serializer.cpp
--- 0.2.0-3/src/libcamera/ipa_data_serializer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_data_serializer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipa_data_serializer.cpp - Image Processing Algorithm data serializer
+ * Image Processing Algorithm data serializer
  */
 
 #include "libcamera/internal/ipa_data_serializer.h"
diff -pruN 0.2.0-3/src/libcamera/ipa_interface.cpp 0.3.0-1/src/libcamera/ipa_interface.cpp
--- 0.2.0-3/src/libcamera/ipa_interface.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_interface.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_interface.cpp - Image Processing Algorithm interface
+ * Image Processing Algorithm interface
  */
 
 #include <libcamera/ipa/ipa_interface.h>
diff -pruN 0.2.0-3/src/libcamera/ipa_manager.cpp 0.3.0-1/src/libcamera/ipa_manager.cpp
--- 0.2.0-3/src/libcamera/ipa_manager.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_manager.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_manager.cpp - Image Processing Algorithm module manager
+ * Image Processing Algorithm module manager
  */
 
 #include "libcamera/internal/ipa_manager.h"
diff -pruN 0.2.0-3/src/libcamera/ipa_module.cpp 0.3.0-1/src/libcamera/ipa_module.cpp
--- 0.2.0-3/src/libcamera/ipa_module.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_module.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_module.cpp - Image Processing Algorithm module
+ * Image Processing Algorithm module
  */
 
 #include "libcamera/internal/ipa_module.h"
diff -pruN 0.2.0-3/src/libcamera/ipa_proxy.cpp 0.3.0-1/src/libcamera/ipa_proxy.cpp
--- 0.2.0-3/src/libcamera/ipa_proxy.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_proxy.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_proxy.cpp - Image Processing Algorithm proxy
+ * Image Processing Algorithm proxy
  */
 
 #include "libcamera/internal/ipa_proxy.h"
diff -pruN 0.2.0-3/src/libcamera/ipa_pub_key.cpp.in 0.3.0-1/src/libcamera/ipa_pub_key.cpp.in
--- 0.2.0-3/src/libcamera/ipa_pub_key.cpp.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipa_pub_key.cpp.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Laurent Pinchart <laurent.pinchart@ideasonboard.com>
  *
- * ipa_pub_key.cpp - IPA module signing public key
+ * IPA module signing public key
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/src/libcamera/ipc_pipe.cpp 0.3.0-1/src/libcamera/ipc_pipe.cpp
--- 0.2.0-3/src/libcamera/ipc_pipe.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipc_pipe.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipc_pipe.cpp - Image Processing Algorithm IPC module for IPA proxies
+ * Image Processing Algorithm IPC module for IPA proxies
  */
 
 #include "libcamera/internal/ipc_pipe.h"
diff -pruN 0.2.0-3/src/libcamera/ipc_pipe_unixsocket.cpp 0.3.0-1/src/libcamera/ipc_pipe_unixsocket.cpp
--- 0.2.0-3/src/libcamera/ipc_pipe_unixsocket.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipc_pipe_unixsocket.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipc_pipe_unixsocket.cpp - Image Processing Algorithm IPC module using unix socket
+ * Image Processing Algorithm IPC module using unix socket
  */
 
 #include "libcamera/internal/ipc_pipe_unixsocket.h"
diff -pruN 0.2.0-3/src/libcamera/ipc_unixsocket.cpp 0.3.0-1/src/libcamera/ipc_unixsocket.cpp
--- 0.2.0-3/src/libcamera/ipc_unixsocket.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/ipc_unixsocket.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipc_unixsocket.cpp - IPC mechanism based on Unix sockets
+ * IPC mechanism based on Unix sockets
  */
 
 #include "libcamera/internal/ipc_unixsocket.h"
diff -pruN 0.2.0-3/src/libcamera/mapped_framebuffer.cpp 0.3.0-1/src/libcamera/mapped_framebuffer.cpp
--- 0.2.0-3/src/libcamera/mapped_framebuffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/mapped_framebuffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * mapped_framebuffer.cpp - Mapped Framebuffer support
+ * Mapped Framebuffer support
  */
 
 #include "libcamera/internal/mapped_framebuffer.h"
diff -pruN 0.2.0-3/src/libcamera/media_device.cpp 0.3.0-1/src/libcamera/media_device.cpp
--- 0.2.0-3/src/libcamera/media_device.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/media_device.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * media_device.cpp - Media device handler
+ * Media device handler
  */
 
 #include "libcamera/internal/media_device.h"
diff -pruN 0.2.0-3/src/libcamera/media_object.cpp 0.3.0-1/src/libcamera/media_object.cpp
--- 0.2.0-3/src/libcamera/media_object.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/media_object.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * media_object.cpp - Media device objects: entities, pads and links
+ * Media device objects: entities, pads and links
  */
 
 #include "libcamera/internal/media_object.h"
diff -pruN 0.2.0-3/src/libcamera/meson.build 0.3.0-1/src/libcamera/meson.build
--- 0.2.0-3/src/libcamera/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -7,8 +7,6 @@ libcamera_sources = files([
     'camera_controls.cpp',
     'camera_lens.cpp',
     'camera_manager.cpp',
-    'camera_sensor.cpp',
-    'camera_sensor_properties.cpp',
     'color_space.cpp',
     'controls.cpp',
     'control_serializer.cpp',
@@ -17,6 +15,7 @@ libcamera_sources = files([
     'delayed_controls.cpp',
     'device_enumerator.cpp',
     'device_enumerator_sysfs.cpp',
+    'dma_heaps.cpp',
     'fence.cpp',
     'formats.cpp',
     'framebuffer.cpp',
@@ -40,6 +39,7 @@ libcamera_sources = files([
     'process.cpp',
     'pub_key.cpp',
     'request.cpp',
+    'shared_mem_object.cpp',
     'source_paths.cpp',
     'stream.cpp',
     'sysfs.cpp',
@@ -69,6 +69,8 @@ subdir('converter')
 subdir('ipa')
 subdir('pipeline')
 subdir('proxy')
+subdir('sensor')
+subdir('software_isp')
 
 null_dep = dependency('', required : false)
 
diff -pruN 0.2.0-3/src/libcamera/orientation.cpp 0.3.0-1/src/libcamera/orientation.cpp
--- 0.2.0-3/src/libcamera/orientation.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/orientation.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Ideas On Board Oy
  *
- * orientation.cpp - Image orientation
+ * Image orientation
  */
 
 #include <libcamera/orientation.h>
diff -pruN 0.2.0-3/src/libcamera/pipeline/imx8-isi/imx8-isi.cpp 0.3.0-1/src/libcamera/pipeline/imx8-isi/imx8-isi.cpp
--- 0.2.0-3/src/libcamera/pipeline/imx8-isi/imx8-isi.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/imx8-isi/imx8-isi.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022 - Jacopo Mondi <jacopo@jmondi.org>
  *
- * imx8-isi.cpp - Pipeline handler for ISI interface found on NXP i.MX8 SoC
+ * Pipeline handler for ISI interface found on NXP i.MX8 SoC
  */
 
 #include <algorithm>
@@ -554,7 +554,7 @@ CameraConfiguration::Status ISICameraCon
 	PixelFormat pixelFormat = config_[0].pixelFormat;
 
 	V4L2SubdeviceFormat sensorFormat{};
-	sensorFormat.mbus_code = data_->getMediaBusFormat(&pixelFormat);
+	sensorFormat.code = data_->getMediaBusFormat(&pixelFormat);
 	sensorFormat.size = maxSize;
 
 	LOG(ISI, Debug) << "Computed sensor configuration: " << sensorFormat;
@@ -569,7 +569,7 @@ CameraConfiguration::Status ISICameraCon
 	 * the smallest larger format without considering the aspect ratio
 	 * as the ISI can freely scale.
 	 */
-	auto sizes = sensor->sizes(sensorFormat.mbus_code);
+	auto sizes = sensor->sizes(sensorFormat.code);
 	Size bestSize;
 
 	for (const Size &s : sizes) {
@@ -595,7 +595,7 @@ CameraConfiguration::Status ISICameraCon
 		return Invalid;
 	}
 
-	sensorFormat_.mbus_code = sensorFormat.mbus_code;
+	sensorFormat_.code = sensorFormat.code;
 	sensorFormat_.size = bestSize;
 
 	LOG(ISI, Debug) << "Selected sensor format: " << sensorFormat_;
@@ -632,7 +632,7 @@ StreamConfiguration PipelineHandlerISI::
 
 	/* Adjust the requested size to the sensor's capabilities. */
 	V4L2SubdeviceFormat sensorFmt;
-	sensorFmt.mbus_code = mbusCode;
+	sensorFmt.code = mbusCode;
 	sensorFmt.size = size;
 
 	int ret = data->sensor_->tryFormat(&sensorFmt);
@@ -827,16 +827,10 @@ int PipelineHandlerISI::configure(Camera
 	unsigned int xbarFirstSource = crossbar_->entity()->pads().size() / 2 + 1;
 
 	for (const auto &[idx, config] : utils::enumerate(*c)) {
-		struct v4l2_subdev_route route = {
-			.sink_pad = data->xbarSink_,
-			.sink_stream = 0,
-			.source_pad = static_cast<uint32_t>(xbarFirstSource + idx),
-			.source_stream = 0,
-			.flags = V4L2_SUBDEV_ROUTE_FL_ACTIVE,
-			.reserved = {}
-		};
-
-		routing.push_back(route);
+		uint32_t sourcePad = xbarFirstSource + idx;
+		routing.emplace_back(V4L2Subdevice::Stream{ data->xbarSink_, 0 },
+				     V4L2Subdevice::Stream{ sourcePad, 0 },
+				     V4L2_SUBDEV_ROUTE_FL_ACTIVE);
 	}
 
 	int ret = crossbar_->setRouting(&routing, V4L2Subdevice::ActiveFormat);
@@ -891,7 +885,7 @@ int PipelineHandlerISI::configure(Camera
 		unsigned int isiCode = ISICameraConfiguration::formatsMap_.at(config.pixelFormat);
 
 		V4L2SubdeviceFormat isiFormat{};
-		isiFormat.mbus_code = isiCode;
+		isiFormat.code = isiCode;
 		isiFormat.size = config.size;
 
 		ret = pipe->isi->setFormat(1, &isiFormat);
@@ -1118,6 +1112,6 @@ void PipelineHandlerISI::bufferReady(Fra
 	completeRequest(request);
 }
 
-REGISTER_PIPELINE_HANDLER(PipelineHandlerISI)
+REGISTER_PIPELINE_HANDLER(PipelineHandlerISI, "imx8-isi")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/cio2.cpp 0.3.0-1/src/libcamera/pipeline/ipu3/cio2.cpp
--- 0.2.0-3/src/libcamera/pipeline/ipu3/cio2.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/cio2.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * cio2.cpp - Intel IPU3 CIO2
+ * Intel IPU3 CIO2
  */
 
 #include "cio2.h"
@@ -202,7 +202,7 @@ int CIO2Device::configure(const Size &si
 	if (ret)
 		return ret;
 
-	const auto &itInfo = mbusCodesToPixelFormat.find(sensorFormat.mbus_code);
+	const auto &itInfo = mbusCodesToPixelFormat.find(sensorFormat.code);
 	if (itInfo == mbusCodesToPixelFormat.end())
 		return -EINVAL;
 
@@ -230,13 +230,13 @@ StreamConfiguration CIO2Device::generate
 	/* Query the sensor static information for closest match. */
 	std::vector<unsigned int> mbusCodes = utils::map_keys(mbusCodesToPixelFormat);
 	V4L2SubdeviceFormat sensorFormat = getSensorFormat(mbusCodes, size);
-	if (!sensorFormat.mbus_code) {
+	if (!sensorFormat.code) {
 		LOG(IPU3, Error) << "Sensor does not support mbus code";
 		return {};
 	}
 
 	cfg.size = sensorFormat.size;
-	cfg.pixelFormat = mbusCodesToPixelFormat.at(sensorFormat.mbus_code);
+	cfg.pixelFormat = mbusCodesToPixelFormat.at(sensorFormat.code);
 	cfg.bufferCount = kBufferCount;
 
 	return cfg;
@@ -326,7 +326,7 @@ V4L2SubdeviceFormat CIO2Device::getSenso
 	}
 
 	V4L2SubdeviceFormat format{};
-	format.mbus_code = bestCode;
+	format.code = bestCode;
 	format.size = bestSize;
 
 	return format;
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/cio2.h 0.3.0-1/src/libcamera/pipeline/ipu3/cio2.h
--- 0.2.0-3/src/libcamera/pipeline/ipu3/cio2.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/cio2.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * cio2.h - Intel IPU3 CIO2
+ * Intel IPU3 CIO2
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/frames.cpp 0.3.0-1/src/libcamera/pipeline/ipu3/frames.cpp
--- 0.2.0-3/src/libcamera/pipeline/ipu3/frames.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/frames.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * frames.cpp - Intel IPU3 Frames helper
+ * Intel IPU3 Frames helper
  */
 
 #include "frames.h"
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/frames.h 0.3.0-1/src/libcamera/pipeline/ipu3/frames.h
--- 0.2.0-3/src/libcamera/pipeline/ipu3/frames.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/frames.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * frames.h - Intel IPU3 Frames helper
+ * Intel IPU3 Frames helper
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/imgu.cpp 0.3.0-1/src/libcamera/pipeline/ipu3/imgu.cpp
--- 0.2.0-3/src/libcamera/pipeline/ipu3/imgu.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/imgu.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * imgu.cpp - Intel IPU3 ImgU
+ * Intel IPU3 ImgU
  */
 
 #include "imgu.h"
@@ -504,7 +504,7 @@ int ImgUDevice::configure(const PipeConf
 	LOG(IPU3, Debug) << "ImgU BDS rectangle = " << bds;
 
 	V4L2SubdeviceFormat gdcFormat = {};
-	gdcFormat.mbus_code = MEDIA_BUS_FMT_FIXED;
+	gdcFormat.code = MEDIA_BUS_FMT_FIXED;
 	gdcFormat.size = pipeConfig.gdc;
 
 	ret = imgu_->setFormat(PAD_INPUT, &gdcFormat);
@@ -543,7 +543,7 @@ int ImgUDevice::configureVideoDevice(V4L
 				     V4L2DeviceFormat *outputFormat)
 {
 	V4L2SubdeviceFormat imguFormat = {};
-	imguFormat.mbus_code = MEDIA_BUS_FMT_FIXED;
+	imguFormat.code = MEDIA_BUS_FMT_FIXED;
 	imguFormat.size = cfg.size;
 
 	int ret = imgu_->setFormat(pad, &imguFormat);
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/imgu.h 0.3.0-1/src/libcamera/pipeline/ipu3/imgu.h
--- 0.2.0-3/src/libcamera/pipeline/ipu3/imgu.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/imgu.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * imgu.h - Intel IPU3 ImgU
+ * Intel IPU3 ImgU
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/libcamera/pipeline/ipu3/ipu3.cpp 0.3.0-1/src/libcamera/pipeline/ipu3/ipu3.cpp
--- 0.2.0-3/src/libcamera/pipeline/ipu3/ipu3.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/ipu3/ipu3.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipu3.cpp - Pipeline handler for Intel IPU3
+ * Pipeline handler for Intel IPU3
  */
 
 #include <algorithm>
@@ -1420,6 +1420,6 @@ void IPU3CameraData::frameStart(uint32_t
 				*testPatternMode);
 }
 
-REGISTER_PIPELINE_HANDLER(PipelineHandlerIPU3)
+REGISTER_PIPELINE_HANDLER(PipelineHandlerIPU3, "ipu3")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/mali-c55/mali-c55.cpp 0.3.0-1/src/libcamera/pipeline/mali-c55/mali-c55.cpp
--- 0.2.0-3/src/libcamera/pipeline/mali-c55/mali-c55.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/mali-c55/mali-c55.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,1066 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2024, Ideas on Board Oy
+ *
+ * Pipeline Handler for ARM's Mali-C55 ISP
+ */
+
+#include <algorithm>
+#include <array>
+#include <map>
+#include <memory>
+#include <set>
+#include <string>
+
+#include <linux/media-bus-format.h>
+#include <linux/media.h>
+
+#include <libcamera/base/log.h>
+
+#include <libcamera/camera.h>
+#include <libcamera/formats.h>
+#include <libcamera/geometry.h>
+#include <libcamera/stream.h>
+
+#include "libcamera/internal/bayer_format.h"
+#include "libcamera/internal/camera.h"
+#include "libcamera/internal/camera_sensor.h"
+#include "libcamera/internal/device_enumerator.h"
+#include "libcamera/internal/media_device.h"
+#include "libcamera/internal/pipeline_handler.h"
+#include "libcamera/internal/v4l2_subdevice.h"
+#include "libcamera/internal/v4l2_videodevice.h"
+
+namespace {
+
+bool isFormatRaw(const libcamera::PixelFormat &pixFmt)
+{
+	return libcamera::PixelFormatInfo::info(pixFmt).colourEncoding ==
+	       libcamera::PixelFormatInfo::ColourEncodingRAW;
+}
+
+} /* namespace */
+
+namespace libcamera {
+
+LOG_DEFINE_CATEGORY(MaliC55)
+
+const std::map<libcamera::PixelFormat, unsigned int> maliC55FmtToCode = {
+	/* \todo Support all formats supported by the driver in libcamera. */
+
+	{ formats::RGB565, MEDIA_BUS_FMT_RGB121212_1X36 },
+	{ formats::RGB888, MEDIA_BUS_FMT_RGB121212_1X36 },
+	{ formats::YUYV, MEDIA_BUS_FMT_YUV10_1X30 },
+	{ formats::UYVY, MEDIA_BUS_FMT_YUV10_1X30 },
+	{ formats::R8, MEDIA_BUS_FMT_YUV10_1X30 },
+	{ formats::NV12, MEDIA_BUS_FMT_YUV10_1X30 },
+	{ formats::NV21, MEDIA_BUS_FMT_YUV10_1X30 },
+
+	/* RAW formats, FR pipe only. */
+	{ formats::SGBRG8, MEDIA_BUS_FMT_SGBRG8_1X8 },
+	{ formats::SRGGB8, MEDIA_BUS_FMT_SRGGB8_1X8 },
+	{ formats::SBGGR8, MEDIA_BUS_FMT_SBGGR8_1X8 },
+	{ formats::SGRBG8, MEDIA_BUS_FMT_SGRBG8_1X8 },
+	{ formats::SGBRG10, MEDIA_BUS_FMT_SGBRG10_1X10 },
+	{ formats::SRGGB10, MEDIA_BUS_FMT_SRGGB10_1X10 },
+	{ formats::SBGGR10, MEDIA_BUS_FMT_SBGGR10_1X10 },
+	{ formats::SGRBG10, MEDIA_BUS_FMT_SGRBG10_1X10 },
+	{ formats::SGBRG12, MEDIA_BUS_FMT_SGBRG12_1X12 },
+	{ formats::SRGGB12, MEDIA_BUS_FMT_SRGGB12_1X12 },
+	{ formats::SBGGR12, MEDIA_BUS_FMT_SBGGR12_1X12 },
+	{ formats::SGRBG12, MEDIA_BUS_FMT_SGRBG12_1X12 },
+	{ formats::SGBRG14, MEDIA_BUS_FMT_SGBRG14_1X14 },
+	{ formats::SRGGB14, MEDIA_BUS_FMT_SRGGB14_1X14 },
+	{ formats::SBGGR14, MEDIA_BUS_FMT_SBGGR14_1X14 },
+	{ formats::SGRBG14, MEDIA_BUS_FMT_SGRBG14_1X14 },
+	{ formats::SGBRG16, MEDIA_BUS_FMT_SGBRG16_1X16 },
+	{ formats::SRGGB16, MEDIA_BUS_FMT_SRGGB16_1X16 },
+	{ formats::SBGGR16, MEDIA_BUS_FMT_SBGGR16_1X16 },
+	{ formats::SGRBG16, MEDIA_BUS_FMT_SGRBG16_1X16 },
+};
+
+constexpr Size kMaliC55MinSize = { 128, 128 };
+constexpr Size kMaliC55MaxSize = { 8192, 8192 };
+constexpr unsigned int kMaliC55ISPInternalFormat = MEDIA_BUS_FMT_RGB121212_1X36;
+
+class MaliC55CameraData : public Camera::Private
+{
+public:
+	MaliC55CameraData(PipelineHandler *pipe, MediaEntity *entity)
+		: Camera::Private(pipe), entity_(entity)
+	{
+	}
+
+	int init();
+
+	/* Deflect these functionalities to either TPG or CameraSensor. */
+	const std::vector<unsigned int> mbusCodes() const;
+	const std::vector<Size> sizes(unsigned int mbusCode) const;
+	const Size resolution() const;
+
+	PixelFormat bestRawFormat() const;
+
+	PixelFormat adjustRawFormat(const PixelFormat &pixFmt) const;
+	Size adjustRawSizes(const PixelFormat &pixFmt, const Size &rawSize) const;
+
+	std::unique_ptr<CameraSensor> sensor_;
+
+	MediaEntity *entity_;
+	std::unique_ptr<V4L2Subdevice> csi_;
+	std::unique_ptr<V4L2Subdevice> sd_;
+	Stream frStream_;
+	Stream dsStream_;
+
+private:
+	void initTPGData();
+
+	std::string id_;
+	std::vector<unsigned int> tpgCodes_;
+	std::vector<Size> tpgSizes_;
+	Size tpgResolution_;
+};
+
+int MaliC55CameraData::init()
+{
+	int ret;
+
+	sd_ = std::make_unique<V4L2Subdevice>(entity_);
+	ret = sd_->open();
+	if (ret) {
+		LOG(MaliC55, Error) << "Failed to open sensor subdevice";
+		return ret;
+	}
+
+	/* If this camera is created from TPG, we return here. */
+	if (entity_->name() == "mali-c55 tpg") {
+		initTPGData();
+		return 0;
+	}
+
+	/*
+	 * Register a CameraSensor if we connect to a sensor and create
+	 * an entity for the connected CSI-2 receiver.
+	 */
+	sensor_ = std::make_unique<CameraSensor>(entity_);
+	ret = sensor_->init();
+	if (ret)
+		return ret;
+
+	const MediaPad *sourcePad = entity_->getPadByIndex(0);
+	MediaEntity *csiEntity = sourcePad->links()[0]->sink()->entity();
+
+	csi_ = std::make_unique<V4L2Subdevice>(csiEntity);
+	if (csi_->open()) {
+		LOG(MaliC55, Error) << "Failed to open CSI-2 subdevice";
+		return false;
+	}
+
+	return 0;
+}
+
+void MaliC55CameraData::initTPGData()
+{
+	/* Replicate the CameraSensor implementation for TPG. */
+	V4L2Subdevice::Formats formats = sd_->formats(0);
+	if (formats.empty())
+		return;
+
+	tpgCodes_ = utils::map_keys(formats);
+	std::sort(tpgCodes_.begin(), tpgCodes_.end());
+
+	for (const auto &format : formats) {
+		const std::vector<SizeRange> &ranges = format.second;
+		std::transform(ranges.begin(), ranges.end(), std::back_inserter(tpgSizes_),
+			       [](const SizeRange &range) { return range.max; });
+	}
+
+	tpgResolution_ = tpgSizes_.back();
+}
+
+const std::vector<unsigned int> MaliC55CameraData::mbusCodes() const
+{
+	if (sensor_)
+		return sensor_->mbusCodes();
+
+	return tpgCodes_;
+}
+
+const std::vector<Size> MaliC55CameraData::sizes(unsigned int mbusCode) const
+{
+	if (sensor_)
+		return sensor_->sizes(mbusCode);
+
+	V4L2Subdevice::Formats formats = sd_->formats(0);
+	if (formats.empty())
+		return {};
+
+	std::vector<Size> sizes;
+	const auto &format = formats.find(mbusCode);
+	if (format == formats.end())
+		return {};
+
+	const std::vector<SizeRange> &ranges = format->second;
+	std::transform(ranges.begin(), ranges.end(), std::back_inserter(sizes),
+		       [](const SizeRange &range) { return range.max; });
+
+	std::sort(sizes.begin(), sizes.end());
+
+	return sizes;
+}
+
+const Size MaliC55CameraData::resolution() const
+{
+	if (sensor_)
+		return sensor_->resolution();
+
+	return tpgResolution_;
+}
+
+PixelFormat MaliC55CameraData::bestRawFormat() const
+{
+	unsigned int bitDepth = 0;
+	PixelFormat rawFormat;
+
+	/*
+	 * Iterate over all the supported PixelFormat and find the one
+	 * supported by the camera with the largest bitdepth.
+	 */
+	for (const auto &maliFormat : maliC55FmtToCode) {
+		PixelFormat pixFmt = maliFormat.first;
+		if (!isFormatRaw(pixFmt))
+			continue;
+
+		unsigned int rawCode = maliFormat.second;
+		const auto rawSizes = sizes(rawCode);
+		if (rawSizes.empty())
+			continue;
+
+		BayerFormat bayer = BayerFormat::fromMbusCode(rawCode);
+		if (bayer.bitDepth > bitDepth) {
+			bitDepth = bayer.bitDepth;
+			rawFormat = pixFmt;
+		}
+	}
+
+	return rawFormat;
+}
+
+/*
+ * Make sure the provided raw pixel format is supported and adjust it to
+ * one of the supported ones if it's not.
+ */
+PixelFormat MaliC55CameraData::adjustRawFormat(const PixelFormat &rawFmt) const
+{
+	/* Make sure the provided raw format is supported by the pipeline. */
+	auto it = maliC55FmtToCode.find(rawFmt);
+	if (it == maliC55FmtToCode.end())
+		return bestRawFormat();
+
+	/* Now make sure the RAW mbus code is supported by the image source. */
+	unsigned int rawCode = it->second;
+	const auto rawSizes = sizes(rawCode);
+	if (rawSizes.empty())
+		return bestRawFormat();
+
+	return rawFmt;
+}
+
+Size MaliC55CameraData::adjustRawSizes(const PixelFormat &rawFmt, const Size &rawSize) const
+{
+	/* Just make sure the format is supported. */
+	auto it = maliC55FmtToCode.find(rawFmt);
+	if (it == maliC55FmtToCode.end())
+		return {};
+
+	/* Check if the size is natively supported. */
+	unsigned int rawCode = it->second;
+	const auto rawSizes = sizes(rawCode);
+	auto sizeIt = std::find(rawSizes.begin(), rawSizes.end(), rawSize);
+	if (sizeIt != rawSizes.end())
+		return rawSize;
+
+	/* Or adjust it to the closest supported size. */
+	uint16_t distance = std::numeric_limits<uint16_t>::max();
+	Size bestSize;
+	for (const Size &size : rawSizes) {
+		uint16_t dist = std::abs(static_cast<int>(rawSize.width) -
+					 static_cast<int>(size.width)) +
+				std::abs(static_cast<int>(rawSize.height) -
+					 static_cast<int>(size.height));
+		if (dist < distance) {
+			dist = distance;
+			bestSize = size;
+		}
+	}
+
+	return bestSize;
+}
+
+class MaliC55CameraConfiguration : public CameraConfiguration
+{
+public:
+	MaliC55CameraConfiguration(MaliC55CameraData *data)
+		: CameraConfiguration(), data_(data)
+	{
+	}
+
+	Status validate() override;
+
+	V4L2SubdeviceFormat sensorFormat_;
+
+private:
+	static constexpr unsigned int kMaxStreams = 2;
+
+	const MaliC55CameraData *data_;
+};
+
+CameraConfiguration::Status MaliC55CameraConfiguration::validate()
+{
+	Status status = Valid;
+
+	if (config_.empty())
+		return Invalid;
+
+	/* Only 2 streams available. */
+	if (config_.size() > kMaxStreams) {
+		config_.resize(kMaxStreams);
+		status = Adjusted;
+	}
+
+	bool frPipeAvailable = true;
+	StreamConfiguration *rawConfig = nullptr;
+	for (StreamConfiguration &config : config_) {
+		if (!isFormatRaw(config.pixelFormat))
+			continue;
+
+		if (rawConfig) {
+			LOG(MaliC55, Error)
+				<< "Only a single RAW stream is supported";
+			return Invalid;
+		}
+
+		rawConfig = &config;
+	}
+
+	Size maxSize = kMaliC55MaxSize;
+	if (rawConfig) {
+		/*
+		 * \todo Take into account the Bayer components ordering once
+		 * we support rotations.
+		 */
+		PixelFormat rawFormat =
+			data_->adjustRawFormat(rawConfig->pixelFormat);
+		if (rawFormat != rawConfig->pixelFormat) {
+			LOG(MaliC55, Debug)
+				<< "RAW format adjusted to " << rawFormat;
+			rawConfig->pixelFormat = rawFormat;
+			status = Adjusted;
+		}
+
+		Size rawSize =
+			data_->adjustRawSizes(rawFormat, rawConfig->size);
+		if (rawSize != rawConfig->size) {
+			LOG(MaliC55, Debug)
+				<< "RAW sizes adjusted to " << rawSize;
+			rawConfig->size = rawSize;
+			status = Adjusted;
+		}
+
+		maxSize = rawSize;
+
+		rawConfig->setStream(const_cast<Stream *>(&data_->frStream_));
+		frPipeAvailable = false;
+	}
+
+	/* Adjust processed streams. */
+	Size maxYuvSize;
+	for (StreamConfiguration &config : config_) {
+		if (isFormatRaw(config.pixelFormat))
+			continue;
+
+		/* Adjust format and size for processed streams. */
+		const auto it = maliC55FmtToCode.find(config.pixelFormat);
+		if (it == maliC55FmtToCode.end()) {
+			LOG(MaliC55, Debug)
+				<< "Format adjusted to " << formats::RGB565;
+			config.pixelFormat = formats::RGB565;
+			status = Adjusted;
+		}
+
+		Size size = std::clamp(config.size, kMaliC55MinSize, maxSize);
+		if (size != config.size) {
+			LOG(MaliC55, Debug)
+				<< "Size adjusted to " << size;
+			config.size = size;
+			status = Adjusted;
+		}
+
+		if (maxYuvSize < size)
+			maxYuvSize = size;
+
+		if (frPipeAvailable) {
+			config.setStream(const_cast<Stream *>(&data_->frStream_));
+			frPipeAvailable = false;
+		} else {
+			config.setStream(const_cast<Stream *>(&data_->dsStream_));
+		}
+	}
+
+	/* Compute the sensor format. */
+
+	/* If there's a RAW config, sensor configuration follows it. */
+	if (rawConfig) {
+		const auto it = maliC55FmtToCode.find(rawConfig->pixelFormat);
+		sensorFormat_.code = it->second;
+		sensorFormat_.size = rawConfig->size;
+
+		return status;
+	}
+
+	/* If there's no RAW config, compute the sensor configuration here. */
+	PixelFormat rawFormat = data_->bestRawFormat();
+	const auto it = maliC55FmtToCode.find(rawFormat);
+	sensorFormat_.code = it->second;
+
+	uint16_t distance = std::numeric_limits<uint16_t>::max();
+	const auto sizes = data_->sizes(it->second);
+	Size bestSize;
+	for (const auto &size : sizes) {
+		/* Skip sensor sizes that are smaller than the max YUV size. */
+		if (maxYuvSize.width > size.width ||
+		    maxYuvSize.height > size.height)
+			continue;
+
+		uint16_t dist = std::abs(static_cast<int>(maxYuvSize.width) -
+					 static_cast<int>(size.width)) +
+				std::abs(static_cast<int>(maxYuvSize.height) -
+					 static_cast<int>(size.height));
+		if (dist < distance) {
+			dist = distance;
+			bestSize = size;
+		}
+	}
+	sensorFormat_.size = bestSize;
+
+	LOG(MaliC55, Debug) << "Computed sensor configuration " << sensorFormat_;
+
+	return status;
+}
+
+class PipelineHandlerMaliC55 : public PipelineHandler
+{
+public:
+	PipelineHandlerMaliC55(CameraManager *manager);
+
+	std::unique_ptr<CameraConfiguration> generateConfiguration(Camera *camera,
+								   Span<const StreamRole> roles) override;
+	int configure(Camera *camera, CameraConfiguration *config) override;
+
+	int exportFrameBuffers(Camera *camera, Stream *stream,
+			       std::vector<std::unique_ptr<FrameBuffer>> *buffers) override;
+
+	int start(Camera *camera, const ControlList *controls) override;
+	void stopDevice(Camera *camera) override;
+
+	int queueRequestDevice(Camera *camera, Request *request) override;
+
+	void bufferReady(FrameBuffer *buffer);
+
+	bool match(DeviceEnumerator *enumerator) override;
+
+private:
+	struct MaliC55Pipe {
+		std::unique_ptr<V4L2Subdevice> resizer;
+		std::unique_ptr<V4L2VideoDevice> cap;
+		Stream *stream;
+	};
+
+	enum {
+		MaliC55FR,
+		MaliC55DS,
+		MaliC55NumPipes,
+	};
+
+	MaliC55CameraData *cameraData(Camera *camera)
+	{
+		return static_cast<MaliC55CameraData *>(camera->_d());
+	}
+
+	MaliC55Pipe *pipeFromStream(MaliC55CameraData *data, Stream *stream)
+	{
+		if (stream == &data->frStream_)
+			return &pipes_[MaliC55FR];
+		else if (stream == &data->dsStream_)
+			return &pipes_[MaliC55DS];
+		else
+			LOG(MaliC55, Fatal) << "Stream " << stream << " not valid";
+		return nullptr;
+	}
+
+	MaliC55Pipe *pipeFromStream(MaliC55CameraData *data, const Stream *stream)
+	{
+		return pipeFromStream(data, const_cast<Stream *>(stream));
+	}
+
+	void resetPipes()
+	{
+		for (MaliC55Pipe &pipe : pipes_)
+			pipe.stream = nullptr;
+	}
+
+	int configureRawStream(MaliC55CameraData *data,
+			       const StreamConfiguration &config,
+			       V4L2SubdeviceFormat &subdevFormat);
+	int configureProcessedStream(MaliC55CameraData *data,
+				     const StreamConfiguration &config,
+				     V4L2SubdeviceFormat &subdevFormat);
+
+	void registerMaliCamera(std::unique_ptr<MaliC55CameraData> data,
+				const std::string &name);
+	bool registerTPGCamera(MediaLink *link);
+	bool registerSensorCamera(MediaLink *link);
+
+	MediaDevice *media_;
+	std::unique_ptr<V4L2Subdevice> isp_;
+
+	std::array<MaliC55Pipe, MaliC55NumPipes> pipes_;
+
+	bool dsFitted_;
+};
+
+PipelineHandlerMaliC55::PipelineHandlerMaliC55(CameraManager *manager)
+	: PipelineHandler(manager), dsFitted_(true)
+{
+}
+
+std::unique_ptr<CameraConfiguration>
+PipelineHandlerMaliC55::generateConfiguration(Camera *camera,
+					      Span<const StreamRole> roles)
+{
+	MaliC55CameraData *data = cameraData(camera);
+	std::unique_ptr<CameraConfiguration> config =
+		std::make_unique<MaliC55CameraConfiguration>(data);
+	bool frPipeAvailable = true;
+
+	if (roles.empty())
+		return config;
+
+	/* Check if one stream is RAW to reserve the FR pipe for it. */
+	if (std::find(roles.begin(), roles.end(), StreamRole::Raw) != roles.end())
+		frPipeAvailable = false;
+
+	for (const StreamRole &role : roles) {
+		struct MaliC55Pipe *pipe;
+
+		/* Assign pipe for this role. */
+		if (role == StreamRole::Raw) {
+			pipe = &pipes_[MaliC55FR];
+		} else {
+			if (frPipeAvailable) {
+				pipe = &pipes_[MaliC55FR];
+				frPipeAvailable = false;
+			} else {
+				pipe = &pipes_[MaliC55DS];
+			}
+		}
+
+		Size size = std::min(Size{ 1920, 1080 }, data->resolution());
+		PixelFormat pixelFormat;
+
+		switch (role) {
+		case StreamRole::StillCapture:
+			size = data->resolution();
+			[[fallthrough]];
+		case StreamRole::VideoRecording:
+			pixelFormat = formats::NV12;
+			break;
+
+		case StreamRole::Viewfinder:
+			pixelFormat = formats::RGB565;
+			break;
+
+		case StreamRole::Raw:
+			pixelFormat = data->bestRawFormat();
+			if (!pixelFormat.isValid()) {
+				LOG(MaliC55, Error)
+					<< "Camera does not support RAW formats";
+				return nullptr;
+			}
+
+			size = data->resolution();
+			break;
+
+		default:
+			LOG(MaliC55, Error)
+				<< "Requested stream role not supported: " << role;
+			return nullptr;
+		}
+
+		std::map<PixelFormat, std::vector<SizeRange>> formats;
+		for (const auto &maliFormat : maliC55FmtToCode) {
+			PixelFormat pixFmt = maliFormat.first;
+			bool isRaw = isFormatRaw(pixFmt);
+
+			/* RAW formats are only supported on the FR pipe. */
+			if (pipe != &pipes_[MaliC55FR] && isRaw)
+				continue;
+
+			if (isRaw) {
+				/* Make sure the mbus code is supported. */
+				unsigned int rawCode = maliFormat.second;
+				const auto sizes = data->sizes(rawCode);
+				if (sizes.empty())
+					continue;
+
+				/* And list all sizes the sensor can produce. */
+				std::vector<SizeRange> sizeRanges;
+				std::transform(sizes.begin(), sizes.end(),
+					       std::back_inserter(sizeRanges),
+					       [](const Size &s) {
+						       return SizeRange(s);
+					       });
+
+				formats[pixFmt] = sizeRanges;
+			} else {
+				/* Processed formats are always available. */
+				Size maxSize = std::min(kMaliC55MaxSize,
+							data->resolution());
+				formats[pixFmt] = { kMaliC55MinSize, maxSize };
+			}
+		}
+
+		StreamFormats streamFormats(formats);
+		StreamConfiguration cfg(streamFormats);
+		cfg.pixelFormat = pixelFormat;
+		cfg.bufferCount = 4;
+		cfg.size = size;
+
+		config->addConfiguration(cfg);
+	}
+
+	if (config->validate() == CameraConfiguration::Invalid)
+		return nullptr;
+
+	return config;
+}
+
+int PipelineHandlerMaliC55::configureRawStream(MaliC55CameraData *data,
+					       const StreamConfiguration &config,
+					       V4L2SubdeviceFormat &subdevFormat)
+{
+	Stream *stream = config.stream();
+	MaliC55Pipe *pipe = pipeFromStream(data, stream);
+
+	if (pipe != &pipes_[MaliC55FR]) {
+		LOG(MaliC55, Fatal) << "Only the FR pipe supports RAW capture.";
+		return -EINVAL;
+	}
+
+	/* Enable the debayer route to set fixed internal format on pad #0. */
+	V4L2Subdevice::Routing routing = {};
+	routing.emplace_back(V4L2Subdevice::Stream{ 0, 0 },
+			     V4L2Subdevice::Stream{ 1, 0 },
+			     V4L2_SUBDEV_ROUTE_FL_ACTIVE);
+
+	int ret = pipe->resizer->setRouting(&routing, V4L2Subdevice::ActiveFormat);
+	if (ret)
+		return ret;
+
+	unsigned int rawCode = subdevFormat.code;
+	subdevFormat.code = kMaliC55ISPInternalFormat;
+	ret = pipe->resizer->setFormat(0, &subdevFormat);
+	if (ret)
+		return ret;
+
+	/* Enable the bypass route and apply RAW formats there. */
+	routing.clear();
+	routing.emplace_back(V4L2Subdevice::Stream{ 2, 0 },
+			     V4L2Subdevice::Stream{ 1, 0 },
+			     V4L2_SUBDEV_ROUTE_FL_ACTIVE);
+	ret = pipe->resizer->setRouting(&routing, V4L2Subdevice::ActiveFormat);
+	if (ret)
+		return ret;
+
+	subdevFormat.code = rawCode;
+	ret = pipe->resizer->setFormat(2, &subdevFormat);
+	if (ret)
+		return ret;
+
+	ret = pipe->resizer->setFormat(1, &subdevFormat);
+	if (ret)
+		return ret;
+
+	return 0;
+}
+
+int PipelineHandlerMaliC55::configureProcessedStream(MaliC55CameraData *data,
+						     const StreamConfiguration &config,
+						     V4L2SubdeviceFormat &subdevFormat)
+{
+	Stream *stream = config.stream();
+	MaliC55Pipe *pipe = pipeFromStream(data, stream);
+
+	/* Enable the debayer route on the resizer pipe. */
+	V4L2Subdevice::Routing routing = {};
+	routing.emplace_back(V4L2Subdevice::Stream{ 0, 0 },
+			     V4L2Subdevice::Stream{ 1, 0 },
+			     V4L2_SUBDEV_ROUTE_FL_ACTIVE);
+
+	int ret = pipe->resizer->setRouting(&routing, V4L2Subdevice::ActiveFormat);
+	if (ret)
+		return ret;
+
+	subdevFormat.code = kMaliC55ISPInternalFormat;
+	ret = pipe->resizer->setFormat(0, &subdevFormat);
+	if (ret)
+		return ret;
+
+	/* \todo Configure the resizer crop/compose rectangles. */
+	Rectangle ispCrop = { 0, 0, config.size };
+	ret = pipe->resizer->setSelection(0, V4L2_SEL_TGT_CROP, &ispCrop);
+	if (ret)
+		return ret;
+
+	ret = pipe->resizer->setSelection(0, V4L2_SEL_TGT_COMPOSE, &ispCrop);
+	if (ret)
+		return ret;
+
+	subdevFormat.code = maliC55FmtToCode.find(config.pixelFormat)->second;
+	return pipe->resizer->setFormat(1, &subdevFormat);
+}
+
+int PipelineHandlerMaliC55::configure(Camera *camera,
+				      CameraConfiguration *config)
+{
+	resetPipes();
+
+	int ret = media_->disableLinks();
+	if (ret)
+		return ret;
+
+	/* Link the graph depending if we are operating the TPG or a sensor. */
+	MaliC55CameraData *data = cameraData(camera);
+	if (data->csi_) {
+		const MediaEntity *csiEntity = data->csi_->entity();
+		ret = csiEntity->getPadByIndex(1)->links()[0]->setEnabled(true);
+	} else {
+		ret = data->entity_->getPadByIndex(0)->links()[0]->setEnabled(true);
+	}
+	if (ret)
+		return ret;
+
+	MaliC55CameraConfiguration *maliConfig =
+		static_cast<MaliC55CameraConfiguration *>(config);
+	V4L2SubdeviceFormat subdevFormat = maliConfig->sensorFormat_;
+	ret = data->sd_->getFormat(0, &subdevFormat);
+	if (ret)
+		return ret;
+
+	if (data->csi_) {
+		ret = data->csi_->setFormat(0, &subdevFormat);
+		if (ret)
+			return ret;
+
+		ret = data->csi_->setFormat(1, &subdevFormat);
+		if (ret)
+			return ret;
+	}
+
+	/*
+	 * Propagate the format to the ISP sink pad and configure the input
+	 * crop rectangle (no crop at the moment).
+	 *
+	 * \todo Configure the CSI-2 receiver.
+	 */
+	ret = isp_->setFormat(0, &subdevFormat);
+	if (ret)
+		return ret;
+
+	Rectangle ispCrop(0, 0, subdevFormat.size);
+	ret = isp_->setSelection(0, V4L2_SEL_TGT_CROP, &ispCrop);
+	if (ret)
+		return ret;
+
+	/*
+	 * Configure the resizer: fixed format the sink pad; use the media
+	 * bus code associated with the desired capture format on the source
+	 * pad.
+	 *
+	 * Configure the crop and compose rectangles to match the desired
+	 * stream output size
+	 *
+	 * \todo Make the crop/scaler configurable
+	 */
+	for (const StreamConfiguration &streamConfig : *config) {
+		Stream *stream = streamConfig.stream();
+		MaliC55Pipe *pipe = pipeFromStream(data, stream);
+
+		if (isFormatRaw(streamConfig.pixelFormat))
+			ret = configureRawStream(data, streamConfig, subdevFormat);
+		else
+			ret = configureProcessedStream(data, streamConfig, subdevFormat);
+		if (ret) {
+			LOG(MaliC55, Error) << "Failed to configure pipeline";
+			return ret;
+		}
+
+		/* Now apply the pixel format and size to the capture device. */
+		V4L2DeviceFormat captureFormat;
+		captureFormat.fourcc = pipe->cap->toV4L2PixelFormat(streamConfig.pixelFormat);
+		captureFormat.size = streamConfig.size;
+
+		ret = pipe->cap->setFormat(&captureFormat);
+		if (ret)
+			return ret;
+
+		pipe->stream = stream;
+	}
+
+	return 0;
+}
+
+int PipelineHandlerMaliC55::exportFrameBuffers(Camera *camera, Stream *stream,
+					       std::vector<std::unique_ptr<FrameBuffer>> *buffers)
+{
+	MaliC55Pipe *pipe = pipeFromStream(cameraData(camera), stream);
+	unsigned int count = stream->configuration().bufferCount;
+
+	return pipe->cap->exportBuffers(count, buffers);
+}
+
+int PipelineHandlerMaliC55::start([[maybe_unused]] Camera *camera, [[maybe_unused]] const ControlList *controls)
+{
+	for (MaliC55Pipe &pipe : pipes_) {
+		if (!pipe.stream)
+			continue;
+
+		Stream *stream = pipe.stream;
+
+		int ret = pipe.cap->importBuffers(stream->configuration().bufferCount);
+		if (ret) {
+			LOG(MaliC55, Error) << "Failed to import buffers";
+			return ret;
+		}
+
+		ret = pipe.cap->streamOn();
+		if (ret) {
+			LOG(MaliC55, Error) << "Failed to start stream";
+			return ret;
+		}
+	}
+
+	return 0;
+}
+
+void PipelineHandlerMaliC55::stopDevice([[maybe_unused]] Camera *camera)
+{
+	for (MaliC55Pipe &pipe : pipes_) {
+		if (!pipe.stream)
+			continue;
+
+		pipe.cap->streamOff();
+		pipe.cap->releaseBuffers();
+	}
+}
+
+int PipelineHandlerMaliC55::queueRequestDevice(Camera *camera, Request *request)
+{
+	int ret;
+
+	for (auto &[stream, buffer] : request->buffers()) {
+		MaliC55Pipe *pipe = pipeFromStream(cameraData(camera), stream);
+
+		ret = pipe->cap->queueBuffer(buffer);
+		if (ret)
+			return ret;
+	}
+
+	return 0;
+}
+
+void PipelineHandlerMaliC55::bufferReady(FrameBuffer *buffer)
+{
+	Request *request = buffer->request();
+
+	completeBuffer(request, buffer);
+
+	if (request->hasPendingBuffers())
+		return;
+
+	completeRequest(request);
+}
+
+void PipelineHandlerMaliC55::registerMaliCamera(std::unique_ptr<MaliC55CameraData> data,
+						const std::string &name)
+{
+	std::set<Stream *> streams{ &data->frStream_ };
+	if (dsFitted_)
+		streams.insert(&data->dsStream_);
+
+	std::shared_ptr<Camera> camera = Camera::create(std::move(data),
+							name, streams);
+	registerCamera(std::move(camera));
+}
+
+/*
+ * The only camera we support through direct connection to the ISP is the
+ * Mali-C55 TPG. Check we have that and warn if not.
+ */
+bool PipelineHandlerMaliC55::registerTPGCamera(MediaLink *link)
+{
+	const std::string &name = link->source()->entity()->name();
+	if (name != "mali-c55 tpg") {
+		LOG(MaliC55, Warning) << "Unsupported direct connection to "
+				      << link->source()->entity()->name();
+		/*
+		 * Return true and just skip registering a camera for this
+		 * entity.
+		 */
+		return true;
+	}
+
+	std::unique_ptr<MaliC55CameraData> data =
+		std::make_unique<MaliC55CameraData>(this, link->source()->entity());
+
+	if (data->init())
+		return false;
+
+	registerMaliCamera(std::move(data), name);
+
+	return true;
+}
+
+/*
+ * Register a Camera for each sensor connected to the ISP through a CSI-2
+ * receiver.
+ *
+ * \todo Support more complex topologies, such as video muxes.
+ */
+bool PipelineHandlerMaliC55::registerSensorCamera(MediaLink *ispLink)
+{
+	MediaEntity *csi2 = ispLink->source()->entity();
+	const MediaPad *csi2Sink = csi2->getPadByIndex(0);
+
+	for (MediaLink *link : csi2Sink->links()) {
+		MediaEntity *sensor = link->source()->entity();
+		unsigned int function = sensor->function();
+
+		if (function != MEDIA_ENT_F_CAM_SENSOR)
+			continue;
+
+		std::unique_ptr<MaliC55CameraData> data =
+			std::make_unique<MaliC55CameraData>(this, sensor);
+		if (data->init())
+			return false;
+
+		/* \todo: Init properties and controls. */
+
+		registerMaliCamera(std::move(data), sensor->name());
+	}
+
+	return true;
+}
+
+bool PipelineHandlerMaliC55::match(DeviceEnumerator *enumerator)
+{
+	const MediaPad *ispSink;
+
+	/*
+	 * We search for just the ISP subdevice and the full resolution pipe.
+	 * The TPG and the downscale pipe are both optional blocks and may not
+	 * be fitted.
+	 */
+	DeviceMatch dm("mali-c55");
+	dm.add("mali-c55 isp");
+	dm.add("mali-c55 resizer fr");
+	dm.add("mali-c55 fr");
+
+	media_ = acquireMediaDevice(enumerator, dm);
+	if (!media_)
+		return false;
+
+	isp_ = V4L2Subdevice::fromEntityName(media_, "mali-c55 isp");
+	if (isp_->open() < 0)
+		return false;
+
+	MaliC55Pipe *frPipe = &pipes_[MaliC55FR];
+	frPipe->resizer = V4L2Subdevice::fromEntityName(media_, "mali-c55 resizer fr");
+	if (frPipe->resizer->open() < 0)
+		return false;
+
+	frPipe->cap = V4L2VideoDevice::fromEntityName(media_, "mali-c55 fr");
+	if (frPipe->cap->open() < 0)
+		return false;
+
+	frPipe->cap->bufferReady.connect(this, &PipelineHandlerMaliC55::bufferReady);
+
+	dsFitted_ = !!media_->getEntityByName("mali-c55 ds");
+	if (dsFitted_) {
+		LOG(MaliC55, Debug) << "Downscaler pipe is fitted";
+
+		MaliC55Pipe *dsPipe = &pipes_[MaliC55DS];
+
+		dsPipe->resizer = V4L2Subdevice::fromEntityName(media_, "mali-c55 resizer ds");
+		if (dsPipe->resizer->open() < 0)
+			return false;
+
+		dsPipe->cap = V4L2VideoDevice::fromEntityName(media_, "mali-c55 ds");
+		if (dsPipe->cap->open() < 0)
+			return false;
+
+		dsPipe->cap->bufferReady.connect(this, &PipelineHandlerMaliC55::bufferReady);
+	}
+
+	ispSink = isp_->entity()->getPadByIndex(0);
+	if (!ispSink || ispSink->links().empty()) {
+		LOG(MaliC55, Error) << "ISP sink pad error";
+		return false;
+	}
+
+	/*
+	 * We could have several links pointing to the ISP's sink pad, which
+	 * will be from entities with one of the following functions:
+	 *
+	 * MEDIA_ENT_F_CAM_SENSOR - The test pattern generator
+	 * MEDIA_ENT_F_VID_IF_BRIDGE - A CSI-2 receiver
+	 * MEDIA_ENT_F_IO_V4L - An input device
+	 *
+	 * The last one will be unsupported for now. The TPG is relatively easy,
+	 * we just register a Camera for it. If we have a CSI-2 receiver we need
+	 * to check its sink pad and register Cameras for anything connected to
+	 * it (probably...there are some complex situations in which that might
+	 * not be true but let's pretend they don't exist until we come across
+	 * them)
+	 */
+	bool registered;
+	for (MediaLink *link : ispSink->links()) {
+		unsigned int function = link->source()->entity()->function();
+
+		switch (function) {
+		case MEDIA_ENT_F_CAM_SENSOR:
+			registered = registerTPGCamera(link);
+			if (!registered)
+				return registered;
+
+			break;
+		case MEDIA_ENT_F_VID_IF_BRIDGE:
+			registered = registerSensorCamera(link);
+			if (!registered)
+				return registered;
+
+			break;
+		case MEDIA_ENT_F_IO_V4L:
+			LOG(MaliC55, Warning) << "Memory input not yet supported";
+			break;
+		default:
+			LOG(MaliC55, Error) << "Unsupported entity function";
+			return false;
+		}
+	}
+
+	return true;
+}
+
+REGISTER_PIPELINE_HANDLER(PipelineHandlerMaliC55, "mali-c55")
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/mali-c55/meson.build 0.3.0-1/src/libcamera/pipeline/mali-c55/meson.build
--- 0.2.0-3/src/libcamera/pipeline/mali-c55/meson.build	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/mali-c55/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,5 @@
+# SPDX-License-Identifier: CC0-1.0
+
+libcamera_sources += files([
+    'mali-c55.cpp'
+])
diff -pruN 0.2.0-3/src/libcamera/pipeline/rkisp1/rkisp1.cpp 0.3.0-1/src/libcamera/pipeline/rkisp1/rkisp1.cpp
--- 0.2.0-3/src/libcamera/pipeline/rkisp1/rkisp1.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rkisp1/rkisp1.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * rkisp1.cpp - Pipeline handler for Rockchip ISP1
+ * Pipeline handler for Rockchip ISP1
  */
 
 #include <algorithm>
@@ -761,7 +761,7 @@ int PipelineHandlerRkISP1::configure(Cam
 
 	/* YUYV8_2X8 is required on the ISP source path pad for YUV output. */
 	if (!isRaw_)
-		format.mbus_code = MEDIA_BUS_FMT_YUYV8_2X8;
+		format.code = MEDIA_BUS_FMT_YUYV8_2X8;
 
 	LOG(RkISP1, Debug)
 		<< "Configuring ISP output pad with " << format
@@ -1322,6 +1322,6 @@ void PipelineHandlerRkISP1::statReady(Fr
 				       data->delayedCtrls_->get(buffer->metadata().sequence));
 }
 
-REGISTER_PIPELINE_HANDLER(PipelineHandlerRkISP1)
+REGISTER_PIPELINE_HANDLER(PipelineHandlerRkISP1, "rkisp1")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rkisp1/rkisp1_path.cpp 0.3.0-1/src/libcamera/pipeline/rkisp1/rkisp1_path.cpp
--- 0.2.0-3/src/libcamera/pipeline/rkisp1/rkisp1_path.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rkisp1/rkisp1_path.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * rkisp1path.cpp - Rockchip ISP1 path helper
+ * Rockchip ISP1 path helper
  */
 
 #include "rkisp1_path.h"
@@ -365,7 +365,7 @@ int RkISP1Path::configure(const StreamCo
 	 * The configuration has been validated, the pixel format is guaranteed
 	 * to be supported and thus found in formatToMediaBus.
 	 */
-	ispFormat.mbus_code = formatToMediaBus.at(config.pixelFormat);
+	ispFormat.code = formatToMediaBus.at(config.pixelFormat);
 
 	ret = resizer_->setFormat(1, &ispFormat);
 	if (ret < 0)
diff -pruN 0.2.0-3/src/libcamera/pipeline/rkisp1/rkisp1_path.h 0.3.0-1/src/libcamera/pipeline/rkisp1/rkisp1_path.h
--- 0.2.0-3/src/libcamera/pipeline/rkisp1/rkisp1_path.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rkisp1/rkisp1_path.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * rkisp1path.h - Rockchip ISP1 path helper
+ * Rockchip ISP1 path helper
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/delayed_controls.cpp 0.3.0-1/src/libcamera/pipeline/rpi/common/delayed_controls.cpp
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/delayed_controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/delayed_controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * delayed_controls.cpp - Helper to deal with controls that take effect with a delay
+ * Helper to deal with controls that take effect with a delay
  *
  * Note: This has been forked from the libcamera core implementation.
  */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/delayed_controls.h 0.3.0-1/src/libcamera/pipeline/rpi/common/delayed_controls.h
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/delayed_controls.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/delayed_controls.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * delayed_controls.h - Helper to deal with controls that take effect with a delay
+ * Helper to deal with controls that take effect with a delay
  *
  * Note: This has been forked from the libcamera core implementation.
  */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/pipeline_base.cpp 0.3.0-1/src/libcamera/pipeline/rpi/common/pipeline_base.cpp
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/pipeline_base.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/pipeline_base.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2023, Raspberry Pi Ltd
  *
- * pipeline_base.cpp - Pipeline handler base class for Raspberry Pi devices
+ * Pipeline handler base class for Raspberry Pi devices
  */
 
 #include "pipeline_base.h"
@@ -37,10 +37,10 @@ namespace {
 
 constexpr unsigned int defaultRawBitDepth = 12;
 
-PixelFormat mbusCodeToPixelFormat(unsigned int mbus_code,
+PixelFormat mbusCodeToPixelFormat(unsigned int code,
 				  BayerFormat::Packing packingReq)
 {
-	BayerFormat bayer = BayerFormat::fromMbusCode(mbus_code);
+	BayerFormat bayer = BayerFormat::fromMbusCode(code);
 
 	ASSERT(bayer.isValid());
 
@@ -221,7 +221,7 @@ CameraConfiguration::Status RPiCameraCon
 	 * without modifications.
 	 */
 	if (sensorConfig) {
-		BayerFormat bayer = BayerFormat::fromMbusCode(sensorFormat_.mbus_code);
+		BayerFormat bayer = BayerFormat::fromMbusCode(sensorFormat_.code);
 
 		if (bayer.bitDepth != sensorConfig->bitDepth ||
 		    sensorFormat_.size != sensorConfig->outputSize) {
@@ -235,24 +235,16 @@ CameraConfiguration::Status RPiCameraCon
 	for (auto &raw : rawStreams_) {
 		StreamConfiguration *rawStream = raw.cfg;
 
-		/* Adjust the RAW stream to match the computed sensor format. */
-		BayerFormat sensorBayer = BayerFormat::fromMbusCode(sensorFormat_.mbus_code);
-
 		/*
-		 * Some sensors change their Bayer order when they are h-flipped
-		 * or v-flipped, according to the transform. If this one does, we
-		 * must advertise the transformed Bayer order in the raw stream.
-		 * Note how we must fetch the "native" (i.e. untransformed) Bayer
-		 * order, because the sensor may currently be flipped!
+		 * Some sensors change their Bayer order when they are
+		 * h-flipped or v-flipped, according to the transform. Adjust
+		 * the RAW stream to match the computed sensor format by
+		 * applying the sensor Bayer order resulting from the transform
+		 * to the user request.
 		 */
-		if (data_->flipsAlterBayerOrder_) {
-			sensorBayer.order = data_->nativeBayerOrder_;
-			sensorBayer = sensorBayer.transform(combinedTransform_);
-		}
 
-		/* Apply the sensor adjusted Bayer order to the user request. */
 		BayerFormat cfgBayer = BayerFormat::fromPixelFormat(rawStream->pixelFormat);
-		cfgBayer.order = sensorBayer.order;
+		cfgBayer.order = data_->sensor_->bayerOrder(combinedTransform_);
 
 		if (rawStream->pixelFormat != cfgBayer.toPixelFormat()) {
 			rawStream->pixelFormat = cfgBayer.toPixelFormat();
@@ -377,8 +369,8 @@ V4L2DeviceFormat PipelineHandlerBase::to
 							 const V4L2SubdeviceFormat &format,
 							 BayerFormat::Packing packingReq)
 {
-	unsigned int mbus_code = format.mbus_code;
-	const PixelFormat pix = mbusCodeToPixelFormat(mbus_code, packingReq);
+	unsigned int code = format.code;
+	const PixelFormat pix = mbusCodeToPixelFormat(code, packingReq);
 	V4L2DeviceFormat deviceFormat;
 
 	deviceFormat.fourcc = dev->toV4L2PixelFormat(pix);
@@ -409,7 +401,7 @@ PipelineHandlerBase::generateConfigurati
 		case StreamRole::Raw:
 			size = sensorSize;
 			sensorFormat = data->findBestFormat(size, defaultRawBitDepth);
-			pixelFormat = mbusCodeToPixelFormat(sensorFormat.mbus_code,
+			pixelFormat = mbusCodeToPixelFormat(sensorFormat.code,
 							    BayerFormat::Packing::CSI2);
 			ASSERT(pixelFormat.isValid());
 			colorSpace = ColorSpace::Raw;
@@ -482,7 +474,11 @@ PipelineHandlerBase::generateConfigurati
 			 */
 			for (const auto &format : fmts) {
 				PixelFormat pf = format.first.toPixelFormat();
-				if (pf.isValid()) {
+				/*
+				 * Some V4L2 formats translate to the same pixel format (e.g. YU12, YM12
+				 * both give YUV420). We must avoid duplicating the range in this case.
+				 */
+				if (pf.isValid() && deviceFormats.find(pf) == deviceFormats.end()) {
 					const SizeRange &ispSizes = format.second[0];
 					deviceFormats[pf].emplace_back(ispSizes.min, sensorSize,
 								       ispSizes.hStep, ispSizes.vStep);
@@ -840,40 +836,6 @@ int PipelineHandlerBase::registerCamera(
 	 */
 	data->properties_.set(properties::ScalerCropMaximum, Rectangle{});
 
-	/*
-	 * We cache two things about the sensor in relation to transforms
-	 * (meaning horizontal and vertical flips): if they affect the Bayer
-	 * ordering, and what the "native" Bayer order is, when no transforms
-	 * are applied.
-	 *
-	 * If flips are supported verify if they affect the Bayer ordering
-	 * and what the "native" Bayer order is, when no transforms are
-	 * applied.
-	 *
-	 * We note that the sensor's cached list of supported formats is
-	 * already in the "native" order, with any flips having been undone.
-	 */
-	const V4L2Subdevice *sensor = data->sensor_->device();
-	const struct v4l2_query_ext_ctrl *hflipCtrl = sensor->controlInfo(V4L2_CID_HFLIP);
-	if (hflipCtrl) {
-		/* We assume it will support vflips too... */
-		data->flipsAlterBayerOrder_ = hflipCtrl->flags & V4L2_CTRL_FLAG_MODIFY_LAYOUT;
-	}
-
-	/* Look for a valid Bayer format. */
-	BayerFormat bayerFormat;
-	for (const auto &iter : data->sensorFormats_) {
-		bayerFormat = BayerFormat::fromMbusCode(iter.first);
-		if (bayerFormat.isValid())
-			break;
-	}
-
-	if (!bayerFormat.isValid()) {
-		LOG(RPI, Error) << "No Bayer format found";
-		return -EINVAL;
-	}
-	data->nativeBayerOrder_ = bayerFormat.order;
-
 	ret = platformRegister(cameraData, frontend, backend);
 	if (ret)
 		return ret;
@@ -990,7 +952,7 @@ V4L2SubdeviceFormat CameraData::findBest
 
 			if (score <= bestScore) {
 				bestScore = score;
-				bestFormat.mbus_code = mbusCode;
+				bestFormat.code = mbusCode;
 				bestFormat.size = size;
 			}
 
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/pipeline_base.h 0.3.0-1/src/libcamera/pipeline/rpi/common/pipeline_base.h
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/pipeline_base.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/pipeline_base.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2023, Raspberry Pi Ltd
  *
- * pipeline_base.h - Pipeline handler base class for Raspberry Pi devices
+ * Pipeline handler base class for Raspberry Pi devices
  */
 
 #include <map>
@@ -48,7 +48,7 @@ class CameraData : public Camera::Privat
 public:
 	CameraData(PipelineHandler *pipe)
 		: Camera::Private(pipe), state_(State::Stopped),
-		  flipsAlterBayerOrder_(false), dropFrameCount_(0), buffersAllocated_(false),
+		  dropFrameCount_(0), buffersAllocated_(false),
 		  ispOutputCount_(0), ispOutputTotal_(0)
 	{
 	}
@@ -131,10 +131,6 @@ public:
 
 	std::queue<Request *> requestQueue_;
 
-	/* Store the "native" Bayer order (that is, with no transforms applied). */
-	bool flipsAlterBayerOrder_;
-	BayerFormat::Order nativeBayerOrder_;
-
 	/* For handling digital zoom. */
 	IPACameraSensorInfo sensorInfo_;
 	Rectangle ispCrop_; /* crop in ISP (camera mode) pixels */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/rpi_stream.cpp 0.3.0-1/src/libcamera/pipeline/rpi/common/rpi_stream.cpp
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/rpi_stream.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/rpi_stream.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * rpi_stream.cpp - Raspberry Pi device stream abstraction class.
+ * Raspberry Pi device stream abstraction class.
  */
 #include "rpi_stream.h"
 
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/rpi_stream.h 0.3.0-1/src/libcamera/pipeline/rpi/common/rpi_stream.h
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/rpi_stream.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/rpi_stream.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * rpi_stream.h - Raspberry Pi device stream abstraction class.
+ * Raspberry Pi device stream abstraction class.
  */
 
 #pragma once
@@ -14,6 +14,7 @@
 #include <vector>
 
 #include <libcamera/base/flags.h>
+#include <libcamera/base/utils.h>
 
 #include <libcamera/stream.h>
 
@@ -180,19 +181,14 @@ private:
 template<typename E, std::size_t N>
 class Device : public std::array<class Stream, N>
 {
-private:
-	constexpr auto index(E e) const noexcept
-	{
-		return static_cast<std::underlying_type_t<E>>(e);
-	}
 public:
 	Stream &operator[](E e)
 	{
-		return std::array<class Stream, N>::operator[](index(e));
+		return std::array<class Stream, N>::operator[](utils::to_underlying(e));
 	}
 	const Stream &operator[](E e) const
 	{
-		return std::array<class Stream, N>::operator[](index(e));
+		return std::array<class Stream, N>::operator[](utils::to_underlying(e));
 	}
 };
 
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/common/shared_mem_object.h 0.3.0-1/src/libcamera/pipeline/rpi/common/shared_mem_object.h
--- 0.2.0-3/src/libcamera/pipeline/rpi/common/shared_mem_object.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/common/shared_mem_object.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,128 +0,0 @@
-/* SPDX-License-Identifier: LGPL-2.1-or-later */
-/*
- * Copyright (C) 2023, Raspberry Pi Ltd
- *
- * shared_mem_object.h - Helper class for shared memory allocations
- */
-#pragma once
-
-#include <cstddef>
-#include <fcntl.h>
-#include <string>
-#include <sys/mman.h>
-#include <sys/stat.h>
-#include <unistd.h>
-#include <utility>
-
-#include <libcamera/base/class.h>
-#include <libcamera/base/shared_fd.h>
-
-namespace libcamera {
-
-namespace RPi {
-
-template<class T>
-class SharedMemObject
-{
-public:
-	static constexpr std::size_t SIZE = sizeof(T);
-
-	SharedMemObject()
-		: obj_(nullptr)
-	{
-	}
-
-	template<class... Args>
-	SharedMemObject(const std::string &name, Args &&...args)
-		: name_(name), obj_(nullptr)
-	{
-		void *mem;
-		int ret;
-
-		ret = memfd_create(name_.c_str(), MFD_CLOEXEC);
-		if (ret < 0)
-			return;
-
-		fd_ = SharedFD(std::move(ret));
-		if (!fd_.isValid())
-			return;
-
-		ret = ftruncate(fd_.get(), SIZE);
-		if (ret < 0)
-			return;
-
-		mem = mmap(nullptr, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED,
-			   fd_.get(), 0);
-		if (mem == MAP_FAILED)
-			return;
-
-		obj_ = new (mem) T(std::forward<Args>(args)...);
-	}
-
-	SharedMemObject(SharedMemObject<T> &&rhs)
-	{
-		this->name_ = std::move(rhs.name_);
-		this->fd_ = std::move(rhs.fd_);
-		this->obj_ = rhs.obj_;
-		rhs.obj_ = nullptr;
-	}
-
-	~SharedMemObject()
-	{
-		if (obj_) {
-			obj_->~T();
-			munmap(obj_, SIZE);
-		}
-	}
-
-	/* Make SharedMemObject non-copyable for now. */
-	LIBCAMERA_DISABLE_COPY(SharedMemObject)
-
-	SharedMemObject<T> &operator=(SharedMemObject<T> &&rhs)
-	{
-		this->name_ = std::move(rhs.name_);
-		this->fd_ = std::move(rhs.fd_);
-		this->obj_ = rhs.obj_;
-		rhs.obj_ = nullptr;
-		return *this;
-	}
-
-	T *operator->()
-	{
-		return obj_;
-	}
-
-	const T *operator->() const
-	{
-		return obj_;
-	}
-
-	T &operator*()
-	{
-		return *obj_;
-	}
-
-	const T &operator*() const
-	{
-		return *obj_;
-	}
-
-	const SharedFD &fd() const
-	{
-		return fd_;
-	}
-
-	explicit operator bool() const
-	{
-		return !!obj_;
-	}
-
-private:
-	std::string name_;
-	SharedFD fd_;
-	T *obj_;
-};
-
-} /* namespace RPi */
-
-} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/vc4/dma_heaps.cpp 0.3.0-1/src/libcamera/pipeline/rpi/vc4/dma_heaps.cpp
--- 0.2.0-3/src/libcamera/pipeline/rpi/vc4/dma_heaps.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/vc4/dma_heaps.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,90 +0,0 @@
-/* SPDX-License-Identifier: LGPL-2.1-or-later */
-/*
- * Copyright (C) 2020, Raspberry Pi Ltd
- *
- * dma_heaps.h - Helper class for dma-heap allocations.
- */
-
-#include "dma_heaps.h"
-
-#include <array>
-#include <fcntl.h>
-#include <linux/dma-buf.h>
-#include <linux/dma-heap.h>
-#include <sys/ioctl.h>
-#include <unistd.h>
-
-#include <libcamera/base/log.h>
-
-/*
- * /dev/dma-heap/linux,cma is the dma-heap allocator, which allows dmaheap-cma
- * to only have to worry about importing.
- *
- * Annoyingly, should the cma heap size be specified on the kernel command line
- * instead of DT, the heap gets named "reserved" instead.
- */
-static constexpr std::array<const char *, 2> heapNames = {
-	"/dev/dma_heap/linux,cma",
-	"/dev/dma_heap/reserved"
-};
-
-namespace libcamera {
-
-LOG_DECLARE_CATEGORY(RPI)
-
-namespace RPi {
-
-DmaHeap::DmaHeap()
-{
-	for (const char *name : heapNames) {
-		int ret = ::open(name, O_RDWR | O_CLOEXEC, 0);
-		if (ret < 0) {
-			ret = errno;
-			LOG(RPI, Debug) << "Failed to open " << name << ": "
-					<< strerror(ret);
-			continue;
-		}
-
-		dmaHeapHandle_ = UniqueFD(ret);
-		break;
-	}
-
-	if (!dmaHeapHandle_.isValid())
-		LOG(RPI, Error) << "Could not open any dmaHeap device";
-}
-
-DmaHeap::~DmaHeap() = default;
-
-UniqueFD DmaHeap::alloc(const char *name, std::size_t size)
-{
-	int ret;
-
-	if (!name)
-		return {};
-
-	struct dma_heap_allocation_data alloc = {};
-
-	alloc.len = size;
-	alloc.fd_flags = O_CLOEXEC | O_RDWR;
-
-	ret = ::ioctl(dmaHeapHandle_.get(), DMA_HEAP_IOCTL_ALLOC, &alloc);
-	if (ret < 0) {
-		LOG(RPI, Error) << "dmaHeap allocation failure for "
-				<< name;
-		return {};
-	}
-
-	UniqueFD allocFd(alloc.fd);
-	ret = ::ioctl(allocFd.get(), DMA_BUF_SET_NAME, name);
-	if (ret < 0) {
-		LOG(RPI, Error) << "dmaHeap naming failure for "
-				<< name;
-		return {};
-	}
-
-	return allocFd;
-}
-
-} /* namespace RPi */
-
-} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/vc4/dma_heaps.h 0.3.0-1/src/libcamera/pipeline/rpi/vc4/dma_heaps.h
--- 0.2.0-3/src/libcamera/pipeline/rpi/vc4/dma_heaps.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/vc4/dma_heaps.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,32 +0,0 @@
-/* SPDX-License-Identifier: LGPL-2.1-or-later */
-/*
- * Copyright (C) 2020, Raspberry Pi Ltd
- *
- * dma_heaps.h - Helper class for dma-heap allocations.
- */
-
-#pragma once
-
-#include <stddef.h>
-
-#include <libcamera/base/unique_fd.h>
-
-namespace libcamera {
-
-namespace RPi {
-
-class DmaHeap
-{
-public:
-	DmaHeap();
-	~DmaHeap();
-	bool isValid() const { return dmaHeapHandle_.isValid(); }
-	UniqueFD alloc(const char *name, std::size_t size);
-
-private:
-	UniqueFD dmaHeapHandle_;
-};
-
-} /* namespace RPi */
-
-} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/vc4/meson.build 0.3.0-1/src/libcamera/pipeline/rpi/vc4/meson.build
--- 0.2.0-3/src/libcamera/pipeline/rpi/vc4/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/vc4/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -1,7 +1,6 @@
 # SPDX-License-Identifier: CC0-1.0
 
 libcamera_sources += files([
-    'dma_heaps.cpp',
     'vc4.cpp',
 ])
 
diff -pruN 0.2.0-3/src/libcamera/pipeline/rpi/vc4/vc4.cpp 0.3.0-1/src/libcamera/pipeline/rpi/vc4/vc4.cpp
--- 0.2.0-3/src/libcamera/pipeline/rpi/vc4/vc4.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/rpi/vc4/vc4.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019-2023, Raspberry Pi Ltd
  *
- * vc4.cpp - Pipeline handler for VC4-based Raspberry Pi devices
+ * Pipeline handler for VC4-based Raspberry Pi devices
  */
 
 #include <linux/bcm2835-isp.h>
@@ -12,12 +12,11 @@
 #include <libcamera/formats.h>
 
 #include "libcamera/internal/device_enumerator.h"
+#include "libcamera/internal/dma_heaps.h"
 
 #include "../common/pipeline_base.h"
 #include "../common/rpi_stream.h"
 
-#include "dma_heaps.h"
-
 using namespace std::chrono_literals;
 
 namespace libcamera {
@@ -87,7 +86,7 @@ public:
 	RPi::Device<Isp, 4> isp_;
 
 	/* DMAHEAP allocation helper. */
-	RPi::DmaHeap dmaHeap_;
+	DmaHeap dmaHeap_;
 	SharedFD lsTable_;
 
 	struct Config {
@@ -426,7 +425,7 @@ CameraConfiguration::Status Vc4CameraDat
 		BayerFormat rawBayer = BayerFormat::fromPixelFormat(rawStream->pixelFormat);
 
 		/* Apply the sensor bitdepth. */
-		rawBayer.bitDepth = BayerFormat::fromMbusCode(rpiConfig->sensorFormat_.mbus_code).bitDepth;
+		rawBayer.bitDepth = BayerFormat::fromMbusCode(rpiConfig->sensorFormat_.code).bitDepth;
 
 		/* Default to CSI2 packing if the user request is unsupported. */
 		if (rawBayer.packing != BayerFormat::Packing::CSI2 &&
@@ -434,6 +433,17 @@ CameraConfiguration::Status Vc4CameraDat
 			rawBayer.packing = BayerFormat::Packing::CSI2;
 
 		PixelFormat rawFormat = rawBayer.toPixelFormat();
+
+		/*
+		 * Try for an unpacked format if a packed one wasn't available.
+		 * This catches 8 (and 16) bit formats which would otherwise
+		 * fail.
+		 */
+		if (!rawFormat.isValid() && rawBayer.packing != BayerFormat::Packing::None) {
+			rawBayer.packing = BayerFormat::Packing::None;
+			rawFormat = rawBayer.toPixelFormat();
+		}
+
 		if (rawStream->pixelFormat != rawFormat ||
 		    rawStream->size != rpiConfig->sensorFormat_.size) {
 			rawStream->pixelFormat = rawFormat;
@@ -945,6 +955,7 @@ void Vc4CameraData::tryRunPipeline()
 	params.requestControls = request->controls();
 	params.ipaContext = request->sequence();
 	params.delayContext = bayerFrame.delayContext;
+	params.buffers.embedded = 0;
 
 	if (embeddedBuffer) {
 		unsigned int embeddedId = unicam_[Unicam::Embedded].getBufferId(embeddedBuffer);
@@ -1007,6 +1018,6 @@ bool Vc4CameraData::findMatchingBuffers(
 	return true;
 }
 
-REGISTER_PIPELINE_HANDLER(PipelineHandlerVc4)
+REGISTER_PIPELINE_HANDLER(PipelineHandlerVc4, "rpi/vc4")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/simple/simple.cpp 0.3.0-1/src/libcamera/pipeline/simple/simple.cpp
--- 0.2.0-3/src/libcamera/pipeline/simple/simple.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/simple/simple.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2020, Laurent Pinchart
  * Copyright (C) 2019, Martijn Braam
  *
- * simple.cpp - Pipeline handler for simple pipelines
+ * Pipeline handler for simple pipelines
  */
 
 #include <algorithm>
@@ -34,6 +34,7 @@
 #include "libcamera/internal/device_enumerator.h"
 #include "libcamera/internal/media_device.h"
 #include "libcamera/internal/pipeline_handler.h"
+#include "libcamera/internal/software_isp/software_isp.h"
 #include "libcamera/internal/v4l2_subdevice.h"
 #include "libcamera/internal/v4l2_videodevice.h"
 
@@ -185,17 +186,24 @@ struct SimplePipelineInfo {
 	 * and the number of streams it supports.
 	 */
 	std::vector<std::pair<const char *, unsigned int>> converters;
+	/*
+	 * Using Software ISP is to be enabled per driver.
+	 *
+	 * The Software ISP can't be used together with the converters.
+	 */
+	bool swIspEnabled;
 };
 
 namespace {
 
 static const SimplePipelineInfo supportedDevices[] = {
-	{ "dcmipp", {} },
-	{ "imx7-csi", { { "pxp", 1 } } },
-	{ "j721e-csi2rx", {} },
-	{ "mxc-isi", {} },
-	{ "qcom-camss", {} },
-	{ "sun6i-csi", {} },
+	{ "dcmipp", {}, false },
+	{ "imx7-csi", { { "pxp", 1 } }, false },
+	{ "j721e-csi2rx", {}, false },
+	{ "mtk-seninf", { { "mtk-mdp", 3 } }, false },
+	{ "mxc-isi", {}, false },
+	{ "qcom-camss", {}, true },
+	{ "sun6i-csi", {}, false },
 };
 
 } /* namespace */
@@ -269,17 +277,22 @@ public:
 	std::vector<Configuration> configs_;
 	std::map<PixelFormat, std::vector<const Configuration *>> formats_;
 
+	std::vector<std::unique_ptr<FrameBuffer>> conversionBuffers_;
+	std::queue<std::map<unsigned int, FrameBuffer *>> conversionQueue_;
+	bool useConversion_;
+
 	std::unique_ptr<Converter> converter_;
-	std::vector<std::unique_ptr<FrameBuffer>> converterBuffers_;
-	bool useConverter_;
-	std::queue<std::map<unsigned int, FrameBuffer *>> converterQueue_;
+	std::unique_ptr<SoftwareIsp> swIsp_;
 
 private:
 	void tryPipeline(unsigned int code, const Size &size);
 	static std::vector<const MediaPad *> routedSourcePads(MediaPad *sink);
 
-	void converterInputDone(FrameBuffer *buffer);
-	void converterOutputDone(FrameBuffer *buffer);
+	void conversionInputDone(FrameBuffer *buffer);
+	void conversionOutputDone(FrameBuffer *buffer);
+
+	void ispStatsReady();
+	void setSensorControls(const ControlList &sensorControls);
 };
 
 class SimpleCameraConfiguration : public CameraConfiguration
@@ -331,6 +344,7 @@ public:
 	V4L2VideoDevice *video(const MediaEntity *entity);
 	V4L2Subdevice *subdev(const MediaEntity *entity);
 	MediaDevice *converter() { return converter_; }
+	bool swIspEnabled() const { return swIspEnabled_; }
 
 protected:
 	int queueRequestDevice(Camera *camera, Request *request) override;
@@ -359,6 +373,7 @@ private:
 	std::map<const MediaEntity *, EntityData> entities_;
 
 	MediaDevice *converter_;
+	bool swIspEnabled_;
 };
 
 /* -----------------------------------------------------------------------------
@@ -503,8 +518,39 @@ int SimpleCameraData::init()
 				<< "Failed to create converter, disabling format conversion";
 			converter_.reset();
 		} else {
-			converter_->inputBufferReady.connect(this, &SimpleCameraData::converterInputDone);
-			converter_->outputBufferReady.connect(this, &SimpleCameraData::converterOutputDone);
+			converter_->inputBufferReady.connect(this, &SimpleCameraData::conversionInputDone);
+			converter_->outputBufferReady.connect(this, &SimpleCameraData::conversionOutputDone);
+		}
+	}
+
+	/*
+	 * Instantiate Soft ISP if this is enabled for the given driver and no converter is used.
+	 */
+	if (!converter_ && pipe->swIspEnabled()) {
+		swIsp_ = std::make_unique<SoftwareIsp>(pipe, sensor_.get());
+		if (!swIsp_->isValid()) {
+			LOG(SimplePipeline, Warning)
+				<< "Failed to create software ISP, disabling software debayering";
+			swIsp_.reset();
+		} else {
+			/*
+			 * The inputBufferReady signal is emitted from the soft ISP thread,
+			 * and needs to be handled in the pipeline handler thread. Signals
+			 * implement queued delivery, but this works transparently only if
+			 * the receiver is bound to the target thread. As the
+			 * SimpleCameraData class doesn't inherit from the Object class, it
+			 * is not bound to any thread, and the signal would be delivered
+			 * synchronously. Instead, connect the signal to a lambda function
+			 * bound explicitly to the pipe, which is bound to the pipeline
+			 * handler thread. The function then simply forwards the call to
+			 * conversionInputDone().
+			 */
+			swIsp_->inputBufferReady.connect(pipe, [this](FrameBuffer *buffer) {
+				this->conversionInputDone(buffer);
+			});
+			swIsp_->outputBufferReady.connect(this, &SimpleCameraData::conversionOutputDone);
+			swIsp_->ispStatsReady.connect(this, &SimpleCameraData::ispStatsReady);
+			swIsp_->setSensorControls.connect(this, &SimpleCameraData::setSensorControls);
 		}
 	}
 
@@ -562,13 +608,13 @@ void SimpleCameraData::tryPipeline(unsig
 	 * corresponding possible V4L2 pixel formats on the video node.
 	 */
 	V4L2SubdeviceFormat format{};
-	format.mbus_code = code;
+	format.code = code;
 	format.size = size;
 
 	int ret = setupFormats(&format, V4L2Subdevice::TryFormat);
 	if (ret < 0) {
 		/* Pipeline configuration failed, skip this configuration. */
-		format.mbus_code = code;
+		format.code = code;
 		format.size = size;
 		LOG(SimplePipeline, Debug)
 			<< "Sensor format " << format
@@ -576,7 +622,7 @@ void SimpleCameraData::tryPipeline(unsig
 		return;
 	}
 
-	V4L2VideoDevice::Formats videoFormats = video_->formats(format.mbus_code);
+	V4L2VideoDevice::Formats videoFormats = video_->formats(format.code);
 
 	LOG(SimplePipeline, Debug)
 		<< "Adding configuration for " << format.size
@@ -598,12 +644,20 @@ void SimpleCameraData::tryPipeline(unsig
 		config.captureFormat = pixelFormat;
 		config.captureSize = format.size;
 
-		if (!converter_) {
-			config.outputFormats = { pixelFormat };
-			config.outputSizes = config.captureSize;
-		} else {
+		if (converter_) {
 			config.outputFormats = converter_->formats(pixelFormat);
 			config.outputSizes = converter_->sizes(format.size);
+		} else if (swIsp_) {
+			config.outputFormats = swIsp_->formats(pixelFormat);
+			config.outputSizes = swIsp_->sizes(pixelFormat, format.size);
+			if (config.outputFormats.empty()) {
+				/* Do not use swIsp for unsupported pixelFormat's. */
+				config.outputFormats = { pixelFormat };
+				config.outputSizes = config.captureSize;
+			}
+		} else {
+			config.outputFormats = { pixelFormat };
+			config.outputSizes = config.captureSize;
 		}
 
 		configs_.push_back(config);
@@ -706,7 +760,7 @@ int SimpleCameraData::setupFormats(V4L2S
 			if (ret < 0)
 				return ret;
 
-			if (format->mbus_code != sourceFormat.mbus_code ||
+			if (format->code != sourceFormat.code ||
 			    format->size != sourceFormat.size) {
 				LOG(SimplePipeline, Debug)
 					<< "Source '" << source->entity()->name()
@@ -740,7 +794,7 @@ void SimpleCameraData::bufferReady(Frame
 	 * point converting an erroneous buffer.
 	 */
 	if (buffer->metadata().status != FrameMetadata::FrameSuccess) {
-		if (!useConverter_) {
+		if (!useConversion_) {
 			/* No conversion, just complete the request. */
 			Request *request = buffer->request();
 			pipe->completeBuffer(request, buffer);
@@ -749,23 +803,23 @@ void SimpleCameraData::bufferReady(Frame
 		}
 
 		/*
-		 * The converter is in use. Requeue the internal buffer for
-		 * capture (unless the stream is being stopped), and complete
-		 * the request with all the user-facing buffers.
+		 * The converter or Software ISP is in use. Requeue the internal
+		 * buffer for capture (unless the stream is being stopped), and
+		 * complete the request with all the user-facing buffers.
 		 */
 		if (buffer->metadata().status != FrameMetadata::FrameCancelled)
 			video_->queueBuffer(buffer);
 
-		if (converterQueue_.empty())
+		if (conversionQueue_.empty())
 			return;
 
 		Request *request = nullptr;
-		for (auto &item : converterQueue_.front()) {
+		for (auto &item : conversionQueue_.front()) {
 			FrameBuffer *outputBuffer = item.second;
 			request = outputBuffer->request();
 			pipe->completeBuffer(request, outputBuffer);
 		}
-		converterQueue_.pop();
+		conversionQueue_.pop();
 
 		if (request)
 			pipe->completeRequest(request);
@@ -782,9 +836,9 @@ void SimpleCameraData::bufferReady(Frame
 	 */
 	Request *request = buffer->request();
 
-	if (useConverter_ && !converterQueue_.empty()) {
+	if (useConversion_ && !conversionQueue_.empty()) {
 		const std::map<unsigned int, FrameBuffer *> &outputs =
-			converterQueue_.front();
+			conversionQueue_.front();
 		if (!outputs.empty()) {
 			FrameBuffer *outputBuffer = outputs.begin()->second;
 			if (outputBuffer)
@@ -797,18 +851,22 @@ void SimpleCameraData::bufferReady(Frame
 					buffer->metadata().timestamp);
 
 	/*
-	 * Queue the captured and the request buffer to the converter if format
-	 * conversion is needed. If there's no queued request, just requeue the
-	 * captured buffer for capture.
+	 * Queue the captured and the request buffer to the converter or Software
+	 * ISP if format conversion is needed. If there's no queued request, just
+	 * requeue the captured buffer for capture.
 	 */
-	if (useConverter_) {
-		if (converterQueue_.empty()) {
+	if (useConversion_) {
+		if (conversionQueue_.empty()) {
 			video_->queueBuffer(buffer);
 			return;
 		}
 
-		converter_->queueBuffers(buffer, converterQueue_.front());
-		converterQueue_.pop();
+		if (converter_)
+			converter_->queueBuffers(buffer, conversionQueue_.front());
+		else
+			swIsp_->queueBuffers(buffer, conversionQueue_.front());
+
+		conversionQueue_.pop();
 		return;
 	}
 
@@ -817,13 +875,13 @@ void SimpleCameraData::bufferReady(Frame
 	pipe->completeRequest(request);
 }
 
-void SimpleCameraData::converterInputDone(FrameBuffer *buffer)
+void SimpleCameraData::conversionInputDone(FrameBuffer *buffer)
 {
 	/* Queue the input buffer back for capture. */
 	video_->queueBuffer(buffer);
 }
 
-void SimpleCameraData::converterOutputDone(FrameBuffer *buffer)
+void SimpleCameraData::conversionOutputDone(FrameBuffer *buffer)
 {
 	SimplePipelineHandler *pipe = SimpleCameraData::pipe();
 
@@ -833,6 +891,19 @@ void SimpleCameraData::converterOutputDo
 		pipe->completeRequest(request);
 }
 
+void SimpleCameraData::ispStatsReady()
+{
+	/* \todo Use the DelayedControls class */
+	swIsp_->processStats(sensor_->getControls({ V4L2_CID_ANALOGUE_GAIN,
+						    V4L2_CID_EXPOSURE }));
+}
+
+void SimpleCameraData::setSensorControls(const ControlList &sensorControls)
+{
+	ControlList ctrls(sensorControls);
+	sensor_->setControls(&ctrls);
+}
+
 /* Retrieve all source pads connected to a sink pad through active routes. */
 std::vector<const MediaPad *> SimpleCameraData::routedSourcePads(MediaPad *sink)
 {
@@ -851,17 +922,17 @@ std::vector<const MediaPad *> SimpleCame
 
 	std::vector<const MediaPad *> pads;
 
-	for (const struct v4l2_subdev_route &route : routing) {
-		if (sink->index() != route.sink_pad ||
+	for (const V4L2Subdevice::Route &route : routing) {
+		if (sink->index() != route.sink.pad ||
 		    !(route.flags & V4L2_SUBDEV_ROUTE_FL_ACTIVE))
 			continue;
 
-		const MediaPad *pad = entity->getPadByIndex(route.source_pad);
+		const MediaPad *pad = entity->getPadByIndex(route.source.pad);
 		if (!pad) {
 			LOG(SimplePipeline, Warning)
 				<< "Entity " << entity->name()
 				<< " has invalid route source pad "
-				<< route.source_pad;
+				<< route.source.pad;
 		}
 
 		pads.push_back(pad);
@@ -881,6 +952,33 @@ SimpleCameraConfiguration::SimpleCameraC
 {
 }
 
+namespace {
+
+static Size adjustSize(const Size &requestedSize, const SizeRange &supportedSizes)
+{
+	ASSERT(supportedSizes.min <= supportedSizes.max);
+
+	if (supportedSizes.min == supportedSizes.max)
+		return supportedSizes.max;
+
+	unsigned int hStep = supportedSizes.hStep;
+	unsigned int vStep = supportedSizes.vStep;
+
+	if (hStep == 0)
+		hStep = supportedSizes.max.width - supportedSizes.min.width;
+	if (vStep == 0)
+		vStep = supportedSizes.max.height - supportedSizes.min.height;
+
+	Size adjusted = requestedSize.boundedTo(supportedSizes.max)
+				.expandedTo(supportedSizes.min);
+
+	return adjusted.shrunkBy(supportedSizes.min)
+		.alignedDownTo(hStep, vStep)
+		.grownBy(supportedSizes.min);
+}
+
+} /* namespace */
+
 CameraConfiguration::Status SimpleCameraConfiguration::validate()
 {
 	const CameraSensor *sensor = data_->sensor_.get();
@@ -997,10 +1095,19 @@ CameraConfiguration::Status SimpleCamera
 		}
 
 		if (!pipeConfig_->outputSizes.contains(cfg.size)) {
+			Size adjustedSize = pipeConfig_->captureSize;
+			/*
+			 * The converter (when present) may not be able to output
+			 * a size identical to its input size. The capture size is thus
+			 * not guaranteed to be a valid output size. In such cases, use
+			 * the smaller valid output size closest to the requested.
+			 */
+			if (!pipeConfig_->outputSizes.contains(adjustedSize))
+				adjustedSize = adjustSize(cfg.size, pipeConfig_->outputSizes);
 			LOG(SimplePipeline, Debug)
 				<< "Adjusting size from " << cfg.size
-				<< " to " << pipeConfig_->captureSize;
-			cfg.size = pipeConfig_->captureSize;
+				<< " to " << adjustedSize;
+			cfg.size = adjustedSize;
 			status = Adjusted;
 		}
 
@@ -1012,8 +1119,11 @@ CameraConfiguration::Status SimpleCamera
 		/* Set the stride, frameSize and bufferCount. */
 		if (needConversion_) {
 			std::tie(cfg.stride, cfg.frameSize) =
-				data_->converter_->strideAndFrameSize(cfg.pixelFormat,
-								      cfg.size);
+				data_->converter_
+					? data_->converter_->strideAndFrameSize(cfg.pixelFormat,
+										cfg.size)
+					: data_->swIsp_->strideAndFrameSize(cfg.pixelFormat,
+									    cfg.size);
 			if (cfg.stride == 0)
 				return Invalid;
 		} else {
@@ -1120,7 +1230,7 @@ int SimplePipelineHandler::configure(Cam
 
 	const SimpleCameraData::Configuration *pipeConfig = config->pipeConfig();
 	V4L2SubdeviceFormat format{};
-	format.mbus_code = pipeConfig->code;
+	format.code = pipeConfig->code;
 	format.size = pipeConfig->sensorSize;
 
 	ret = data->setupFormats(&format, V4L2Subdevice::ActiveFormat,
@@ -1156,14 +1266,14 @@ int SimplePipelineHandler::configure(Cam
 
 	/* Configure the converter if needed. */
 	std::vector<std::reference_wrapper<StreamConfiguration>> outputCfgs;
-	data->useConverter_ = config->needConversion();
+	data->useConversion_ = config->needConversion();
 
 	for (unsigned int i = 0; i < config->size(); ++i) {
 		StreamConfiguration &cfg = config->at(i);
 
 		cfg.setStream(&data->streams_[i]);
 
-		if (data->useConverter_)
+		if (data->useConversion_)
 			outputCfgs.push_back(cfg);
 	}
 
@@ -1176,7 +1286,10 @@ int SimplePipelineHandler::configure(Cam
 	inputCfg.stride = captureFormat.planes[0].bpl;
 	inputCfg.bufferCount = kNumInternalBuffers;
 
-	return data->converter_->configure(inputCfg, outputCfgs);
+	return data->converter_
+		       ? data->converter_->configure(inputCfg, outputCfgs)
+		       : data->swIsp_->configure(inputCfg, outputCfgs,
+						 data->sensor_->controls());
 }
 
 int SimplePipelineHandler::exportFrameBuffers(Camera *camera, Stream *stream,
@@ -1189,9 +1302,12 @@ int SimplePipelineHandler::exportFrameBu
 	 * Export buffers on the converter or capture video node, depending on
 	 * whether the converter is used or not.
 	 */
-	if (data->useConverter_)
-		return data->converter_->exportBuffers(data->streamIndex(stream),
-						       count, buffers);
+	if (data->useConversion_)
+		return data->converter_
+			       ? data->converter_->exportBuffers(data->streamIndex(stream),
+								 count, buffers)
+			       : data->swIsp_->exportBuffers(data->streamIndex(stream),
+							     count, buffers);
 	else
 		return data->video_->exportBuffers(count, buffers);
 }
@@ -1210,13 +1326,13 @@ int SimplePipelineHandler::start(Camera
 		return -EBUSY;
 	}
 
-	if (data->useConverter_) {
+	if (data->useConversion_) {
 		/*
 		 * When using the converter allocate a fixed number of internal
 		 * buffers.
 		 */
 		ret = video->allocateBuffers(kNumInternalBuffers,
-					     &data->converterBuffers_);
+					     &data->conversionBuffers_);
 	} else {
 		/* Otherwise, prepare for using buffers from the only stream. */
 		Stream *stream = &data->streams_[0];
@@ -1235,15 +1351,21 @@ int SimplePipelineHandler::start(Camera
 		return ret;
 	}
 
-	if (data->useConverter_) {
-		ret = data->converter_->start();
+	if (data->useConversion_) {
+		if (data->converter_)
+			ret = data->converter_->start();
+		else if (data->swIsp_)
+			ret = data->swIsp_->start();
+		else
+			ret = 0;
+
 		if (ret < 0) {
 			stop(camera);
 			return ret;
 		}
 
 		/* Queue all internal buffers for capture. */
-		for (std::unique_ptr<FrameBuffer> &buffer : data->converterBuffers_)
+		for (std::unique_ptr<FrameBuffer> &buffer : data->conversionBuffers_)
 			video->queueBuffer(buffer.get());
 	}
 
@@ -1255,15 +1377,19 @@ void SimplePipelineHandler::stopDevice(C
 	SimpleCameraData *data = cameraData(camera);
 	V4L2VideoDevice *video = data->video_;
 
-	if (data->useConverter_)
-		data->converter_->stop();
+	if (data->useConversion_) {
+		if (data->converter_)
+			data->converter_->stop();
+		else if (data->swIsp_)
+			data->swIsp_->stop();
+	}
 
 	video->streamOff();
 	video->releaseBuffers();
 
 	video->bufferReady.disconnect(data, &SimpleCameraData::bufferReady);
 
-	data->converterBuffers_.clear();
+	data->conversionBuffers_.clear();
 
 	releasePipeline(data);
 }
@@ -1281,7 +1407,7 @@ int SimplePipelineHandler::queueRequestD
 		 * queue, it will be handed to the converter in the capture
 		 * completion handler.
 		 */
-		if (data->useConverter_) {
+		if (data->useConversion_) {
 			buffers.emplace(data->streamIndex(stream), buffer);
 		} else {
 			ret = data->video_->queueBuffer(buffer);
@@ -1290,8 +1416,8 @@ int SimplePipelineHandler::queueRequestD
 		}
 	}
 
-	if (data->useConverter_)
-		data->converterQueue_.push(std::move(buffers));
+	if (data->useConversion_)
+		data->conversionQueue_.push(std::move(buffers));
 
 	return 0;
 }
@@ -1387,7 +1513,7 @@ int SimplePipelineHandler::resetRoutingT
 
 	LOG(SimplePipeline, Debug)
 		<< "Routing table of " << subdev->deviceNode()
-		<< " reset to " << routing.toString();
+		<< " reset to " << routing;
 
 	return 0;
 }
@@ -1418,6 +1544,8 @@ bool SimplePipelineHandler::match(Device
 		}
 	}
 
+	swIspEnabled_ = info->swIspEnabled;
+
 	/* Locate the sensors. */
 	std::vector<MediaEntity *> sensors = locateSensors();
 	if (sensors.empty()) {
@@ -1604,6 +1732,6 @@ void SimplePipelineHandler::releasePipel
 	}
 }
 
-REGISTER_PIPELINE_HANDLER(SimplePipelineHandler)
+REGISTER_PIPELINE_HANDLER(SimplePipelineHandler, "simple")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/uvcvideo/uvcvideo.cpp 0.3.0-1/src/libcamera/pipeline/uvcvideo/uvcvideo.cpp
--- 0.2.0-3/src/libcamera/pipeline/uvcvideo/uvcvideo.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/uvcvideo/uvcvideo.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * uvcvideo.cpp - Pipeline handler for uvcvideo devices
+ * Pipeline handler for uvcvideo devices
  */
 
 #include <algorithm>
@@ -709,6 +709,6 @@ void UVCCameraData::bufferReady(FrameBuf
 	pipe()->completeRequest(request);
 }
 
-REGISTER_PIPELINE_HANDLER(PipelineHandlerUVC)
+REGISTER_PIPELINE_HANDLER(PipelineHandlerUVC, "uvcvideo")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline/vimc/vimc.cpp 0.3.0-1/src/libcamera/pipeline/vimc/vimc.cpp
--- 0.2.0-3/src/libcamera/pipeline/vimc/vimc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline/vimc/vimc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * vimc.cpp - Pipeline handler for the vimc device
+ * Pipeline handler for the vimc device
  */
 
 #include <algorithm>
@@ -244,7 +244,7 @@ int PipelineHandlerVimc::configure(Camer
 
 	/* The scaler hardcodes a x3 scale-up ratio. */
 	V4L2SubdeviceFormat subformat = {};
-	subformat.mbus_code = MEDIA_BUS_FMT_SGRBG8_1X8;
+	subformat.code = MEDIA_BUS_FMT_SGRBG8_1X8;
 	subformat.size = { cfg.size.width / 3, cfg.size.height / 3 };
 
 	ret = data->sensor_->setFormat(&subformat);
@@ -255,7 +255,7 @@ int PipelineHandlerVimc::configure(Camer
 	if (ret)
 		return ret;
 
-	subformat.mbus_code = pixelformats.find(cfg.pixelFormat)->second;
+	subformat.code = pixelformats.find(cfg.pixelFormat)->second;
 	ret = data->debayer_->setFormat(1, &subformat);
 	if (ret)
 		return ret;
@@ -623,6 +623,6 @@ void VimcCameraData::paramsBufferReady([
 {
 }
 
-REGISTER_PIPELINE_HANDLER(PipelineHandlerVimc)
+REGISTER_PIPELINE_HANDLER(PipelineHandlerVimc, "vimc")
 
 } /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/pipeline_handler.cpp 0.3.0-1/src/libcamera/pipeline_handler.cpp
--- 0.2.0-3/src/libcamera/pipeline_handler.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pipeline_handler.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * pipeline_handler.cpp - Pipeline handler infrastructure
+ * Pipeline handler infrastructure
  */
 
 #include "libcamera/internal/pipeline_handler.h"
@@ -795,6 +795,28 @@ std::vector<PipelineHandlerFactoryBase *
 }
 
 /**
+ * \brief Return the factory for the pipeline handler with name \a name
+ * \param[in] name The pipeline handler name
+ * \return The factory of the pipeline with name \a name, or nullptr if not found
+ */
+const PipelineHandlerFactoryBase *PipelineHandlerFactoryBase::getFactoryByName(const std::string &name)
+{
+	const std::vector<PipelineHandlerFactoryBase *> &factories =
+		PipelineHandlerFactoryBase::factories();
+
+	auto iter = std::find_if(factories.begin(),
+				 factories.end(),
+				 [&name](const PipelineHandlerFactoryBase *f) {
+					 return f->name() == name;
+				 });
+
+	if (iter != factories.end())
+		return *iter;
+
+	return nullptr;
+}
+
+/**
  * \class PipelineHandlerFactory
  * \brief Registration of PipelineHandler classes and creation of instances
  * \tparam _PipelineHandler The pipeline handler class type for this factory
@@ -830,6 +852,8 @@ std::vector<PipelineHandlerFactoryBase *
  * \def REGISTER_PIPELINE_HANDLER
  * \brief Register a pipeline handler with the pipeline handler factory
  * \param[in] handler Class name of PipelineHandler derived class to register
+ * \param[in] name Name assigned to the pipeline handler, matching the pipeline
+ * subdirectory name in the source tree.
  *
  * Register a PipelineHandler subclass with the factory and make it available to
  * try and match devices.
diff -pruN 0.2.0-3/src/libcamera/pixel_format.cpp 0.3.0-1/src/libcamera/pixel_format.cpp
--- 0.2.0-3/src/libcamera/pixel_format.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pixel_format.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * pixel_format.cpp - libcamera Pixel Format
+ * libcamera Pixel Format
  */
 
 #include <libcamera/formats.h>
diff -pruN 0.2.0-3/src/libcamera/process.cpp 0.3.0-1/src/libcamera/process.cpp
--- 0.2.0-3/src/libcamera/process.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/process.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * process.cpp - Process object
+ * Process object
  */
 
 #include "libcamera/internal/process.h"
diff -pruN 0.2.0-3/src/libcamera/pub_key.cpp 0.3.0-1/src/libcamera/pub_key.cpp
--- 0.2.0-3/src/libcamera/pub_key.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/pub_key.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * pub_key.cpp - Public key signature verification
+ * Public key signature verification
  */
 
 #include "libcamera/internal/pub_key.h"
diff -pruN 0.2.0-3/src/libcamera/request.cpp 0.3.0-1/src/libcamera/request.cpp
--- 0.2.0-3/src/libcamera/request.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/request.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * request.cpp - Capture request handling
+ * Capture request handling
  */
 
 #include "libcamera/internal/request.h"
diff -pruN 0.2.0-3/src/libcamera/sensor/camera_sensor.cpp 0.3.0-1/src/libcamera/sensor/camera_sensor.cpp
--- 0.2.0-3/src/libcamera/sensor/camera_sensor.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/sensor/camera_sensor.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,1207 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2019, Google Inc.
+ *
+ * A camera sensor
+ */
+
+#include "libcamera/internal/camera_sensor.h"
+#include "libcamera/internal/media_device.h"
+
+#include <algorithm>
+#include <float.h>
+#include <iomanip>
+#include <limits.h>
+#include <math.h>
+#include <string.h>
+
+#include <libcamera/camera.h>
+#include <libcamera/orientation.h>
+#include <libcamera/property_ids.h>
+
+#include <libcamera/base/utils.h>
+
+#include "libcamera/internal/bayer_format.h"
+#include "libcamera/internal/camera_lens.h"
+#include "libcamera/internal/camera_sensor_properties.h"
+#include "libcamera/internal/formats.h"
+#include "libcamera/internal/sysfs.h"
+
+/**
+ * \file camera_sensor.h
+ * \brief A camera sensor
+ */
+
+namespace libcamera {
+
+LOG_DEFINE_CATEGORY(CameraSensor)
+
+/**
+ * \class CameraSensor
+ * \brief A camera sensor based on V4L2 subdevices
+ *
+ * The CameraSensor class eases handling of sensors for pipeline handlers by
+ * hiding the details of the V4L2 subdevice kernel API and caching sensor
+ * information.
+ *
+ * The implementation is currently limited to sensors that expose a single V4L2
+ * subdevice with a single pad. It will be extended to support more complex
+ * devices as the needs arise.
+ */
+
+/**
+ * \brief Construct a CameraSensor
+ * \param[in] entity The media entity backing the camera sensor
+ *
+ * Once constructed the instance must be initialized with init().
+ */
+CameraSensor::CameraSensor(const MediaEntity *entity)
+	: entity_(entity), pad_(UINT_MAX), staticProps_(nullptr),
+	  bayerFormat_(nullptr), supportFlips_(false),
+	  flipsAlterBayerOrder_(false), properties_(properties::properties)
+{
+}
+
+/**
+ * \brief Destroy a CameraSensor
+ */
+CameraSensor::~CameraSensor()
+{
+}
+
+/**
+ * \brief Initialize the camera sensor instance
+ *
+ * This function performs the initialisation steps of the CameraSensor that may
+ * fail. It shall be called once and only once after constructing the instance.
+ *
+ * \return 0 on success or a negative error code otherwise
+ */
+int CameraSensor::init()
+{
+	for (const MediaPad *pad : entity_->pads()) {
+		if (pad->flags() & MEDIA_PAD_FL_SOURCE) {
+			pad_ = pad->index();
+			break;
+		}
+	}
+
+	if (pad_ == UINT_MAX) {
+		LOG(CameraSensor, Error)
+			<< "Sensors with more than one pad are not supported";
+		return -EINVAL;
+	}
+
+	switch (entity_->function()) {
+	case MEDIA_ENT_F_CAM_SENSOR:
+	case MEDIA_ENT_F_PROC_VIDEO_ISP:
+		break;
+
+	default:
+		LOG(CameraSensor, Error)
+			<< "Invalid sensor function "
+			<< utils::hex(entity_->function());
+		return -EINVAL;
+	}
+
+	/* Create and open the subdev. */
+	subdev_ = std::make_unique<V4L2Subdevice>(entity_);
+	int ret = subdev_->open();
+	if (ret < 0)
+		return ret;
+
+	/*
+	 * Clear any flips to be sure we get the "native" Bayer order. This is
+	 * harmless for sensors where the flips don't affect the Bayer order.
+	 */
+	ControlList ctrls(subdev_->controls());
+	if (subdev_->controls().find(V4L2_CID_HFLIP) != subdev_->controls().end())
+		ctrls.set(V4L2_CID_HFLIP, 0);
+	if (subdev_->controls().find(V4L2_CID_VFLIP) != subdev_->controls().end())
+		ctrls.set(V4L2_CID_VFLIP, 0);
+	subdev_->setControls(&ctrls);
+
+	/* Enumerate, sort and cache media bus codes and sizes. */
+	formats_ = subdev_->formats(pad_);
+	if (formats_.empty()) {
+		LOG(CameraSensor, Error) << "No image format found";
+		return -EINVAL;
+	}
+
+	mbusCodes_ = utils::map_keys(formats_);
+	std::sort(mbusCodes_.begin(), mbusCodes_.end());
+
+	for (const auto &format : formats_) {
+		const std::vector<SizeRange> &ranges = format.second;
+		std::transform(ranges.begin(), ranges.end(), std::back_inserter(sizes_),
+			       [](const SizeRange &range) { return range.max; });
+	}
+
+	std::sort(sizes_.begin(), sizes_.end());
+
+	/* Remove duplicates. */
+	auto last = std::unique(sizes_.begin(), sizes_.end());
+	sizes_.erase(last, sizes_.end());
+
+	/*
+	 * VIMC is a bit special, as it does not yet support all the mandatory
+	 * requirements regular sensors have to respect.
+	 *
+	 * Do not validate the driver if it's VIMC and initialize the sensor
+	 * properties with static information.
+	 *
+	 * \todo Remove the special case once the VIMC driver has been
+	 * updated in all test platforms.
+	 */
+	if (entity_->device()->driver() == "vimc") {
+		initVimcDefaultProperties();
+
+		ret = initProperties();
+		if (ret)
+			return ret;
+
+		return discoverAncillaryDevices();
+	}
+
+	/* Get the color filter array pattern (only for RAW sensors). */
+	for (unsigned int mbusCode : mbusCodes_) {
+		const BayerFormat &bayerFormat = BayerFormat::fromMbusCode(mbusCode);
+		if (bayerFormat.isValid()) {
+			bayerFormat_ = &bayerFormat;
+			break;
+		}
+	}
+
+	ret = validateSensorDriver();
+	if (ret)
+		return ret;
+
+	ret = initProperties();
+	if (ret)
+		return ret;
+
+	ret = discoverAncillaryDevices();
+	if (ret)
+		return ret;
+
+	/*
+	 * Set HBLANK to the minimum to start with a well-defined line length,
+	 * allowing IPA modules that do not modify HBLANK to use the sensor
+	 * minimum line length in their calculations.
+	 */
+	const struct v4l2_query_ext_ctrl *hblankInfo = subdev_->controlInfo(V4L2_CID_HBLANK);
+	if (hblankInfo && !(hblankInfo->flags & V4L2_CTRL_FLAG_READ_ONLY)) {
+		ControlList ctrl(subdev_->controls());
+
+		ctrl.set(V4L2_CID_HBLANK, static_cast<int32_t>(hblankInfo->minimum));
+		ret = subdev_->setControls(&ctrl);
+		if (ret)
+			return ret;
+	}
+
+	return applyTestPatternMode(controls::draft::TestPatternModeEnum::TestPatternModeOff);
+}
+
+int CameraSensor::generateId()
+{
+	const std::string devPath = subdev_->devicePath();
+
+	/* Try to get ID from firmware description. */
+	id_ = sysfs::firmwareNodePath(devPath);
+	if (!id_.empty())
+		return 0;
+
+	/*
+	 * Virtual sensors not described in firmware
+	 *
+	 * Verify it's a platform device and construct ID from the device path
+	 * and model of sensor.
+	 */
+	if (devPath.find("/sys/devices/platform/", 0) == 0) {
+		id_ = devPath.substr(strlen("/sys/devices/")) + " " + model();
+		return 0;
+	}
+
+	LOG(CameraSensor, Error) << "Can't generate sensor ID";
+	return -EINVAL;
+}
+
+int CameraSensor::validateSensorDriver()
+{
+	int err = 0;
+
+	/*
+	 * Optional controls are used to register optional sensor properties. If
+	 * not present, some values will be defaulted.
+	 */
+	static constexpr uint32_t optionalControls[] = {
+		V4L2_CID_CAMERA_SENSOR_ROTATION,
+	};
+
+	const ControlIdMap &controls = subdev_->controls().idmap();
+	for (uint32_t ctrl : optionalControls) {
+		if (!controls.count(ctrl))
+			LOG(CameraSensor, Debug)
+				<< "Optional V4L2 control " << utils::hex(ctrl)
+				<< " not supported";
+	}
+
+	/*
+	 * Recommended controls are similar to optional controls, but will
+	 * become mandatory in the near future. Be loud if they're missing.
+	 */
+	static constexpr uint32_t recommendedControls[] = {
+		V4L2_CID_CAMERA_ORIENTATION,
+	};
+
+	for (uint32_t ctrl : recommendedControls) {
+		if (!controls.count(ctrl)) {
+			LOG(CameraSensor, Warning)
+				<< "Recommended V4L2 control " << utils::hex(ctrl)
+				<< " not supported";
+			err = -EINVAL;
+		}
+	}
+
+	/*
+	 * Verify if sensor supports horizontal/vertical flips
+	 *
+	 * \todo Handle horizontal and vertical flips independently.
+	 */
+	const struct v4l2_query_ext_ctrl *hflipInfo = subdev_->controlInfo(V4L2_CID_HFLIP);
+	const struct v4l2_query_ext_ctrl *vflipInfo = subdev_->controlInfo(V4L2_CID_VFLIP);
+	if (hflipInfo && !(hflipInfo->flags & V4L2_CTRL_FLAG_READ_ONLY) &&
+	    vflipInfo && !(vflipInfo->flags & V4L2_CTRL_FLAG_READ_ONLY)) {
+		supportFlips_ = true;
+
+		if (hflipInfo->flags & V4L2_CTRL_FLAG_MODIFY_LAYOUT ||
+		    vflipInfo->flags & V4L2_CTRL_FLAG_MODIFY_LAYOUT)
+			flipsAlterBayerOrder_ = true;
+	}
+
+	if (!supportFlips_)
+		LOG(CameraSensor, Debug)
+			<< "Camera sensor does not support horizontal/vertical flip";
+
+	/*
+	 * Make sure the required selection targets are supported.
+	 *
+	 * Failures in reading any of the targets are not deemed to be fatal,
+	 * but some properties and features, like constructing a
+	 * IPACameraSensorInfo for the IPA module, won't be supported.
+	 *
+	 * \todo Make support for selection targets mandatory as soon as all
+	 * test platforms have been updated.
+	 */
+	Rectangle rect;
+	int ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP_BOUNDS, &rect);
+	if (ret) {
+		/*
+		 * Default the pixel array size to the largest size supported
+		 * by the sensor. The sizes_ vector is sorted in ascending
+		 * order, the largest size is thus the last element.
+		 */
+		pixelArraySize_ = sizes_.back();
+
+		LOG(CameraSensor, Warning)
+			<< "The PixelArraySize property has been defaulted to "
+			<< pixelArraySize_;
+		err = -EINVAL;
+	} else {
+		pixelArraySize_ = rect.size();
+	}
+
+	ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP_DEFAULT, &activeArea_);
+	if (ret) {
+		activeArea_ = Rectangle(pixelArraySize_);
+		LOG(CameraSensor, Warning)
+			<< "The PixelArrayActiveAreas property has been defaulted to "
+			<< activeArea_;
+		err = -EINVAL;
+	}
+
+	ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP, &rect);
+	if (ret) {
+		LOG(CameraSensor, Warning)
+			<< "Failed to retrieve the sensor crop rectangle";
+		err = -EINVAL;
+	}
+
+	if (err) {
+		LOG(CameraSensor, Warning)
+			<< "The sensor kernel driver needs to be fixed";
+		LOG(CameraSensor, Warning)
+			<< "See Documentation/sensor_driver_requirements.rst in the libcamera sources for more information";
+	}
+
+	if (!bayerFormat_)
+		return 0;
+
+	/*
+	 * For raw sensors, make sure the sensor driver supports the controls
+	 * required by the CameraSensor class.
+	 */
+	static constexpr uint32_t mandatoryControls[] = {
+		V4L2_CID_ANALOGUE_GAIN,
+		V4L2_CID_EXPOSURE,
+		V4L2_CID_HBLANK,
+		V4L2_CID_PIXEL_RATE,
+		V4L2_CID_VBLANK,
+	};
+
+	err = 0;
+	for (uint32_t ctrl : mandatoryControls) {
+		if (!controls.count(ctrl)) {
+			LOG(CameraSensor, Error)
+				<< "Mandatory V4L2 control " << utils::hex(ctrl)
+				<< " not available";
+			err = -EINVAL;
+		}
+	}
+
+	if (err) {
+		LOG(CameraSensor, Error)
+			<< "The sensor kernel driver needs to be fixed";
+		LOG(CameraSensor, Error)
+			<< "See Documentation/sensor_driver_requirements.rst in the libcamera sources for more information";
+		return err;
+	}
+
+	return 0;
+}
+
+/*
+ * \brief Initialize properties that cannot be intialized by the
+ * regular initProperties() function for VIMC
+ */
+void CameraSensor::initVimcDefaultProperties()
+{
+	/* Use the largest supported size. */
+	pixelArraySize_ = sizes_.back();
+	activeArea_ = Rectangle(pixelArraySize_);
+}
+
+void CameraSensor::initStaticProperties()
+{
+	staticProps_ = CameraSensorProperties::get(model_);
+	if (!staticProps_)
+		return;
+
+	/* Register the properties retrieved from the sensor database. */
+	properties_.set(properties::UnitCellSize, staticProps_->unitCellSize);
+
+	initTestPatternModes();
+}
+
+void CameraSensor::initTestPatternModes()
+{
+	const auto &v4l2TestPattern = controls().find(V4L2_CID_TEST_PATTERN);
+	if (v4l2TestPattern == controls().end()) {
+		LOG(CameraSensor, Debug) << "V4L2_CID_TEST_PATTERN is not supported";
+		return;
+	}
+
+	const auto &testPatternModes = staticProps_->testPatternModes;
+	if (testPatternModes.empty()) {
+		/*
+		 * The camera sensor supports test patterns but we don't know
+		 * how to map them so this should be fixed.
+		 */
+		LOG(CameraSensor, Debug) << "No static test pattern map for \'"
+					 << model() << "\'";
+		return;
+	}
+
+	/*
+	 * Create a map that associates the V4L2 control index to the test
+	 * pattern mode by reversing the testPatternModes map provided by the
+	 * camera sensor properties. This makes it easier to verify if the
+	 * control index is supported in the below for loop that creates the
+	 * list of supported test patterns.
+	 */
+	std::map<int32_t, controls::draft::TestPatternModeEnum> indexToTestPatternMode;
+	for (const auto &it : testPatternModes)
+		indexToTestPatternMode[it.second] = it.first;
+
+	for (const ControlValue &value : v4l2TestPattern->second.values()) {
+		const int32_t index = value.get<int32_t>();
+
+		const auto it = indexToTestPatternMode.find(index);
+		if (it == indexToTestPatternMode.end()) {
+			LOG(CameraSensor, Debug)
+				<< "Test pattern mode " << index << " ignored";
+			continue;
+		}
+
+		testPatternModes_.push_back(it->second);
+	}
+}
+
+int CameraSensor::initProperties()
+{
+	model_ = subdev_->model();
+	properties_.set(properties::Model, utils::toAscii(model_));
+
+	/* Generate a unique ID for the sensor. */
+	int ret = generateId();
+	if (ret)
+		return ret;
+
+	/* Initialize the static properties from the sensor database. */
+	initStaticProperties();
+
+	/* Retrieve and register properties from the kernel interface. */
+	const ControlInfoMap &controls = subdev_->controls();
+
+	const auto &orientation = controls.find(V4L2_CID_CAMERA_ORIENTATION);
+	if (orientation != controls.end()) {
+		int32_t v4l2Orientation = orientation->second.def().get<int32_t>();
+		int32_t propertyValue;
+
+		switch (v4l2Orientation) {
+		default:
+			LOG(CameraSensor, Warning)
+				<< "Unsupported camera location "
+				<< v4l2Orientation << ", setting to External";
+			[[fallthrough]];
+		case V4L2_CAMERA_ORIENTATION_EXTERNAL:
+			propertyValue = properties::CameraLocationExternal;
+			break;
+		case V4L2_CAMERA_ORIENTATION_FRONT:
+			propertyValue = properties::CameraLocationFront;
+			break;
+		case V4L2_CAMERA_ORIENTATION_BACK:
+			propertyValue = properties::CameraLocationBack;
+			break;
+		}
+		properties_.set(properties::Location, propertyValue);
+	} else {
+		LOG(CameraSensor, Warning) << "Failed to retrieve the camera location";
+	}
+
+	const auto &rotationControl = controls.find(V4L2_CID_CAMERA_SENSOR_ROTATION);
+	if (rotationControl != controls.end()) {
+		int32_t propertyValue = rotationControl->second.def().get<int32_t>();
+
+		/*
+		 * Cache the Transform associated with the camera mounting
+		 * rotation for later use in computeTransform().
+		 */
+		bool success;
+		mountingOrientation_ = orientationFromRotation(propertyValue, &success);
+		if (!success) {
+			LOG(CameraSensor, Warning)
+				<< "Invalid rotation of " << propertyValue
+				<< " degrees - ignoring";
+			mountingOrientation_ = Orientation::Rotate0;
+		}
+
+		properties_.set(properties::Rotation, propertyValue);
+	} else {
+		LOG(CameraSensor, Warning)
+			<< "Rotation control not available, default to 0 degrees";
+		properties_.set(properties::Rotation, 0);
+		mountingOrientation_ = Orientation::Rotate0;
+	}
+
+	properties_.set(properties::PixelArraySize, pixelArraySize_);
+	properties_.set(properties::PixelArrayActiveAreas, { activeArea_ });
+
+	/* Color filter array pattern, register only for RAW sensors. */
+	if (bayerFormat_) {
+		int32_t cfa;
+		switch (bayerFormat_->order) {
+		case BayerFormat::BGGR:
+			cfa = properties::draft::BGGR;
+			break;
+		case BayerFormat::GBRG:
+			cfa = properties::draft::GBRG;
+			break;
+		case BayerFormat::GRBG:
+			cfa = properties::draft::GRBG;
+			break;
+		case BayerFormat::RGGB:
+			cfa = properties::draft::RGGB;
+			break;
+		case BayerFormat::MONO:
+			cfa = properties::draft::MONO;
+			break;
+		}
+
+		properties_.set(properties::draft::ColorFilterArrangement, cfa);
+	}
+
+	return 0;
+}
+
+/**
+ * \brief Check for and initialise any ancillary devices
+ *
+ * Sensors sometimes have ancillary devices such as a Lens or Flash that could
+ * be linked to their MediaEntity by the kernel. Search for and handle any
+ * such device.
+ *
+ * \todo Handle MEDIA_ENT_F_FLASH too.
+ */
+int CameraSensor::discoverAncillaryDevices()
+{
+	int ret;
+
+	for (MediaEntity *ancillary : entity_->ancillaryEntities()) {
+		switch (ancillary->function()) {
+		case MEDIA_ENT_F_LENS:
+			focusLens_ = std::make_unique<CameraLens>(ancillary);
+			ret = focusLens_->init();
+			if (ret) {
+				LOG(CameraSensor, Error)
+					<< "Lens initialisation failed, lens disabled";
+				focusLens_.reset();
+			}
+			break;
+
+		default:
+			LOG(CameraSensor, Warning)
+				<< "Unsupported ancillary entity function "
+				<< ancillary->function();
+			break;
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * \fn CameraSensor::model()
+ * \brief Retrieve the sensor model name
+ *
+ * The sensor model name is a free-formed string that uniquely identifies the
+ * sensor model.
+ *
+ * \return The sensor model name
+ */
+
+/**
+ * \fn CameraSensor::id()
+ * \brief Retrieve the sensor ID
+ *
+ * The sensor ID is a free-form string that uniquely identifies the sensor in
+ * the system. The ID satisfies the requirements to be used as a camera ID.
+ *
+ * \return The sensor ID
+ */
+
+/**
+ * \fn CameraSensor::entity()
+ * \brief Retrieve the sensor media entity
+ * \return The sensor media entity
+ */
+
+/**
+ * \fn CameraSensor::device()
+ * \brief Retrieve the camera sensor device
+ * \todo Remove this function by integrating DelayedControl with CameraSensor
+ * \return The camera sensor device
+ */
+
+/**
+ * \fn CameraSensor::focusLens()
+ * \brief Retrieve the focus lens controller
+ *
+ * \return The focus lens controller. nullptr if no focus lens controller is
+ * connected to the sensor
+ */
+
+/**
+ * \fn CameraSensor::mbusCodes()
+ * \brief Retrieve the media bus codes supported by the camera sensor
+ *
+ * Any Bayer formats are listed using the sensor's native Bayer order,
+ * that is, with the effect of V4L2_CID_HFLIP and V4L2_CID_VFLIP undone
+ * (where these controls exist).
+ *
+ * \return The supported media bus codes sorted in increasing order
+ */
+
+/**
+ * \brief Retrieve the supported frame sizes for a media bus code
+ * \param[in] mbusCode The media bus code for which sizes are requested
+ *
+ * \return The supported frame sizes for \a mbusCode sorted in increasing order
+ */
+std::vector<Size> CameraSensor::sizes(unsigned int mbusCode) const
+{
+	std::vector<Size> sizes;
+
+	const auto &format = formats_.find(mbusCode);
+	if (format == formats_.end())
+		return sizes;
+
+	const std::vector<SizeRange> &ranges = format->second;
+	std::transform(ranges.begin(), ranges.end(), std::back_inserter(sizes),
+		       [](const SizeRange &range) { return range.max; });
+
+	std::sort(sizes.begin(), sizes.end());
+
+	return sizes;
+}
+
+/**
+ * \brief Retrieve the camera sensor resolution
+ *
+ * The camera sensor resolution is the active pixel area size, clamped to the
+ * maximum frame size the sensor can produce if it is smaller than the active
+ * pixel area.
+ *
+ * \todo Consider if it desirable to distinguish between the maximum resolution
+ * the sensor can produce (also including upscaled ones) and the actual pixel
+ * array size by splitting this function in two.
+ *
+ * \return The camera sensor resolution in pixels
+ */
+Size CameraSensor::resolution() const
+{
+	return std::min(sizes_.back(), activeArea_.size());
+}
+
+/**
+ * \brief Retrieve the best sensor format for a desired output
+ * \param[in] mbusCodes The list of acceptable media bus codes
+ * \param[in] size The desired size
+ *
+ * Media bus codes are selected from \a mbusCodes, which lists all acceptable
+ * codes in decreasing order of preference. Media bus codes supported by the
+ * sensor but not listed in \a mbusCodes are ignored. If none of the desired
+ * codes is supported, it returns an error.
+ *
+ * \a size indicates the desired size at the output of the sensor. This function
+ * selects the best media bus code and size supported by the sensor according
+ * to the following criteria.
+ *
+ * - The desired \a size shall fit in the sensor output size to avoid the need
+ *   to up-scale.
+ * - The sensor output size shall match the desired aspect ratio to avoid the
+ *   need to crop the field of view.
+ * - The sensor output size shall be as small as possible to lower the required
+ *   bandwidth.
+ * - The desired \a size shall be supported by one of the media bus code listed
+ *   in \a mbusCodes.
+ *
+ * When multiple media bus codes can produce the same size, the code at the
+ * lowest position in \a mbusCodes is selected.
+ *
+ * The use of this function is optional, as the above criteria may not match the
+ * needs of all pipeline handlers. Pipeline handlers may implement custom
+ * sensor format selection when needed.
+ *
+ * The returned sensor output format is guaranteed to be acceptable by the
+ * setFormat() function without any modification.
+ *
+ * \return The best sensor output format matching the desired media bus codes
+ * and size on success, or an empty format otherwise.
+ */
+V4L2SubdeviceFormat CameraSensor::getFormat(const std::vector<unsigned int> &mbusCodes,
+					    const Size &size) const
+{
+	unsigned int desiredArea = size.width * size.height;
+	unsigned int bestArea = UINT_MAX;
+	float desiredRatio = static_cast<float>(size.width) / size.height;
+	float bestRatio = FLT_MAX;
+	const Size *bestSize = nullptr;
+	uint32_t bestCode = 0;
+
+	for (unsigned int code : mbusCodes) {
+		const auto formats = formats_.find(code);
+		if (formats == formats_.end())
+			continue;
+
+		for (const SizeRange &range : formats->second) {
+			const Size &sz = range.max;
+
+			if (sz.width < size.width || sz.height < size.height)
+				continue;
+
+			float ratio = static_cast<float>(sz.width) / sz.height;
+			float ratioDiff = fabsf(ratio - desiredRatio);
+			unsigned int area = sz.width * sz.height;
+			unsigned int areaDiff = area - desiredArea;
+
+			if (ratioDiff > bestRatio)
+				continue;
+
+			if (ratioDiff < bestRatio || areaDiff < bestArea) {
+				bestRatio = ratioDiff;
+				bestArea = areaDiff;
+				bestSize = &sz;
+				bestCode = code;
+			}
+		}
+	}
+
+	if (!bestSize) {
+		LOG(CameraSensor, Debug) << "No supported format or size found";
+		return {};
+	}
+
+	V4L2SubdeviceFormat format{
+		.code = bestCode,
+		.size = *bestSize,
+		.colorSpace = ColorSpace::Raw,
+	};
+
+	return format;
+}
+
+/**
+ * \brief Set the sensor output format
+ * \param[in] format The desired sensor output format
+ * \param[in] transform The transform to be applied on the sensor.
+ * Defaults to Identity.
+ *
+ * If flips are writable they are configured according to the desired Transform.
+ * Transform::Identity always corresponds to H/V flip being disabled if the
+ * controls are writable. Flips are set before the new format is applied as
+ * they can effectively change the Bayer pattern ordering.
+ *
+ * The ranges of any controls associated with the sensor are also updated.
+ *
+ * \return 0 on success or a negative error code otherwise
+ */
+int CameraSensor::setFormat(V4L2SubdeviceFormat *format, Transform transform)
+{
+	/* Configure flips if the sensor supports that. */
+	if (supportFlips_) {
+		ControlList flipCtrls(subdev_->controls());
+
+		flipCtrls.set(V4L2_CID_HFLIP,
+			      static_cast<int32_t>(!!(transform & Transform::HFlip)));
+		flipCtrls.set(V4L2_CID_VFLIP,
+			      static_cast<int32_t>(!!(transform & Transform::VFlip)));
+
+		int ret = subdev_->setControls(&flipCtrls);
+		if (ret)
+			return ret;
+	}
+
+	/* Apply format on the subdev. */
+	int ret = subdev_->setFormat(pad_, format);
+	if (ret)
+		return ret;
+
+	subdev_->updateControlInfo();
+	return 0;
+}
+
+/**
+ * \brief Try the sensor output format
+ * \param[in] format The desired sensor output format
+ *
+ * The ranges of any controls associated with the sensor are not updated.
+ *
+ * \todo Add support for Transform by changing the format's Bayer ordering
+ * before calling subdev_->setFormat().
+ *
+ * \return 0 on success or a negative error code otherwise
+ */
+int CameraSensor::tryFormat(V4L2SubdeviceFormat *format) const
+{
+	return subdev_->setFormat(pad_, format,
+				  V4L2Subdevice::Whence::TryFormat);
+}
+
+/**
+ * \brief Apply a sensor configuration to the camera sensor
+ * \param[in] config The sensor configuration
+ * \param[in] transform The transform to be applied on the sensor.
+ * Defaults to Identity
+ * \param[out] sensorFormat Format applied to the sensor (optional)
+ *
+ * Apply to the camera sensor the configuration \a config.
+ *
+ * \todo The configuration shall be fully populated and if any of the fields
+ * specified cannot be applied exactly, an error code is returned.
+ *
+ * \return 0 if \a config is applied correctly to the camera sensor, a negative
+ * error code otherwise
+ */
+int CameraSensor::applyConfiguration(const SensorConfiguration &config,
+				     Transform transform,
+				     V4L2SubdeviceFormat *sensorFormat)
+{
+	if (!config.isValid()) {
+		LOG(CameraSensor, Error) << "Invalid sensor configuration";
+		return -EINVAL;
+	}
+
+	std::vector<unsigned int> filteredCodes;
+	std::copy_if(mbusCodes_.begin(), mbusCodes_.end(),
+		     std::back_inserter(filteredCodes),
+		     [&config](unsigned int mbusCode) {
+			     BayerFormat bayer = BayerFormat::fromMbusCode(mbusCode);
+			     if (bayer.bitDepth == config.bitDepth)
+				     return true;
+			     return false;
+		     });
+	if (filteredCodes.empty()) {
+		LOG(CameraSensor, Error)
+			<< "Cannot find any format with bit depth "
+			<< config.bitDepth;
+		return -EINVAL;
+	}
+
+	/*
+	 * Compute the sensor's data frame size by applying the cropping
+	 * rectangle, subsampling and output crop to the sensor's pixel array
+	 * size.
+	 *
+	 * \todo The actual size computation is for now ignored and only the
+	 * output size is considered. This implies that resolutions obtained
+	 * with two different cropping/subsampling will look identical and
+	 * only the first found one will be considered.
+	 */
+	V4L2SubdeviceFormat subdevFormat = {};
+	for (unsigned int code : filteredCodes) {
+		for (const Size &size : sizes(code)) {
+			if (size.width != config.outputSize.width ||
+			    size.height != config.outputSize.height)
+				continue;
+
+			subdevFormat.code = code;
+			subdevFormat.size = size;
+			break;
+		}
+	}
+	if (!subdevFormat.code) {
+		LOG(CameraSensor, Error) << "Invalid output size in sensor configuration";
+		return -EINVAL;
+	}
+
+	int ret = setFormat(&subdevFormat, transform);
+	if (ret)
+		return ret;
+
+	/*
+	 * Return to the caller the format actually applied to the sensor.
+	 * This is relevant if transform has changed the bayer pattern order.
+	 */
+	if (sensorFormat)
+		*sensorFormat = subdevFormat;
+
+	/* \todo Handle AnalogCrop. Most sensors do not support set_selection */
+	/* \todo Handle scaling in the digital domain. */
+
+	return 0;
+}
+
+/**
+ * \fn CameraSensor::properties()
+ * \brief Retrieve the camera sensor properties
+ * \return The list of camera sensor properties
+ */
+
+/**
+ * \brief Assemble and return the camera sensor info
+ * \param[out] info The camera sensor info
+ *
+ * This function fills \a info with information that describes the camera sensor
+ * and its current configuration. The information combines static data (such as
+ * the the sensor model or active pixel array size) and data specific to the
+ * current sensor configuration (such as the line length and pixel rate).
+ *
+ * Sensor information is only available for raw sensors. When called for a YUV
+ * sensor, this function returns -EINVAL.
+ *
+ * \return 0 on success, a negative error code otherwise
+ */
+int CameraSensor::sensorInfo(IPACameraSensorInfo *info) const
+{
+	if (!bayerFormat_)
+		return -EINVAL;
+
+	info->model = model();
+
+	/*
+	 * The active area size is a static property, while the crop
+	 * rectangle needs to be re-read as it depends on the sensor
+	 * configuration.
+	 */
+	info->activeAreaSize = { activeArea_.width, activeArea_.height };
+
+	/*
+	 * \todo Support for retreiving the crop rectangle is scheduled to
+	 * become mandatory. For the time being use the default value if it has
+	 * been initialized at sensor driver validation time.
+	 */
+	int ret = subdev_->getSelection(pad_, V4L2_SEL_TGT_CROP, &info->analogCrop);
+	if (ret) {
+		info->analogCrop = activeArea_;
+		LOG(CameraSensor, Warning)
+			<< "The analogue crop rectangle has been defaulted to the active area size";
+	}
+
+	/*
+	 * IPACameraSensorInfo::analogCrop::x and IPACameraSensorInfo::analogCrop::y
+	 * are defined relatively to the active pixel area, while V4L2's
+	 * TGT_CROP target is defined in respect to the full pixel array.
+	 *
+	 * Compensate it by subtracting the active area offset.
+	 */
+	info->analogCrop.x -= activeArea_.x;
+	info->analogCrop.y -= activeArea_.y;
+
+	/* The bit depth and image size depend on the currently applied format. */
+	V4L2SubdeviceFormat format{};
+	ret = subdev_->getFormat(pad_, &format);
+	if (ret)
+		return ret;
+
+	info->bitsPerPixel = MediaBusFormatInfo::info(format.code).bitsPerPixel;
+	info->outputSize = format.size;
+
+	std::optional<int32_t> cfa = properties_.get(properties::draft::ColorFilterArrangement);
+	info->cfaPattern = cfa ? *cfa : properties::draft::RGB;
+
+	/*
+	 * Retrieve the pixel rate, line length and minimum/maximum frame
+	 * duration through V4L2 controls. Support for the V4L2_CID_PIXEL_RATE,
+	 * V4L2_CID_HBLANK and V4L2_CID_VBLANK controls is mandatory.
+	 */
+	ControlList ctrls = subdev_->getControls({ V4L2_CID_PIXEL_RATE,
+						   V4L2_CID_HBLANK,
+						   V4L2_CID_VBLANK });
+	if (ctrls.empty()) {
+		LOG(CameraSensor, Error)
+			<< "Failed to retrieve camera info controls";
+		return -EINVAL;
+	}
+
+	info->pixelRate = ctrls.get(V4L2_CID_PIXEL_RATE).get<int64_t>();
+
+	const ControlInfo hblank = ctrls.infoMap()->at(V4L2_CID_HBLANK);
+	info->minLineLength = info->outputSize.width + hblank.min().get<int32_t>();
+	info->maxLineLength = info->outputSize.width + hblank.max().get<int32_t>();
+
+	const ControlInfo vblank = ctrls.infoMap()->at(V4L2_CID_VBLANK);
+	info->minFrameLength = info->outputSize.height + vblank.min().get<int32_t>();
+	info->maxFrameLength = info->outputSize.height + vblank.max().get<int32_t>();
+
+	return 0;
+}
+
+/**
+ * \brief Compute the Transform that gives the requested \a orientation
+ * \param[inout] orientation The desired image orientation
+ *
+ * This function computes the Transform that the pipeline handler should apply
+ * to the CameraSensor to obtain the requested \a orientation.
+ *
+ * The intended caller of this function is the validate() implementation of
+ * pipeline handlers, that pass in the application requested
+ * CameraConfiguration::orientation and obtain a Transform to apply to the
+ * camera sensor, likely at configure() time.
+ *
+ * If the requested \a orientation cannot be obtained, the \a orientation
+ * parameter is adjusted to report the current image orientation and
+ * Transform::Identity is returned.
+ *
+ * If the requested \a orientation can be obtained, the function computes a
+ * Transform and does not adjust \a orientation.
+ *
+ * Pipeline handlers are expected to verify if \a orientation has been
+ * adjusted by this function and set the CameraConfiguration::status to
+ * Adjusted accordingly.
+ *
+ * \return A Transform instance that applied to the CameraSensor produces images
+ * with \a orientation
+ */
+Transform CameraSensor::computeTransform(Orientation *orientation) const
+{
+	/*
+	 * If we cannot do any flips we cannot change the native camera mounting
+	 * orientation.
+	 */
+	if (!supportFlips_) {
+		*orientation = mountingOrientation_;
+		return Transform::Identity;
+	}
+
+	/*
+	 * Now compute the required transform to obtain 'orientation' starting
+	 * from the mounting rotation.
+	 *
+	 * As a note:
+	 * 	orientation / mountingOrientation_ = transform
+	 * 	mountingOrientation_ * transform = orientation
+	 */
+	Transform transform = *orientation / mountingOrientation_;
+
+	/*
+	 * If transform contains any Transpose we cannot do it, so adjust
+	 * 'orientation' to report the image native orientation and return Identity.
+	 */
+	if (!!(transform & Transform::Transpose)) {
+		*orientation = mountingOrientation_;
+		return Transform::Identity;
+	}
+
+	return transform;
+}
+
+/**
+ * \brief Compute the Bayer order that results from the given Transform
+ * \param[in] t The Transform to apply to the sensor
+ *
+ * Some sensors change their Bayer order when they are h-flipped or v-flipped.
+ * This function computes and returns the Bayer order that would result from the
+ * given transform applied to the sensor.
+ *
+ * This function is valid only when the sensor produces raw Bayer formats.
+ *
+ * \return The Bayer order produced by the sensor when the Transform is applied
+ */
+BayerFormat::Order CameraSensor::bayerOrder(Transform t) const
+{
+	/* Return a defined by meaningless value for non-Bayer sensors. */
+	if (!bayerFormat_)
+		return BayerFormat::Order::BGGR;
+
+	if (!flipsAlterBayerOrder_)
+		return bayerFormat_->order;
+
+	/*
+	 * Apply the transform to the native (i.e. untransformed) Bayer order,
+	 * using the rest of the Bayer format supplied by the caller.
+	 */
+	return bayerFormat_->transform(t).order;
+}
+
+/**
+ * \brief Retrieve the supported V4L2 controls and their information
+ *
+ * Control information is updated automatically to reflect the current sensor
+ * configuration when the setFormat() function is called, without invalidating
+ * any iterator on the ControlInfoMap.
+ *
+ * \return A map of the V4L2 controls supported by the sensor
+ */
+const ControlInfoMap &CameraSensor::controls() const
+{
+	return subdev_->controls();
+}
+
+/**
+ * \brief Read V4L2 controls from the sensor
+ * \param[in] ids The list of controls to read, specified by their ID
+ *
+ * This function reads the value of all controls contained in \a ids, and
+ * returns their values as a ControlList. The control identifiers are defined by
+ * the V4L2 specification (V4L2_CID_*).
+ *
+ * If any control in \a ids is not supported by the device, is disabled (i.e.
+ * has the V4L2_CTRL_FLAG_DISABLED flag set), or if any other error occurs
+ * during validation of the requested controls, no control is read and this
+ * function returns an empty control list.
+ *
+ * \sa V4L2Device::getControls()
+ *
+ * \return The control values in a ControlList on success, or an empty list on
+ * error
+ */
+ControlList CameraSensor::getControls(const std::vector<uint32_t> &ids)
+{
+	return subdev_->getControls(ids);
+}
+
+/**
+ * \brief Write V4L2 controls to the sensor
+ * \param[in] ctrls The list of controls to write
+ *
+ * This function writes the value of all controls contained in \a ctrls, and
+ * stores the values actually applied to the device in the corresponding \a
+ * ctrls entry. The control identifiers are defined by the V4L2 specification
+ * (V4L2_CID_*).
+ *
+ * If any control in \a ctrls is not supported by the device, is disabled (i.e.
+ * has the V4L2_CTRL_FLAG_DISABLED flag set), is read-only, or if any other
+ * error occurs during validation of the requested controls, no control is
+ * written and this function returns -EINVAL.
+ *
+ * If an error occurs while writing the controls, the index of the first
+ * control that couldn't be written is returned. All controls below that index
+ * are written and their values are updated in \a ctrls, while all other
+ * controls are not written and their values are not changed.
+ *
+ * \sa V4L2Device::setControls()
+ *
+ * \return 0 on success or an error code otherwise
+ * \retval -EINVAL One of the control is not supported or not accessible
+ * \retval i The index of the control that failed
+ */
+int CameraSensor::setControls(ControlList *ctrls)
+{
+	return subdev_->setControls(ctrls);
+}
+
+/**
+ * \fn CameraSensor::testPatternModes()
+ * \brief Retrieve all the supported test pattern modes of the camera sensor
+ * The test pattern mode values correspond to the controls::TestPattern control.
+ *
+ * \return The list of test pattern modes
+ */
+
+/**
+ * \brief Set the test pattern mode for the camera sensor
+ * \param[in] mode The test pattern mode
+ *
+ * The new \a mode is applied to the sensor if it differs from the active test
+ * pattern mode. Otherwise, this function is a no-op. Setting the same test
+ * pattern mode for every frame thus incurs no performance penalty.
+ */
+int CameraSensor::setTestPatternMode(controls::draft::TestPatternModeEnum mode)
+{
+	if (testPatternMode_ == mode)
+		return 0;
+
+	if (testPatternModes_.empty()) {
+		LOG(CameraSensor, Error)
+			<< "Camera sensor does not support test pattern modes.";
+		return -EINVAL;
+	}
+
+	return applyTestPatternMode(mode);
+}
+
+int CameraSensor::applyTestPatternMode(controls::draft::TestPatternModeEnum mode)
+{
+	if (testPatternModes_.empty())
+		return 0;
+
+	auto it = std::find(testPatternModes_.begin(), testPatternModes_.end(),
+			    mode);
+	if (it == testPatternModes_.end()) {
+		LOG(CameraSensor, Error) << "Unsupported test pattern mode "
+					 << mode;
+		return -EINVAL;
+	}
+
+	LOG(CameraSensor, Debug) << "Apply test pattern mode " << mode;
+
+	int32_t index = staticProps_->testPatternModes.at(mode);
+	ControlList ctrls{ controls() };
+	ctrls.set(V4L2_CID_TEST_PATTERN, index);
+
+	int ret = setControls(&ctrls);
+	if (ret)
+		return ret;
+
+	testPatternMode_ = mode;
+
+	return 0;
+}
+
+std::string CameraSensor::logPrefix() const
+{
+	return "'" + entity_->name() + "'";
+}
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/sensor/camera_sensor_properties.cpp 0.3.0-1/src/libcamera/sensor/camera_sensor_properties.cpp
--- 0.2.0-3/src/libcamera/sensor/camera_sensor_properties.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/sensor/camera_sensor_properties.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,284 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2021, Google Inc.
+ *
+ * Database of camera sensor properties
+ */
+
+#include "libcamera/internal/camera_sensor_properties.h"
+
+#include <map>
+
+#include <libcamera/base/log.h>
+
+#include <libcamera/control_ids.h>
+
+/**
+ * \file camera_sensor_properties.h
+ * \brief Database of camera sensor properties
+ *
+ * The database of camera sensor properties collects static information about
+ * camera sensors that is not possible or desirable to retrieve from the device
+ * at run time.
+ *
+ * The database is indexed using the camera sensor model, as reported by the
+ * properties::Model property, and for each supported sensor it contains a
+ * list of properties.
+ */
+
+namespace libcamera {
+
+LOG_DEFINE_CATEGORY(CameraSensorProperties)
+
+/**
+ * \struct CameraSensorProperties
+ * \brief Database of camera sensor properties
+ *
+ * \var CameraSensorProperties::unitCellSize
+ * \brief The physical size of a pixel, including pixel edges, in nanometers.
+ *
+ * \var CameraSensorProperties::testPatternModes
+ * \brief Map that associates the TestPattern control value with the indexes of
+ * the corresponding sensor test pattern modes as returned by
+ * V4L2_CID_TEST_PATTERN.
+ */
+
+/**
+ * \brief Retrieve the properties associated with a sensor
+ * \param sensor The sensor model name as reported by properties::Model
+ * \return A pointer to the CameraSensorProperties instance associated with a sensor
+ * or nullptr if the sensor is not supported
+ */
+const CameraSensorProperties *CameraSensorProperties::get(const std::string &sensor)
+{
+	static const std::map<std::string, const CameraSensorProperties> sensorProps = {
+		{ "ar0521", {
+			.unitCellSize = { 2200, 2200 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeSolidColor, 1 },
+				{ controls::draft::TestPatternModeColorBars, 2 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
+			},
+		} },
+		{ "hi846", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeSolidColor, 1 },
+				{ controls::draft::TestPatternModeColorBars, 2 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
+				{ controls::draft::TestPatternModePn9, 4 },
+				/*
+				 * No corresponding test pattern mode for:
+				 * 5: "Gradient Horizontal"
+				 * 6: "Gradient Vertical"
+				 * 7: "Check Board"
+				 * 8: "Slant Pattern"
+				 * 9: "Resolution Pattern"
+				 */
+			},
+		} },
+		{ "imx219", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+				{ controls::draft::TestPatternModeSolidColor, 2 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
+				{ controls::draft::TestPatternModePn9, 4 },
+			},
+		} },
+		{ "imx258", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeSolidColor, 1 },
+				{ controls::draft::TestPatternModeColorBars, 2 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
+				{ controls::draft::TestPatternModePn9, 4 },
+			},
+		} },
+		{ "imx283", {
+			.unitCellSize = { 2400, 2400 },
+			.testPatternModes = {},
+		} },
+		{ "imx290", {
+			.unitCellSize = { 2900, 2900 },
+			.testPatternModes = {},
+		} },
+		{ "imx296", {
+			.unitCellSize = { 3450, 3450 },
+			.testPatternModes = {},
+		} },
+		{ "imx327", {
+			.unitCellSize = { 2900, 2900 },
+			.testPatternModes = {},
+		} },
+		{ "imx335", {
+			.unitCellSize = { 2000, 2000 },
+			.testPatternModes = {},
+		} },
+		{ "imx415", {
+			.unitCellSize = { 1450, 1450 },
+			.testPatternModes = {},
+		} },
+		{ "imx477", {
+			.unitCellSize = { 1550, 1550 },
+			.testPatternModes = {},
+		} },
+		{ "imx519", {
+			.unitCellSize = { 1220, 1220 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeSolidColor, 2 },
+				{ controls::draft::TestPatternModePn9, 4 },
+				/*
+				 * The driver reports ColorBars and ColorBarsFadeToGray as well but
+				 * these two patterns do not comply with MIPI CCS v1.1 (Section 10.1).
+				 */
+			},
+		} },
+		{ "imx708", {
+			.unitCellSize = { 1400, 1400 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+				{ controls::draft::TestPatternModeSolidColor, 2 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 3 },
+				{ controls::draft::TestPatternModePn9, 4 },
+			},
+		} },
+		{ "ov2685", {
+			.unitCellSize = { 1750, 1750 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1},
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2 },
+				/*
+				 * No corresponding test pattern mode for:
+				 * 3: "Random Data"
+				 * 4: "Black White Square"
+				 * 5: "Color Square"
+				 */
+			},
+		} },
+		{ "ov2740", {
+			.unitCellSize = { 1400, 1400 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1},
+			},
+		} },
+		{ "ov4689", {
+			.unitCellSize = { 2000, 2000 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1},
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2},
+				/*
+				 * No corresponding test patterns in
+				 * MIPI CCS specification for sensor's
+				 * colorBarType2 and colorBarType3.
+				 */
+			},
+		} },
+		{ "ov5640", {
+			.unitCellSize = { 1400, 1400 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+			},
+		} },
+		{ "ov5647", {
+			.unitCellSize = { 1400, 1400 },
+			.testPatternModes = {},
+		} },
+		{ "ov5670", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+			},
+		} },
+		{ "ov5675", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+			},
+		} },
+		{ "ov5693", {
+			.unitCellSize = { 1400, 1400 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 2 },
+				/*
+				 * No corresponding test pattern mode for
+				 * 1: "Random data" and 3: "Colour Bars with
+				 * Rolling Bar".
+				 */
+			},
+		} },
+		{ "ov64a40", {
+			.unitCellSize = { 1008, 1008 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2 },
+				/*
+				 * No corresponding test patter mode
+				 * 3: "Vertical Color Bar Type 3",
+				 * 4: "Vertical Color Bar Type 4"
+				 */
+			},
+		} },
+		{ "ov8858", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+				{ controls::draft::TestPatternModeColorBarsFadeToGray, 2 },
+				/*
+				 * No corresponding test patter mode
+				 * 3: "Vertical Color Bar Type 3",
+				 * 4: "Vertical Color Bar Type 4"
+				 */
+			},
+		} },
+		{ "ov8865", {
+			.unitCellSize = { 1400, 1400 },
+			.testPatternModes = {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 2 },
+				/*
+				 * No corresponding test pattern mode for:
+				 * 1: "Random data"
+				 * 3: "Color bars with rolling bar"
+				 * 4: "Color squares"
+				 * 5: "Color squares with rolling bar"
+				 */
+			},
+		} },
+		{ "ov13858", {
+			.unitCellSize = { 1120, 1120 },
+			.testPatternModes =  {
+				{ controls::draft::TestPatternModeOff, 0 },
+				{ controls::draft::TestPatternModeColorBars, 1 },
+			},
+		} },
+	};
+
+	const auto it = sensorProps.find(sensor);
+	if (it == sensorProps.end()) {
+		LOG(CameraSensorProperties, Warning)
+			<< "No static properties available for '" << sensor << "'";
+		LOG(CameraSensorProperties, Warning)
+			<< "Please consider updating the camera sensor properties database";
+		return nullptr;
+	}
+
+	return &it->second;
+}
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/sensor/meson.build 0.3.0-1/src/libcamera/sensor/meson.build
--- 0.2.0-3/src/libcamera/sensor/meson.build	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/sensor/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,6 @@
+# SPDX-License-Identifier: CC0-1.0
+
+libcamera_sources += files([
+    'camera_sensor.cpp',
+    'camera_sensor_properties.cpp',
+])
diff -pruN 0.2.0-3/src/libcamera/shared_mem_object.cpp 0.3.0-1/src/libcamera/shared_mem_object.cpp
--- 0.2.0-3/src/libcamera/shared_mem_object.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/shared_mem_object.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,242 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023 Raspberry Pi Ltd
+ * Copyright (C) 2024 Andrei Konovalov
+ * Copyright (C) 2024 Dennis Bonke
+ * Copyright (C) 2024 Ideas on Board Oy
+ *
+ * Helpers for shared memory allocations
+ */
+
+#include "libcamera/internal/shared_mem_object.h"
+
+#include <stddef.h>
+#include <stdint.h>
+#include <sys/mman.h>
+#include <sys/syscall.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+/**
+ * \file shared_mem_object.cpp
+ * \brief Helpers for shared memory allocations
+ */
+
+namespace libcamera {
+
+/**
+ * \class SharedMem
+ * \brief Helper class to allocate and manage memory shareable between processes
+ *
+ * SharedMem manages memory suitable for sharing between processes. When an
+ * instance is constructed, it allocates a memory buffer of the requested size
+ * backed by an anonymous file, using the memfd API.
+ *
+ * The allocated memory is exposed by the mem() function. If memory allocation
+ * fails, the function returns an empty Span. This can be also checked using the
+ * bool() operator.
+ *
+ * The file descriptor for the backing file is exposed as a SharedFD by the fd()
+ * function. It can be shared with other processes across IPC boundaries, which
+ * can then map the memory with mmap().
+ *
+ * A single memfd is created for every SharedMem. If there is a need to allocate
+ * a large number of objects in shared memory, these objects should be grouped
+ * together and use the shared memory allocated by a single SharedMem object if
+ * possible. This will help to minimize the number of created memfd's.
+ */
+
+SharedMem::SharedMem() = default;
+
+/**
+ * \brief Construct a SharedMem with memory of the given \a size
+ * \param[in] name Name of the SharedMem
+ * \param[in] size Size of the shared memory to allocate and map
+ *
+ * The \a name is used for debugging purpose only. Multiple SharedMem instances
+ * can have the same name.
+ */
+SharedMem::SharedMem(const std::string &name, std::size_t size)
+{
+#if HAVE_MEMFD_CREATE
+	int fd = memfd_create(name.c_str(), MFD_CLOEXEC);
+#else
+	int fd = syscall(SYS_memfd_create, name.c_str(), MFD_CLOEXEC);
+#endif
+	if (fd < 0)
+		return;
+
+	fd_ = SharedFD(std::move(fd));
+	if (!fd_.isValid())
+		return;
+
+	if (ftruncate(fd_.get(), size) < 0) {
+		fd_ = SharedFD();
+		return;
+	}
+
+	void *mem = mmap(nullptr, size, PROT_READ | PROT_WRITE, MAP_SHARED,
+			 fd_.get(), 0);
+	if (mem == MAP_FAILED) {
+		fd_ = SharedFD();
+		return;
+	}
+
+	mem_ = { static_cast<uint8_t *>(mem), size };
+}
+
+/**
+ * \brief Move constructor for SharedMem
+ * \param[in] rhs The object to move
+ */
+SharedMem::SharedMem(SharedMem &&rhs)
+{
+	this->fd_ = std::move(rhs.fd_);
+	this->mem_ = rhs.mem_;
+	rhs.mem_ = {};
+}
+
+/**
+ * \brief Destroy the SharedMem instance
+ *
+ * Destroying an instance invalidates the memory mapping exposed with mem().
+ * Other mappings of the backing file, created in this or other processes with
+ * mmap(), remain valid.
+ *
+ * Similarly, other references to the backing file descriptor created by copying
+ * the SharedFD returned by fd() remain valid. The underlying memory will be
+ * freed only when all file descriptors that reference the anonymous file get
+ * closed.
+ */
+SharedMem::~SharedMem()
+{
+	if (!mem_.empty())
+		munmap(mem_.data(), mem_.size_bytes());
+}
+
+/**
+ * \brief Move assignment operator for SharedMem
+ * \param[in] rhs The object to move
+ */
+SharedMem &SharedMem::operator=(SharedMem &&rhs)
+{
+	this->fd_ = std::move(rhs.fd_);
+	this->mem_ = rhs.mem_;
+	rhs.mem_ = {};
+	return *this;
+}
+
+/**
+ * \fn const SharedFD &SharedMem::fd() const
+ * \brief Retrieve the file descriptor for the underlying shared memory
+ * \return The file descriptor, or an invalid SharedFD if allocation failed
+ */
+
+/**
+ * \fn Span<uint8_t> SharedMem::mem() const
+ * \brief Retrieve the underlying shared memory
+ * \return The memory buffer, or an empty Span if allocation failed
+ */
+
+/**
+ * \fn SharedMem::operator bool()
+ * \brief Check if the shared memory allocation succeeded
+ * \return True if allocation of the shared memory succeeded, false otherwise
+ */
+
+/**
+ * \class SharedMemObject
+ * \brief Helper class to allocate an object in shareable memory
+ * \tparam The object type
+ *
+ * The SharedMemObject class is a specialization of the SharedMem class that
+ * wraps an object of type \a T and constructs it in shareable memory. It uses
+ * the same underlying memory allocation and sharing mechanism as the SharedMem
+ * class.
+ *
+ * The wrapped object is constructed at the same time as the SharedMemObject
+ * instance, by forwarding the arguments passed to the SharedMemObject
+ * constructor. The underlying memory allocation is sized to the object \a T
+ * size. The bool() operator should be used to check the allocation was
+ * successful. The object can be accessed using the dereference operators
+ * operator*() and operator->().
+ *
+ * While no restriction on the type \a T is enforced, not all types are suitable
+ * for sharing between multiple processes. Most notably, any object type that
+ * contains pointer or reference members will likely cause issues. Even if those
+ * members refer to other members of the same object, the shared memory will be
+ * mapped at different addresses in different processes, and the pointers will
+ * not be valid.
+ *
+ * A new anonymous file is created for every SharedMemObject instance. If there
+ * is a need to share a large number of small objects, these objects should be
+ * grouped into a single larger object to limit the number of file descriptors.
+ *
+ * To share the object with other processes, see the SharedMem documentation.
+ */
+
+/**
+ * \var SharedMemObject::kSize
+ * \brief The size of the object stored in shared memory
+ */
+
+/**
+ * \fn SharedMemObject::SharedMemObject(const std::string &name, Args &&...args)
+ * \brief Construct a SharedMemObject
+ * \param[in] name Name of the SharedMemObject
+ * \param[in] args Arguments to pass to the constructor of the object T
+ *
+ * The \a name is used for debugging purpose only. Multiple SharedMem instances
+ * can have the same name.
+ */
+
+/**
+ * \fn SharedMemObject::SharedMemObject(SharedMemObject<T> &&rhs)
+ * \brief Move constructor for SharedMemObject
+ * \param[in] rhs The object to move
+ */
+
+/**
+ * \fn SharedMemObject::~SharedMemObject()
+ * \brief Destroy the SharedMemObject instance
+ *
+ * Destroying a SharedMemObject calls the wrapped T object's destructor. While
+ * the underlying memory may not be freed immediately if other mappings have
+ * been created manually (see SharedMem::~SharedMem() for more information), the
+ * stored object may be modified. Depending on the ~T() destructor, accessing
+ * the object after destruction of the SharedMemObject causes undefined
+ * behaviour. It is the responsibility of the user of this class to synchronize
+ * with other users who have access to the shared object.
+ */
+
+/**
+ * \fn SharedMemObject::operator=(SharedMemObject<T> &&rhs)
+ * \brief Move assignment operator for SharedMemObject
+ * \param[in] rhs The SharedMemObject object to take the data from
+ *
+ * Moving a SharedMemObject does not affect the stored object.
+ */
+
+/**
+ * \fn SharedMemObject::operator->()
+ * \brief Dereference the stored object
+ * \return Pointer to the stored object
+ */
+
+/**
+ * \fn const T *SharedMemObject::operator->() const
+ * \copydoc SharedMemObject::operator->
+ */
+
+/**
+ * \fn SharedMemObject::operator*()
+ * \brief Dereference the stored object
+ * \return Reference to the stored object
+ */
+
+/**
+ * \fn const T &SharedMemObject::operator*() const
+ * \copydoc SharedMemObject::operator*
+ */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/TODO 0.3.0-1/src/libcamera/software_isp/TODO
--- 0.2.0-3/src/libcamera/software_isp/TODO	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/TODO	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,279 @@
+1. Setting F_SEAL_SHRINK and F_SEAL_GROW after ftruncate()
+
+>> SharedMem::SharedMem(const std::string &name, std::size_t size)
+>> 	: name_(name), size_(size), mem_(nullptr)
+>>
+>> ...
+>>
+>> 	if (ftruncate(fd_.get(), size_) < 0)
+>> 		return;
+>
+> Should we set the GROW and SHRINK seals (in a separate patch) ?
+
+Yes, this can be done.
+Setting F_SEAL_SHRINK and F_SEAL_GROW after the ftruncate() call above could catch
+some potential errors related to improper access to the shared memory allocated by
+the SharedMemObject.
+
+---
+
+2. Reconsider stats sharing
+
+>>> +void SwStatsCpu::finishFrame(void)
+>>> +{
+>>> +	*sharedStats_ = stats_;
+>> 
+>> Is it more efficient to copy the stats instead of operating directly on
+>> the shared memory ?
+>
+> I inherited doing things this way from Andrey. I kept this because
+> we don't really have any synchronization with the IPA reading this.
+>
+> So the idea is to only touch this when the next set of statistics
+> is ready since we don't know when the IPA is done with accessing
+> the previous set of statistics ...
+>
+> This is both something which seems mostly a theoretic problem,
+> yet also definitely something which I think we need to fix.
+>
+> Maybe use a ringbuffer of stats buffers and pass the index into
+> the ringbuffer to the emit signal ?
+
+That would match how we deal with hardware ISPs, and I think that's a
+good idea. It will help decoupling the processing side from the IPA.
+
+---
+
+3. Remove statsReady signal
+
+> class SwStatsCpu
+> {
+> 	/**
+> 	 * \brief Signals that the statistics are ready
+> 	 */
+> 	Signal<> statsReady;
+
+But better, I wonder if the signal could be dropped completely. The
+SwStatsCpu class does not operate asynchronously. Shouldn't whoever
+calls the finishFrame() function then handle emitting the signal ?
+
+Now, the trouble is that this would be the DebayerCpu class, whose name
+doesn't indicate as a prime candidate to handle stats. However, it
+already exposes a getStatsFD() function, so we're already calling for
+trouble :-) Either that should be moved to somewhere else, or the class
+should be renamed. Considering that the class applies colour gains in
+addition to performing the interpolation, it may be more of a naming
+issue.
+
+Removing the signal and refactoring those classes doesn't have to be
+addressed now, I think it would be part of a larger refactoring
+(possibly also considering platforms that have no ISP but can produce
+stats in hardware, such as the i.MX7), but please keep it on your radar.
+
+---
+
+4. Hide internal representation of gains from callers
+
+> struct DebayerParams {
+> 	static constexpr unsigned int kGain10 = 256;
+
+Forcing the caller to deal with the internal representation of gains
+isn't nice, especially given that it precludes implementing gains of
+different precisions in different backend. Wouldn't it be better to pass
+the values as floating point numbers, and convert them to the internal
+representation in the implementation of process() before using them ?
+
+---
+
+5. Store ISP parameters in per-frame buffers
+
+> /**
+>  * \fn void Debayer::process(FrameBuffer *input, FrameBuffer *output, DebayerParams params)
+>  * \brief Process the bayer data into the requested format.
+>  * \param[in] input The input buffer.
+>  * \param[in] output The output buffer.
+>  * \param[in] params The parameters to be used in debayering.
+>  *
+>  * \note DebayerParams is passed by value deliberately so that a copy is passed
+>  * when this is run in another thread by invokeMethod().
+>  */
+
+Possibly something to address later, by storing ISP parameters in
+per-frame buffers like we do for hardware ISPs.
+
+---
+
+6. Input buffer copying configuration
+
+> DebayerCpu::DebayerCpu(std::unique_ptr<SwStatsCpu> stats)
+> 	: stats_(std::move(stats)), gammaCorrection_(1.0)
+> {
+> 	enableInputMemcpy_ = true;
+
+Set this appropriately and/or make it configurable.
+
+---
+
+7. Performance measurement configuration
+
+> void DebayerCpu::process(FrameBuffer *input, FrameBuffer *output, DebayerParams params)
+> /* Measure before emitting signals */
+> if (measuredFrames_ < DebayerCpu::kLastFrameToMeasure &&
+>     ++measuredFrames_ > DebayerCpu::kFramesToSkip) {
+> 	timespec frameEndTime = {};
+> 	clock_gettime(CLOCK_MONOTONIC_RAW, &frameEndTime);
+> 	frameProcessTime_ += timeDiff(frameEndTime, frameStartTime);
+> 	if (measuredFrames_ == DebayerCpu::kLastFrameToMeasure) {
+> 		const unsigned int measuredFrames = DebayerCpu::kLastFrameToMeasure -
+> 						    DebayerCpu::kFramesToSkip;
+> 		LOG(Debayer, Info)
+> 			<< "Processed " << measuredFrames
+> 			<< " frames in " << frameProcessTime_ / 1000 << "us, "
+> 			<< frameProcessTime_ / (1000 * measuredFrames)
+> 			<< " us/frame";
+> 	}
+> }
+
+I wonder if there would be a way to control at runtime when/how to
+perform those measurements. Maybe that's a bit overkill.
+
+---
+
+8. DebayerCpu cleanups
+
+> >> class DebayerCpu : public Debayer, public Object
+> >>   const SharedFD &getStatsFD() { return stats_->getStatsFD(); }
+> >
+> > This,
+>
+> Note the statistics pass-through stuff is sort of a necessary evil
+> since we want one main loop going over the data line by line and
+> doing both debayering as well as stats while the line is still
+> hot in the l2 cache. And things like the process2() and process4()
+> loops are highly CPU debayering specific so I don't think we should
+> move those out of the CpuDebayer code.
+
+Yes, that I understood from the review. "necessary evil" is indeed the
+right term :-) I expect it will take quite some design skills to balance
+the need for performances and the need for a maintainable architecture.
+
+> > plus the fact that this class handles colour gains and gamma,
+> > makes me thing we have either a naming issue, or an architecture issue.
+>
+> I agree that this does a bit more then debayering, although
+> the debayering really is the main thing it does.
+>
+> I guess the calculation of the rgb lookup tables which do the
+> color gains and gamma could be moved outside of this class,
+> that might even be beneficial for GPU based debayering assuming
+> that that is going to use rgb lookup tables too (it could
+> implement actual color gains + gamma correction in some different
+> way).
+>
+> I think this falls under the lets wait until we have a GPU
+> based SoftISP MVP/POC and then do some refactoring to see which
+> bits should go where.
+
+---
+
+8. Decouple pipeline and IPA naming
+
+> The current src/ipa/meson.build assumes the IPA name to match the
+> pipeline name. For this reason "-Dipas=simple" is used for the
+> Soft IPA module.
+
+This should be addressed.
+
+---
+
+9. Doxyfile cleanup
+
+>> diff --git a/Documentation/Doxyfile.in b/Documentation/Doxyfile.in
+>> index a86ea6c1..2be8d47b 100644
+>> --- a/Documentation/Doxyfile.in
+>> +++ b/Documentation/Doxyfile.in
+>> @@ -44,6 +44,7 @@ EXCLUDE                = @TOP_SRCDIR@/include/libcamera/base/span.h \
+>>                            @TOP_SRCDIR@/src/libcamera/pipeline/ \
+>>                            @TOP_SRCDIR@/src/libcamera/tracepoints.cpp \
+>>                            @TOP_BUILDDIR@/include/libcamera/internal/tracepoints.h \
+>> +                         @TOP_BUILDDIR@/include/libcamera/ipa/soft_ipa_interface.h \
+> Why is this needed ?
+>
+>>                            @TOP_BUILDDIR@/src/libcamera/proxy/
+>>     EXCLUDE_PATTERNS       = @TOP_BUILDDIR@/include/libcamera/ipa/*_serializer.h \
+>> diff --git a/include/libcamera/ipa/meson.build b/include/libcamera/ipa/meson.build
+>> index f3b4881c..3352d08f 100644
+>> --- a/include/libcamera/ipa/meson.build
+>> +++ b/include/libcamera/ipa/meson.build
+>> @@ -65,6 +65,7 @@ pipeline_ipa_mojom_mapping = {
+>>       'ipu3': 'ipu3.mojom',
+>>       'rkisp1': 'rkisp1.mojom',
+>>       'rpi/vc4': 'raspberrypi.mojom',
+>> +    'simple': 'soft.mojom',
+>>       'vimc': 'vimc.mojom',
+>>   }
+>>   diff --git a/include/libcamera/ipa/soft.mojom b/include/libcamera/ipa/soft.mojom
+>> new file mode 100644
+>> index 00000000..c249bd75
+>> --- /dev/null
+>> +++ b/include/libcamera/ipa/soft.mojom
+>> @@ -0,0 +1,28 @@
+>> +/* SPDX-License-Identifier: LGPL-2.1-or-later */
+>> +
+>> +/*
+>> + * \todo Document the interface and remove the related EXCLUDE_PATTERNS entry.
+> Ah that's why.
+
+Yes, because, well... all the other IPAs were doing that...
+
+> It doesn't have to be done before merging, but could you
+> address this sooner than later ?
+
+---
+
+10. Switch to libipa/algorithm.h API in processStats
+
+>> void IPASoftSimple::processStats(const ControlList &sensorControls)
+>>
+> Do you envision switching to the libipa/algorithm.h API at some point ?
+
+At some point, yes.
+
+---
+
+11. Improve handling the sensor controls which take effect with a delay
+
+> void IPASoftSimple::processStats(const ControlList &sensorControls)
+> {
+>       ...
+>	/*
+>	 * AE / AGC, use 2 frames delay to make sure that the exposure and
+>	 * the gain set have applied to the camera sensor.
+>	 */
+>	if (ignore_updates_ > 0) {
+>		--ignore_updates_;
+>		return;
+>	}
+
+This could be handled better with DelayedControls.
+
+---
+
+12. Use DelayedControls class in ispStatsReady()
+
+> void SimpleCameraData::ispStatsReady()
+> {
+> 	swIsp_->processStats(sensor_->getControls({ V4L2_CID_ANALOGUE_GAIN,
+> 						    V4L2_CID_EXPOSURE }));
+
+You should use the DelayedControls class.
+
+---
+
+13. Improve black level and colour gains application
+
+I think the black level should eventually be moved before debayering, and
+ideally the colour gains as well. I understand the need for optimizations to
+lower the CPU consumption, but at the same time I don't feel comfortable
+building up on top of an implementation that may work a bit more by chance than
+by correctness, as that's not very maintainable.
diff -pruN 0.2.0-3/src/libcamera/software_isp/debayer.cpp 0.3.0-1/src/libcamera/software_isp/debayer.cpp
--- 0.2.0-3/src/libcamera/software_isp/debayer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/debayer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,132 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * debayer base class
+ */
+
+#include "debayer.h"
+
+namespace libcamera {
+
+/**
+ * \struct DebayerParams
+ * \brief Struct to hold the debayer parameters.
+ */
+
+/**
+ * \var DebayerParams::kGain10
+ * \brief const value for 1.0 gain
+ */
+
+/**
+ * \var DebayerParams::gainR
+ * \brief Red gain
+ *
+ * 128 = 0.5, 256 = 1.0, 512 = 2.0, etc.
+ */
+
+/**
+ * \var DebayerParams::gainG
+ * \brief Green gain
+ *
+ * 128 = 0.5, 256 = 1.0, 512 = 2.0, etc.
+ */
+
+/**
+ * \var DebayerParams::gainB
+ * \brief Blue gain
+ *
+ * 128 = 0.5, 256 = 1.0, 512 = 2.0, etc.
+ */
+
+/**
+ * \var DebayerParams::gamma
+ * \brief Gamma correction, 1.0 is no correction
+ */
+
+/**
+ * \class Debayer
+ * \brief Base debayering class
+ *
+ * Base class that provides functions for setting up the debayering process.
+ */
+
+LOG_DEFINE_CATEGORY(Debayer)
+
+Debayer::~Debayer()
+{
+}
+
+/**
+ * \fn int Debayer::configure(const StreamConfiguration &inputCfg, const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfgs)
+ * \brief Configure the debayer object according to the passed in parameters.
+ * \param[in] inputCfg The input configuration.
+ * \param[in] outputCfgs The output configurations.
+ *
+ * \return 0 on success, a negative errno on failure.
+ */
+
+/**
+ * \fn Size Debayer::patternSize(PixelFormat inputFormat)
+ * \brief Get the width and height at which the bayer pattern repeats.
+ * \param[in] inputFormat The input format.
+ *
+ * Valid sizes are: 2x2, 4x2 or 4x4.
+ *
+ * \return Pattern size or an empty size for unsupported inputFormats.
+ */
+
+/**
+ * \fn std::vector<PixelFormat> Debayer::formats(PixelFormat inputFormat)
+ * \brief Get the supported output formats.
+ * \param[in] inputFormat The input format.
+ *
+ * \return All supported output formats or an empty vector if there are none.
+ */
+
+/**
+ * \fn std::tuple<unsigned int, unsigned int> Debayer::strideAndFrameSize(const PixelFormat &outputFormat, const Size &size)
+ * \brief Get the stride and the frame size.
+ * \param[in] outputFormat The output format.
+ * \param[in] size The output size.
+ *
+ * \return A tuple of the stride and the frame size, or a tuple with 0,0 if
+ *    there is no valid output config.
+ */
+
+/**
+ * \fn void Debayer::process(FrameBuffer *input, FrameBuffer *output, DebayerParams params)
+ * \brief Process the bayer data into the requested format.
+ * \param[in] input The input buffer.
+ * \param[in] output The output buffer.
+ * \param[in] params The parameters to be used in debayering.
+ *
+ * \note DebayerParams is passed by value deliberately so that a copy is passed
+ * when this is run in another thread by invokeMethod().
+ */
+
+/**
+ * \fn virtual SizeRange Debayer::sizes(PixelFormat inputFormat, const Size &inputSize)
+ * \brief Get the supported output sizes for the given input format and size.
+ * \param[in] inputFormat The input format.
+ * \param[in] inputSize The input size.
+ *
+ * \return The valid size ranges or an empty range if there are none.
+ */
+
+/**
+ * \var Signal<FrameBuffer *> Debayer::inputBufferReady
+ * \brief Signals when the input buffer is ready.
+ */
+
+/**
+ * \var Signal<FrameBuffer *> Debayer::outputBufferReady
+ * \brief Signals when the output buffer is ready.
+ */
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/debayer.h 0.3.0-1/src/libcamera/software_isp/debayer.h
--- 0.2.0-3/src/libcamera/software_isp/debayer.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/debayer.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,54 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * debayering base class
+ */
+
+#pragma once
+
+#include <stdint.h>
+
+#include <libcamera/base/log.h>
+#include <libcamera/base/signal.h>
+
+#include <libcamera/geometry.h>
+#include <libcamera/stream.h>
+
+#include "libcamera/internal/software_isp/debayer_params.h"
+
+namespace libcamera {
+
+class FrameBuffer;
+
+LOG_DECLARE_CATEGORY(Debayer)
+
+class Debayer
+{
+public:
+	virtual ~Debayer() = 0;
+
+	virtual int configure(const StreamConfiguration &inputCfg,
+			      const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfgs) = 0;
+
+	virtual std::vector<PixelFormat> formats(PixelFormat inputFormat) = 0;
+
+	virtual std::tuple<unsigned int, unsigned int>
+	strideAndFrameSize(const PixelFormat &outputFormat, const Size &size) = 0;
+
+	virtual void process(FrameBuffer *input, FrameBuffer *output, DebayerParams params) = 0;
+
+	virtual SizeRange sizes(PixelFormat inputFormat, const Size &inputSize) = 0;
+
+	Signal<FrameBuffer *> inputBufferReady;
+	Signal<FrameBuffer *> outputBufferReady;
+
+private:
+	virtual Size patternSize(PixelFormat inputFormat) = 0;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/debayer_cpu.cpp 0.3.0-1/src/libcamera/software_isp/debayer_cpu.cpp
--- 0.2.0-3/src/libcamera/software_isp/debayer_cpu.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/debayer_cpu.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,807 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * CPU based debayering class
+ */
+
+#include "debayer_cpu.h"
+
+#include <math.h>
+#include <stdlib.h>
+#include <time.h>
+
+#include <libcamera/formats.h>
+
+#include "libcamera/internal/bayer_format.h"
+#include "libcamera/internal/framebuffer.h"
+#include "libcamera/internal/mapped_framebuffer.h"
+
+namespace libcamera {
+
+/**
+ * \class DebayerCpu
+ * \brief Class for debayering on the CPU
+ *
+ * Implementation for CPU based debayering
+ */
+
+/**
+ * \brief Constructs a DebayerCpu object
+ * \param[in] stats Pointer to the stats object to use
+ */
+DebayerCpu::DebayerCpu(std::unique_ptr<SwStatsCpu> stats)
+	: stats_(std::move(stats)), gammaCorrection_(1.0), blackLevel_(0)
+{
+	/*
+	 * Reading from uncached buffers may be very slow.
+	 * In such a case, it's better to copy input buffer data to normal memory.
+	 * But in case of cached buffers, copying the data is unnecessary overhead.
+	 * enable_input_memcpy_ makes this behavior configurable.  At the moment, we
+	 * always set it to true as the safer choice but this should be changed in
+	 * future.
+	 */
+	enableInputMemcpy_ = true;
+
+	/* Initialize gamma to 1.0 curve */
+	for (unsigned int i = 0; i < kGammaLookupSize; i++)
+		gamma_[i] = i / (kGammaLookupSize / kRGBLookupSize);
+
+	for (unsigned int i = 0; i < kMaxLineBuffers; i++)
+		lineBuffers_[i] = nullptr;
+}
+
+DebayerCpu::~DebayerCpu()
+{
+	for (unsigned int i = 0; i < kMaxLineBuffers; i++)
+		free(lineBuffers_[i]);
+}
+
+#define DECLARE_SRC_POINTERS(pixel_t)                            \
+	const pixel_t *prev = (const pixel_t *)src[0] + xShift_; \
+	const pixel_t *curr = (const pixel_t *)src[1] + xShift_; \
+	const pixel_t *next = (const pixel_t *)src[2] + xShift_;
+
+/*
+ * RGR
+ * GBG
+ * RGR
+ */
+#define BGGR_BGR888(p, n, div)                                                                \
+	*dst++ = blue_[curr[x] / (div)];                                                      \
+	*dst++ = green_[(prev[x] + curr[x - p] + curr[x + n] + next[x]) / (4 * (div))];       \
+	*dst++ = red_[(prev[x - p] + prev[x + n] + next[x - p] + next[x + n]) / (4 * (div))]; \
+	x++;
+
+/*
+ * GBG
+ * RGR
+ * GBG
+ */
+#define GRBG_BGR888(p, n, div)                                    \
+	*dst++ = blue_[(prev[x] + next[x]) / (2 * (div))];        \
+	*dst++ = green_[curr[x] / (div)];                         \
+	*dst++ = red_[(curr[x - p] + curr[x + n]) / (2 * (div))]; \
+	x++;
+
+/*
+ * GRG
+ * BGB
+ * GRG
+ */
+#define GBRG_BGR888(p, n, div)                                     \
+	*dst++ = blue_[(curr[x - p] + curr[x + n]) / (2 * (div))]; \
+	*dst++ = green_[curr[x] / (div)];                          \
+	*dst++ = red_[(prev[x] + next[x]) / (2 * (div))];          \
+	x++;
+
+/*
+ * BGB
+ * GRG
+ * BGB
+ */
+#define RGGB_BGR888(p, n, div)                                                                 \
+	*dst++ = blue_[(prev[x - p] + prev[x + n] + next[x - p] + next[x + n]) / (4 * (div))]; \
+	*dst++ = green_[(prev[x] + curr[x - p] + curr[x + n] + next[x]) / (4 * (div))];        \
+	*dst++ = red_[curr[x] / (div)];                                                        \
+	x++;
+
+void DebayerCpu::debayer8_BGBG_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	DECLARE_SRC_POINTERS(uint8_t)
+
+	for (int x = 0; x < (int)window_.width;) {
+		BGGR_BGR888(1, 1, 1)
+		GBRG_BGR888(1, 1, 1)
+	}
+}
+
+void DebayerCpu::debayer8_GRGR_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	DECLARE_SRC_POINTERS(uint8_t)
+
+	for (int x = 0; x < (int)window_.width;) {
+		GRBG_BGR888(1, 1, 1)
+		RGGB_BGR888(1, 1, 1)
+	}
+}
+
+void DebayerCpu::debayer10_BGBG_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	DECLARE_SRC_POINTERS(uint16_t)
+
+	for (int x = 0; x < (int)window_.width;) {
+		/* divide values by 4 for 10 -> 8 bpp value */
+		BGGR_BGR888(1, 1, 4)
+		GBRG_BGR888(1, 1, 4)
+	}
+}
+
+void DebayerCpu::debayer10_GRGR_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	DECLARE_SRC_POINTERS(uint16_t)
+
+	for (int x = 0; x < (int)window_.width;) {
+		/* divide values by 4 for 10 -> 8 bpp value */
+		GRBG_BGR888(1, 1, 4)
+		RGGB_BGR888(1, 1, 4)
+	}
+}
+
+void DebayerCpu::debayer12_BGBG_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	DECLARE_SRC_POINTERS(uint16_t)
+
+	for (int x = 0; x < (int)window_.width;) {
+		/* divide values by 16 for 12 -> 8 bpp value */
+		BGGR_BGR888(1, 1, 16)
+		GBRG_BGR888(1, 1, 16)
+	}
+}
+
+void DebayerCpu::debayer12_GRGR_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	DECLARE_SRC_POINTERS(uint16_t)
+
+	for (int x = 0; x < (int)window_.width;) {
+		/* divide values by 16 for 12 -> 8 bpp value */
+		GRBG_BGR888(1, 1, 16)
+		RGGB_BGR888(1, 1, 16)
+	}
+}
+
+void DebayerCpu::debayer10P_BGBG_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	const int widthInBytes = window_.width * 5 / 4;
+	const uint8_t *prev = src[0];
+	const uint8_t *curr = src[1];
+	const uint8_t *next = src[2];
+
+	/*
+	 * For the first pixel getting a pixel from the previous column uses
+	 * x - 2 to skip the 5th byte with least-significant bits for 4 pixels.
+	 * Same for last pixel (uses x + 2) and looking at the next column.
+	 */
+	for (int x = 0; x < widthInBytes;) {
+		/* First pixel */
+		BGGR_BGR888(2, 1, 1)
+		/* Second pixel BGGR -> GBRG */
+		GBRG_BGR888(1, 1, 1)
+		/* Same thing for third and fourth pixels */
+		BGGR_BGR888(1, 1, 1)
+		GBRG_BGR888(1, 2, 1)
+		/* Skip 5th src byte with 4 x 2 least-significant-bits */
+		x++;
+	}
+}
+
+void DebayerCpu::debayer10P_GRGR_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	const int widthInBytes = window_.width * 5 / 4;
+	const uint8_t *prev = src[0];
+	const uint8_t *curr = src[1];
+	const uint8_t *next = src[2];
+
+	for (int x = 0; x < widthInBytes;) {
+		/* First pixel */
+		GRBG_BGR888(2, 1, 1)
+		/* Second pixel GRBG -> RGGB */
+		RGGB_BGR888(1, 1, 1)
+		/* Same thing for third and fourth pixels */
+		GRBG_BGR888(1, 1, 1)
+		RGGB_BGR888(1, 2, 1)
+		/* Skip 5th src byte with 4 x 2 least-significant-bits */
+		x++;
+	}
+}
+
+void DebayerCpu::debayer10P_GBGB_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	const int widthInBytes = window_.width * 5 / 4;
+	const uint8_t *prev = src[0];
+	const uint8_t *curr = src[1];
+	const uint8_t *next = src[2];
+
+	for (int x = 0; x < widthInBytes;) {
+		/* Even pixel */
+		GBRG_BGR888(2, 1, 1)
+		/* Odd pixel GBGR -> BGGR */
+		BGGR_BGR888(1, 1, 1)
+		/* Same thing for next 2 pixels */
+		GBRG_BGR888(1, 1, 1)
+		BGGR_BGR888(1, 2, 1)
+		/* Skip 5th src byte with 4 x 2 least-significant-bits */
+		x++;
+	}
+}
+
+void DebayerCpu::debayer10P_RGRG_BGR888(uint8_t *dst, const uint8_t *src[])
+{
+	const int widthInBytes = window_.width * 5 / 4;
+	const uint8_t *prev = src[0];
+	const uint8_t *curr = src[1];
+	const uint8_t *next = src[2];
+
+	for (int x = 0; x < widthInBytes;) {
+		/* Even pixel */
+		RGGB_BGR888(2, 1, 1)
+		/* Odd pixel RGGB -> GRBG */
+		GRBG_BGR888(1, 1, 1)
+		/* Same thing for next 2 pixels */
+		RGGB_BGR888(1, 1, 1)
+		GRBG_BGR888(1, 2, 1)
+		/* Skip 5th src byte with 4 x 2 least-significant-bits */
+		x++;
+	}
+}
+
+static bool isStandardBayerOrder(BayerFormat::Order order)
+{
+	return order == BayerFormat::BGGR || order == BayerFormat::GBRG ||
+	       order == BayerFormat::GRBG || order == BayerFormat::RGGB;
+}
+
+/*
+ * Setup the Debayer object according to the passed in parameters.
+ * Return 0 on success, a negative errno value on failure
+ * (unsupported parameters).
+ */
+int DebayerCpu::getInputConfig(PixelFormat inputFormat, DebayerInputConfig &config)
+{
+	BayerFormat bayerFormat =
+		BayerFormat::fromPixelFormat(inputFormat);
+
+	if ((bayerFormat.bitDepth == 8 || bayerFormat.bitDepth == 10 || bayerFormat.bitDepth == 12) &&
+	    bayerFormat.packing == BayerFormat::Packing::None &&
+	    isStandardBayerOrder(bayerFormat.order)) {
+		config.bpp = (bayerFormat.bitDepth + 7) & ~7;
+		config.patternSize.width = 2;
+		config.patternSize.height = 2;
+		config.outputFormats = std::vector<PixelFormat>({ formats::RGB888, formats::BGR888 });
+		return 0;
+	}
+
+	if (bayerFormat.bitDepth == 10 &&
+	    bayerFormat.packing == BayerFormat::Packing::CSI2 &&
+	    isStandardBayerOrder(bayerFormat.order)) {
+		config.bpp = 10;
+		config.patternSize.width = 4; /* 5 bytes per *4* pixels */
+		config.patternSize.height = 2;
+		config.outputFormats = std::vector<PixelFormat>({ formats::RGB888, formats::BGR888 });
+		return 0;
+	}
+
+	LOG(Debayer, Info)
+		<< "Unsupported input format " << inputFormat.toString();
+	return -EINVAL;
+}
+
+int DebayerCpu::getOutputConfig(PixelFormat outputFormat, DebayerOutputConfig &config)
+{
+	if (outputFormat == formats::RGB888 || outputFormat == formats::BGR888) {
+		config.bpp = 24;
+		return 0;
+	}
+
+	LOG(Debayer, Info)
+		<< "Unsupported output format " << outputFormat.toString();
+	return -EINVAL;
+}
+
+/*
+ * Check for standard Bayer orders and set xShift_ and swap debayer0/1, so that
+ * a single pair of BGGR debayer functions can be used for all 4 standard orders.
+ */
+int DebayerCpu::setupStandardBayerOrder(BayerFormat::Order order)
+{
+	switch (order) {
+	case BayerFormat::BGGR:
+		break;
+	case BayerFormat::GBRG:
+		xShift_ = 1; /* BGGR -> GBRG */
+		break;
+	case BayerFormat::GRBG:
+		std::swap(debayer0_, debayer1_); /* BGGR -> GRBG */
+		break;
+	case BayerFormat::RGGB:
+		xShift_ = 1; /* BGGR -> GBRG */
+		std::swap(debayer0_, debayer1_); /* GBRG -> RGGB */
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+int DebayerCpu::setDebayerFunctions(PixelFormat inputFormat, PixelFormat outputFormat)
+{
+	BayerFormat bayerFormat =
+		BayerFormat::fromPixelFormat(inputFormat);
+
+	xShift_ = 0;
+	swapRedBlueGains_ = false;
+
+	auto invalidFmt = []() -> int {
+		LOG(Debayer, Error) << "Unsupported input output format combination";
+		return -EINVAL;
+	};
+
+	switch (outputFormat) {
+	case formats::RGB888:
+		break;
+	case formats::BGR888:
+		/* Swap R and B in bayer order to generate BGR888 instead of RGB888 */
+		swapRedBlueGains_ = true;
+
+		switch (bayerFormat.order) {
+		case BayerFormat::BGGR:
+			bayerFormat.order = BayerFormat::RGGB;
+			break;
+		case BayerFormat::GBRG:
+			bayerFormat.order = BayerFormat::GRBG;
+			break;
+		case BayerFormat::GRBG:
+			bayerFormat.order = BayerFormat::GBRG;
+			break;
+		case BayerFormat::RGGB:
+			bayerFormat.order = BayerFormat::BGGR;
+			break;
+		default:
+			return invalidFmt();
+		}
+		break;
+	default:
+		return invalidFmt();
+	}
+
+	if ((bayerFormat.bitDepth == 8 || bayerFormat.bitDepth == 10 || bayerFormat.bitDepth == 12) &&
+	    bayerFormat.packing == BayerFormat::Packing::None &&
+	    isStandardBayerOrder(bayerFormat.order)) {
+		switch (bayerFormat.bitDepth) {
+		case 8:
+			debayer0_ = &DebayerCpu::debayer8_BGBG_BGR888;
+			debayer1_ = &DebayerCpu::debayer8_GRGR_BGR888;
+			break;
+		case 10:
+			debayer0_ = &DebayerCpu::debayer10_BGBG_BGR888;
+			debayer1_ = &DebayerCpu::debayer10_GRGR_BGR888;
+			break;
+		case 12:
+			debayer0_ = &DebayerCpu::debayer12_BGBG_BGR888;
+			debayer1_ = &DebayerCpu::debayer12_GRGR_BGR888;
+			break;
+		}
+		setupStandardBayerOrder(bayerFormat.order);
+		return 0;
+	}
+
+	if (bayerFormat.bitDepth == 10 &&
+	    bayerFormat.packing == BayerFormat::Packing::CSI2) {
+		switch (bayerFormat.order) {
+		case BayerFormat::BGGR:
+			debayer0_ = &DebayerCpu::debayer10P_BGBG_BGR888;
+			debayer1_ = &DebayerCpu::debayer10P_GRGR_BGR888;
+			return 0;
+		case BayerFormat::GBRG:
+			debayer0_ = &DebayerCpu::debayer10P_GBGB_BGR888;
+			debayer1_ = &DebayerCpu::debayer10P_RGRG_BGR888;
+			return 0;
+		case BayerFormat::GRBG:
+			debayer0_ = &DebayerCpu::debayer10P_GRGR_BGR888;
+			debayer1_ = &DebayerCpu::debayer10P_BGBG_BGR888;
+			return 0;
+		case BayerFormat::RGGB:
+			debayer0_ = &DebayerCpu::debayer10P_RGRG_BGR888;
+			debayer1_ = &DebayerCpu::debayer10P_GBGB_BGR888;
+			return 0;
+		default:
+			break;
+		}
+	}
+
+	return invalidFmt();
+}
+
+int DebayerCpu::configure(const StreamConfiguration &inputCfg,
+			  const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfgs)
+{
+	if (getInputConfig(inputCfg.pixelFormat, inputConfig_) != 0)
+		return -EINVAL;
+
+	if (stats_->configure(inputCfg) != 0)
+		return -EINVAL;
+
+	const Size &statsPatternSize = stats_->patternSize();
+	if (inputConfig_.patternSize.width != statsPatternSize.width ||
+	    inputConfig_.patternSize.height != statsPatternSize.height) {
+		LOG(Debayer, Error)
+			<< "mismatching stats and debayer pattern sizes for "
+			<< inputCfg.pixelFormat.toString();
+		return -EINVAL;
+	}
+
+	inputConfig_.stride = inputCfg.stride;
+
+	if (outputCfgs.size() != 1) {
+		LOG(Debayer, Error)
+			<< "Unsupported number of output streams: "
+			<< outputCfgs.size();
+		return -EINVAL;
+	}
+
+	const StreamConfiguration &outputCfg = outputCfgs[0];
+	SizeRange outSizeRange = sizes(inputCfg.pixelFormat, inputCfg.size);
+	std::tie(outputConfig_.stride, outputConfig_.frameSize) =
+		strideAndFrameSize(outputCfg.pixelFormat, outputCfg.size);
+
+	if (!outSizeRange.contains(outputCfg.size) || outputConfig_.stride != outputCfg.stride) {
+		LOG(Debayer, Error)
+			<< "Invalid output size/stride: "
+			<< "\n  " << outputCfg.size << " (" << outSizeRange << ")"
+			<< "\n  " << outputCfg.stride << " (" << outputConfig_.stride << ")";
+		return -EINVAL;
+	}
+
+	if (setDebayerFunctions(inputCfg.pixelFormat, outputCfg.pixelFormat) != 0)
+		return -EINVAL;
+
+	window_.x = ((inputCfg.size.width - outputCfg.size.width) / 2) &
+		    ~(inputConfig_.patternSize.width - 1);
+	window_.y = ((inputCfg.size.height - outputCfg.size.height) / 2) &
+		    ~(inputConfig_.patternSize.height - 1);
+	window_.width = outputCfg.size.width;
+	window_.height = outputCfg.size.height;
+
+	/* Don't pass x,y since process() already adjusts src before passing it */
+	stats_->setWindow(Rectangle(window_.size()));
+
+	/* pad with patternSize.Width on both left and right side */
+	lineBufferPadding_ = inputConfig_.patternSize.width * inputConfig_.bpp / 8;
+	lineBufferLength_ = window_.width * inputConfig_.bpp / 8 +
+			    2 * lineBufferPadding_;
+	for (unsigned int i = 0;
+	     i < (inputConfig_.patternSize.height + 1) && enableInputMemcpy_;
+	     i++) {
+		free(lineBuffers_[i]);
+		lineBuffers_[i] = (uint8_t *)malloc(lineBufferLength_);
+		if (!lineBuffers_[i])
+			return -ENOMEM;
+	}
+
+	measuredFrames_ = 0;
+	frameProcessTime_ = 0;
+
+	return 0;
+}
+
+/*
+ * Get width and height at which the bayer-pattern repeats.
+ * Return pattern-size or an empty Size for an unsupported inputFormat.
+ */
+Size DebayerCpu::patternSize(PixelFormat inputFormat)
+{
+	DebayerCpu::DebayerInputConfig config;
+
+	if (getInputConfig(inputFormat, config) != 0)
+		return {};
+
+	return config.patternSize;
+}
+
+std::vector<PixelFormat> DebayerCpu::formats(PixelFormat inputFormat)
+{
+	DebayerCpu::DebayerInputConfig config;
+
+	if (getInputConfig(inputFormat, config) != 0)
+		return std::vector<PixelFormat>();
+
+	return config.outputFormats;
+}
+
+std::tuple<unsigned int, unsigned int>
+DebayerCpu::strideAndFrameSize(const PixelFormat &outputFormat, const Size &size)
+{
+	DebayerCpu::DebayerOutputConfig config;
+
+	if (getOutputConfig(outputFormat, config) != 0)
+		return std::make_tuple(0, 0);
+
+	/* round up to multiple of 8 for 64 bits alignment */
+	unsigned int stride = (size.width * config.bpp / 8 + 7) & ~7;
+
+	return std::make_tuple(stride, stride * size.height);
+}
+
+void DebayerCpu::setupInputMemcpy(const uint8_t *linePointers[])
+{
+	const unsigned int patternHeight = inputConfig_.patternSize.height;
+
+	if (!enableInputMemcpy_)
+		return;
+
+	for (unsigned int i = 0; i < patternHeight; i++) {
+		memcpy(lineBuffers_[i], linePointers[i + 1] - lineBufferPadding_,
+		       lineBufferLength_);
+		linePointers[i + 1] = lineBuffers_[i] + lineBufferPadding_;
+	}
+
+	/* Point lineBufferIndex_ to first unused lineBuffer */
+	lineBufferIndex_ = patternHeight;
+}
+
+void DebayerCpu::shiftLinePointers(const uint8_t *linePointers[], const uint8_t *src)
+{
+	const unsigned int patternHeight = inputConfig_.patternSize.height;
+
+	for (unsigned int i = 0; i < patternHeight; i++)
+		linePointers[i] = linePointers[i + 1];
+
+	linePointers[patternHeight] = src +
+				      (patternHeight / 2) * (int)inputConfig_.stride;
+}
+
+void DebayerCpu::memcpyNextLine(const uint8_t *linePointers[])
+{
+	const unsigned int patternHeight = inputConfig_.patternSize.height;
+
+	if (!enableInputMemcpy_)
+		return;
+
+	memcpy(lineBuffers_[lineBufferIndex_], linePointers[patternHeight] - lineBufferPadding_,
+	       lineBufferLength_);
+	linePointers[patternHeight] = lineBuffers_[lineBufferIndex_] + lineBufferPadding_;
+
+	lineBufferIndex_ = (lineBufferIndex_ + 1) % (patternHeight + 1);
+}
+
+void DebayerCpu::process2(const uint8_t *src, uint8_t *dst)
+{
+	unsigned int yEnd = window_.y + window_.height;
+	/* Holds [0] previous- [1] current- [2] next-line */
+	const uint8_t *linePointers[3];
+
+	/* Adjust src to top left corner of the window */
+	src += window_.y * inputConfig_.stride + window_.x * inputConfig_.bpp / 8;
+
+	/* [x] becomes [x - 1] after initial shiftLinePointers() call */
+	if (window_.y) {
+		linePointers[1] = src - inputConfig_.stride; /* previous-line */
+		linePointers[2] = src;
+	} else {
+		/* window_.y == 0, use the next line as prev line */
+		linePointers[1] = src + inputConfig_.stride;
+		linePointers[2] = src;
+		/* Last 2 lines also need special handling */
+		yEnd -= 2;
+	}
+
+	setupInputMemcpy(linePointers);
+
+	for (unsigned int y = window_.y; y < yEnd; y += 2) {
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		stats_->processLine0(y, linePointers);
+		(this->*debayer0_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		(this->*debayer1_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+	}
+
+	if (window_.y == 0) {
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		stats_->processLine0(yEnd, linePointers);
+		(this->*debayer0_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+
+		shiftLinePointers(linePointers, src);
+		/* next line may point outside of src, use prev. */
+		linePointers[2] = linePointers[0];
+		(this->*debayer1_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+	}
+}
+
+void DebayerCpu::process4(const uint8_t *src, uint8_t *dst)
+{
+	const unsigned int yEnd = window_.y + window_.height;
+	/*
+	 * This holds pointers to [0] 2-lines-up [1] 1-line-up [2] current-line
+	 * [3] 1-line-down [4] 2-lines-down.
+	 */
+	const uint8_t *linePointers[5];
+
+	/* Adjust src to top left corner of the window */
+	src += window_.y * inputConfig_.stride + window_.x * inputConfig_.bpp / 8;
+
+	/* [x] becomes [x - 1] after initial shiftLinePointers() call */
+	linePointers[1] = src - 2 * inputConfig_.stride;
+	linePointers[2] = src - inputConfig_.stride;
+	linePointers[3] = src;
+	linePointers[4] = src + inputConfig_.stride;
+
+	setupInputMemcpy(linePointers);
+
+	for (unsigned int y = window_.y; y < yEnd; y += 4) {
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		stats_->processLine0(y, linePointers);
+		(this->*debayer0_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		(this->*debayer1_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		stats_->processLine2(y, linePointers);
+		(this->*debayer2_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+
+		shiftLinePointers(linePointers, src);
+		memcpyNextLine(linePointers);
+		(this->*debayer3_)(dst, linePointers);
+		src += inputConfig_.stride;
+		dst += outputConfig_.stride;
+	}
+}
+
+static inline int64_t timeDiff(timespec &after, timespec &before)
+{
+	return (after.tv_sec - before.tv_sec) * 1000000000LL +
+	       (int64_t)after.tv_nsec - (int64_t)before.tv_nsec;
+}
+
+void DebayerCpu::process(FrameBuffer *input, FrameBuffer *output, DebayerParams params)
+{
+	timespec frameStartTime;
+
+	if (measuredFrames_ < DebayerCpu::kLastFrameToMeasure) {
+		frameStartTime = {};
+		clock_gettime(CLOCK_MONOTONIC_RAW, &frameStartTime);
+	}
+
+	/* Apply DebayerParams */
+	if (params.gamma != gammaCorrection_ || params.blackLevel != blackLevel_) {
+		const unsigned int blackIndex =
+			params.blackLevel * kGammaLookupSize / 256;
+		std::fill(gamma_.begin(), gamma_.begin() + blackIndex, 0);
+		const float divisor = kGammaLookupSize - blackIndex - 1.0;
+		for (unsigned int i = blackIndex; i < kGammaLookupSize; i++)
+			gamma_[i] = UINT8_MAX * powf((i - blackIndex) / divisor, params.gamma);
+
+		gammaCorrection_ = params.gamma;
+		blackLevel_ = params.blackLevel;
+	}
+
+	if (swapRedBlueGains_)
+		std::swap(params.gainR, params.gainB);
+
+	for (unsigned int i = 0; i < kRGBLookupSize; i++) {
+		constexpr unsigned int div =
+			kRGBLookupSize * DebayerParams::kGain10 / kGammaLookupSize;
+		unsigned int idx;
+
+		/* Apply gamma after gain! */
+		idx = std::min({ i * params.gainR / div, (kGammaLookupSize - 1) });
+		red_[i] = gamma_[idx];
+
+		idx = std::min({ i * params.gainG / div, (kGammaLookupSize - 1) });
+		green_[i] = gamma_[idx];
+
+		idx = std::min({ i * params.gainB / div, (kGammaLookupSize - 1) });
+		blue_[i] = gamma_[idx];
+	}
+
+	/* Copy metadata from the input buffer */
+	FrameMetadata &metadata = output->_d()->metadata();
+	metadata.status = input->metadata().status;
+	metadata.sequence = input->metadata().sequence;
+	metadata.timestamp = input->metadata().timestamp;
+
+	MappedFrameBuffer in(input, MappedFrameBuffer::MapFlag::Read);
+	MappedFrameBuffer out(output, MappedFrameBuffer::MapFlag::Write);
+	if (!in.isValid() || !out.isValid()) {
+		LOG(Debayer, Error) << "mmap-ing buffer(s) failed";
+		metadata.status = FrameMetadata::FrameError;
+		return;
+	}
+
+	stats_->startFrame();
+
+	if (inputConfig_.patternSize.height == 2)
+		process2(in.planes()[0].data(), out.planes()[0].data());
+	else
+		process4(in.planes()[0].data(), out.planes()[0].data());
+
+	metadata.planes()[0].bytesused = out.planes()[0].size();
+
+	/* Measure before emitting signals */
+	if (measuredFrames_ < DebayerCpu::kLastFrameToMeasure &&
+	    ++measuredFrames_ > DebayerCpu::kFramesToSkip) {
+		timespec frameEndTime = {};
+		clock_gettime(CLOCK_MONOTONIC_RAW, &frameEndTime);
+		frameProcessTime_ += timeDiff(frameEndTime, frameStartTime);
+		if (measuredFrames_ == DebayerCpu::kLastFrameToMeasure) {
+			const unsigned int measuredFrames = DebayerCpu::kLastFrameToMeasure -
+							    DebayerCpu::kFramesToSkip;
+			LOG(Debayer, Info)
+				<< "Processed " << measuredFrames
+				<< " frames in " << frameProcessTime_ / 1000 << "us, "
+				<< frameProcessTime_ / (1000 * measuredFrames)
+				<< " us/frame";
+		}
+	}
+
+	stats_->finishFrame();
+	outputBufferReady.emit(output);
+	inputBufferReady.emit(input);
+}
+
+SizeRange DebayerCpu::sizes(PixelFormat inputFormat, const Size &inputSize)
+{
+	Size patternSize = this->patternSize(inputFormat);
+	unsigned int borderHeight = patternSize.height;
+
+	if (patternSize.isNull())
+		return {};
+
+	/* No need for top/bottom border with a pattern height of 2 */
+	if (patternSize.height == 2)
+		borderHeight = 0;
+
+	/*
+	 * For debayer interpolation a border is kept around the entire image
+	 * and the minimum output size is pattern-height x pattern-width.
+	 */
+	if (inputSize.width < (3 * patternSize.width) ||
+	    inputSize.height < (2 * borderHeight + patternSize.height)) {
+		LOG(Debayer, Warning)
+			<< "Input format size too small: " << inputSize.toString();
+		return {};
+	}
+
+	return SizeRange(Size(patternSize.width, patternSize.height),
+			 Size((inputSize.width - 2 * patternSize.width) & ~(patternSize.width - 1),
+			      (inputSize.height - 2 * borderHeight) & ~(patternSize.height - 1)),
+			 patternSize.width, patternSize.height);
+}
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/debayer_cpu.h 0.3.0-1/src/libcamera/software_isp/debayer_cpu.h
--- 0.2.0-3/src/libcamera/software_isp/debayer_cpu.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/debayer_cpu.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,158 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * CPU based debayering header
+ */
+
+#pragma once
+
+#include <memory>
+#include <stdint.h>
+#include <vector>
+
+#include <libcamera/base/object.h>
+
+#include "libcamera/internal/bayer_format.h"
+
+#include "debayer.h"
+#include "swstats_cpu.h"
+
+namespace libcamera {
+
+class DebayerCpu : public Debayer, public Object
+{
+public:
+	DebayerCpu(std::unique_ptr<SwStatsCpu> stats);
+	~DebayerCpu();
+
+	int configure(const StreamConfiguration &inputCfg,
+		      const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfgs);
+	Size patternSize(PixelFormat inputFormat);
+	std::vector<PixelFormat> formats(PixelFormat input);
+	std::tuple<unsigned int, unsigned int>
+	strideAndFrameSize(const PixelFormat &outputFormat, const Size &size);
+	void process(FrameBuffer *input, FrameBuffer *output, DebayerParams params);
+	SizeRange sizes(PixelFormat inputFormat, const Size &inputSize);
+
+	/**
+	 * \brief Get the file descriptor for the statistics
+	 *
+	 * \return the file descriptor pointing to the statistics
+	 */
+	const SharedFD &getStatsFD() { return stats_->getStatsFD(); }
+
+	/**
+	 * \brief Get the output frame size
+	 *
+	 * \return The output frame size
+	 */
+	unsigned int frameSize() { return outputConfig_.frameSize; }
+
+private:
+	/**
+	 * \brief Called to debayer 1 line of Bayer input data to output format
+	 * \param[out] dst Pointer to the start of the output line to write
+	 * \param[in] src The input data
+	 *
+	 * Input data is an array of (patternSize_.height + 1) src
+	 * pointers each pointing to a line in the Bayer source. The middle
+	 * element of the array will point to the actual line being processed.
+	 * Earlier element(s) will point to the previous line(s) and later
+	 * element(s) to the next line(s).
+	 *
+	 * These functions take an array of src pointers, rather than
+	 * a single src pointer + a stride for the source, so that when the src
+	 * is slow uncached memory it can be copied to faster memory before
+	 * debayering. Debayering a standard 2x2 Bayer pattern requires access
+	 * to the previous and next src lines for interpolating the missing
+	 * colors. To allow copying the src lines only once 3 temporary buffers
+	 * each holding a single line are used, re-using the oldest buffer for
+	 * the next line and the pointers are swizzled so that:
+	 * src[0] = previous-line, src[1] = currrent-line, src[2] = next-line.
+	 * This way the 3 pointers passed to the debayer functions form
+	 * a sliding window over the src avoiding the need to copy each
+	 * line more than once.
+	 *
+	 * Similarly for bayer patterns which repeat every 4 lines, 5 src
+	 * pointers are passed holding: src[0] = 2-lines-up, src[1] = 1-line-up
+	 * src[2] = current-line, src[3] = 1-line-down, src[4] = 2-lines-down.
+	 */
+	using debayerFn = void (DebayerCpu::*)(uint8_t *dst, const uint8_t *src[]);
+
+	/* 8-bit raw bayer format */
+	void debayer8_BGBG_BGR888(uint8_t *dst, const uint8_t *src[]);
+	void debayer8_GRGR_BGR888(uint8_t *dst, const uint8_t *src[]);
+	/* unpacked 10-bit raw bayer format */
+	void debayer10_BGBG_BGR888(uint8_t *dst, const uint8_t *src[]);
+	void debayer10_GRGR_BGR888(uint8_t *dst, const uint8_t *src[]);
+	/* unpacked 12-bit raw bayer format */
+	void debayer12_BGBG_BGR888(uint8_t *dst, const uint8_t *src[]);
+	void debayer12_GRGR_BGR888(uint8_t *dst, const uint8_t *src[]);
+	/* CSI-2 packed 10-bit raw bayer format (all the 4 orders) */
+	void debayer10P_BGBG_BGR888(uint8_t *dst, const uint8_t *src[]);
+	void debayer10P_GRGR_BGR888(uint8_t *dst, const uint8_t *src[]);
+	void debayer10P_GBGB_BGR888(uint8_t *dst, const uint8_t *src[]);
+	void debayer10P_RGRG_BGR888(uint8_t *dst, const uint8_t *src[]);
+
+	struct DebayerInputConfig {
+		Size patternSize;
+		unsigned int bpp; /* Memory used per pixel, not precision */
+		unsigned int stride;
+		std::vector<PixelFormat> outputFormats;
+	};
+
+	struct DebayerOutputConfig {
+		unsigned int bpp; /* Memory used per pixel, not precision */
+		unsigned int stride;
+		unsigned int frameSize;
+	};
+
+	int getInputConfig(PixelFormat inputFormat, DebayerInputConfig &config);
+	int getOutputConfig(PixelFormat outputFormat, DebayerOutputConfig &config);
+	int setupStandardBayerOrder(BayerFormat::Order order);
+	int setDebayerFunctions(PixelFormat inputFormat, PixelFormat outputFormat);
+	void setupInputMemcpy(const uint8_t *linePointers[]);
+	void shiftLinePointers(const uint8_t *linePointers[], const uint8_t *src);
+	void memcpyNextLine(const uint8_t *linePointers[]);
+	void process2(const uint8_t *src, uint8_t *dst);
+	void process4(const uint8_t *src, uint8_t *dst);
+
+	static constexpr unsigned int kGammaLookupSize = 1024;
+	static constexpr unsigned int kRGBLookupSize = 256;
+	/* Max. supported Bayer pattern height is 4, debayering this requires 5 lines */
+	static constexpr unsigned int kMaxLineBuffers = 5;
+
+	std::array<uint8_t, kGammaLookupSize> gamma_;
+	std::array<uint8_t, kRGBLookupSize> red_;
+	std::array<uint8_t, kRGBLookupSize> green_;
+	std::array<uint8_t, kRGBLookupSize> blue_;
+	debayerFn debayer0_;
+	debayerFn debayer1_;
+	debayerFn debayer2_;
+	debayerFn debayer3_;
+	Rectangle window_;
+	DebayerInputConfig inputConfig_;
+	DebayerOutputConfig outputConfig_;
+	std::unique_ptr<SwStatsCpu> stats_;
+	uint8_t *lineBuffers_[kMaxLineBuffers];
+	unsigned int lineBufferLength_;
+	unsigned int lineBufferPadding_;
+	unsigned int lineBufferIndex_;
+	unsigned int xShift_; /* Offset of 0/1 applied to window_.x */
+	bool enableInputMemcpy_;
+	bool swapRedBlueGains_;
+	float gammaCorrection_;
+	unsigned int blackLevel_;
+	unsigned int measuredFrames_;
+	int64_t frameProcessTime_;
+	/* Skip 30 frames for things to stabilize then measure 30 frames */
+	static constexpr unsigned int kFramesToSkip = 30;
+	static constexpr unsigned int kLastFrameToMeasure = 60;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/meson.build 0.3.0-1/src/libcamera/software_isp/meson.build
--- 0.2.0-3/src/libcamera/software_isp/meson.build	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,15 @@
+# SPDX-License-Identifier: CC0-1.0
+
+softisp_enabled = pipelines.contains('simple')
+summary({'SoftISP support' : softisp_enabled}, section : 'Configuration')
+
+if not softisp_enabled
+    subdir_done()
+endif
+
+libcamera_sources += files([
+    'debayer.cpp',
+    'debayer_cpu.cpp',
+    'software_isp.cpp',
+    'swstats_cpu.cpp',
+])
diff -pruN 0.2.0-3/src/libcamera/software_isp/software_isp.cpp 0.3.0-1/src/libcamera/software_isp/software_isp.cpp
--- 0.2.0-3/src/libcamera/software_isp/software_isp.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/software_isp.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,357 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ *
+ * Simple software ISP implementation
+ */
+
+#include "libcamera/internal/software_isp/software_isp.h"
+
+#include <sys/mman.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+#include <libcamera/formats.h>
+#include <libcamera/stream.h>
+
+#include "libcamera/internal/bayer_format.h"
+#include "libcamera/internal/framebuffer.h"
+#include "libcamera/internal/ipa_manager.h"
+#include "libcamera/internal/mapped_framebuffer.h"
+
+#include "debayer_cpu.h"
+
+/**
+ * \file software_isp.cpp
+ * \brief Simple software ISP implementation
+ */
+
+namespace libcamera {
+
+LOG_DEFINE_CATEGORY(SoftwareIsp)
+
+/**
+ * \class SoftwareIsp
+ * \brief Class for the Software ISP
+ */
+
+/**
+ * \var SoftwareIsp::inputBufferReady
+ * \brief A signal emitted when the input frame buffer completes
+ */
+
+/**
+ * \var SoftwareIsp::outputBufferReady
+ * \brief A signal emitted when the output frame buffer completes
+ */
+
+/**
+ * \var SoftwareIsp::ispStatsReady
+ * \brief A signal emitted when the statistics for IPA are ready
+ */
+
+/**
+ * \var SoftwareIsp::setSensorControls
+ * \brief A signal emitted when the values to write to the sensor controls are
+ * ready
+ */
+
+/**
+ * \brief Constructs SoftwareIsp object
+ * \param[in] pipe The pipeline handler in use
+ * \param[in] sensor Pointer to the CameraSensor instance owned by the pipeline
+ * handler
+ */
+SoftwareIsp::SoftwareIsp(PipelineHandler *pipe, const CameraSensor *sensor)
+	: debayerParams_{ DebayerParams::kGain10, DebayerParams::kGain10,
+			  DebayerParams::kGain10, 0.5f, 0 },
+	  dmaHeap_(DmaHeap::DmaHeapFlag::Cma | DmaHeap::DmaHeapFlag::System)
+{
+	if (!dmaHeap_.isValid()) {
+		LOG(SoftwareIsp, Error) << "Failed to create DmaHeap object";
+		return;
+	}
+
+	sharedParams_ = SharedMemObject<DebayerParams>("softIsp_params");
+	if (!sharedParams_) {
+		LOG(SoftwareIsp, Error) << "Failed to create shared memory for parameters";
+		return;
+	}
+
+	auto stats = std::make_unique<SwStatsCpu>();
+	if (!stats->isValid()) {
+		LOG(SoftwareIsp, Error) << "Failed to create SwStatsCpu object";
+		return;
+	}
+	stats->statsReady.connect(this, &SoftwareIsp::statsReady);
+
+	debayer_ = std::make_unique<DebayerCpu>(std::move(stats));
+	debayer_->inputBufferReady.connect(this, &SoftwareIsp::inputReady);
+	debayer_->outputBufferReady.connect(this, &SoftwareIsp::outputReady);
+
+	ipa_ = IPAManager::createIPA<ipa::soft::IPAProxySoft>(pipe, 0, 0);
+	if (!ipa_) {
+		LOG(SoftwareIsp, Error)
+			<< "Creating IPA for software ISP failed";
+		debayer_.reset();
+		return;
+	}
+
+	/*
+	 * The API tuning file is made from the sensor name. If the tuning file
+	 * isn't found, fall back to the 'uncalibrated' file.
+	 */
+	std::string ipaTuningFile = ipa_->configurationFile(sensor->model() + ".yaml");
+	if (ipaTuningFile.empty())
+		ipaTuningFile = ipa_->configurationFile("uncalibrated.yaml");
+
+	int ret = ipa_->init(IPASettings{ ipaTuningFile, sensor->model() },
+			     debayer_->getStatsFD(),
+			     sharedParams_.fd(),
+			     sensor->controls());
+	if (ret) {
+		LOG(SoftwareIsp, Error) << "IPA init failed";
+		debayer_.reset();
+		return;
+	}
+
+	ipa_->setIspParams.connect(this, &SoftwareIsp::saveIspParams);
+	ipa_->setSensorControls.connect(this, &SoftwareIsp::setSensorCtrls);
+
+	debayer_->moveToThread(&ispWorkerThread_);
+}
+
+SoftwareIsp::~SoftwareIsp()
+{
+	/* make sure to destroy the DebayerCpu before the ispWorkerThread_ is gone */
+	debayer_.reset();
+}
+
+/**
+ * \fn int SoftwareIsp::loadConfiguration([[maybe_unused]] const std::string &filename)
+ * \brief Load a configuration from a file
+ * \param[in] filename The file to load the configuration data from
+ *
+ * Currently is a stub doing nothing and always returning "success".
+ *
+ * \return 0 on success
+ */
+
+/**
+ * \brief Process the statistics gathered
+ * \param[in] sensorControls The sensor controls
+ *
+ * Requests the IPA to calculate new parameters for ISP and new control
+ * values for the sensor.
+ */
+void SoftwareIsp::processStats(const ControlList &sensorControls)
+{
+	ASSERT(ipa_);
+	ipa_->processStats(sensorControls);
+}
+
+/**
+ * \brief Check the validity of Software Isp object
+ * \return True if Software Isp is valid, false otherwise
+ */
+bool SoftwareIsp::isValid() const
+{
+	return !!debayer_;
+}
+
+/**
+  * \brief Get the output formats supported for the given input format
+  * \param[in] inputFormat The input format
+  * \return All the supported output formats or an empty vector if there are none
+  */
+std::vector<PixelFormat> SoftwareIsp::formats(PixelFormat inputFormat)
+{
+	ASSERT(debayer_);
+
+	return debayer_->formats(inputFormat);
+}
+
+/**
+ * \brief Get the supported output sizes for the given input format and size
+ * \param[in] inputFormat The input format
+ * \param[in] inputSize The input frame size
+ * \return The valid size range or an empty range if there are none
+ */
+SizeRange SoftwareIsp::sizes(PixelFormat inputFormat, const Size &inputSize)
+{
+	ASSERT(debayer_);
+
+	return debayer_->sizes(inputFormat, inputSize);
+}
+
+/**
+ * Get the output stride and the frame size in bytes for the given output format and size
+ * \param[in] outputFormat The output format
+ * \param[in] size The output size (width and height in pixels)
+ * \return A tuple of the stride and the frame size in bytes, or a tuple of 0,0
+ * if there is no valid output config
+ */
+std::tuple<unsigned int, unsigned int>
+SoftwareIsp::strideAndFrameSize(const PixelFormat &outputFormat, const Size &size)
+{
+	ASSERT(debayer_);
+
+	return debayer_->strideAndFrameSize(outputFormat, size);
+}
+
+/**
+ * \brief Configure the SoftwareIsp object according to the passed in parameters
+ * \param[in] inputCfg The input configuration
+ * \param[in] outputCfgs The output configurations
+ * \param[in] sensorControls ControlInfoMap of the controls supported by the sensor
+ * \return 0 on success, a negative errno on failure
+ */
+int SoftwareIsp::configure(const StreamConfiguration &inputCfg,
+			   const std::vector<std::reference_wrapper<StreamConfiguration>> &outputCfgs,
+			   const ControlInfoMap &sensorControls)
+{
+	ASSERT(ipa_ && debayer_);
+
+	int ret = ipa_->configure(sensorControls);
+	if (ret < 0)
+		return ret;
+
+	return debayer_->configure(inputCfg, outputCfgs);
+}
+
+/**
+ * \brief Export the buffers from the Software ISP
+ * \param[in] output Output stream index exporting the buffers
+ * \param[in] count Number of buffers to allocate
+ * \param[out] buffers Vector to store the allocated buffers
+ * \return The number of allocated buffers on success or a negative error code
+ * otherwise
+ */
+int SoftwareIsp::exportBuffers(unsigned int output, unsigned int count,
+			       std::vector<std::unique_ptr<FrameBuffer>> *buffers)
+{
+	ASSERT(debayer_ != nullptr);
+
+	/* single output for now */
+	if (output >= 1)
+		return -EINVAL;
+
+	for (unsigned int i = 0; i < count; i++) {
+		const std::string name = "frame-" + std::to_string(i);
+		const size_t frameSize = debayer_->frameSize();
+
+		FrameBuffer::Plane outPlane;
+		outPlane.fd = SharedFD(dmaHeap_.alloc(name.c_str(), frameSize));
+		if (!outPlane.fd.isValid()) {
+			LOG(SoftwareIsp, Error)
+				<< "failed to allocate a dma_buf";
+			return -ENOMEM;
+		}
+		outPlane.offset = 0;
+		outPlane.length = frameSize;
+
+		std::vector<FrameBuffer::Plane> planes{ outPlane };
+		buffers->emplace_back(std::make_unique<FrameBuffer>(std::move(planes)));
+	}
+
+	return count;
+}
+
+/**
+ * \brief Queue buffers to Software ISP
+ * \param[in] input The input framebuffer
+ * \param[in] outputs The container holding the output stream indexes and
+ * their respective frame buffer outputs
+ * \return 0 on success, a negative errno on failure
+ */
+int SoftwareIsp::queueBuffers(FrameBuffer *input,
+			      const std::map<unsigned int, FrameBuffer *> &outputs)
+{
+	unsigned int mask = 0;
+
+	/*
+	 * Validate the outputs as a sanity check: at least one output is
+	 * required, all outputs must reference a valid stream and no two
+	 * outputs can reference the same stream.
+	 */
+	if (outputs.empty())
+		return -EINVAL;
+
+	for (auto [index, buffer] : outputs) {
+		if (!buffer)
+			return -EINVAL;
+		if (index >= 1) /* only single stream atm */
+			return -EINVAL;
+		if (mask & (1 << index))
+			return -EINVAL;
+
+		mask |= 1 << index;
+	}
+
+	process(input, outputs.at(0));
+
+	return 0;
+}
+
+/**
+ * \brief Starts the Software ISP streaming operation
+ * \return 0 on success, any other value indicates an error
+ */
+int SoftwareIsp::start()
+{
+	int ret = ipa_->start();
+	if (ret)
+		return ret;
+
+	ispWorkerThread_.start();
+	return 0;
+}
+
+/**
+ * \brief Stops the Software ISP streaming operation
+ */
+void SoftwareIsp::stop()
+{
+	ispWorkerThread_.exit();
+	ispWorkerThread_.wait();
+
+	ipa_->stop();
+}
+
+/**
+ * \brief Passes the input framebuffer to the ISP worker to process
+ * \param[in] input The input framebuffer
+ * \param[out] output The framebuffer to write the processed frame to
+ */
+void SoftwareIsp::process(FrameBuffer *input, FrameBuffer *output)
+{
+	debayer_->invokeMethod(&DebayerCpu::process,
+			       ConnectionTypeQueued, input, output, debayerParams_);
+}
+
+void SoftwareIsp::saveIspParams()
+{
+	debayerParams_ = *sharedParams_;
+}
+
+void SoftwareIsp::setSensorCtrls(const ControlList &sensorControls)
+{
+	setSensorControls.emit(sensorControls);
+}
+
+void SoftwareIsp::statsReady()
+{
+	ispStatsReady.emit();
+}
+
+void SoftwareIsp::inputReady(FrameBuffer *input)
+{
+	inputBufferReady.emit(input);
+}
+
+void SoftwareIsp::outputReady(FrameBuffer *output)
+{
+	outputBufferReady.emit(output);
+}
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/swstats_cpu.cpp 0.3.0-1/src/libcamera/software_isp/swstats_cpu.cpp
--- 0.2.0-3/src/libcamera/software_isp/swstats_cpu.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/swstats_cpu.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,432 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * CPU based software statistics implementation
+ */
+
+#include "swstats_cpu.h"
+
+#include <libcamera/base/log.h>
+
+#include <libcamera/stream.h>
+
+#include "libcamera/internal/bayer_format.h"
+
+namespace libcamera {
+
+/**
+ * \class SwStatsCpu
+ * \brief Class for gathering statistics on the CPU
+ *
+ * CPU based software ISP statistics implementation.
+ *
+ * This class offers a configure function + functions to gather statistics on a
+ * line by line basis. This allows CPU based software debayering to interleave
+ * debayering and statistics gathering on a line by line basis while the input
+ * data is still hot in the cache.
+ *
+ * It is also possible to specify a window over which to gather statistics
+ * instead of processing the whole frame.
+ */
+
+/**
+ * \fn bool SwStatsCpu::isValid() const
+ * \brief Gets whether the statistics object is valid
+ *
+ * \return True if it's valid, false otherwise
+ */
+
+/**
+ * \fn const SharedFD &SwStatsCpu::getStatsFD()
+ * \brief Get the file descriptor for the statistics
+ *
+ * \return The file descriptor
+ */
+
+/**
+ * \fn const Size &SwStatsCpu::patternSize()
+ * \brief Get the pattern size
+ *
+ * For some input-formats, e.g. Bayer data, processing is done multiple lines
+ * and/or columns at a time. Get width and height at which the (bayer) pattern
+ * repeats. Window values are rounded down to a multiple of this and the height
+ * also indicates if processLine2() should be called or not.
+ * This may only be called after a successful configure() call.
+ *
+ * \return The pattern size
+ */
+
+/**
+ * \fn void SwStatsCpu::processLine0(unsigned int y, const uint8_t *src[])
+ * \brief Process line 0
+ * \param[in] y The y coordinate.
+ * \param[in] src The input data.
+ *
+ * This function processes line 0 for input formats with
+ * patternSize height == 1.
+ * It'll process line 0 and 1 for input formats with patternSize height >= 2.
+ * This function may only be called after a successful setWindow() call.
+ */
+
+/**
+ * \fn void SwStatsCpu::processLine2(unsigned int y, const uint8_t *src[])
+ * \brief Process line 2 and 3
+ * \param[in] y The y coordinate.
+ * \param[in] src The input data.
+ *
+ * This function processes line 2 and 3 for input formats with
+ * patternSize height == 4.
+ * This function may only be called after a successful setWindow() call.
+ */
+
+/**
+ * \var Signal<> SwStatsCpu::statsReady
+ * \brief Signals that the statistics are ready
+ */
+
+/**
+ * \typedef SwStatsCpu::statsProcessFn
+ * \brief Called when there is data to get statistics from
+ * \param[in] src The input data
+ *
+ * These functions take an array of (patternSize_.height + 1) src
+ * pointers each pointing to a line in the source image. The middle
+ * element of the array will point to the actual line being processed.
+ * Earlier element(s) will point to the previous line(s) and later
+ * element(s) to the next line(s).
+ *
+ * See the documentation of DebayerCpu::debayerFn for more details.
+ */
+
+/**
+ * \var unsigned int SwStatsCpu::ySkipMask_
+ * \brief Skip lines where this bitmask is set in y
+ */
+
+/**
+ * \var Rectangle SwStatsCpu::window_
+ * \brief Statistics window, set by setWindow(), used every line
+ */
+
+/**
+ * \var Size SwStatsCpu::patternSize_
+ * \brief The size of the bayer pattern
+ *
+ * Valid sizes are: 2x2, 4x2 or 4x4.
+ */
+
+/**
+ * \var unsigned int SwStatsCpu::xShift_
+ * \brief The offset of x, applied to window_.x for bayer variants
+ *
+ * This can either be 0 or 1.
+ */
+
+LOG_DEFINE_CATEGORY(SwStatsCpu)
+
+SwStatsCpu::SwStatsCpu()
+	: sharedStats_("softIsp_stats")
+{
+	if (!sharedStats_)
+		LOG(SwStatsCpu, Error)
+			<< "Failed to create shared memory for statistics";
+}
+
+static constexpr unsigned int kRedYMul = 77; /* 0.299 * 256 */
+static constexpr unsigned int kGreenYMul = 150; /* 0.587 * 256 */
+static constexpr unsigned int kBlueYMul = 29; /* 0.114 * 256 */
+
+#define SWSTATS_START_LINE_STATS(pixel_t) \
+	pixel_t r, g, g2, b;              \
+	uint64_t yVal;                    \
+                                          \
+	uint64_t sumR = 0;                \
+	uint64_t sumG = 0;                \
+	uint64_t sumB = 0;
+
+#define SWSTATS_ACCUMULATE_LINE_STATS(div) \
+	sumR += r;                         \
+	sumG += g;                         \
+	sumB += b;                         \
+                                           \
+	yVal = r * kRedYMul;               \
+	yVal += g * kGreenYMul;            \
+	yVal += b * kBlueYMul;             \
+	stats_.yHistogram[yVal * SwIspStats::kYHistogramSize / (256 * 256 * (div))]++;
+
+#define SWSTATS_FINISH_LINE_STATS() \
+	stats_.sumR_ += sumR;       \
+	stats_.sumG_ += sumG;       \
+	stats_.sumB_ += sumB;
+
+void SwStatsCpu::statsBGGR8Line0(const uint8_t *src[])
+{
+	const uint8_t *src0 = src[1] + window_.x;
+	const uint8_t *src1 = src[2] + window_.x;
+
+	SWSTATS_START_LINE_STATS(uint8_t)
+
+	if (swapLines_)
+		std::swap(src0, src1);
+
+	/* x += 4 sample every other 2x2 block */
+	for (int x = 0; x < (int)window_.width; x += 4) {
+		b = src0[x];
+		g = src0[x + 1];
+		g2 = src1[x];
+		r = src1[x + 1];
+
+		g = (g + g2) / 2;
+
+		SWSTATS_ACCUMULATE_LINE_STATS(1)
+	}
+
+	SWSTATS_FINISH_LINE_STATS()
+}
+
+void SwStatsCpu::statsBGGR10Line0(const uint8_t *src[])
+{
+	const uint16_t *src0 = (const uint16_t *)src[1] + window_.x;
+	const uint16_t *src1 = (const uint16_t *)src[2] + window_.x;
+
+	SWSTATS_START_LINE_STATS(uint16_t)
+
+	if (swapLines_)
+		std::swap(src0, src1);
+
+	/* x += 4 sample every other 2x2 block */
+	for (int x = 0; x < (int)window_.width; x += 4) {
+		b = src0[x];
+		g = src0[x + 1];
+		g2 = src1[x];
+		r = src1[x + 1];
+
+		g = (g + g2) / 2;
+
+		/* divide Y by 4 for 10 -> 8 bpp value */
+		SWSTATS_ACCUMULATE_LINE_STATS(4)
+	}
+
+	SWSTATS_FINISH_LINE_STATS()
+}
+
+void SwStatsCpu::statsBGGR12Line0(const uint8_t *src[])
+{
+	const uint16_t *src0 = (const uint16_t *)src[1] + window_.x;
+	const uint16_t *src1 = (const uint16_t *)src[2] + window_.x;
+
+	SWSTATS_START_LINE_STATS(uint16_t)
+
+	if (swapLines_)
+		std::swap(src0, src1);
+
+	/* x += 4 sample every other 2x2 block */
+	for (int x = 0; x < (int)window_.width; x += 4) {
+		b = src0[x];
+		g = src0[x + 1];
+		g2 = src1[x];
+		r = src1[x + 1];
+
+		g = (g + g2) / 2;
+
+		/* divide Y by 16 for 12 -> 8 bpp value */
+		SWSTATS_ACCUMULATE_LINE_STATS(16)
+	}
+
+	SWSTATS_FINISH_LINE_STATS()
+}
+
+void SwStatsCpu::statsBGGR10PLine0(const uint8_t *src[])
+{
+	const uint8_t *src0 = src[1] + window_.x * 5 / 4;
+	const uint8_t *src1 = src[2] + window_.x * 5 / 4;
+	const int widthInBytes = window_.width * 5 / 4;
+
+	if (swapLines_)
+		std::swap(src0, src1);
+
+	SWSTATS_START_LINE_STATS(uint8_t)
+
+	/* x += 5 sample every other 2x2 block */
+	for (int x = 0; x < widthInBytes; x += 5) {
+		/* BGGR */
+		b = src0[x];
+		g = src0[x + 1];
+		g2 = src1[x];
+		r = src1[x + 1];
+		g = (g + g2) / 2;
+		/* Data is already 8 bits, divide by 1 */
+		SWSTATS_ACCUMULATE_LINE_STATS(1)
+	}
+
+	SWSTATS_FINISH_LINE_STATS()
+}
+
+void SwStatsCpu::statsGBRG10PLine0(const uint8_t *src[])
+{
+	const uint8_t *src0 = src[1] + window_.x * 5 / 4;
+	const uint8_t *src1 = src[2] + window_.x * 5 / 4;
+	const int widthInBytes = window_.width * 5 / 4;
+
+	if (swapLines_)
+		std::swap(src0, src1);
+
+	SWSTATS_START_LINE_STATS(uint8_t)
+
+	/* x += 5 sample every other 2x2 block */
+	for (int x = 0; x < widthInBytes; x += 5) {
+		/* GBRG */
+		g = src0[x];
+		b = src0[x + 1];
+		r = src1[x];
+		g2 = src1[x + 1];
+		g = (g + g2) / 2;
+		/* Data is already 8 bits, divide by 1 */
+		SWSTATS_ACCUMULATE_LINE_STATS(1)
+	}
+
+	SWSTATS_FINISH_LINE_STATS()
+}
+
+/**
+ * \brief Reset state to start statistics gathering for a new frame
+ *
+ * This may only be called after a successful setWindow() call.
+ */
+void SwStatsCpu::startFrame(void)
+{
+	if (window_.width == 0)
+		LOG(SwStatsCpu, Error) << "Calling startFrame() without setWindow()";
+
+	stats_.sumR_ = 0;
+	stats_.sumB_ = 0;
+	stats_.sumG_ = 0;
+	stats_.yHistogram.fill(0);
+}
+
+/**
+ * \brief Finish statistics calculation for the current frame
+ *
+ * This may only be called after a successful setWindow() call.
+ */
+void SwStatsCpu::finishFrame(void)
+{
+	*sharedStats_ = stats_;
+	statsReady.emit();
+}
+
+/**
+ * \brief Setup SwStatsCpu object for standard Bayer orders
+ * \param[in] order The Bayer order
+ *
+ * Check if order is a standard Bayer order and setup xShift_ and swapLines_
+ * so that a single BGGR stats function can be used for all 4 standard orders.
+ */
+int SwStatsCpu::setupStandardBayerOrder(BayerFormat::Order order)
+{
+	switch (order) {
+	case BayerFormat::BGGR:
+		xShift_ = 0;
+		swapLines_ = false;
+		break;
+	case BayerFormat::GBRG:
+		xShift_ = 1; /* BGGR -> GBRG */
+		swapLines_ = false;
+		break;
+	case BayerFormat::GRBG:
+		xShift_ = 0;
+		swapLines_ = true; /* BGGR -> GRBG */
+		break;
+	case BayerFormat::RGGB:
+		xShift_ = 1; /* BGGR -> GBRG */
+		swapLines_ = true; /* GBRG -> RGGB */
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	patternSize_.height = 2;
+	patternSize_.width = 2;
+	ySkipMask_ = 0x02; /* Skip every 3th and 4th line */
+	return 0;
+}
+
+/**
+ * \brief Configure the statistics object for the passed in input format
+ * \param[in] inputCfg The input format
+ *
+ * \return 0 on success, a negative errno value on failure
+ */
+int SwStatsCpu::configure(const StreamConfiguration &inputCfg)
+{
+	BayerFormat bayerFormat =
+		BayerFormat::fromPixelFormat(inputCfg.pixelFormat);
+
+	if (bayerFormat.packing == BayerFormat::Packing::None &&
+	    setupStandardBayerOrder(bayerFormat.order) == 0) {
+		switch (bayerFormat.bitDepth) {
+		case 8:
+			stats0_ = &SwStatsCpu::statsBGGR8Line0;
+			return 0;
+		case 10:
+			stats0_ = &SwStatsCpu::statsBGGR10Line0;
+			return 0;
+		case 12:
+			stats0_ = &SwStatsCpu::statsBGGR12Line0;
+			return 0;
+		}
+	}
+
+	if (bayerFormat.bitDepth == 10 &&
+	    bayerFormat.packing == BayerFormat::Packing::CSI2) {
+		patternSize_.height = 2;
+		patternSize_.width = 4; /* 5 bytes per *4* pixels */
+		/* Skip every 3th and 4th line, sample every other 2x2 block */
+		ySkipMask_ = 0x02;
+		xShift_ = 0;
+
+		switch (bayerFormat.order) {
+		case BayerFormat::BGGR:
+		case BayerFormat::GRBG:
+			stats0_ = &SwStatsCpu::statsBGGR10PLine0;
+			swapLines_ = bayerFormat.order == BayerFormat::GRBG;
+			return 0;
+		case BayerFormat::GBRG:
+		case BayerFormat::RGGB:
+			stats0_ = &SwStatsCpu::statsGBRG10PLine0;
+			swapLines_ = bayerFormat.order == BayerFormat::RGGB;
+			return 0;
+		default:
+			break;
+		}
+	}
+
+	LOG(SwStatsCpu, Info)
+		<< "Unsupported input format " << inputCfg.pixelFormat.toString();
+	return -EINVAL;
+}
+
+/**
+ * \brief Specify window coordinates over which to gather statistics
+ * \param[in] window The window object.
+ */
+void SwStatsCpu::setWindow(const Rectangle &window)
+{
+	window_ = window;
+
+	window_.x &= ~(patternSize_.width - 1);
+	window_.x += xShift_;
+	window_.y &= ~(patternSize_.height - 1);
+
+	/* width_ - xShift_ to make sure the window fits */
+	window_.width -= xShift_;
+	window_.width &= ~(patternSize_.width - 1);
+	window_.height &= ~(patternSize_.height - 1);
+}
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/software_isp/swstats_cpu.h 0.3.0-1/src/libcamera/software_isp/swstats_cpu.h
--- 0.2.0-3/src/libcamera/software_isp/swstats_cpu.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/src/libcamera/software_isp/swstats_cpu.h	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,97 @@
+/* SPDX-License-Identifier: LGPL-2.1-or-later */
+/*
+ * Copyright (C) 2023, Linaro Ltd
+ * Copyright (C) 2023, Red Hat Inc.
+ *
+ * Authors:
+ * Hans de Goede <hdegoede@redhat.com>
+ *
+ * CPU based software statistics implementation
+ */
+
+#pragma once
+
+#include <stdint.h>
+
+#include <libcamera/base/signal.h>
+
+#include <libcamera/geometry.h>
+
+#include "libcamera/internal/bayer_format.h"
+#include "libcamera/internal/shared_mem_object.h"
+#include "libcamera/internal/software_isp/swisp_stats.h"
+
+namespace libcamera {
+
+class PixelFormat;
+struct StreamConfiguration;
+
+class SwStatsCpu
+{
+public:
+	SwStatsCpu();
+	~SwStatsCpu() = default;
+
+	bool isValid() const { return sharedStats_.fd().isValid(); }
+
+	const SharedFD &getStatsFD() { return sharedStats_.fd(); }
+
+	const Size &patternSize() { return patternSize_; }
+
+	int configure(const StreamConfiguration &inputCfg);
+	void setWindow(const Rectangle &window);
+	void startFrame();
+	void finishFrame();
+
+	void processLine0(unsigned int y, const uint8_t *src[])
+	{
+		if ((y & ySkipMask_) || y < static_cast<unsigned int>(window_.y) ||
+		    y >= (window_.y + window_.height))
+			return;
+
+		(this->*stats0_)(src);
+	}
+
+	void processLine2(unsigned int y, const uint8_t *src[])
+	{
+		if ((y & ySkipMask_) || y < static_cast<unsigned int>(window_.y) ||
+		    y >= (window_.y + window_.height))
+			return;
+
+		(this->*stats2_)(src);
+	}
+
+	Signal<> statsReady;
+
+private:
+	using statsProcessFn = void (SwStatsCpu::*)(const uint8_t *src[]);
+
+	int setupStandardBayerOrder(BayerFormat::Order order);
+	/* Bayer 8 bpp unpacked */
+	void statsBGGR8Line0(const uint8_t *src[]);
+	/* Bayer 10 bpp unpacked */
+	void statsBGGR10Line0(const uint8_t *src[]);
+	/* Bayer 12 bpp unpacked */
+	void statsBGGR12Line0(const uint8_t *src[]);
+	/* Bayer 10 bpp packed */
+	void statsBGGR10PLine0(const uint8_t *src[]);
+	void statsGBRG10PLine0(const uint8_t *src[]);
+
+	/* Variables set by configure(), used every line */
+	statsProcessFn stats0_;
+	statsProcessFn stats2_;
+	bool swapLines_;
+
+	unsigned int ySkipMask_;
+
+	Rectangle window_;
+
+	Size patternSize_;
+
+	unsigned int xShift_;
+
+	SharedMemObject<SwIspStats> sharedStats_;
+	SwIspStats stats_;
+};
+
+} /* namespace libcamera */
diff -pruN 0.2.0-3/src/libcamera/source_paths.cpp 0.3.0-1/src/libcamera/source_paths.cpp
--- 0.2.0-3/src/libcamera/source_paths.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/source_paths.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * source_paths.cpp - Identify libcamera source and build paths
+ * Identify libcamera source and build paths
  */
 
 #include "libcamera/internal/source_paths.h"
diff -pruN 0.2.0-3/src/libcamera/stream.cpp 0.3.0-1/src/libcamera/stream.cpp
--- 0.2.0-3/src/libcamera/stream.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/stream.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * stream.cpp - Video stream for a Camera
+ * Video stream for a Camera
  */
 
 #include <libcamera/stream.h>
@@ -433,7 +433,7 @@ std::ostream &operator<<(std::ostream &o
 		"Viewfinder",
 	};
 
-	out << names[static_cast<std::underlying_type_t<StreamRole>>(role)];
+	out << names[utils::to_underlying(role)];
 	return out;
 }
 
diff -pruN 0.2.0-3/src/libcamera/sysfs.cpp 0.3.0-1/src/libcamera/sysfs.cpp
--- 0.2.0-3/src/libcamera/sysfs.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/sysfs.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * sysfs.cpp - Miscellaneous utility functions to access sysfs
+ * Miscellaneous utility functions to access sysfs
  */
 
 #include "libcamera/internal/sysfs.h"
diff -pruN 0.2.0-3/src/libcamera/tracepoints.cpp 0.3.0-1/src/libcamera/tracepoints.cpp
--- 0.2.0-3/src/libcamera/tracepoints.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/tracepoints.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * tracepoints.cpp - Tracepoints with lttng
+ * Tracepoints with lttng
  */
 #define TRACEPOINT_CREATE_PROBES
 #define TRACEPOINT_DEFINE
diff -pruN 0.2.0-3/src/libcamera/transform.cpp 0.3.0-1/src/libcamera/transform.cpp
--- 0.2.0-3/src/libcamera/transform.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/transform.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * transform.cpp - 2D plane transforms.
+ * 2D plane transforms.
  */
 
 #include <libcamera/transform.h>
diff -pruN 0.2.0-3/src/libcamera/v4l2_device.cpp 0.3.0-1/src/libcamera/v4l2_device.cpp
--- 0.2.0-3/src/libcamera/v4l2_device.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/v4l2_device.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_device.cpp - Common base for V4L2 video devices and subdevices
+ * Common base for V4L2 video devices and subdevices
  */
 
 #include "libcamera/internal/v4l2_device.h"
diff -pruN 0.2.0-3/src/libcamera/v4l2_pixelformat.cpp 0.3.0-1/src/libcamera/v4l2_pixelformat.cpp
--- 0.2.0-3/src/libcamera/v4l2_pixelformat.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/v4l2_pixelformat.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
  * Copyright (C) 2019, Google Inc.
  * Copyright (C) 2020, Raspberry Pi Ltd
  *
- * v4l2_pixelformat.cpp - V4L2 Pixel Format
+ * V4L2 Pixel Format
  */
 
 #include "libcamera/internal/v4l2_pixelformat.h"
@@ -71,6 +71,10 @@ const std::map<V4L2PixelFormat, V4L2Pixe
 		{ formats::BGRA8888, "32-bit ARGB 8-8-8-8" } },
 	{ V4L2PixelFormat(V4L2_PIX_FMT_BGRA32),
 		{ formats::RGBA8888, "32-bit ABGR 8-8-8-8" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_RGB48),
+		{ formats::BGR161616, "48-bit RGB 16-16-16" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_BGR48),
+		{ formats::RGB161616, "48-bit BGR 16-16-16" } },
 
 	/* YUV packed formats. */
 	{ V4L2PixelFormat(V4L2_PIX_FMT_YUYV),
@@ -135,6 +139,8 @@ const std::map<V4L2PixelFormat, V4L2Pixe
 		{ formats::R10_CSI2P, "10-bit Greyscale Packed" } },
 	{ V4L2PixelFormat(V4L2_PIX_FMT_Y12),
 		{ formats::R12, "12-bit Greyscale" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_Y16),
+		{ formats::R16, "16-bit Greyscale" } },
 
 	/* Bayer formats. */
 	{ V4L2PixelFormat(V4L2_PIX_FMT_SBGGR8),
@@ -201,6 +207,16 @@ const std::map<V4L2PixelFormat, V4L2Pixe
 		{ formats::SGRBG16, "16-bit Bayer GRGR/BGBG" } },
 	{ V4L2PixelFormat(V4L2_PIX_FMT_SRGGB16),
 		{ formats::SRGGB16, "16-bit Bayer RGRG/GBGB" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_BGGR),
+		{ formats::BGGR_PISP_COMP1, "16-bit Bayer BGBG/GRGR PiSP Compress Mode 1" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_GBRG),
+		{ formats::GBRG_PISP_COMP1, "16-bit Bayer GBGB/RGRG PiSP Compress Mode 1" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_GRBG),
+		{ formats::GRBG_PISP_COMP1, "16-bit Bayer GRGR/BGBG PiSP Compress Mode 1" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_RGGB),
+		{ formats::RGGB_PISP_COMP1, "16-bit Bayer RGRG/GBGB PiSP Compress Mode 1" } },
+	{ V4L2PixelFormat(V4L2_PIX_FMT_PISP_COMP1_MONO),
+		{ formats::MONO_PISP_COMP1, "16-bit Mono PiSP Compress Mode 1" } },
 
 	/* Compressed formats. */
 	{ V4L2PixelFormat(V4L2_PIX_FMT_MJPEG),
diff -pruN 0.2.0-3/src/libcamera/v4l2_subdevice.cpp 0.3.0-1/src/libcamera/v4l2_subdevice.cpp
--- 0.2.0-3/src/libcamera/v4l2_subdevice.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/v4l2_subdevice.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_subdevice.cpp - V4L2 Subdevice
+ * V4L2 Subdevice
  */
 
 #include "libcamera/internal/v4l2_subdevice.h"
@@ -36,110 +36,703 @@ namespace libcamera {
 
 LOG_DECLARE_CATEGORY(V4L2)
 
-namespace {
-
-/*
- * \struct V4L2SubdeviceFormatInfo
+/**
+ * \class MediaBusFormatInfo
  * \brief Information about media bus formats
- * \param bitsPerPixel Bits per pixel
- * \param name Name of MBUS format
- * \param colourEncoding Type of colour encoding
- */
-struct V4L2SubdeviceFormatInfo {
-	unsigned int bitsPerPixel;
-	const char *name;
-	PixelFormatInfo::ColourEncoding colourEncoding;
-};
+ *
+ * The MediaBusFormatInfo class groups together information describing a media
+ * bus format. It facilitates handling of media bus formats by providing data
+ * commonly used in pipeline handlers.
+ *
+ * \var MediaBusFormatInfo::name
+ * \brief The format name as a human-readable string, used as the text
+ * representation of the format
+ *
+ * \var MediaBusFormatInfo::code
+ * \brief The media bus format code described by this instance (MEDIA_BUS_FMT_*)
+ *
+ * \var MediaBusFormatInfo::type
+ * \brief The media bus format type
+ *
+ * \var MediaBusFormatInfo::bitsPerPixel
+ * \brief The average number of bits per pixel
+ *
+ * The number of bits per pixel averages the total number of bits for all
+ * colour components over the whole image, excluding any padding bits or
+ * padding pixels.
+ *
+ * For formats that transmit multiple or fractional pixels per sample, the
+ * value will differ from the bus width.
+ *
+ * Formats that don't have a fixed number of bits per pixel, such as compressed
+ * formats, or device-specific embedded data formats, report 0 in this field.
+ *
+ * \var MediaBusFormatInfo::colourEncoding
+ * \brief The colour encoding type
+ *
+ * This field is valid for Type::Image formats only.
+ */
 
-/*
- * \var formatInfoMap
- * \brief A map that associates V4L2SubdeviceFormatInfo struct to V4L2 media
- * bus codes
- */
-const std::map<uint32_t, V4L2SubdeviceFormatInfo> formatInfoMap = {
-	{ MEDIA_BUS_FMT_RGB444_2X8_PADHI_BE, { 16, "RGB444_2X8_PADHI_BE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB444_2X8_PADHI_LE, { 16, "RGB444_2X8_PADHI_LE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB555_2X8_PADHI_BE, { 16, "RGB555_2X8_PADHI_BE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB555_2X8_PADHI_LE, { 16, "RGB555_2X8_PADHI_LE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB565_1X16, { 16, "RGB565_1X16", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_BGR565_2X8_BE, { 16, "BGR565_2X8_BE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_BGR565_2X8_LE, { 16, "BGR565_2X8_LE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB565_2X8_BE, { 16, "RGB565_2X8_BE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB565_2X8_LE, { 16, "RGB565_2X8_LE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB666_1X18, { 18, "RGB666_1X18", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_BGR888_1X24, { 24, "BGR888_1X24", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB888_1X24, { 24, "RGB888_1X24", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB888_2X12_BE, { 24, "RGB888_2X12_BE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_RGB888_2X12_LE, { 24, "RGB888_2X12_LE", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_ARGB8888_1X32, { 32, "ARGB8888_1X32", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_Y8_1X8, { 8, "Y8_1X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UV8_1X8, { 8, "UV8_1X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY8_1_5X8, { 12, "UYVY8_1_5X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY8_1_5X8, { 12, "VYUY8_1_5X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV8_1_5X8, { 12, "YUYV8_1_5X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU8_1_5X8, { 12, "YVYU8_1_5X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY8_2X8, { 16, "UYVY8_2X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY8_2X8, { 16, "VYUY8_2X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV8_2X8, { 16, "YUYV8_2X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU8_2X8, { 16, "YVYU8_2X8", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_Y10_1X10, { 10, "Y10_1X10", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY10_2X10, { 20, "UYVY10_2X10", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY10_2X10, { 20, "VYUY10_2X10", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV10_2X10, { 20, "YUYV10_2X10", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU10_2X10, { 20, "YVYU10_2X10", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_Y12_1X12, { 12, "Y12_1X12", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY8_1X16, { 16, "UYVY8_1X16", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY8_1X16, { 16, "VYUY8_1X16", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV8_1X16, { 16, "YUYV8_1X16", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU8_1X16, { 16, "YVYU8_1X16", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YDYUYDYV8_1X16, { 16, "YDYUYDYV8_1X16", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY10_1X20, { 20, "UYVY10_1X20", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY10_1X20, { 20, "VYUY10_1X20", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV10_1X20, { 20, "YUYV10_1X20", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU10_1X20, { 20, "YVYU10_1X20", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUV8_1X24, { 24, "YUV8_1X24", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUV10_1X30, { 30, "YUV10_1X30", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_AYUV8_1X32, { 32, "AYUV8_1X32", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY12_2X12, { 24, "UYVY12_2X12", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY12_2X12, { 24, "VYUY12_2X12", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV12_2X12, { 24, "YUYV12_2X12", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU12_2X12, { 24, "YVYU12_2X12", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_UYVY12_1X24, { 24, "UYVY12_1X24", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_VYUY12_1X24, { 24, "VYUY12_1X24", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YUYV12_1X24, { 24, "YUYV12_1X24", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_YVYU12_1X24, { 24, "YVYU12_1X24", PixelFormatInfo::ColourEncodingYUV } },
-	{ MEDIA_BUS_FMT_SBGGR8_1X8, { 8, "SBGGR8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGBRG8_1X8, { 8, "SGBRG8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGRBG8_1X8, { 8, "SGRBG8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SRGGB8_1X8, { 8, "SRGGB8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_ALAW8_1X8, { 8, "SBGGR10_ALAW8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGBRG10_ALAW8_1X8, { 8, "SGBRG10_ALAW8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGRBG10_ALAW8_1X8, { 8, "SGRBG10_ALAW8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SRGGB10_ALAW8_1X8, { 8, "SRGGB10_ALAW8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_DPCM8_1X8, { 8, "SBGGR10_DPCM8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGBRG10_DPCM8_1X8, { 8, "SGBRG10_DPCM8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGRBG10_DPCM8_1X8, { 8, "SGRBG10_DPCM8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SRGGB10_DPCM8_1X8, { 8, "SRGGB10_DPCM8_1X8", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADHI_BE, { 16, "SBGGR10_2X8_PADHI_BE", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADHI_LE, { 16, "SBGGR10_2X8_PADHI_LE", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADLO_BE, { 16, "SBGGR10_2X8_PADLO_BE", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADLO_LE, { 16, "SBGGR10_2X8_PADLO_LE", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR10_1X10, { 10, "SBGGR10_1X10", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGBRG10_1X10, { 10, "SGBRG10_1X10", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGRBG10_1X10, { 10, "SGRBG10_1X10", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SRGGB10_1X10, { 10, "SRGGB10_1X10", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SBGGR12_1X12, { 12, "SBGGR12_1X12", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGBRG12_1X12, { 12, "SGBRG12_1X12", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SGRBG12_1X12, { 12, "SGRBG12_1X12", PixelFormatInfo::ColourEncodingRAW } },
-	{ MEDIA_BUS_FMT_SRGGB12_1X12, { 12, "SRGGB12_1X12", PixelFormatInfo::ColourEncodingRAW } },
+/**
+ * \enum MediaBusFormatInfo::Type
+ * \brief The format type
+ *
+ * \var MediaBusFormatInfo::Type::Image
+ * \brief The format describes image data
+ *
+ * \var MediaBusFormatInfo::Type::Metadata
+ * \brief The format describes generic metadata
+ *
+ * \var MediaBusFormatInfo::Type::EmbeddedData
+ * \brief The format describes sensor embedded data
+ */
+
+namespace {
+
+const std::map<uint32_t, MediaBusFormatInfo> mediaBusFormatInfo{
+	/* This table is sorted to match the order in linux/media-bus-format.h */
+	{ MEDIA_BUS_FMT_RGB444_2X8_PADHI_BE, {
+		.name = "RGB444_2X8_PADHI_BE",
+		.code = MEDIA_BUS_FMT_RGB444_2X8_PADHI_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB444_2X8_PADHI_LE, {
+		.name = "RGB444_2X8_PADHI_LE",
+		.code = MEDIA_BUS_FMT_RGB444_2X8_PADHI_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB555_2X8_PADHI_BE, {
+		.name = "RGB555_2X8_PADHI_BE",
+		.code = MEDIA_BUS_FMT_RGB555_2X8_PADHI_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB555_2X8_PADHI_LE, {
+		.name = "RGB555_2X8_PADHI_LE",
+		.code = MEDIA_BUS_FMT_RGB555_2X8_PADHI_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB565_1X16, {
+		.name = "RGB565_1X16",
+		.code = MEDIA_BUS_FMT_RGB565_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_BGR565_2X8_BE, {
+		.name = "BGR565_2X8_BE",
+		.code = MEDIA_BUS_FMT_BGR565_2X8_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_BGR565_2X8_LE, {
+		.name = "BGR565_2X8_LE",
+		.code = MEDIA_BUS_FMT_BGR565_2X8_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB565_2X8_BE, {
+		.name = "RGB565_2X8_BE",
+		.code = MEDIA_BUS_FMT_RGB565_2X8_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB565_2X8_LE, {
+		.name = "RGB565_2X8_LE",
+		.code = MEDIA_BUS_FMT_RGB565_2X8_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB666_1X18, {
+		.name = "RGB666_1X18",
+		.code = MEDIA_BUS_FMT_RGB666_1X18,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 18,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_BGR888_1X24, {
+		.name = "BGR888_1X24",
+		.code = MEDIA_BUS_FMT_BGR888_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB888_1X24, {
+		.name = "RGB888_1X24",
+		.code = MEDIA_BUS_FMT_RGB888_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB888_2X12_BE, {
+		.name = "RGB888_2X12_BE",
+		.code = MEDIA_BUS_FMT_RGB888_2X12_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_RGB888_2X12_LE, {
+		.name = "RGB888_2X12_LE",
+		.code = MEDIA_BUS_FMT_RGB888_2X12_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_ARGB8888_1X32, {
+		.name = "ARGB8888_1X32",
+		.code = MEDIA_BUS_FMT_ARGB8888_1X32,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 32,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_Y8_1X8, {
+		.name = "Y8_1X8",
+		.code = MEDIA_BUS_FMT_Y8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UV8_1X8, {
+		.name = "UV8_1X8",
+		.code = MEDIA_BUS_FMT_UV8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY8_1_5X8, {
+		.name = "UYVY8_1_5X8",
+		.code = MEDIA_BUS_FMT_UYVY8_1_5X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY8_1_5X8, {
+		.name = "VYUY8_1_5X8",
+		.code = MEDIA_BUS_FMT_VYUY8_1_5X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV8_1_5X8, {
+		.name = "YUYV8_1_5X8",
+		.code = MEDIA_BUS_FMT_YUYV8_1_5X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU8_1_5X8, {
+		.name = "YVYU8_1_5X8",
+		.code = MEDIA_BUS_FMT_YVYU8_1_5X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY8_2X8, {
+		.name = "UYVY8_2X8",
+		.code = MEDIA_BUS_FMT_UYVY8_2X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY8_2X8, {
+		.name = "VYUY8_2X8",
+		.code = MEDIA_BUS_FMT_VYUY8_2X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV8_2X8, {
+		.name = "YUYV8_2X8",
+		.code = MEDIA_BUS_FMT_YUYV8_2X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU8_2X8, {
+		.name = "YVYU8_2X8",
+		.code = MEDIA_BUS_FMT_YVYU8_2X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_Y10_1X10, {
+		.name = "Y10_1X10",
+		.code = MEDIA_BUS_FMT_Y10_1X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 10,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY10_2X10, {
+		.name = "UYVY10_2X10",
+		.code = MEDIA_BUS_FMT_UYVY10_2X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY10_2X10, {
+		.name = "VYUY10_2X10",
+		.code = MEDIA_BUS_FMT_VYUY10_2X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV10_2X10, {
+		.name = "YUYV10_2X10",
+		.code = MEDIA_BUS_FMT_YUYV10_2X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU10_2X10, {
+		.name = "YVYU10_2X10",
+		.code = MEDIA_BUS_FMT_YVYU10_2X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_Y12_1X12, {
+		.name = "Y12_1X12",
+		.code = MEDIA_BUS_FMT_Y12_1X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_Y16_1X16, {
+		.name = "Y16_1X16",
+		.code = MEDIA_BUS_FMT_Y16_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY8_1X16, {
+		.name = "UYVY8_1X16",
+		.code = MEDIA_BUS_FMT_UYVY8_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY8_1X16, {
+		.name = "VYUY8_1X16",
+		.code = MEDIA_BUS_FMT_VYUY8_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV8_1X16, {
+		.name = "YUYV8_1X16",
+		.code = MEDIA_BUS_FMT_YUYV8_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU8_1X16, {
+		.name = "YVYU8_1X16",
+		.code = MEDIA_BUS_FMT_YVYU8_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YDYUYDYV8_1X16, {
+		.name = "YDYUYDYV8_1X16",
+		.code = MEDIA_BUS_FMT_YDYUYDYV8_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY10_1X20, {
+		.name = "UYVY10_1X20",
+		.code = MEDIA_BUS_FMT_UYVY10_1X20,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY10_1X20, {
+		.name = "VYUY10_1X20",
+		.code = MEDIA_BUS_FMT_VYUY10_1X20,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV10_1X20, {
+		.name = "YUYV10_1X20",
+		.code = MEDIA_BUS_FMT_YUYV10_1X20,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU10_1X20, {
+		.name = "YVYU10_1X20",
+		.code = MEDIA_BUS_FMT_YVYU10_1X20,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 20,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUV8_1X24, {
+		.name = "YUV8_1X24",
+		.code = MEDIA_BUS_FMT_YUV8_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUV10_1X30, {
+		.name = "YUV10_1X30",
+		.code = MEDIA_BUS_FMT_YUV10_1X30,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 30,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_AYUV8_1X32, {
+		.name = "AYUV8_1X32",
+		.code = MEDIA_BUS_FMT_AYUV8_1X32,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 32,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY12_2X12, {
+		.name = "UYVY12_2X12",
+		.code = MEDIA_BUS_FMT_UYVY12_2X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY12_2X12, {
+		.name = "VYUY12_2X12",
+		.code = MEDIA_BUS_FMT_VYUY12_2X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV12_2X12, {
+		.name = "YUYV12_2X12",
+		.code = MEDIA_BUS_FMT_YUYV12_2X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU12_2X12, {
+		.name = "YVYU12_2X12",
+		.code = MEDIA_BUS_FMT_YVYU12_2X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_UYVY12_1X24, {
+		.name = "UYVY12_1X24",
+		.code = MEDIA_BUS_FMT_UYVY12_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_VYUY12_1X24, {
+		.name = "VYUY12_1X24",
+		.code = MEDIA_BUS_FMT_VYUY12_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YUYV12_1X24, {
+		.name = "YUYV12_1X24",
+		.code = MEDIA_BUS_FMT_YUYV12_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_YVYU12_1X24, {
+		.name = "YVYU12_1X24",
+		.code = MEDIA_BUS_FMT_YVYU12_1X24,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 24,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR8_1X8, {
+		.name = "SBGGR8_1X8",
+		.code = MEDIA_BUS_FMT_SBGGR8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGBRG8_1X8, {
+		.name = "SGBRG8_1X8",
+		.code = MEDIA_BUS_FMT_SGBRG8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGRBG8_1X8, {
+		.name = "SGRBG8_1X8",
+		.code = MEDIA_BUS_FMT_SGRBG8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SRGGB8_1X8, {
+		.name = "SRGGB8_1X8",
+		.code = MEDIA_BUS_FMT_SRGGB8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_ALAW8_1X8, {
+		.name = "SBGGR10_ALAW8_1X8",
+		.code = MEDIA_BUS_FMT_SBGGR10_ALAW8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGBRG10_ALAW8_1X8, {
+		.name = "SGBRG10_ALAW8_1X8",
+		.code = MEDIA_BUS_FMT_SGBRG10_ALAW8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGRBG10_ALAW8_1X8, {
+		.name = "SGRBG10_ALAW8_1X8",
+		.code = MEDIA_BUS_FMT_SGRBG10_ALAW8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SRGGB10_ALAW8_1X8, {
+		.name = "SRGGB10_ALAW8_1X8",
+		.code = MEDIA_BUS_FMT_SRGGB10_ALAW8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_DPCM8_1X8, {
+		.name = "SBGGR10_DPCM8_1X8",
+		.code = MEDIA_BUS_FMT_SBGGR10_DPCM8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGBRG10_DPCM8_1X8, {
+		.name = "SGBRG10_DPCM8_1X8",
+		.code = MEDIA_BUS_FMT_SGBRG10_DPCM8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGRBG10_DPCM8_1X8, {
+		.name = "SGRBG10_DPCM8_1X8",
+		.code = MEDIA_BUS_FMT_SGRBG10_DPCM8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SRGGB10_DPCM8_1X8, {
+		.name = "SRGGB10_DPCM8_1X8",
+		.code = MEDIA_BUS_FMT_SRGGB10_DPCM8_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADHI_BE, {
+		.name = "SBGGR10_2X8_PADHI_BE",
+		.code = MEDIA_BUS_FMT_SBGGR10_2X8_PADHI_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADHI_LE, {
+		.name = "SBGGR10_2X8_PADHI_LE",
+		.code = MEDIA_BUS_FMT_SBGGR10_2X8_PADHI_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADLO_BE, {
+		.name = "SBGGR10_2X8_PADLO_BE",
+		.code = MEDIA_BUS_FMT_SBGGR10_2X8_PADLO_BE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_2X8_PADLO_LE, {
+		.name = "SBGGR10_2X8_PADLO_LE",
+		.code = MEDIA_BUS_FMT_SBGGR10_2X8_PADLO_LE,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR10_1X10, {
+		.name = "SBGGR10_1X10",
+		.code = MEDIA_BUS_FMT_SBGGR10_1X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 10,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGBRG10_1X10, {
+		.name = "SGBRG10_1X10",
+		.code = MEDIA_BUS_FMT_SGBRG10_1X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 10,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGRBG10_1X10, {
+		.name = "SGRBG10_1X10",
+		.code = MEDIA_BUS_FMT_SGRBG10_1X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 10,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SRGGB10_1X10, {
+		.name = "SRGGB10_1X10",
+		.code = MEDIA_BUS_FMT_SRGGB10_1X10,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 10,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR12_1X12, {
+		.name = "SBGGR12_1X12",
+		.code = MEDIA_BUS_FMT_SBGGR12_1X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGBRG12_1X12, {
+		.name = "SGBRG12_1X12",
+		.code = MEDIA_BUS_FMT_SGBRG12_1X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGRBG12_1X12, {
+		.name = "SGRBG12_1X12",
+		.code = MEDIA_BUS_FMT_SGRBG12_1X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SRGGB12_1X12, {
+		.name = "SRGGB12_1X12",
+		.code = MEDIA_BUS_FMT_SRGGB12_1X12,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 12,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR14_1X14, {
+		.name = "SBGGR14_1X14",
+		.code = MEDIA_BUS_FMT_SBGGR14_1X14,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 14,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGBRG14_1X14, {
+		.name = "SGBRG14_1X14",
+		.code = MEDIA_BUS_FMT_SGBRG14_1X14,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 14,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SGRBG14_1X14, {
+		.name = "SGRBG14_1X14",
+		.code = MEDIA_BUS_FMT_SGRBG14_1X14,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 14,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SRGGB14_1X14, {
+		.name = "SRGGB14_1X14",
+		.code = MEDIA_BUS_FMT_SRGGB14_1X14,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 14,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
+	{ MEDIA_BUS_FMT_SBGGR16_1X16, {
+		.name = "SBGGR16_1X16",
+		.code = MEDIA_BUS_FMT_SBGGR16_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW
+	} },
+	{ MEDIA_BUS_FMT_SGBRG16_1X16, {
+		.name = "SGBRG16_1X16",
+		.code = MEDIA_BUS_FMT_SGBRG16_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW
+	} },
+	{ MEDIA_BUS_FMT_SGRBG16_1X16, {
+		.name = "SGRBG16_1X16",
+		.code = MEDIA_BUS_FMT_SGRBG16_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW
+	} },
+	{ MEDIA_BUS_FMT_SRGGB16_1X16, {
+		.name = "SRGGB16_1X16",
+		.code = MEDIA_BUS_FMT_SRGGB16_1X16,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 16,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW
+	} },
 	/* \todo Clarify colour encoding for HSV formats */
-	{ MEDIA_BUS_FMT_AHSV8888_1X32, { 32, "AHSV8888_1X32", PixelFormatInfo::ColourEncodingRGB } },
-	{ MEDIA_BUS_FMT_JPEG_1X8, { 8, "JPEG_1X8", PixelFormatInfo::ColourEncodingYUV } },
+	{ MEDIA_BUS_FMT_AHSV8888_1X32, {
+		.name = "AHSV8888_1X32",
+		.code = MEDIA_BUS_FMT_AHSV8888_1X32,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 32,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRGB,
+	} },
+	{ MEDIA_BUS_FMT_JPEG_1X8, {
+		.name = "JPEG_1X8",
+		.code = MEDIA_BUS_FMT_JPEG_1X8,
+		.type = MediaBusFormatInfo::Type::Image,
+		.bitsPerPixel = 8,
+		.colourEncoding = PixelFormatInfo::ColourEncodingYUV,
+	} },
+	{ MEDIA_BUS_FMT_METADATA_FIXED, {
+		.name = "METADATA_FIXED",
+		.code = MEDIA_BUS_FMT_METADATA_FIXED,
+		.type = MediaBusFormatInfo::Type::Metadata,
+		.bitsPerPixel = 0,
+		.colourEncoding = PixelFormatInfo::ColourEncodingRAW,
+	} },
 };
 
 } /* namespace */
 
 /**
+ * \fn bool MediaBusFormatInfo::isValid() const
+ * \brief Check if the media bus format info is valid
+ * \return True if the media bus format info is valid, false otherwise
+ */
+
+/**
+ * \brief Retrieve information about a media bus format
+ * \param[in] code The media bus format code
+ * \return The MediaBusFormatInfo describing the \a code if known, or an invalid
+ * MediaBusFormatInfo otherwise
+ */
+const MediaBusFormatInfo &MediaBusFormatInfo::info(uint32_t code)
+{
+	static const MediaBusFormatInfo invalid{};
+
+	const auto it = mediaBusFormatInfo.find(code);
+	if (it == mediaBusFormatInfo.end()) {
+		LOG(V4L2, Warning)
+			<< "Unsupported media bus format "
+			<< utils::hex(code, 4);
+		return invalid;
+	}
+
+	return it->second;
+}
+
+/**
  * \struct V4L2SubdeviceCapability
  * \brief struct v4l2_subdev_capability object wrapper and helpers
  *
@@ -192,7 +785,7 @@ const std::map<uint32_t, V4L2SubdeviceFo
  */
 
 /**
- * \var V4L2SubdeviceFormat::mbus_code
+ * \var V4L2SubdeviceFormat::code
  * \brief The image format bus code
  */
 
@@ -229,23 +822,6 @@ const std::string V4L2SubdeviceFormat::t
 }
 
 /**
- * \brief Retrieve the number of bits per pixel for the V4L2 subdevice format
- * \return The number of bits per pixel for the format, or 0 if the format is
- * not supported
- */
-uint8_t V4L2SubdeviceFormat::bitsPerPixel() const
-{
-	const auto it = formatInfoMap.find(mbus_code);
-	if (it == formatInfoMap.end()) {
-		LOG(V4L2, Error) << "No information available for format '"
-				 << *this << "'";
-		return 0;
-	}
-
-	return it->second.bitsPerPixel;
-}
-
-/**
  * \brief Insert a text representation of a V4L2SubdeviceFormat into an output
  * stream
  * \param[in] out The output stream
@@ -256,10 +832,10 @@ std::ostream &operator<<(std::ostream &o
 {
 	out << f.size << "-";
 
-	const auto it = formatInfoMap.find(f.mbus_code);
+	const auto it = mediaBusFormatInfo.find(f.code);
 
-	if (it == formatInfoMap.end())
-		out << utils::hex(f.mbus_code, 4);
+	if (it == mediaBusFormatInfo.end())
+		out << utils::hex(f.code, 4);
 	else
 		out << it->second.name;
 
@@ -295,30 +871,131 @@ std::ostream &operator<<(std::ostream &o
  */
 
 /**
- * \class V4L2Subdevice::Routing
+ * \class V4L2Subdevice::Stream
+ * \brief V4L2 subdevice stream
+ *
+ * This class identifies a subdev stream, by bundling the pad number with the
+ * stream number. It is used in all stream-aware functions of the V4L2Subdevice
+ * class to identify the stream the functions operate on.
+ *
+ * \var V4L2Subdevice::Stream::pad
+ * \brief The 0-indexed pad number
+ *
+ * \var V4L2Subdevice::Stream::stream
+ * \brief The stream number
+ */
+
+/**
+ * \fn V4L2Subdevice::Stream::Stream()
+ * \brief Construct a Stream with pad and stream set to 0
+ */
+
+/**
+ * \fn V4L2Subdevice::Stream::Stream(unsigned int pad, unsigned int stream)
+ * \brief Construct a Stream with a given \a pad and \a stream number
+ * \param[in] pad The indexed pad number
+ * \param[in] stream The stream number
+ */
+
+/**
+ * \brief Compare streams for equality
+ * \return True if the two streams are equal, false otherwise
+ */
+bool operator==(const V4L2Subdevice::Stream &lhs, const V4L2Subdevice::Stream &rhs)
+{
+	return lhs.pad == rhs.pad && lhs.stream == rhs.stream;
+}
+
+/**
+ * \fn bool operator!=(const V4L2Subdevice::Stream &lhs, const V4L2Subdevice::Stream &rhs)
+ * \brief Compare streams for inequality
+ * \return True if the two streams are not equal, false otherwise
+ */
+
+/**
+ * \brief Insert a text representation of a V4L2Subdevice::Stream into an
+ * output stream
+ * \param[in] out The output stream
+ * \param[in] stream The V4L2Subdevice::Stream
+ * \return The output stream \a out
+ */
+std::ostream &operator<<(std::ostream &out, const V4L2Subdevice::Stream &stream)
+{
+	out << stream.pad << "/" << stream.stream;
+
+	return out;
+}
+
+/**
+ * \class V4L2Subdevice::Route
+ * \brief V4L2 subdevice routing table entry
+ *
+ * This class models a route in the subdevice routing table. It is similar to
+ * the v4l2_subdev_route structure, but uses the V4L2Subdevice::Stream class
+ * for easier usage with the V4L2Subdevice stream-aware functions.
+ *
+ * \var V4L2Subdevice::Route::sink
+ * \brief The sink stream of the route
+ *
+ * \var V4L2Subdevice::Route::source
+ * \brief The source stream of the route
+ *
+ * \var V4L2Subdevice::Route::flags
+ * \brief The route flags (V4L2_SUBDEV_ROUTE_FL_*)
+ */
+
+/**
+ * \fn V4L2Subdevice::Route::Route()
+ * \brief Construct a Route with default streams
+ */
+
+/**
+ * \fn V4L2Subdevice::Route::Route(const Stream &sink, const Stream &source,
+ * uint32_t flags)
+ * \brief Construct a Route from \a sink to \a source
+ * \param[in] sink The sink stream
+ * \param[in] source The source stream
+ * \param[in] flags The route flags
+ */
+
+/**
+ * \brief Insert a text representation of a V4L2Subdevice::Route into an
+ * output stream
+ * \param[in] out The output stream
+ * \param[in] route The V4L2Subdevice::Route
+ * \return The output stream \a out
+ */
+std::ostream &operator<<(std::ostream &out, const V4L2Subdevice::Route &route)
+{
+	out << route.sink << " -> " << route.source
+	    << " (" << utils::hex(route.flags) << ")";
+
+	return out;
+}
+
+/**
+ * \typedef V4L2Subdevice::Routing
  * \brief V4L2 subdevice routing table
  *
  * This class stores a subdevice routing table as a vector of routes.
  */
 
 /**
- * \brief Assemble and return a string describing the routing table
- * \return A string describing the routing table
+ * \brief Insert a text representation of a V4L2Subdevice::Routing into an
+ * output stream
+ * \param[in] out The output stream
+ * \param[in] routing The V4L2Subdevice::Routing
+ * \return The output stream \a out
  */
-std::string V4L2Subdevice::Routing::toString() const
+std::ostream &operator<<(std::ostream &out, const V4L2Subdevice::Routing &routing)
 {
-	std::stringstream routing;
-
-	for (const auto &[i, route] : utils::enumerate(*this)) {
-		routing << "[" << i << "] "
-			<< route.sink_pad << "/" << route.sink_stream << " -> "
-			<< route.source_pad << "/" << route.source_stream
-			<< " (" << utils::hex(route.flags) << ")";
-		if (i != size() - 1)
-			routing << ", ";
+	for (const auto &[i, route] : utils::enumerate(routing)) {
+		out << "[" << i << "] " << route;
+		if (i != routing.size() - 1)
+			out << ", ";
 	}
 
-	return routing.str();
+	return out;
 }
 
 /**
@@ -359,6 +1036,21 @@ int V4L2Subdevice::open()
 		return ret;
 	}
 
+	/* If the subdev supports streams, enable the streams API. */
+	if (caps_.hasStreams()) {
+		struct v4l2_subdev_client_capability clientCaps{};
+		clientCaps.capabilities = V4L2_SUBDEV_CLIENT_CAP_STREAMS;
+
+		ret = ioctl(VIDIOC_SUBDEV_S_CLIENT_CAP, &clientCaps);
+		if (ret < 0) {
+			ret = -errno;
+			LOG(V4L2, Error)
+				<< "Unable to set client capabilities: "
+				<< strerror(-ret);
+			return ret;
+		}
+	}
+
 	return 0;
 }
 
@@ -370,7 +1062,7 @@ int V4L2Subdevice::open()
 
 /**
  * \brief Get selection rectangle \a rect for \a target
- * \param[in] pad The 0-indexed pad number the rectangle is retrieved from
+ * \param[in] stream The stream the rectangle is retrieved from
  * \param[in] target The selection target defined by the V4L2_SEL_TGT_* flags
  * \param[out] rect The retrieved selection rectangle
  *
@@ -378,13 +1070,14 @@ int V4L2Subdevice::open()
  *
  * \return 0 on success or a negative error code otherwise
  */
-int V4L2Subdevice::getSelection(unsigned int pad, unsigned int target,
+int V4L2Subdevice::getSelection(const Stream &stream, unsigned int target,
 				Rectangle *rect)
 {
 	struct v4l2_subdev_selection sel = {};
 
 	sel.which = V4L2_SUBDEV_FORMAT_ACTIVE;
-	sel.pad = pad;
+	sel.pad = stream.pad;
+	sel.stream = stream.stream;
 	sel.target = target;
 	sel.flags = 0;
 
@@ -392,7 +1085,7 @@ int V4L2Subdevice::getSelection(unsigned
 	if (ret < 0) {
 		LOG(V4L2, Error)
 			<< "Unable to get rectangle " << target << " on pad "
-			<< pad << ": " << strerror(-ret);
+			<< stream << ": " << strerror(-ret);
 		return ret;
 	}
 
@@ -405,8 +1098,19 @@ int V4L2Subdevice::getSelection(unsigned
 }
 
 /**
+ * \fn V4L2Subdevice::getSelection(unsigned int pad, unsigned int target,
+ * Rectangle *rect)
+ * \brief Get selection rectangle \a rect for \a target
+ * \param[in] pad The 0-indexed pad number the rectangle is retrieved from
+ * \param[in] target The selection target defined by the V4L2_SEL_TGT_* flags
+ * \param[out] rect The retrieved selection rectangle
+ *
+ * \return 0 on success or a negative error code otherwise
+ */
+
+/**
  * \brief Set selection rectangle \a rect for \a target
- * \param[in] pad The 0-indexed pad number the rectangle is to be applied to
+ * \param[in] stream The stream the rectangle is to be applied to
  * \param[in] target The selection target defined by the V4L2_SEL_TGT_* flags
  * \param[inout] rect The selection rectangle to be applied
  *
@@ -414,13 +1118,14 @@ int V4L2Subdevice::getSelection(unsigned
  *
  * \return 0 on success or a negative error code otherwise
  */
-int V4L2Subdevice::setSelection(unsigned int pad, unsigned int target,
+int V4L2Subdevice::setSelection(const Stream &stream, unsigned int target,
 				Rectangle *rect)
 {
 	struct v4l2_subdev_selection sel = {};
 
 	sel.which = V4L2_SUBDEV_FORMAT_ACTIVE;
-	sel.pad = pad;
+	sel.pad = stream.pad;
+	sel.stream = stream.stream;
 	sel.target = target;
 	sel.flags = 0;
 
@@ -433,7 +1138,7 @@ int V4L2Subdevice::setSelection(unsigned
 	if (ret < 0) {
 		LOG(V4L2, Error)
 			<< "Unable to set rectangle " << target << " on pad "
-			<< pad << ": " << strerror(-ret);
+			<< stream << ": " << strerror(-ret);
 		return ret;
 	}
 
@@ -444,26 +1149,40 @@ int V4L2Subdevice::setSelection(unsigned
 
 	return 0;
 }
+
 /**
- * \brief Enumerate all media bus codes and frame sizes on a \a pad
- * \param[in] pad The 0-indexed pad number to enumerate formats on
+ * \fn V4L2Subdevice::setSelection(unsigned int pad, unsigned int target,
+ * Rectangle *rect)
+ * \brief Set selection rectangle \a rect for \a target
+ * \param[in] pad The 0-indexed pad number the rectangle is to be applied to
+ * \param[in] target The selection target defined by the V4L2_SEL_TGT_* flags
+ * \param[inout] rect The selection rectangle to be applied
+ *
+ * \todo Define a V4L2SelectionTarget enum for the selection target
+ *
+ * \return 0 on success or a negative error code otherwise
+ */
+
+/**
+ * \brief Enumerate all media bus codes and frame sizes on a \a stream
+ * \param[in] stream The stream to enumerate formats for
  *
  * Enumerate all media bus codes and frame sizes supported by the subdevice on
- * a \a pad.
+ * a \a stream.
  *
  * \return A list of the supported device formats
  */
-V4L2Subdevice::Formats V4L2Subdevice::formats(unsigned int pad)
+V4L2Subdevice::Formats V4L2Subdevice::formats(const Stream &stream)
 {
 	Formats formats;
 
-	if (pad >= entity_->pads().size()) {
-		LOG(V4L2, Error) << "Invalid pad: " << pad;
+	if (stream.pad >= entity_->pads().size()) {
+		LOG(V4L2, Error) << "Invalid pad: " << stream.pad;
 		return {};
 	}
 
-	for (unsigned int code : enumPadCodes(pad)) {
-		std::vector<SizeRange> sizes = enumPadSizes(pad, code);
+	for (unsigned int code : enumPadCodes(stream)) {
+		std::vector<SizeRange> sizes = enumPadSizes(stream, code);
 		if (sizes.empty())
 			return {};
 
@@ -471,7 +1190,7 @@ V4L2Subdevice::Formats V4L2Subdevice::fo
 		if (!inserted.second) {
 			LOG(V4L2, Error)
 				<< "Could not add sizes for media bus code "
-				<< code << " on pad " << pad;
+				<< code << " on pad " << stream.pad;
 			return {};
 		}
 	}
@@ -479,6 +1198,17 @@ V4L2Subdevice::Formats V4L2Subdevice::fo
 	return formats;
 }
 
+/**
+ * \fn V4L2Subdevice::formats(unsigned int pad)
+ * \brief Enumerate all media bus codes and frame sizes on a \a pad
+ * \param[in] pad The 0-indexed pad number to enumerate formats on
+ *
+ * Enumerate all media bus codes and frame sizes supported by the subdevice on
+ * a \a pad
+ *
+ * \return A list of the supported device formats
+ */
+
 std::optional<ColorSpace> V4L2Subdevice::toColorSpace(const v4l2_mbus_framefmt &format) const
 {
 	/*
@@ -494,9 +1224,9 @@ std::optional<ColorSpace> V4L2Subdevice:
 		return std::nullopt;
 
 	PixelFormatInfo::ColourEncoding colourEncoding;
-	auto iter = formatInfoMap.find(format.code);
-	if (iter != formatInfoMap.end()) {
-		colourEncoding = iter->second.colourEncoding;
+	const MediaBusFormatInfo &info = MediaBusFormatInfo::info(format.code);
+	if (info.isValid()) {
+		colourEncoding = info.colourEncoding;
 	} else {
 		LOG(V4L2, Warning)
 			<< "Unknown subdev format "
@@ -510,83 +1240,135 @@ std::optional<ColorSpace> V4L2Subdevice:
 }
 
 /**
- * \brief Retrieve the image format set on one of the V4L2 subdevice pads
- * \param[in] pad The 0-indexed pad number the format is to be retrieved from
+ * \brief Retrieve the image format set on one of the V4L2 subdevice streams
+ * \param[in] stream The stream the format is to be retrieved from
  * \param[out] format The image bus format
  * \param[in] whence The format to get, \ref V4L2Subdevice::ActiveFormat
  * "ActiveFormat" or \ref V4L2Subdevice::TryFormat "TryFormat"
  * \return 0 on success or a negative error code otherwise
  */
-int V4L2Subdevice::getFormat(unsigned int pad, V4L2SubdeviceFormat *format,
+int V4L2Subdevice::getFormat(const Stream &stream, V4L2SubdeviceFormat *format,
 			     Whence whence)
 {
 	struct v4l2_subdev_format subdevFmt = {};
 	subdevFmt.which = whence;
-	subdevFmt.pad = pad;
+	subdevFmt.pad = stream.pad;
+	subdevFmt.stream = stream.stream;
 
 	int ret = ioctl(VIDIOC_SUBDEV_G_FMT, &subdevFmt);
 	if (ret) {
 		LOG(V4L2, Error)
-			<< "Unable to get format on pad " << pad
-			<< ": " << strerror(-ret);
+			<< "Unable to get format on pad " << stream << ": "
+			<< strerror(-ret);
 		return ret;
 	}
 
 	format->size.width = subdevFmt.format.width;
 	format->size.height = subdevFmt.format.height;
-	format->mbus_code = subdevFmt.format.code;
+	format->code = subdevFmt.format.code;
 	format->colorSpace = toColorSpace(subdevFmt.format);
 
 	return 0;
 }
 
 /**
+ * \fn V4L2Subdevice::getFormat(unsigned int pad, V4L2SubdeviceFormat *format,
+ * Whence whence)
+ * \brief Retrieve the image format set on one of the V4L2 subdevice pads
+ * \param[in] pad The 0-indexed pad number the format is to be retrieved from
+ * \param[out] format The image bus format
+ * \param[in] whence The format to get, \ref V4L2Subdevice::ActiveFormat
+ * "ActiveFormat" or \ref V4L2Subdevice::TryFormat "TryFormat"
+ * \return 0 on success or a negative error code otherwise
+ */
+
+/**
  * \brief Set an image format on one of the V4L2 subdevice pads
- * \param[in] pad The 0-indexed pad number the format is to be applied to
- * \param[inout] format The image bus format to apply to the subdevice's pad
+ * \param[in] stream The stream the format is to be applied to
+ * \param[inout] format The image bus format to apply to the stream
  * \param[in] whence The format to set, \ref V4L2Subdevice::ActiveFormat
  * "ActiveFormat" or \ref V4L2Subdevice::TryFormat "TryFormat"
  *
- * Apply the requested image format to the desired media pad and return the
+ * Apply the requested image format to the desired stream and return the
  * actually applied format parameters, as getFormat() would do.
  *
  * \return 0 on success or a negative error code otherwise
  */
-int V4L2Subdevice::setFormat(unsigned int pad, V4L2SubdeviceFormat *format,
+int V4L2Subdevice::setFormat(const Stream &stream, V4L2SubdeviceFormat *format,
 			     Whence whence)
 {
 	struct v4l2_subdev_format subdevFmt = {};
 	subdevFmt.which = whence;
-	subdevFmt.pad = pad;
+	subdevFmt.pad = stream.pad;
+	subdevFmt.stream = stream.stream;
 	subdevFmt.format.width = format->size.width;
 	subdevFmt.format.height = format->size.height;
-	subdevFmt.format.code = format->mbus_code;
+	subdevFmt.format.code = format->code;
 	subdevFmt.format.field = V4L2_FIELD_NONE;
 	if (format->colorSpace) {
 		fromColorSpace(format->colorSpace, subdevFmt.format);
 
 		/* The CSC flag is only applicable to source pads. */
-		if (entity_->pads()[pad]->flags() & MEDIA_PAD_FL_SOURCE)
+		if (entity_->pads()[stream.pad]->flags() & MEDIA_PAD_FL_SOURCE)
 			subdevFmt.format.flags |= V4L2_MBUS_FRAMEFMT_SET_CSC;
 	}
 
 	int ret = ioctl(VIDIOC_SUBDEV_S_FMT, &subdevFmt);
 	if (ret) {
 		LOG(V4L2, Error)
-			<< "Unable to set format on pad " << pad
-			<< ": " << strerror(-ret);
+			<< "Unable to set format on pad " << stream << ": "
+			<< strerror(-ret);
 		return ret;
 	}
 
 	format->size.width = subdevFmt.format.width;
 	format->size.height = subdevFmt.format.height;
-	format->mbus_code = subdevFmt.format.code;
+	format->code = subdevFmt.format.code;
 	format->colorSpace = toColorSpace(subdevFmt.format);
 
 	return 0;
 }
 
 /**
+ * \fn V4L2Subdevice::setFormat(unsigned int pad, V4L2SubdeviceFormat *format,
+ * Whence whence)
+ * \brief Set an image format on one of the V4L2 subdevice pads
+ * \param[in] pad The 0-indexed pad number the format is to be applied to
+ * \param[inout] format The image bus format to apply to the subdevice's pad
+ * \param[in] whence The format to set, \ref V4L2Subdevice::ActiveFormat
+ * "ActiveFormat" or \ref V4L2Subdevice::TryFormat "TryFormat"
+ *
+ * Apply the requested image format to the desired media pad and return the
+ * actually applied format parameters, as getFormat() would do.
+ *
+ * \return 0 on success or a negative error code otherwise
+ */
+
+namespace {
+
+void routeFromKernel(V4L2Subdevice::Route &route,
+		     const struct v4l2_subdev_route &kroute)
+{
+	route.sink.pad = kroute.sink_pad;
+	route.sink.stream = kroute.sink_stream;
+	route.source.pad = kroute.source_pad;
+	route.source.stream = kroute.source_stream;
+	route.flags = kroute.flags;
+}
+
+void routeToKernel(const V4L2Subdevice::Route &route,
+		   struct v4l2_subdev_route &kroute)
+{
+	kroute.sink_pad = route.sink.pad;
+	kroute.sink_stream = route.sink.stream;
+	kroute.source_pad = route.source.pad;
+	kroute.source_stream = route.source.stream;
+	kroute.flags = route.flags;
+}
+
+} /* namespace */
+
+/**
  * \brief Retrieve the subdevice's internal routing table
  * \param[out] routing The routing table
  * \param[in] whence The routing table to get, \ref V4L2Subdevice::ActiveFormat
@@ -596,6 +1378,8 @@ int V4L2Subdevice::setFormat(unsigned in
  */
 int V4L2Subdevice::getRouting(Routing *routing, Whence whence)
 {
+	routing->clear();
+
 	if (!caps_.hasStreams())
 		return 0;
 
@@ -614,8 +1398,8 @@ int V4L2Subdevice::getRouting(Routing *r
 		return ret;
 	}
 
-	routing->resize(rt.num_routes);
-	rt.routes = reinterpret_cast<uintptr_t>(routing->data());
+	std::vector<struct v4l2_subdev_route> routes{ rt.num_routes };
+	rt.routes = reinterpret_cast<uintptr_t>(routes.data());
 
 	ret = ioctl(VIDIOC_SUBDEV_G_ROUTING, &rt);
 	if (ret) {
@@ -624,11 +1408,16 @@ int V4L2Subdevice::getRouting(Routing *r
 		return ret;
 	}
 
-	if (rt.num_routes != routing->size()) {
+	if (rt.num_routes != routes.size()) {
 		LOG(V4L2, Error) << "Invalid number of routes";
 		return -EINVAL;
 	}
 
+	routing->resize(rt.num_routes);
+
+	for (const auto &[i, route] : utils::enumerate(routes))
+		routeFromKernel((*routing)[i], route);
+
 	return 0;
 }
 
@@ -646,13 +1435,20 @@ int V4L2Subdevice::getRouting(Routing *r
  */
 int V4L2Subdevice::setRouting(Routing *routing, Whence whence)
 {
-	if (!caps_.hasStreams())
+	if (!caps_.hasStreams()) {
+		routing->clear();
 		return 0;
+	}
+
+	std::vector<struct v4l2_subdev_route> routes{ routing->size() };
+
+	for (const auto &[i, route] : utils::enumerate(*routing))
+		routeToKernel(route, routes[i]);
 
 	struct v4l2_subdev_routing rt = {};
 	rt.which = whence;
-	rt.num_routes = routing->size();
-	rt.routes = reinterpret_cast<uintptr_t>(routing->data());
+	rt.num_routes = routes.size();
+	rt.routes = reinterpret_cast<uintptr_t>(routes.data());
 
 	int ret = ioctl(VIDIOC_SUBDEV_S_ROUTING, &rt);
 	if (ret) {
@@ -660,8 +1456,12 @@ int V4L2Subdevice::setRouting(Routing *r
 		return ret;
 	}
 
+	routes.resize(rt.num_routes);
 	routing->resize(rt.num_routes);
 
+	for (const auto &[i, route] : utils::enumerate(routes))
+		routeFromKernel((*routing)[i], route);
+
 	return 0;
 }
 
@@ -747,14 +1547,15 @@ std::string V4L2Subdevice::logPrefix() c
 	return "'" + entity_->name() + "'";
 }
 
-std::vector<unsigned int> V4L2Subdevice::enumPadCodes(unsigned int pad)
+std::vector<unsigned int> V4L2Subdevice::enumPadCodes(const Stream &stream)
 {
 	std::vector<unsigned int> codes;
 	int ret;
 
 	for (unsigned int index = 0; ; index++) {
 		struct v4l2_subdev_mbus_code_enum mbusEnum = {};
-		mbusEnum.pad = pad;
+		mbusEnum.pad = stream.pad;
+		mbusEnum.stream = stream.stream;
 		mbusEnum.index = index;
 		mbusEnum.which = V4L2_SUBDEV_FORMAT_ACTIVE;
 
@@ -767,7 +1568,7 @@ std::vector<unsigned int> V4L2Subdevice:
 
 	if (ret < 0 && ret != -EINVAL) {
 		LOG(V4L2, Error)
-			<< "Unable to enumerate formats on pad " << pad
+			<< "Unable to enumerate formats on pad " << stream
 			<< ": " << strerror(-ret);
 		return {};
 	}
@@ -775,7 +1576,7 @@ std::vector<unsigned int> V4L2Subdevice:
 	return codes;
 }
 
-std::vector<SizeRange> V4L2Subdevice::enumPadSizes(unsigned int pad,
+std::vector<SizeRange> V4L2Subdevice::enumPadSizes(const Stream &stream,
 						   unsigned int code)
 {
 	std::vector<SizeRange> sizes;
@@ -784,7 +1585,8 @@ std::vector<SizeRange> V4L2Subdevice::en
 	for (unsigned int index = 0;; index++) {
 		struct v4l2_subdev_frame_size_enum sizeEnum = {};
 		sizeEnum.index = index;
-		sizeEnum.pad = pad;
+		sizeEnum.pad = stream.pad;
+		sizeEnum.stream = stream.stream;
 		sizeEnum.code = code;
 		sizeEnum.which = V4L2_SUBDEV_FORMAT_ACTIVE;
 
@@ -798,7 +1600,7 @@ std::vector<SizeRange> V4L2Subdevice::en
 
 	if (ret < 0 && ret != -EINVAL && ret != -ENOTTY) {
 		LOG(V4L2, Error)
-			<< "Unable to enumerate sizes on pad " << pad
+			<< "Unable to enumerate sizes on pad " << stream
 			<< ": " << strerror(-ret);
 		return {};
 	}
diff -pruN 0.2.0-3/src/libcamera/v4l2_videodevice.cpp 0.3.0-1/src/libcamera/v4l2_videodevice.cpp
--- 0.2.0-3/src/libcamera/v4l2_videodevice.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/v4l2_videodevice.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_videodevice.cpp - V4L2 Video Device
+ * V4L2 Video Device
  */
 
 #include "libcamera/internal/v4l2_videodevice.h"
diff -pruN 0.2.0-3/src/libcamera/version.cpp.in 0.3.0-1/src/libcamera/version.cpp.in
--- 0.2.0-3/src/libcamera/version.cpp.in	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/version.cpp.in	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * version.cpp - libcamera version
+ * libcamera version
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/src/libcamera/yaml_parser.cpp 0.3.0-1/src/libcamera/yaml_parser.cpp
--- 0.2.0-3/src/libcamera/yaml_parser.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/libcamera/yaml_parser.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * yaml_parser.cpp - libcamera YAML parsing helper
+ * libcamera YAML parsing helper
  */
 
 #include "libcamera/internal/yaml_parser.h"
diff -pruN 0.2.0-3/src/v4l2/meson.build 0.3.0-1/src/v4l2/meson.build
--- 0.2.0-3/src/v4l2/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -24,6 +24,7 @@ v4l2_compat_cpp_args = [
     '-U_FILE_OFFSET_BITS',
     '-D_FILE_OFFSET_BITS=32',
     '-D_LARGEFILE64_SOURCE',
+    '-U_TIME_BITS',
     '-fvisibility=hidden',
 ]
 
diff -pruN 0.2.0-3/src/v4l2/v4l2_camera.cpp 0.3.0-1/src/v4l2/v4l2_camera.cpp
--- 0.2.0-3/src/v4l2/v4l2_camera.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_camera.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_camera.cpp - V4L2 compatibility camera
+ * V4L2 compatibility camera
  */
 
 #include "v4l2_camera.h"
diff -pruN 0.2.0-3/src/v4l2/v4l2_camera.h 0.3.0-1/src/v4l2/v4l2_camera.h
--- 0.2.0-3/src/v4l2/v4l2_camera.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_camera.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_camera.h - V4L2 compatibility camera
+ * V4L2 compatibility camera
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/v4l2/v4l2_camera_file.cpp 0.3.0-1/src/v4l2/v4l2_camera_file.cpp
--- 0.2.0-3/src/v4l2/v4l2_camera_file.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_camera_file.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * v4l2_camera_file.h - V4L2 compatibility camera file information
+ * V4L2 compatibility camera file information
  */
 
 #include "v4l2_camera_file.h"
diff -pruN 0.2.0-3/src/v4l2/v4l2_camera_file.h 0.3.0-1/src/v4l2/v4l2_camera_file.h
--- 0.2.0-3/src/v4l2/v4l2_camera_file.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_camera_file.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * v4l2_camera_file.h - V4L2 compatibility camera file information
+ * V4L2 compatibility camera file information
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/v4l2/v4l2_camera_proxy.cpp 0.3.0-1/src/v4l2/v4l2_camera_proxy.cpp
--- 0.2.0-3/src/v4l2/v4l2_camera_proxy.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_camera_proxy.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_camera_proxy.cpp - Proxy to V4L2 compatibility camera
+ * Proxy to V4L2 compatibility camera
  */
 
 #include "v4l2_camera_proxy.h"
diff -pruN 0.2.0-3/src/v4l2/v4l2_camera_proxy.h 0.3.0-1/src/v4l2/v4l2_camera_proxy.h
--- 0.2.0-3/src/v4l2/v4l2_camera_proxy.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_camera_proxy.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_camera_proxy.h - Proxy to V4L2 compatibility camera
+ * Proxy to V4L2 compatibility camera
  */
 
 #pragma once
diff -pruN 0.2.0-3/src/v4l2/v4l2_compat.cpp 0.3.0-1/src/v4l2/v4l2_compat.cpp
--- 0.2.0-3/src/v4l2/v4l2_compat.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_compat.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_compat.cpp - V4L2 compatibility layer
+ * V4L2 compatibility layer
  */
 
 #include "v4l2_compat_manager.h"
diff -pruN 0.2.0-3/src/v4l2/v4l2_compat_manager.cpp 0.3.0-1/src/v4l2/v4l2_compat_manager.cpp
--- 0.2.0-3/src/v4l2/v4l2_compat_manager.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_compat_manager.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_compat_manager.cpp - V4L2 compatibility manager
+ * V4L2 compatibility manager
  */
 
 #include "v4l2_compat_manager.h"
diff -pruN 0.2.0-3/src/v4l2/v4l2_compat_manager.h 0.3.0-1/src/v4l2/v4l2_compat_manager.h
--- 0.2.0-3/src/v4l2/v4l2_compat_manager.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/src/v4l2/v4l2_compat_manager.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_compat_manager.h - V4L2 compatibility manager
+ * V4L2 compatibility manager
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/bayer-format.cpp 0.3.0-1/test/bayer-format.cpp
--- 0.2.0-3/test/bayer-format.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/bayer-format.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Sebastian Fricke
  *
- * bayer_format.cpp - BayerFormat class tests
+ * BayerFormat class tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/byte-stream-buffer.cpp 0.3.0-1/test/byte-stream-buffer.cpp
--- 0.2.0-3/test/byte-stream-buffer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/byte-stream-buffer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * byte_stream_buffer.cpp - ByteStreamBuffer tests
+ * ByteStreamBuffer tests
  */
 
 #include <array>
diff -pruN 0.2.0-3/test/camera-sensor.cpp 0.3.0-1/test/camera-sensor.cpp
--- 0.2.0-3/test/camera-sensor.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/camera-sensor.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera-sensor.cpp - Camera sensor tests
+ * Camera sensor tests
  */
 
 #include <algorithm>
@@ -100,7 +100,7 @@ protected:
 								  MEDIA_BUS_FMT_SBGGR10_1X10,
 								  MEDIA_BUS_FMT_BGR888_1X24 },
 								Size(1024, 768));
-		if (format.mbus_code != MEDIA_BUS_FMT_SBGGR10_1X10 ||
+		if (format.code != MEDIA_BUS_FMT_SBGGR10_1X10 ||
 		    format.size != Size(4096, 2160)) {
 			cerr << "Failed to get a suitable format, expected 4096x2160-0x"
 			     << utils::hex(MEDIA_BUS_FMT_SBGGR10_1X10)
diff -pruN 0.2.0-3/test/controls/control_info.cpp 0.3.0-1/test/controls/control_info.cpp
--- 0.2.0-3/test/controls/control_info.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/controls/control_info.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_info.cpp - ControlInfo tests
+ * ControlInfo tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/controls/control_info_map.cpp 0.3.0-1/test/controls/control_info_map.cpp
--- 0.2.0-3/test/controls/control_info_map.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/controls/control_info_map.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_info.cpp - ControlInfoMap tests
+ * ControlInfoMap tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/controls/control_list.cpp 0.3.0-1/test/controls/control_list.cpp
--- 0.2.0-3/test/controls/control_list.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/controls/control_list.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_list.cpp - ControlList tests
+ * ControlList tests
  */
 
 #include <iostream>
@@ -183,6 +183,56 @@ protected:
 			     << endl;
 			return TestFail;
 		}
+
+		if (mergeList.get(controls::Contrast) != 1.1f) {
+			cout << "Contrast control value changed after merging lists"
+			     << endl;
+			return TestFail;
+		}
+
+		if (mergeList.get(controls::Saturation) != 0.4f) {
+			cout << "Saturation control value changed after merging lists"
+			     << endl;
+			return TestFail;
+		}
+
+		/*
+		 * Create two lists with overlapping controls. Merge them with
+		 * overwriteExisting = true, verifying that the existing control
+		 * values *get* overwritten.
+		 */
+		mergeList.clear();
+		mergeList.set(controls::Brightness, 0.7f);
+		mergeList.set(controls::Saturation, 0.4f);
+
+		list.clear();
+		list.set(controls::Brightness, 0.5f);
+		list.set(controls::Contrast, 1.1f);
+
+		mergeList.merge(list, ControlList::MergePolicy::OverwriteExisting);
+		if (mergeList.size() != 3) {
+			cout << "Merged list should contain three elements" << endl;
+			return TestFail;
+		}
+
+		if (list.size() != 2) {
+			cout << "The list to merge should contain two elements"
+			     << endl;
+			return TestFail;
+		}
+
+		if (!mergeList.get(controls::Brightness) ||
+		    !mergeList.get(controls::Contrast) ||
+		    !mergeList.get(controls::Saturation)) {
+			cout << "Merged list does not contain all controls" << endl;
+			return TestFail;
+		}
+
+		if (mergeList.get(controls::Brightness) != 0.5f) {
+			cout << "Brightness control value did not change after merging lists"
+			     << endl;
+			return TestFail;
+		}
 
 		if (mergeList.get(controls::Contrast) != 1.1f) {
 			cout << "Contrast control value changed after merging lists"
diff -pruN 0.2.0-3/test/controls/control_value.cpp 0.3.0-1/test/controls/control_value.cpp
--- 0.2.0-3/test/controls/control_value.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/controls/control_value.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_value.cpp - ControlValue tests
+ * ControlValue tests
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/delayed_controls.cpp 0.3.0-1/test/delayed_controls.cpp
--- 0.2.0-3/test/delayed_controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/delayed_controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * delayed_controls.cpp - libcamera delayed controls test
+ * libcamera delayed controls test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/event-dispatcher.cpp 0.3.0-1/test/event-dispatcher.cpp
--- 0.2.0-3/test/event-dispatcher.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/event-dispatcher.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event-dispatcher.cpp - Event dispatcher test
+ * Event dispatcher test
  */
 
 #include <chrono>
diff -pruN 0.2.0-3/test/event-thread.cpp 0.3.0-1/test/event-thread.cpp
--- 0.2.0-3/test/event-thread.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/event-thread.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event-thread.cpp - Threaded event test
+ * Threaded event test
  */
 
 #include <chrono>
@@ -11,6 +11,7 @@
 #include <unistd.h>
 
 #include <libcamera/base/event_notifier.h>
+#include <libcamera/base/object.h>
 #include <libcamera/base/thread.h>
 #include <libcamera/base/timer.h>
 
@@ -84,10 +85,17 @@ private:
 class EventThreadTest : public Test
 {
 protected:
+	int init()
+	{
+		thread_.start();
+
+		handler_ = new EventHandler();
+
+		return TestPass;
+	}
+
 	int run()
 	{
-		Thread thread;
-		thread.start();
 
 		/*
 		 * Fire the event notifier and then move the notifier to a
@@ -97,23 +105,33 @@ protected:
 		 * different thread will correctly process already pending
 		 * events in the new thread.
 		 */
-		EventHandler handler;
-		handler.notify();
-		handler.moveToThread(&thread);
+		handler_->notify();
+		handler_->moveToThread(&thread_);
 
 		this_thread::sleep_for(chrono::milliseconds(100));
 
-		/* Must stop thread before destroying the handler. */
-		thread.exit(0);
-		thread.wait();
-
-		if (!handler.notified()) {
+		if (!handler_->notified()) {
 			cout << "Thread event handling test failed" << endl;
 			return TestFail;
 		}
 
 		return TestPass;
 	}
+
+	void cleanup()
+	{
+		/*
+		 * Object class instances must be destroyed from the thread
+		 * they live in.
+		 */
+		handler_->deleteLater();
+		thread_.exit(0);
+		thread_.wait();
+	}
+
+private:
+	EventHandler *handler_;
+	Thread thread_;
 };
 
 TEST_REGISTER(EventThreadTest)
diff -pruN 0.2.0-3/test/event.cpp 0.3.0-1/test/event.cpp
--- 0.2.0-3/test/event.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/event.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * event.cpp - Event test
+ * Event test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/fence.cpp 0.3.0-1/test/fence.cpp
--- 0.2.0-3/test/fence.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/fence.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * fence.cpp - Fence test
+ * Fence test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/file.cpp 0.3.0-1/test/file.cpp
--- 0.2.0-3/test/file.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/file.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * file.cpp - File I/O operations tests
+ * File I/O operations tests
  */
 
 #include <fstream>
diff -pruN 0.2.0-3/test/flags.cpp 0.3.0-1/test/flags.cpp
--- 0.2.0-3/test/flags.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/flags.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * flags.cpp - Flags tests
+ * Flags tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/geometry.cpp 0.3.0-1/test/geometry.cpp
--- 0.2.0-3/test/geometry.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/geometry.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * geometry.cpp - Geometry classes tests
+ * Geometry classes tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/gstreamer/gstreamer_device_provider_test.cpp 0.3.0-1/test/gstreamer/gstreamer_device_provider_test.cpp
--- 0.2.0-3/test/gstreamer/gstreamer_device_provider_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/gstreamer/gstreamer_device_provider_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Umang Jain <umang.jain@ideasonboard.com>
  *
- * gstreamer_single_stream_test.cpp - GStreamer single stream capture test
+ * GStreamer single stream capture test
  */
 
 #include <vector>
diff -pruN 0.2.0-3/test/gstreamer/gstreamer_multi_stream_test.cpp 0.3.0-1/test/gstreamer/gstreamer_multi_stream_test.cpp
--- 0.2.0-3/test/gstreamer/gstreamer_multi_stream_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/gstreamer/gstreamer_multi_stream_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Vedant Paranjape
  *
- * gstreamer_multi_stream_test.cpp - GStreamer multi stream capture test
+ * GStreamer multi stream capture test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/gstreamer/gstreamer_single_stream_test.cpp 0.3.0-1/test/gstreamer/gstreamer_single_stream_test.cpp
--- 0.2.0-3/test/gstreamer/gstreamer_single_stream_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/gstreamer/gstreamer_single_stream_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Vedant Paranjape
  *
- * gstreamer_single_stream_test.cpp - GStreamer single stream capture test
+ * GStreamer single stream capture test
  */
 
 #include <iostream>
@@ -29,30 +29,21 @@ protected:
 		if (status_ != TestPass)
 			return status_;
 
-		const gchar *streamDescription = "fakesink";
-		g_autoptr(GError) error0 = NULL;
-		stream0_ = gst_parse_bin_from_description_full(streamDescription, TRUE,
-						NULL,
-						GST_PARSE_FLAG_FATAL_ERRORS,
-						&error0);
-
-		if (!stream0_) {
-			g_printerr("Bin could not be created (%s)\n", error0->message);
+		fakesink_ = gst_element_factory_make("fakesink", nullptr);
+		if (!fakesink_) {
+			g_printerr("Your installation is missing 'fakesink'\n");
 			return TestFail;
 		}
-		g_object_ref_sink(stream0_);
-
-		if (createPipeline() != TestPass)
-			return TestFail;
+		g_object_ref_sink(fakesink_);
 
-		return TestPass;
+		return createPipeline();
 	}
 
 	int run() override
 	{
 		/* Build the pipeline */
-		gst_bin_add_many(GST_BIN(pipeline_), libcameraSrc_, stream0_, NULL);
-		if (gst_element_link(libcameraSrc_, stream0_) != TRUE) {
+		gst_bin_add_many(GST_BIN(pipeline_), libcameraSrc_, fakesink_, nullptr);
+		if (!gst_element_link(libcameraSrc_, fakesink_)) {
 			g_printerr("Elements could not be linked.\n");
 			return TestFail;
 		}
@@ -68,11 +59,11 @@ protected:
 
 	void cleanup() override
 	{
-		g_clear_object(&stream0_);
+		g_clear_object(&fakesink_);
 	}
 
 private:
-	GstElement *stream0_;
+	GstElement *fakesink_;
 };
 
 TEST_REGISTER(GstreamerSingleStreamTest)
diff -pruN 0.2.0-3/test/gstreamer/gstreamer_test.cpp 0.3.0-1/test/gstreamer/gstreamer_test.cpp
--- 0.2.0-3/test/gstreamer/gstreamer_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/gstreamer/gstreamer_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -52,23 +52,6 @@ GstreamerTest::GstreamerTest(unsigned in
 	}
 
 	/*
-	 * Remove the system libcamera plugin, if any, and add the plugin from
-	 * the build directory.
-	 */
-	GstRegistry *registry = gst_registry_get();
-	g_autoptr(GstPlugin) plugin = gst_registry_lookup(registry, "libgstlibcamera.so");
-	if (plugin)
-		gst_registry_remove_plugin(registry, plugin);
-
-	std::string path = libcamera::utils::libcameraBuildPath() + "src/gstreamer";
-	if (!gst_registry_scan_path(registry, path.c_str())) {
-		g_printerr("Failed to add plugin to registry\n");
-
-		status_ = TestFail;
-		return;
-	}
-
-	/*
 	 * Atleast one camera should be available with numStreams streams,
 	 * otherwise skip the test entirely.
 	 */
diff -pruN 0.2.0-3/test/gstreamer/gstreamer_test.h 0.3.0-1/test/gstreamer/gstreamer_test.h
--- 0.2.0-3/test/gstreamer/gstreamer_test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/gstreamer/gstreamer_test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Vedant Paranjape
  *
- * gstreamer_test.cpp - GStreamer test base class
+ * GStreamer test base class
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/gstreamer/meson.build 0.3.0-1/test/gstreamer/meson.build
--- 0.2.0-3/test/gstreamer/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/gstreamer/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -17,5 +17,5 @@ foreach test : gstreamer_tests
                      link_with : test_libraries,
                      include_directories : test_includes_internal)
 
-    test(test['name'], exe, suite : 'gstreamer', is_parallel : false)
+    test(test['name'], exe, suite : 'gstreamer', is_parallel : false, env : gst_env)
 endforeach
diff -pruN 0.2.0-3/test/hotplug-cameras.cpp 0.3.0-1/test/hotplug-cameras.cpp
--- 0.2.0-3/test/hotplug-cameras.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/hotplug-cameras.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Umang Jain <email@uajain.com>
  *
- * hotplug-cameras.cpp - Test cameraAdded/cameraRemoved signals in CameraManager
+ * Test cameraAdded/cameraRemoved signals in CameraManager
  */
 
 #include <dirent.h>
diff -pruN 0.2.0-3/test/ipa/ipa_interface_test.cpp 0.3.0-1/test/ipa/ipa_interface_test.cpp
--- 0.2.0-3/test/ipa/ipa_interface_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/ipa/ipa_interface_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_interface_test.cpp - Test the IPA interface
+ * Test the IPA interface
  */
 
 #include <fcntl.h>
@@ -16,6 +16,7 @@
 
 #include <libcamera/base/event_dispatcher.h>
 #include <libcamera/base/event_notifier.h>
+#include <libcamera/base/object.h>
 #include <libcamera/base/thread.h>
 #include <libcamera/base/timer.h>
 
@@ -55,7 +56,7 @@ protected:
 		const std::vector<PipelineHandlerFactoryBase *> &factories =
 			PipelineHandlerFactoryBase::factories();
 		for (const PipelineHandlerFactoryBase *factory : factories) {
-			if (factory->name() == "PipelineHandlerVimc") {
+			if (factory->name() == "vimc") {
 				pipe_ = factory->create(nullptr);
 				break;
 			}
diff -pruN 0.2.0-3/test/ipa/ipa_module_test.cpp 0.3.0-1/test/ipa/ipa_module_test.cpp
--- 0.2.0-3/test/ipa/ipa_module_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/ipa/ipa_module_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * ipa_module_test.cpp - Test loading of the VIMC IPA module and verify its info
+ * Test loading of the VIMC IPA module and verify its info
  */
 
 #include <iostream>
@@ -57,7 +57,7 @@ protected:
 		const struct IPAModuleInfo testInfo = {
 			IPA_MODULE_API_VERSION,
 			0,
-			"PipelineHandlerVimc",
+			"vimc",
 			"vimc",
 		};
 
diff -pruN 0.2.0-3/test/ipc/unixsocket.cpp 0.3.0-1/test/ipc/unixsocket.cpp
--- 0.2.0-3/test/ipc/unixsocket.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/ipc/unixsocket.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * unixsocket.cpp - Unix socket IPC test
+ * Unix socket IPC test
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/ipc/unixsocket_ipc.cpp 0.3.0-1/test/ipc/unixsocket_ipc.cpp
--- 0.2.0-3/test/ipc/unixsocket_ipc.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/ipc/unixsocket_ipc.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * unixsocket_ipc.cpp - Unix socket IPC test
+ * Unix socket IPC test
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/libtest/buffer_source.h 0.3.0-1/test/libtest/buffer_source.h
--- 0.2.0-3/test/libtest/buffer_source.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/libtest/buffer_source.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * buffer_source.h - libcamera camera test helper to create FrameBuffers
+ * libcamera camera test helper to create FrameBuffers
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/libtest/camera_test.h 0.3.0-1/test/libtest/camera_test.h
--- 0.2.0-3/test/libtest/camera_test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/libtest/camera_test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * camera_test.h - libcamera camera test base class
+ * libcamera camera test base class
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/libtest/test.cpp 0.3.0-1/test/libtest/test.cpp
--- 0.2.0-3/test/libtest/test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/libtest/test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * test.cpp - libcamera test base class
+ * libcamera test base class
  */
 
 #include <stdlib.h>
diff -pruN 0.2.0-3/test/libtest/test.h 0.3.0-1/test/libtest/test.h
--- 0.2.0-3/test/libtest/test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/libtest/test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * test.h - libcamera test base class
+ * libcamera test base class
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/log/log_api.cpp 0.3.0-1/test/log/log_api.cpp
--- 0.2.0-3/test/log/log_api.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/log/log_api.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * log.cpp - log API test
+ * log API test
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/log/log_process.cpp 0.3.0-1/test/log/log_process.cpp
--- 0.2.0-3/test/log/log_process.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/log/log_process.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * log_process.cpp - Logging in isolated child process test
+ * Logging in isolated child process test
  */
 
 #include <fcntl.h>
diff -pruN 0.2.0-3/test/media_device/media_device_link_test.cpp 0.3.0-1/test/media_device/media_device_link_test.cpp
--- 0.2.0-3/test/media_device/media_device_link_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/media_device/media_device_link_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * media_device_link_test.cpp - Tests link handling on VIMC media device
+ * Tests link handling on VIMC media device
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/media_device/media_device_print_test.cpp 0.3.0-1/test/media_device/media_device_print_test.cpp
--- 0.2.0-3/test/media_device/media_device_print_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/media_device/media_device_print_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018-2019, Google Inc.
  *
- * media_device_print_test.cpp - Print out media devices
+ * Print out media devices
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/media_device/media_device_test.cpp 0.3.0-1/test/media_device/media_device_test.cpp
--- 0.2.0-3/test/media_device/media_device_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/media_device/media_device_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * media_device_test.cpp - libcamera media device test base class
+ * libcamera media device test base class
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/media_device/media_device_test.h 0.3.0-1/test/media_device/media_device_test.h
--- 0.2.0-3/test/media_device/media_device_test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/media_device/media_device_test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * media_device_test.h - libcamera media device test base class
+ * libcamera media device test base class
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/meson.build 0.3.0-1/test/meson.build
--- 0.2.0-3/test/meson.build	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/meson.build	2024-05-19 15:54:11.000000000 +0000
@@ -69,6 +69,7 @@ internal_tests = [
     {'name': 'signal-threads', 'sources': ['signal-threads.cpp']},
     {'name': 'threads', 'sources': 'threads.cpp', 'dependencies': [libthreads]},
     {'name': 'timer', 'sources': ['timer.cpp']},
+    {'name': 'timer-fail', 'sources': ['timer-fail.cpp'], 'should_fail': true},
     {'name': 'timer-thread', 'sources': ['timer-thread.cpp']},
     {'name': 'unique-fd', 'sources': ['unique-fd.cpp']},
     {'name': 'utils', 'sources': ['utils.cpp']},
@@ -88,10 +89,11 @@ foreach test : public_tests
 
     exe = executable(test['name'], test['sources'],
                      dependencies : deps,
+                     implicit_include_directories : false,
                      link_with : test_libraries,
                      include_directories : test_includes_public)
 
-    test(test['name'], exe)
+    test(test['name'], exe, should_fail : test.get('should_fail', false))
 endforeach
 
 foreach test : internal_tests
@@ -102,10 +104,11 @@ foreach test : internal_tests
 
     exe = executable(test['name'], test['sources'],
                      dependencies : deps,
+                     implicit_include_directories : false,
                      link_with : test_libraries,
                      include_directories : test_includes_internal)
 
-    test(test['name'], exe)
+    test(test['name'], exe, should_fail : test.get('should_fail', false))
 endforeach
 
 foreach test : internal_non_parallel_tests
@@ -116,8 +119,11 @@ foreach test : internal_non_parallel_tes
 
     exe = executable(test['name'], test['sources'],
                      dependencies : deps,
+                     implicit_include_directories : false,
                      link_with : test_libraries,
                      include_directories : test_includes_internal)
 
-    test(test['name'], exe, is_parallel : false)
+    test(test['name'], exe,
+         is_parallel : false,
+         should_fail : test.get('should_fail', false))
 endforeach
diff -pruN 0.2.0-3/test/message.cpp 0.3.0-1/test/message.cpp
--- 0.2.0-3/test/message.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/message.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * message.cpp - Messages test
+ * Messages test
  */
 
 #include <chrono>
@@ -11,6 +11,7 @@
 #include <thread>
 
 #include <libcamera/base/message.h>
+#include <libcamera/base/object.h>
 #include <libcamera/base/thread.h>
 
 #include "test.h"
@@ -92,25 +93,6 @@ private:
 	bool success_;
 };
 
-class SlowMessageReceiver : public Object
-{
-protected:
-	void message(Message *msg)
-	{
-		if (msg->type() != Message::None) {
-			Object::message(msg);
-			return;
-		}
-
-		/*
-		 * Don't access any member of the object here (including the
-		 * vtable) as the object will be deleted by the main thread
-		 * while we're sleeping.
-		 */
-		this_thread::sleep_for(chrono::milliseconds(100));
-	}
-};
-
 class MessageTest : public Test
 {
 protected:
@@ -127,16 +109,19 @@ protected:
 			return TestFail;
 		}
 
-		MessageReceiver receiver;
-		receiver.moveToThread(&thread_);
+		MessageReceiver *receiver = new MessageReceiver();
+		receiver->moveToThread(&thread_);
 
 		thread_.start();
 
-		receiver.postMessage(std::make_unique<Message>(Message::None));
+		receiver->postMessage(std::make_unique<Message>(Message::None));
 
 		this_thread::sleep_for(chrono::milliseconds(100));
 
-		switch (receiver.status()) {
+		MessageReceiver::Status status = receiver->status();
+		receiver->deleteLater();
+
+		switch (status) {
 		case MessageReceiver::NoMessage:
 			cout << "No message received" << endl;
 			return TestFail;
@@ -148,28 +133,12 @@ protected:
 		}
 
 		/*
-		 * Test for races between message delivery and object deletion.
-		 * Failures result in assertion errors, there is no need for
-		 * explicit checks.
-		 */
-		SlowMessageReceiver *slowReceiver = new SlowMessageReceiver();
-		slowReceiver->moveToThread(&thread_);
-		slowReceiver->postMessage(std::make_unique<Message>(Message::None));
-
-		this_thread::sleep_for(chrono::milliseconds(10));
-
-		delete slowReceiver;
-
-		this_thread::sleep_for(chrono::milliseconds(100));
-
-		/*
 		 * Test recursive calls to Thread::dispatchMessages(). Messages
 		 * should be delivered correctly, without crashes or memory
 		 * leaks. Two messages need to be posted to ensure we don't only
 		 * test the simple case of a queue containing a single message.
 		 */
-		std::unique_ptr<RecursiveMessageReceiver> recursiveReceiver =
-			std::make_unique<RecursiveMessageReceiver>();
+		RecursiveMessageReceiver *recursiveReceiver = new RecursiveMessageReceiver();
 		recursiveReceiver->moveToThread(&thread_);
 
 		recursiveReceiver->postMessage(std::make_unique<Message>(Message::None));
@@ -177,7 +146,10 @@ protected:
 
 		this_thread::sleep_for(chrono::milliseconds(10));
 
-		if (!recursiveReceiver->success()) {
+		bool success = recursiveReceiver->success();
+		recursiveReceiver->deleteLater();
+
+		if (!success) {
 			cout << "Recursive message delivery failed" << endl;
 			return TestFail;
 		}
diff -pruN 0.2.0-3/test/object-delete.cpp 0.3.0-1/test/object-delete.cpp
--- 0.2.0-3/test/object-delete.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/object-delete.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * object.cpp - Object deletion tests
+ * Object deletion tests
  */
 
 #include <iostream>
@@ -33,10 +33,10 @@ public:
 	unsigned int *deleteCount_;
 };
 
-class NewThread : public Thread
+class DeleterThread : public Thread
 {
 public:
-	NewThread(Object *obj)
+	DeleterThread(Object *obj)
 		: object_(obj)
 	{
 	}
@@ -63,9 +63,9 @@ protected:
 		unsigned int count = 0;
 		TestObject *obj = new TestObject(&count);
 
-		NewThread thread(obj);
-		thread.start();
-		thread.wait();
+		DeleterThread delThread(obj);
+		delThread.start();
+		delThread.wait();
 
 		Thread::current()->dispatchMessages(Message::Type::DeferredDelete);
 
@@ -89,6 +89,26 @@ protected:
 			return TestFail;
 		}
 
+		/*
+		 * Test that deleteLater() works properly when called just
+		 * before the object's thread exits.
+		 */
+		Thread boundThread;
+		boundThread.start();
+
+		count = 0;
+		obj = new TestObject(&count);
+		obj->moveToThread(&boundThread);
+
+		obj->deleteLater();
+		boundThread.exit();
+		boundThread.wait();
+
+		if (count != 1) {
+			cout << "Object deletion right before thread exit failed (" << count << ")" << endl;
+			return TestFail;
+		}
+
 		return TestPass;
 	}
 };
diff -pruN 0.2.0-3/test/object-invoke.cpp 0.3.0-1/test/object-invoke.cpp
--- 0.2.0-3/test/object-invoke.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/object-invoke.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * object-invoke.cpp - Cross-thread Object method invocation test
+ * Cross-thread Object method invocation test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/object.cpp 0.3.0-1/test/object.cpp
--- 0.2.0-3/test/object.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/object.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * object.cpp - Object tests
+ * Object tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/process/process_test.cpp 0.3.0-1/test/process/process_test.cpp
--- 0.2.0-3/test/process/process_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/process/process_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * process_test.cpp - Process test
+ * Process test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/public-api.cpp 0.3.0-1/test/public-api.cpp
--- 0.2.0-3/test/public-api.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/public-api.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * public-api.cpp - Public API validation
+ * Public API validation
  */
 
 #include <libcamera/libcamera.h>
diff -pruN 0.2.0-3/test/serialization/control_serialization.cpp 0.3.0-1/test/serialization/control_serialization.cpp
--- 0.2.0-3/test/serialization/control_serialization.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/serialization/control_serialization.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * control_serialization.cpp - Serialize and deserialize controls
+ * Serialize and deserialize controls
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/serialization/generated_serializer/generated_serializer_test.cpp 0.3.0-1/test/serialization/generated_serializer/generated_serializer_test.cpp
--- 0.2.0-3/test/serialization/generated_serializer/generated_serializer_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/serialization/generated_serializer/generated_serializer_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * generated_serializer_test.cpp - Test generated serializer
+ * Test generated serializer
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/serialization/ipa_data_serializer_test.cpp 0.3.0-1/test/serialization/ipa_data_serializer_test.cpp
--- 0.2.0-3/test/serialization/ipa_data_serializer_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/serialization/ipa_data_serializer_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * ipa_data_serializer_test.cpp - Test serializing/deserializing with IPADataSerializer
+ * Test serializing/deserializing with IPADataSerializer
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/serialization/serialization_test.cpp 0.3.0-1/test/serialization/serialization_test.cpp
--- 0.2.0-3/test/serialization/serialization_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/serialization/serialization_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * serialization_test.cpp - Base class for serialization tests
+ * Base class for serialization tests
  */
 
 #include "serialization_test.h"
diff -pruN 0.2.0-3/test/serialization/serialization_test.h 0.3.0-1/test/serialization/serialization_test.h
--- 0.2.0-3/test/serialization/serialization_test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/serialization/serialization_test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * serialization_test.h - Base class for serialization tests
+ * Base class for serialization tests
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/shared-fd.cpp 0.3.0-1/test/shared-fd.cpp
--- 0.2.0-3/test/shared-fd.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/shared-fd.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * shared_fd.cpp - SharedFD test
+ * SharedFD test
  */
 
 #include <fcntl.h>
diff -pruN 0.2.0-3/test/signal-threads.cpp 0.3.0-1/test/signal-threads.cpp
--- 0.2.0-3/test/signal-threads.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/signal-threads.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * signal-threads.cpp - Cross-thread signal delivery test
+ * Cross-thread signal delivery test
  */
 
 #include <chrono>
@@ -10,6 +10,7 @@
 #include <thread>
 
 #include <libcamera/base/message.h>
+#include <libcamera/base/object.h>
 #include <libcamera/base/thread.h>
 #include <libcamera/base/utils.h>
 
@@ -58,15 +59,20 @@ private:
 class SignalThreadsTest : public Test
 {
 protected:
-	int run()
+	int init()
 	{
-		SignalReceiver receiver;
-		signal_.connect(&receiver, &SignalReceiver::slot);
+		receiver_ = new SignalReceiver();
+		signal_.connect(receiver_, &SignalReceiver::slot);
+
+		return TestPass;
+	}
 
+	int run()
+	{
 		/* Test that a signal is received in the main thread. */
 		signal_.emit(0);
 
-		switch (receiver.status()) {
+		switch (receiver_->status()) {
 		case SignalReceiver::NoSignal:
 			cout << "No signal received for direct connection" << endl;
 			return TestFail;
@@ -82,8 +88,8 @@ protected:
 		 * Move the object to a thread and verify that the signal is
 		 * correctly delivered, with the correct data.
 		 */
-		receiver.reset();
-		receiver.moveToThread(&thread_);
+		receiver_->reset();
+		receiver_->moveToThread(&thread_);
 
 		thread_.start();
 
@@ -91,7 +97,7 @@ protected:
 
 		this_thread::sleep_for(chrono::milliseconds(100));
 
-		switch (receiver.status()) {
+		switch (receiver_->status()) {
 		case SignalReceiver::NoSignal:
 			cout << "No signal received for message connection" << endl;
 			return TestFail;
@@ -103,7 +109,7 @@ protected:
 			break;
 		}
 
-		if (receiver.value() != 42) {
+		if (receiver_->value() != 42) {
 			cout << "Signal received with incorrect value" << endl;
 			return TestFail;
 		}
@@ -113,11 +119,13 @@ protected:
 
 	void cleanup()
 	{
+		receiver_->deleteLater();
 		thread_.exit(0);
 		thread_.wait();
 	}
 
 private:
+	SignalReceiver *receiver_;
 	Thread thread_;
 
 	Signal<int> signal_;
diff -pruN 0.2.0-3/test/signal.cpp 0.3.0-1/test/signal.cpp
--- 0.2.0-3/test/signal.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/signal.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * signal.cpp - Signal test
+ * Signal test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/span.cpp 0.3.0-1/test/span.cpp
--- 0.2.0-3/test/span.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/span.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * span.cpp - Span tests
+ * Span tests
  */
 
 /*
diff -pruN 0.2.0-3/test/stream/stream_colorspace.cpp 0.3.0-1/test/stream/stream_colorspace.cpp
--- 0.2.0-3/test/stream/stream_colorspace.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/stream/stream_colorspace.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Ideas on Board Oy.
  *
- * stream_colorspace.cpp - Stream colorspace adjustment test
+ * Stream colorspace adjustment test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/stream/stream_formats.cpp 0.3.0-1/test/stream/stream_formats.cpp
--- 0.2.0-3/test/stream/stream_formats.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/stream/stream_formats.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * stream_formats.cpp - StreamFormats test
+ * StreamFormats test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/threads.cpp 0.3.0-1/test/threads.cpp
--- 0.2.0-3/test/threads.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/threads.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * threads.cpp - Threads test
+ * Threads test
  */
 
 #include <chrono>
diff -pruN 0.2.0-3/test/timer-fail.cpp 0.3.0-1/test/timer-fail.cpp
--- 0.2.0-3/test/timer-fail.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.3.0-1/test/timer-fail.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -0,0 +1,109 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+/*
+ * Copyright (C) 2024, Ideas on Board Oy
+ *
+ * Threaded timer failure test
+ */
+
+#include <chrono>
+#include <iostream>
+
+#include <libcamera/base/event_dispatcher.h>
+#include <libcamera/base/object.h>
+#include <libcamera/base/thread.h>
+#include <libcamera/base/timer.h>
+
+#include "test.h"
+
+using namespace libcamera;
+using namespace std;
+using namespace std::chrono_literals;
+
+class TimeoutHandler : public Object
+{
+public:
+	TimeoutHandler()
+		: timer_(this), timeout_(false)
+	{
+		timer_.timeout.connect(this, &TimeoutHandler::timeoutHandler);
+	}
+
+	void start()
+	{
+		timer_.start(100ms);
+	}
+
+	bool timeout() const
+	{
+		return timeout_;
+	}
+
+private:
+	void timeoutHandler()
+	{
+		timeout_ = true;
+	}
+
+	Timer timer_;
+	bool timeout_;
+};
+
+class TimerFailTest : public Test
+{
+protected:
+	int init()
+	{
+		thread_.start();
+
+		timeout_ = new TimeoutHandler();
+		timeout_->moveToThread(&thread_);
+
+		return TestPass;
+	}
+
+	int run()
+	{
+		/*
+		 * Test that the forbidden operation of starting the timer from
+		 * another thread results in a failure. We need to interrupt the
+		 * event dispatcher to make sure we don't succeed simply because
+		 * the event dispatcher hasn't noticed the timer restart.
+		 */
+		timeout_->start();
+		thread_.eventDispatcher()->interrupt();
+
+		this_thread::sleep_for(chrono::milliseconds(200));
+
+		/*
+		 * The wrong start() call should result in an assertion in debug
+		 * builds, and a timeout in release builds. The test is
+		 * therefore marked in meson.build as expected to fail. We need
+		 * to return TestPass in the unexpected (usually known as
+		 * "fail") case, and TestFail otherwise.
+		 */
+		if (timeout_->timeout()) {
+			cout << "Timer start from wrong thread succeeded unexpectedly"
+			     << endl;
+			return TestPass;
+		}
+
+		return TestFail;
+	}
+
+	void cleanup()
+	{
+		/*
+		 * Object class instances must be destroyed from the thread
+		 * they live in.
+		 */
+		timeout_->deleteLater();
+		thread_.exit(0);
+		thread_.wait();
+	}
+
+private:
+	TimeoutHandler *timeout_;
+	Thread thread_;
+};
+
+TEST_REGISTER(TimerFailTest)
diff -pruN 0.2.0-3/test/timer-thread.cpp 0.3.0-1/test/timer-thread.cpp
--- 0.2.0-3/test/timer-thread.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/timer-thread.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,13 +2,14 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * timer-thread.cpp - Threaded timer test
+ * Threaded timer test
  */
 
 #include <chrono>
 #include <iostream>
 
 #include <libcamera/base/event_dispatcher.h>
+#include <libcamera/base/object.h>
 #include <libcamera/base/thread.h>
 #include <libcamera/base/timer.h>
 
@@ -28,12 +29,6 @@ public:
 		timer_.start(100ms);
 	}
 
-	void restart()
-	{
-		timeout_ = false;
-		timer_.start(100ms);
-	}
-
 	bool timeout() const
 	{
 		return timeout_;
@@ -55,7 +50,9 @@ protected:
 	int init()
 	{
 		thread_.start();
-		timeout_.moveToThread(&thread_);
+
+		timeout_ = new TimeoutHandler();
+		timeout_->moveToThread(&thread_);
 
 		return TestPass;
 	}
@@ -68,39 +65,27 @@ protected:
 		 */
 		this_thread::sleep_for(chrono::milliseconds(200));
 
-		if (!timeout_.timeout()) {
+		if (!timeout_->timeout()) {
 			cout << "Timer expiration test failed" << endl;
 			return TestFail;
 		}
 
-		/*
-		 * Test that starting the timer from another thread fails. We
-		 * need to interrupt the event dispatcher to make sure we don't
-		 * succeed simply because the event dispatcher hasn't noticed
-		 * the timer restart.
-		 */
-		timeout_.restart();
-		thread_.eventDispatcher()->interrupt();
-
-		this_thread::sleep_for(chrono::milliseconds(200));
-
-		if (timeout_.timeout()) {
-			cout << "Timer restart test failed" << endl;
-			return TestFail;
-		}
-
 		return TestPass;
 	}
 
 	void cleanup()
 	{
-		/* Must stop thread before destroying timeout. */
+		/*
+		 * Object class instances must be destroyed from the thread
+		 * they live in.
+		 */
+		timeout_->deleteLater();
 		thread_.exit(0);
 		thread_.wait();
 	}
 
 private:
-	TimeoutHandler timeout_;
+	TimeoutHandler *timeout_;
 	Thread thread_;
 };
 
diff -pruN 0.2.0-3/test/timer.cpp 0.3.0-1/test/timer.cpp
--- 0.2.0-3/test/timer.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/timer.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * timer.cpp - Timer test
+ * Timer test
  */
 
 #include <chrono>
diff -pruN 0.2.0-3/test/transform.cpp 0.3.0-1/test/transform.cpp
--- 0.2.0-3/test/transform.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/transform.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2023, Ideas On Board Oy
  *
- * transform.cpp - Transform and Orientation tests
+ * Transform and Orientation tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/unique-fd.cpp 0.3.0-1/test/unique-fd.cpp
--- 0.2.0-3/test/unique-fd.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/unique-fd.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * unique-fd.cpp - UniqueFD test
+ * UniqueFD test
  */
 
 #include <fcntl.h>
diff -pruN 0.2.0-3/test/utils.cpp 0.3.0-1/test/utils.cpp
--- 0.2.0-3/test/utils.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/utils.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * utils.cpp - Miscellaneous utility tests
+ * Miscellaneous utility tests
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/v4l2_compat/v4l2_compat_test.py 0.3.0-1/test/v4l2_compat/v4l2_compat_test.py
--- 0.2.0-3/test/v4l2_compat/v4l2_compat_test.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/v4l2_compat/v4l2_compat_test.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# v4l2_compat_test.py - Test the V4L2 compatibility layer
+# Test the V4L2 compatibility layer
 
 import argparse
 import glob
diff -pruN 0.2.0-3/test/v4l2_subdevice/v4l2_subdevice_test.cpp 0.3.0-1/test/v4l2_subdevice/v4l2_subdevice_test.cpp
--- 0.2.0-3/test/v4l2_subdevice/v4l2_subdevice_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/v4l2_subdevice/v4l2_subdevice_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_subdevice_test.cpp - VIMC-based V4L2 subdevice test
+ * VIMC-based V4L2 subdevice test
  */
 
 #include <iostream>
diff -pruN 0.2.0-3/test/v4l2_subdevice/v4l2_subdevice_test.h 0.3.0-1/test/v4l2_subdevice/v4l2_subdevice_test.h
--- 0.2.0-3/test/v4l2_subdevice/v4l2_subdevice_test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/v4l2_subdevice/v4l2_subdevice_test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * v4l2_subdevice_test.h - VIMC-based V4L2 subdevice test
+ * VIMC-based V4L2 subdevice test
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/v4l2_videodevice/controls.cpp 0.3.0-1/test/v4l2_videodevice/controls.cpp
--- 0.2.0-3/test/v4l2_videodevice/controls.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/v4l2_videodevice/controls.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2019, Google Inc.
  *
- * controls.cpp - V4L2 device controls handling test
+ * V4L2 device controls handling test
  */
 
 #include <algorithm>
diff -pruN 0.2.0-3/test/v4l2_videodevice/v4l2_videodevice_test.cpp 0.3.0-1/test/v4l2_videodevice/v4l2_videodevice_test.cpp
--- 0.2.0-3/test/v4l2_videodevice/v4l2_videodevice_test.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/v4l2_videodevice/v4l2_videodevice_test.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -75,7 +75,7 @@ int V4L2VideoDeviceTest::init()
 		format.fourcc = V4L2PixelFormat(V4L2_PIX_FMT_SBGGR8);
 
 		V4L2SubdeviceFormat subformat = {};
-		subformat.mbus_code = MEDIA_BUS_FMT_SBGGR8_1X8;
+		subformat.code = MEDIA_BUS_FMT_SBGGR8_1X8;
 		subformat.size = format.size;
 
 		if (sensor_->setFormat(&subformat))
diff -pruN 0.2.0-3/test/v4l2_videodevice/v4l2_videodevice_test.h 0.3.0-1/test/v4l2_videodevice/v4l2_videodevice_test.h
--- 0.2.0-3/test/v4l2_videodevice/v4l2_videodevice_test.h	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/v4l2_videodevice/v4l2_videodevice_test.h	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2018, Google Inc.
  *
- * vl42device_test.h - libcamera v4l2device test base class
+ * libcamera v4l2device test base class
  */
 
 #pragma once
diff -pruN 0.2.0-3/test/yaml-parser.cpp 0.3.0-1/test/yaml-parser.cpp
--- 0.2.0-3/test/yaml-parser.cpp	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/test/yaml-parser.cpp	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 /*
  * Copyright (C) 2022, Google Inc.
  *
- * yaml-parser.cpp - YAML parser operations tests
+ * YAML parser operations tests
  */
 
 #include <array>
diff -pruN 0.2.0-3/utils/checkstyle.py 0.3.0-1/utils/checkstyle.py
--- 0.2.0-3/utils/checkstyle.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/checkstyle.py	2024-05-19 15:54:11.000000000 +0000
@@ -1,10 +1,10 @@
-#!/usr/bin/python3
+#!/usr/bin/env python3
 # SPDX-License-Identifier: GPL-2.0-or-later
 # Copyright (C) 2018, Google Inc.
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# checkstyle.py - A patch style checker script based on clang-format
+# A patch style checker script based on clang-format
 #
 # TODO:
 #
@@ -168,6 +168,12 @@ def parse_diff(diff):
             hunk = DiffHunk(line)
 
         elif hunk is not None:
+            # Work around https://github.com/python/cpython/issues/46395
+            # See https://www.gnu.org/software/diffutils/manual/html_node/Incomplete-Lines.html
+            if line[-1] != '\n':
+                hunk.append(line + '\n')
+                line = '\\ No newline at end of file\n'
+
             hunk.append(line)
 
     if hunk:
@@ -471,6 +477,7 @@ class TrailersChecker(CommitChecker):
     known_trailers = {
         'Acked-by': email_regex,
         'Bug': link_regex,
+        'Co-developed-by': email_regex,
         'Fixes': commit_regex,
         'Link': link_regex,
         'Reported-by': validate_reported_by,
@@ -562,7 +569,7 @@ class IncludeChecker(StyleChecker):
                'limits', 'locale', 'setjmp', 'signal', 'stdarg', 'stddef',
                'stdint', 'stdio', 'stdlib', 'string', 'time', 'uchar', 'wchar',
                'wctype')
-    include_regex = re.compile('^#include <c([a-z]*)>')
+    include_regex = re.compile(r'^#include <c([a-z]*)>')
 
     def __init__(self, content):
         super().__init__()
@@ -588,7 +595,7 @@ class IncludeChecker(StyleChecker):
 
 
 class LogCategoryChecker(StyleChecker):
-    log_regex = re.compile('\\bLOG\((Debug|Info|Warning|Error|Fatal)\)')
+    log_regex = re.compile(r'\bLOG\((Debug|Info|Warning|Error|Fatal)\)')
     patterns = ('*.cpp',)
 
     def __init__(self, content):
@@ -625,7 +632,7 @@ class MesonChecker(StyleChecker):
 
 class Pep8Checker(StyleChecker):
     patterns = ('*.py',)
-    results_regex = re.compile('stdin:([0-9]+):([0-9]+)(.*)')
+    results_regex = re.compile(r'stdin:([0-9]+):([0-9]+)(.*)')
 
     def __init__(self, content):
         super().__init__()
@@ -658,7 +665,7 @@ class Pep8Checker(StyleChecker):
 
 class ShellChecker(StyleChecker):
     patterns = ('*.sh',)
-    results_line_regex = re.compile('In - line ([0-9]+):')
+    results_line_regex = re.compile(r'In - line ([0-9]+):')
 
     def __init__(self, content):
         super().__init__()
@@ -746,7 +753,8 @@ class CLangFormatter(Formatter):
 class DoxygenFormatter(Formatter):
     patterns = ('*.c', '*.cpp')
 
-    return_regex = re.compile(' +\\* +\\\\return +[a-z]')
+    oneliner_regex = re.compile(r'^ +\* +\\(brief|param|return)\b.*\.$')
+    return_regex = re.compile(r' +\* +\\return +[a-z]')
 
     @classmethod
     def format(cls, filename, data):
@@ -761,6 +769,7 @@ class DoxygenFormatter(Formatter):
                 lines.append(line)
                 continue
 
+            line = cls.oneliner_regex.sub(lambda m: m.group(0)[:-1], line)
             line = cls.return_regex.sub(lambda m: m.group(0)[:-1] + m.group(0)[-1].upper(), line)
 
             if line.find('*/') != -1:
@@ -806,7 +815,7 @@ class DPointerFormatter(Formatter):
 class IncludeOrderFormatter(Formatter):
     patterns = ('*.cpp', '*.h')
 
-    include_regex = re.compile('^#include (["<])([^">]*)([">])')
+    include_regex = re.compile(r'^#include (["<])([^">]*)([">])')
 
     @classmethod
     def format(cls, filename, data):
diff -pruN 0.2.0-3/utils/gen-controls.py 0.3.0-1/utils/gen-controls.py
--- 0.2.0-3/utils/gen-controls.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/gen-controls.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# gen-controls.py - Generate control definitions from YAML
+# Generate control definitions from YAML
 
 import argparse
 from functools import reduce
@@ -140,6 +140,12 @@ ${description}
  */''')
     enum_values_start = string.Template('''extern const std::array<const ControlValue, ${size}> ${name}Values = {''')
     enum_values_values = string.Template('''\tstatic_cast<int32_t>(${name}),''')
+    name_value_map_doc = string.Template('''/**
+ * \\var ${name}NameValueMap
+ * \\brief Map of all $name supported value names (in std::string format) to value
+ */''')
+    name_value_map_start = string.Template('''extern const std::map<std::string, ${type}> ${name}NameValueMap = {''')
+    name_value_values = string.Template('''\t{ "${name}", ${name} },''')
 
     ctrls_doc = {}
     ctrls_def = {}
@@ -183,6 +189,7 @@ ${description}
 
             values_info = {
                 'name': info['name'],
+                'type': ctrl.type,
                 'size': num_entries,
             }
             target_doc.append(enum_values_doc.substitute(values_info))
@@ -194,6 +201,15 @@ ${description}
                 target_def.append(enum_values_values.substitute(value_info))
             target_def.append("};")
 
+            target_doc.append(name_value_map_doc.substitute(values_info))
+            target_def.append(name_value_map_start.substitute(values_info))
+            for enum in ctrl.enum_values:
+                value_info = {
+                    'name': enum.name
+                }
+                target_def.append(name_value_values.substitute(value_info))
+            target_def.append("};")
+
         target_doc.append(doc_template.substitute(info))
         target_def.append(def_template.substitute(info))
 
@@ -231,6 +247,7 @@ def generate_h(controls, mode, ranges):
     enum_template_start = string.Template('''enum ${name}Enum {''')
     enum_value_template = string.Template('''\t${name} = ${value},''')
     enum_values_template = string.Template('''extern const std::array<const ControlValue, ${size}> ${name}Values;''')
+    name_value_map_template = string.Template('''extern const std::map<std::string, ${type}> ${name}NameValueMap;''')
     template = string.Template('''extern const Control<${type}> ${name};''')
 
     ctrls = {}
@@ -273,9 +290,11 @@ def generate_h(controls, mode, ranges):
 
             values_info = {
                 'name': info['name'],
+                'type': ctrl.type,
                 'size': num_entries,
             }
             target_ctrls.append(enum_values_template.substitute(values_info))
+            target_ctrls.append(name_value_map_template.substitute(values_info))
 
         target_ctrls.append(template.substitute(info))
         id_value[vendor] += 1
diff -pruN 0.2.0-3/utils/gen-formats.py 0.3.0-1/utils/gen-formats.py
--- 0.2.0-3/utils/gen-formats.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/gen-formats.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# gen-formats.py - Generate formats definitions from YAML
+# Generate formats definitions from YAML
 
 import argparse
 import re
diff -pruN 0.2.0-3/utils/gen-header.sh 0.3.0-1/utils/gen-header.sh
--- 0.2.0-3/utils/gen-header.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/gen-header.sh	2024-05-19 15:54:11.000000000 +0000
@@ -9,7 +9,7 @@ cat <<EOF > "$dst_file"
 /*
  * Copyright (C) 2018-2019, Google Inc.
  *
- * libcamera.h - libcamera public API
+ * libcamera public API
  */
 
 #pragma once
diff -pruN 0.2.0-3/utils/gen-ipa-priv-key.sh 0.3.0-1/utils/gen-ipa-priv-key.sh
--- 0.2.0-3/utils/gen-ipa-priv-key.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/gen-ipa-priv-key.sh	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# gen-ipa-priv-key.sh - Generate an RSA private key to sign IPA modules
+# Generate an RSA private key to sign IPA modules
 
 key="$1"
 
diff -pruN 0.2.0-3/utils/gen-ipa-pub-key.py 0.3.0-1/utils/gen-ipa-pub-key.py
--- 0.2.0-3/utils/gen-ipa-pub-key.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/gen-ipa-pub-key.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# ipa-gen-key.py - Generate the IPA module signing public key
+# Generate the IPA module signing public key
 
 import string
 import subprocess
diff -pruN 0.2.0-3/utils/ipc/extract-docs.py 0.3.0-1/utils/ipc/extract-docs.py
--- 0.2.0-3/utils/ipc/extract-docs.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/extract-docs.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,15 +4,15 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# extract-docs.py - Extract doxygen documentation from mojom files
+# Extract doxygen documentation from mojom files
 
 import argparse
 import re
 import sys
 
-regex_block_start = re.compile('^\/\*\*$')
-regex_block_end = re.compile('^ \*\/$')
-regex_spdx = re.compile('^\/\* SPDX-License-Identifier: .* \*\/$')
+regex_block_start = re.compile(r'^/\*\*$')
+regex_block_end = re.compile(r'^ \*/$')
+regex_spdx = re.compile(r'^/\* SPDX-License-Identifier: .* \*/$')
 
 
 def main(argv):
@@ -38,7 +38,7 @@ def main(argv):
 /*
  * Copyright (C) 2021, Google Inc.
  *
- * {pipeline}_ipa_interface.cpp - Docs file for generated {pipeline}.mojom
+ * Docs file for generated {pipeline}.mojom
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/utils/ipc/generate.py 0.3.0-1/utils/ipc/generate.py
--- 0.2.0-3/utils/ipc/generate.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generate.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# generate.py - Run mojo code generator for generating libcamera IPC files
+# Run mojo code generator for generating libcamera IPC files
 
 import os
 import sys
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/core_ipa_interface.h.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/core_ipa_interface.h.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/core_ipa_interface.h.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/core_ipa_interface.h.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -7,7 +7,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * core_ipa_interface.h - libcamera core definitions for Image Processing Algorithms
+ * libcamera core definitions for Image Processing Algorithms
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/core_ipa_serializer.h.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/core_ipa_serializer.h.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/core_ipa_serializer.h.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/core_ipa_serializer.h.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -8,7 +8,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * core_ipa_serializer.h - Data serializer for core libcamera definitions for IPA
+ * Data serializer for core libcamera definitions for IPA
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_interface.h.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_interface.h.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_interface.h.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_interface.h.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -7,7 +7,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * {{module_name}}_ipa_interface.h - Image Processing Algorithm interface for {{module_name}}
+ * Image Processing Algorithm interface for {{module_name}}
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_proxy.cpp.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_proxy.cpp.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_proxy.cpp.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_proxy.cpp.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -8,7 +8,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * {{module_name}}_ipa_proxy.cpp - Image Processing Algorithm proxy for {{module_name}}
+ * Image Processing Algorithm proxy for {{module_name}}
  *
  * This file is auto-generated. Do not edit.
  */
@@ -175,9 +175,9 @@ void {{proxy_name}}::recvMessage(const I
 );
 {% elif method|is_async %}
 	ASSERT(state_ == ProxyRunning);
-	proxy_.invokeMethod(&ThreadProxy::{{method.mojom_name}}, ConnectionTypeQueued,
+	proxy_.invokeMethod(&ThreadProxy::{{method.mojom_name}}, ConnectionTypeQueued
 	{%- for param in method|method_param_names -%}
-		{{param}}{{- ", " if not loop.last}}
+		, {{param}}
 	{%- endfor -%}
 );
 {%- endif %}
@@ -235,8 +235,8 @@ void {{proxy_name}}::recvMessage(const I
 }
 
 void {{proxy_name}}::{{method.mojom_name}}IPC(
-	std::vector<uint8_t>::const_iterator data,
-	size_t dataSize,
+	[[maybe_unused]] std::vector<uint8_t>::const_iterator data,
+	[[maybe_unused]] size_t dataSize,
 	[[maybe_unused]] const std::vector<SharedFD> &fds)
 {
 {%- for param in method.parameters %}
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_proxy.h.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_proxy.h.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_proxy.h.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_proxy.h.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -8,7 +8,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * {{module_name}}_ipa_proxy.h - Image Processing Algorithm proxy for {{module_name}}
+ * Image Processing Algorithm proxy for {{module_name}}
  *
  * This file is auto-generated. Do not edit.
  */
@@ -18,6 +18,7 @@
 #include <libcamera/ipa/ipa_interface.h>
 #include <libcamera/ipa/{{module_name}}_ipa_interface.h>
 
+#include <libcamera/base/object.h>
 #include <libcamera/base/thread.h>
 
 #include "libcamera/internal/control_serializer.h"
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_proxy_worker.cpp.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_proxy_worker.cpp.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_proxy_worker.cpp.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_proxy_worker.cpp.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -8,7 +8,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * {{module_name}}_ipa_proxy_worker.cpp - Image Processing Algorithm proxy worker for {{module_name}}
+ * Image Processing Algorithm proxy worker for {{module_name}}
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_serializer.h.tmpl 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_serializer.h.tmpl
--- 0.2.0-3/utils/ipc/generators/libcamera_templates/module_ipa_serializer.h.tmpl	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/libcamera_templates/module_ipa_serializer.h.tmpl	2024-05-19 15:54:11.000000000 +0000
@@ -8,7 +8,7 @@
 /*
  * Copyright (C) 2020, Google Inc.
  *
- * {{module_name}}_ipa_serializer.h - Image Processing Algorithm data serializer for {{module_name}}
+ * Image Processing Algorithm data serializer for {{module_name}}
  *
  * This file is auto-generated. Do not edit.
  */
diff -pruN 0.2.0-3/utils/ipc/generators/mojom_libcamera_generator.py 0.3.0-1/utils/ipc/generators/mojom_libcamera_generator.py
--- 0.2.0-3/utils/ipc/generators/mojom_libcamera_generator.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/generators/mojom_libcamera_generator.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# mojom_libcamera_generator.py - Generates libcamera files from a mojom.Module.
+# Generates libcamera files from a mojom.Module.
 
 import argparse
 import datetime
@@ -72,7 +72,7 @@ def ParamsCommaSep(l):
 def GetDefaultValue(element):
     if element.default is not None:
         return element.default
-    if type(element.kind) == mojom.Kind:
+    if type(element.kind) == mojom.ValueKind:
         return '0'
     if IsFlags(element):
         return ''
diff -pruN 0.2.0-3/utils/ipc/parser.py 0.3.0-1/utils/ipc/parser.py
--- 0.2.0-3/utils/ipc/parser.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipc/parser.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# parser.py - Run mojo parser with python3
+# Run mojo parser with python3
 
 import os
 import sys
diff -pruN 0.2.0-3/utils/ipu3/ipu3-capture.sh 0.3.0-1/utils/ipu3/ipu3-capture.sh
--- 0.2.0-3/utils/ipu3/ipu3-capture.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipu3/ipu3-capture.sh	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# ipu3-capture.sh - Capture raw frames from cameras based on the Intel IPU3
+# Capture raw frames from cameras based on the Intel IPU3
 #
 # The scripts makes use of the following tools, which are expected to be
 # executable from the system-wide path or from the local directory:
diff -pruN 0.2.0-3/utils/ipu3/ipu3-pack.c 0.3.0-1/utils/ipu3/ipu3-pack.c
--- 0.2.0-3/utils/ipu3/ipu3-pack.c	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipu3/ipu3-pack.c	2024-05-19 15:54:11.000000000 +0000
@@ -8,6 +8,7 @@
 
 #include <errno.h>
 #include <fcntl.h>
+#include <libgen.h>
 #include <stdint.h>
 #include <stdio.h>
 #include <string.h>
@@ -15,9 +16,8 @@
 #include <sys/types.h>
 #include <unistd.h>
 
-static void usage(const char *argv0)
+static void usage(char *argv0)
 {
-
 	printf("Usage: %s input-file output-file\n", basename(argv0));
 	printf("Convert unpacked RAW10 Bayer data to the IPU3 packed Bayer formats\n");
 	printf("If the output-file '-', output data will be written to standard output\n");
diff -pruN 0.2.0-3/utils/ipu3/ipu3-process.sh 0.3.0-1/utils/ipu3/ipu3-process.sh
--- 0.2.0-3/utils/ipu3/ipu3-process.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipu3/ipu3-process.sh	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# ipu3-process.sh - Process raw frames with the Intel IPU3
+# Process raw frames with the Intel IPU3
 #
 # The scripts makes use of the following tools, which are expected to be
 # found in $PATH:
diff -pruN 0.2.0-3/utils/ipu3/ipu3-unpack.c 0.3.0-1/utils/ipu3/ipu3-unpack.c
--- 0.2.0-3/utils/ipu3/ipu3-unpack.c	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/ipu3/ipu3-unpack.c	2024-05-19 15:54:11.000000000 +0000
@@ -8,6 +8,7 @@
 
 #include <errno.h>
 #include <fcntl.h>
+#include <libgen.h>
 #include <stdint.h>
 #include <stdio.h>
 #include <string.h>
@@ -15,7 +16,7 @@
 #include <sys/types.h>
 #include <unistd.h>
 
-static void usage(const char *argv0)
+static void usage(char *argv0)
 {
 	printf("Usage: %s input-file output-file\n", basename(argv0));
 	printf("Unpack the IPU3 raw Bayer format to 16-bit Bayer\n");
@@ -78,7 +79,7 @@ int main(int argc, char *argv[])
 		}
 
 		ret = write(out_fd, out_data, 50);
-		if (ret < -1) {
+		if (ret == -1) {
 			fprintf(stderr, "Failed to write output data: %s\n",
 				strerror(errno));
 			goto done;
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/alsc_only.py 0.3.0-1/utils/raspberrypi/ctt/alsc_only.py
--- 0.2.0-3/utils/raspberrypi/ctt/alsc_only.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/alsc_only.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Copyright (C) 2022, Raspberry Pi (Trading) Limited
 #
-# alsc_only.py - alsc tuning tool
+# alsc tuning tool
 
 from ctt import *
 
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/colors.py 0.3.0-1/utils/raspberrypi/ctt/colors.py
--- 0.2.0-3/utils/raspberrypi/ctt/colors.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/colors.py	2024-05-19 15:54:11.000000000 +0000
@@ -1,4 +1,4 @@
-# colors.py - Program to convert from RGB to LAB color space
+# Program to convert from RGB to LAB color space
 def RGB_to_LAB(RGB):  # where RGB is a 1x3 array.   e.g RGB = [100, 255, 230]
     num = 0
     XYZ = [0, 0, 0]
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt.py 0.3.0-1/utils/raspberrypi/ctt/ctt.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt.py - camera tuning tool
+# camera tuning tool
 
 import os
 import sys
@@ -350,7 +350,7 @@ class Camera:
         alsc_out = alsc_all(self, do_alsc_colour, plot)
         cal_cr_list, cal_cb_list, luminance_lut, av_corn = alsc_out
         """
-        write ouput to json and finish if not do_alsc_colour
+        write output to json and finish if not do_alsc_colour
         """
         if not do_alsc_colour:
             self.json['rpi.alsc']['luminance_lut'] = luminance_lut
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_alsc.py 0.3.0-1/utils/raspberrypi/ctt/ctt_alsc.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_alsc.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_alsc.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_alsc.py - camera tuning tool for ALSC (auto lens shading correction)
+# camera tuning tool for ALSC (auto lens shading correction)
 
 from ctt_image_load import *
 import matplotlib.pyplot as plt
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_awb.py 0.3.0-1/utils/raspberrypi/ctt/ctt_awb.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_awb.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_awb.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_awb.py - camera tuning tool for AWB
+# camera tuning tool for AWB
 
 from ctt_image_load import *
 import matplotlib.pyplot as plt
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_ccm.py 0.3.0-1/utils/raspberrypi/ctt/ctt_ccm.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_ccm.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_ccm.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_ccm.py - camera tuning tool for CCM (colour correction matrix)
+# camera tuning tool for CCM (colour correction matrix)
 
 from ctt_image_load import *
 from ctt_awb import get_alsc_patches
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_geq.py 0.3.0-1/utils/raspberrypi/ctt/ctt_geq.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_geq.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_geq.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_geq.py - camera tuning tool for GEQ (green equalisation)
+# camera tuning tool for GEQ (green equalisation)
 
 from ctt_tools import *
 import matplotlib.pyplot as plt
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_image_load.py 0.3.0-1/utils/raspberrypi/ctt/ctt_image_load.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_image_load.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_image_load.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019-2020, Raspberry Pi Ltd
 #
-# ctt_image_load.py - camera tuning tool image loading
+# camera tuning tool image loading
 
 from ctt_tools import *
 from ctt_macbeth_locator import *
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_lux.py 0.3.0-1/utils/raspberrypi/ctt/ctt_lux.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_lux.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_lux.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_lux.py - camera tuning tool for lux level
+# camera tuning tool for lux level
 
 from ctt_tools import *
 
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_macbeth_locator.py 0.3.0-1/utils/raspberrypi/ctt/ctt_macbeth_locator.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_macbeth_locator.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_macbeth_locator.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_macbeth_locator.py - camera tuning tool Macbeth chart locator
+# camera tuning tool Macbeth chart locator
 
 from ctt_ransac import *
 from ctt_tools import *
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_noise.py 0.3.0-1/utils/raspberrypi/ctt/ctt_noise.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_noise.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_noise.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_noise.py - camera tuning tool noise calibration
+# camera tuning tool noise calibration
 
 from ctt_image_load import *
 import matplotlib.pyplot as plt
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_ransac.py 0.3.0-1/utils/raspberrypi/ctt/ctt_ransac.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_ransac.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_ransac.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_ransac.py - camera tuning tool RANSAC selector for Macbeth chart locator
+# camera tuning tool RANSAC selector for Macbeth chart locator
 
 import numpy as np
 
diff -pruN 0.2.0-3/utils/raspberrypi/ctt/ctt_tools.py 0.3.0-1/utils/raspberrypi/ctt/ctt_tools.py
--- 0.2.0-3/utils/raspberrypi/ctt/ctt_tools.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/raspberrypi/ctt/ctt_tools.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# ctt_tools.py - camera tuning tool miscellaneous
+# camera tuning tool miscellaneous
 
 import time
 import re
diff -pruN 0.2.0-3/utils/rkisp1/gen-csc-table.py 0.3.0-1/utils/rkisp1/gen-csc-table.py
--- 0.2.0-3/utils/rkisp1/gen-csc-table.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/rkisp1/gen-csc-table.py	2024-05-19 15:54:11.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python3
+#!/usr/bin/env python3
 # SPDX-License-Identifier: GPL-2.0-or-later
 # Copyright (C) 2022, Ideas on Board Oy
 #
diff -pruN 0.2.0-3/utils/rkisp1/rkisp1-capture.sh 0.3.0-1/utils/rkisp1/rkisp1-capture.sh
--- 0.2.0-3/utils/rkisp1/rkisp1-capture.sh	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/rkisp1/rkisp1-capture.sh	2024-05-19 15:54:11.000000000 +0000
@@ -4,8 +4,7 @@
 #
 # Author: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 #
-# rkisp-capture.sh - Capture processed frames from cameras based on the
-# Rockchip ISP1
+# Capture processed frames from cameras based on the Rockchip ISP1
 #
 # The scripts makes use of the following tools, which are expected to be
 # executable from the system-wide path or from the local directory:
diff -pruN 0.2.0-3/utils/tracepoints/analyze-ipa-trace.py 0.3.0-1/utils/tracepoints/analyze-ipa-trace.py
--- 0.2.0-3/utils/tracepoints/analyze-ipa-trace.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tracepoints/analyze-ipa-trace.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# analyze-ipa-trace.py - Example of how to extract information from libcamera lttng traces
+# Example of how to extract information from libcamera lttng traces
 
 import argparse
 import bt2
diff -pruN 0.2.0-3/utils/tracepoints/gen-tp-header.py 0.3.0-1/utils/tracepoints/gen-tp-header.py
--- 0.2.0-3/utils/tracepoints/gen-tp-header.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tracepoints/gen-tp-header.py	2024-05-19 15:54:11.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # Author: Paul Elder <paul.elder@ideasonboard.com>
 #
-# gen-tp-header.py - Generate header file to contain lttng tracepoints
+# Generate header file to contain lttng tracepoints
 
 import datetime
 import jinja2
diff -pruN 0.2.0-3/utils/tuning/README.rst 0.3.0-1/utils/tuning/README.rst
--- 0.2.0-3/utils/tuning/README.rst	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/README.rst	2024-05-19 15:54:11.000000000 +0000
@@ -5,7 +5,7 @@
 Dependencies
 ------------
 
-- cv2
 - numpy
-- pyexiv2
+- opencv-python
+- py3exiv2
 - rawpy
diff -pruN 0.2.0-3/utils/tuning/libtuning/average.py 0.3.0-1/utils/tuning/libtuning/average.py
--- 0.2.0-3/utils/tuning/libtuning/average.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/average.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# average.py - Wrapper for numpy averaging functions to enable duck-typing
+# Wrapper for numpy averaging functions to enable duck-typing
 
 import numpy as np
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/generators/generator.py 0.3.0-1/utils/tuning/libtuning/generators/generator.py
--- 0.2.0-3/utils/tuning/libtuning/generators/generator.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/generators/generator.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# generator.py - Base class for a generator to convert dict to tuning file
+# Base class for a generator to convert dict to tuning file
 
 from pathlib import Path
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/generators/raspberrypi_output.py 0.3.0-1/utils/tuning/libtuning/generators/raspberrypi_output.py
--- 0.2.0-3/utils/tuning/libtuning/generators/raspberrypi_output.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/generators/raspberrypi_output.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright 2022 Raspberry Pi Ltd
 #
-# raspberrypi_output.py - Generate tuning file in Raspberry Pi's json format
+# Generate tuning file in Raspberry Pi's json format
 #
 # (Copied from ctt_pretty_print_json.py)
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/generators/yaml_output.py 0.3.0-1/utils/tuning/libtuning/generators/yaml_output.py
--- 0.2.0-3/utils/tuning/libtuning/generators/yaml_output.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/generators/yaml_output.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright 2022 Paul Elder <paul.elder@ideasonboard.com>
 #
-# yaml_output.py - Generate tuning file in YAML format
+# Generate tuning file in YAML format
 
 from .generator import Generator
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/gradient.py 0.3.0-1/utils/tuning/libtuning/gradient.py
--- 0.2.0-3/utils/tuning/libtuning/gradient.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/gradient.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# gradient.py - Gradients that can be used to distribute or map numbers
+# Gradients that can be used to distribute or map numbers
 
 import libtuning as lt
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/image.py 0.3.0-1/utils/tuning/libtuning/image.py
--- 0.2.0-3/utils/tuning/libtuning/image.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/image.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# image.py - Container for an image and associated metadata
+# Container for an image and associated metadata
 
 import binascii
 import numpy as np
diff -pruN 0.2.0-3/utils/tuning/libtuning/libtuning.py 0.3.0-1/utils/tuning/libtuning/libtuning.py
--- 0.2.0-3/utils/tuning/libtuning/libtuning.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/libtuning.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# libtuning.py - An infrastructure for camera tuning tools
+# An infrastructure for camera tuning tools
 
 import argparse
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/macbeth.py 0.3.0-1/utils/tuning/libtuning/macbeth.py
--- 0.2.0-3/utils/tuning/libtuning/macbeth.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/macbeth.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2019, Raspberry Pi Ltd
 #
-# macbeth.py - Locate and extract Macbeth charts from images
+# Locate and extract Macbeth charts from images
 # (Copied from: ctt_macbeth_locator.py)
 
 # \todo Add debugging
diff -pruN 0.2.0-3/utils/tuning/libtuning/modules/lsc/raspberrypi.py 0.3.0-1/utils/tuning/libtuning/modules/lsc/raspberrypi.py
--- 0.2.0-3/utils/tuning/libtuning/modules/lsc/raspberrypi.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/modules/lsc/raspberrypi.py	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
 # Copyright (C) 2019, Raspberry Pi Ltd
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# raspberrypi.py - ALSC module for tuning Raspberry Pi
+# ALSC module for tuning Raspberry Pi
 
 from .lsc import LSC
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/modules/lsc/rkisp1.py 0.3.0-1/utils/tuning/libtuning/modules/lsc/rkisp1.py
--- 0.2.0-3/utils/tuning/libtuning/modules/lsc/rkisp1.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/modules/lsc/rkisp1.py	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
 # Copyright (C) 2019, Raspberry Pi Ltd
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# rkisp1.py - LSC module for tuning rkisp1
+# LSC module for tuning rkisp1
 
 from .lsc import LSC
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/modules/module.py 0.3.0-1/utils/tuning/libtuning/modules/module.py
--- 0.2.0-3/utils/tuning/libtuning/modules/module.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/modules/module.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# module.py - Base class for algorithm-specific tuning modules
+# Base class for algorithm-specific tuning modules
 
 
 # @var type Type of the module. Defined in the base module.
diff -pruN 0.2.0-3/utils/tuning/libtuning/parsers/parser.py 0.3.0-1/utils/tuning/libtuning/parsers/parser.py
--- 0.2.0-3/utils/tuning/libtuning/parsers/parser.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/parsers/parser.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# parser.py - Base class for a parser for a specific format of config file
+# Base class for a parser for a specific format of config file
 
 class Parser(object):
     def __init__(self):
diff -pruN 0.2.0-3/utils/tuning/libtuning/parsers/raspberrypi_parser.py 0.3.0-1/utils/tuning/libtuning/parsers/raspberrypi_parser.py
--- 0.2.0-3/utils/tuning/libtuning/parsers/raspberrypi_parser.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/parsers/raspberrypi_parser.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# raspberrypi_parser.py - Parser for Raspberry Pi config file format
+# Parser for Raspberry Pi config file format
 
 from .parser import Parser
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/parsers/yaml_parser.py 0.3.0-1/utils/tuning/libtuning/parsers/yaml_parser.py
--- 0.2.0-3/utils/tuning/libtuning/parsers/yaml_parser.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/parsers/yaml_parser.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# yaml_parser.py - Parser for YAML format config file
+# Parser for YAML format config file
 
 from .parser import Parser
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/smoothing.py 0.3.0-1/utils/tuning/libtuning/smoothing.py
--- 0.2.0-3/utils/tuning/libtuning/smoothing.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/smoothing.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# smoothing.py - Wrapper for cv2 smoothing functions to enable duck-typing
+# Wrapper for cv2 smoothing functions to enable duck-typing
 
 import cv2
 
diff -pruN 0.2.0-3/utils/tuning/libtuning/utils.py 0.3.0-1/utils/tuning/libtuning/utils.py
--- 0.2.0-3/utils/tuning/libtuning/utils.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/libtuning/utils.py	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
 # Copyright (C) 2019, Raspberry Pi Ltd
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# utils.py - Utilities for libtuning
+# Utilities for libtuning
 
 import decimal
 import math
diff -pruN 0.2.0-3/utils/tuning/raspberrypi/alsc.py 0.3.0-1/utils/tuning/raspberrypi/alsc.py
--- 0.2.0-3/utils/tuning/raspberrypi/alsc.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/raspberrypi/alsc.py	2024-05-19 15:54:11.000000000 +0000
@@ -2,7 +2,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# alsc.py - ALSC module instance for Raspberry Pi tuning scripts
+# ALSC module instance for Raspberry Pi tuning scripts
 
 import libtuning as lt
 from libtuning.modules.lsc import ALSCRaspberryPi
diff -pruN 0.2.0-3/utils/tuning/raspberrypi_alsc_only.py 0.3.0-1/utils/tuning/raspberrypi_alsc_only.py
--- 0.2.0-3/utils/tuning/raspberrypi_alsc_only.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/raspberrypi_alsc_only.py	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# raspberrypi_alsc_only.py - Tuning script for raspberrypi, ALSC only
+# Tuning script for raspberrypi, ALSC only
 
 import sys
 
diff -pruN 0.2.0-3/utils/tuning/rkisp1.py 0.3.0-1/utils/tuning/rkisp1.py
--- 0.2.0-3/utils/tuning/rkisp1.py	2024-01-09 17:21:06.000000000 +0000
+++ 0.3.0-1/utils/tuning/rkisp1.py	2024-05-19 15:54:11.000000000 +0000
@@ -3,7 +3,7 @@
 #
 # Copyright (C) 2022, Paul Elder <paul.elder@ideasonboard.com>
 #
-# rkisp1.py - Tuning script for rkisp1
+# Tuning script for rkisp1
 
 import sys
 
